#!/usr/bin/env python

func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]

cvt_dict = {
    'vheight_lo':       0,  # -186
    'cvt_1':            1,  # 0
    'vheight':          2,  # 417
    'cvt_3':            3,  # 445
    'vheight_cap':      4,  # 563
    'vheight_po':       5,  # 604
    'cvt_6':            6,  # 612
    'stem':7,#41
    'stemt':            7,  # 41
    'stemt_thick':      8,  # 50
    'stemw':            9,  # 41
    'stemw_thick':      10, # 60
    'stemw_thin':       11, # 39
    'stemw_thin_2':     12, # 37
    'stem_sara':        13, # 36
    'vheight_cap_shoot':14, # 576
    'vbase_shoot':      15, # 16
    'vbase_thai_shoot': 16, # 10
    'vheight_shoot':    17, # 431
    'vheight_thai':     18, # 445
    'vheight_thai_shoot':19,# 455
    'vheight_lu':       20, # 165
    'vheight_num':      21, # 366
    'vheight_num_shoot':22, # 376
    'headdia':          23, # 160
    'head_sara':        24, # 120
    'w_422':            25, # 422
    'w_356':            26, # 356
    'w_275':            27, # 275
    }

pseudo_fpgm = """
                           #--- PUSHB_1   0         ;PUSH Bytes
FDEF            0          ;Function DEFinition
                           #--- PUSHB_1   0         ;PUSH Bytes
SZP0            0          ;Set Zone Pointer 0
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM#1 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   74        ;PUSH Bytes
SROUND          74         ;Super ROUND
EIF                        ;    End IF
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_arg1   ;SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP#1 &_SWAP#2 ;Move Indirect Absolute Point
RTG                        ;Round To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
RTDG                       ;Round To Double Grid
EIF                        ;    End IF
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM#1 ; Less Than
IF              &_LT#1     ;   IF test
RDTG                       ;Round Down To Grid
EIF                        ;    End IF
                           #--- DUP       #&_arg2   ;DUPlicate top stack element
MDRP[rp0,rnd,grey] &_arg2     ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SZP0            1          ;Set Zone Pointer 0
MDAP[no-rnd]    &_arg2     ;Move Direct Absolute Point
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   1         ;PUSH Bytes
FDEF            1          ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,min,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_arg1  ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   2         ;PUSH Bytes
FDEF            2          ;Function DEFinition
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_arg1 ;Greater Than
IF              &_GT#1     ;   IF test
RCVT            &_arg2     ;Read Control Value Table entry
SWAP            &_RCVT#1 &_arg3 ;SWAP the top two elements on the stack
EIF                        ;    End IF
POP             &_SWAP#1   ;POP top stack element
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP#2
#------------------
#STACK_REMAIN=RETURN : &_f2_retval#1
#------------------

                           #--- PUSHB_1   3         ;PUSH Bytes
FDEF            3          ;Function DEFinition
ROUND[Black]    &_arg1     ;ROUND value
RTG                        ;Round To Grid
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
LT              64 &_ROUND#1 ; Less Than
IF              &_LT#1     ;   IF test
POP             &_ROUND#1  ;POP top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#------------------
#STACK_REMAIN=RETURN : &_f3_retval#1
#------------------

                           #--- PUSHB_1   4         ;PUSH Bytes
FDEF            4          ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
POP             &_arg1     ;POP top stack element
SWAP            &_arg2 &_arg3 ;SWAP the top two elements on the stack
POP             &_SWAP#1   ;POP top stack element
ROFF                       ; Round OFF
IF              &_SWAP#2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg4     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg4     ;Move Direct Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_arg1 ;Greater Than
IF              &_GT#1     ;   IF test
IF              &_arg2     ;   IF test
MIRP[rp0,min,rnd,black] &_arg3 &_arg4 ;Move Indirect Relative Point
ELSE                       ;ELSE clause
MIRP[min,rnd,black] &_arg3 &_arg4 ;Move Indirect Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg2 &_arg3 ;SWAP the top two elements on the stack
POP             &_SWAP#1   ;POP top stack element
                           #--- PUSHB_1   5         ;PUSH Bytes
CALL            5          ;CALL function
IF              &_f5_retval#1 ;   IF test
                           #--- PUSHB_1   70        ;PUSH Bytes
SROUND          70         ;Super ROUND
EIF                        ;    End IF
IF              &_SWAP#2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg4     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg4     ;Move Direct Relative Point
EIF                        ;    End IF
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   5         ;PUSH Bytes
FDEF            5          ;Function DEFinition
GFV                        ;Get Freedom Vector
NOT             &_GFV#1    ;logical NOT
AND             &_NOT#1 &_GFV#2 ;logical AND
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND#1
#------------------
#STACK_REMAIN=RETURN : &_f5_retval#1
#------------------

                           #--- PUSHB_1   6         ;PUSH Bytes
FDEF            6          ;Function DEFinition
                           #--- PUSHB_2   34 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO#1 34 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   32        ;PUSH Bytes
GETINFO         32         ;GET INFOrmation
NOT             &_GETINFO#1 ;logical NOT
NOT             &_NOT#1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT#1
#------------------
#STACK_REMAIN=RETURN : &_f6_retval#1
#------------------

                           #--- PUSHB_1   7         ;PUSH Bytes
FDEF            7          ;Function DEFinition
                           #--- PUSHB_2   36 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO#1 36 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
GETINFO         64         ;GET INFOrmation
NOT             &_GETINFO#1 ;logical NOT
NOT             &_NOT#1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT#1
#------------------
#STACK_REMAIN=RETURN : &_f7_retval#1
#------------------

                           #--- PUSHB_1   8         ;PUSH Bytes
FDEF            8          ;Function DEFinition
SRP2            &_arg1     ;Set Reference Point 2
SRP1            &_arg2     ;Set Reference Point 1
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
IP              &_arg3     ;Interpolate Point
MDAP[rnd]       &_arg3     ;Move Direct Absolute Point
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   9         ;PUSH Bytes
FDEF            9          ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
RDTG                       ;Round Down To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
MDRP[rnd,grey]  &_arg1     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg1     ;Move Direct Relative Point
EIF                        ;    End IF
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX#1 &_arg1 ;Measure Distance
SWAP            &_MD#1 &_arg1 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[orig]        &_SWAP#1 &_SWAP#1 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD#1   ; Less Than
IF              &_LT#1     ;   IF test
ROLL            &_SWAP#2 &_arg2 &_arg3 ;ROLL the top three stack elements
NEG             &_ROLL#1   ;    NEGate
ROLL            &_NEG#1 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SUB             &_ROLL#1 &_ROLL#2 ;  SUBtract
                           #--- DUP       #&_SUB#1  ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SUB#1  ; Less Than
IF              &_LT#1     ;   IF test
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
ROLL            &_arg2 &_arg3 &_arg4 ;ROLL the top three stack elements
ROLL            &_ROLL#1 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SUB             &_ROLL#1 &_ROLL#2 ;  SUBtract
                           #--- DUP       #&_SUB#1  ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SUB#1  ;Greater Than
IF              &_GT#1     ;   IF test
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg5     ;POP top stack element
POP             &_arg6     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   10        ;PUSH Bytes
FDEF            10         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
POP             &_arg1     ;POP top stack element
SRP0            &_arg2     ;Set Reference Point 0
ELSE                       ;ELSE clause
SRP0            &_arg1     ;Set Reference Point 0
POP             &_arg2     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   11        ;PUSH Bytes
FDEF            11         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_arg1  ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   12        ;PUSH Bytes
FDEF            12         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDAP[rnd]       &_arg1     ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
GC[orig]        &_arg1     ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_arg1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
IF              &_ROUND#1  ;   IF test
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
ABS             &_ROUND#1  ;ABSolute value
DIV             &_ABS#1 &_ROUND#1 ;    DIVide
SHPIX           &_DIV#1 &_arg1 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   13        ;PUSH Bytes
FDEF            13         ;Function DEFinition
SRP2            &_arg1     ;Set Reference Point 2
SRP1            &_arg2     ;Set Reference Point 1
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
IP              &_arg3     ;Interpolate Point
MDAP[rnd]       &_arg3     ;Move Direct Absolute Point
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
ROLL            &_arg3 &_arg3 &_arg4 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
GC[orig]        &_ROLL#1   ;Get Coordinate projected onto the projection vector
ROLL            &_GC#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
GC[cur]         &_ROLL#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_ROLL#2 ;  SUBtract
SWAP            &_SUB#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_ROLL#3 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
MD[orig]        &_SWAP#1 &_SWAP#2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD#1   ; Less Than
IF              &_LT#1     ;   IF test
SWAP            &_ROLL#3 &_ROLL#3 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SWAP#1 ;Greater Than
IF              &_GT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
SHPIX           64 &_SWAP#2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg5 &_arg6 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SWAP#1 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
NEG             64         ;    NEGate
SHPIX           &_NEG#1 &_SWAP#2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg7     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   14        ;PUSH Bytes
FDEF            14         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
RTDG                       ;Round To Double Grid
MDRP[rp0,rnd,white] &_arg1     ;Move Direct Relative Point
RTG                        ;Round To Grid
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
ELSE                       ;ELSE clause
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_arg1     ;Move Direct Relative Point
ROLL            &_arg1 &_arg2 &_arg3 ;ROLL the top three stack elements
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_ROLL#1 ;Greater Than
IF              &_GT#1     ;   IF test
                           #--- DUP       #&_ROLL#2 ;DUPlicate top stack element
ROLL            &_ROLL#2 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
MD[grid]        &_SWAP#1 &_SWAP#2 ;Measure Distance
                           #--- DUP       #&_MD#1   ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
NEQ             0 &_MD#1   ; Not EQual
IF              &_NEQ#1    ;   IF test
SHPIX           &_MD#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   15        ;PUSH Bytes
FDEF            15         ;Function DEFinition
SWAP            &_arg1 &_arg2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_SWAP#1   ;Move Direct Relative Point
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
MDAP[rnd]       &_SWAP#1   ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
SWAP            &_SWAP#1 &_SWAP#2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
IF              &_SWAP#1   ;   IF test
MPPEM                      ;Measure Pixels Per EM
GTEQ            &_MPPEM#1 &_SWAP#1 ;Greater Than or EQual
ELSE                       ;ELSE clause
POP             &_GTEQ#1   ;POP top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
EIF                        ;    End IF
IF              &_GTEQ#1   ;   IF test
ROLL            &_SWAP#2 &_arg3 &_arg4 ;ROLL the top three stack elements
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[grid]        &_ROLL#1 &_ROLL#2 ;Measure Distance
SWAP            &_MD#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_arg5 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
ROLL            &_SWAP#1 &_SWAP#1 &_SWAP#2 ;ROLL the top three stack elements
MD[grid]        &_ROLL#1 &_ROLL#2 ;Measure Distance
ROLL            &_MD#1 &_ROLL#3 &_ROLL#3 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SUB             &_SWAP#1 &_SWAP#2 ;  SUBtract
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
POP             &_arg6     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             1          ;POP top stack element
POP             &_SWAP#2   ;POP top stack element
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=5:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   16        ;PUSH Bytes
FDEF            16         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,min,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_arg1 &_arg2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   17        ;PUSH Bytes
FDEF            17         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_arg1 &_arg2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   18        ;PUSH Bytes
FDEF            18         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDAP[rnd]       &_arg1     ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
GC[orig]        &_arg1     ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_arg1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
ROLL            &_ROUND#1 &_arg1 &_arg2 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
GC[orig]        &_ROLL#1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_ROLL#1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_SWAP#2 ;SWAP the top two elements on the stack
SUB             &_SWAP#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
ADD             &_ROUND#1 &_ROLL#2 ;       ADD
                           #--- DUP       #&_ADD#1  ;DUPlicate top stack element
IF              &_ADD#1    ;   IF test
                           #--- DUP       #&_ADD#1  ;DUPlicate top stack element
ABS             &_ADD#1    ;ABSolute value
DIV             &_ABS#1 &_ADD#1 ;    DIVide
SHPIX           &_DIV#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   19        ;PUSH Bytes
FDEF            19         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
ROLL            &_arg1 &_arg1 &_arg2 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL#1 &_ROLL#2 ;Set Dual Projection Vector To Line
                           #--- DUP       #&_ROLL#3 ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX#1 &_ROLL#3 ;Measure Distance
ABS             &_MD#1     ;ABSolute value
SWAP            &_ABS#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_ROLL#3 ;ROLL the top three stack elements
SPVTL[orthog]   &_ROLL#1 &_ROLL#2 ;Set Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
LT              32 &_ROLL#3 ; Less Than
IF              &_LT#1     ;   IF test
ALIGNRP         &_arg3     ;ALIGN to Reference Point
ELSE                       ;ELSE clause
MDRP[grey]      &_arg3     ;Move Direct Relative Point
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------
"""

