#!/usr/bin/env python

func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]

cvt_dict = {
    'vheight_lo':       0,  # -186
    'cvt_1':            1,  # 0
    'vheight':          2,  # 417
    'cvt_3':            3,  # 445
    'vheight_cap':      4,  # 563
    'vheight_po':       5,  # 604
    'cvt_6':            6,  # 612
    'stem':7,#41
    'stemt':            7,  # 41
    'stemt_thick':      8,  # 50
    'stemw':            9,  # 41
    'stemw_thick':      10, # 60
    'stemw_thin':       11, # 39
    'stemw_thin_2':     12, # 37
    'stem_sara':        13, # 36
    'vheight_cap_shoot':14, # 576
    'vbase_shoot':      15, # 16
    'vbase_thai_shoot': 16, # 10
    'vheight_shoot':    17, # 431
    'vheight_thai':     18, # 445
    'vheight_thai_shoot':19,# 455
    'vheight_lu':       20, # 165
    'vheight_num':      21, # 366
    'vheight_num_shoot':22, # 376
    'headdia':          23, # 160
    'head_sara':        24, # 120
    'w_422':            25, # 422
    'w_356':            26, # 356
    'w_275':            27, # 275
    }

pseudo_fpgm = """
                           #--- PUSHB_1   0         ;PUSH Bytes
FDEF            0          ;Function DEFinition
                           #--- PUSHB_1   0         ;PUSH Bytes
SZP0            0          ;Set Zone Pointer 0
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM#1 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   74        ;PUSH Bytes
SROUND          74         ;Super ROUND
EIF                        ;    End IF
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_arg1   ;SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP#1 &_SWAP#2 ;Move Indirect Absolute Point
RTG                        ;Round To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
RTDG                       ;Round To Double Grid
EIF                        ;    End IF
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM#1 ; Less Than
IF              &_LT#1     ;   IF test
RDTG                       ;Round Down To Grid
EIF                        ;    End IF
                           #--- DUP       #&_arg2   ;DUPlicate top stack element
MDRP[rp0,rnd,grey] &_arg2     ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SZP0            1          ;Set Zone Pointer 0
MDAP[no-rnd]    &_arg2     ;Move Direct Absolute Point
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   1         ;PUSH Bytes
FDEF            1          ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,min,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_arg1  ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   2         ;PUSH Bytes
FDEF            2          ;Function DEFinition
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_arg1 ;Greater Than
IF              &_GT#1     ;   IF test
RCVT            &_arg2     ;Read Control Value Table entry
SWAP            &_RCVT#1 &_arg3 ;SWAP the top two elements on the stack
EIF                        ;    End IF
POP             &_SWAP#1   ;POP top stack element
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP#2
#------------------
#STACK_REMAIN=RETURN : &_f2_retval#1
#------------------

                           #--- PUSHB_1   3         ;PUSH Bytes
FDEF            3          ;Function DEFinition
ROUND[Black]    &_arg1     ;ROUND value
RTG                        ;Round To Grid
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
LT              64 &_ROUND#1 ; Less Than
IF              &_LT#1     ;   IF test
POP             &_ROUND#1  ;POP top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#------------------
#STACK_REMAIN=RETURN : &_f3_retval#1
#------------------

                           #--- PUSHB_1   4         ;PUSH Bytes
FDEF            4          ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
POP             &_arg1     ;POP top stack element
SWAP            &_arg2 &_arg3 ;SWAP the top two elements on the stack
POP             &_SWAP#1   ;POP top stack element
ROFF                       ; Round OFF
IF              &_SWAP#2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg4     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg4     ;Move Direct Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_arg1 ;Greater Than
IF              &_GT#1     ;   IF test
IF              &_arg2     ;   IF test
MIRP[rp0,min,rnd,black] &_arg3 &_arg4 ;Move Indirect Relative Point
ELSE                       ;ELSE clause
MIRP[min,rnd,black] &_arg3 &_arg4 ;Move Indirect Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg2 &_arg3 ;SWAP the top two elements on the stack
POP             &_SWAP#1   ;POP top stack element
                           #--- PUSHB_1   5         ;PUSH Bytes
CALL            5          ;CALL function
IF              &_f5_retval#1 ;   IF test
                           #--- PUSHB_1   70        ;PUSH Bytes
SROUND          70         ;Super ROUND
EIF                        ;    End IF
IF              &_SWAP#2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg4     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg4     ;Move Direct Relative Point
EIF                        ;    End IF
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   5         ;PUSH Bytes
FDEF            5          ;Function DEFinition
GFV                        ;Get Freedom Vector
NOT             &_GFV#1    ;logical NOT
AND             &_NOT#1 &_GFV#2 ;logical AND
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND#1
#------------------
#STACK_REMAIN=RETURN : &_f5_retval#1
#------------------

                           #--- PUSHB_1   6         ;PUSH Bytes
FDEF            6          ;Function DEFinition
                           #--- PUSHB_2   34 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO#1 34 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   32        ;PUSH Bytes
GETINFO         32         ;GET INFOrmation
NOT             &_GETINFO#1 ;logical NOT
NOT             &_NOT#1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT#1
#------------------
#STACK_REMAIN=RETURN : &_f6_retval#1
#------------------

                           #--- PUSHB_1   7         ;PUSH Bytes
FDEF            7          ;Function DEFinition
                           #--- PUSHB_2   36 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO#1 36 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
GETINFO         64         ;GET INFOrmation
NOT             &_GETINFO#1 ;logical NOT
NOT             &_NOT#1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT#1
#------------------
#STACK_REMAIN=RETURN : &_f7_retval#1
#------------------

                           #--- PUSHB_1   8         ;PUSH Bytes
FDEF            8          ;Function DEFinition
SRP2            &_arg1     ;Set Reference Point 2
SRP1            &_arg2     ;Set Reference Point 1
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
IP              &_arg3     ;Interpolate Point
MDAP[rnd]       &_arg3     ;Move Direct Absolute Point
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   9         ;PUSH Bytes
FDEF            9          ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
RDTG                       ;Round Down To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
MDRP[rnd,grey]  &_arg1     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg1     ;Move Direct Relative Point
EIF                        ;    End IF
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX#1 &_arg1 ;Measure Distance
SWAP            &_MD#1 &_arg1 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[orig]        &_SWAP#1 &_SWAP#1 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD#1   ; Less Than
IF              &_LT#1     ;   IF test
ROLL            &_SWAP#2 &_arg2 &_arg3 ;ROLL the top three stack elements
NEG             &_ROLL#1   ;    NEGate
ROLL            &_NEG#1 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SUB             &_ROLL#1 &_ROLL#2 ;  SUBtract
                           #--- DUP       #&_SUB#1  ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SUB#1  ; Less Than
IF              &_LT#1     ;   IF test
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
ROLL            &_arg2 &_arg3 &_arg4 ;ROLL the top three stack elements
ROLL            &_ROLL#1 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SUB             &_ROLL#1 &_ROLL#2 ;  SUBtract
                           #--- DUP       #&_SUB#1  ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SUB#1  ;Greater Than
IF              &_GT#1     ;   IF test
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg5     ;POP top stack element
POP             &_arg6     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   10        ;PUSH Bytes
FDEF            10         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
POP             &_arg1     ;POP top stack element
SRP0            &_arg2     ;Set Reference Point 0
ELSE                       ;ELSE clause
SRP0            &_arg1     ;Set Reference Point 0
POP             &_arg2     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   11        ;PUSH Bytes
FDEF            11         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_arg1  ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   12        ;PUSH Bytes
FDEF            12         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDAP[rnd]       &_arg1     ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
GC[orig]        &_arg1     ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_arg1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
IF              &_ROUND#1  ;   IF test
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
ABS             &_ROUND#1  ;ABSolute value
DIV             &_ABS#1 &_ROUND#1 ;    DIVide
SHPIX           &_DIV#1 &_arg1 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   13        ;PUSH Bytes
FDEF            13         ;Function DEFinition
SRP2            &_arg1     ;Set Reference Point 2
SRP1            &_arg2     ;Set Reference Point 1
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
IP              &_arg3     ;Interpolate Point
MDAP[rnd]       &_arg3     ;Move Direct Absolute Point
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
ROLL            &_arg3 &_arg3 &_arg4 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
GC[orig]        &_ROLL#1   ;Get Coordinate projected onto the projection vector
ROLL            &_GC#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
GC[cur]         &_ROLL#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_ROLL#2 ;  SUBtract
SWAP            &_SUB#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_ROLL#3 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
MD[orig]        &_SWAP#1 &_SWAP#2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD#1   ; Less Than
IF              &_LT#1     ;   IF test
SWAP            &_ROLL#3 &_ROLL#3 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SWAP#1 ;Greater Than
IF              &_GT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
SHPIX           64 &_SWAP#2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg5 &_arg6 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SWAP#1 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
NEG             64         ;    NEGate
SHPIX           &_NEG#1 &_SWAP#2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg7     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   14        ;PUSH Bytes
FDEF            14         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
RTDG                       ;Round To Double Grid
MDRP[rp0,rnd,white] &_arg1     ;Move Direct Relative Point
RTG                        ;Round To Grid
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
ELSE                       ;ELSE clause
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_arg1     ;Move Direct Relative Point
ROLL            &_arg1 &_arg2 &_arg3 ;ROLL the top three stack elements
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_ROLL#1 ;Greater Than
IF              &_GT#1     ;   IF test
                           #--- DUP       #&_ROLL#2 ;DUPlicate top stack element
ROLL            &_ROLL#2 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
MD[grid]        &_SWAP#1 &_SWAP#2 ;Measure Distance
                           #--- DUP       #&_MD#1   ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
NEQ             0 &_MD#1   ; Not EQual
IF              &_NEQ#1    ;   IF test
SHPIX           &_MD#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   15        ;PUSH Bytes
FDEF            15         ;Function DEFinition
SWAP            &_arg1 &_arg2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_SWAP#1   ;Move Direct Relative Point
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
MDAP[rnd]       &_SWAP#1   ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
SWAP            &_SWAP#1 &_SWAP#2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
IF              &_SWAP#1   ;   IF test
MPPEM                      ;Measure Pixels Per EM
GTEQ            &_MPPEM#1 &_SWAP#1 ;Greater Than or EQual
ELSE                       ;ELSE clause
POP             &_GTEQ#1   ;POP top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
EIF                        ;    End IF
IF              &_GTEQ#1   ;   IF test
ROLL            &_SWAP#2 &_arg3 &_arg4 ;ROLL the top three stack elements
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[grid]        &_ROLL#1 &_ROLL#2 ;Measure Distance
SWAP            &_MD#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_arg5 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
ROLL            &_SWAP#1 &_SWAP#1 &_SWAP#2 ;ROLL the top three stack elements
MD[grid]        &_ROLL#1 &_ROLL#2 ;Measure Distance
ROLL            &_MD#1 &_ROLL#3 &_ROLL#3 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SUB             &_SWAP#1 &_SWAP#2 ;  SUBtract
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
POP             &_arg6     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             1          ;POP top stack element
POP             &_SWAP#2   ;POP top stack element
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=5:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   16        ;PUSH Bytes
FDEF            16         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,min,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_arg1 &_arg2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   17        ;PUSH Bytes
FDEF            17         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_arg1 &_arg2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   18        ;PUSH Bytes
FDEF            18         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDAP[rnd]       &_arg1     ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
GC[orig]        &_arg1     ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_arg1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
ROLL            &_ROUND#1 &_arg1 &_arg2 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
GC[orig]        &_ROLL#1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_ROLL#1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_SWAP#2 ;SWAP the top two elements on the stack
SUB             &_SWAP#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
ADD             &_ROUND#1 &_ROLL#2 ;       ADD
                           #--- DUP       #&_ADD#1  ;DUPlicate top stack element
IF              &_ADD#1    ;   IF test
                           #--- DUP       #&_ADD#1  ;DUPlicate top stack element
ABS             &_ADD#1    ;ABSolute value
DIV             &_ABS#1 &_ADD#1 ;    DIVide
SHPIX           &_DIV#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   19        ;PUSH Bytes
FDEF            19         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
ROLL            &_arg1 &_arg1 &_arg2 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL#1 &_ROLL#2 ;Set Dual Projection Vector To Line
                           #--- DUP       #&_ROLL#3 ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX#1 &_ROLL#3 ;Measure Distance
ABS             &_MD#1     ;ABSolute value
SWAP            &_ABS#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_ROLL#3 ;ROLL the top three stack elements
SPVTL[orthog]   &_ROLL#1 &_ROLL#2 ;Set Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
LT              32 &_ROLL#3 ; Less Than
IF              &_LT#1     ;   IF test
ALIGNRP         &_arg3     ;ALIGN to Reference Point
ELSE                       ;ELSE clause
MDRP[grey]      &_arg3     ;Move Direct Relative Point
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------
"""



pseudo_code_dict = {
    '.notdef': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_2   52 56     ;PUSH Bytes
SHP[rp2]        56         ;SHift Point using reference point
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_3   4 8 10    ;PUSH Bytes
CALL            10 8 4     ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp1]        63         ;SHift Point using reference point
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[min,black] stem 51    ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 49     ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   15 11 10  ;PUSH Bytes
CALL            10 11 15   ;CALL function
                           #--- PUSHB_4   64 15 19 9 ;PUSH Bytes
CALL            9 19 15 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   55 9      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_3   9 55 10   ;PUSH Bytes
CALL            10 55 9    ;CALL function
                           #--- PUSHB_4   64 9 6 9  ;PUSH Bytes
CALL            9 6 9 64   ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_3   16 48 52  ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SHP[rp2]        48         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   37 9      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 39 56  ;PUSH Bytes
SHP[rp2]        56         ;SHift Point using reference point
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   60 11     ;PUSH Bytes
CALL            11 60      ;CALL function
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   43 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   54 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   1 36 8 19 13 ;PUSH Bytes
CALL            13 19 8 36 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'AE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_4   2 13 40 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        52 40 13 2 ;SHift Point using reference point
                           #--- PUSHB_3   12 8 10   ;PUSH Bytes
CALL            10 8 12    ;CALL function
                           #--- PUSHB_4   0 12 44 9 ;PUSH Bytes
CALL            9 44 12 0  ;CALL function
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   14 26 56  ;PUSH Bytes
SHP[rp2]        56         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   15 19 10  ;PUSH Bytes
CALL            10 19 15   ;CALL function
                           #--- PUSHB_4   0 15 23 9 ;PUSH Bytes
CALL            9 23 15 0  ;CALL function
                           #--- PUSHB_5   1 57 8 19 13 ;PUSH Bytes
CALL            13 19 8 57 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_5   28 39 8 19 13 ;PUSH Bytes
CALL            13 19 8 39 28 ;CALL function
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_3   39 28 10  ;PUSH Bytes
CALL            10 28 39   ;CALL function
                           #--- PUSHB_4   64 39 36 9 ;PUSH Bytes
CALL            9 36 39 64 ;CALL function
                           #--- PUSHB_3   28 39 10  ;PUSH Bytes
CALL            10 39 28   ;CALL function
                           #--- PUSHB_4   64 28 32 9 ;PUSH Bytes
CALL            9 32 28 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDRP[rp0,rnd,white] 53         ;Move Direct Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_2   40 9      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   53 40 10  ;PUSH Bytes
CALL            10 40 53   ;CALL function
                           #--- PUSHB_4   64 53 50 9 ;PUSH Bytes
CALL            9 50 53 64 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 21 10  ;PUSH Bytes
CALL            10 21 25   ;CALL function
                           #--- PUSHB_4   64 25 17 9 ;PUSH Bytes
CALL            9 17 25 64 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_1   41        ;PUSH Bytes
                           #--- DUP       #41       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   47 9      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   13 14     ;PUSH Bytes
SDPVTL[orthog]  14 13      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[no-rnd]    13         ;Move Direct Absolute Point
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[no-rnd]    56         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   2 11      ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 2 ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   14 11     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 14 ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_4   1 2 56 19 ;PUSH Bytes
CALL            19 56 2 1  ;CALL function
                           #--- PUSHB_4   57 2 56 19 ;PUSH Bytes
CALL            19 56 2 57 ;CALL function
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_6   1 2 13 14 56 57 ;PUSH Bytes
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    56         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   41 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Aacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   1 36 8 19 13 ;PUSH Bytes
CALL            13 19 8 36 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Acircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   1 36 8 19 13 ;PUSH Bytes
CALL            13 19 8 36 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Adieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   1 36 8 19 13 ;PUSH Bytes
CALL            13 19 8 36 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_5   37 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 37 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[rp0,rnd,white] 45         ;Move Direct Relative Point
                           #--- PUSHB_5   40 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 40 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   45 40 10  ;PUSH Bytes
CALL            10 40 45   ;CALL function
                           #--- PUSHB_4   64 45 10 9 ;PUSH Bytes
CALL            9 10 45 64 ;CALL function
                           #--- PUSHB_4   64 45 17 9 ;PUSH Bytes
CALL            9 17 45 64 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_5   50 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 50 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   40 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   1 36      ;PUSH Bytes
IP              36         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_4   14 20 34 35 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              35 34 20 14 ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_3   0 33 29   ;PUSH Bytes
IP              29         ;Interpolate Point
IP              33         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Agrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   1 36 8 19 13 ;PUSH Bytes
CALL            13 19 8 36 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Aring': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   1 36 8 19 13 ;PUSH Bytes
CALL            13 19 8 36 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_5   53 7 0 86 4 ;PUSH Bytes
CALL            4 86 0 7 53 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_5   37 7 0 86 4 ;PUSH Bytes
CALL            4 86 0 7 37 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[rp0,rnd,white] 45         ;Move Direct Relative Point
                           #--- PUSHB_5   50 9 0 86 4 ;PUSH Bytes
CALL            4 86 0 9 50 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   45 50 10  ;PUSH Bytes
CALL            10 50 45   ;CALL function
                           #--- PUSHB_4   64 45 17 9 ;PUSH Bytes
CALL            9 17 45 64 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_5   40 9 0 86 4 ;PUSH Bytes
CALL            4 86 0 9 40 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   55 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_6   20 34 35 37 43 14 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              14 43 37 35 34 20 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   45 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              45         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Atilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   1 36 8 19 13 ;PUSH Bytes
CALL            13 19 8 36 1 ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   58 7      ;PUSH Bytes
MIRP[min,black] stem 58    ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_2   58 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   6 4 0     ;PUSH Bytes
CALL            0 4 6      ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_5   23 42 18 6 13 ;PUSH Bytes
CALL            13 6 18 42 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   0 32 10   ;PUSH Bytes
CALL            10 32 0    ;CALL function
                           #--- PUSHB_4   64 0 4 9  ;PUSH Bytes
CALL            9 4 0 64   ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   10 9      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   36 11     ;PUSH Bytes
CALL            11 36      ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   27 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   27 39 10  ;PUSH Bytes
CALL            10 39 27   ;CALL function
                           #--- PUSHB_4   0 27 32 9 ;PUSH Bytes
CALL            9 32 27 0  ;CALL function
                           #--- PUSHB_3   10 4 0    ;PUSH Bytes
CALL            0 4 10     ;CALL function
                           #--- PUSHB_3   5 4 0     ;PUSH Bytes
CALL            0 4 5      ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   17 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_3   5 27 39   ;PUSH Bytes
IP              39         ;Interpolate Point
IP              27         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_2   30 32     ;PUSH Bytes
IP              32         ;Interpolate Point
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   7 15      ;PUSH Bytes
IP              15         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ccedilla': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   59 7      ;PUSH Bytes
MIRP[min,black] stem 59    ;Move Indirect Relative Point
                           #--- PUSHB_3   59 4 10   ;PUSH Bytes
CALL            10 4 59    ;CALL function
                           #--- PUSHB_4   0 59 64 9 ;PUSH Bytes
CALL            9 64 59 0  ;CALL function
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_3   42 4 0    ;PUSH Bytes
CALL            0 4 42     ;CALL function
                           #--- PUSHB_3   37 4 0    ;PUSH Bytes
CALL            0 4 37     ;CALL function
                           #--- PUSHB_2   52 7      ;PUSH Bytes
MIRP[min,black] stem 52    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   19 7      ;PUSH Bytes
MIRP[min,black] stem 19    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   5 7 0 86 4 ;PUSH Bytes
CALL            4 86 0 7 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_2   56 9      ;PUSH Bytes
MIRP[min,black] stemw 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 22 10   ;PUSH Bytes
CALL            10 22 7    ;CALL function
                           #--- PUSHB_4   64 7 0 9  ;PUSH Bytes
CALL            9 0 7 64   ;CALL function
                           #--- PUSHB_3   22 7 10   ;PUSH Bytes
CALL            10 7 22    ;CALL function
                           #--- PUSHB_4   0 22 13 9 ;PUSH Bytes
CALL            9 13 22 0  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   5 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   37 52     ;PUSH Bytes
IP              52         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
                           #--- PUSHB_2   45 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   62 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              62         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_3   13 7 16   ;PUSH Bytes
IP              16         ;Interpolate Point
IP              7          ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   52 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   39 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   19 7      ;PUSH Bytes
MIRP[min,black] stem 19    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   6 4 0     ;PUSH Bytes
CALL            0 4 6      ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 27 10   ;PUSH Bytes
CALL            10 27 0    ;CALL function
                           #--- PUSHB_4   64 0 17 9 ;PUSH Bytes
CALL            9 17 0 64  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   13 9 10   ;PUSH Bytes
CALL            10 9 13    ;CALL function
                           #--- PUSHB_4   0 13 5 9  ;PUSH Bytes
CALL            9 5 13 0   ;CALL function
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   16 20 10  ;PUSH Bytes
CALL            10 20 16   ;CALL function
                           #--- PUSHB_4   0 16 24 9 ;PUSH Bytes
CALL            9 24 16 0  ;CALL function
                           #--- PUSHB_5   29 0 9 20 13 ;PUSH Bytes
CALL            13 20 9 0 29 ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 29 10   ;PUSH Bytes
CALL            10 29 0    ;CALL function
                           #--- PUSHB_4   64 0 38 9 ;PUSH Bytes
CALL            9 38 0 64  ;CALL function
                           #--- PUSHB_3   29 0 10   ;PUSH Bytes
CALL            10 0 29    ;CALL function
                           #--- PUSHB_4   64 29 33 9 ;PUSH Bytes
CALL            9 33 29 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_4   22 8 2 8  ;PUSH Bytes
CALL            8 2 8 22   ;CALL function
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   2 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Eacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   13 9 10   ;PUSH Bytes
CALL            10 9 13    ;CALL function
                           #--- PUSHB_4   0 13 5 9  ;PUSH Bytes
CALL            9 5 13 0   ;CALL function
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   16 20 10  ;PUSH Bytes
CALL            10 20 16   ;CALL function
                           #--- PUSHB_4   0 16 24 9 ;PUSH Bytes
CALL            9 24 16 0  ;CALL function
                           #--- PUSHB_5   29 0 9 20 13 ;PUSH Bytes
CALL            13 20 9 0 29 ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 29 10   ;PUSH Bytes
CALL            10 29 0    ;CALL function
                           #--- PUSHB_4   64 0 38 9 ;PUSH Bytes
CALL            9 38 0 64  ;CALL function
                           #--- PUSHB_3   29 0 10   ;PUSH Bytes
CALL            10 0 29    ;CALL function
                           #--- PUSHB_4   64 29 33 9 ;PUSH Bytes
CALL            9 33 29 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_4   22 8 2 8  ;PUSH Bytes
CALL            8 2 8 22   ;CALL function
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   45 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              45         ;Interpolate Point
                           #--- PUSHB_2   26 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   53 56     ;PUSH Bytes
IP              56         ;Interpolate Point
IP              53         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ecircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   13 9 10   ;PUSH Bytes
CALL            10 9 13    ;CALL function
                           #--- PUSHB_4   0 13 5 9  ;PUSH Bytes
CALL            9 5 13 0   ;CALL function
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   16 20 10  ;PUSH Bytes
CALL            10 20 16   ;CALL function
                           #--- PUSHB_4   0 16 24 9 ;PUSH Bytes
CALL            9 24 16 0  ;CALL function
                           #--- PUSHB_5   29 0 9 20 13 ;PUSH Bytes
CALL            13 20 9 0 29 ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 29 10   ;PUSH Bytes
CALL            10 29 0    ;CALL function
                           #--- PUSHB_4   64 0 38 9 ;PUSH Bytes
CALL            9 38 0 64  ;CALL function
                           #--- PUSHB_3   29 0 10   ;PUSH Bytes
CALL            10 0 29    ;CALL function
                           #--- PUSHB_4   64 29 33 9 ;PUSH Bytes
CALL            9 33 29 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_4   22 8 2 8  ;PUSH Bytes
CALL            8 2 8 22   ;CALL function
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   1 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_3   42 51 54  ;PUSH Bytes
IP              54         ;Interpolate Point
IP              51         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_2   26 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   45 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              45         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Edieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   13 9 10   ;PUSH Bytes
CALL            10 9 13    ;CALL function
                           #--- PUSHB_4   0 13 5 9  ;PUSH Bytes
CALL            9 5 13 0   ;CALL function
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   16 20 10  ;PUSH Bytes
CALL            10 20 16   ;CALL function
                           #--- PUSHB_4   0 16 24 9 ;PUSH Bytes
CALL            9 24 16 0  ;CALL function
                           #--- PUSHB_5   29 0 9 20 13 ;PUSH Bytes
CALL            13 20 9 0 29 ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 29 10   ;PUSH Bytes
CALL            10 29 0    ;CALL function
                           #--- PUSHB_4   64 0 38 9 ;PUSH Bytes
CALL            9 38 0 64  ;CALL function
                           #--- PUSHB_3   29 0 10   ;PUSH Bytes
CALL            10 0 29    ;CALL function
                           #--- PUSHB_4   64 29 33 9 ;PUSH Bytes
CALL            9 33 29 64 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp1]        57         ;SHift Point using reference point
                           #--- PUSHB_5   42 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 42 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_1   50        ;PUSH Bytes
                           #--- DUP       #50       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_5   45 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 45 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   60 11     ;PUSH Bytes
CALL            11 60      ;CALL function
                           #--- PUSHB_5   55 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_4   22 8 2 8  ;PUSH Bytes
CALL            8 2 8 22   ;CALL function
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   1 50      ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_2   2 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Egrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   13 9 10   ;PUSH Bytes
CALL            10 9 13    ;CALL function
                           #--- PUSHB_4   0 13 5 9  ;PUSH Bytes
CALL            9 5 13 0   ;CALL function
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   16 20 10  ;PUSH Bytes
CALL            10 20 16   ;CALL function
                           #--- PUSHB_4   0 16 24 9 ;PUSH Bytes
CALL            9 24 16 0  ;CALL function
                           #--- PUSHB_5   29 0 9 20 13 ;PUSH Bytes
CALL            13 20 9 0 29 ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 29 10   ;PUSH Bytes
CALL            10 29 0    ;CALL function
                           #--- PUSHB_4   64 0 38 9 ;PUSH Bytes
CALL            9 38 0 64  ;CALL function
                           #--- PUSHB_3   29 0 10   ;PUSH Bytes
CALL            10 0 29    ;CALL function
                           #--- PUSHB_4   64 29 33 9 ;PUSH Bytes
CALL            9 33 29 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_4   22 8 2 8  ;PUSH Bytes
CALL            8 2 8 22   ;CALL function
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   53 56     ;PUSH Bytes
IP              56         ;Interpolate Point
IP              53         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   45 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              45         ;Interpolate Point
                           #--- PUSHB_2   2 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Eth': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_3   12 4 0    ;PUSH Bytes
CALL            0 4 12     ;CALL function
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_5   5 1 21 12 13 ;PUSH Bytes
CALL            13 12 21 1 5 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_2   41 9      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   41 26 10  ;PUSH Bytes
CALL            10 26 41   ;CALL function
                           #--- PUSHB_4   64 41 37 9 ;PUSH Bytes
CALL            9 37 41 64 ;CALL function
                           #--- PUSHB_3   26 41 10  ;PUSH Bytes
CALL            10 41 26   ;CALL function
                           #--- PUSHB_4   64 26 3 9 ;PUSH Bytes
CALL            9 3 26 64  ;CALL function
                           #--- PUSHB_4   64 26 23 9 ;PUSH Bytes
CALL            9 23 26 64 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   17 9      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   14 18 10  ;PUSH Bytes
CALL            10 18 14   ;CALL function
                           #--- PUSHB_4   0 14 22 9 ;PUSH Bytes
CALL            9 22 14 0  ;CALL function
                           #--- PUSHB_5   27 0 7 18 13 ;PUSH Bytes
CALL            13 18 7 0 27 ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 27 10   ;PUSH Bytes
CALL            10 27 0    ;CALL function
                           #--- PUSHB_4   64 0 36 9 ;PUSH Bytes
CALL            9 36 0 64  ;CALL function
                           #--- PUSHB_3   27 0 10   ;PUSH Bytes
CALL            10 0 27    ;CALL function
                           #--- PUSHB_4   64 27 31 9 ;PUSH Bytes
CALL            9 31 27 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'G': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_3   33 4 0    ;PUSH Bytes
CALL            0 4 33     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_5   13 17 26 33 13 ;PUSH Bytes
CALL            13 33 26 17 13 ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_4   43 26 33 8 ;PUSH Bytes
CALL            8 33 26 43 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   6 9       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   35 45     ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_3   24 11 10  ;PUSH Bytes
CALL            10 11 24   ;CALL function
                           #--- PUSHB_4   64 24 20 9 ;PUSH Bytes
CALL            9 20 24 64 ;CALL function
                           #--- PUSHB_3   11 24 10  ;PUSH Bytes
CALL            10 24 11   ;CALL function
                           #--- PUSHB_4   64 11 15 9 ;PUSH Bytes
CALL            9 15 11 64 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   26 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   0 43      ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'H': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 40 50   ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   24 28 38  ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_5   26 1 8 19 13 ;PUSH Bytes
CALL            13 19 8 1 26 ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   2 9       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   2 13 10   ;PUSH Bytes
CALL            10 13 2    ;CALL function
                           #--- PUSHB_4   64 2 5 9  ;PUSH Bytes
CALL            9 5 2 64   ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   13 2 10   ;PUSH Bytes
CALL            10 2 13    ;CALL function
                           #--- PUSHB_4   64 13 10 9 ;PUSH Bytes
CALL            9 10 13 64 ;CALL function
                           #--- PUSHB_4   64 13 17 9 ;PUSH Bytes
CALL            9 17 13 64 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   40 9      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   40 51 10  ;PUSH Bytes
CALL            10 51 40   ;CALL function
                           #--- PUSHB_4   64 40 36 9 ;PUSH Bytes
CALL            9 36 40 64 ;CALL function
                           #--- PUSHB_4   64 40 43 9 ;PUSH Bytes
CALL            9 43 40 64 ;CALL function
                           #--- PUSHB_3   51 40 10  ;PUSH Bytes
CALL            10 40 51   ;CALL function
                           #--- PUSHB_4   64 51 31 9 ;PUSH Bytes
CALL            9 31 51 64 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'I': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Iacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   1 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Icircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   1 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   24 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Idieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_5   24 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 24 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_5   27 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   37 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 37 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Igrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'J': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 4 10   ;PUSH Bytes
CALL            10 4 15    ;CALL function
                           #--- PUSHB_4   0 15 10 9 ;PUSH Bytes
CALL            9 10 15 0  ;CALL function
                           #--- PUSHB_3   24 4 0    ;PUSH Bytes
CALL            0 4 24     ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 18 10   ;PUSH Bytes
CALL            10 18 1    ;CALL function
                           #--- PUSHB_4   64 1 27 9 ;PUSH Bytes
CALL            9 27 1 64  ;CALL function
                           #--- PUSHB_3   18 1 10   ;PUSH Bytes
CALL            10 1 18    ;CALL function
                           #--- PUSHB_4   64 18 22 9 ;PUSH Bytes
CALL            9 22 18 64 ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   18 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'K': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_2   1 41      ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   23 26 36  ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   25 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'L': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   13 9 10   ;PUSH Bytes
CALL            10 9 13    ;CALL function
                           #--- PUSHB_4   0 13 5 9  ;PUSH Bytes
CALL            9 5 13 0   ;CALL function
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 14 10   ;PUSH Bytes
CALL            10 14 1    ;CALL function
                           #--- PUSHB_4   64 1 23 9 ;PUSH Bytes
CALL            9 23 1 64  ;CALL function
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'M': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 31 41   ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   21 4 0    ;PUSH Bytes
CALL            0 4 21     ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 29 43   ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 15 10   ;PUSH Bytes
CALL            10 15 4    ;CALL function
                           #--- PUSHB_4   64 4 7 9  ;PUSH Bytes
CALL            9 7 4 64   ;CALL function
                           #--- PUSHB_3   15 4 10   ;PUSH Bytes
CALL            10 4 15    ;CALL function
                           #--- PUSHB_4   64 15 12 9 ;PUSH Bytes
CALL            9 12 15 64 ;CALL function
                           #--- PUSHB_4   64 15 19 9 ;PUSH Bytes
CALL            9 19 15 64 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   31 9      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 42 10  ;PUSH Bytes
CALL            10 42 31   ;CALL function
                           #--- PUSHB_4   64 31 27 9 ;PUSH Bytes
CALL            9 27 31 64 ;CALL function
                           #--- PUSHB_4   64 31 34 9 ;PUSH Bytes
CALL            9 34 31 64 ;CALL function
                           #--- PUSHB_3   42 31 10  ;PUSH Bytes
CALL            10 31 42   ;CALL function
                           #--- PUSHB_4   64 42 39 9 ;PUSH Bytes
CALL            9 39 42 64 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   22 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   0 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'N': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_2   23 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 14 10   ;PUSH Bytes
CALL            10 14 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_3   14 3 10   ;PUSH Bytes
CALL            10 3 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_4   64 14 18 9 ;PUSH Bytes
CALL            9 18 14 64 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 22 10   ;PUSH Bytes
CALL            10 22 0    ;CALL function
                           #--- PUSHB_4   64 0 31 9 ;PUSH Bytes
CALL            9 31 0 64  ;CALL function
                           #--- PUSHB_3   22 0 10   ;PUSH Bytes
CALL            10 0 22    ;CALL function
                           #--- PUSHB_4   64 22 26 9 ;PUSH Bytes
CALL            9 26 22 64 ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   22 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   1 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   2 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ntilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_2   23 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_2   56 7      ;PUSH Bytes
MIRP[min,black] stem 56    ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 14 10   ;PUSH Bytes
CALL            10 14 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_3   14 3 10   ;PUSH Bytes
CALL            10 3 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_4   64 14 18 9 ;PUSH Bytes
CALL            9 18 14 64 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 22 10   ;PUSH Bytes
CALL            10 22 0    ;CALL function
                           #--- PUSHB_4   64 0 31 9 ;PUSH Bytes
CALL            9 31 0 64  ;CALL function
                           #--- PUSHB_3   22 0 10   ;PUSH Bytes
CALL            10 0 22    ;CALL function
                           #--- PUSHB_4   64 22 26 9 ;PUSH Bytes
CALL            9 26 22 64 ;CALL function
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   3 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_5   1 21 41 50 56 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              56 50 41 21 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   2 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_2   35 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
                           #--- PUSHB_2   56 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'O': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 4 0     ;PUSH Bytes
CALL            0 4 0      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Oacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 4 0     ;PUSH Bytes
CALL            0 4 0      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 28 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 28 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ocircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 4 0     ;PUSH Bytes
CALL            0 4 0      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 25 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 25 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Odieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 4 0     ;PUSH Bytes
CALL            0 4 0      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_5   22 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 22 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_5   25 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_5   35 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   40 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   6 11 16 0 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              0 16 11 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ograve': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 4 0     ;PUSH Bytes
CALL            0 4 0      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 25 33 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              33 25 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Otilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 4 0     ;PUSH Bytes
CALL            0 4 0      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] stem 43    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 28 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 28 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   22 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_2   43 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'P': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_5   0 25 7 18 13 ;PUSH Bytes
CALL            13 18 7 25 0 ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Q': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   44 7      ;PUSH Bytes
MIRP[min,black] stem 44    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_4   30 27 3 8 ;PUSH Bytes
CALL            8 3 27 30  ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   47 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_7   0 10 19 24 13 30 25 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              25 30 13 24 19 10 0 ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_2   27 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   25 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_2   39 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   21 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'R': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_2   1 27      ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_5   0 37 7 18 13 ;PUSH Bytes
CALL            13 18 7 37 0 ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 41 10  ;PUSH Bytes
CALL            10 41 22   ;CALL function
                           #--- PUSHB_4   64 22 30 9 ;PUSH Bytes
CALL            9 30 22 64 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   24 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'S': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   41 7      ;PUSH Bytes
MIRP[min,black] stem 41    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 4 0     ;PUSH Bytes
CALL            0 4 3      ;CALL function
                           #--- PUSHB_3   58 4 0    ;PUSH Bytes
CALL            0 4 58     ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   29 9      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_4   55 29 33 8 ;PUSH Bytes
CALL            8 33 29 55 ;CALL function
                           #--- PUSHB_2   16 9      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
                           #--- DUP       #10       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   6 9       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   55 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_2   31 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_2   10 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_6   20 26 41 51 52 58 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              58 52 51 41 26 20 ;Interpolate Point
                           #--- PUSHB_2   6 44      ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_6   0 8 23 28 36 55 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              55 36 28 23 8 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'T': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[min,black] stem 10    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_5   16 8 0 15 4 ;PUSH Bytes
CALL            4 15 0 8 16 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   64 0 3 9  ;PUSH Bytes
CALL            9 3 0 64   ;CALL function
                           #--- PUSHB_3   11 0 10   ;PUSH Bytes
CALL            10 0 11    ;CALL function
                           #--- PUSHB_4   64 11 8 9 ;PUSH Bytes
CALL            9 8 11 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Thorn': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
                           #--- PUSHB_5   0 32 7 25 13 ;PUSH Bytes
CALL            13 25 7 32 0 ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   24 32     ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   29 9      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'U': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 18 27   ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 7 10   ;PUSH Bytes
CALL            10 7 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 26 10   ;PUSH Bytes
CALL            10 26 1    ;CALL function
                           #--- PUSHB_4   64 1 35 9 ;PUSH Bytes
CALL            9 35 1 64  ;CALL function
                           #--- PUSHB_3   26 1 10   ;PUSH Bytes
CALL            10 1 26    ;CALL function
                           #--- PUSHB_4   64 26 30 9 ;PUSH Bytes
CALL            9 30 26 64 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Uacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 18 27   ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 7 10   ;PUSH Bytes
CALL            10 7 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 26 10   ;PUSH Bytes
CALL            10 26 1    ;CALL function
                           #--- PUSHB_4   64 1 35 9 ;PUSH Bytes
CALL            9 35 1 64  ;CALL function
                           #--- PUSHB_3   26 1 10   ;PUSH Bytes
CALL            10 1 26    ;CALL function
                           #--- PUSHB_4   64 26 30 9 ;PUSH Bytes
CALL            9 30 26 64 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   4 44 52   ;PUSH Bytes
IP              52         ;Interpolate Point
IP              44         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ucircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 18 27   ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 7 10   ;PUSH Bytes
CALL            10 7 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 26 10   ;PUSH Bytes
CALL            10 26 1    ;CALL function
                           #--- PUSHB_4   64 1 35 9 ;PUSH Bytes
CALL            9 35 1 64  ;CALL function
                           #--- PUSHB_3   26 1 10   ;PUSH Bytes
CALL            10 1 26    ;CALL function
                           #--- PUSHB_4   64 26 30 9 ;PUSH Bytes
CALL            9 30 26 64 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   4 41 53   ;PUSH Bytes
IP              53         ;Interpolate Point
IP              41         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Udieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 18 27   ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp1]        53         ;SHift Point using reference point
                           #--- PUSHB_5   38 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 38 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 7 10   ;PUSH Bytes
CALL            10 7 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_4   46 20 7 8 ;PUSH Bytes
CALL            8 7 20 46  ;CALL function
                           #--- PUSHB_5   41 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 41 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 26 10   ;PUSH Bytes
CALL            10 26 1    ;CALL function
                           #--- PUSHB_4   64 1 35 9 ;PUSH Bytes
CALL            9 35 1 64  ;CALL function
                           #--- PUSHB_4   51 1 26 8 ;PUSH Bytes
CALL            8 26 1 51  ;CALL function
                           #--- PUSHB_5   56 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 56 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_5   51 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 51 ;CALL function
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   41 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   38 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_2   4 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ugrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 18 27   ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 7 10   ;PUSH Bytes
CALL            10 7 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 26 10   ;PUSH Bytes
CALL            10 26 1    ;CALL function
                           #--- PUSHB_4   64 1 35 9 ;PUSH Bytes
CALL            9 35 1 64  ;CALL function
                           #--- PUSHB_3   26 1 10   ;PUSH Bytes
CALL            10 1 26    ;CALL function
                           #--- PUSHB_4   64 26 30 9 ;PUSH Bytes
CALL            9 30 26 64 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   4 41 49   ;PUSH Bytes
IP              49         ;Interpolate Point
IP              41         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'V': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 4 0     ;PUSH Bytes
CALL            0 4 6      ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_3   11 15 25  ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   15 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_4   0 9 18 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 18 9 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'W': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   29 30 32  ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
SHP[rp1]        30         ;SHift Point using reference point
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   13 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 13 ;Move Indirect Relative Point
                           #--- PUSHB_3   6 4 0     ;PUSH Bytes
CALL            0 4 6      ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_3   11 17 28  ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_4   15 0 6 8  ;PUSH Bytes
CALL            8 6 0 15   ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   13 14     ;PUSH Bytes
SDPVTL[orthog]  14 13      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[no-rnd]    13         ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   32 12     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin_2 32 ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   14 12     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin_2 14 ;Move Indirect Relative Point
                           #--- PUSHB_2   31 30     ;PUSH Bytes
SDPVTL[orthog]  30 31      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[no-rnd]    30         ;Move Direct Absolute Point
                           #--- PUSHB_2   32 31     ;PUSH Bytes
SFVTL[parallel] 31 32      ;Set Freedom Vector To Line
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[grey]      31         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[rp0,min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[grey]      15         ;Move Direct Relative Point
                           #--- PUSHB_2   16 17     ;PUSH Bytes
SDPVTL[orthog]  17 16      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[no-rnd]    29         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   28 11     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 28 ;Move Indirect Relative Point
                           #--- PUSHB_2   15 16     ;PUSH Bytes
SFVTL[parallel] 16 15      ;Set Freedom Vector To Line
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   16 11     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 16 ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 31     ;PUSH Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    9 13 14 15 16 28 29 30 31 32 ;PUSH N Bytes
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    29         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   0 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'X': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] stem 24    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 11 14   ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   32 4 0    ;PUSH Bytes
CALL            0 4 32     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_3   37 40 50  ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        37         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   13 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Y': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   24 27 37  ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   1 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Yacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   24 27 37  ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   1 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Z': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 1 10   ;PUSH Bytes
CALL            10 1 15    ;CALL function
                           #--- PUSHB_4   0 15 19 9 ;PUSH Bytes
CALL            9 19 15 0  ;CALL function
                           #--- PUSHB_3   11 4 0    ;PUSH Bytes
CALL            0 4 11     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   5 11 10   ;PUSH Bytes
CALL            10 11 5    ;CALL function
                           #--- PUSHB_4   64 5 8 9  ;PUSH Bytes
CALL            9 8 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   6 9       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
                           #--- DUP       #2        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_4   13 0 16 8 ;PUSH Bytes
CALL            8 16 0 13  ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   15 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_2   0 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   2 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'a': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_5   30 39 24 11 13 ;PUSH Bytes
CALL            13 11 24 39 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   32 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 22 10  ;PUSH Bytes
CALL            10 22 15   ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   22 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_4   11 7 24 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 24 7 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 27 22 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'aacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_5   30 39 24 11 13 ;PUSH Bytes
CALL            13 11 24 39 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   32 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 22 10  ;PUSH Bytes
CALL            10 22 15   ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   22 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_6   11 7 24 30 54 62 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              62 54 30 24 7 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 27 22 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'acircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_5   30 39 24 11 13 ;PUSH Bytes
CALL            13 11 24 39 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   32 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 22 10  ;PUSH Bytes
CALL            10 22 15   ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   22 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_7   11 7 24 30 48 54 63 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              63 54 48 30 24 7 11 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 27 22 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'acute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 8 0 14 4 ;PUSH Bytes
CALL            4 14 0 8 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'adieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   48 6 0    ;PUSH Bytes
CALL            0 6 48     ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_5   54 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 54 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp2]        63         ;SHift Point using reference point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_5   30 39 24 11 13 ;PUSH Bytes
CALL            13 11 24 39 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   51 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   32 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 22 10  ;PUSH Bytes
CALL            10 22 15   ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_1   61        ;PUSH Bytes
                           #--- DUP       #61       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 61         ;Move Direct Relative Point
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_5   66 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 66 ;CALL function
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_5   61 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 61 ;CALL function
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_2   56 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_3   24 45 4   ;PUSH Bytes
IP              4          ;Interpolate Point
IP              45         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_4   11 30 0 39 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              39 0 30 11 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_2   58 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              58         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 27 22 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ae': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SHP[rp2]        66         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp2]        73         ;SHift Point using reference point
                           #--- PUSHB_3   0 10 10   ;PUSH Bytes
CALL            10 10 0    ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
                           #--- PUSHB_5   68 20 33 10 13 ;PUSH Bytes
CALL            13 10 33 20 68 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp1]        56         ;SHift Point using reference point
                           #--- PUSHB_2   68 7      ;PUSH Bytes
MIRP[min,black] stem 68    ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_1   58        ;PUSH Bytes
                           #--- DUP       #58       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 58         ;Move Direct Relative Point
SRP1            58         ;Set Reference Point 1
                           #--- PUSHB_2   49 7      ;PUSH Bytes
MIRP[min,black] stem 49    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_2   63 9      ;PUSH Bytes
MIRP[min,black] stemw 63   ;Move Indirect Relative Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   51 55     ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp2]        68         ;SHift Point using reference point
                           #--- PUSHB_3   36 39 10  ;PUSH Bytes
CALL            10 39 36   ;CALL function
                           #--- PUSHB_4   64 36 19 9 ;PUSH Bytes
CALL            9 19 36 64 ;CALL function
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   39 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   10 6 42 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 42 6 10 ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   13 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_7   26 29 35 40 44 55 63 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              63 55 44 40 35 29 26 ;Interpolate Point
                           #--- PUSHB_2   0 49      ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'agrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_5   30 39 24 11 13 ;PUSH Bytes
CALL            13 11 24 39 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   32 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 22 10  ;PUSH Bytes
CALL            10 22 15   ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   22 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_6   11 7 24 30 51 59 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              59 51 30 24 7 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 27 22 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ampersand': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   55 7      ;PUSH Bytes
MIRP[min,black] stem 55    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_1   19        ;PUSH Bytes
                           #--- DUP       #19       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   52 9      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   29 9      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   55 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_2   39 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_5   6 1 31 48 52 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              52 48 31 1 6 ;Interpolate Point
                           #--- PUSHB_2   24 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_4   9 12 29 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 29 12 9 ;Interpolate Point
                           #--- PUSHB_2   19 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   17 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'aring': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_5   30 39 24 11 13 ;PUSH Bytes
CALL            13 11 24 39 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_5   64 7 0 86 4 ;PUSH Bytes
CALL            4 86 0 7 64 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_5   48 7 0 86 4 ;PUSH Bytes
CALL            4 86 0 7 48 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   61 9 0 86 4 ;PUSH Bytes
CALL            4 86 0 9 61 ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP0            61         ;Set Reference Point 0
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_5   51 9 0 86 4 ;PUSH Bytes
CALL            4 86 0 9 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   32 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 22 10  ;PUSH Bytes
CALL            10 22 15   ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_2   56 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_2   4 7       ;PUSH Bytes
IP              7          ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_2   24 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_6   11 30 0 39 54 48 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              48 54 39 0 30 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 27 22 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_2   59 64     ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_2   56 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              56         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asciicircum': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 6 0     ;PUSH Bytes
CALL            0 6 0      ;CALL function
                           #--- PUSHB_5   12 8 0 8 4 ;PUSH Bytes
CALL            4 8 0 8 12 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asciitilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   7 4       ;PUSH Bytes
IP              4          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   19 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asterisk': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 5 0     ;PUSH Bytes
CALL            0 5 3      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   6 9       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   41 0      ;PUSH Bytes
SDPVTL[orthog]  0 41       ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[grey]      41         ;Move Direct Relative Point
                           #--- PUSHB_2   33 7      ;PUSH Bytes
MIRP[rp0,min,black] stem 33    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[grey]      34         ;Move Direct Relative Point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
SDPVTL[orthog]  7 6        ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[no-rnd]    6          ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[grey]      7          ;Move Direct Relative Point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[rp0,min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[grey]      14         ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_8   0 6 7 14 15 33 34 41 ;PUSH Bytes
MDAP[no-rnd]    41         ;Move Direct Absolute Point
MDAP[no-rnd]    34         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   7 14 15 33 34 41 ;PUSH Bytes
MDAP[no-rnd]    41         ;Move Direct Absolute Point
MDAP[no-rnd]    34         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'at': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 2 0     ;PUSH Bytes
CALL            0 2 9      ;CALL function
                           #--- PUSHB_2   49 7      ;PUSH Bytes
MIRP[min,black] stem 49    ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 7      ;PUSH Bytes
MIRP[min,black] stem 21    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 31 10  ;PUSH Bytes
CALL            10 31 21   ;CALL function
                           #--- PUSHB_4   0 21 25 9 ;PUSH Bytes
CALL            9 25 21 0  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   55 7      ;PUSH Bytes
MIRP[min,black] stem 55    ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   17 9      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   52 9      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   43 9      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 48 10  ;PUSH Bytes
CALL            10 48 43   ;CALL function
                           #--- PUSHB_4   64 43 45 9 ;PUSH Bytes
CALL            9 45 43 64 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   48 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_6   3 13 21 23 31 39 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              39 31 23 21 13 3 ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_2   25 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   55 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_2   43 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'atilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   69 5 0    ;PUSH Bytes
CALL            0 5 69     ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_2   60 7      ;PUSH Bytes
MIRP[min,black] stem 60    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_5   30 39 24 11 13 ;PUSH Bytes
CALL            13 11 24 39 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   48 57 4 69 13 ;PUSH Bytes
CALL            13 69 4 57 48 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp1]        63         ;SHift Point using reference point
                           #--- PUSHB_2   48 7      ;PUSH Bytes
MIRP[min,black] stem 48    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   32 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 22 10  ;PUSH Bytes
CALL            10 22 15   ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   22 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_7   11 7 24 30 48 57 66 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              66 57 48 30 24 7 11 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_2   51 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              51         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 27 22 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_2   48 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   66        ;PUSH Bytes
IP              66         ;Interpolate Point
                           #--- PUSHB_2   69 60     ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'b': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   24 5 0    ;PUSH Bytes
CALL            0 5 24     ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 27      ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_5   22 10 0 17 4 ;PUSH Bytes
CALL            4 17 0 10 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   6 9       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   33 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   25 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_5   6 11 1 28 33 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              33 28 1 11 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'backslash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 5 0     ;PUSH Bytes
CALL            0 5 7      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'braceleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 5 0    ;PUSH Bytes
CALL            0 5 33     ;CALL function
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   18 8 10   ;PUSH Bytes
CALL            10 8 18    ;CALL function
                           #--- PUSHB_4   64 18 24 9 ;PUSH Bytes
CALL            9 24 18 64 ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   7 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   1 30      ;PUSH Bytes
IP              30         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'braceright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 5 0    ;PUSH Bytes
CALL            0 5 15     ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   30 9      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   30 0 10   ;PUSH Bytes
CALL            10 0 30    ;CALL function
                           #--- PUSHB_4   64 30 24 9 ;PUSH Bytes
CALL            9 24 30 64 ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   1 30      ;PUSH Bytes
IP              30         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   7 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bracketleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 5 0     ;PUSH Bytes
CALL            0 5 8      ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 7 10    ;PUSH Bytes
CALL            10 7 1     ;CALL function
                           #--- PUSHB_4   0 1 4 9   ;PUSH Bytes
CALL            9 4 1 0    ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bracketright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 5 0     ;PUSH Bytes
CALL            0 5 6      ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 8 10    ;PUSH Bytes
CALL            10 8 0     ;CALL function
                           #--- PUSHB_4   0 0 11 9  ;PUSH Bytes
CALL            9 11 0 0   ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'brokenbar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 5 0     ;PUSH Bytes
CALL            0 5 7      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bullet': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 8 0 11 4 ;PUSH Bytes
CALL            4 11 0 8 0 ;CALL function
                           #--- PUSHB_5   0 8 0 11 4 ;PUSH Bytes
CALL            4 11 0 8 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   3 10 0 11 4 ;PUSH Bytes
CALL            4 11 0 10 3 ;CALL function
                           #--- PUSHB_5   3 10 0 11 4 ;PUSH Bytes
CALL            4 11 0 10 3 ;CALL function
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'c': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   18 9      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   22 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   10 4 31   ;PUSH Bytes
IP              31         ;Interpolate Point
IP              4          ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_2   33 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_5   0 7 12 20 34 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              34 20 12 7 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ccedilla': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   55 7      ;PUSH Bytes
MIRP[min,black] stem 55    ;Move Indirect Relative Point
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
                           #--- PUSHB_2   49 7      ;PUSH Bytes
MIRP[min,black] stem 49    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 7      ;PUSH Bytes
MIRP[min,black] stem 21    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   7 7 0 86 4 ;PUSH Bytes
CALL            4 86 0 7 7 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   52 9      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   24 9 10   ;PUSH Bytes
CALL            10 9 24    ;CALL function
                           #--- PUSHB_4   0 24 15 9 ;PUSH Bytes
CALL            9 15 24 0  ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_2   43 9      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   7 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_3   35 49 55  ;PUSH Bytes
IP              55         ;Interpolate Point
IP              49         ;Interpolate Point
IP              35         ;Interpolate Point
                           #--- PUSHB_2   46 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_2   57 58     ;PUSH Bytes
IP              58         ;Interpolate Point
IP              57         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   15 9 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              9          ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_2   49 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_5   0 32 45 37 58 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              58 37 45 32 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'cedilla': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_5   9 8 0 25 4 ;PUSH Bytes
CALL            4 25 0 8 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_5   12 7 0 86 4 ;PUSH Bytes
CALL            4 86 0 7 12 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 7       ;PUSH Bytes
MIRP[min,black] stem 3     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 14 10   ;PUSH Bytes
CALL            10 14 6    ;CALL function
                           #--- PUSHB_4   0 6 20 9  ;PUSH Bytes
CALL            9 20 6 0   ;CALL function
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   0 14 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              14         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'cent': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 14 10   ;PUSH Bytes
CALL            10 14 0    ;CALL function
                           #--- PUSHB_4   64 0 4 9  ;PUSH Bytes
CALL            9 4 0 64   ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   27 41 10  ;PUSH Bytes
CALL            10 41 27   ;CALL function
                           #--- PUSHB_4   64 27 24 9 ;PUSH Bytes
CALL            9 24 27 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   44 9      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   9 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   0 41      ;PUSH Bytes
IP              41         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_2   29 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   4 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   6 17 36   ;PUSH Bytes
IP              36         ;Interpolate Point
IP              17         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_3   21 29 31  ;PUSH Bytes
IP              31         ;Interpolate Point
IP              29         ;Interpolate Point
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'colon': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_5   0 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 0 ;CALL function
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_5   19 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 19 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   4 10 0 14 4 ;PUSH Bytes
CALL            4 14 0 10 4 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_5   4 10 0 14 4 ;PUSH Bytes
CALL            4 14 0 10 4 ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'comma': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 8 0 7 4 ;PUSH Bytes
CALL            4 7 0 8 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   1 10 0 10 4 ;PUSH Bytes
CALL            4 10 0 10 1 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'copyright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 1 0    ;PUSH Bytes
CALL            0 1 43     ;CALL function
                           #--- PUSHB_2   54 7      ;PUSH Bytes
MIRP[min,black] stem 54    ;Move Indirect Relative Point
                           #--- PUSHB_3   10 3 0    ;PUSH Bytes
CALL            0 3 10     ;CALL function
                           #--- PUSHB_5   23 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 23 ;CALL function
                           #--- PUSHB_5   3 30 43 10 13 ;PUSH Bytes
CALL            13 10 43 30 3 ;CALL function
                           #--- PUSHB_5   3 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 3 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
                           #--- PUSHB_2   51 9      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   27 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_5   16 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   40 9      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   20 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_7   3 10 30 37 43 48 54 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              54 48 43 37 30 10 3 ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   33 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_7   0 18 34 40 46 51 57 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              57 51 46 40 34 18 0 ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'currency': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   51 2 0    ;PUSH Bytes
CALL            0 2 51     ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_3   23 51 10  ;PUSH Bytes
CALL            10 51 23   ;CALL function
                           #--- PUSHB_4   64 23 19 9 ;PUSH Bytes
CALL            9 19 23 64 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   57 7      ;PUSH Bytes
MIRP[min,black] stem 57    ;Move Indirect Relative Point
                           #--- PUSHB_3   49 57 10  ;PUSH Bytes
CALL            10 57 49   ;CALL function
                           #--- PUSHB_4   64 49 3 9 ;PUSH Bytes
CALL            9 3 49 64  ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   54 9      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 54 10  ;PUSH Bytes
CALL            10 54 11   ;CALL function
                           #--- PUSHB_4   64 11 6 9 ;PUSH Bytes
CALL            9 6 11 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 60 10  ;PUSH Bytes
CALL            10 60 36   ;CALL function
                           #--- PUSHB_4   64 36 41 9 ;PUSH Bytes
CALL            9 41 36 64 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   54 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_2   9 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_4   21 0 25 47 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              47 25 0 21 ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   34 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              34         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   57 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_2   47 0      ;PUSH Bytes
IP              0          ;Interpolate Point
IP              47         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_4   9 13 34 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 34 13 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'd': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_3   23 5 0    ;PUSH Bytes
CALL            0 5 23     ;CALL function
                           #--- PUSHB_2   19 7      ;PUSH Bytes
MIRP[min,black] stem 19    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] stem 24    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   17 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 7 10    ;PUSH Bytes
CALL            10 7 1     ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   7 1 10    ;PUSH Bytes
CALL            10 1 7     ;CALL function
                           #--- PUSHB_4   0 7 21 9  ;PUSH Bytes
CALL            9 21 7 0   ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   7 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   10 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_5   8 13 17 27 33 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              33 27 17 13 8 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dagger': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 5 0     ;PUSH Bytes
CALL            0 5 6      ;CALL function
                           #--- PUSHB_3   2 2 0     ;PUSH Bytes
CALL            0 2 2      ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 10   ;PUSH Bytes
CALL            10 2 22    ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   16 9      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   16 20 10  ;PUSH Bytes
CALL            10 20 16   ;CALL function
                           #--- PUSHB_4   64 16 12 9 ;PUSH Bytes
CALL            9 12 16 64 ;CALL function
                           #--- PUSHB_3   20 16 10  ;PUSH Bytes
CALL            10 16 20   ;CALL function
                           #--- PUSHB_4   64 20 0 9 ;PUSH Bytes
CALL            9 0 20 64  ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'daggerdbl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 5 0     ;PUSH Bytes
CALL            0 5 6      ;CALL function
                           #--- PUSHB_3   2 2 0     ;PUSH Bytes
CALL            0 2 2      ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   33 7      ;PUSH Bytes
MIRP[min,black] stem 33    ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_3   29 33 10  ;PUSH Bytes
CALL            10 33 29   ;CALL function
                           #--- PUSHB_4   64 29 25 9 ;PUSH Bytes
CALL            9 25 29 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   3 34      ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   8 15      ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   23 27 10  ;PUSH Bytes
CALL            10 27 23   ;CALL function
                           #--- PUSHB_4   64 23 19 9 ;PUSH Bytes
CALL            9 19 23 64 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   27 23 10  ;PUSH Bytes
CALL            10 23 27   ;CALL function
                           #--- PUSHB_4   64 27 31 9 ;PUSH Bytes
CALL            9 31 27 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'degree': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   5 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'desc.uni0E10': """

""",

    'dieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 6 0     ;PUSH Bytes
CALL            0 6 0      ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_5   6 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 6 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   0 6 0     ;PUSH Bytes
CALL            0 6 0      ;CALL function
                           #--- PUSHB_5   6 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   13 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 13 ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'divide': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 8 0 21 4 ;PUSH Bytes
CALL            4 21 0 8 8 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   19 8 0 21 4 ;PUSH Bytes
CALL            4 21 0 8 19 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_5   11 10 0 21 4 ;PUSH Bytes
CALL            4 21 0 10 11 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dollar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   56 4 0    ;PUSH Bytes
CALL            0 4 56     ;CALL function
                           #--- PUSHB_3   45 4 0    ;PUSH Bytes
CALL            0 4 45     ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_2   66 7      ;PUSH Bytes
MIRP[min,black] stem 66    ;Move Indirect Relative Point
                           #--- PUSHB_3   45 66 10  ;PUSH Bytes
CALL            10 66 45   ;CALL function
                           #--- PUSHB_4   64 45 48 9 ;PUSH Bytes
CALL            9 48 45 64 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   32 7      ;PUSH Bytes
MIRP[min,black] stem 32    ;Move Indirect Relative Point
                           #--- PUSHB_3   16 32 10  ;PUSH Bytes
CALL            10 32 16   ;CALL function
                           #--- PUSHB_4   64 16 13 9 ;PUSH Bytes
CALL            9 13 16 64 ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_4   20 0 42 8 ;PUSH Bytes
CALL            8 42 0 20  ;CALL function
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_4   59 7 35 8 ;PUSH Bytes
CALL            8 35 7 59  ;CALL function
                           #--- PUSHB_2   63 9      ;PUSH Bytes
MIRP[min,black] stemw 63   ;Move Indirect Relative Point
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp1]        54         ;SHift Point using reference point
                           #--- PUSHB_2   59 9      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   39 37     ;PUSH Bytes
SDPVTL[orthog]  37 39      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[no-rnd]    39         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDRP[grey]      37         ;Move Direct Relative Point
                           #--- PUSHB_2   2 11      ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 2 ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[grey]      5          ;Move Direct Relative Point
                           #--- PUSHB_2   39 37     ;PUSH Bytes
SDPVTL[orthog]  37 39      ;Set Dual Projection Vector To Line
                           #--- PUSHB_2   39 37     ;PUSH Bytes
SFVTL[parallel] 37 39      ;Set Freedom Vector To Line
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_1   37        ;PUSH Bytes
MDRP[grey]      37         ;Move Direct Relative Point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[rp0,min,black] stem 2     ;Move Indirect Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[grey]      4          ;Move Direct Relative Point
                           #--- PUSHB_4   3 2 5 19  ;PUSH Bytes
CALL            19 5 2 3   ;CALL function
                           #--- PUSHB_2   2 5       ;PUSH Bytes
SFVTL[parallel] 5 2        ;Set Freedom Vector To Line
                           #--- PUSHB_4   3 2 4 19  ;PUSH Bytes
CALL            19 4 2 3   ;CALL function
                           #--- PUSHB_4   4 2 5 19  ;PUSH Bytes
CALL            19 5 2 4   ;CALL function
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_4   38 39 37 19 ;PUSH Bytes
CALL            19 37 39 38 ;CALL function
                           #--- PUSHB_3   38 39 37  ;PUSH Bytes
                           #--- DUP       #37       ;DUPlicate top stack element
ROLL            37 37 39   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_7   2 3 4 5 37 38 39 ;PUSH Bytes
MDAP[no-rnd]    39         ;Move Direct Absolute Point
MDAP[no-rnd]    38         ;Move Direct Absolute Point
MDAP[no-rnd]    37         ;Move Direct Absolute Point
MDAP[no-rnd]    5          ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_7   2 3 4 5 37 38 39 ;PUSH Bytes
MDAP[no-rnd]    39         ;Move Direct Absolute Point
MDAP[no-rnd]    38         ;Move Direct Absolute Point
MDAP[no-rnd]    37         ;Move Direct Absolute Point
MDAP[no-rnd]    5          ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   22 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_2   11 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   32 66     ;PUSH Bytes
IP              66         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_1   64        ;PUSH Bytes
IP              64         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   56 61     ;PUSH Bytes
IP              61         ;Interpolate Point
IP              56         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_5   0 7 19 27 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              42 27 19 7 0 ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dottedcircle': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   109 2 0   ;PUSH Bytes
CALL            0 2 109    ;CALL function
                           #--- PUSHB_2   114 8     ;PUSH Bytes
MIRP[min,black] stemt_thick 114 ;Move Indirect Relative Point
                           #--- PUSHB_1   114       ;PUSH Bytes
SRP0            114        ;Set Reference Point 0
                           #--- PUSHB_1   16        ;PUSH Bytes
                           #--- DUP       #16       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   11 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 11 ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_2   41 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 41 ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
                           #--- DUP       #26       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   21 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 21 ;Move Indirect Relative Point
                           #--- PUSHB_1   104       ;PUSH Bytes
                           #--- DUP       #104      ;DUPlicate top stack element
MDRP[rp0,rnd,white] 104        ;Move Direct Relative Point
SRP1            104        ;Set Reference Point 1
                           #--- PUSHB_2   99 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 99 ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_2   51 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 51 ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
                           #--- DUP       #36       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   31 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 31 ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 8       ;PUSH Bytes
MIRP[min,black] stemt_thick 1 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   118       ;PUSH Bytes
MDAP[rnd]       118        ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_5   33 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 33 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   97        ;PUSH Bytes
                           #--- DUP       #97       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 97         ;Move Direct Relative Point
SRP1            97         ;Set Reference Point 1
                           #--- PUSHB_5   93 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 93 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   13 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 13 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_5   23 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 23 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   106 1     ;PUSH Bytes
CALL            1 106      ;CALL function
                           #--- PUSHB_1   116       ;PUSH Bytes
SHP[rp2]        116        ;SHift Point using reference point
                           #--- PUSHB_5   101 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 101 ;CALL function
                           #--- PUSHB_1   111       ;PUSH Bytes
SHP[rp2]        111        ;SHift Point using reference point
                           #--- PUSHB_1   101       ;PUSH Bytes
SRP0            101        ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_5   43 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 43 ;CALL function
                           #--- PUSHB_1   78        ;PUSH Bytes
                           #--- DUP       #78       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 78         ;Move Direct Relative Point
SRP1            78         ;Set Reference Point 1
                           #--- PUSHB_5   73 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 73 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp2]        68         ;SHift Point using reference point
                           #--- PUSHB_5   53 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 53 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp2]        63         ;SHift Point using reference point
                           #--- PUSHB_1   88        ;PUSH Bytes
                           #--- DUP       #88       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 88         ;Move Direct Relative Point
SRP1            88         ;Set Reference Point 1
                           #--- PUSHB_5   83 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 83 ;CALL function
                           #--- PUSHB_2   119 1     ;PUSH Bytes
CALL            1 119      ;CALL function
                           #--- PUSHB_2   38 97     ;PUSH Bytes
SRP1            97         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   90 95     ;PUSH Bytes
IP              95         ;Interpolate Point
IP              90         ;Interpolate Point
                           #--- PUSHB_1   93        ;PUSH Bytes
SRP1            93         ;Set Reference Point 1
                           #--- PUSHB_5   6 0 30 36 91 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              91 36 30 0 6 ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   31 1      ;PUSH Bytes
IP              1          ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_2   23 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_4   11 16 20 26 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              26 20 16 11 ;Interpolate Point
                           #--- PUSHB_2   101 106   ;PUSH Bytes
SRP1            106        ;Set Reference Point 1
SRP2            101        ;Set Reference Point 2
                           #--- PUSHB_2   108 114   ;PUSH Bytes
IP              114        ;Interpolate Point
IP              108        ;Interpolate Point
                           #--- PUSHB_2   73 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            73         ;Set Reference Point 2
                           #--- PUSHB_4   41 46 70 76 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              76 70 46 41 ;Interpolate Point
                           #--- PUSHB_2   88 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            88         ;Set Reference Point 2
                           #--- PUSHB_4   56 50 60 66 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              66 60 50 56 ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_4   51 61 80 86 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              86 80 61 51 ;Interpolate Point
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP2            83         ;Set Reference Point 2
                           #--- PUSHB_1   81        ;PUSH Bytes
IP              81         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 104    ;PUSH Bytes
SRP1            104        ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   101 106   ;PUSH Bytes
IP              106        ;Interpolate Point
IP              101        ;Interpolate Point
                           #--- PUSHB_2   99 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            99         ;Set Reference Point 2
                           #--- PUSHB_2   28 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_2   43 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_2   31 56     ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   33 38 53 58 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              58 53 38 33 ;Interpolate Point
                           #--- PUSHB_2   6 51      ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_6   65 66 80 85 90 94 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              94 90 85 80 66 65 ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_3   60 63 68  ;PUSH Bytes
IP              68         ;Interpolate Point
IP              63         ;Interpolate Point
IP              60         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   75 76     ;PUSH Bytes
IP              76         ;Interpolate Point
IP              75         ;Interpolate Point
                           #--- PUSHB_1   114       ;PUSH Bytes
SRP1            114        ;Set Reference Point 1
                           #--- PUSHB_2   73 78     ;PUSH Bytes
IP              78         ;Interpolate Point
IP              73         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_6   13 18 70 71 111 116 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              116 111 71 70 18 13 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'e': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   26 1 15 21 13 ;PUSH Bytes
CALL            13 21 15 1 26 ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   9 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   26 1 15 21 13 ;PUSH Bytes
CALL            13 21 15 1 26 ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   9 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ecircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   26 1 15 21 13 ;PUSH Bytes
CALL            13 21 15 1 26 ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   9 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'edieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   32 6 0    ;PUSH Bytes
CALL            0 6 32     ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_5   38 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 38 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   26 1 15 21 13 ;PUSH Bytes
CALL            13 21 15 1 26 ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_5   35 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_5   45 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 45 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   35 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_3   4 21 15   ;PUSH Bytes
IP              15         ;Interpolate Point
IP              21         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   9 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'egrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   26 1 15 21 13 ;PUSH Bytes
CALL            13 21 15 1 26 ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   9 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eight': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
                           #--- PUSHB_3   14 6 0    ;PUSH Bytes
CALL            0 6 14     ;CALL function
                           #--- PUSHB_2   19 7      ;PUSH Bytes
MIRP[min,black] stem 19    ;Move Indirect Relative Point
                           #--- PUSHB_5   24 29 5 14 13 ;PUSH Bytes
CALL            13 14 5 29 24 ;CALL function
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] stem 24    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
                           #--- DUP       #11       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   2 9       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
                           #--- DUP       #27       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   16 9      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   27 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_6   5 9 14 0 29 34 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              34 29 0 14 9 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   7 2       ;PUSH Bytes
IP              2          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   9 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   16 11     ;PUSH Bytes
IP              11         ;Interpolate Point
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ellipsis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 28     ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_5   0 8 0 21 4 ;PUSH Bytes
CALL            4 21 0 8 0 ;CALL function
                           #--- PUSHB_2   12 22     ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_5   0 8 0 21 4 ;PUSH Bytes
CALL            4 21 0 8 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   3 10 0 21 4 ;PUSH Bytes
CALL            4 21 0 10 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   15 10 0 21 4 ;PUSH Bytes
CALL            4 21 0 10 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_5   25 10 0 21 4 ;PUSH Bytes
CALL            4 21 0 10 25 ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'emdash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'endash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'equal': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eth': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   48 7      ;PUSH Bytes
MIRP[min,black] stem 48    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 2 0    ;PUSH Bytes
CALL            0 2 13     ;CALL function
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] stem 43    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   46 9      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   51 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_5   8 13 1 31 41 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              41 31 1 13 8 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_3   4 10 16   ;PUSH Bytes
IP              16         ;Interpolate Point
IP              10         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_2   29 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_3   1 18 36   ;PUSH Bytes
IP              36         ;Interpolate Point
IP              18         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'f': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   37 5 0    ;PUSH Bytes
CALL            0 5 37     ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   4 37 10   ;PUSH Bytes
CALL            10 37 4    ;CALL function
                           #--- PUSHB_4   0 4 0 9   ;PUSH Bytes
CALL            9 0 4 0    ;CALL function
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   15 26 10  ;PUSH Bytes
CALL            10 26 15   ;CALL function
                           #--- PUSHB_4   64 15 11 9 ;PUSH Bytes
CALL            9 11 15 64 ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_4   0 15 41 9 ;PUSH Bytes
CALL            9 41 15 0  ;CALL function
                           #--- PUSHB_3   26 15 10  ;PUSH Bytes
CALL            10 15 26   ;CALL function
                           #--- PUSHB_4   64 26 30 9 ;PUSH Bytes
CALL            9 30 26 64 ;CALL function
                           #--- PUSHB_4   64 26 23 9 ;PUSH Bytes
CALL            9 23 26 64 ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'five': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 5 0     ;PUSH Bytes
CALL            0 5 7      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_5   16 0 22 7 13 ;PUSH Bytes
CALL            13 7 22 0 16 ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 16 10   ;PUSH Bytes
CALL            10 16 0    ;CALL function
                           #--- PUSHB_4   64 0 4 9  ;PUSH Bytes
CALL            9 4 0 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 6 10   ;PUSH Bytes
CALL            10 6 14    ;CALL function
                           #--- PUSHB_4   0 14 10 9 ;PUSH Bytes
CALL            9 10 14 0  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_4   0 16 22 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 22 16 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   19 25 27  ;PUSH Bytes
IP              27         ;Interpolate Point
IP              25         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'four': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   3 5 0     ;PUSH Bytes
CALL            0 5 3      ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
                           #--- PUSHB_5   1 27 18 3 13 ;PUSH Bytes
CALL            13 3 18 27 1 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   12 23 10  ;PUSH Bytes
CALL            10 23 12   ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   23 12 10  ;PUSH Bytes
CALL            10 12 23   ;CALL function
                           #--- PUSHB_4   64 23 20 9 ;PUSH Bytes
CALL            9 20 23 64 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   23 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'g': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 2 0     ;PUSH Bytes
CALL            0 2 1      ;CALL function
                           #--- PUSHB_2   7 7       ;PUSH Bytes
MIRP[min,black] stem 7     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   33 9      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   0 20      ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 38 10   ;PUSH Bytes
CALL            10 38 7    ;CALL function
                           #--- PUSHB_4   0 7 4 9   ;PUSH Bytes
CALL            9 4 7 0    ;CALL function
                           #--- PUSHB_3   38 7 10   ;PUSH Bytes
CALL            10 7 38    ;CALL function
                           #--- PUSHB_4   64 38 14 9 ;PUSH Bytes
CALL            9 14 38 64 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   38 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   23 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 36      ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_5   0 21 26 33 38 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              38 33 26 21 0 ;Interpolate Point
                           #--- PUSHB_2   1 30      ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'germandbls': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   54 7      ;PUSH Bytes
MIRP[min,black] stem 54    ;Move Indirect Relative Point
                           #--- PUSHB_3   54 44 10  ;PUSH Bytes
CALL            10 44 54   ;CALL function
                           #--- PUSHB_4   0 54 49 9 ;PUSH Bytes
CALL            9 49 54 0  ;CALL function
                           #--- PUSHB_3   34 5 0    ;PUSH Bytes
CALL            0 5 34     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_5   8 4 44 34 13 ;PUSH Bytes
CALL            13 34 44 4 8 ;CALL function
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 30 10  ;PUSH Bytes
CALL            10 30 19   ;CALL function
                           #--- PUSHB_4   64 19 22 9 ;PUSH Bytes
CALL            9 22 19 64 ;CALL function
                           #--- PUSHB_3   30 19 10  ;PUSH Bytes
CALL            10 19 30   ;CALL function
                           #--- PUSHB_4   64 30 27 9 ;PUSH Bytes
CALL            9 27 30 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   51 9      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   37 9      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 37 10  ;PUSH Bytes
CALL            10 37 12   ;CALL function
                           #--- PUSHB_4   64 12 6 9 ;PUSH Bytes
CALL            9 6 12 64  ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   41 9      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   51 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_6   4 8 9 15 34 3 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              3 34 15 9 8 4 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_3   39 44 54  ;PUSH Bytes
IP              54         ;Interpolate Point
IP              44         ;Interpolate Point
IP              39         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   54 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_2   22 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_2   4 29      ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   0 41      ;PUSH Bytes
IP              41         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'grave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 8 0 14 4 ;PUSH Bytes
CALL            4 14 0 8 15 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   4 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 4 ;CALL function
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'greater': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   6 10 0 25 4 ;PUSH Bytes
CALL            4 25 0 10 6 ;CALL function
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guillemotleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guillemotright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_3   13 2 0    ;PUSH Bytes
CALL            0 2 13     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'h': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 18 27   ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   44 5 0    ;PUSH Bytes
CALL            0 5 44     ;CALL function
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   27 38 10  ;PUSH Bytes
CALL            10 38 27   ;CALL function
                           #--- PUSHB_4   64 27 30 9 ;PUSH Bytes
CALL            9 30 27 64 ;CALL function
                           #--- PUSHB_3   38 27 10  ;PUSH Bytes
CALL            10 27 38   ;CALL function
                           #--- PUSHB_4   0 38 42 9 ;PUSH Bytes
CALL            9 42 38 0  ;CALL function
                           #--- PUSHB_4   64 38 35 9 ;PUSH Bytes
CALL            9 35 38 64 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 19 10   ;PUSH Bytes
CALL            10 19 8    ;CALL function
                           #--- PUSHB_4   64 8 11 9 ;PUSH Bytes
CALL            9 11 8 64  ;CALL function
                           #--- PUSHB_3   19 8 10   ;PUSH Bytes
CALL            10 8 19    ;CALL function
                           #--- PUSHB_4   64 19 16 9 ;PUSH Bytes
CALL            9 16 19 64 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   19 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hyphen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'i': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   22 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 22 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   21 10     ;PUSH Bytes
MIRP[min,black] stemw_thick 21 ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_3   21 1 10   ;PUSH Bytes
CALL            10 1 21    ;CALL function
                           #--- PUSHB_4   64 21 16 9 ;PUSH Bytes
CALL            9 16 21 64 ;CALL function
                           #--- PUSHB_4   64 21 9 9 ;PUSH Bytes
CALL            9 9 21 64  ;CALL function
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   0 12 16 9 ;PUSH Bytes
CALL            9 16 12 0  ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'icircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   0 12 16 9 ;PUSH Bytes
CALL            9 16 12 0  ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   1 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   19 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'idieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   19 6 0    ;PUSH Bytes
CALL            0 6 19     ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_5   25 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 25 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_5   22 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   0 12 16 9 ;PUSH Bytes
CALL            9 16 12 0  ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   32 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 32 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'igrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   0 12 16 9 ;PUSH Bytes
CALL            9 16 12 0  ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'j': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   21 10     ;PUSH Bytes
MIRP[min,black] stemw_thick 21 ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 7 10   ;PUSH Bytes
CALL            10 7 19    ;CALL function
                           #--- PUSHB_4   0 19 13 9 ;PUSH Bytes
CALL            9 13 19 0  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'k': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] stem 6     ;Move Indirect Relative Point
                           #--- PUSHB_2   29 39     ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   13 5 0    ;PUSH Bytes
CALL            0 5 13     ;CALL function
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   11 10 0 17 4 ;PUSH Bytes
CALL            4 17 0 10 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_3   0 15 41   ;PUSH Bytes
IP              41         ;Interpolate Point
IP              15         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'l': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   18 5 0    ;PUSH Bytes
CALL            0 5 18     ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   0 12 16 9 ;PUSH Bytes
CALL            9 16 12 0  ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'less': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   15 10 0 25 4 ;PUSH Bytes
CALL            4 25 0 10 15 ;CALL function
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'logicalnot': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   1 5 10    ;PUSH Bytes
CALL            10 5 1     ;CALL function
                           #--- PUSHB_4   0 1 9 9   ;PUSH Bytes
CALL            9 9 1 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 7 10   ;PUSH Bytes
CALL            10 7 11    ;CALL function
                           #--- PUSHB_4   0 11 3 9  ;PUSH Bytes
CALL            9 3 11 0   ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'm': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   17 30     ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_2   48 7      ;PUSH Bytes
MIRP[min,black] stem 48    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 25 38  ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   55 2 0    ;PUSH Bytes
CALL            0 2 55     ;CALL function
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[min,black] stem 51    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
                           #--- PUSHB_2   38 9      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   38 49 10  ;PUSH Bytes
CALL            10 49 38   ;CALL function
                           #--- PUSHB_4   64 38 41 9 ;PUSH Bytes
CALL            9 41 38 64 ;CALL function
                           #--- PUSHB_3   49 38 10  ;PUSH Bytes
CALL            10 38 49   ;CALL function
                           #--- PUSHB_4   64 49 46 9 ;PUSH Bytes
CALL            9 46 49 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_5   53 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 53 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   25 9      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_5   28 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 28 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_5   15 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 15 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   31 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   18 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   8 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_4   1 6 24 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 24 6 1  ;Interpolate Point
                           #--- PUSHB_2   55 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'macron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 4 0     ;PUSH Bytes
CALL            0 4 4      ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_3   4 4 0     ;PUSH Bytes
CALL            0 4 4      ;CALL function
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   7 10 0 7 4 ;PUSH Bytes
CALL            4 7 0 10 7 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'mu': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] stem 24    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 15 10  ;PUSH Bytes
CALL            10 15 32   ;CALL function
                           #--- PUSHB_4   64 32 3 9 ;PUSH Bytes
CALL            9 3 32 64  ;CALL function
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   7 7       ;PUSH Bytes
MIRP[min,black] stem 7     ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   5 1 10    ;PUSH Bytes
CALL            10 1 5     ;CALL function
                           #--- PUSHB_4   0 5 9 9   ;PUSH Bytes
CALL            9 9 5 0    ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 24 10  ;PUSH Bytes
CALL            10 24 30   ;CALL function
                           #--- PUSHB_4   0 30 21 9 ;PUSH Bytes
CALL            9 21 30 0  ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_5   27 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 27 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_2   7 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   17 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'multiply': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 1 0    ;PUSH Bytes
CALL            0 1 30     ;CALL function
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] stem 43    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 5 0    ;PUSH Bytes
CALL            0 5 19     ;CALL function
                           #--- PUSHB_3   14 4 0    ;PUSH Bytes
CALL            0 4 14     ;CALL function
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   38 9      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   38 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_8   0 14 16 9 30 25 33 41 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              41 33 25 30 9 16 14 0 ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_8   9 11 16 25 27 0 32 40 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              40 32 0 27 25 16 11 9 ;Interpolate Point
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'n': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 30 40   ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   26 2 0    ;PUSH Bytes
CALL            0 2 26     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   4 15 10   ;PUSH Bytes
CALL            10 15 4    ;CALL function
                           #--- PUSHB_4   64 4 7 9  ;PUSH Bytes
CALL            9 7 4 64   ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_5   19 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_3   19 4 10   ;PUSH Bytes
CALL            10 4 19    ;CALL function
                           #--- PUSHB_4   64 19 12 9 ;PUSH Bytes
CALL            9 12 19 64 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   30 9      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 41 10  ;PUSH Bytes
CALL            10 41 30   ;CALL function
                           #--- PUSHB_4   64 30 33 9 ;PUSH Bytes
CALL            9 33 30 64 ;CALL function
                           #--- PUSHB_3   41 30 10  ;PUSH Bytes
CALL            10 30 41   ;CALL function
                           #--- PUSHB_4   64 41 38 9 ;PUSH Bytes
CALL            9 38 41 64 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   3 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'nine': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 22 10   ;PUSH Bytes
CALL            10 22 0    ;CALL function
                           #--- PUSHB_4   0 0 28 9  ;PUSH Bytes
CALL            9 28 0 0   ;CALL function
                           #--- PUSHB_3   15 6 0    ;PUSH Bytes
CALL            0 6 15     ;CALL function
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
                           #--- PUSHB_5   9 40 22 15 13 ;PUSH Bytes
CALL            13 15 22 40 9 ;CALL function
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   37 9      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   18 9      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   37 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_5   0 9 15 22 31 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              31 22 15 9 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_4   5 12 18 7 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              7 18 12 5  ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'nonbreakingspace': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_5   17 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 17 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   26 10 0 17 4 ;PUSH Bytes
CALL            4 17 0 10 26 ;CALL function
                           #--- PUSHB_5   26 10 0 17 4 ;PUSH Bytes
CALL            4 17 0 10 26 ;CALL function
                           #--- PUSHB_4   8 26 20 8 ;PUSH Bytes
CALL            8 20 26 8  ;CALL function
                           #--- PUSHB_5   14 10 0 26 4 ;PUSH Bytes
CALL            4 26 0 10 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 10 0 26 4 ;PUSH Bytes
CALL            4 26 0 10 8 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ntilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 30 40   ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   66 5 0    ;PUSH Bytes
CALL            0 5 66     ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp1]        48         ;SHift Point using reference point
                           #--- PUSHB_2   57 7      ;PUSH Bytes
MIRP[min,black] stem 57    ;Move Indirect Relative Point
                           #--- PUSHB_3   26 2 0    ;PUSH Bytes
CALL            0 2 26     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_5   45 54 17 66 13 ;PUSH Bytes
CALL            13 66 17 54 45 ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SHP[rp1]        60         ;SHift Point using reference point
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   4 15 10   ;PUSH Bytes
CALL            10 15 4    ;CALL function
                           #--- PUSHB_4   64 4 7 9  ;PUSH Bytes
CALL            9 7 4 64   ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_5   19 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_3   19 4 10   ;PUSH Bytes
CALL            10 4 19    ;CALL function
                           #--- PUSHB_4   64 19 12 9 ;PUSH Bytes
CALL            9 12 19 64 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   30 9      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 41 10  ;PUSH Bytes
CALL            10 41 30   ;CALL function
                           #--- PUSHB_4   64 30 33 9 ;PUSH Bytes
CALL            9 33 30 64 ;CALL function
                           #--- PUSHB_3   41 30 10  ;PUSH Bytes
CALL            10 30 41   ;CALL function
                           #--- PUSHB_4   64 41 38 9 ;PUSH Bytes
CALL            9 38 41 64 ;CALL function
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_2   4 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   60 63     ;PUSH Bytes
IP              63         ;Interpolate Point
IP              60         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_5   26 48 54 57 66 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              66 57 54 48 26 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   3 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_2   45 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
                           #--- PUSHB_2   66 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'numbersign': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_4   7 14 15 22 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp1]        22 15 14 7 ;SHift Point using reference point
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_4   1 28 57 58 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        58 57 28 1 ;SHift Point using reference point
                           #--- PUSHB_3   23 27 10  ;PUSH Bytes
CALL            10 27 23   ;CALL function
                           #--- PUSHB_4   64 23 10 9 ;PUSH Bytes
CALL            9 10 23 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_4   0 29 55 56 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp1]        56 55 29 0 ;SHift Point using reference point
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
                           #--- PUSHB_4   35 42 43 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        49 43 42 35 ;SHift Point using reference point
                           #--- PUSHB_3   34 30 10  ;PUSH Bytes
CALL            10 30 34   ;CALL function
                           #--- PUSHB_4   64 34 38 9 ;PUSH Bytes
CALL            9 38 34 64 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   21 36     ;PUSH Bytes
SDPVTL[orthog]  36 21      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[no-rnd]    21         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[grey]      36         ;Move Direct Relative Point
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[rp0,min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[grey]      41         ;Move Direct Relative Point
                           #--- PUSHB_2   13 44     ;PUSH Bytes
SDPVTL[orthog]  44 13      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[no-rnd]    13         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[grey]      44         ;Move Direct Relative Point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[rp0,min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDRP[grey]      48         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_4   0 8 48 19 ;PUSH Bytes
CALL            19 48 8 0  ;CALL function
                           #--- PUSHB_4   1 8 48 19 ;PUSH Bytes
CALL            19 48 8 1  ;CALL function
                           #--- PUSHB_4   7 8 48 19 ;PUSH Bytes
CALL            19 48 8 7  ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_4   14 13 44 19 ;PUSH Bytes
CALL            19 44 13 14 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_4   15 16 41 19 ;PUSH Bytes
CALL            19 41 16 15 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_4   22 21 36 19 ;PUSH Bytes
CALL            19 36 21 22 ;CALL function
                           #--- PUSHB_4   28 21 36 19 ;PUSH Bytes
CALL            19 36 21 28 ;CALL function
                           #--- PUSHB_4   29 21 36 19 ;PUSH Bytes
CALL            19 36 21 29 ;CALL function
                           #--- PUSHB_4   35 21 36 19 ;PUSH Bytes
CALL            19 36 21 35 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_4   42 16 41 19 ;PUSH Bytes
CALL            19 41 16 42 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_4   43 13 44 19 ;PUSH Bytes
CALL            19 44 13 43 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_4   49 8 48 19 ;PUSH Bytes
CALL            19 48 8 49 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_4   55 13 44 19 ;PUSH Bytes
CALL            19 44 13 55 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_4   56 16 41 19 ;PUSH Bytes
CALL            19 41 16 56 ;CALL function
                           #--- PUSHB_4   57 16 41 19 ;PUSH Bytes
CALL            19 41 16 57 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_4   58 13 44 19 ;PUSH Bytes
CALL            19 44 13 58 ;CALL function
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_8   8 13 16 21 36 41 44 48 ;PUSH Bytes
MDAP[no-rnd]    48         ;Move Direct Absolute Point
MDAP[no-rnd]    44         ;Move Direct Absolute Point
MDAP[no-rnd]    41         ;Move Direct Absolute Point
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDAP[no-rnd]    21         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    24 0 1 7 8 13 14 15 16 21 22 28 29 35 36 41 42 43 44 48 49 55 56 57 58 ;PUSH N Bytes
MDAP[no-rnd]    58         ;Move Direct Absolute Point
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    56         ;Move Direct Absolute Point
MDAP[no-rnd]    55         ;Move Direct Absolute Point
MDAP[no-rnd]    49         ;Move Direct Absolute Point
MDAP[no-rnd]    48         ;Move Direct Absolute Point
MDAP[no-rnd]    44         ;Move Direct Absolute Point
MDAP[no-rnd]    43         ;Move Direct Absolute Point
MDAP[no-rnd]    42         ;Move Direct Absolute Point
MDAP[no-rnd]    41         ;Move Direct Absolute Point
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    29         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    22         ;Move Direct Absolute Point
MDAP[no-rnd]    21         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'o': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'oacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 29 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 29 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ocircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 26 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 26 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'odieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   23 6 0    ;PUSH Bytes
CALL            0 6 23     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_5   29 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 29 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_5   26 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   36 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   41 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_4   6 12 17 0 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              0 17 12 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ograve': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 26 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 26 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'one': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   0 6 0     ;PUSH Bytes
CALL            0 6 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   0 12 19 9 ;PUSH Bytes
CALL            9 19 12 0  ;CALL function
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SDPVTL[orthog]  0 21       ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[grey]      21         ;Move Direct Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   13 11     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 13 ;Move Indirect Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[grey]      14         ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 14 21  ;PUSH Bytes
MDAP[no-rnd]    21         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 21     ;PUSH Bytes
MDAP[no-rnd]    21         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'onehalf': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   52 1 0    ;PUSH Bytes
CALL            0 1 52     ;CALL function
                           #--- PUSHB_5   45 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 45 ;CALL function
                           #--- PUSHB_3   52 1 0    ;PUSH Bytes
CALL            0 1 52     ;CALL function
                           #--- PUSHB_5   49 8 0 34 4 ;PUSH Bytes
CALL            4 34 0 8 49 ;CALL function
                           #--- PUSHB_3   15 6 0    ;PUSH Bytes
CALL            0 6 15     ;CALL function
                           #--- PUSHB_5   21 24 52 15 13 ;PUSH Bytes
CALL            13 15 52 24 21 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   21 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 21 ;CALL function
                           #--- PUSHB_5   39 60 52 15 13 ;PUSH Bytes
CALL            13 15 52 60 39 ;CALL function
                           #--- PUSHB_5   39 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 39 ;CALL function
                           #--- PUSHB_3   60 39 10  ;PUSH Bytes
CALL            10 39 60   ;CALL function
                           #--- PUSHB_4   64 60 65 9 ;PUSH Bytes
CALL            9 65 60 64 ;CALL function
                           #--- PUSHB_4   30 52 15 8 ;PUSH Bytes
CALL            8 15 52 30 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_5   16 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 16 ;CALL function
                           #--- PUSHB_3   16 26 10  ;PUSH Bytes
CALL            10 26 16   ;CALL function
                           #--- PUSHB_4   64 16 19 9 ;PUSH Bytes
CALL            9 19 16 64 ;CALL function
                           #--- PUSHB_3   26 16 10  ;PUSH Bytes
CALL            10 16 26   ;CALL function
                           #--- PUSHB_4   0 26 33 9 ;PUSH Bytes
CALL            9 33 26 0  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   63 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 63 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_3   36 63 10  ;PUSH Bytes
CALL            10 63 36   ;CALL function
                           #--- PUSHB_4   64 36 52 9 ;PUSH Bytes
CALL            9 52 36 64 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_5   50 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 50 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_2   46 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_3   10 39 13  ;PUSH Bytes
IP              13         ;Interpolate Point
IP              39         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   49 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_3   2 3 53    ;PUSH Bytes
IP              53         ;Interpolate Point
IP              3          ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_3   5 42 57   ;PUSH Bytes
IP              57         ;Interpolate Point
IP              42         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   36 63     ;PUSH Bytes
IP              63         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_2   30 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   13 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'onequarter': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   59 1 0    ;PUSH Bytes
CALL            0 1 59     ;CALL function
                           #--- PUSHB_5   42 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 42 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_3   0 6 0     ;PUSH Bytes
CALL            0 6 0      ;CALL function
                           #--- PUSHB_5   44 64 59 0 13 ;PUSH Bytes
CALL            13 0 59 64 44 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp1]        48         ;SHift Point using reference point
                           #--- PUSHB_5   44 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 44 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_3   64 44 10  ;PUSH Bytes
CALL            10 44 64   ;CALL function
                           #--- PUSHB_4   64 64 47 9 ;PUSH Bytes
CALL            9 47 64 64 ;CALL function
                           #--- PUSHB_5   6 9 59 0 13 ;PUSH Bytes
CALL            13 0 59 9 6 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   6 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 6 ;CALL function
                           #--- PUSHB_4   15 59 0 8 ;PUSH Bytes
CALL            8 0 59 15  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   1 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 1 ;CALL function
                           #--- PUSHB_3   1 11 10   ;PUSH Bytes
CALL            10 11 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   11 1 10   ;PUSH Bytes
CALL            10 1 11    ;CALL function
                           #--- PUSHB_4   0 11 18 9 ;PUSH Bytes
CALL            9 18 11 0  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
                           #--- PUSHB_5   54 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 54 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_3   54 42 10  ;PUSH Bytes
CALL            10 42 54   ;CALL function
                           #--- PUSHB_4   64 54 57 9 ;PUSH Bytes
CALL            9 57 54 64 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_3   42 54 10  ;PUSH Bytes
CALL            10 54 42   ;CALL function
                           #--- PUSHB_4   64 42 36 9 ;PUSH Bytes
CALL            9 36 42 64 ;CALL function
                           #--- PUSHB_4   64 42 44 9 ;PUSH Bytes
CALL            9 44 42 64 ;CALL function
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   1 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_4   31 34 46 64 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              64 46 34 31 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   44 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   23 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_4   31 34 62 63 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              63 62 34 31 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'onesuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 6 0     ;PUSH Bytes
CALL            0 6 0      ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   9 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 9 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   1 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 1 ;CALL function
                           #--- PUSHB_3   1 11 10   ;PUSH Bytes
CALL            10 11 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   11 1 10   ;PUSH Bytes
CALL            10 1 11    ;CALL function
                           #--- PUSHB_4   0 11 18 9 ;PUSH Bytes
CALL            9 18 11 0  ;CALL function
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ordfeminine': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 4 0    ;PUSH Bytes
CALL            0 4 10     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 10 10   ;PUSH Bytes
CALL            10 10 0    ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
                           #--- PUSHB_3   29 3 0    ;PUSH Bytes
CALL            0 3 29     ;CALL function
                           #--- PUSHB_5   38 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 38 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   41 9      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   20 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 35 10  ;PUSH Bytes
CALL            10 35 14   ;CALL function
                           #--- PUSHB_4   64 14 17 9 ;PUSH Bytes
CALL            9 17 14 64 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   41 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_4   3 10 23 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 23 10 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_3   26 35 41  ;PUSH Bytes
IP              41         ;Interpolate Point
IP              35         ;Interpolate Point
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ordmasculine': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 4 0     ;PUSH Bytes
CALL            0 4 0      ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   18 7      ;PUSH Bytes
MIRP[min,black] stem 18    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'oslash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   34 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_8   0 12 14 7 26 21 29 37 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              37 29 21 26 7 14 12 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_8   7 9 14 21 23 0 28 36 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              36 28 0 23 21 14 9 7 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'otilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 5 0    ;PUSH Bytes
CALL            0 5 44     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 32 12 44 13 ;PUSH Bytes
CALL            13 44 12 32 23 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 29 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 29 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   23 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
                           #--- PUSHB_2   44 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'p': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   2 30      ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   12 23 10  ;PUSH Bytes
CALL            10 23 12   ;CALL function
                           #--- PUSHB_4   64 12 15 9 ;PUSH Bytes
CALL            9 15 12 64 ;CALL function
                           #--- PUSHB_3   23 12 10  ;PUSH Bytes
CALL            10 12 23   ;CALL function
                           #--- PUSHB_4   64 23 20 9 ;PUSH Bytes
CALL            9 20 23 64 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   8 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   33 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_5   3 8 11 31 36 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              36 31 11 8 3 ;Interpolate Point
                           #--- PUSHB_2   29 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'paragraph': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 5 0     ;PUSH Bytes
CALL            0 5 7      ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   38 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 38 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   43 10 0 29 4 ;PUSH Bytes
CALL            4 29 0 10 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 37 10  ;PUSH Bytes
CALL            10 37 27   ;CALL function
                           #--- PUSHB_4   64 27 29 9 ;PUSH Bytes
CALL            9 29 27 64 ;CALL function
                           #--- PUSHB_3   37 27 10  ;PUSH Bytes
CALL            10 27 37   ;CALL function
                           #--- PUSHB_4   64 37 34 9 ;PUSH Bytes
CALL            9 34 37 64 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 24 10  ;PUSH Bytes
CALL            10 24 14   ;CALL function
                           #--- PUSHB_4   64 14 10 9 ;PUSH Bytes
CALL            9 10 14 64 ;CALL function
                           #--- PUSHB_3   24 14 10  ;PUSH Bytes
CALL            10 14 24   ;CALL function
                           #--- PUSHB_4   64 24 22 9 ;PUSH Bytes
CALL            9 22 24 64 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   24 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_2   38 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'parenleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 5 0    ;PUSH Bytes
CALL            0 5 16     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 0 ;Move Indirect Relative Point
                           #--- PUSHB_3   0 12 10   ;PUSH Bytes
CALL            10 12 0    ;CALL function
                           #--- PUSHB_4   0 0 5 9   ;PUSH Bytes
CALL            9 5 0 0    ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'parenright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 5 0     ;PUSH Bytes
CALL            0 5 8      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   12 10     ;PUSH Bytes
MIRP[min,black] stemw_thick 12 ;Move Indirect Relative Point
                           #--- PUSHB_3   0 12 10   ;PUSH Bytes
CALL            10 12 0    ;CALL function
                           #--- PUSHB_4   0 0 5 9   ;PUSH Bytes
CALL            9 5 0 0    ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'percent': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   23 6 0    ;PUSH Bytes
CALL            0 6 23     ;CALL function
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
                           #--- PUSHB_5   11 0 6 23 13 ;PUSH Bytes
CALL            13 23 6 0 11 ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_5   39 29 6 23 13 ;PUSH Bytes
CALL            13 23 6 29 39 ;CALL function
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   37 9      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   53 54     ;PUSH Bytes
SDPVTL[orthog]  54 53      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[no-rnd]    53         ;Move Direct Absolute Point
                           #--- PUSHB_1   54        ;PUSH Bytes
MDRP[grey]      54         ;Move Direct Relative Point
                           #--- PUSHB_2   46 12     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin_2 46 ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[grey]      45         ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   45 46 53 54 ;PUSH Bytes
MDAP[no-rnd]    54         ;Move Direct Absolute Point
MDAP[no-rnd]    53         ;Move Direct Absolute Point
MDAP[no-rnd]    46         ;Move Direct Absolute Point
MDAP[no-rnd]    45         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   45 46 53 54 ;PUSH Bytes
MDAP[no-rnd]    54         ;Move Direct Absolute Point
MDAP[no-rnd]    53         ;Move Direct Absolute Point
MDAP[no-rnd]    46         ;Move Direct Absolute Point
MDAP[no-rnd]    45         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   9 37      ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   23 29 34 39 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              39 34 29 23 ;Interpolate Point
                           #--- PUSHB_2   20 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   0 11 17 6 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              6 17 11 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   51 59     ;PUSH Bytes
IP              59         ;Interpolate Point
IP              51         ;Interpolate Point
                           #--- PUSHB_2   34 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   32 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'period': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_5   0 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 0 ;CALL function
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_5   0 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   4 10 0 14 4 ;PUSH Bytes
CALL            4 14 0 10 4 ;CALL function
                           #--- PUSHB_5   4 10 0 14 4 ;PUSH Bytes
CALL            4 14 0 10 4 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'periodcentered': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 0 ;CALL function
                           #--- PUSHB_5   0 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   4 10 0 14 4 ;PUSH Bytes
CALL            4 14 0 10 4 ;CALL function
                           #--- PUSHB_5   4 10 0 14 4 ;PUSH Bytes
CALL            4 14 0 10 4 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'plus': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   7 11 10   ;PUSH Bytes
CALL            10 11 7    ;CALL function
                           #--- PUSHB_4   64 7 3 9  ;PUSH Bytes
CALL            9 3 7 64   ;CALL function
                           #--- PUSHB_3   11 7 10   ;PUSH Bytes
CALL            10 7 11    ;CALL function
                           #--- PUSHB_4   64 11 15 9 ;PUSH Bytes
CALL            9 15 11 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   1 5 10    ;PUSH Bytes
CALL            10 5 1     ;CALL function
                           #--- PUSHB_4   64 1 21 9 ;PUSH Bytes
CALL            9 21 1 64  ;CALL function
                           #--- PUSHB_3   5 1 10    ;PUSH Bytes
CALL            10 1 5     ;CALL function
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'plusminus': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[min,black] stem 10    ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   7 10 10   ;PUSH Bytes
CALL            10 10 7    ;CALL function
                           #--- PUSHB_4   64 7 3 9  ;PUSH Bytes
CALL            9 3 7 64   ;CALL function
                           #--- PUSHB_3   10 7 10   ;PUSH Bytes
CALL            10 7 10    ;CALL function
                           #--- PUSHB_4   64 10 14 9 ;PUSH Bytes
CALL            9 14 10 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_3   1 5 10    ;PUSH Bytes
CALL            10 5 1     ;CALL function
                           #--- PUSHB_4   64 1 25 9 ;PUSH Bytes
CALL            9 25 1 64  ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   5 1 10    ;PUSH Bytes
CALL            10 1 5     ;CALL function
                           #--- PUSHB_4   64 5 29 9 ;PUSH Bytes
CALL            9 29 5 64  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'q': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] stem 6     ;Move Indirect Relative Point
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   12 21     ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 9 10   ;PUSH Bytes
CALL            10 9 28    ;CALL function
                           #--- PUSHB_4   0 28 25 9 ;PUSH Bytes
CALL            9 25 28 0  ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   9 28 10   ;PUSH Bytes
CALL            10 28 9    ;CALL function
                           #--- PUSHB_4   64 9 37 9 ;PUSH Bytes
CALL            9 37 9 64  ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   9 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   14 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_5   3 9 12 17 21 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              21 17 12 9 3 ;Interpolate Point
                           #--- PUSHB_2   22 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'question': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   37 1 0    ;PUSH Bytes
CALL            0 1 37     ;CALL function
                           #--- PUSHB_5   30 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 30 ;CALL function
                           #--- PUSHB_3   4 4 0     ;PUSH Bytes
CALL            0 4 4      ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_5   13 16 37 4 13 ;PUSH Bytes
CALL            13 4 37 16 13 ;CALL function
                           #--- PUSHB_5   13 8 0 21 4 ;PUSH Bytes
CALL            4 21 0 8 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   25 9      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_4   15 11 34 14 ;PUSH Bytes
CALL            14 34 11 15 ;CALL function
                           #--- PUSHB_5   40 10 0 15 4 ;PUSH Bytes
CALL            4 15 0 10 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_5   34 10 0 15 4 ;PUSH Bytes
CALL            4 15 0 10 34 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   40 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_2   11 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   4 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_3   0 7 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              7          ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'questiondown': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 2 0    ;PUSH Bytes
CALL            0 2 34     ;CALL function
                           #--- PUSHB_5   29 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 29 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 2 10   ;PUSH Bytes
CALL            10 2 20    ;CALL function
                           #--- PUSHB_4   0 20 25 9 ;PUSH Bytes
CALL            9 25 20 0  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   11 8 0 21 4 ;PUSH Bytes
CALL            4 21 0 8 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   17 9      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_4   15 8 32 14 ;PUSH Bytes
CALL            14 32 8 15 ;CALL function
                           #--- PUSHB_5   38 10 0 15 4 ;PUSH Bytes
CALL            4 15 0 10 38 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   14 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   2 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedbl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 5 0     ;PUSH Bytes
CALL            0 5 0      ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_5   4 8 0 7 4 ;PUSH Bytes
CALL            4 7 0 8 4  ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   2 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 2 ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   8 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 8 ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   11 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedblleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 5 0    ;PUSH Bytes
CALL            0 5 19     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   16 8 0 8 4 ;PUSH Bytes
CALL            4 8 0 8 16 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedblright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 5 0     ;PUSH Bytes
CALL            0 5 0      ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_5   4 8 0 8 4 ;PUSH Bytes
CALL            4 8 0 8 4  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quoteleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 5 0     ;PUSH Bytes
CALL            0 5 9      ;CALL function
                           #--- PUSHB_5   6 8 0 8 4 ;PUSH Bytes
CALL            4 8 0 8 6  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   1 10 0 10 4 ;PUSH Bytes
CALL            4 10 0 10 1 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quoteright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 5 0     ;PUSH Bytes
CALL            0 5 0      ;CALL function
                           #--- PUSHB_5   4 8 0 7 4 ;PUSH Bytes
CALL            4 7 0 8 4  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   1 10 0 10 4 ;PUSH Bytes
CALL            4 10 0 10 1 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotesingle': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 5 0     ;PUSH Bytes
CALL            0 5 0      ;CALL function
                           #--- PUSHB_5   4 8 0 7 4 ;PUSH Bytes
CALL            4 7 0 8 4  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   2 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 2 ;Move Indirect Relative Point
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'r': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   3 7       ;PUSH Bytes
MIRP[min,black] stem 3     ;Move Indirect Relative Point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   7 18 10   ;PUSH Bytes
CALL            10 18 7    ;CALL function
                           #--- PUSHB_4   64 7 10 9 ;PUSH Bytes
CALL            9 10 7 64  ;CALL function
                           #--- PUSHB_3   18 7 10   ;PUSH Bytes
CALL            10 7 18    ;CALL function
                           #--- PUSHB_4   64 18 15 9 ;PUSH Bytes
CALL            9 15 18 64 ;CALL function
                           #--- PUSHB_4   0 18 22 9 ;PUSH Bytes
CALL            9 22 18 0  ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 26 33 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              33 26 0 6  ;Interpolate Point
                           #--- PUSHB_2   24 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    's': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] stem 43    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_3   55 2 0    ;PUSH Bytes
CALL            0 2 55     ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_2   30 9      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_4   53 30 34 8 ;PUSH Bytes
CALL            8 34 30 53 ;CALL function
                           #--- PUSHB_2   16 9      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
                           #--- DUP       #10       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   6 9       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   53 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_2   32 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_2   10 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_5   20 27 43 50 55 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              55 50 43 27 20 ;Interpolate Point
                           #--- PUSHB_2   6 46      ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_6   0 8 24 29 37 53 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              53 37 29 24 8 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'section': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 5 0    ;PUSH Bytes
CALL            0 5 32     ;CALL function
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_3   40 32 10  ;PUSH Bytes
CALL            10 32 40   ;CALL function
                           #--- PUSHB_4   0 40 36 9 ;PUSH Bytes
CALL            9 36 40 0  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   14 8 10   ;PUSH Bytes
CALL            10 8 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_4   65 14 8 8 ;PUSH Bytes
CALL            8 8 14 65  ;CALL function
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   65 9      ;PUSH Bytes
MIRP[min,black] stemw 65   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   43 9      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_4   54 34 38 8 ;PUSH Bytes
CALL            8 38 34 54 ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   14 65     ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_2   43 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   27 62     ;PUSH Bytes
IP              62         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_6   22 47 50 57 60 67 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              67 60 57 50 47 22 ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_2   54 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_2   36 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   4 29 50 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 50 29 4 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'semicolon': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_5   17 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 17 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   14 10 0 14 4 ;PUSH Bytes
CALL            4 14 0 10 14 ;CALL function
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   14 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   0 1       ;PUSH Bytes
IP              1          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'seven': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_3   8 5 0     ;PUSH Bytes
CALL            0 5 8      ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_3   8 5 0     ;PUSH Bytes
CALL            0 5 8      ;CALL function
                           #--- PUSHB_5   5 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   10 9      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   13 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   0 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'six': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
                           #--- PUSHB_3   22 6 0    ;PUSH Bytes
CALL            0 6 22     ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
MIRP[min,black] stem 0     ;Move Indirect Relative Point
                           #--- PUSHB_3   0 22 10   ;PUSH Bytes
CALL            10 22 0    ;CALL function
                           #--- PUSHB_4   0 0 28 9  ;PUSH Bytes
CALL            9 28 0 0   ;CALL function
                           #--- PUSHB_5   9 40 15 22 13 ;PUSH Bytes
CALL            13 22 15 40 9 ;CALL function
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   37 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_5   0 9 15 22 31 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              31 22 15 9 0 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   5 12 18 7 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              7 18 12 5  ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'slash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'softhyphen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 1 0    ;PUSH Bytes
CALL            0 1 48     ;CALL function
                           #--- PUSHB_2   59 7      ;PUSH Bytes
MIRP[min,black] stem 59    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_5   9 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 9 ;CALL function
                           #--- PUSHB_2   1 25      ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   33 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 33 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_5   15 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 15 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDRP[rp0,rnd,white] 51         ;Move Direct Relative Point
                           #--- PUSHB_2   56 9      ;PUSH Bytes
MIRP[min,black] stemw 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   1 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 1 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   1 10 10   ;PUSH Bytes
CALL            10 10 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   10 1 10   ;PUSH Bytes
CALL            10 1 10    ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   19 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 19 ;CALL function
                           #--- PUSHB_4   30 19 37 8 ;PUSH Bytes
CALL            8 37 19 30 ;CALL function
                           #--- PUSHB_2   28 10     ;PUSH Bytes
MIRP[min,black] stemw_thick 28 ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_6   22 32 42 48 53 59 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              59 53 48 42 32 22 ;Interpolate Point
                           #--- PUSHB_2   28 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_4   22 45 56 62 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              62 56 45 22 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_2   19 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'space': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_5   14 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 14 ;CALL function
                           #--- PUSHB_3   11 6 0    ;PUSH Bytes
CALL            0 6 11     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_5   18 10 0 17 4 ;PUSH Bytes
CALL            4 17 0 10 18 ;CALL function
                           #--- PUSHB_5   18 10 0 17 4 ;PUSH Bytes
CALL            4 17 0 10 18 ;CALL function
                           #--- PUSHB_4   7 18 24 8 ;PUSH Bytes
CALL            8 24 18 7  ;CALL function
                           #--- PUSHB_5   1 10 0 26 4 ;PUSH Bytes
CALL            4 26 0 10 1 ;CALL function
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sterling': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   38 7      ;PUSH Bytes
MIRP[min,black] stem 38    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   44 7      ;PUSH Bytes
MIRP[min,black] stem 44    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   41 0 10   ;PUSH Bytes
CALL            10 0 41    ;CALL function
                           #--- PUSHB_4   64 41 36 9 ;PUSH Bytes
CALL            9 36 41 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   31 11     ;PUSH Bytes
CALL            11 31      ;CALL function
                           #--- PUSHB_2   10 9      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 31 10  ;PUSH Bytes
CALL            10 31 10   ;CALL function
                           #--- PUSHB_4   64 10 5 9 ;PUSH Bytes
CALL            9 5 10 64  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   0 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   12 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_3   44 47 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              47         ;Interpolate Point
IP              44         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   18 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_2   53 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_3   41 47 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              47         ;Interpolate Point
IP              41         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    't': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[min,black] stem 10    ;Move Indirect Relative Point
                           #--- PUSHB_3   34 4 0    ;PUSH Bytes
CALL            0 4 34     ;CALL function
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   7 24 10   ;PUSH Bytes
CALL            10 24 7    ;CALL function
                           #--- PUSHB_4   64 7 3 9  ;PUSH Bytes
CALL            9 3 7 64   ;CALL function
                           #--- PUSHB_3   24 7 10   ;PUSH Bytes
CALL            10 7 24    ;CALL function
                           #--- PUSHB_4   64 24 28 9 ;PUSH Bytes
CALL            9 28 24 64 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   15 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'thorn': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   9 36 18 4 13 ;PUSH Bytes
CALL            13 4 18 36 9 ;CALL function
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 33      ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   12 23 10  ;PUSH Bytes
CALL            10 23 12   ;CALL function
                           #--- PUSHB_4   64 12 15 9 ;PUSH Bytes
CALL            9 15 12 64 ;CALL function
                           #--- PUSHB_3   23 12 10  ;PUSH Bytes
CALL            10 12 23   ;CALL function
                           #--- PUSHB_4   0 23 27 9 ;PUSH Bytes
CALL            9 27 23 0  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   38 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   4 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_3   7 11 1    ;PUSH Bytes
IP              1          ;Interpolate Point
IP              11         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'three': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 6 0     ;PUSH Bytes
CALL            0 6 4      ;CALL function
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] stem 43    ;Move Indirect Relative Point
                           #--- PUSHB_3   43 4 10   ;PUSH Bytes
CALL            10 4 43    ;CALL function
                           #--- PUSHB_4   0 43 47 9 ;PUSH Bytes
CALL            9 47 43 0  ;CALL function
                           #--- PUSHB_5   35 31 15 4 13 ;PUSH Bytes
CALL            13 4 15 31 35 ;CALL function
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_4   7 12 28 8 ;PUSH Bytes
CALL            8 28 12 7  ;CALL function
                           #--- PUSHB_2   40 9      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 9       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   40 7 10   ;PUSH Bytes
CALL            10 7 40    ;CALL function
                           #--- PUSHB_4   64 40 33 9 ;PUSH Bytes
CALL            9 33 40 64 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_3   18 12 21  ;PUSH Bytes
IP              21         ;Interpolate Point
IP              12         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'threequarters': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   88 1 0    ;PUSH Bytes
CALL            0 1 88     ;CALL function
                           #--- PUSHB_5   71 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 71 ;CALL function
                           #--- PUSHB_1   83        ;PUSH Bytes
SHP[rp2]        83         ;SHift Point using reference point
                           #--- PUSHB_3   10 6 0    ;PUSH Bytes
CALL            0 6 10     ;CALL function
                           #--- PUSHB_5   0 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 0 ;CALL function
                           #--- PUSHB_3   0 10 10   ;PUSH Bytes
CALL            10 10 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
                           #--- PUSHB_5   44 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 44 ;CALL function
                           #--- PUSHB_5   73 93 88 44 13 ;PUSH Bytes
CALL            13 44 88 93 73 ;CALL function
                           #--- PUSHB_1   77        ;PUSH Bytes
SHP[rp1]        77         ;SHift Point using reference point
                           #--- PUSHB_5   73 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 73 ;CALL function
                           #--- PUSHB_1   81        ;PUSH Bytes
SHP[rp2]        81         ;SHift Point using reference point
                           #--- PUSHB_3   93 73 10  ;PUSH Bytes
CALL            10 73 93   ;CALL function
                           #--- PUSHB_4   64 93 76 9 ;PUSH Bytes
CALL            9 76 93 64 ;CALL function
                           #--- PUSHB_5   29 20 88 44 13 ;PUSH Bytes
CALL            13 44 88 20 29 ;CALL function
                           #--- PUSHB_5   29 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 29 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   94        ;PUSH Bytes
MDAP[rnd]       94         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_5   17 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 17 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
                           #--- DUP       #47       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_5   13 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 13 ;CALL function
                           #--- PUSHB_3   47 13 10  ;PUSH Bytes
CALL            10 13 47   ;CALL function
                           #--- PUSHB_4   0 47 7 9  ;PUSH Bytes
CALL            9 7 47 0   ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_1   90        ;PUSH Bytes
SHP[rp2]        90         ;SHift Point using reference point
                           #--- PUSHB_5   83 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 83 ;CALL function
                           #--- PUSHB_1   76        ;PUSH Bytes
SHP[rp2]        76         ;SHift Point using reference point
                           #--- PUSHB_3   83 71 10  ;PUSH Bytes
CALL            10 71 83   ;CALL function
                           #--- PUSHB_4   64 83 86 9 ;PUSH Bytes
CALL            9 86 83 64 ;CALL function
                           #--- PUSHB_1   79        ;PUSH Bytes
SHP[rp2]        79         ;SHift Point using reference point
                           #--- PUSHB_3   71 83 10  ;PUSH Bytes
CALL            10 83 71   ;CALL function
                           #--- PUSHB_4   64 71 65 9 ;PUSH Bytes
CALL            9 65 71 64 ;CALL function
                           #--- PUSHB_4   64 71 73 9 ;PUSH Bytes
CALL            9 73 71 64 ;CALL function
                           #--- PUSHB_2   95 1      ;PUSH Bytes
CALL            1 95       ;CALL function
                           #--- PUSHB_2   71 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_4   60 63 75 93 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              93 75 63 60 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   73 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            73         ;Set Reference Point 2
                           #--- PUSHB_2   52 55     ;PUSH Bytes
IP              55         ;Interpolate Point
IP              52         ;Interpolate Point
                           #--- PUSHB_1   93        ;PUSH Bytes
SRP1            93         ;Set Reference Point 1
                           #--- PUSHB_1   74        ;PUSH Bytes
IP              74         ;Interpolate Point
                           #--- PUSHB_2   35 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_5   23 17 26 91 92 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              92 91 26 17 23 ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   13 60 63  ;PUSH Bytes
IP              63         ;Interpolate Point
IP              60         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'threesuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 6 0    ;PUSH Bytes
CALL            0 6 10     ;CALL function
                           #--- PUSHB_5   0 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 0 ;CALL function
                           #--- PUSHB_3   0 10 10   ;PUSH Bytes
CALL            10 10 0    ;CALL function
                           #--- PUSHB_4   0 0 4 9   ;PUSH Bytes
CALL            9 4 0 0    ;CALL function
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
                           #--- PUSHB_5   44 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 44 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 29 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_5   17 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 17 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
                           #--- DUP       #47       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_5   13 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 13 ;CALL function
                           #--- PUSHB_3   47 13 10  ;PUSH Bytes
CALL            10 13 47   ;CALL function
                           #--- PUSHB_4   0 47 7 9  ;PUSH Bytes
CALL            9 7 47 0   ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_3   23 17 26  ;PUSH Bytes
IP              26         ;Interpolate Point
IP              17         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'two': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_5   16 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 16 ;CALL function
                           #--- PUSHB_3   3 6 0     ;PUSH Bytes
CALL            0 6 3      ;CALL function
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_4   33 20 3 8 ;PUSH Bytes
CALL            8 3 20 33  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   31 9      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_4   12 31 0 8 ;PUSH Bytes
CALL            8 0 31 12  ;CALL function
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   18 9      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   12 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_2   13 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   11 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_2   6 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'twosuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 6 0     ;PUSH Bytes
CALL            0 6 3      ;CALL function
                           #--- PUSHB_5   24 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 24 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 9 ;CALL function
                           #--- PUSHB_5   13 8 0 34 4 ;PUSH Bytes
CALL            4 34 0 8 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   27 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 27 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   0 27 10   ;PUSH Bytes
CALL            10 27 0    ;CALL function
                           #--- PUSHB_4   64 0 16 9 ;PUSH Bytes
CALL            9 16 0 64  ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   14 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 14 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   10 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_4   0 6 21 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 21 6 0  ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'u': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 14 10   ;PUSH Bytes
CALL            10 14 6    ;CALL function
                           #--- PUSHB_4   0 6 10 9  ;PUSH Bytes
CALL            9 10 6 0   ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   1 27 10   ;PUSH Bytes
CALL            10 27 1    ;CALL function
                           #--- PUSHB_4   0 1 23 9  ;PUSH Bytes
CALL            9 23 1 0   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   30 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 30 ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   1 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   1 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 14 10   ;PUSH Bytes
CALL            10 14 6    ;CALL function
                           #--- PUSHB_4   0 6 10 9  ;PUSH Bytes
CALL            9 10 6 0   ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   1 27 10   ;PUSH Bytes
CALL            10 27 1    ;CALL function
                           #--- PUSHB_4   0 1 23 9  ;PUSH Bytes
CALL            9 23 1 0   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   30 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 30 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   1 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_3   3 39 47   ;PUSH Bytes
IP              47         ;Interpolate Point
IP              39         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   1 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ucircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 14 10   ;PUSH Bytes
CALL            10 14 6    ;CALL function
                           #--- PUSHB_4   0 6 10 9  ;PUSH Bytes
CALL            9 10 6 0   ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   1 27 10   ;PUSH Bytes
CALL            10 27 1    ;CALL function
                           #--- PUSHB_4   0 1 23 9  ;PUSH Bytes
CALL            9 23 1 0   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   30 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 30 ;CALL function
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_4   3 33 36 45 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              45 36 33 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   1 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'udieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   33 6 0    ;PUSH Bytes
CALL            0 6 33     ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   39 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 39 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 14 10   ;PUSH Bytes
CALL            10 14 6    ;CALL function
                           #--- PUSHB_4   0 6 10 9  ;PUSH Bytes
CALL            9 10 6 0   ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_1   41        ;PUSH Bytes
                           #--- DUP       #41       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_5   36 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 36 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   1 27 10   ;PUSH Bytes
CALL            10 27 1    ;CALL function
                           #--- PUSHB_4   0 1 23 9  ;PUSH Bytes
CALL            9 23 1 0   ;CALL function
                           #--- PUSHB_4   46 27 1 8 ;PUSH Bytes
CALL            8 1 27 46  ;CALL function
                           #--- PUSHB_5   51 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_5   46 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 46 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   30 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 30 ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   14 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   17 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   43 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              43         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   1 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ugrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 14 10   ;PUSH Bytes
CALL            10 14 6    ;CALL function
                           #--- PUSHB_4   0 6 10 9  ;PUSH Bytes
CALL            9 10 6 0   ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   1 27 10   ;PUSH Bytes
CALL            10 27 1    ;CALL function
                           #--- PUSHB_4   0 1 23 9  ;PUSH Bytes
CALL            9 23 1 0   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   30 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 30 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   1 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_3   3 36 44   ;PUSH Bytes
IP              44         ;Interpolate Point
IP              36         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   1 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'underscore': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 8       ;PUSH Bytes
MIRP[min,black] stemt_thick 3 ;Move Indirect Relative Point
                           #--- PUSHB_2   3 8       ;PUSH Bytes
MIRP[min,black] stemt_thick 3 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E01': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   8 17 16 22 13 ;PUSH Bytes
CALL            13 22 16 17 8 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   1 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_3   5 11 22   ;PUSH Bytes
IP              22         ;Interpolate Point
IP              11         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E02': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_5   42 23 1 29 13 ;PUSH Bytes
CALL            13 29 1 23 42 ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   51 9      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   38 9      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 38 10   ;PUSH Bytes
CALL            10 38 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   45 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   17 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   15 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_2   38 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_2   10 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_3   9 10 34   ;PUSH Bytes
IP              34         ;Interpolate Point
IP              10         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_5   11 20 26 32 48 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              48 32 26 20 11 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E03': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_3   47 2 0    ;PUSH Bytes
CALL            0 2 47     ;CALL function
                           #--- PUSHB_2   34 36     ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   28 49 1 34 13 ;PUSH Bytes
CALL            13 34 1 49 28 ;CALL function
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_5   22 55 1 34 13 ;PUSH Bytes
CALL            13 34 1 55 22 ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_5   58 9 0 82 4 ;PUSH Bytes
CALL            4 82 0 9 58 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   25 9      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 45 10   ;PUSH Bytes
CALL            10 45 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   39 9      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   52 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_4   17 22 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 22 17 ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   16 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_2   45 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_4   10 15 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 15 10 ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   49 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_6   9 10 31 39 41 25 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              25 41 39 31 10 9 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   12 16 20  ;PUSH Bytes
IP              20         ;Interpolate Point
IP              16         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_3   17 15 35  ;PUSH Bytes
IP              35         ;Interpolate Point
IP              15         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E04': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   37 2 0    ;PUSH Bytes
CALL            0 2 37     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   21 41 28 37 13 ;PUSH Bytes
CALL            13 37 28 41 21 ;CALL function
                           #--- PUSHB_2   21 7      ;PUSH Bytes
MIRP[min,black] stem 21    ;Move Indirect Relative Point
                           #--- PUSHB_5   15 47 28 37 13 ;PUSH Bytes
CALL            13 37 28 47 15 ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   18 9      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   8 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_2   27 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_5   15 21 5 37 50 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              50 37 5 21 15 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   11 31 32  ;PUSH Bytes
IP              32         ;Interpolate Point
IP              31         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_2   18 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   8 34      ;PUSH Bytes
IP              34         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E05': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 1 0    ;PUSH Bytes
CALL            0 1 30     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   39 2 0    ;PUSH Bytes
CALL            0 2 39     ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_5   23 45 30 39 13 ;PUSH Bytes
CALL            13 39 30 45 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_5   17 51 30 39 13 ;PUSH Bytes
CALL            13 39 30 51 17 ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_2   10 9      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   29 9      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   10 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_2   29 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_6   7 6 23 39 40 54 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              54 40 39 23 6 7 ;Interpolate Point
                           #--- PUSHB_2   1 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   5 41      ;PUSH Bytes
IP              41         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_3   13 33 34  ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_2   20 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   10 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_4   5 7 6 40  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 6 7 5   ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E06': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   71 7      ;PUSH Bytes
MIRP[min,black] stem 71    ;Move Indirect Relative Point
                           #--- PUSHB_3   57 2 0    ;PUSH Bytes
CALL            0 2 57     ;CALL function
                           #--- PUSHB_2   43 45     ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   77 13 7 43 13 ;PUSH Bytes
CALL            13 43 7 13 77 ;CALL function
                           #--- PUSHB_2   77 7      ;PUSH Bytes
MIRP[min,black] stem 77    ;Move Indirect Relative Point
                           #--- PUSHB_5   59 37 7 43 13 ;PUSH Bytes
CALL            13 43 7 37 59 ;CALL function
                           #--- PUSHB_2   59 7      ;PUSH Bytes
MIRP[min,black] stem 59    ;Move Indirect Relative Point
                           #--- PUSHB_5   31 65 7 43 13 ;PUSH Bytes
CALL            13 43 7 65 31 ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   83        ;PUSH Bytes
MDAP[rnd]       83         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_5   68 9 0 82 4 ;PUSH Bytes
CALL            4 82 0 9 68 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP0            68         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_2   80 9      ;PUSH Bytes
MIRP[min,black] stemw 80   ;Move Indirect Relative Point
                           #--- PUSHB_1   80        ;PUSH Bytes
SRP0            80         ;Set Reference Point 0
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   74 1      ;PUSH Bytes
CALL            1 74       ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   48 9      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   84 1      ;PUSH Bytes
CALL            1 84       ;CALL function
                           #--- PUSHB_2   10 68     ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   80        ;PUSH Bytes
SRP1            80         ;Set Reference Point 1
                           #--- PUSHB_5   31 37 43 59 65 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              65 59 43 37 31 ;Interpolate Point
                           #--- PUSHB_2   34 62     ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_6   13 25 7 44 71 77 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              77 71 44 7 25 13 ;Interpolate Point
                           #--- PUSHB_2   4 74      ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_4   19 24 45 51 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              51 45 24 19 ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   77 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            77         ;Set Reference Point 2
                           #--- PUSHB_3   10 56 3   ;PUSH Bytes
IP              3          ;Interpolate Point
IP              56         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
                           #--- PUSHB_2   59 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
                           #--- PUSHB_6   18 19 40 48 50 34 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              34 50 48 40 19 18 ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_3   21 25 29  ;PUSH Bytes
IP              29         ;Interpolate Point
IP              25         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_3   26 24 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              24         ;Interpolate Point
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E07': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
                           #--- PUSHB_5   36 23 2 29 13 ;PUSH Bytes
CALL            13 29 2 23 36 ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_2   33 9      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 33 10  ;PUSH Bytes
CALL            10 33 20   ;CALL function
                           #--- PUSHB_4   0 20 8 9  ;PUSH Bytes
CALL            9 8 20 0   ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   20 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   23 29 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 29 23 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   8 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   11 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E08': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   31 2 0    ;PUSH Bytes
CALL            0 2 31     ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 31 10  ;PUSH Bytes
CALL            10 31 20   ;CALL function
                           #--- PUSHB_4   0 20 26 9 ;PUSH Bytes
CALL            9 26 20 0  ;CALL function
                           #--- PUSHB_5   4 38 1 31 13 ;PUSH Bytes
CALL            13 31 1 38 4 ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_5   10 44 1 31 13 ;PUSH Bytes
CALL            13 31 1 44 10 ;CALL function
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[min,black] stem 10    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   47 9      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   7 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_2   2 47      ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_6   4 10 20 31 38 44 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              44 38 31 20 10 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   14 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_2   17 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E09': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   63 7      ;PUSH Bytes
MIRP[min,black] stem 63    ;Move Indirect Relative Point
                           #--- PUSHB_3   34 2 0    ;PUSH Bytes
CALL            0 2 34     ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
                           #--- PUSHB_5   4 51 44 34 13 ;PUSH Bytes
CALL            13 34 44 51 4 ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
                           #--- PUSHB_5   10 57 44 34 13 ;PUSH Bytes
CALL            13 34 44 57 10 ;CALL function
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[min,black] stem 10    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   60 9      ;PUSH Bytes
MIRP[min,black] stemw 60   ;Move Indirect Relative Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP0            60         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   72 9      ;PUSH Bytes
MIRP[min,black] stemw 72   ;Move Indirect Relative Point
                           #--- PUSHB_1   72        ;PUSH Bytes
SRP0            72         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   38 9      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   41 9      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   60 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_6   4 10 23 24 51 57 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              57 51 24 23 10 4 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_2   20 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_2   38 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_3   44 63 69  ;PUSH Bytes
IP              69         ;Interpolate Point
IP              63         ;Interpolate Point
IP              44         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 63      ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_4   14 41 47 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 47 41 14 ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_3   2 16 38   ;PUSH Bytes
IP              38         ;Interpolate Point
IP              16         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_2   20 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   29 15 10  ;PUSH Bytes
CALL            10 15 29   ;CALL function
                           #--- PUSHB_4   64 29 38 9 ;PUSH Bytes
CALL            9 38 29 64 ;CALL function
                           #--- PUSHB_5   61 23 1 38 13 ;PUSH Bytes
CALL            13 38 1 23 61 ;CALL function
                           #--- PUSHB_2   61 7      ;PUSH Bytes
MIRP[min,black] stem 61    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   70 9      ;PUSH Bytes
MIRP[min,black] stemw 70   ;Move Indirect Relative Point
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP0            70         ;Set Reference Point 0
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   60 9      ;PUSH Bytes
MIRP[min,black] stemw 60   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 60 10   ;PUSH Bytes
CALL            10 60 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP0            60         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   74 1      ;PUSH Bytes
CALL            1 74       ;CALL function
                           #--- PUSHB_2   64 70     ;PUSH Bytes
SRP1            70         ;Set Reference Point 1
SRP2            64         ;Set Reference Point 2
                           #--- PUSHB_2   17 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   60 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_4   10 32 13 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 13 32 10 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   35 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              35         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_3   9 10 56   ;PUSH Bytes
IP              56         ;Interpolate Point
IP              10         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_7   11 20 26 32 46 54 67 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              67 54 46 32 26 20 11 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_3   34 2 0    ;PUSH Bytes
CALL            0 2 34     ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_5   28 68 1 34 13 ;PUSH Bytes
CALL            13 34 1 68 28 ;CALL function
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_5   22 74 1 34 13 ;PUSH Bytes
CALL            13 34 1 74 22 ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_5   77 9 0 82 4 ;PUSH Bytes
CALL            4 82 0 9 77 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   77        ;PUSH Bytes
SRP0            77         ;Set Reference Point 0
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   25 9      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   67 9      ;PUSH Bytes
MIRP[min,black] stemw 67   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 67 10   ;PUSH Bytes
CALL            10 67 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP0            67         ;Set Reference Point 0
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   71 77     ;PUSH Bytes
SRP1            77         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_4   17 22 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 22 17 ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   16 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_2   67 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            67         ;Set Reference Point 2
                           #--- PUSHB_3   9 15 36   ;PUSH Bytes
IP              36         ;Interpolate Point
IP              15         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_4   10 39 12 53 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              53 12 39 10 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   42 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              42         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   68 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_1   64        ;PUSH Bytes
IP              64         ;Interpolate Point
                           #--- PUSHB_1   74        ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
                           #--- PUSHB_6   9 10 31 25 63 61 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              61 63 25 31 10 9 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_5   12 16 20 39 53 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              53 39 20 16 12 ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_3   17 15 35  ;PUSH Bytes
IP              35         ;Interpolate Point
IP              15         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   54 7      ;PUSH Bytes
MIRP[min,black] stem 54    ;Move Indirect Relative Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SHP[rp2]        66         ;SHift Point using reference point
                           #--- PUSHB_3   52 2 0    ;PUSH Bytes
CALL            0 2 52     ;CALL function
                           #--- PUSHB_3   45 2 0    ;PUSH Bytes
CALL            0 2 45     ;CALL function
                           #--- PUSHB_2   18 7      ;PUSH Bytes
MIRP[min,black] stem 18    ;Move Indirect Relative Point
                           #--- PUSHB_5   60 30 36 45 13 ;PUSH Bytes
CALL            13 45 36 30 60 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_2   60 7      ;PUSH Bytes
MIRP[min,black] stem 60    ;Move Indirect Relative Point
                           #--- PUSHB_1   72        ;PUSH Bytes
SHP[rp2]        72         ;SHift Point using reference point
                           #--- PUSHB_5   21 27 36 45 13 ;PUSH Bytes
CALL            13 45 36 27 21 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_2   21 7      ;PUSH Bytes
MIRP[min,black] stem 21    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp2]        63         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   33 9      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   75 9      ;PUSH Bytes
MIRP[min,black] stemw 75   ;Move Indirect Relative Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP0            75         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   49 9      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_4   69 49 14 8 ;PUSH Bytes
CALL            8 14 49 69 ;CALL function
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   28 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_4   30 36 54 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 54 36 30 ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   18 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_2   14 75     ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_3   8 66 72   ;PUSH Bytes
IP              72         ;Interpolate Point
IP              66         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   51 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   60 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_4   11 33 51 3 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              3 51 33 11 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_2   28 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   78 7      ;PUSH Bytes
MIRP[min,black] stem 78    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   62 7      ;PUSH Bytes
MIRP[min,black] stem 62    ;Move Indirect Relative Point
                           #--- PUSHB_3   58 2 0    ;PUSH Bytes
CALL            0 2 58     ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   74 7      ;PUSH Bytes
MIRP[min,black] stem 74    ;Move Indirect Relative Point
                           #--- PUSHB_5   68 50 78 58 13 ;PUSH Bytes
CALL            13 58 78 50 68 ;CALL function
                           #--- PUSHB_2   68 7      ;PUSH Bytes
MIRP[min,black] stem 68    ;Move Indirect Relative Point
                           #--- PUSHB_5   34 53 78 58 13 ;PUSH Bytes
CALL            13 58 78 53 34 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   84        ;PUSH Bytes
MDAP[rnd]       84         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
                           #--- PUSHB_2   71 9      ;PUSH Bytes
MIRP[min,black] stemw 71   ;Move Indirect Relative Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp2]        65         ;SHift Point using reference point
                           #--- PUSHB_2   41 9      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   8 11      ;PUSH Bytes
CALL            11 8       ;CALL function
                           #--- PUSHB_2   81 9      ;PUSH Bytes
MIRP[min,black] stemw 81   ;Move Indirect Relative Point
                           #--- PUSHB_1   81        ;PUSH Bytes
SRP0            81         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   85 1      ;PUSH Bytes
CALL            1 85       ;CALL function
                           #--- PUSHB_2   52 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_6   44 50 34 54 62 68 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              68 62 54 34 50 44 ;Interpolate Point
                           #--- PUSHB_2   27 81     ;PUSH Bytes
SRP1            81         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_7   1 5 11 31 37 58 76 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              76 58 37 31 11 5 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   74 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            74         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP1            78         ;Set Reference Point 1
                           #--- PUSHB_2   8 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   13 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_2   15 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_3   57 1 0    ;PUSH Bytes
CALL            0 1 57     ;CALL function
                           #--- PUSHB_2   75 7      ;PUSH Bytes
MIRP[min,black] stem 75    ;Move Indirect Relative Point
                           #--- PUSHB_3   71 2 0    ;PUSH Bytes
CALL            0 2 71     ;CALL function
                           #--- PUSHB_2   44 7      ;PUSH Bytes
MIRP[min,black] stem 44    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   87 7      ;PUSH Bytes
MIRP[min,black] stem 87    ;Move Indirect Relative Point
                           #--- PUSHB_1   91        ;PUSH Bytes
MDAP[rnd]       91         ;Move Direct Absolute Point
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_5   81 63 57 71 13 ;PUSH Bytes
CALL            13 71 57 63 81 ;CALL function
                           #--- PUSHB_2   81 7      ;PUSH Bytes
MIRP[min,black] stem 81    ;Move Indirect Relative Point
                           #--- PUSHB_5   47 66 57 71 13 ;PUSH Bytes
CALL            13 71 57 66 47 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_2   47 7      ;PUSH Bytes
MIRP[min,black] stem 47    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   97        ;PUSH Bytes
MDAP[rnd]       97         ;Move Direct Absolute Point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDRP[rp0,rnd,white] 60         ;Move Direct Relative Point
                           #--- PUSHB_2   84 9      ;PUSH Bytes
MIRP[min,black] stemw 84   ;Move Indirect Relative Point
                           #--- PUSHB_1   84        ;PUSH Bytes
SRP0            84         ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_1   78        ;PUSH Bytes
SHP[rp2]        78         ;SHift Point using reference point
                           #--- PUSHB_2   54 9      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_4   94 54 65 8 ;PUSH Bytes
CALL            8 65 54 94 ;CALL function
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   94 9      ;PUSH Bytes
MIRP[min,black] stemw 94   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   98 1      ;PUSH Bytes
CALL            1 98       ;CALL function
                           #--- PUSHB_2   13 84     ;PUSH Bytes
SRP1            84         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_6   47 57 63 67 75 81 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              81 75 67 63 57 47 ;Interpolate Point
                           #--- PUSHB_2   40 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- NPUSHB    9 1 10 16 44 50 71 87 89 91 ;PUSH N Bytes
                           #--- DEPTH     #9        ;DEPTH of the stack
SLOOP           9          ;Set LOOP variable
IP              91 89 87 71 50 44 16 10 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   91 87     ;PUSH Bytes
SRP1            87         ;Set Reference Point 1
SRP2            91         ;Set Reference Point 2
                           #--- PUSHB_5   3 13 32 40 8 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              8 40 32 13 3 ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_3   18 30 36  ;PUSH Bytes
IP              36         ;Interpolate Point
IP              30         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_2   20 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_2   81 75     ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
SRP2            81         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E10': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   58 2 0    ;PUSH Bytes
CALL            0 2 58     ;CALL function
                           #--- PUSHB_2   41 43     ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_2   22 24     ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_5   35 62 13 58 13 ;PUSH Bytes
CALL            13 58 13 62 35 ;CALL function
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
                           #--- PUSHB_5   29 68 13 58 13 ;PUSH Bytes
CALL            13 58 13 68 29 ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_5   71 9 0 82 4 ;PUSH Bytes
CALL            4 82 0 9 71 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   46 9      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   53 55     ;PUSH Bytes
SDPVTL[orthog]  55 53      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[no-rnd]    53         ;Move Direct Absolute Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDRP[grey]      55         ;Move Direct Relative Point
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[rp0,min,black] stem 10    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[grey]      8          ;Move Direct Relative Point
                           #--- PUSHB_4   9 10 8 19 ;PUSH Bytes
CALL            19 8 10 9  ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_4   54 53 55 19 ;PUSH Bytes
CALL            19 55 53 54 ;CALL function
                           #--- PUSHB_3   54 53 55  ;PUSH Bytes
                           #--- DUP       #55       ;DUPlicate top stack element
ROLL            55 55 53   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              54         ;Interpolate Point
                           #--- PUSHB_3   9 10 8    ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   8 55 9 10 53 54 ;PUSH Bytes
MDAP[no-rnd]    54         ;Move Direct Absolute Point
MDAP[no-rnd]    53         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    55         ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   8 55 9 10 53 54 ;PUSH Bytes
MDAP[no-rnd]    54         ;Move Direct Absolute Point
MDAP[no-rnd]    53         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    55         ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   65 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_4   24 35 41 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 41 35 24 ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   23 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_2   12 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_3   17 22 43  ;PUSH Bytes
IP              43         ;Interpolate Point
IP              22         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_2   46 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_6   16 17 32 38 46 48 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              48 46 38 32 17 16 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_3   19 23 27  ;PUSH Bytes
IP              27         ;Interpolate Point
IP              23         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E10.descless': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_5   4 48 1 25 13 ;PUSH Bytes
CALL            13 25 1 48 4 ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_5   54 10 1 25 13 ;PUSH Bytes
CALL            13 25 1 10 54 ;CALL function
                           #--- PUSHB_2   54 7      ;PUSH Bytes
MIRP[min,black] stem 54    ;Move Indirect Relative Point
                           #--- PUSHB_5   40 21 1 25 13 ;PUSH Bytes
CALL            13 25 1 21 40 ;CALL function
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_5   28 34 1 25 13 ;PUSH Bytes
CALL            13 25 1 34 28 ;CALL function
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   57 9      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   44 9      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   2 57      ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_6   4 10 25 37 48 54 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              54 48 37 25 10 4 ;Interpolate Point
                           #--- PUSHB_2   44 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   28 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   14 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E12': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   49 1 0    ;PUSH Bytes
CALL            0 1 49     ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   81 7      ;PUSH Bytes
MIRP[min,black] stem 81    ;Move Indirect Relative Point
                           #--- PUSHB_3   67 2 0    ;PUSH Bytes
CALL            0 2 67     ;CALL function
                           #--- PUSHB_2   58 60     ;PUSH Bytes
SHP[rp1]        60         ;SHift Point using reference point
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_5   87 14 8 58 13 ;PUSH Bytes
CALL            13 58 8 14 87 ;CALL function
                           #--- PUSHB_2   87 7      ;PUSH Bytes
MIRP[min,black] stem 87    ;Move Indirect Relative Point
                           #--- PUSHB_5   39 75 8 58 13 ;PUSH Bytes
CALL            13 58 8 75 39 ;CALL function
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   93        ;PUSH Bytes
MDAP[rnd]       93         ;Move Direct Absolute Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDRP[rp0,rnd,white] 55         ;Move Direct Relative Point
                           #--- PUSHB_2   25 9      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   30 9      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   36 11     ;PUSH Bytes
CALL            11 36      ;CALL function
                           #--- PUSHB_2   78 9      ;PUSH Bytes
MIRP[min,black] stemw 78   ;Move Indirect Relative Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP0            78         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   90 9      ;PUSH Bytes
MIRP[min,black] stemw 90   ;Move Indirect Relative Point
                           #--- PUSHB_1   72        ;PUSH Bytes
                           #--- DUP       #72       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 72         ;Move Direct Relative Point
SRP1            72         ;Set Reference Point 1
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   90        ;PUSH Bytes
SRP0            90         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   64 9      ;PUSH Bytes
MIRP[min,black] stemw 64   ;Move Indirect Relative Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP0            64         ;Set Reference Point 0
                           #--- PUSHB_1   5         ;PUSH Bytes
                           #--- DUP       #5        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   84 9      ;PUSH Bytes
MIRP[min,black] stemw 84   ;Move Indirect Relative Point
                           #--- PUSHB_1   84        ;PUSH Bytes
MDAP[rnd]       84         ;Move Direct Absolute Point
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP0            64         ;Set Reference Point 0
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   94 1      ;PUSH Bytes
CALL            1 94       ;CALL function
                           #--- PUSHB_2   25 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_2   30 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   27 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP1            78         ;Set Reference Point 1
                           #--- PUSHB_2   22 58     ;PUSH Bytes
IP              58         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   72        ;PUSH Bytes
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_5   21 45 46 59 33 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              33 59 46 45 21 ;Interpolate Point
                           #--- PUSHB_2   90 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            90         ;Set Reference Point 2
                           #--- PUSHB_2   20 60     ;PUSH Bytes
IP              60         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_4   14 8 81 87 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              87 81 8 14 ;Interpolate Point
                           #--- PUSHB_2   66 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   87 81     ;PUSH Bytes
SRP1            81         ;Set Reference Point 1
SRP2            87         ;Set Reference Point 2
                           #--- PUSHB_5   11 30 46 66 3 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              3 66 46 30 11 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_3   33 45 64  ;PUSH Bytes
IP              64         ;Interpolate Point
IP              45         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP2            75         ;Set Reference Point 2
                           #--- PUSHB_7   25 28 36 42 52 55 69 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              69 55 52 42 36 28 25 ;Interpolate Point
                           #--- PUSHB_2   67 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            67         ;Set Reference Point 2
                           #--- PUSHB_4   20 22 21 59 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              59 21 22 20 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E13': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   52 7      ;PUSH Bytes
MIRP[min,black] stem 52    ;Move Indirect Relative Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SHP[rp2]        64         ;SHift Point using reference point
                           #--- PUSHB_3   39 2 0    ;PUSH Bytes
CALL            0 2 39     ;CALL function
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   58 17 23 32 13 ;PUSH Bytes
CALL            13 32 23 17 58 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   58 7      ;PUSH Bytes
MIRP[min,black] stem 58    ;Move Indirect Relative Point
                           #--- PUSHB_1   70        ;PUSH Bytes
SHP[rp2]        70         ;SHift Point using reference point
                           #--- PUSHB_5   8 27 23 32 13 ;PUSH Bytes
CALL            13 32 23 27 8 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   73 9      ;PUSH Bytes
MIRP[min,black] stemw 73   ;Move Indirect Relative Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SRP0            73         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   41 9      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   44 9      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   55 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_6   5 11 17 23 52 58 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              58 52 23 17 11 5 ;Interpolate Point
                           #--- PUSHB_2   41 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   47 64 70  ;PUSH Bytes
IP              70         ;Interpolate Point
IP              64         ;Interpolate Point
IP              47         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   58 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_4   20 44 36 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 36 44 20 ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_2   15 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E14': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   41 2 0    ;PUSH Bytes
CALL            0 2 41     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   22 51 32 41 13 ;PUSH Bytes
CALL            13 41 32 51 22 ;CALL function
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] stem 22    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   54 9      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   25 9      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   8 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   13 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   10 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_2   48 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_5   5 28 29 41 16 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              16 41 29 28 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_6   10 13 19 25 36 45 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              45 36 25 19 13 10 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_2   8 38      ;PUSH Bytes
IP              38         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E15': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 1 0    ;PUSH Bytes
CALL            0 1 34     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   43 2 0    ;PUSH Bytes
CALL            0 2 43     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_5   24 55 34 43 13 ;PUSH Bytes
CALL            13 43 34 55 24 ;CALL function
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] stem 24    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_2   10 9      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   58 9      ;PUSH Bytes
MIRP[min,black] stemw 58   ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   10 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_2   15 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   12 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_2   7 43      ;PUSH Bytes
IP              43         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_2   52 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_5   6 30 31 44 18 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              18 44 31 30 6 ;Interpolate Point
                           #--- PUSHB_2   1 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   5 45      ;PUSH Bytes
IP              45         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   55 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_6   12 15 21 27 38 49 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              49 38 27 21 15 12 ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   10 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_4   5 7 6 44  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              44 6 7 5   ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E16': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   42 17 23 32 13 ;PUSH Bytes
CALL            13 32 23 17 42 ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
                           #--- PUSHB_5   8 27 23 32 13 ;PUSH Bytes
CALL            13 32 23 27 8 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_5   11 17 23 36 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              42 36 23 17 11 ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E17': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   34 15 12 21 13 ;PUSH Bytes
CALL            13 21 12 15 34 ;CALL function
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   43 9      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   12 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   15 21 34 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 34 21 15 ;Interpolate Point
                           #--- PUSHB_2   1 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   10 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   8 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E18': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   4 1 10    ;PUSH Bytes
CALL            10 1 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   14 2 0    ;PUSH Bytes
CALL            0 2 14     ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_5   30 10 1 14 13 ;PUSH Bytes
CALL            13 14 1 10 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_5   17 24 1 14 13 ;PUSH Bytes
CALL            13 14 1 24 17 ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   14 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   17 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E19': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   46 7      ;PUSH Bytes
MIRP[min,black] stem 46    ;Move Indirect Relative Point
                           #--- PUSHB_3   26 2 0    ;PUSH Bytes
CALL            0 2 26     ;CALL function
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_5   34 12 0 18 13 ;PUSH Bytes
CALL            13 18 0 12 34 ;CALL function
                           #--- PUSHB_2   34 7      ;PUSH Bytes
MIRP[min,black] stem 34    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   43 9      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   55 9      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   31 9      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   9 43      ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   12 18 34 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 34 18 12 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_2   28 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_3   0 46 52   ;PUSH Bytes
IP              52         ;Interpolate Point
IP              46         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_7   3 5 22 25 28 31 52 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              52 31 28 25 22 5 3 ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 9 1 15 13 ;PUSH Bytes
CALL            13 15 1 9 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 19 10   ;PUSH Bytes
CALL            10 19 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   6 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   9 15 23 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 23 15 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   21 5 0    ;PUSH Bytes
CALL            0 5 21     ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 9 1 15 13 ;PUSH Bytes
CALL            13 15 1 9 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 19 10   ;PUSH Bytes
CALL            10 19 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   6 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   9 15 23 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 23 15 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_3   8 2 0     ;PUSH Bytes
CALL            0 2 8      ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 14 4 8 13 ;PUSH Bytes
CALL            13 8 4 14 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   17 9      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_4   8 14 23 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 23 14 8 ;Interpolate Point
                           #--- PUSHB_2   20 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_3   1 2 18    ;PUSH Bytes
IP              18         ;Interpolate Point
IP              2          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   2 17 18 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 18 17 2 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 5 0    ;PUSH Bytes
CALL            0 5 21     ;CALL function
                           #--- PUSHB_3   8 2 0     ;PUSH Bytes
CALL            0 2 8      ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 14 4 8 13 ;PUSH Bytes
CALL            13 8 4 14 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   17 9      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_4   8 14 23 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 23 14 8 ;Interpolate Point
                           #--- PUSHB_2   20 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_3   1 2 18    ;PUSH Bytes
IP              18         ;Interpolate Point
IP              2          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   2 17 18 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 18 17 2 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_5   25 9 6 15 13 ;PUSH Bytes
CALL            13 15 6 9 25 ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   6 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   9 15 25 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 25 15 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   2 4 19 22 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              22 19 4 2  ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   12 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   23 5 0    ;PUSH Bytes
CALL            0 5 23     ;CALL function
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_5   25 9 6 15 13 ;PUSH Bytes
CALL            13 15 6 9 25 ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   6 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   9 15 25 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 25 15 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   2 4 19 22 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              22 19 4 2  ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   12 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E20': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   42 24 18 32 13 ;PUSH Bytes
CALL            13 32 18 24 42 ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
                           #--- PUSHB_5   8 27 18 32 13 ;PUSH Bytes
CALL            13 32 18 27 8 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   26 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_6   18 24 8 28 36 42 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              42 36 28 8 24 18 ;Interpolate Point
                           #--- PUSHB_2   1 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_3   5 11 32   ;PUSH Bytes
IP              32         ;Interpolate Point
IP              11         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E21': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   31 2 0    ;PUSH Bytes
CALL            0 2 31     ;CALL function
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
                           #--- PUSHB_5   51 13 7 24 13 ;PUSH Bytes
CALL            13 24 7 13 51 ;CALL function
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[min,black] stem 51    ;Move Indirect Relative Point
                           #--- PUSHB_5   33 18 7 24 13 ;PUSH Bytes
CALL            13 24 7 18 33 ;CALL function
                           #--- PUSHB_2   33 7      ;PUSH Bytes
MIRP[min,black] stem 33    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   54 9      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   15 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   48 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_6   13 7 18 24 33 39 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              39 33 24 18 7 13 ;Interpolate Point
                           #--- PUSHB_2   30 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_3   10 30 3   ;PUSH Bytes
IP              3          ;Interpolate Point
IP              30         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_2   33 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E22': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
                           #--- PUSHB_3   37 2 0    ;PUSH Bytes
CALL            0 2 37     ;CALL function
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_5   31 25 1 11 13 ;PUSH Bytes
CALL            13 11 1 25 31 ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_5   39 17 1 11 13 ;PUSH Bytes
CALL            13 11 1 17 39 ;CALL function
                           #--- PUSHB_2   39 7      ;PUSH Bytes
MIRP[min,black] stem 39    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   35 9      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 1 10   ;PUSH Bytes
CALL            10 1 35    ;CALL function
                           #--- PUSHB_4   64 35 28 9 ;PUSH Bytes
CALL            9 28 35 64 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   1 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_2   5 48      ;PUSH Bytes
IP              48         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_6   17 25 31 11 39 45 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              45 39 11 31 25 17 ;Interpolate Point
                           #--- PUSHB_2   36 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   26 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_2   39 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   8 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_2   14 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E23': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 2 0    ;PUSH Bytes
CALL            0 2 17     ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_5   46 6 0 17 13 ;PUSH Bytes
CALL            13 17 0 6 46 ;CALL function
                           #--- PUSHB_2   46 7      ;PUSH Bytes
MIRP[min,black] stem 46    ;Move Indirect Relative Point
                           #--- PUSHB_5   32 13 0 17 13 ;PUSH Bytes
CALL            13 17 0 13 32 ;CALL function
                           #--- PUSHB_2   32 7      ;PUSH Bytes
MIRP[min,black] stem 32    ;Move Indirect Relative Point
                           #--- PUSHB_5   20 26 0 17 13 ;PUSH Bytes
CALL            13 17 0 26 20 ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   49 9      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   37 9      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   8 49      ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_6   6 0 17 29 40 46 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              46 40 29 17 0 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E24': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   42 17 23 32 13 ;PUSH Bytes
CALL            13 32 23 17 42 ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
                           #--- PUSHB_5   8 27 23 32 13 ;PUSH Bytes
CALL            13 32 23 27 8 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   39 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_5   11 17 23 36 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              42 36 23 17 11 ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   5 32      ;PUSH Bytes
IP              32         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E25': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
                           #--- PUSHB_3   41 2 0    ;PUSH Bytes
CALL            0 2 41     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_3   30 41 10  ;PUSH Bytes
CALL            10 41 30   ;CALL function
                           #--- PUSHB_4   0 30 36 9 ;PUSH Bytes
CALL            9 36 30 0  ;CALL function
                           #--- PUSHB_5   51 10 16 41 13 ;PUSH Bytes
CALL            13 41 16 10 51 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[min,black] stem 51    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 4 16 41 13 ;PUSH Bytes
CALL            13 41 16 4 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   20 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_2   48 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_4   10 16 45 51 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              51 45 16 10 ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_4   4 23 30 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 30 23 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E26': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   42 24 18 32 13 ;PUSH Bytes
CALL            13 32 18 24 42 ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
                           #--- PUSHB_5   8 27 18 32 13 ;PUSH Bytes
CALL            13 32 18 27 8 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   26 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_6   18 24 8 28 36 42 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              42 36 28 8 24 18 ;Interpolate Point
                           #--- PUSHB_2   1 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_3   5 11 32   ;PUSH Bytes
IP              32         ;Interpolate Point
IP              11         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E27': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 24 10  ;PUSH Bytes
CALL            10 24 12   ;CALL function
                           #--- PUSHB_4   0 12 19 9 ;PUSH Bytes
CALL            9 19 12 0  ;CALL function
                           #--- PUSHB_5   37 6 0 24 13 ;PUSH Bytes
CALL            13 24 0 6 37 ;CALL function
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   17 9      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   40 9      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   3 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   12 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   8 40      ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_4   6 0 31 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 31 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E28': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   53 7      ;PUSH Bytes
MIRP[min,black] stem 53    ;Move Indirect Relative Point
                           #--- PUSHB_5   13 68 20 29 13 ;PUSH Bytes
CALL            13 29 20 68 13 ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_5   63 74 20 29 13 ;PUSH Bytes
CALL            13 29 20 74 63 ;CALL function
                           #--- PUSHB_2   63 7      ;PUSH Bytes
MIRP[min,black] stem 63    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   56 9      ;PUSH Bytes
MIRP[min,black] stemw 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   10 9      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   56 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_2   19 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
                           #--- PUSHB_5   13 29 53 65 77 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              77 65 53 29 13 ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_3   5 32 50   ;PUSH Bytes
IP              50         ;Interpolate Point
IP              32         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   35 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              35         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   68 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_3   23 24 59  ;PUSH Bytes
IP              59         ;Interpolate Point
IP              24         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   74        ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
                           #--- PUSHB_2   10 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_4   26 56 8 65 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              65 8 56 26 ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_4   32 46 50 5 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              5 50 46 32 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E29': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   63 7      ;PUSH Bytes
MIRP[min,black] stem 63    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 38 1 15 13 ;PUSH Bytes
CALL            13 15 1 38 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
                           #--- PUSHB_5   32 75 1 15 13 ;PUSH Bytes
CALL            13 15 1 75 32 ;CALL function
                           #--- PUSHB_2   32 7      ;PUSH Bytes
MIRP[min,black] stem 32    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
                           #--- DUP       #9        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   57 7      ;PUSH Bytes
MIRP[min,black] stem 57    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   81        ;PUSH Bytes
MDAP[rnd]       81         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   66 9      ;PUSH Bytes
MIRP[min,black] stemw 66   ;Move Indirect Relative Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP0            66         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SHP[rp2]        60         ;SHift Point using reference point
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 19 10   ;PUSH Bytes
CALL            10 19 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   78 9      ;PUSH Bytes
MIRP[min,black] stemw 78   ;Move Indirect Relative Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP0            78         ;Set Reference Point 0
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_2   35 9      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_3   0 20 10   ;PUSH Bytes
CALL            10 20 0    ;CALL function
                           #--- PUSHB_4   64 0 52 9 ;PUSH Bytes
CALL            9 52 0 64  ;CALL function
                           #--- PUSHB_2   82 1      ;PUSH Bytes
CALL            1 82       ;CALL function
                           #--- PUSHB_2   6 66      ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   9 15 57 63 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              63 57 15 9 ;Interpolate Point
                           #--- PUSHB_2   72 78     ;PUSH Bytes
SRP1            78         ;Set Reference Point 1
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_2   23 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   21 56     ;PUSH Bytes
IP              56         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
                           #--- PUSHB_7   35 29 41 44 49 52 69 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              69 52 49 44 41 29 35 ;Interpolate Point
                           #--- PUSHB_2   32 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_2   63 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   69 7      ;PUSH Bytes
MIRP[min,black] stem 69    ;Move Indirect Relative Point
                           #--- PUSHB_3   41 2 0    ;PUSH Bytes
CALL            0 2 41     ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
                           #--- PUSHB_3   30 41 10  ;PUSH Bytes
CALL            10 41 30   ;CALL function
                           #--- PUSHB_4   0 30 36 9 ;PUSH Bytes
CALL            9 36 30 0  ;CALL function
                           #--- PUSHB_5   75 10 16 41 13 ;PUSH Bytes
CALL            13 41 16 10 75 ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SHP[rp1]        60         ;SHift Point using reference point
                           #--- PUSHB_2   75 7      ;PUSH Bytes
MIRP[min,black] stem 75    ;Move Indirect Relative Point
                           #--- PUSHB_5   23 4 16 41 13 ;PUSH Bytes
CALL            13 41 16 4 23 ;CALL function
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[min,black] stem 23    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   81        ;PUSH Bytes
MDAP[rnd]       81         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SHP[rp2]        78         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SHP[rp2]        60         ;SHift Point using reference point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_2   82 1      ;PUSH Bytes
CALL            1 82       ;CALL function
                           #--- PUSHB_2   20 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_2   72 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_4   10 16 69 75 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              75 69 16 10 ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_3   4 23 41   ;PUSH Bytes
IP              41         ;Interpolate Point
IP              23         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   25 28 43 66 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              66 43 28 25 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   46 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              46         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   75 69     ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
SRP2            75         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   66        ;PUSH Bytes
IP              66         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_4   28 43 57 63 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              63 57 43 28 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   52 7      ;PUSH Bytes
MIRP[min,black] stem 52    ;Move Indirect Relative Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SHP[rp2]        64         ;SHift Point using reference point
                           #--- PUSHB_5   46 15 12 21 13 ;PUSH Bytes
CALL            13 21 12 15 46 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   46 7      ;PUSH Bytes
MIRP[min,black] stem 46    ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   55 9      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   67 9      ;PUSH Bytes
MIRP[min,black] stemw 67   ;Move Indirect Relative Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP0            67         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   39 9      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   12 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   15 21 46 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              52 46 21 15 ;Interpolate Point
                           #--- PUSHB_2   67 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            67         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_2   5 36      ;PUSH Bytes
IP              36         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_3   13 30 42  ;PUSH Bytes
IP              42         ;Interpolate Point
IP              30         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_3   33 39 18  ;PUSH Bytes
IP              18         ;Interpolate Point
IP              39         ;Interpolate Point
IP              33         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_2   66 7      ;PUSH Bytes
MIRP[min,black] stem 66    ;Move Indirect Relative Point
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_2   60 7      ;PUSH Bytes
MIRP[min,black] stem 60    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   54 7      ;PUSH Bytes
MIRP[min,black] stem 54    ;Move Indirect Relative Point
                           #--- PUSHB_5   48 9 6 15 13 ;PUSH Bytes
CALL            13 15 6 9 48 ;CALL function
                           #--- PUSHB_2   48 7      ;PUSH Bytes
MIRP[min,black] stem 48    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   57 9      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   69 9      ;PUSH Bytes
MIRP[min,black] stemw 69   ;Move Indirect Relative Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP0            69         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   22 62     ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   6 57      ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   9 15 48 54 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              54 48 15 9 ;Interpolate Point
                           #--- PUSHB_2   28 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
                           #--- PUSHB_2   3 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   25 66     ;PUSH Bytes
IP              66         ;Interpolate Point
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   2 4 19 22 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              22 19 4 2  ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_2   12 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   21 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_2   60 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
                           #--- PUSHB_2   40 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_2   19 7      ;PUSH Bytes
MIRP[min,black] stem 19    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 30 10  ;PUSH Bytes
CALL            10 30 19   ;CALL function
                           #--- PUSHB_4   0 19 25 9 ;PUSH Bytes
CALL            9 25 19 0  ;CALL function
                           #--- PUSHB_5   11 34 1 30 13 ;PUSH Bytes
CALL            13 30 1 34 11 ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_5   5 40 1 30 13 ;PUSH Bytes
CALL            13 30 1 40 5 ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   1 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_2   37 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   11 5 34 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 34 5 11 ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   19 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[min,black] stem 51    ;Move Indirect Relative Point
                           #--- PUSHB_5   11 57 1 27 13 ;PUSH Bytes
CALL            13 27 1 57 11 ;CALL function
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
                           #--- PUSHB_5   5 63 1 27 13 ;PUSH Bytes
CALL            13 27 1 63 5 ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   45 21 1 27 13 ;PUSH Bytes
CALL            13 27 1 21 45 ;CALL function
                           #--- PUSHB_2   45 7      ;PUSH Bytes
MIRP[min,black] stem 45    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SHP[rp2]        66         ;SHift Point using reference point
                           #--- PUSHB_4   54 14 1 8 ;PUSH Bytes
CALL            8 1 14 54  ;CALL function
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   54 9      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_2   60 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_4   11 5 57 63 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              63 57 5 11 ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_4   21 27 45 51 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              51 45 27 21 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   18 30 48  ;PUSH Bytes
IP              48         ;Interpolate Point
IP              30         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_3   32 35 42  ;PUSH Bytes
IP              42         ;Interpolate Point
IP              35         ;Interpolate Point
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   57 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_2   51 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_4   24 30 42 18 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              18 42 30 24 ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_5   25 10 1 19 13 ;PUSH Bytes
CALL            13 19 1 10 25 ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   40 9      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 0 10    ;PUSH Bytes
CALL            10 0 6     ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   34 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_2   10 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   16 22 7 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 7 22 16 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E30': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 10   ;PUSH Bytes
CALL            10 0 15    ;CALL function
                           #--- PUSHB_4   0 15 22 9 ;PUSH Bytes
CALL            9 22 15 0  ;CALL function
                           #--- PUSHB_3   51 2 0    ;PUSH Bytes
CALL            0 2 51     ;CALL function
                           #--- PUSHB_2   78 7      ;PUSH Bytes
MIRP[min,black] stem 78    ;Move Indirect Relative Point
                           #--- PUSHB_5   36 9 0 51 13 ;PUSH Bytes
CALL            13 51 0 9 36 ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_5   57 42 0 51 13 ;PUSH Bytes
CALL            13 51 0 42 57 ;CALL function
                           #--- PUSHB_2   57 7      ;PUSH Bytes
MIRP[min,black] stem 57    ;Move Indirect Relative Point
                           #--- PUSHB_3   57 42 10  ;PUSH Bytes
CALL            10 42 57   ;CALL function
                           #--- PUSHB_4   0 57 64 9 ;PUSH Bytes
CALL            9 64 57 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   84        ;PUSH Bytes
MDAP[rnd]       84         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_2   39 9      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   81        ;PUSH Bytes
SHP[rp2]        81         ;SHift Point using reference point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   75        ;PUSH Bytes
SHP[rp2]        75         ;SHift Point using reference point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_2   85 1      ;PUSH Bytes
CALL            1 85       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   9 51      ;PUSH Bytes
IP              51         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_4   0 15 42 57 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              57 42 15 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_3   12 6 30   ;PUSH Bytes
IP              30         ;Interpolate Point
IP              6          ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   78 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            78         ;Set Reference Point 2
                           #--- PUSHB_3   54 48 72  ;PUSH Bytes
IP              72         ;Interpolate Point
IP              48         ;Interpolate Point
IP              54         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E31': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   15 7      ;PUSH Bytes
MIRP[min,black] stem 15    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 10   ;PUSH Bytes
CALL            10 0 15    ;CALL function
                           #--- PUSHB_4   0 15 22 9 ;PUSH Bytes
CALL            9 22 15 0  ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   39 9      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_2   0 15      ;PUSH Bytes
IP              15         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_3   12 6 30   ;PUSH Bytes
IP              30         ;Interpolate Point
IP              6          ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E32': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   5 16 10   ;PUSH Bytes
CALL            10 16 5    ;CALL function
                           #--- PUSHB_4   0 5 11 9  ;PUSH Bytes
CALL            9 11 5 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E33': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 4 0    ;PUSH Bytes
CALL            0 4 27     ;CALL function
                           #--- PUSHB_5   0 8 0 26 4 ;PUSH Bytes
CALL            4 26 0 8 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   36 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_5   15 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 15 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_3   12 0 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              0          ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   4 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_4   7 15 30 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 30 15 7 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E34': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E35': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   16 7      ;PUSH Bytes
MIRP[min,black] stem 16    ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   4 13 10   ;PUSH Bytes
CALL            10 13 4    ;CALL function
                           #--- PUSHB_4   64 4 8 9  ;PUSH Bytes
CALL            9 8 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 1 9  ;PUSH Bytes
CALL            9 1 7 64   ;CALL function
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E37': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] stem 4     ;Move Indirect Relative Point
                           #--- PUSHB_3   4 17 10   ;PUSH Bytes
CALL            10 17 4    ;CALL function
                           #--- PUSHB_4   64 4 12 9 ;PUSH Bytes
CALL            9 12 4 64  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 1 9  ;PUSH Bytes
CALL            9 1 6 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   11 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_2   6 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E38': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   14 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 14 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   10 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   23 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_5   17 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   1 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   4 10 14 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 14 10 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E39': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 16 9 ;PUSH Bytes
CALL            9 16 14 64 ;CALL function
                           #--- PUSHB_4   4 14 1 8  ;PUSH Bytes
CALL            8 1 14 4   ;CALL function
                           #--- PUSHB_5   18 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 18 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   10 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   27 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   13 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   21 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   4 10 1    ;PUSH Bytes
IP              1          ;Interpolate Point
IP              10         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E3A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   6 8 0 25 4 ;PUSH Bytes
CALL            4 25 0 8 6 ;CALL function
                           #--- PUSHB_5   6 8 0 25 4 ;PUSH Bytes
CALL            4 25 0 8 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   9 10 0 25 4 ;PUSH Bytes
CALL            4 25 0 10 9 ;CALL function
                           #--- PUSHB_5   9 10 0 25 4 ;PUSH Bytes
CALL            4 25 0 10 9 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E40': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_5   20 8 0 4 13 ;PUSH Bytes
CALL            13 4 0 8 20 ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   6 9       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_4   0 8 14 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 14 8 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E41': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 6 0    ;PUSH Bytes
CALL            0 6 15     ;CALL function
                           #--- PUSHB_2   21 7      ;PUSH Bytes
MIRP[min,black] stem 21    ;Move Indirect Relative Point
                           #--- PUSHB_5   46 34 0 15 13 ;PUSH Bytes
CALL            13 15 0 34 46 ;CALL function
                           #--- PUSHB_2   46 7      ;PUSH Bytes
MIRP[min,black] stem 46    ;Move Indirect Relative Point
                           #--- PUSHB_5   27 8 0 15 13 ;PUSH Bytes
CALL            13 15 0 8 27 ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
MIRP[min,black] stem 27    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   37 9      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   43 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_5   21 0 34 40 46 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              46 40 34 0 21 ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   37 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E43': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   48 7      ;PUSH Bytes
MIRP[min,black] stem 48    ;Move Indirect Relative Point
                           #--- PUSHB_5   42 30 0 48 13 ;PUSH Bytes
CALL            13 48 0 30 42 ;CALL function
                           #--- PUSHB_2   42 7      ;PUSH Bytes
MIRP[min,black] stem 42    ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] stem 24    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   57 9 0 82 4 ;PUSH Bytes
CALL            4 82 0 9 57 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   33 9      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   51 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   18 12     ;PUSH Bytes
IP              12         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_2   7 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_2   39 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   0 30 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 30 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   33 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_2   54 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_3   4 21 15   ;PUSH Bytes
IP              15         ;Interpolate Point
IP              21         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E44': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] stem 31    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   34 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_4   0 25 31 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 31 25 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E45': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   5 16 10   ;PUSH Bytes
CALL            10 16 5    ;CALL function
                           #--- PUSHB_4   0 5 11 9  ;PUSH Bytes
CALL            9 11 5 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E46': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   41 26 1 32 13 ;PUSH Bytes
CALL            13 32 1 26 41 ;CALL function
                           #--- PUSHB_2   41 7      ;PUSH Bytes
MIRP[min,black] stem 41    ;Move Indirect Relative Point
                           #--- PUSHB_5   20 47 1 32 13 ;PUSH Bytes
CALL            13 32 1 47 20 ;CALL function
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_5   50 9 0 82 4 ;PUSH Bytes
CALL            4 82 0 9 50 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   38 9      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   9 38 10   ;PUSH Bytes
CALL            10 38 9    ;CALL function
                           #--- PUSHB_4   64 9 3 9  ;PUSH Bytes
CALL            9 3 9 64   ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   44 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_4   15 20 26 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 26 20 15 ;Interpolate Point
                           #--- PUSHB_2   9 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   14 33 34  ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   29 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   18 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_3   15 13 33  ;PUSH Bytes
IP              33         ;Interpolate Point
IP              13         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E47': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_5   45 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 45 ;CALL function
                           #--- PUSHB_3   45 0 10   ;PUSH Bytes
CALL            10 0 45    ;CALL function
                           #--- PUSHB_4   64 45 30 9 ;PUSH Bytes
CALL            9 30 45 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 39 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[min,black] stem 10    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_5   3 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   55 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_5   42 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 42 ;CALL function
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   3 29      ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   10 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_2   22 11     ;PUSH Bytes
IP              11         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_3   13 39 0   ;PUSH Bytes
IP              0          ;Interpolate Point
IP              39         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_8   7 26 3 34 36 42 49 55 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              55 49 42 36 34 3 26 7 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E47.high': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 15 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 9 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   39 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   12 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 12 ;CALL function
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_3   30 36 9   ;PUSH Bytes
IP              9          ;Interpolate Point
IP              36         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_2   0 15      ;PUSH Bytes
IP              15         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_5   12 19 25 6 30 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              30 6 25 19 12 ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_3   20 21 22  ;PUSH Bytes
IP              22         ;Interpolate Point
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E48': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   8 9 0 86 4 ;PUSH Bytes
CALL            4 86 0 9 8 ;CALL function
                           #--- PUSHB_5   8 9 0 86 4 ;PUSH Bytes
CALL            4 86 0 9 8 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   8 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E48.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 8 0 16 4 ;PUSH Bytes
CALL            4 16 0 8 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E49': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 1 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   30 7 0 37 4 ;PUSH Bytes
CALL            4 37 0 7 30 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 37 4 ;PUSH Bytes
CALL            4 37 0 7 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   39 9 0 37 4 ;PUSH Bytes
CALL            4 37 0 9 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   15 9 0 37 4 ;PUSH Bytes
CALL            4 37 0 9 15 ;CALL function
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_6   6 12 18 30 4 36 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              36 4 30 18 12 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_4   15 21 23 9 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              9 23 21 15 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E49.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 7       ;PUSH Bytes
MIRP[min,black] stem 1     ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   30 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 30 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   39 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   15 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 15 ;CALL function
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_4   6 12 18 4 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              4 18 12 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_4   15 21 23 9 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              9 23 21 15 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   63 7 0 37 4 ;PUSH Bytes
CALL            4 37 0 7 63 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   26 7 0 37 4 ;PUSH Bytes
CALL            4 37 0 7 26 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_5   39 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 39 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_5   72 9 0 37 4 ;PUSH Bytes
CALL            4 37 0 9 72 ;CALL function
                           #--- PUSHB_1   72        ;PUSH Bytes
SRP0            72         ;Set Reference Point 0
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_5   29 9 0 37 4 ;PUSH Bytes
CALL            4 37 0 9 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   17 11     ;PUSH Bytes
CALL            11 17      ;CALL function
                           #--- PUSHB_5   16 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   49 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_5   60 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 60 ;CALL function
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   66 72     ;PUSH Bytes
SRP1            72         ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_6   21 26 32 63 69 24 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              24 69 63 32 26 21 ;Interpolate Point
                           #--- PUSHB_2   16 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_2   60 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   56        ;PUSH Bytes
IP              56         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   63 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
                           #--- PUSHB_5   29 49 50 66 72 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              72 66 50 49 29 ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_2   39 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4A.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   63 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 63 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   26 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 26 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_5   39 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 39 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_5   72 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 72 ;CALL function
                           #--- PUSHB_1   72        ;PUSH Bytes
SRP0            72         ;Set Reference Point 0
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_5   29 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   17 11     ;PUSH Bytes
CALL            11 17      ;CALL function
                           #--- PUSHB_5   16 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   49 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_5   60 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 60 ;CALL function
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   66 72     ;PUSH Bytes
SRP1            72         ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_4   21 26 32 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 32 26 21 ;Interpolate Point
                           #--- PUSHB_2   16 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   4 45      ;PUSH Bytes
IP              45         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   63 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
                           #--- PUSHB_3   29 49 50  ;PUSH Bytes
IP              50         ;Interpolate Point
IP              49         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_2   39 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_5   8 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 8 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   4 8 10    ;PUSH Bytes
CALL            10 8 4     ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_3   8 4 10    ;PUSH Bytes
CALL            10 4 8     ;CALL function
                           #--- PUSHB_4   64 8 12 9 ;PUSH Bytes
CALL            9 12 8 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   22 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 22 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 10   ;PUSH Bytes
CALL            10 2 22    ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
                           #--- PUSHB_3   2 22 10   ;PUSH Bytes
CALL            10 22 2    ;CALL function
                           #--- PUSHB_4   64 2 6 9  ;PUSH Bytes
CALL            9 6 2 64   ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4B.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 4 0     ;PUSH Bytes
CALL            0 4 4      ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_5   8 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 8 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   4 8 10    ;PUSH Bytes
CALL            10 8 4     ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_3   8 4 10    ;PUSH Bytes
CALL            10 4 8     ;CALL function
                           #--- PUSHB_4   64 8 12 9 ;PUSH Bytes
CALL            9 12 8 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   22 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 22 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 10   ;PUSH Bytes
CALL            10 2 22    ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
                           #--- PUSHB_3   2 22 10   ;PUSH Bytes
CALL            10 22 2    ;CALL function
                           #--- PUSHB_4   64 2 6 9  ;PUSH Bytes
CALL            9 6 2 64   ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   25 7 0 37 4 ;PUSH Bytes
CALL            4 37 0 7 25 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_5   6 7 0 37 4 ;PUSH Bytes
CALL            4 37 0 7 6 ;CALL function
                           #--- PUSHB_3   6 31 10   ;PUSH Bytes
CALL            10 31 6    ;CALL function
                           #--- PUSHB_4   64 6 13 9 ;PUSH Bytes
CALL            9 13 6 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   34 9 0 37 4 ;PUSH Bytes
CALL            4 37 0 9 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   22 9 0 37 4 ;PUSH Bytes
CALL            4 37 0 9 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   17 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 17 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   28 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   0 25 6 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 6 25 0  ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   3 22 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 22 3 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4C.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   25 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 25 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_5   6 7 0 61 4 ;PUSH Bytes
CALL            4 61 0 7 6 ;CALL function
                           #--- PUSHB_3   6 31 10   ;PUSH Bytes
CALL            10 31 6    ;CALL function
                           #--- PUSHB_4   64 6 13 9 ;PUSH Bytes
CALL            9 13 6 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   34 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   22 9 0 61 4 ;PUSH Bytes
CALL            4 61 0 9 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   17 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 17 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   28 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   0 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   3 22 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 22 3 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] stem 6     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   51 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 51 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 48      ;PUSH Bytes
SHP[rp1]        48         ;SHift Point using reference point
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 6 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_5   13 7 0 110 4 ;PUSH Bytes
CALL            4 110 0 7 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   48 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 48 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   30 9 0 110 4 ;PUSH Bytes
CALL            4 110 0 9 30 ;CALL function
                           #--- PUSHB_3   30 10 10  ;PUSH Bytes
CALL            10 10 30   ;CALL function
                           #--- PUSHB_4   64 30 36 9 ;PUSH Bytes
CALL            9 36 30 64 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   10 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_3   0 43 51   ;PUSH Bytes
IP              51         ;Interpolate Point
IP              43         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   36 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_3   8 33 34   ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_4   10 21 25 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 25 21 10 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_2   18 7      ;PUSH Bytes
MIRP[min,black] stem 18    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] stem 30    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   33 9      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_6   6 12 18 24 30 0 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              0 30 24 18 12 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_6   9 3 21 27 33 15 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              15 33 27 21 3 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E50': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] stem 6     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   21 9      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E51': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   32 7      ;PUSH Bytes
MIRP[min,black] stem 32    ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_2   47 7      ;PUSH Bytes
MIRP[min,black] stem 47    ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   41 7      ;PUSH Bytes
MIRP[min,black] stem 41    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] stem 6     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   29 9      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   56 9      ;PUSH Bytes
MIRP[min,black] stemw 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   44 9      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   56 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_2   32 0      ;PUSH Bytes
IP              0          ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_4   26 6 41 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 41 6 26 ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   17 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_2   53 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_6   9 23 29 3 44 38 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              38 44 3 29 23 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E52': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   18 7      ;PUSH Bytes
MIRP[min,black] stem 18    ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_2   54 7      ;PUSH Bytes
MIRP[min,black] stem 54    ;Move Indirect Relative Point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 7      ;PUSH Bytes
MIRP[min,black] stem 33    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   18 9      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   63 9 0 82 4 ;PUSH Bytes
CALL            4 82 0 9 63 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   51 9      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   63 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_4   28 39 45 33 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              33 45 39 28 ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   27 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_2   26 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   60 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_2   42 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E53': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] stem 43    ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 7      ;PUSH Bytes
MIRP[min,black] stem 20    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   33 7      ;PUSH Bytes
MIRP[min,black] stem 33    ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   18 9      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   46 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_4   20 26 43 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 43 26 20 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_2   9 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   5 39      ;PUSH Bytes
IP              39         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E54': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] stem 26    ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_2   49 7      ;PUSH Bytes
MIRP[min,black] stem 49    ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 7      ;PUSH Bytes
MIRP[min,black] stem 33    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 7       ;PUSH Bytes
MIRP[min,black] stem 7     ;Move Indirect Relative Point
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   0 7 12 9  ;PUSH Bytes
CALL            9 12 7 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   58 9      ;PUSH Bytes
MIRP[min,black] stemw 58   ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   58 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_2   20 7      ;PUSH Bytes
IP              7          ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_4   33 39 41 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 41 39 33 ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   8 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   55 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_4   4 30 36 23 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              23 36 30 4 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E55': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_3   76 3 0    ;PUSH Bytes
CALL            0 3 76     ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] stem 12    ;Move Indirect Relative Point
                           #--- PUSHB_3   24 3 0    ;PUSH Bytes
CALL            0 3 24     ;CALL function
                           #--- PUSHB_3   19 3 0    ;PUSH Bytes
CALL            0 3 19     ;CALL function
                           #--- PUSHB_5   48 58 1 12 13 ;PUSH Bytes
CALL            13 12 1 58 48 ;CALL function
                           #--- PUSHB_2   48 7      ;PUSH Bytes
MIRP[min,black] stem 48    ;Move Indirect Relative Point
                           #--- PUSHB_5   64 42 1 12 13 ;PUSH Bytes
CALL            13 12 1 42 64 ;CALL function
                           #--- PUSHB_2   64 7      ;PUSH Bytes
MIRP[min,black] stem 64    ;Move Indirect Relative Point
                           #--- PUSHB_5   70 29 1 12 13 ;PUSH Bytes
CALL            13 12 1 29 70 ;CALL function
                           #--- PUSHB_2   70 7      ;PUSH Bytes
MIRP[min,black] stem 70    ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   82        ;PUSH Bytes
MDAP[rnd]       82         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   32 9      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   67 9      ;PUSH Bytes
MIRP[min,black] stemw 67   ;Move Indirect Relative Point
                           #--- PUSHB_1   79        ;PUSH Bytes
SHP[rp2]        79         ;SHift Point using reference point
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP0            67         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp2]        73         ;SHift Point using reference point
                           #--- PUSHB_2   45 9      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   83 1      ;PUSH Bytes
CALL            1 83       ;CALL function
                           #--- PUSHB_2   67 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            67         ;Set Reference Point 2
                           #--- PUSHB_2   29 7      ;PUSH Bytes
IP              7          ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_7   12 42 48 50 36 70 76 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              76 70 36 50 48 42 12 ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   17 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   64 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            64         ;Set Reference Point 2
                           #--- PUSHB_4   4 39 45 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 45 39 4 ;Interpolate Point
                           #--- PUSHB_2   70 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_2   12 76     ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E56': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_2   9 7       ;PUSH Bytes
MIRP[min,black] stem 9     ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   47 7      ;PUSH Bytes
MIRP[min,black] stem 47    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_2   44 9      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_4   6 44 28 8 ;PUSH Bytes
CALL            8 28 44 6  ;CALL function
                           #--- PUSHB_2   62 9      ;PUSH Bytes
MIRP[min,black] stemw 62   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   12 9      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   50 9      ;PUSH Bytes
MIRP[min,black] stemw 50   ;Move Indirect Relative Point
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   62 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_5   0 15 17 23 47 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              47 23 17 15 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   59 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_3   15 6 53   ;PUSH Bytes
IP              53         ;Interpolate Point
IP              6          ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_2   23 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_5   20 26 27 44 50 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              50 44 27 26 20 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E57': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_2   60 7      ;PUSH Bytes
MIRP[min,black] stem 60    ;Move Indirect Relative Point
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   38 7      ;PUSH Bytes
MIRP[min,black] stem 38    ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_3   38 19 10  ;PUSH Bytes
CALL            10 19 38   ;CALL function
                           #--- PUSHB_4   64 38 54 9 ;PUSH Bytes
CALL            9 54 38 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_2   23 9      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   48 9      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 48 10   ;PUSH Bytes
CALL            10 48 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   57 9      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   63 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_6   19 25 31 38 60 66 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              66 60 38 31 25 19 ;Interpolate Point
                           #--- PUSHB_2   14 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   10 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   60 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_2   66 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_1   69        ;PUSH Bytes
IP              69         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   23 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   14 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E58': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   36 0 10   ;PUSH Bytes
CALL            10 0 36    ;CALL function
                           #--- PUSHB_4   64 36 31 9 ;PUSH Bytes
CALL            9 31 36 64 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_2   44 7      ;PUSH Bytes
MIRP[min,black] stem 44    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
MIRP[min,black] stem 11    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   27 9      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   62 9      ;PUSH Bytes
MIRP[min,black] stemw 62   ;Move Indirect Relative Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP0            62         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   47 9      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   41 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   11 24 32  ;PUSH Bytes
IP              32         ;Interpolate Point
IP              24         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_5   0 12 36 39 23 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              23 39 36 12 0 ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_2   38 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_3   4 41 53   ;PUSH Bytes
IP              53         ;Interpolate Point
IP              41         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E59': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   58 7      ;PUSH Bytes
MIRP[min,black] stem 58    ;Move Indirect Relative Point
                           #--- PUSHB_3   43 2 0    ;PUSH Bytes
CALL            0 2 43     ;CALL function
                           #--- PUSHB_5   64 16 22 43 13 ;PUSH Bytes
CALL            13 43 22 16 64 ;CALL function
                           #--- PUSHB_2   64 7      ;PUSH Bytes
MIRP[min,black] stem 64    ;Move Indirect Relative Point
                           #--- PUSHB_5   37 51 22 43 13 ;PUSH Bytes
CALL            13 43 22 51 37 ;CALL function
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_2   28 43     ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[grey]      28         ;Move Direct Relative Point
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   67 9      ;PUSH Bytes
MIRP[min,black] stemw 67   ;Move Indirect Relative Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP0            67         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   46 9      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   61 67     ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_4   5 22 28 16 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              16 28 22 5 ;Interpolate Point
                           #--- PUSHB_2   41 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_5   1 0 31 51 56 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              56 51 31 0 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   64 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            64         ;Set Reference Point 2
                           #--- PUSHB_2   13 11     ;PUSH Bytes
IP              11         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   51 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_2   43 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   40 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E5A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   29 45     ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_2   37 7      ;PUSH Bytes
MIRP[min,black] stem 37    ;Move Indirect Relative Point
                           #--- PUSHB_5   25 10 1 19 13 ;PUSH Bytes
CALL            13 19 1 10 25 ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   40 9      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   43 9      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   34 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_2   10 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   16 22 7 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 7 22 16 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E5B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] stem 29    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   62 7      ;PUSH Bytes
MIRP[min,black] stem 62    ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] stem 43    ;Move Indirect Relative Point
                           #--- PUSHB_2   35 38     ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   43 49 10  ;PUSH Bytes
CALL            10 49 43   ;CALL function
                           #--- PUSHB_4   64 43 33 9 ;PUSH Bytes
CALL            9 33 43 64 ;CALL function
                           #--- PUSHB_2   36 39     ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_2   18 7      ;PUSH Bytes
MIRP[min,black] stem 18    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] stem 6     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   71 9      ;PUSH Bytes
MIRP[min,black] stemw 71   ;Move Indirect Relative Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_5   9 9 0 60 4 ;PUSH Bytes
CALL            4 60 0 9 9 ;CALL function
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   32 33     ;PUSH Bytes
SDPVTL[orthog]  33 32      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[grey]      32         ;Move Direct Relative Point
                           #--- PUSHB_2   57 12     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin_2 57 ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
MDRP[grey]      58         ;Move Direct Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_3   32 57 58  ;PUSH Bytes
MDAP[no-rnd]    58         ;Move Direct Absolute Point
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   32 33 57 58 ;PUSH Bytes
MDAP[no-rnd]    58         ;Move Direct Absolute Point
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   65 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_6   6 0 18 23 29 12 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              12 29 23 18 0 6 ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   20 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   62 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_4   52 53 55 56 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              56 55 53 52 ;Interpolate Point
                           #--- PUSHB_2   43 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_7   3 26 15 51 54 65 71 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              71 65 54 51 15 26 3 ;Interpolate Point
                           #--- PUSHB_2   18 68     ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   9 20 61   ;PUSH Bytes
IP              61         ;Interpolate Point
IP              20         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uniF700': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   1 3 0     ;PUSH Bytes
CALL            0 3 1      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   3 10 0 7 4 ;PUSH Bytes
CALL            4 7 0 10 3 ;CALL function
                           #--- PUSHB_5   3 10 0 7 4 ;PUSH Bytes
CALL            4 7 0 10 3 ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uniF71C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_5   7 8 0 17 4 ;PUSH Bytes
CALL            4 17 0 8 7 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_5   5 8 0 34 4 ;PUSH Bytes
CALL            4 34 0 8 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   6 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 6 ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   2 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 2 ;Move Indirect Relative Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'v': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] stem 14    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 2 0     ;PUSH Bytes
CALL            0 2 7      ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   3 7       ;PUSH Bytes
MIRP[min,black] stem 3     ;Move Indirect Relative Point
                           #--- PUSHB_3   12 16 26  ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   16 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_4   1 0 10 19 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              19 10 0 1  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'w': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_5   20 8 0 36 4 ;PUSH Bytes
CALL            4 36 0 8 20 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] stem 6     ;Move Indirect Relative Point
                           #--- PUSHB_3   15 21 32  ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_5   19 2 4 10 13 ;PUSH Bytes
CALL            13 10 4 2 19 ;CALL function
                           #--- PUSHB_2   19 8      ;PUSH Bytes
MIRP[min,black] stemt_thick 19 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   16 9      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 5 10   ;PUSH Bytes
CALL            10 5 16    ;CALL function
                           #--- PUSHB_4   64 16 13 9 ;PUSH Bytes
CALL            9 13 16 64 ;CALL function
                           #--- PUSHB_3   5 16 10   ;PUSH Bytes
CALL            10 16 5    ;CALL function
                           #--- PUSHB_4   64 5 8 9  ;PUSH Bytes
CALL            9 8 5 64   ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   20 21     ;PUSH Bytes
SDPVTL[orthog]  21 20      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   32 11     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 32 ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   20 11     ;PUSH Bytes
MIRP[rp0,min,black] stemw_thin 20 ;Move Indirect Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_3   0 20 32   ;PUSH Bytes
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    20         ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   21 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   4 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'x': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] stem 24    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 11 14   ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_3   37 40 50  ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_5   39 13 20 32 13 ;PUSH Bytes
CALL            13 32 20 13 39 ;CALL function
                           #--- PUSHB_5   39 8 0 36 4 ;PUSH Bytes
CALL            4 36 0 8 39 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 0 ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
                           #--- DUP       #40       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   26 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   17 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   13 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   9 43      ;PUSH Bytes
IP              43         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   0 26      ;PUSH Bytes
IP              26         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'y': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_3   11 14 24  ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_4   13 32 6 8 ;PUSH Bytes
CALL            8 6 32 13  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   26 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   9 37      ;PUSH Bytes
IP              37         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'yacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_3   11 14 24  ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 36      ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ydieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   38 6 0    ;PUSH Bytes
CALL            0 6 38     ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp1]        48         ;SHift Point using reference point
                           #--- PUSHB_5   44 8 0 20 4 ;PUSH Bytes
CALL            4 20 0 8 44 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_3   11 14 24  ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
                           #--- PUSHB_5   41 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 41 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   51 10 0 20 4 ;PUSH Bytes
CALL            4 20 0 10 51 ;CALL function
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   41 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   12 37 9   ;PUSH Bytes
IP              9          ;Interpolate Point
IP              37         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_4   13 26 29 0 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              0 29 26 13 ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 36      ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'yen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   18 7      ;PUSH Bytes
MIRP[min,black] stem 18    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   39 4 0    ;PUSH Bytes
CALL            0 4 39     ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_2   35 7      ;PUSH Bytes
MIRP[min,black] stem 35    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 47 57  ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_5   21 25 14 39 13 ;PUSH Bytes
CALL            13 39 14 25 21 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_2   21 7      ;PUSH Bytes
MIRP[min,black] stem 21    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   28 32 14 39 13 ;PUSH Bytes
CALL            13 39 14 32 28 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp1]        59         ;SHift Point using reference point
                           #--- PUSHB_2   28 7      ;PUSH Bytes
MIRP[min,black] stem 28    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   8 19 10   ;PUSH Bytes
CALL            10 19 8    ;CALL function
                           #--- PUSHB_4   64 8 4 9  ;PUSH Bytes
CALL            9 4 8 64   ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_4   64 8 11 9 ;PUSH Bytes
CALL            9 11 8 64  ;CALL function
                           #--- PUSHB_3   19 8 10   ;PUSH Bytes
CALL            10 8 19    ;CALL function
                           #--- PUSHB_4   64 19 23 9 ;PUSH Bytes
CALL            9 23 19 64 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_4   64 19 16 9 ;PUSH Bytes
CALL            9 16 19 64 ;CALL function
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   8 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'z': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] stem 2     ;Move Indirect Relative Point
                           #--- PUSHB_3   2 10 10   ;PUSH Bytes
CALL            10 10 2    ;CALL function
                           #--- PUSHB_4   0 2 6 9   ;PUSH Bytes
CALL            9 6 2 0    ;CALL function
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] stem 13    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 19 10  ;PUSH Bytes
CALL            10 19 13   ;CALL function
                           #--- PUSHB_4   64 13 16 9 ;PUSH Bytes
CALL            9 16 13 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   11 10     ;PUSH Bytes
MIRP[min,black] stemw_thick 11 ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   9 9       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_1   0         ;PUSH Bytes
                           #--- DUP       #0        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   12 10     ;PUSH Bytes
MIRP[min,black] stemw_thick 12 ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] stemw_thick 0 ;Move Indirect Relative Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   0 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_2   19 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zero': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   17 7      ;PUSH Bytes
MIRP[min,black] stem 17    ;Move Indirect Relative Point
                           #--- PUSHB_3   10 6 0    ;PUSH Bytes
CALL            0 6 10     ;CALL function
                           #--- PUSHB_2   25 7      ;PUSH Bytes
MIRP[min,black] stem 25    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   13 9      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   20 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   10 4      ;PUSH Bytes
IP              4          ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zerowidthnonjoiner': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[min,black] stem 36    ;Move Indirect Relative Point
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   40 7      ;PUSH Bytes
MIRP[min,black] stem 40    ;Move Indirect Relative Point
                           #--- PUSHB_3   38 2 0    ;PUSH Bytes
CALL            0 2 38     ;CALL function
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_5   46 17 23 32 13 ;PUSH Bytes
CALL            13 32 23 17 46 ;CALL function
                           #--- PUSHB_2   46 7      ;PUSH Bytes
MIRP[min,black] stem 46    ;Move Indirect Relative Point
                           #--- PUSHB_5   8 27 23 32 13 ;PUSH Bytes
CALL            13 32 23 27 8 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   8 7       ;PUSH Bytes
MIRP[min,black] stem 8     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   15 9      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   20 9      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   36 9      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   43 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_6   5 11 17 23 40 46 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              46 40 23 17 11 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_3   20 43 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              43         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zerowidthspace': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
                           #--- PUSHB_2   5 7       ;PUSH Bytes
MIRP[min,black] stem 5     ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   8 10 0 7 4 ;PUSH Bytes
CALL            4 7 0 10 8 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

}
