#!/usr/bin/env python

func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]

cvt_dict = {
    'cvt_0' : 0,   #  0
    'vheight' : 1,   #  437
    'vheight_cap' : 2,   #  583
    'cvt_3' : 3,   #  623
    'stemt' : 4,   #  101
    'cvt_5' : 5,   #  93
    'stemw' : 6,   #  101
    'cvt_7' : 7,   #  99
    'cvt_8' : 8,   #  61
    'cvt_9' : 9,   #  71
    'cvt_10' : 10,   #  89
    'cvt_11' : 11,   #  85
    'cvt_12' : 12,   #  57
    'cvt_13' : 13,   #  42
    'cvt_14' : 14,   #  44
    'cvt_15' : 15,   #  37
    'cvt_16' : 16,   #  83
    'cvt_17' : 17,   #  81
    'cvt_18' : 18,   #  79
    'cvt_19' : 19,   #  109
    }

pseudo_fpgm = """
                           #--- PUSHB_1   0         ;PUSH Bytes
FDEF            0          ;Function DEFinition
                           #--- PUSHB_1   0         ;PUSH Bytes
SZP0            0          ;Set Zone Pointer 0
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM#1 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   74        ;PUSH Bytes
SROUND          74         ;Super ROUND
EIF                        ;    End IF
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_arg1   ;SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP#1 &_SWAP#2 ;Move Indirect Absolute Point
RTG                        ;Round To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
RTDG                       ;Round To Double Grid
EIF                        ;    End IF
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM#1 ; Less Than
IF              &_LT#1     ;   IF test
RDTG                       ;Round Down To Grid
EIF                        ;    End IF
                           #--- DUP       #&_arg2   ;DUPlicate top stack element
MDRP[rp0,rnd,grey] &_arg2     ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SZP0            1          ;Set Zone Pointer 0
MDAP[no-rnd]    &_arg2     ;Move Direct Absolute Point
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   1         ;PUSH Bytes
FDEF            1          ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,min,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_arg1  ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   2         ;PUSH Bytes
FDEF            2          ;Function DEFinition
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_arg1 ;Greater Than
IF              &_GT#1     ;   IF test
RCVT            &_arg2     ;Read Control Value Table entry
SWAP            &_RCVT#1 &_arg3 ;SWAP the top two elements on the stack
EIF                        ;    End IF
POP             &_SWAP#1   ;POP top stack element
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP#2
#------------------
#STACK_REMAIN=RETURN : &_f2_retval#1
#------------------

                           #--- PUSHB_1   3         ;PUSH Bytes
FDEF            3          ;Function DEFinition
ROUND[Black]    &_arg1     ;ROUND value
RTG                        ;Round To Grid
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
LT              64 &_ROUND#1 ; Less Than
IF              &_LT#1     ;   IF test
POP             &_ROUND#1  ;POP top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#------------------
#STACK_REMAIN=RETURN : &_f3_retval#1
#------------------

                           #--- PUSHB_1   4         ;PUSH Bytes
FDEF            4          ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
POP             &_arg1     ;POP top stack element
SWAP            &_arg2 &_arg3 ;SWAP the top two elements on the stack
POP             &_SWAP#1   ;POP top stack element
ROFF                       ; Round OFF
IF              &_SWAP#2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg4     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg4     ;Move Direct Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_arg1 ;Greater Than
IF              &_GT#1     ;   IF test
IF              &_arg2     ;   IF test
MIRP[rp0,min,rnd,black] &_arg3 &_arg4 ;Move Indirect Relative Point
ELSE                       ;ELSE clause
MIRP[min,rnd,black] &_arg3 &_arg4 ;Move Indirect Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg2 &_arg3 ;SWAP the top two elements on the stack
POP             &_SWAP#1   ;POP top stack element
                           #--- PUSHB_1   5         ;PUSH Bytes
CALL            5          ;CALL function
IF              &_f5_retval#1 ;   IF test
                           #--- PUSHB_1   70        ;PUSH Bytes
SROUND          70         ;Super ROUND
EIF                        ;    End IF
IF              &_SWAP#2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg4     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg4     ;Move Direct Relative Point
EIF                        ;    End IF
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   5         ;PUSH Bytes
FDEF            5          ;Function DEFinition
GFV                        ;Get Freedom Vector
NOT             &_GFV#1    ;logical NOT
AND             &_NOT#1 &_GFV#2 ;logical AND
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND#1
#------------------
#STACK_REMAIN=RETURN : &_f5_retval#1
#------------------

                           #--- PUSHB_1   6         ;PUSH Bytes
FDEF            6          ;Function DEFinition
                           #--- PUSHB_2   34 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO#1 34 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   32        ;PUSH Bytes
GETINFO         32         ;GET INFOrmation
NOT             &_GETINFO#1 ;logical NOT
NOT             &_NOT#1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT#1
#------------------
#STACK_REMAIN=RETURN : &_f6_retval#1
#------------------

                           #--- PUSHB_1   7         ;PUSH Bytes
FDEF            7          ;Function DEFinition
                           #--- PUSHB_2   36 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO#1 36 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
GETINFO         64         ;GET INFOrmation
NOT             &_GETINFO#1 ;logical NOT
NOT             &_NOT#1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT#1
#------------------
#STACK_REMAIN=RETURN : &_f7_retval#1
#------------------

                           #--- PUSHB_1   8         ;PUSH Bytes
FDEF            8          ;Function DEFinition
SRP2            &_arg1     ;Set Reference Point 2
SRP1            &_arg2     ;Set Reference Point 1
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
IP              &_arg3     ;Interpolate Point
MDAP[rnd]       &_arg3     ;Move Direct Absolute Point
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   9         ;PUSH Bytes
FDEF            9          ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
RDTG                       ;Round Down To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
MDRP[rnd,grey]  &_arg1     ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg1     ;Move Direct Relative Point
EIF                        ;    End IF
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX#1 &_arg1 ;Measure Distance
SWAP            &_MD#1 &_arg1 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[orig]        &_SWAP#1 &_SWAP#1 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD#1   ; Less Than
IF              &_LT#1     ;   IF test
ROLL            &_SWAP#2 &_arg2 &_arg3 ;ROLL the top three stack elements
NEG             &_ROLL#1   ;    NEGate
ROLL            &_NEG#1 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SUB             &_ROLL#1 &_ROLL#2 ;  SUBtract
                           #--- DUP       #&_SUB#1  ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SUB#1  ; Less Than
IF              &_LT#1     ;   IF test
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
ROLL            &_arg2 &_arg3 &_arg4 ;ROLL the top three stack elements
ROLL            &_ROLL#1 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SUB             &_ROLL#1 &_ROLL#2 ;  SUBtract
                           #--- DUP       #&_SUB#1  ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SUB#1  ;Greater Than
IF              &_GT#1     ;   IF test
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg5     ;POP top stack element
POP             &_arg6     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   10        ;PUSH Bytes
FDEF            10         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
POP             &_arg1     ;POP top stack element
SRP0            &_arg2     ;Set Reference Point 0
ELSE                       ;ELSE clause
SRP0            &_arg1     ;Set Reference Point 0
POP             &_arg2     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   11        ;PUSH Bytes
FDEF            11         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_arg1  ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   12        ;PUSH Bytes
FDEF            12         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDAP[rnd]       &_arg1     ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
GC[orig]        &_arg1     ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_arg1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
IF              &_ROUND#1  ;   IF test
                           #--- DUP       #&_ROUND#1 ;DUPlicate top stack element
ABS             &_ROUND#1  ;ABSolute value
DIV             &_ABS#1 &_ROUND#1 ;    DIVide
SHPIX           &_DIV#1 &_arg1 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   13        ;PUSH Bytes
FDEF            13         ;Function DEFinition
SRP2            &_arg1     ;Set Reference Point 2
SRP1            &_arg2     ;Set Reference Point 1
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
IP              &_arg3     ;Interpolate Point
MDAP[rnd]       &_arg3     ;Move Direct Absolute Point
                           #--- DUP       #&_arg3   ;DUPlicate top stack element
ROLL            &_arg3 &_arg3 &_arg4 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
GC[orig]        &_ROLL#1   ;Get Coordinate projected onto the projection vector
ROLL            &_GC#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
GC[cur]         &_ROLL#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_ROLL#2 ;  SUBtract
SWAP            &_SUB#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_ROLL#3 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
MD[orig]        &_SWAP#1 &_SWAP#2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD#1   ; Less Than
IF              &_LT#1     ;   IF test
SWAP            &_ROLL#3 &_ROLL#3 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SWAP#1 ;Greater Than
IF              &_GT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
SHPIX           64 &_SWAP#2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg5 &_arg6 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SWAP#1 ; Less Than
IF              &_LT#1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
NEG             64         ;    NEGate
SHPIX           &_NEG#1 &_SWAP#2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg7     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   14        ;PUSH Bytes
FDEF            14         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval#1 ;   IF test
RTDG                       ;Round To Double Grid
MDRP[rp0,rnd,white] &_arg1     ;Move Direct Relative Point
RTG                        ;Round To Grid
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
ELSE                       ;ELSE clause
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_arg1     ;Move Direct Relative Point
ROLL            &_arg1 &_arg2 &_arg3 ;ROLL the top three stack elements
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM#1 &_ROLL#1 ;Greater Than
IF              &_GT#1     ;   IF test
                           #--- DUP       #&_ROLL#2 ;DUPlicate top stack element
ROLL            &_ROLL#2 &_ROLL#2 &_ROLL#3 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
MD[grid]        &_SWAP#1 &_SWAP#2 ;Measure Distance
                           #--- DUP       #&_MD#1   ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
NEQ             0 &_MD#1   ; Not EQual
IF              &_NEQ#1    ;   IF test
SHPIX           &_MD#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   15        ;PUSH Bytes
FDEF            15         ;Function DEFinition
SWAP            &_arg1 &_arg2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_SWAP#1   ;Move Direct Relative Point
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
MDAP[rnd]       &_SWAP#1   ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
SWAP            &_SWAP#1 &_SWAP#2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
IF              &_SWAP#1   ;   IF test
MPPEM                      ;Measure Pixels Per EM
GTEQ            &_MPPEM#1 &_SWAP#1 ;Greater Than or EQual
ELSE                       ;ELSE clause
POP             &_GTEQ#1   ;POP top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
EIF                        ;    End IF
IF              &_GTEQ#1   ;   IF test
ROLL            &_SWAP#2 &_arg3 &_arg4 ;ROLL the top three stack elements
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[grid]        &_ROLL#1 &_ROLL#2 ;Measure Distance
SWAP            &_MD#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_arg5 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
                           #--- DUP       #&_SWAP#1 ;DUPlicate top stack element
ROLL            &_SWAP#1 &_SWAP#1 &_SWAP#2 ;ROLL the top three stack elements
MD[grid]        &_ROLL#1 &_ROLL#2 ;Measure Distance
ROLL            &_MD#1 &_ROLL#3 &_ROLL#3 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SUB             &_SWAP#1 &_SWAP#2 ;  SUBtract
SHPIX           &_SUB#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
POP             &_arg6     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             1          ;POP top stack element
POP             &_SWAP#2   ;POP top stack element
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
POP             &_arg5     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=5:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   16        ;PUSH Bytes
FDEF            16         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,min,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_arg1 &_arg2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   17        ;PUSH Bytes
FDEF            17         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDRP[rp0,white] &_arg1     ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_arg1 &_arg2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   18        ;PUSH Bytes
FDEF            18         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
MDAP[rnd]       &_arg1     ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval#1 ;logical NOT
IF              &_NOT#1    ;   IF test
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
GC[orig]        &_arg1     ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_arg1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SUB             &_GC#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
ROLL            &_ROUND#1 &_arg1 &_arg2 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
GC[orig]        &_ROLL#1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_ROLL#1 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP#1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC#1 &_SWAP#2 ;SWAP the top two elements on the stack
SUB             &_SWAP#1 &_SWAP#2 ;  SUBtract
ROUND[White]    &_SUB#1    ;ROUND value
ADD             &_ROUND#1 &_ROLL#2 ;       ADD
                           #--- DUP       #&_ADD#1  ;DUPlicate top stack element
IF              &_ADD#1    ;   IF test
                           #--- DUP       #&_ADD#1  ;DUPlicate top stack element
ABS             &_ADD#1    ;ABSolute value
DIV             &_ABS#1 &_ADD#1 ;    DIVide
SHPIX           &_DIV#1 &_ROLL#3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg3     ;POP top stack element
POP             &_arg4     ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg2     ;POP top stack element
POP             &_arg3     ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   19        ;PUSH Bytes
FDEF            19         ;Function DEFinition
                           #--- DUP       #&_arg1   ;DUPlicate top stack element
ROLL            &_arg1 &_arg1 &_arg2 ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL#1 &_ROLL#2 ;Set Dual Projection Vector To Line
                           #--- DUP       #&_ROLL#3 ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX#1 &_ROLL#3 ;Measure Distance
ABS             &_MD#1     ;ABSolute value
SWAP            &_ABS#1 &_ROLL#3 ;SWAP the top two elements on the stack
ROLL            &_SWAP#1 &_SWAP#2 &_ROLL#3 ;ROLL the top three stack elements
SPVTL[orthog]   &_ROLL#1 &_ROLL#2 ;Set Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
LT              32 &_ROLL#3 ; Less Than
IF              &_LT#1     ;   IF test
ALIGNRP         &_arg3     ;ALIGN to Reference Point
ELSE                       ;ELSE clause
MDRP[grey]      &_arg3     ;Move Direct Relative Point
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------
"""



pseudo_code_dict = {
    'A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 7 26    ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_5   6 34 12 24 13 ;PUSH Bytes
CALL            13 24 12 34 6 ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_5   10 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 10 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   28 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 28 ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   10 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_5   6 7 18 21 34 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              34 21 18 7 6 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   4 5 25 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 25 5 4  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'AEacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 8 10   ;PUSH Bytes
CALL            10 8 19    ;CALL function
                           #--- PUSHB_4   64 19 24 9 ;PUSH Bytes
CALL            9 24 19 64 ;CALL function
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_5   14 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 14 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 30 10   ;PUSH Bytes
CALL            10 30 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 15 10  ;PUSH Bytes
CALL            10 15 12   ;CALL function
                           #--- PUSHB_4   64 12 18 9 ;PUSH Bytes
CALL            9 18 12 64 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 27 10   ;PUSH Bytes
CALL            10 27 6    ;CALL function
                           #--- PUSHB_4   64 6 8 9  ;PUSH Bytes
CALL            9 8 6 64   ;CALL function
                           #--- PUSHB_4   0 6 33 9  ;PUSH Bytes
CALL            9 33 6 0   ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   6 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   10 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_2   16 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Acyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_5   1 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 1 ;CALL function
                           #--- PUSHB_5   5 30 13 24 13 ;PUSH Bytes
CALL            13 24 13 30 5 ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   17 31 10  ;PUSH Bytes
CALL            10 31 17   ;CALL function
                           #--- PUSHB_4   64 17 21 9 ;PUSH Bytes
CALL            9 21 17 64 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Alphatonos': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_5   1 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 1 ;CALL function
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_5   1 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 11 ;CALL function
                           #--- PUSHB_5   11 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 11 ;CALL function
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_5   23 36 22 10 13 ;PUSH Bytes
CALL            13 10 22 36 23 ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   3 37 10   ;PUSH Bytes
CALL            10 37 3    ;CALL function
                           #--- PUSHB_4   64 3 7 9  ;PUSH Bytes
CALL            9 7 3 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
                           #--- DUP       #32       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   32 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 5 9   ;PUSH Bytes
CALL            9 5 0 0    ;CALL function
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_5   29 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 29 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   32 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_3   0 11 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              11         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_3   3 21 5    ;PUSH Bytes
IP              5          ;Interpolate Point
IP              21         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Cacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_5   12 7 0 19 13 ;PUSH Bytes
CALL            13 19 0 7 12 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_3   35 5 10   ;PUSH Bytes
CALL            10 5 35    ;CALL function
                           #--- PUSHB_4   64 35 31 9 ;PUSH Bytes
CALL            9 31 35 64 ;CALL function
                           #--- PUSHB_3   5 35 10   ;PUSH Bytes
CALL            10 35 5    ;CALL function
                           #--- PUSHB_4   64 5 2 9  ;PUSH Bytes
CALL            9 2 5 64   ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ccedilla': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   37 2 0    ;PUSH Bytes
CALL            0 2 37     ;CALL function
                           #--- PUSHB_2   55 4      ;PUSH Bytes
MIRP[min,black] stemt 55   ;Move Indirect Relative Point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_5   48 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 48 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_5   20 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 20 ;CALL function
                           #--- PUSHB_3   20 11 10  ;PUSH Bytes
CALL            10 11 20   ;CALL function
                           #--- PUSHB_4   0 20 17 9 ;PUSH Bytes
CALL            9 17 20 0  ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   62 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 62 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_5   8 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 8 ;CALL function
                           #--- PUSHB_3   8 22 10   ;PUSH Bytes
CALL            10 22 8    ;CALL function
                           #--- PUSHB_4   64 8 0 9  ;PUSH Bytes
CALL            9 0 8 64   ;CALL function
                           #--- PUSHB_3   22 8 10   ;PUSH Bytes
CALL            10 8 22    ;CALL function
                           #--- PUSHB_4   0 22 14 9 ;PUSH Bytes
CALL            9 14 22 0  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   22 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_6   6 26 27 37 55 62 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              62 55 37 27 26 6 ;Interpolate Point
                           #--- PUSHB_2   46 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_3   40 65 67  ;PUSH Bytes
IP              67         ;Interpolate Point
IP              65         ;Interpolate Point
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_3   5 6 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              6          ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   0 67      ;PUSH Bytes
IP              67         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   42 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Cheabkhasiancyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   12 5      ;PUSH Bytes
MIRP[min,black] cvt_5 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   59 2 0    ;PUSH Bytes
CALL            0 2 59     ;CALL function
                           #--- PUSHB_2   4 5       ;PUSH Bytes
MIRP[min,black] cvt_5 4    ;Move Indirect Relative Point
                           #--- PUSHB_5   33 52 29 59 13 ;PUSH Bytes
CALL            13 59 29 52 33 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   33 5      ;PUSH Bytes
MIRP[min,black] cvt_5 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_5   39 46 29 59 13 ;PUSH Bytes
CALL            13 59 29 46 39 ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_5   49 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 49 ;CALL function
                           #--- PUSHB_3   49 36 10  ;PUSH Bytes
CALL            10 36 49   ;CALL function
                           #--- PUSHB_4   0 49 43 9 ;PUSH Bytes
CALL            9 43 49 0  ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   9 32 10   ;PUSH Bytes
CALL            10 32 9    ;CALL function
                           #--- PUSHB_4   64 9 7 9  ;PUSH Bytes
CALL            9 7 9 64   ;CALL function
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   19 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_2   46 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Checyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   17 2 0    ;PUSH Bytes
CALL            0 2 17     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 28 38  ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   6 25 44 17 13 ;PUSH Bytes
CALL            13 17 44 25 6 ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 12 15 14 ;PUSH Bytes
CALL            14 15 12 9 ;CALL function
                           #--- PUSHB_5   20 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 20 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_4   8 39 42 14 ;PUSH Bytes
CALL            14 42 39 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_5   42 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 42 ;CALL function
                           #--- PUSHB_5   36 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 36 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   1 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   6 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Chedescenderabkhasiancyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   76 2 0    ;PUSH Bytes
CALL            0 2 76     ;CALL function
                           #--- PUSHB_2   86 5      ;PUSH Bytes
MIRP[min,black] cvt_5 86   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 29 ;CALL function
                           #--- PUSHB_3   29 38 10  ;PUSH Bytes
CALL            10 38 29   ;CALL function
                           #--- PUSHB_4   0 29 32 9 ;PUSH Bytes
CALL            9 32 29 0  ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   5 4 0 14 4 ;PUSH Bytes
CALL            4 14 0 4 5 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_2   69 5      ;PUSH Bytes
MIRP[min,black] cvt_5 69   ;Move Indirect Relative Point
                           #--- PUSHB_1   82        ;PUSH Bytes
SHP[rp2]        82         ;SHift Point using reference point
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_2   56 4      ;PUSH Bytes
MIRP[min,black] stemt 56   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   89        ;PUSH Bytes
MDAP[rnd]       89         ;Move Direct Absolute Point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDRP[rp0,rnd,white] 53         ;Move Direct Relative Point
                           #--- PUSHB_5   66 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 66 ;CALL function
                           #--- PUSHB_3   66 53 10  ;PUSH Bytes
CALL            10 53 66   ;CALL function
                           #--- PUSHB_4   0 66 60 9 ;PUSH Bytes
CALL            9 60 66 0  ;CALL function
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP0            66         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_1   70        ;PUSH Bytes
SHP[rp2]        70         ;SHift Point using reference point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   82        ;PUSH Bytes
SHP[rp2]        82         ;SHift Point using reference point
                           #--- PUSHB_3   2 49 10   ;PUSH Bytes
CALL            10 49 2    ;CALL function
                           #--- PUSHB_4   64 2 0 9  ;PUSH Bytes
CALL            9 0 2 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   27 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 27 ;CALL function
                           #--- PUSHB_3   27 41 10  ;PUSH Bytes
CALL            10 41 27   ;CALL function
                           #--- PUSHB_4   0 27 35 9 ;PUSH Bytes
CALL            9 35 27 0  ;CALL function
                           #--- PUSHB_2   90 1      ;PUSH Bytes
CALL            1 90       ;CALL function
                           #--- PUSHB_2   27 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   22 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_2   12 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   63 69     ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 25 10   ;PUSH Bytes
CALL            10 25 5    ;CALL function
                           #--- PUSHB_4   64 5 2 9  ;PUSH Bytes
CALL            9 2 5 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Decyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   5 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   15 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 15 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 30      ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 32 10  ;PUSH Bytes
CALL            10 32 21   ;CALL function
                           #--- PUSHB_4   64 21 24 9 ;PUSH Bytes
CALL            9 24 21 64 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 29 10   ;PUSH Bytes
CALL            10 29 5    ;CALL function
                           #--- PUSHB_4   64 5 2 9  ;PUSH Bytes
CALL            9 2 5 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   32 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Delta.math': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 2 0     ;PUSH Bytes
CALL            0 2 1      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Dzecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 0 0    ;PUSH Bytes
CALL            0 0 25     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   19 48     ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   35 25 10  ;PUSH Bytes
CALL            10 25 35   ;CALL function
                           #--- PUSHB_4   64 35 30 9 ;PUSH Bytes
CALL            9 30 35 64 ;CALL function
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_2   5 21      ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   47 6 25 0 13 ;PUSH Bytes
CALL            13 0 25 6 47 ;CALL function
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 23 10  ;PUSH Bytes
CALL            10 23 38   ;CALL function
                           #--- PUSHB_4   64 38 41 9 ;PUSH Bytes
CALL            9 41 38 64 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   48 20 10  ;PUSH Bytes
CALL            10 20 48   ;CALL function
                           #--- PUSHB_4   64 48 3 9 ;PUSH Bytes
CALL            9 3 48 64  ;CALL function
                           #--- PUSHB_3   20 48 10  ;PUSH Bytes
CALL            10 48 20   ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   38 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_5   1 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 1 ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_5   19 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 19 ;CALL function
                           #--- PUSHB_5   23 36 4 15 13 ;PUSH Bytes
CALL            13 15 4 36 23 ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 36 32 14 ;PUSH Bytes
CALL            14 32 36 9 ;CALL function
                           #--- PUSHB_5   27 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 27 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   8 37 10   ;PUSH Bytes
CALL            10 37 8    ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
                           #--- DUP       #20       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ecaron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 11 15   ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   36 2 0    ;PUSH Bytes
CALL            0 2 36     ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   40 44 55  ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_5   14 42 20 36 13 ;PUSH Bytes
CALL            13 36 20 42 14 ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_5   29 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   9 26 33 14 ;PUSH Bytes
CALL            14 33 26 9 ;CALL function
                           #--- PUSHB_5   39 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 39 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_5   22 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
                           #--- PUSHB_3   3 12 10   ;PUSH Bytes
CALL            10 12 3    ;CALL function
                           #--- PUSHB_4   64 3 0 9  ;PUSH Bytes
CALL            9 0 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   8 3 6 14  ;PUSH Bytes
CALL            14 6 3 8   ;CALL function
                           #--- PUSHB_5   10 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 10 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_5   6 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 6  ;CALL function
                           #--- PUSHB_5   53 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 53 ;CALL function
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   2 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_2   0 30      ;PUSH Bytes
IP              30         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Efcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_2   46 4      ;PUSH Bytes
MIRP[min,black] stemt 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   71 2 0    ;PUSH Bytes
CALL            0 2 71     ;CALL function
                           #--- PUSHB_2   66 4      ;PUSH Bytes
MIRP[min,black] stemt 66   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_5   48 86 41 71 13 ;PUSH Bytes
CALL            13 71 41 86 48 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_2   48 4      ;PUSH Bytes
MIRP[min,black] stemt 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_5   62 76 41 71 13 ;PUSH Bytes
CALL            13 71 41 76 62 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   62 4      ;PUSH Bytes
MIRP[min,black] stemt 62   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   88        ;PUSH Bytes
MDAP[rnd]       88         ;Move Direct Absolute Point
                           #--- PUSHB_1   56        ;PUSH Bytes
MDRP[rp0,rnd,white] 56         ;Move Direct Relative Point
                           #--- PUSHB_2   81 6      ;PUSH Bytes
MIRP[min,black] stemw 81   ;Move Indirect Relative Point
                           #--- PUSHB_1   81        ;PUSH Bytes
SRP0            81         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   64 75     ;PUSH Bytes
SHP[rp2]        75         ;SHift Point using reference point
SHP[rp2]        64         ;SHift Point using reference point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 16      ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   34 47 10  ;PUSH Bytes
CALL            10 47 34   ;CALL function
                           #--- PUSHB_4   64 34 38 9 ;PUSH Bytes
CALL            9 38 34 64 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   47 34 10  ;PUSH Bytes
CALL            10 34 47   ;CALL function
                           #--- PUSHB_4   64 47 43 9 ;PUSH Bytes
CALL            9 43 47 64 ;CALL function
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp2]        68         ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_2   89 1      ;PUSH Bytes
CALL            1 89       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   86 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            86         ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
                           #--- PUSHB_2   25 56     ;PUSH Bytes
IP              56         ;Interpolate Point
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Egrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_5   12 7 0 19 13 ;PUSH Bytes
CALL            13 19 0 7 12 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_3   35 5 10   ;PUSH Bytes
CALL            10 5 35    ;CALL function
                           #--- PUSHB_4   64 35 31 9 ;PUSH Bytes
CALL            9 31 35 64 ;CALL function
                           #--- PUSHB_3   5 35 10   ;PUSH Bytes
CALL            10 35 5    ;CALL function
                           #--- PUSHB_4   64 5 2 9  ;PUSH Bytes
CALL            9 2 5 64   ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Elcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 29     ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   5 36 10   ;PUSH Bytes
CALL            10 36 5    ;CALL function
                           #--- PUSHB_4   0 5 0 9   ;PUSH Bytes
CALL            9 0 5 0    ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   20 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 33 10   ;PUSH Bytes
CALL            10 33 8    ;CALL function
                           #--- PUSHB_4   64 8 12 9 ;PUSH Bytes
CALL            9 12 8 64  ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 30 10  ;PUSH Bytes
CALL            10 30 21   ;CALL function
                           #--- PUSHB_4   64 21 18 9 ;PUSH Bytes
CALL            9 18 21 64 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_4   8 21 24 14 ;PUSH Bytes
CALL            14 24 21 8 ;CALL function
                           #--- PUSHB_5   28 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_5   24 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 24 ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   8 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Emacron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_3   19 16 10  ;PUSH Bytes
CALL            10 16 19   ;CALL function
                           #--- PUSHB_4   64 19 53 9 ;PUSH Bytes
CALL            9 53 19 64 ;CALL function
                           #--- PUSHB_3   55 0 0    ;PUSH Bytes
CALL            0 0 55     ;CALL function
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_5   31 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 31 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
                           #--- PUSHB_5   35 48 16 27 13 ;PUSH Bytes
CALL            13 27 16 48 35 ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 48 44 14 ;PUSH Bytes
CALL            14 44 48 9 ;CALL function
                           #--- PUSHB_5   39 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 39 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   49 6      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   20 49 10  ;PUSH Bytes
CALL            10 49 20   ;CALL function
                           #--- PUSHB_4   64 20 24 9 ;PUSH Bytes
CALL            9 24 20 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_4   12 42 46 8 ;PUSH Bytes
CALL            8 46 42 12 ;CALL function
                           #--- PUSHB_5   58 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 58 ;CALL function
                           #--- PUSHB_3   58 12 10  ;PUSH Bytes
CALL            10 12 58   ;CALL function
                           #--- PUSHB_4   0 58 6 9  ;PUSH Bytes
CALL            9 6 58 0   ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   54 6      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
                           #--- DUP       #32       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   12 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   39 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              39         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Emcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 29    ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 6 10   ;PUSH Bytes
CALL            10 6 17    ;CALL function
                           #--- PUSHB_4   64 17 20 9 ;PUSH Bytes
CALL            9 20 17 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_4   8 17 13 14 ;PUSH Bytes
CALL            14 13 17 8 ;CALL function
                           #--- PUSHB_5   9 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 9  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 3 10   ;PUSH Bytes
CALL            10 3 29    ;CALL function
                           #--- PUSHB_4   64 29 26 9 ;PUSH Bytes
CALL            9 26 29 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_4   8 29 32 14 ;PUSH Bytes
CALL            14 32 29 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   32 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 32 ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Epsilon': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_5   48 34 9 0 13 ;PUSH Bytes
CALL            13 0 9 34 48 ;CALL function
                           #--- PUSHB_2   48 5      ;PUSH Bytes
MIRP[min,black] cvt_5 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   48 34 10  ;PUSH Bytes
CALL            10 34 48   ;CALL function
                           #--- PUSHB_4   64 48 52 9 ;PUSH Bytes
CALL            9 52 48 64 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_3   34 48 10  ;PUSH Bytes
CALL            10 48 34   ;CALL function
                           #--- PUSHB_4   64 34 30 9 ;PUSH Bytes
CALL            9 30 34 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_5   49 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 49 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_5   41 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 41 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   46 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_4   9 15 21 0 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              0 21 15 9  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_4   6 18 24 12 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              12 24 18 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Epsilontonos': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   17 18     ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   8 9       ;PUSH Bytes
SDPVTL[orthog]  9 8        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[no-rnd]    8          ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[no-rnd]    20         ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[rp0,min,black] stemt 9    ;Move Indirect Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[no-rnd]    20         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   8 9 18 20 ;PUSH Bytes
MDAP[no-rnd]    20         ;Move Direct Absolute Point
MDAP[no-rnd]    18         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ercyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_5   29 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 29 ;CALL function
                           #--- PUSHB_4   34 29 24 8 ;PUSH Bytes
CALL            8 24 29 34 ;CALL function
                           #--- PUSHB_5   2 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 2  ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   24 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_5   6 17 20 21 32 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              32 21 20 17 6 ;Interpolate Point
                           #--- PUSHB_2   29 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   22 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_2   7 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   20 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ereversedcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 47 10   ;PUSH Bytes
CALL            10 47 5    ;CALL function
                           #--- PUSHB_4   0 5 0 9   ;PUSH Bytes
CALL            9 0 5 0    ;CALL function
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
                           #--- PUSHB_5   27 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 27 ;CALL function
                           #--- PUSHB_5   9 14 47 40 13 ;PUSH Bytes
CALL            13 40 47 14 9 ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 44 10   ;PUSH Bytes
CALL            10 44 8    ;CALL function
                           #--- PUSHB_4   64 8 11 9 ;PUSH Bytes
CALL            9 11 8 64  ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   25 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   0 37      ;PUSH Bytes
IP              37         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_3   3 40 47   ;PUSH Bytes
IP              47         ;Interpolate Point
IP              40         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Euro': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 40 10  ;PUSH Bytes
CALL            10 40 29   ;CALL function
                           #--- PUSHB_4   0 29 34 9 ;PUSH Bytes
CALL            9 34 29 0  ;CALL function
                           #--- PUSHB_3   61 2 0    ;PUSH Bytes
CALL            0 2 61     ;CALL function
                           #--- PUSHB_3   57 2 0    ;PUSH Bytes
CALL            0 2 57     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_5   44 47 40 57 13 ;PUSH Bytes
CALL            13 57 40 47 44 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   44 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 44 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_5   53 50 40 57 13 ;PUSH Bytes
CALL            13 57 40 50 53 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_5   53 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 53 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDRP[rp0,rnd,white] 48         ;Move Direct Relative Point
                           #--- PUSHB_2   43 54     ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   15 26     ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   21 48 10  ;PUSH Bytes
CALL            10 48 21   ;CALL function
                           #--- PUSHB_4   64 21 18 9 ;PUSH Bytes
CALL            9 18 21 64 ;CALL function
                           #--- PUSHB_4   64 21 24 9 ;PUSH Bytes
CALL            9 24 21 64 ;CALL function
                           #--- PUSHB_3   48 21 10  ;PUSH Bytes
CALL            10 21 48   ;CALL function
                           #--- PUSHB_4   64 48 52 9 ;PUSH Bytes
CALL            9 52 48 64 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   7 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_3   29 40 57  ;PUSH Bytes
IP              57         ;Interpolate Point
IP              40         ;Interpolate Point
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_2   59 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              59         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_5   25 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 25 ;CALL function
                           #--- PUSHB_5   29 4 10 21 13 ;PUSH Bytes
CALL            13 21 10 4 29 ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_4   9 29 33 14 ;PUSH Bytes
CALL            14 33 29 9 ;CALL function
                           #--- PUSHB_5   0 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   5 14 10   ;PUSH Bytes
CALL            10 14 5    ;CALL function
                           #--- PUSHB_4   64 5 8 9  ;PUSH Bytes
CALL            9 8 5 64   ;CALL function
                           #--- PUSHB_3   14 5 10   ;PUSH Bytes
CALL            10 5 14    ;CALL function
                           #--- PUSHB_4   64 14 18 9 ;PUSH Bytes
CALL            9 18 14 64 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'G': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_5   29 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 29 ;CALL function
                           #--- PUSHB_5   51 56 8 18 13 ;PUSH Bytes
CALL            13 18 8 56 51 ;CALL function
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   45 6      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   5 49 10   ;PUSH Bytes
CALL            10 49 5    ;CALL function
                           #--- PUSHB_4   64 5 2 9  ;PUSH Bytes
CALL            9 2 5 64   ;CALL function
                           #--- PUSHB_3   49 5 10   ;PUSH Bytes
CALL            10 5 49    ;CALL function
                           #--- PUSHB_4   64 49 53 9 ;PUSH Bytes
CALL            9 53 49 64 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   49 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_3   8 39 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              39         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_2   18 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Gcaron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_2   46 4      ;PUSH Bytes
MIRP[min,black] stemt 46   ;Move Indirect Relative Point
                           #--- PUSHB_3   46 21 10  ;PUSH Bytes
CALL            10 21 46   ;CALL function
                           #--- PUSHB_4   64 46 42 9 ;PUSH Bytes
CALL            9 42 46 64 ;CALL function
                           #--- PUSHB_3   57 1 0    ;PUSH Bytes
CALL            0 1 57     ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SHP[rp1]        61         ;SHift Point using reference point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   57 1 0    ;PUSH Bytes
CALL            0 1 57     ;CALL function
                           #--- PUSHB_5   3 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 3 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 36 10  ;PUSH Bytes
CALL            10 36 27   ;CALL function
                           #--- PUSHB_4   0 27 30 9 ;PUSH Bytes
CALL            9 30 27 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 39 10  ;PUSH Bytes
CALL            10 39 24   ;CALL function
                           #--- PUSHB_4   0 24 33 9 ;PUSH Bytes
CALL            9 33 24 0  ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   24 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   42 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_6   6 21 11 44 52 57 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              57 52 44 11 21 6 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_4   0 14 3 59 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              59 3 14 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_3   14 18 52  ;PUSH Bytes
IP              52         ;Interpolate Point
IP              18         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   11 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Gjecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 18 10   ;PUSH Bytes
CALL            10 18 6    ;CALL function
                           #--- PUSHB_4   0 6 12 9  ;PUSH Bytes
CALL            9 12 6 0   ;CALL function
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_2   45 4      ;PUSH Bytes
MIRP[min,black] stemt 45   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_5   38 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 38 ;CALL function
                           #--- PUSHB_5   3 48 18 25 13 ;PUSH Bytes
CALL            13 25 18 48 3 ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   3 21 10   ;PUSH Bytes
CALL            10 21 3    ;CALL function
                           #--- PUSHB_4   64 3 0 9  ;PUSH Bytes
CALL            9 0 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   41 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   6 18 25   ;PUSH Bytes
IP              25         ;Interpolate Point
IP              18         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_3   10 28 12  ;PUSH Bytes
IP              12         ;Interpolate Point
IP              28         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'H': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 43    ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 31 42  ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_5   5 29 11 23 13 ;PUSH Bytes
CALL            13 23 11 29 5 ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_4   9 17 20 14 ;PUSH Bytes
CALL            14 20 17 9 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   8 43 46 14 ;PUSH Bytes
CALL            14 46 43 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   46 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 46 ;CALL function
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'H18533': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'H18543': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 1  ;CALL function
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'H18551': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   7 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 7 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'H22073': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   7 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 7 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Hardsigncyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_5   0 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 0  ;CALL function
                           #--- PUSHB_5   10 39 20 4 13 ;PUSH Bytes
CALL            13 4 20 39 10 ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   31 26 10  ;PUSH Bytes
CALL            10 26 31   ;CALL function
                           #--- PUSHB_4   64 31 7 9 ;PUSH Bytes
CALL            9 7 31 64  ;CALL function
                           #--- PUSHB_3   26 31 10  ;PUSH Bytes
CALL            10 31 26   ;CALL function
                           #--- PUSHB_4   64 26 23 9 ;PUSH Bytes
CALL            9 23 26 64 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'I': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 12 10  ;PUSH Bytes
CALL            10 12 27   ;CALL function
                           #--- PUSHB_4   64 27 3 9 ;PUSH Bytes
CALL            9 3 27 64  ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   12 27 10  ;PUSH Bytes
CALL            10 27 12   ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'IAcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   2 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_5   5 44 9 20 13 ;PUSH Bytes
CALL            13 20 9 44 5 ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 41 10  ;PUSH Bytes
CALL            10 41 17   ;CALL function
                           #--- PUSHB_4   64 17 11 9 ;PUSH Bytes
CALL            9 11 17 64 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_4   8 28 32 14 ;PUSH Bytes
CALL            14 32 28 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   32 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 32 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   41 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   44 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'IJ': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_2   46 4      ;PUSH Bytes
MIRP[min,black] stemt 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   46 41 10  ;PUSH Bytes
CALL            10 41 46   ;CALL function
                           #--- PUSHB_4   64 46 10 9 ;PUSH Bytes
CALL            9 10 46 64 ;CALL function
                           #--- PUSHB_3   54 2 0    ;PUSH Bytes
CALL            0 2 54     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   49 4      ;PUSH Bytes
MIRP[min,black] stemt 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 21 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_4   8 47 51 14 ;PUSH Bytes
CALL            14 51 47 8 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_4   7 33 30 14 ;PUSH Bytes
CALL            14 30 33 7 ;CALL function
                           #--- PUSHB_5   24 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   30 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 30 ;CALL function
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_2   20 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   17 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   38 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'IUcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   34 2 0    ;PUSH Bytes
CALL            0 2 34     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_5   7 30 3 34 13 ;PUSH Bytes
CALL            13 34 3 30 7 ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_4   9 18 15 14 ;PUSH Bytes
CALL            14 15 18 9 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   43 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   30 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_3   0 40 43   ;PUSH Bytes
IP              43         ;Interpolate Point
IP              40         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   24 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Idotaccent': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 16 10   ;PUSH Bytes
CALL            10 16 5    ;CALL function
                           #--- PUSHB_4   64 5 8 9  ;PUSH Bytes
CALL            9 8 5 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_3   0 5 10    ;PUSH Bytes
CALL            10 5 0     ;CALL function
                           #--- PUSHB_4   64 0 12 9 ;PUSH Bytes
CALL            9 12 0 64  ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Iecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   19 29     ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 24 35  ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   50 2 0    ;PUSH Bytes
CALL            0 2 50     ;CALL function
                           #--- PUSHB_2   8 62      ;PUSH Bytes
SHP[rp1]        62         ;SHift Point using reference point
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 12 57   ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_5   53 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 53 ;CALL function
                           #--- PUSHB_4   39 53 49 8 ;PUSH Bytes
CALL            8 49 53 39 ;CALL function
                           #--- PUSHB_5   44 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 39 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp2]        56         ;SHift Point using reference point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_4   9 35 32 14 ;PUSH Bytes
CALL            14 32 35 9 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp1]        59         ;SHift Point using reference point
                           #--- PUSHB_5   27 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 27 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   11 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 11 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_4   20 11 6 8 ;PUSH Bytes
CALL            8 6 11 20  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 15 ;CALL function
                           #--- PUSHB_3   15 20 10  ;PUSH Bytes
CALL            10 20 15   ;CALL function
                           #--- PUSHB_4   0 15 18 9 ;PUSH Bytes
CALL            9 18 15 0  ;CALL function
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_4   3 23 36 56 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              56 36 23 3 ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_2   4 55      ;PUSH Bytes
IP              55         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ifraktur': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   9 5       ;PUSH Bytes
MIRP[min,black] cvt_5 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   9 20 10   ;PUSH Bytes
CALL            10 20 9    ;CALL function
                           #--- PUSHB_4   64 9 14 9 ;PUSH Bytes
CALL            9 14 9 64  ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
                           #--- DUP       #3        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 3 10   ;PUSH Bytes
CALL            10 3 35    ;CALL function
                           #--- PUSHB_4   64 35 24 9 ;PUSH Bytes
CALL            9 24 35 64 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   6 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   0 9 38 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 38 9 0  ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   32 35 40 43 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 40 35 32 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Iicyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 43    ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 31 42  ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_4   9 17 20 14 ;PUSH Bytes
CALL            14 20 17 9 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   8 43 46 14 ;PUSH Bytes
CALL            14 46 43 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   46 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 46 ;CALL function
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   4 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Iishortcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 46     ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
SHP[rp2]        33         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   10 21 10  ;PUSH Bytes
CALL            10 21 10   ;CALL function
                           #--- PUSHB_4   64 10 13 9 ;PUSH Bytes
CALL            9 13 10 64 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   21 10 10  ;PUSH Bytes
CALL            10 10 21   ;CALL function
                           #--- PUSHB_4   64 21 17 9 ;PUSH Bytes
CALL            9 17 21 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_5   44 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 44 ;CALL function
                           #--- PUSHB_3   44 38 10  ;PUSH Bytes
CALL            10 38 44   ;CALL function
                           #--- PUSHB_4   64 44 3 9 ;PUSH Bytes
CALL            9 3 44 64  ;CALL function
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   38 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_4   6 36 46 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 46 36 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   9 35      ;PUSH Bytes
IP              35         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Iota': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 6 25    ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 9  ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   27 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 27 ;CALL function
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   9 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   6 17 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              17         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   4 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Iotadieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 3 0     ;PUSH Bytes
CALL            0 3 8      ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_5   30 48 17 8 13 ;PUSH Bytes
CALL            13 8 17 48 30 ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_4   9 20 22 14 ;PUSH Bytes
CALL            14 22 20 9 ;CALL function
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   22 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 22 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_4   10 14 43 8 ;PUSH Bytes
CALL            8 43 14 10 ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 10 10  ;PUSH Bytes
CALL            10 10 32   ;CALL function
                           #--- PUSHB_4   64 32 27 9 ;PUSH Bytes
CALL            9 27 32 64 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   32 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_5   8 17 30 35 48 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              48 35 30 17 8 ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_2   12 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   14 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Itilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 37 10  ;PUSH Bytes
CALL            10 37 22   ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_1   46        ;PUSH Bytes
                           #--- DUP       #46       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_5   12 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   46 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 46 ;CALL function
                           #--- PUSHB_3   46 12 10  ;PUSH Bytes
CALL            10 12 46   ;CALL function
                           #--- PUSHB_4   0 46 6 9  ;PUSH Bytes
CALL            9 6 46 0   ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   12 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'J': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 7 10   ;PUSH Bytes
CALL            10 7 18    ;CALL function
                           #--- PUSHB_4   0 18 12 9 ;PUSH Bytes
CALL            9 12 18 0  ;CALL function
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 23 10   ;PUSH Bytes
CALL            10 23 4    ;CALL function
                           #--- PUSHB_4   64 4 1 9  ;PUSH Bytes
CALL            9 1 4 64   ;CALL function
                           #--- PUSHB_3   23 4 10   ;PUSH Bytes
CALL            10 4 23    ;CALL function
                           #--- PUSHB_4   64 23 27 9 ;PUSH Bytes
CALL            9 27 23 64 ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   23 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Jcircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_5   22 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 22 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   8 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'K': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   16 26     ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_2   2 13      ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   26 35 10  ;PUSH Bytes
CALL            10 35 26   ;CALL function
                           #--- PUSHB_4   64 26 29 9 ;PUSH Bytes
CALL            9 29 26 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   35 26 10  ;PUSH Bytes
CALL            10 26 35   ;CALL function
                           #--- PUSHB_4   64 35 33 9 ;PUSH Bytes
CALL            9 33 35 64 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_5   12 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 12 ;CALL function
                           #--- PUSHB_3   12 7 10   ;PUSH Bytes
CALL            10 7 12    ;CALL function
                           #--- PUSHB_4   64 12 19 9 ;PUSH Bytes
CALL            9 19 12 64 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   7 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   14 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_4   5 13 16 21 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              21 16 13 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   4 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Khacyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   19 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_5   1 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 1  ;CALL function
                           #--- PUSHB_3   13 2 0    ;PUSH Bytes
CALL            0 2 13     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 21 31  ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 19 10   ;PUSH Bytes
CALL            10 19 8    ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_4   8 8 12 14 ;PUSH Bytes
CALL            14 12 8 8  ;CALL function
                           #--- PUSHB_5   16 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 16 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_4   8 33 30 14 ;PUSH Bytes
CALL            14 30 33 8 ;CALL function
                           #--- PUSHB_5   25 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   30 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 30 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   2 11      ;PUSH Bytes
CALL            11 2       ;CALL function
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Kjecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 50     ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 35 49  ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 33 10  ;PUSH Bytes
CALL            10 33 21   ;CALL function
                           #--- PUSHB_4   64 21 18 9 ;PUSH Bytes
CALL            9 18 21 64 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_4   8 21 25 14 ;PUSH Bytes
CALL            14 25 21 8 ;CALL function
                           #--- PUSHB_5   30 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 30 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   5 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 5 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   50 6      ;PUSH Bytes
MIRP[min,black] stemw 50   ;Move Indirect Relative Point
                           #--- PUSHB_3   50 34 10  ;PUSH Bytes
CALL            10 34 50   ;CALL function
                           #--- PUSHB_4   64 50 0 9 ;PUSH Bytes
CALL            9 0 50 64  ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_4   8 50 45 14 ;PUSH Bytes
CALL            14 45 50 8 ;CALL function
                           #--- PUSHB_5   40 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_5   45 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 45 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   12 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   10 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_2   40 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_2   34 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   3 7       ;PUSH Bytes
IP              7          ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'L': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_5   0 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 0  ;CALL function
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 11 10  ;PUSH Bytes
CALL            10 11 24   ;CALL function
                           #--- PUSHB_4   64 24 21 9 ;PUSH Bytes
CALL            9 21 24 64 ;CALL function
                           #--- PUSHB_3   11 24 10  ;PUSH Bytes
CALL            10 24 11   ;CALL function
                           #--- PUSHB_4   64 11 7 9 ;PUSH Bytes
CALL            9 7 11 64  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Lacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_5   20 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 20 ;CALL function
                           #--- PUSHB_3   48 2 0    ;PUSH Bytes
CALL            0 2 48     ;CALL function
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   15 30 10  ;PUSH Bytes
CALL            10 30 15   ;CALL function
                           #--- PUSHB_4   64 15 10 9 ;PUSH Bytes
CALL            9 10 15 64 ;CALL function
                           #--- PUSHB_4   64 15 1 9 ;PUSH Bytes
CALL            9 1 15 64  ;CALL function
                           #--- PUSHB_3   30 15 10  ;PUSH Bytes
CALL            10 15 30   ;CALL function
                           #--- PUSHB_4   64 30 26 9 ;PUSH Bytes
CALL            9 26 30 64 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_4   64 30 37 9 ;PUSH Bytes
CALL            9 37 30 64 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   14 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_4   4 7 10 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 10 7 4  ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'M': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 9 36    ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   31 2 0    ;PUSH Bytes
CALL            0 2 31     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 9 10   ;PUSH Bytes
CALL            10 9 19    ;CALL function
                           #--- PUSHB_4   64 19 22 9 ;PUSH Bytes
CALL            9 22 19 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_4   8 19 18 14 ;PUSH Bytes
CALL            14 18 19 8 ;CALL function
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 4 10   ;PUSH Bytes
CALL            10 4 36    ;CALL function
                           #--- PUSHB_4   64 36 33 9 ;PUSH Bytes
CALL            9 33 36 64 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_4   8 36 38 14 ;PUSH Bytes
CALL            14 38 36 8 ;CALL function
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   38 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 38 ;CALL function
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   9 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   6 7 29    ;PUSH Bytes
IP              29         ;Interpolate Point
IP              7          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   5 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Mu': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_5   12 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 12 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   53 2 0    ;PUSH Bytes
CALL            0 2 53     ;CALL function
                           #--- PUSHB_2   46 4      ;PUSH Bytes
MIRP[min,black] stemt 46   ;Move Indirect Relative Point
                           #--- PUSHB_3   53 2 0    ;PUSH Bytes
CALL            0 2 53     ;CALL function
                           #--- PUSHB_5   50 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 50 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_5   22 36 8 53 13 ;PUSH Bytes
CALL            13 53 8 36 22 ;CALL function
                           #--- PUSHB_2   22 5      ;PUSH Bytes
MIRP[min,black] cvt_5 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 22 10  ;PUSH Bytes
CALL            10 22 36   ;CALL function
                           #--- PUSHB_4   64 36 40 9 ;PUSH Bytes
CALL            9 40 36 64 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   22 36 10  ;PUSH Bytes
CALL            10 36 22   ;CALL function
                           #--- PUSHB_4   64 22 19 9 ;PUSH Bytes
CALL            9 19 22 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
MDRP[rp0,rnd,white] 52         ;Move Direct Relative Point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
                           #--- DUP       #9        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   37 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 37 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_5   30 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   60        ;PUSH Bytes
                           #--- DUP       #60       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 60         ;Move Direct Relative Point
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   15 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   12 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   55 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_2   4 58      ;PUSH Bytes
IP              58         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'N': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 27      ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 7 10   ;PUSH Bytes
CALL            10 7 17    ;CALL function
                           #--- PUSHB_4   64 17 21 9 ;PUSH Bytes
CALL            9 21 17 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_4   8 17 16 14 ;PUSH Bytes
CALL            14 16 17 8 ;CALL function
                           #--- PUSHB_5   11 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 11 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   8 4 2 14  ;PUSH Bytes
CALL            14 2 4 8   ;CALL function
                           #--- PUSHB_5   30 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   2 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 2  ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   7 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_2   4 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   6 26      ;PUSH Bytes
IP              26         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Nacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   26 2 0    ;PUSH Bytes
CALL            0 2 26     ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   29 39     ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 43 10   ;PUSH Bytes
CALL            10 43 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 9 10   ;PUSH Bytes
CALL            10 9 19    ;CALL function
                           #--- PUSHB_4   64 19 23 9 ;PUSH Bytes
CALL            9 23 19 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_4   8 19 18 14 ;PUSH Bytes
CALL            14 18 19 8 ;CALL function
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 40 10   ;PUSH Bytes
CALL            10 40 6    ;CALL function
                           #--- PUSHB_4   0 6 46 9  ;PUSH Bytes
CALL            9 46 6 0   ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_4   8 40 38 14 ;PUSH Bytes
CALL            14 38 40 8 ;CALL function
                           #--- PUSHB_5   32 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_5   38 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 38 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   9 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_2   8 28      ;PUSH Bytes
IP              28         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Njecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 34 58  ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 48 52   ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SHP[rp2]        48         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_5   21 50 28 2 13 ;PUSH Bytes
CALL            13 2 28 50 21 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_4   9 35 31 14 ;PUSH Bytes
CALL            14 31 35 9 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_2   58 6      ;PUSH Bytes
MIRP[min,black] stemw 58   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_4   9 58 5 14 ;PUSH Bytes
CALL            14 5 58 9  ;CALL function
                           #--- PUSHB_5   1 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   5 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 5  ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ntilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_3   21 3 0    ;PUSH Bytes
CALL            0 3 21     ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   45 4      ;PUSH Bytes
MIRP[min,black] stemt 45   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   48 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   4 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_6   0 17 32 15 35 43 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              43 35 15 32 17 0 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   21 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              21         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_6   10 27 29 12 34 42 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              42 34 12 29 27 10 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'O': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   24 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   9 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   6 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ohorn': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 9 10   ;PUSH Bytes
CALL            10 9 19    ;CALL function
                           #--- PUSHB_4   64 19 15 9 ;PUSH Bytes
CALL            9 15 19 64 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   9 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   22 28 30 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 30 28 22 ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_3   12 17 33  ;PUSH Bytes
IP              33         ;Interpolate Point
IP              17         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   17 19 25  ;PUSH Bytes
IP              25         ;Interpolate Point
IP              19         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   15 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Omacron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_5   11 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 11 ;CALL function
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_5   25 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 25 ;CALL function
                           #--- PUSHB_4   32 21 25 8 ;PUSH Bytes
CALL            8 25 21 32 ;CALL function
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_1   14        ;PUSH Bytes
                           #--- DUP       #14       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   23 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_5   6 5 29 30 41 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              41 30 29 5 6 ;Interpolate Point
                           #--- PUSHB_2   36 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Omega': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_5   38 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 38 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   48 4      ;PUSH Bytes
MIRP[min,black] stemt 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_5   45 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 45 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 3 10   ;PUSH Bytes
CALL            10 3 35    ;CALL function
                           #--- PUSHB_4   64 35 40 9 ;PUSH Bytes
CALL            9 40 35 64 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_1   42        ;PUSH Bytes
                           #--- DUP       #42       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 11 10  ;PUSH Bytes
CALL            10 11 29   ;CALL function
                           #--- PUSHB_4   64 29 24 9 ;PUSH Bytes
CALL            9 24 29 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_1   16        ;PUSH Bytes
                           #--- DUP       #16       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   48 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_2   29 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_4   14 15 0 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 0 15 14 ;Interpolate Point
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   14 0      ;PUSH Bytes
IP              0          ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   33 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   11 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Omicron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 29    ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 6 10   ;PUSH Bytes
CALL            10 6 17    ;CALL function
                           #--- PUSHB_4   64 17 20 9 ;PUSH Bytes
CALL            9 20 17 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_4   8 17 13 14 ;PUSH Bytes
CALL            14 13 17 8 ;CALL function
                           #--- PUSHB_5   9 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 9  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 3 10   ;PUSH Bytes
CALL            10 3 29    ;CALL function
                           #--- PUSHB_4   64 29 26 9 ;PUSH Bytes
CALL            9 26 29 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_4   8 29 32 14 ;PUSH Bytes
CALL            14 32 29 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   32 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 32 ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'P': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_5   7 29 13 24 13 ;PUSH Bytes
CALL            13 24 13 29 7 ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   8 17 10   ;PUSH Bytes
CALL            10 17 8    ;CALL function
                           #--- PUSHB_4   64 8 11 9 ;PUSH Bytes
CALL            9 11 8 64  ;CALL function
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   64 17 21 9 ;PUSH Bytes
CALL            9 21 17 64 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Psicyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   52 54     ;PUSH Bytes
SHP[rp1]        54         ;SHift Point using reference point
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 43    ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   11 16 10  ;PUSH Bytes
CALL            10 16 11   ;CALL function
                           #--- PUSHB_4   64 11 50 9 ;PUSH Bytes
CALL            9 50 11 64 ;CALL function
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 31 42  ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_5   60 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 60 ;CALL function
                           #--- PUSHB_3   60 70 10  ;PUSH Bytes
CALL            10 70 60   ;CALL function
                           #--- PUSHB_4   0 60 55 9 ;PUSH Bytes
CALL            9 55 60 0  ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp2]        65         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_4   9 17 20 14 ;PUSH Bytes
CALL            14 20 17 9 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   9 43 40 14 ;PUSH Bytes
CALL            14 40 43 9 ;CALL function
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_4   51 43 3 8 ;PUSH Bytes
CALL            8 3 43 51  ;CALL function
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_2   6 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   58 72     ;PUSH Bytes
IP              72         ;Interpolate Point
IP              58         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   70        ;PUSH Bytes
IP              70         ;Interpolate Point
                           #--- PUSHB_2   3 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   60 63     ;PUSH Bytes
IP              63         ;Interpolate Point
IP              60         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_2   65 67     ;PUSH Bytes
IP              67         ;Interpolate Point
IP              65         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   4 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Q': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   49 5      ;PUSH Bytes
MIRP[min,black] cvt_5 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   41 2 0    ;PUSH Bytes
CALL            0 2 41     ;CALL function
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_1   8         ;PUSH Bytes
                           #--- DUP       #8        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   23 5      ;PUSH Bytes
MIRP[min,black] cvt_5 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   46 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_7   3 11 20 26 32 41 6 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              6 41 32 26 20 11 3 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   17 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   49 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_2   0 38      ;PUSH Bytes
IP              38         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'R': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   8 32      ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_5   7 34 13 24 13 ;PUSH Bytes
CALL            13 24 13 34 7 ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_4   8 17 15 14 ;PUSH Bytes
CALL            14 15 17 8 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   11 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 11 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 38 10  ;PUSH Bytes
CALL            10 38 28   ;CALL function
                           #--- PUSHB_4   64 28 1 9 ;PUSH Bytes
CALL            9 1 28 64  ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   11 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Racute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 0 0    ;PUSH Bytes
CALL            0 0 50     ;CALL function
                           #--- PUSHB_5   56 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 56 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
                           #--- DUP       #43       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 43         ;Move Direct Relative Point
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_5   64 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 64 ;CALL function
                           #--- PUSHB_3   25 0 0    ;PUSH Bytes
CALL            0 0 25     ;CALL function
                           #--- PUSHB_3   46 0 0    ;PUSH Bytes
CALL            0 0 46     ;CALL function
                           #--- PUSHB_3   78 2 0    ;PUSH Bytes
CALL            0 2 78     ;CALL function
                           #--- PUSHB_1   83        ;PUSH Bytes
SHP[rp1]        83         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 78 10  ;PUSH Bytes
CALL            10 78 14   ;CALL function
                           #--- PUSHB_4   64 14 2 9 ;PUSH Bytes
CALL            9 2 14 64  ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 39 ;CALL function
                           #--- PUSHB_3   39 30 10  ;PUSH Bytes
CALL            10 30 39   ;CALL function
                           #--- PUSHB_4   0 39 36 9 ;PUSH Bytes
CALL            9 36 39 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   87        ;PUSH Bytes
MDAP[rnd]       87         ;Move Direct Absolute Point
                           #--- PUSHB_1   75        ;PUSH Bytes
MDRP[rp0,rnd,white] 75         ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   27 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 27 ;CALL function
                           #--- PUSHB_3   41 27 10  ;PUSH Bytes
CALL            10 27 41   ;CALL function
                           #--- PUSHB_4   0 41 33 9 ;PUSH Bytes
CALL            9 33 41 0  ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
                           #--- DUP       #11       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   88 1      ;PUSH Bytes
CALL            1 88       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   71 69     ;PUSH Bytes
SDPVTL[orthog]  69 71      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[no-rnd]    71         ;Move Direct Absolute Point
                           #--- PUSHB_1   69        ;PUSH Bytes
MDRP[grey]      69         ;Move Direct Relative Point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[grey]      19         ;Move Direct Relative Point
                           #--- PUSHB_4   18 17 19 19 ;PUSH Bytes
CALL            19 19 17 18 ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_4   70 71 69 19 ;PUSH Bytes
CALL            19 69 71 70 ;CALL function
                           #--- PUSHB_3   18 17 19  ;PUSH Bytes
                           #--- DUP       #19       ;DUPlicate top stack element
ROLL            19 19 17   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              18         ;Interpolate Point
                           #--- PUSHB_3   70 71 69  ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
IP              70         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   17 18 19 69 70 71 ;PUSH Bytes
MDAP[no-rnd]    71         ;Move Direct Absolute Point
MDAP[no-rnd]    70         ;Move Direct Absolute Point
MDAP[no-rnd]    69         ;Move Direct Absolute Point
MDAP[no-rnd]    19         ;Move Direct Absolute Point
MDAP[no-rnd]    18         ;Move Direct Absolute Point
MDAP[no-rnd]    17         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   17 18 19 69 70 71 ;PUSH Bytes
MDAP[no-rnd]    71         ;Move Direct Absolute Point
MDAP[no-rnd]    70         ;Move Direct Absolute Point
MDAP[no-rnd]    69         ;Move Direct Absolute Point
MDAP[no-rnd]    19         ;Move Direct Absolute Point
MDAP[no-rnd]    18         ;Move Direct Absolute Point
MDAP[no-rnd]    17         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 75     ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_4   48 50 56 62 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              62 56 50 48 ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_6   14 25 45 46 64 78 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              78 64 46 45 25 14 ;Interpolate Point
                           #--- PUSHB_2   11 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
                           #--- PUSHB_2   9 80      ;PUSH Bytes
IP              80         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   2 83      ;PUSH Bytes
IP              83         ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_2   64 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            64         ;Set Reference Point 2
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_2   22 67     ;PUSH Bytes
IP              67         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   75        ;PUSH Bytes
IP              75         ;Interpolate Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP1            78         ;Set Reference Point 1
                           #--- PUSHB_1   80        ;PUSH Bytes
IP              80         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Rfraktur': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   37 0 0    ;PUSH Bytes
CALL            0 0 37     ;CALL function
                           #--- PUSHB_2   56 5      ;PUSH Bytes
MIRP[min,black] cvt_5 56   ;Move Indirect Relative Point
                           #--- PUSHB_3   56 37 10  ;PUSH Bytes
CALL            10 37 56   ;CALL function
                           #--- PUSHB_4   0 56 46 9 ;PUSH Bytes
CALL            9 46 56 0  ;CALL function
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   66 5      ;PUSH Bytes
MIRP[min,black] cvt_5 66   ;Move Indirect Relative Point
                           #--- PUSHB_3   66 4 10   ;PUSH Bytes
CALL            10 4 66    ;CALL function
                           #--- PUSHB_4   0 66 75 9 ;PUSH Bytes
CALL            9 75 66 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   97        ;PUSH Bytes
MDAP[rnd]       97         ;Move Direct Absolute Point
                           #--- PUSHB_1   81        ;PUSH Bytes
MDRP[rp0,rnd,white] 81         ;Move Direct Relative Point
                           #--- PUSHB_5   71 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 71 ;CALL function
                           #--- PUSHB_3   81 71 10  ;PUSH Bytes
CALL            10 71 81   ;CALL function
                           #--- PUSHB_4   64 81 0 9 ;PUSH Bytes
CALL            9 0 81 64  ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_1   49        ;PUSH Bytes
                           #--- DUP       #49       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_5   43 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_5   49 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 49 ;CALL function
                           #--- PUSHB_1   81        ;PUSH Bytes
SRP0            81         ;Set Reference Point 0
                           #--- PUSHB_1   78        ;PUSH Bytes
                           #--- DUP       #78       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 78         ;Move Direct Relative Point
SRP1            78         ;Set Reference Point 1
                           #--- PUSHB_5   73 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 73 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_5   31 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 31 ;CALL function
                           #--- PUSHB_1   84        ;PUSH Bytes
SHP[rp2]        84         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   91 1      ;PUSH Bytes
CALL            1 91       ;CALL function
                           #--- PUSHB_5   13 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 13 ;CALL function
                           #--- PUSHB_2   98 1      ;PUSH Bytes
CALL            1 98       ;CALL function
                           #--- PUSHB_2   49 81     ;PUSH Bytes
SRP1            81         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_2   46 75     ;PUSH Bytes
IP              75         ;Interpolate Point
IP              46         ;Interpolate Point
                           #--- PUSHB_2   71 73     ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_2   56 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              56         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_2   4 66      ;PUSH Bytes
IP              66         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   6 95      ;PUSH Bytes
IP              95         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   91        ;PUSH Bytes
SRP1            91         ;Set Reference Point 1
                           #--- PUSHB_4   7 19 88 94 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              94 88 19 7 ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_3   10 20 30  ;PUSH Bytes
IP              30         ;Interpolate Point
IP              20         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   56 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
                           #--- PUSHB_7   11 20 23 31 60 84 94 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              94 84 60 31 23 20 11 ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   6 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Rho': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   0 40      ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 35 46   ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   22 34 15 29 13 ;PUSH Bytes
CALL            13 29 15 34 22 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_5   28 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_4   8 21 17 14 ;PUSH Bytes
CALL            14 17 21 8 ;CALL function
                           #--- PUSHB_5   12 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 12 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_4   9 21 37 14 ;PUSH Bytes
CALL            14 37 21 9 ;CALL function
                           #--- PUSHB_5   44 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 44 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_5   2 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 2 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'S': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_5   39 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 39 ;CALL function
                           #--- PUSHB_3   64 2 0    ;PUSH Bytes
CALL            0 2 64     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 64 10  ;PUSH Bytes
CALL            10 64 18   ;CALL function
                           #--- PUSHB_4   64 18 6 9 ;PUSH Bytes
CALL            9 6 18 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   61        ;PUSH Bytes
MDRP[rp0,rnd,white] 61         ;Move Direct Relative Point
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
                           #--- DUP       #36       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
                           #--- DUP       #15       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   57 55     ;PUSH Bytes
SDPVTL[orthog]  55 57      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[no-rnd]    57         ;Move Direct Absolute Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDRP[grey]      55         ;Move Direct Relative Point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[grey]      24         ;Move Direct Relative Point
                           #--- PUSHB_4   23 22 24 19 ;PUSH Bytes
CALL            19 24 22 23 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_4   56 57 55 19 ;PUSH Bytes
CALL            19 55 57 56 ;CALL function
                           #--- PUSHB_3   23 22 24  ;PUSH Bytes
                           #--- DUP       #24       ;DUPlicate top stack element
ROLL            24 24 22   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              23         ;Interpolate Point
                           #--- PUSHB_3   56 57 55  ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
IP              56         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   22 23 24 55 56 57 ;PUSH Bytes
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    56         ;Move Direct Absolute Point
MDAP[no-rnd]    55         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    23         ;Move Direct Absolute Point
MDAP[no-rnd]    22         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   22 23 24 55 56 57 ;PUSH Bytes
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    56         ;Move Direct Absolute Point
MDAP[no-rnd]    55         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    23         ;Move Direct Absolute Point
MDAP[no-rnd]    22         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_3   31 39 33  ;PUSH Bytes
IP              33         ;Interpolate Point
IP              39         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   29 50 64  ;PUSH Bytes
IP              64         ;Interpolate Point
IP              50         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_2   13 66     ;PUSH Bytes
IP              66         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   0 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   50 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_2   27 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   61        ;PUSH Bytes
IP              61         ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_1   66        ;PUSH Bytes
IP              66         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF010000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF020000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF030000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF040000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF050000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF060000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF070000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 0 9  ;PUSH Bytes
CALL            9 0 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF080000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 0 9  ;PUSH Bytes
CALL            9 0 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF090000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF100000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF110000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF190000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 7 10    ;PUSH Bytes
CALL            10 7 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   0 8       ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 3 10    ;PUSH Bytes
CALL            10 3 4     ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF200000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 6 10    ;PUSH Bytes
CALL            10 6 5     ;CALL function
                           #--- PUSHB_4   64 5 11 9 ;PUSH Bytes
CALL            9 11 5 64  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   6 5 10    ;PUSH Bytes
CALL            10 5 6     ;CALL function
                           #--- PUSHB_4   64 6 8 9  ;PUSH Bytes
CALL            9 8 6 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 5 9 ;PUSH Bytes
CALL            9 5 11 64  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF210000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 6 10    ;PUSH Bytes
CALL            10 6 5     ;CALL function
                           #--- PUSHB_4   64 5 3 9  ;PUSH Bytes
CALL            9 3 5 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 10    ;PUSH Bytes
CALL            10 2 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF220000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 8 10    ;PUSH Bytes
CALL            10 8 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF230000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 11 10  ;PUSH Bytes
CALL            10 11 12   ;CALL function
                           #--- PUSHB_4   64 12 3 9 ;PUSH Bytes
CALL            9 3 12 64  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 2 9  ;PUSH Bytes
CALL            9 2 8 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_5   8 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 8  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF240000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF250000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 8 10    ;PUSH Bytes
CALL            10 8 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF260000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF270000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF280000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 10    ;PUSH Bytes
CALL            10 2 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 8 9  ;PUSH Bytes
CALL            9 8 0 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF360000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 10 9 ;PUSH Bytes
CALL            9 10 0 64  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 4 10    ;PUSH Bytes
CALL            10 4 7     ;CALL function
                           #--- PUSHB_4   64 7 9 9  ;PUSH Bytes
CALL            9 9 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   0 3       ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF370000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 9 10    ;PUSH Bytes
CALL            10 9 4     ;CALL function
                           #--- PUSHB_4   64 4 3 9  ;PUSH Bytes
CALL            9 3 4 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   9 4 10    ;PUSH Bytes
CALL            10 4 9     ;CALL function
                           #--- PUSHB_4   64 9 0 9  ;PUSH Bytes
CALL            9 0 9 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   5 6 10    ;PUSH Bytes
CALL            10 6 5     ;CALL function
                           #--- PUSHB_4   64 5 11 9 ;PUSH Bytes
CALL            9 11 5 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF380000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 2 9  ;PUSH Bytes
CALL            9 2 6 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF390000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 2 9  ;PUSH Bytes
CALL            9 2 6 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 8 10    ;PUSH Bytes
CALL            10 8 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF400000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   12 11 10  ;PUSH Bytes
CALL            10 11 12   ;CALL function
                           #--- PUSHB_4   64 12 14 9 ;PUSH Bytes
CALL            9 14 12 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 10 10  ;PUSH Bytes
CALL            10 10 13   ;CALL function
                           #--- PUSHB_4   64 13 0 9 ;PUSH Bytes
CALL            9 0 13 64  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 4 10    ;PUSH Bytes
CALL            10 4 7     ;CALL function
                           #--- PUSHB_4   64 7 3 9  ;PUSH Bytes
CALL            9 3 7 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF410000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   14 15 10  ;PUSH Bytes
CALL            10 15 14   ;CALL function
                           #--- PUSHB_4   64 14 12 9 ;PUSH Bytes
CALL            9 12 14 64 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 11 10  ;PUSH Bytes
CALL            10 11 12   ;CALL function
                           #--- PUSHB_4   64 12 3 9 ;PUSH Bytes
CALL            9 3 12 64  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 2 9  ;PUSH Bytes
CALL            9 2 8 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF420000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 11 10  ;PUSH Bytes
CALL            10 11 14   ;CALL function
                           #--- PUSHB_4   64 14 0 9 ;PUSH Bytes
CALL            9 0 14 64  ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 4 10    ;PUSH Bytes
CALL            10 4 7     ;CALL function
                           #--- PUSHB_4   64 7 3 9  ;PUSH Bytes
CALL            9 3 7 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_5   6 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 6  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF430000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF440000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   8 7 10    ;PUSH Bytes
CALL            10 7 8     ;CALL function
                           #--- PUSHB_4   64 8 10 9 ;PUSH Bytes
CALL            9 10 8 64  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   22 23 10  ;PUSH Bytes
CALL            10 23 22   ;CALL function
                           #--- PUSHB_4   64 22 20 9 ;PUSH Bytes
CALL            9 20 22 64 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_5   22 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   14 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 14 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF450000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 7 10    ;PUSH Bytes
CALL            10 7 8     ;CALL function
                           #--- PUSHB_4   64 8 10 9 ;PUSH Bytes
CALL            9 10 8 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 9 10    ;PUSH Bytes
CALL            10 9 4     ;CALL function
                           #--- PUSHB_4   64 4 3 9  ;PUSH Bytes
CALL            9 3 4 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   9 4 10    ;PUSH Bytes
CALL            10 4 9     ;CALL function
                           #--- PUSHB_4   64 9 0 9  ;PUSH Bytes
CALL            9 0 9 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF460000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_2   0 8       ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   4 3 10    ;PUSH Bytes
CALL            10 3 4     ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 8 10    ;PUSH Bytes
CALL            10 8 5     ;CALL function
                           #--- PUSHB_4   64 5 3 9  ;PUSH Bytes
CALL            9 3 5 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF470000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 6 10    ;PUSH Bytes
CALL            10 6 5     ;CALL function
                           #--- PUSHB_4   64 5 11 9 ;PUSH Bytes
CALL            9 11 5 64  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   6 5 10    ;PUSH Bytes
CALL            10 5 6     ;CALL function
                           #--- PUSHB_4   64 6 8 9  ;PUSH Bytes
CALL            9 8 6 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF480000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 3       ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 5 10    ;PUSH Bytes
CALL            10 5 6     ;CALL function
                           #--- PUSHB_4   64 6 8 9  ;PUSH Bytes
CALL            9 8 6 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF490000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 8 9  ;PUSH Bytes
CALL            9 8 0 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 1 10    ;PUSH Bytes
CALL            10 1 4     ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF500000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF510000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 1 10    ;PUSH Bytes
CALL            10 1 4     ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   5 6 10    ;PUSH Bytes
CALL            10 6 5     ;CALL function
                           #--- PUSHB_4   64 5 3 9  ;PUSH Bytes
CALL            9 3 5 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF520000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 8 10    ;PUSH Bytes
CALL            10 8 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF530000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 7 9  ;PUSH Bytes
CALL            9 7 1 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 6 10    ;PUSH Bytes
CALL            10 6 7     ;CALL function
                           #--- PUSHB_4   64 7 1 9  ;PUSH Bytes
CALL            9 1 7 64   ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   9 10 10   ;PUSH Bytes
CALL            10 10 9    ;CALL function
                           #--- PUSHB_4   64 9 15 9 ;PUSH Bytes
CALL            9 15 9 64  ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'SF540000': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_3   17 18 10  ;PUSH Bytes
CALL            10 18 17   ;CALL function
                           #--- PUSHB_4   64 17 15 9 ;PUSH Bytes
CALL            9 15 17 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   0 3       ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   5 9       ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   14 15 10  ;PUSH Bytes
CALL            10 15 14   ;CALL function
                           #--- PUSHB_4   64 14 12 9 ;PUSH Bytes
CALL            9 12 14 64 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   15 14 10  ;PUSH Bytes
CALL            10 14 15   ;CALL function
                           #--- PUSHB_4   64 15 17 9 ;PUSH Bytes
CALL            9 17 15 64 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Scaron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_5   29 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 29 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 45 10   ;PUSH Bytes
CALL            10 45 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 34 10  ;PUSH Bytes
CALL            10 34 17   ;CALL function
                           #--- PUSHB_4   64 17 13 9 ;PUSH Bytes
CALL            9 13 17 64 ;CALL function
                           #--- PUSHB_4   5 34 17 8 ;PUSH Bytes
CALL            8 17 34 5  ;CALL function
                           #--- PUSHB_5   42 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 42 ;CALL function
                           #--- PUSHB_3   42 5 10   ;PUSH Bytes
CALL            10 5 42    ;CALL function
                           #--- PUSHB_4   64 42 37 9 ;PUSH Bytes
CALL            9 37 42 64 ;CALL function
                           #--- PUSHB_3   5 42 10   ;PUSH Bytes
CALL            10 42 5    ;CALL function
                           #--- PUSHB_4   0 5 48 9  ;PUSH Bytes
CALL            9 48 5 0   ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   5 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   9 10 39 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 39 10 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Shacyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   28 0 0    ;PUSH Bytes
CALL            0 0 28     ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 23 47   ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   39 2 0    ;PUSH Bytes
CALL            0 2 39     ;CALL function
                           #--- PUSHB_2   2 15      ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_5   6 9 22 46 49 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        49 46 22 9 6 ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_4   11 32 36 14 ;PUSH Bytes
CALL            14 36 32 11 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_5   43 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 43 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_4   11 48 1 14 ;PUSH Bytes
CALL            14 1 48 11 ;CALL function
                           #--- PUSHB_5   5 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 5 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_4   11 23 19 14 ;PUSH Bytes
CALL            14 19 23 11 ;CALL function
                           #--- PUSHB_5   12 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   19 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 19 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Shchacyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 30 40   ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   11 15 10  ;PUSH Bytes
CALL            10 15 11   ;CALL function
                           #--- PUSHB_4   64 11 8 9 ;PUSH Bytes
CALL            9 8 11 64  ;CALL function
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_2   35 48     ;PUSH Bytes
SHP[rp1]        48         ;SHift Point using reference point
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   3 29 32 39 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        42 39 32 29 3 ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_4   11 15 19 14 ;PUSH Bytes
CALL            14 19 15 11 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_5   26 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 26 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_4   11 31 34 14 ;PUSH Bytes
CALL            14 34 31 11 ;CALL function
                           #--- PUSHB_5   38 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 38 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   11 4 0 14 ;PUSH Bytes
CALL            14 0 4 11  ;CALL function
                           #--- PUSHB_5   45 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_4   9 4 41 8  ;PUSH Bytes
CALL            8 41 4 9   ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Softsigncyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   4 38 15 28 13 ;PUSH Bytes
CALL            13 28 15 38 4 ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   30 21 10  ;PUSH Bytes
CALL            10 21 30   ;CALL function
                           #--- PUSHB_4   64 30 1 9 ;PUSH Bytes
CALL            9 1 30 64  ;CALL function
                           #--- PUSHB_3   21 30 10  ;PUSH Bytes
CALL            10 30 21   ;CALL function
                           #--- PUSHB_4   64 21 18 9 ;PUSH Bytes
CALL            9 18 21 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'T': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_5   21 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 21 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 9 10   ;PUSH Bytes
CALL            10 9 26    ;CALL function
                           #--- PUSHB_4   64 26 1 9 ;PUSH Bytes
CALL            9 1 26 64  ;CALL function
                           #--- PUSHB_3   9 26 10   ;PUSH Bytes
CALL            10 26 9    ;CALL function
                           #--- PUSHB_4   64 9 5 9  ;PUSH Bytes
CALL            9 5 9 64   ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Tcaron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   39 2 0    ;PUSH Bytes
CALL            0 2 39     ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   39 2 0    ;PUSH Bytes
CALL            0 2 39     ;CALL function
                           #--- PUSHB_5   0 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 0  ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_5   26 31 18 39 13 ;PUSH Bytes
CALL            13 39 18 31 26 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   13 24 10  ;PUSH Bytes
CALL            10 24 13   ;CALL function
                           #--- PUSHB_4   64 13 16 9 ;PUSH Bytes
CALL            9 16 13 64 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   24 13 10  ;PUSH Bytes
CALL            10 13 24   ;CALL function
                           #--- PUSHB_4   64 24 20 9 ;PUSH Bytes
CALL            9 20 24 64 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Tshecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 19 27  ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_5   40 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 40 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   6 24 32 42 13 ;PUSH Bytes
CALL            13 42 32 24 6 ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_4   9 36 34 14 ;PUSH Bytes
CALL            14 34 36 9 ;CALL function
                           #--- PUSHB_5   30 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 30 ;CALL function
                           #--- PUSHB_4   2 30 34 8 ;PUSH Bytes
CALL            8 34 30 2  ;CALL function
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_4   9 11 13 14 ;PUSH Bytes
CALL            14 13 11 9 ;CALL function
                           #--- PUSHB_5   18 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   18 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'U': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 25 37  ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 5 8 14  ;PUSH Bytes
CALL            14 8 5 8   ;CALL function
                           #--- PUSHB_5   15 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 15 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   8 0 35 14 ;PUSH Bytes
CALL            14 35 0 8  ;CALL function
                           #--- PUSHB_5   28 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 35 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   15 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_2   24 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Ugrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_5   6 32 12 27 13 ;PUSH Bytes
CALL            13 27 12 32 6 ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   26 32     ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   7 16 10   ;PUSH Bytes
CALL            10 16 7    ;CALL function
                           #--- PUSHB_4   64 7 10 9 ;PUSH Bytes
CALL            9 10 7 64  ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   16 7 10   ;PUSH Bytes
CALL            10 7 16    ;CALL function
                           #--- PUSHB_4   64 16 14 9 ;PUSH Bytes
CALL            9 14 16 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   0 1       ;PUSH Bytes
IP              1          ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Uhorn': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 25 33   ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   19 14 10  ;PUSH Bytes
CALL            10 14 19   ;CALL function
                           #--- PUSHB_4   0 19 0 9  ;PUSH Bytes
CALL            9 0 19 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 13 16 14 ;PUSH Bytes
CALL            14 16 13 8 ;CALL function
                           #--- PUSHB_5   23 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 23 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 32 10   ;PUSH Bytes
CALL            10 32 8    ;CALL function
                           #--- PUSHB_4   64 8 3 9  ;PUSH Bytes
CALL            9 3 8 64   ;CALL function
                           #--- PUSHB_3   32 8 10   ;PUSH Bytes
CALL            10 8 32    ;CALL function
                           #--- PUSHB_4   64 32 36 9 ;PUSH Bytes
CALL            9 36 32 64 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   23 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   30 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Upsilon1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   25 5      ;PUSH Bytes
MIRP[min,black] cvt_5 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 16 10  ;PUSH Bytes
CALL            10 16 25   ;CALL function
                           #--- PUSHB_4   0 25 22 9 ;PUSH Bytes
CALL            9 22 25 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 6 9  ;PUSH Bytes
CALL            9 6 2 64   ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   1 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Utilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   59 0 0    ;PUSH Bytes
CALL            0 0 59     ;CALL function
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp1]        48         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   34 42 54  ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 22 25 14 ;PUSH Bytes
CALL            14 25 22 8 ;CALL function
                           #--- PUSHB_5   32 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 32 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   61 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 61 ;CALL function
                           #--- PUSHB_3   61 12 10  ;PUSH Bytes
CALL            10 12 61   ;CALL function
                           #--- PUSHB_4   0 61 6 9  ;PUSH Bytes
CALL            9 6 61 0   ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP0            61         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_4   8 55 52 14 ;PUSH Bytes
CALL            14 52 55 8 ;CALL function
                           #--- PUSHB_5   45 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   52 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 52 ;CALL function
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   45 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_2   39 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'V': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 5 15    ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   14 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 14 ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   0 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   3 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_3   4 16 17   ;PUSH Bytes
IP              17         ;Interpolate Point
IP              16         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   5 15      ;PUSH Bytes
IP              15         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Vecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_5   25 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 25 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 12 10  ;PUSH Bytes
CALL            10 12 30   ;CALL function
                           #--- PUSHB_4   64 30 3 9 ;PUSH Bytes
CALL            9 3 30 64  ;CALL function
                           #--- PUSHB_3   12 30 10  ;PUSH Bytes
CALL            10 30 12   ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'W': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 20 25   ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   18 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   2 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 2  ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   10 9      ;PUSH Bytes
SDPVTL[orthog]  9 10       ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[no-rnd]    10         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[no-rnd]    21         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[rp0,min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   24 25     ;PUSH Bytes
SDPVTL[orthog]  25 24      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[no-rnd]    25         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[no-rnd]    5          ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 4    ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 24   ;Move Indirect Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_2   21 24     ;PUSH Bytes
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    21         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_8   4 5 9 10 20 21 24 25 ;PUSH Bytes
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    21         ;Move Direct Absolute Point
MDAP[no-rnd]    20         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    5          ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   8 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   6 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Wcircumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   29 3 0    ;PUSH Bytes
CALL            0 3 29     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 29 10   ;PUSH Bytes
CALL            10 29 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 17 10   ;PUSH Bytes
CALL            10 17 6    ;CALL function
                           #--- PUSHB_4   64 6 9 9  ;PUSH Bytes
CALL            9 9 6 64   ;CALL function
                           #--- PUSHB_4   0 6 31 9  ;PUSH Bytes
CALL            9 31 6 0   ;CALL function
                           #--- PUSHB_3   17 6 10   ;PUSH Bytes
CALL            10 6 17    ;CALL function
                           #--- PUSHB_4   64 17 13 9 ;PUSH Bytes
CALL            9 13 17 64 ;CALL function
                           #--- PUSHB_4   64 17 21 9 ;PUSH Bytes
CALL            9 21 17 64 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'X': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 14 ;CALL function
                           #--- PUSHB_4   12 9 2 14 ;PUSH Bytes
CALL            14 2 9 12  ;CALL function
                           #--- PUSHB_5   43 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 43 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   32 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 32 ;CALL function
                           #--- PUSHB_4   20 32 37 8 ;PUSH Bytes
CALL            8 37 32 20 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   5 6 16 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 16 6 5  ;Interpolate Point
                           #--- PUSHB_2   37 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   17 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_4   18 29 30 39 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              39 30 29 18 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   39 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_3   7 17 40   ;PUSH Bytes
IP              40         ;Interpolate Point
IP              17         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   16 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Y': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   9 2 0     ;PUSH Bytes
CALL            0 2 9      ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 4 10   ;PUSH Bytes
CALL            10 4 29    ;CALL function
                           #--- PUSHB_4   64 29 32 9 ;PUSH Bytes
CALL            9 32 29 64 ;CALL function
                           #--- PUSHB_3   4 29 10   ;PUSH Bytes
CALL            10 29 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   12 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   6 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   25 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   16 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   14 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Yericyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 12 50   ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   48 2 0    ;PUSH Bytes
CALL            0 2 48     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 13 24   ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   26 58 36 48 13 ;PUSH Bytes
CALL            13 48 36 58 26 ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   50 6      ;PUSH Bytes
MIRP[min,black] stemw 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_4   8 41 46 14 ;PUSH Bytes
CALL            14 46 41 8 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_5   23 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 23 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 0 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_4   32 0 15 8 ;PUSH Bytes
CALL            8 15 0 32  ;CALL function
                           #--- PUSHB_2   54 6      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   0 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   2 12 13   ;PUSH Bytes
IP              13         ;Interpolate Point
IP              12         ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   58 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Z': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_5   11 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 11 ;CALL function
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_5   1 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_5   16 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_1   4         ;PUSH Bytes
                           #--- DUP       #4        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_5   17 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   4 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 4 ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_2   3 18      ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Zecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_2   62 4      ;PUSH Bytes
MIRP[min,black] stemt 62   ;Move Indirect Relative Point
                           #--- PUSHB_3   45 0 0    ;PUSH Bytes
CALL            0 0 45     ;CALL function
                           #--- PUSHB_5   51 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 51 ;CALL function
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 30 10   ;PUSH Bytes
CALL            10 30 9    ;CALL function
                           #--- PUSHB_4   64 9 19 9 ;PUSH Bytes
CALL            9 19 9 64  ;CALL function
                           #--- PUSHB_5   69 2 41 30 13 ;PUSH Bytes
CALL            13 30 41 2 69 ;CALL function
                           #--- PUSHB_2   69 4      ;PUSH Bytes
MIRP[min,black] stemt 69   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_1   59        ;PUSH Bytes
                           #--- DUP       #59       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 59         ;Move Direct Relative Point
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 33 10   ;PUSH Bytes
CALL            10 33 6    ;CALL function
                           #--- PUSHB_4   64 6 0 9  ;PUSH Bytes
CALL            9 0 6 64   ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_1   65        ;PUSH Bytes
                           #--- DUP       #65       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 65         ;Move Direct Relative Point
SRP1            65         ;Set Reference Point 1
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_2   59 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_5   19 25 43 45 51 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              51 45 43 25 19 ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   28 60     ;PUSH Bytes
IP              60         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_6   2 30 41 62 68 69 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              69 68 62 41 30 2 ;Interpolate Point
                           #--- PUSHB_2   33 65     ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   62 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_2   38 65     ;PUSH Bytes
IP              65         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_2   2 69      ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'a': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 0 0    ;PUSH Bytes
CALL            0 0 30     ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 0 0    ;PUSH Bytes
CALL            0 0 26     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 18 10   ;PUSH Bytes
CALL            10 18 8    ;CALL function
                           #--- PUSHB_4   0 8 11 9  ;PUSH Bytes
CALL            9 11 8 0   ;CALL function
                           #--- PUSHB_5   3 36 30 18 13 ;PUSH Bytes
CALL            13 18 30 36 3 ;CALL function
                           #--- PUSHB_2   3 5       ;PUSH Bytes
MIRP[min,black] cvt_5 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   27 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 5 10   ;PUSH Bytes
CALL            10 5 21    ;CALL function
                           #--- PUSHB_4   64 21 25 9 ;PUSH Bytes
CALL            9 25 21 64 ;CALL function
                           #--- PUSHB_3   5 21 10   ;PUSH Bytes
CALL            10 21 5    ;CALL function
                           #--- PUSHB_4   0 5 14 9  ;PUSH Bytes
CALL            9 14 5 0   ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   5 39      ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   3 30 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 30 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_2   36 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_3   0 33 39   ;PUSH Bytes
IP              39         ;Interpolate Point
IP              33         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'acute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   14 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 14 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'acyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_5   3 4 0 22 4 ;PUSH Bytes
CALL            4 22 0 4 3 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_5   28 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 28 ;CALL function
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
                           #--- DUP       #29       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   29 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_4   12 18 33 39 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              39 33 18 12 ;Interpolate Point
                           #--- PUSHB_2   2 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   21 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii00208': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_5   5 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 5  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 2 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   2 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   1 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii10050': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_5   24 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 24 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 12 10  ;PUSH Bytes
CALL            10 12 30   ;CALL function
                           #--- PUSHB_4   64 30 3 9 ;PUSH Bytes
CALL            9 3 30 64  ;CALL function
                           #--- PUSHB_3   12 30 10  ;PUSH Bytes
CALL            10 30 12   ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii10098': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   15 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 15 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 6 5 14  ;PUSH Bytes
CALL            14 5 6 9   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57636': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SHP[rp1]        55         ;SHift Point using reference point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 22 10  ;PUSH Bytes
CALL            10 22 29   ;CALL function
                           #--- PUSHB_4   64 29 26 9 ;PUSH Bytes
CALL            9 26 29 64 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_2   59 4      ;PUSH Bytes
MIRP[min,black] stemt 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   52 59 10  ;PUSH Bytes
CALL            10 59 52   ;CALL function
                           #--- PUSHB_4   0 52 40 9 ;PUSH Bytes
CALL            9 40 52 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   58        ;PUSH Bytes
MDRP[rp0,rnd,white] 58         ;Move Direct Relative Point
                           #--- PUSHB_2   53 6      ;PUSH Bytes
MIRP[min,black] stemw 53   ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   22 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57645': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57796': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_4   5 20 25 8 ;PUSH Bytes
CALL            8 25 20 5  ;CALL function
                           #--- PUSHB_5   1 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 1 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   23 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 23 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   23 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_2   14 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   7 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_2   8 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   11 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57800': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_5   30 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 30 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   27 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 27 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   27 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57801': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   36 47     ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_2   30 42     ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   7 11      ;PUSH Bytes
CALL            11 7       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   50 11     ;PUSH Bytes
CALL            11 50      ;CALL function
                           #--- PUSHB_5   45 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_5   33 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 33 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57802': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_5   7 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 7 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   39 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 39 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   16 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 16 ;CALL function
                           #--- PUSHB_3   16 22 10  ;PUSH Bytes
CALL            10 22 16   ;CALL function
                           #--- PUSHB_4   64 16 11 9 ;PUSH Bytes
CALL            9 11 16 64 ;CALL function
                           #--- PUSHB_3   22 16 10  ;PUSH Bytes
CALL            10 16 22   ;CALL function
                           #--- PUSHB_4   64 22 4 9 ;PUSH Bytes
CALL            9 4 22 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_5   36 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 36 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   36 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57839': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_5   4 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 4 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 7 ;CALL function
                           #--- PUSHB_5   7 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 7 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii57842': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii61352': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 0 0    ;PUSH Bytes
CALL            0 0 50     ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   67 4      ;PUSH Bytes
MIRP[min,black] stemt 67   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_5   22 25 50 33 13 ;PUSH Bytes
CALL            13 33 50 25 22 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_5   22 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 22 ;CALL function
                           #--- PUSHB_5   6 17 50 33 13 ;PUSH Bytes
CALL            13 33 50 17 6 ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_5   0 13 50 33 13 ;PUSH Bytes
CALL            13 33 50 13 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDRP[rp0,rnd,white] 53         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_3   65 47 10  ;PUSH Bytes
CALL            10 47 65   ;CALL function
                           #--- PUSHB_4   64 65 30 9 ;PUSH Bytes
CALL            9 30 65 64 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_2   27 40     ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_2   65 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   59 62     ;PUSH Bytes
IP              62         ;Interpolate Point
IP              59         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_2   13 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_5   3 15 9 20 46 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              46 20 9 15 3 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'agrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   62 4      ;PUSH Bytes
MIRP[min,black] stemt 62   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_5   11 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 11 ;CALL function
                           #--- PUSHB_3   52 1 0    ;PUSH Bytes
CALL            0 1 52     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
                           #--- PUSHB_5   35 56 27 52 13 ;PUSH Bytes
CALL            13 52 27 56 35 ;CALL function
                           #--- PUSHB_2   35 5      ;PUSH Bytes
MIRP[min,black] cvt_5 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
                           #--- DUP       #5        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   71 5      ;PUSH Bytes
MIRP[min,black] cvt_5 71   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   59 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   62 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_3   14 21 25  ;PUSH Bytes
IP              25         ;Interpolate Point
IP              21         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   5 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   30 59 64  ;PUSH Bytes
IP              64         ;Interpolate Point
IP              59         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_2   35 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   47 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              47         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'aleflamedhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_3   29 3 0    ;PUSH Bytes
CALL            0 3 29     ;CALL function
                           #--- PUSHB_5   10 5 20 29 13 ;PUSH Bytes
CALL            13 29 20 5 10 ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_5   8 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   8 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
                           #--- PUSHB_2   12 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   14 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   1 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'aleph': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 24 28   ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   26 33 8 20 13 ;PUSH Bytes
CALL            13 20 8 33 26 ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   23 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   5 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 5  ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   23 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_5   14 11 25 26 33 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              33 26 25 11 14 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   7 27 28 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 28 27 7 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ampersand': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   44 2 10   ;PUSH Bytes
CALL            10 2 44    ;CALL function
                           #--- PUSHB_4   64 44 36 9 ;PUSH Bytes
CALL            9 36 44 64 ;CALL function
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   49 6      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_4   13 49 9 8 ;PUSH Bytes
CALL            8 9 49 13  ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   49 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_6   9 13 27 35 47 49 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              49 47 35 27 13 9 ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'angleleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   6 0 12    ;PUSH Bytes
IP              12         ;Interpolate Point
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'aogonek': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   64 4      ;PUSH Bytes
MIRP[min,black] stemt 64   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_3   40 1 0    ;PUSH Bytes
CALL            0 1 40     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 40 10  ;PUSH Bytes
CALL            10 40 30   ;CALL function
                           #--- PUSHB_4   0 30 33 9 ;PUSH Bytes
CALL            9 33 30 0  ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
                           #--- PUSHB_5   25 58 19 40 13 ;PUSH Bytes
CALL            13 40 19 58 25 ;CALL function
                           #--- PUSHB_2   25 5      ;PUSH Bytes
MIRP[min,black] cvt_5 25   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   61 6      ;PUSH Bytes
MIRP[min,black] stemw 61   ;Move Indirect Relative Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP0            61         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   16 55     ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 27 10  ;PUSH Bytes
CALL            10 27 43   ;CALL function
                           #--- PUSHB_4   64 43 48 9 ;PUSH Bytes
CALL            9 48 43 64 ;CALL function
                           #--- PUSHB_3   27 43 10  ;PUSH Bytes
CALL            10 43 27   ;CALL function
                           #--- PUSHB_4   0 27 36 9 ;PUSH Bytes
CALL            9 36 27 0  ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_1   12        ;PUSH Bytes
                           #--- DUP       #12       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_5   53 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 53 ;CALL function
                           #--- PUSHB_3   53 12 10  ;PUSH Bytes
CALL            10 12 53   ;CALL function
                           #--- PUSHB_4   0 53 6 9  ;PUSH Bytes
CALL            9 6 53 0   ;CALL function
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   12 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   19 25 58 64 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              64 58 25 19 ;Interpolate Point
                           #--- PUSHB_2   43 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   15 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   12 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_2   17 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_3   22 45 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              45         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'aringacute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   46 0 0    ;PUSH Bytes
CALL            0 0 46     ;CALL function
                           #--- PUSHB_2   58 5      ;PUSH Bytes
MIRP[min,black] cvt_5 58   ;Move Indirect Relative Point
                           #--- PUSHB_3   42 0 0    ;PUSH Bytes
CALL            0 0 42     ;CALL function
                           #--- PUSHB_2   38 5      ;PUSH Bytes
MIRP[min,black] cvt_5 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   66 1 0    ;PUSH Bytes
CALL            0 1 66     ;CALL function
                           #--- PUSHB_5   76 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 76 ;CALL function
                           #--- PUSHB_5   52 19 46 76 13 ;PUSH Bytes
CALL            13 76 46 19 52 ;CALL function
                           #--- PUSHB_5   52 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 52 ;CALL function
                           #--- PUSHB_5   34 24 46 76 13 ;PUSH Bytes
CALL            13 76 46 24 34 ;CALL function
                           #--- PUSHB_2   34 5      ;PUSH Bytes
MIRP[min,black] cvt_5 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 34 10  ;PUSH Bytes
CALL            10 34 24   ;CALL function
                           #--- PUSHB_4   0 24 27 9 ;PUSH Bytes
CALL            9 27 24 0  ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_5   60 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 60 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_5   73 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 73 ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SRP0            73         ;Set Reference Point 0
                           #--- PUSHB_2   78 1      ;PUSH Bytes
CALL            1 78       ;CALL function
                           #--- PUSHB_5   63 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 63 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   43 49     ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   37 21 10  ;PUSH Bytes
CALL            10 21 37   ;CALL function
                           #--- PUSHB_4   64 37 41 9 ;PUSH Bytes
CALL            9 41 37 64 ;CALL function
                           #--- PUSHB_3   21 37 10  ;PUSH Bytes
CALL            10 37 21   ;CALL function
                           #--- PUSHB_4   0 21 30 9 ;PUSH Bytes
CALL            9 30 21 0  ;CALL function
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   73 68     ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
SRP2            73         ;Set Reference Point 2
                           #--- PUSHB_4   46 58 66 6 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              6 66 58 46 ;Interpolate Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP1            78         ;Set Reference Point 1
                           #--- PUSHB_4   19 52 60 3 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              3 60 52 19 ;Interpolate Point
                           #--- PUSHB_2   37 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   11 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   58 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_2   52 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_3   16 49 55  ;PUSH Bytes
IP              55         ;Interpolate Point
IP              49         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_2   71 76     ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_1   68        ;PUSH Bytes
IP              68         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'arrowdown': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 6 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'arrowleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'arrowright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 1 0    ;PUSH Bytes
CALL            0 1 17     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   10 5      ;PUSH Bytes
MIRP[min,black] cvt_5 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'arrowup': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 0 0    ;PUSH Bytes
CALL            0 0 25     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_5   23 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 23 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   23 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asciicircum': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   10 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asciitilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 18 10   ;PUSH Bytes
CALL            10 18 7    ;CALL function
                           #--- PUSHB_4   0 7 12 9  ;PUSH Bytes
CALL            9 12 7 0   ;CALL function
                           #--- PUSHB_4   22 7 18 8 ;PUSH Bytes
CALL            8 18 7 22  ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   22 3 10   ;PUSH Bytes
CALL            10 3 22    ;CALL function
                           #--- PUSHB_4   0 22 26 9 ;PUSH Bytes
CALL            9 26 22 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asterisk': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 3 0     ;PUSH Bytes
CALL            0 3 1      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   3 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'at': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   41 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 41 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_5   59 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 59 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_5   28 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 28 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_5   10 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   36 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_5   56 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 56 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   19 28     ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_5   14 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 14 ;CALL function
                           #--- PUSHB_3   14 52 10  ;PUSH Bytes
CALL            10 52 14   ;CALL function
                           #--- PUSHB_4   64 14 16 9 ;PUSH Bytes
CALL            9 16 14 64 ;CALL function
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   52 56     ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_5   10 0 22 32 41 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              41 32 22 0 10 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   44 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              44         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   46 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              46         ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ayinhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 9       ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 16      ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   8 23      ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   1 0       ;PUSH Bytes
SDPVTL[orthog]  0 1        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[no-rnd]    1          ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[rp0,min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[rp0,min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 16     ;PUSH Bytes
SDPVTL[orthog]  16 13      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[no-rnd]    16         ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[grey]      13         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   23 7      ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 23   ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[grey]      26         ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_4   14 13 16 19 ;PUSH Bytes
CALL            19 16 13 14 ;CALL function
                           #--- PUSHB_4   15 13 16 19 ;PUSH Bytes
CALL            19 16 13 15 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   24 26 23 19 ;PUSH Bytes
CALL            19 23 26 24 ;CALL function
                           #--- PUSHB_4   25 26 23 19 ;PUSH Bytes
CALL            19 23 26 25 ;CALL function
                           #--- PUSHB_3   14 13 16  ;PUSH Bytes
                           #--- DUP       #16       ;DUPlicate top stack element
ROLL            16 16 13   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              14         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_3   25 26 23  ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
IP              25         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   15 24 13 14 25 26 ;PUSH Bytes
MDAP[no-rnd]    26         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    12 0 1 8 9 15 16 23 24 13 14 25 26 ;PUSH N Bytes
MDAP[no-rnd]    26         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    23         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'b': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 3 0     ;PUSH Bytes
CALL            0 3 2      ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 13      ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_5   17 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   35 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   6 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   13 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   9 29 35   ;PUSH Bytes
IP              35         ;Interpolate Point
IP              29         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'backslash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 3 0     ;PUSH Bytes
CALL            0 3 8      ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 10 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bethebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_3   20 7 10   ;PUSH Bytes
CALL            10 7 20    ;CALL function
                           #--- PUSHB_4   64 20 17 9 ;PUSH Bytes
CALL            9 17 20 64 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'block': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'braceleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 3 0    ;PUSH Bytes
CALL            0 3 34     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   8 20 10   ;PUSH Bytes
CALL            10 20 8    ;CALL function
                           #--- PUSHB_4   0 8 14 9  ;PUSH Bytes
CALL            9 14 8 0   ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   20 8 10   ;PUSH Bytes
CALL            10 8 20    ;CALL function
                           #--- PUSHB_4   64 20 26 9 ;PUSH Bytes
CALL            9 26 20 64 ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   8 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   7 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   1 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'braceright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 3 0    ;PUSH Bytes
CALL            0 3 17     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   31 0 10   ;PUSH Bytes
CALL            10 0 31    ;CALL function
                           #--- PUSHB_4   64 31 26 9 ;PUSH Bytes
CALL            9 26 31 64 ;CALL function
                           #--- PUSHB_3   0 31 10   ;PUSH Bytes
CALL            10 31 0    ;CALL function
                           #--- PUSHB_4   0 0 14 9  ;PUSH Bytes
CALL            9 14 0 0   ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   31 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   1 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   7 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bracketleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 3 0    ;PUSH Bytes
CALL            0 3 11     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 7  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_5   7 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 7  ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'breve': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_5   5 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 5 ;CALL function
                           #--- PUSHB_3   5 15 10   ;PUSH Bytes
CALL            10 15 5    ;CALL function
                           #--- PUSHB_4   0 5 0 9   ;PUSH Bytes
CALL            9 0 5 0    ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'brokenbar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 3 0     ;PUSH Bytes
CALL            0 3 1      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bullet': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_5   6 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 6  ;CALL function
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_5   6 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 6  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'c': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 30 10  ;PUSH Bytes
CALL            10 30 11   ;CALL function
                           #--- PUSHB_4   0 11 21 9 ;PUSH Bytes
CALL            9 21 11 0  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   0 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_4   11 18 21 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 21 18 11 ;Interpolate Point
                           #--- PUSHB_2   33 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'caron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ccedilla': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   57 4      ;PUSH Bytes
MIRP[min,black] stemt 57   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_2   52 4      ;PUSH Bytes
MIRP[min,black] stemt 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_5   46 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 46 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_5   20 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 20 ;CALL function
                           #--- PUSHB_3   20 11 10  ;PUSH Bytes
CALL            10 11 20   ;CALL function
                           #--- PUSHB_4   0 20 17 9 ;PUSH Bytes
CALL            9 17 20 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_5   8 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 8 ;CALL function
                           #--- PUSHB_3   8 22 10   ;PUSH Bytes
CALL            10 22 8    ;CALL function
                           #--- PUSHB_4   64 8 0 9  ;PUSH Bytes
CALL            9 0 8 64   ;CALL function
                           #--- PUSHB_3   22 8 10   ;PUSH Bytes
CALL            10 8 22    ;CALL function
                           #--- PUSHB_4   0 22 14 9 ;PUSH Bytes
CALL            9 14 22 0  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   22 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_6   5 26 27 36 52 57 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              57 52 36 27 26 5 ;Interpolate Point
                           #--- PUSHB_2   44 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_4   38 49 60 62 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              62 60 49 38 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   8 24 26   ;PUSH Bytes
IP              26         ;Interpolate Point
IP              24         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   46 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_4   0 33 55 62 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              62 55 33 0 ;Interpolate Point
                           #--- PUSHB_2   36 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'cedilla': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_5   7 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 7 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 17 10   ;PUSH Bytes
CALL            10 17 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 14 ;CALL function
                           #--- PUSHB_3   5 14 10   ;PUSH Bytes
CALL            10 14 5    ;CALL function
                           #--- PUSHB_4   0 5 20 9  ;PUSH Bytes
CALL            9 20 5 0   ;CALL function
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'cheabkhasiancyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   45 4      ;PUSH Bytes
MIRP[min,black] stemt 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_1   48        ;PUSH Bytes
                           #--- DUP       #48       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 48         ;Move Direct Relative Point
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_3   37 1 0    ;PUSH Bytes
CALL            0 1 37     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_1   28        ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_5   42 0 11 37 13 ;PUSH Bytes
CALL            13 37 11 0 42 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   42 5      ;PUSH Bytes
MIRP[min,black] cvt_5 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   31 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 31 ;CALL function
                           #--- PUSHB_3   31 18 10  ;PUSH Bytes
CALL            10 18 31   ;CALL function
                           #--- PUSHB_4   0 31 25 9 ;PUSH Bytes
CALL            9 25 31 0  ;CALL function
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   28 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   18 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_2   21 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'checyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 31 40  ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_5   9 27 3 18 13 ;PUSH Bytes
CALL            13 18 3 27 9 ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 12 15 14 ;PUSH Bytes
CALL            14 15 12 9 ;CALL function
                           #--- PUSHB_5   21 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 21 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_5   38 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 38 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_4   41 38 33 8 ;PUSH Bytes
CALL            8 33 38 41 ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 41 10   ;PUSH Bytes
CALL            10 41 6    ;CALL function
                           #--- PUSHB_4   64 6 33 9 ;PUSH Bytes
CALL            9 33 6 64  ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   33 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   9 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_2   18 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'chedescenderabkhasiancyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   66 0 0    ;PUSH Bytes
CALL            0 0 66     ;CALL function
                           #--- PUSHB_2   55 4      ;PUSH Bytes
MIRP[min,black] stemt 55   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_3   47 1 0    ;PUSH Bytes
CALL            0 1 47     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_1   38        ;PUSH Bytes
                           #--- DUP       #38       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   73 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 73 ;CALL function
                           #--- PUSHB_3   73 12 10  ;PUSH Bytes
CALL            10 12 73   ;CALL function
                           #--- PUSHB_4   0 73 6 9  ;PUSH Bytes
CALL            9 6 73 0   ;CALL function
                           #--- PUSHB_5   52 0 66 47 13 ;PUSH Bytes
CALL            13 47 66 0 52 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_2   52 5      ;PUSH Bytes
MIRP[min,black] cvt_5 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_5   41 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 41 ;CALL function
                           #--- PUSHB_3   41 28 10  ;PUSH Bytes
CALL            10 28 41   ;CALL function
                           #--- PUSHB_4   0 41 35 9 ;PUSH Bytes
CALL            9 35 41 0  ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   71 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 71 ;CALL function
                           #--- PUSHB_3   71 15 10  ;PUSH Bytes
CALL            10 15 71   ;CALL function
                           #--- PUSHB_4   0 71 9 9  ;PUSH Bytes
CALL            9 9 71 0   ;CALL function
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   15 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   22 24 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              24         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
                           #--- PUSHB_2   0 52      ;PUSH Bytes
IP              52         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   66 73     ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_1   61        ;PUSH Bytes
IP              61         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
                           #--- PUSHB_2   38 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   28 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'chi': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   42 1 0    ;PUSH Bytes
CALL            0 1 42     ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_2   2 47      ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   7 20      ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_5   22 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   22 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   20 31 37  ;PUSH Bytes
IP              37         ;Interpolate Point
IP              31         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_2   19 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_4   4 8 13 47 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              47 13 8 4  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_2   19 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'circle': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   17 5      ;PUSH Bytes
MIRP[min,black] cvt_5 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   3 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 3 ;CALL function
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   0 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'circumflex': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   10 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'club': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   15 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 15 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   15 9 10   ;PUSH Bytes
CALL            10 9 15    ;CALL function
                           #--- PUSHB_4   64 15 22 9 ;PUSH Bytes
CALL            9 22 15 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   31 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 31 ;CALL function
                           #--- PUSHB_5   31 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 31 ;CALL function
                           #--- PUSHB_4   19 31 12 8 ;PUSH Bytes
CALL            8 12 31 19 ;CALL function
                           #--- PUSHB_5   24 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 24 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   19 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   3 9 2 15  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              15 2 9 3   ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_4   17 22 26 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 26 22 17 ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   1 0 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 0 1  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_4   6 17 26 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 26 17 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'clubsuitwhite': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_5   43 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 43 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   83 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 83 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SHP[rp1]        67         ;SHift Point using reference point
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   86        ;PUSH Bytes
MDAP[rnd]       86         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   80 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 80 ;CALL function
                           #--- PUSHB_1   80        ;PUSH Bytes
SRP0            80         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   55 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_5   24 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_5   31 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 31 ;CALL function
                           #--- PUSHB_2   87 1      ;PUSH Bytes
CALL            1 87       ;CALL function
                           #--- PUSHB_2   19 80     ;PUSH Bytes
SRP1            80         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_5   3 9 15 2 78 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              78 2 15 9 3 ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_2   17 83     ;PUSH Bytes
IP              83         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- NPUSHB    10 22 7 37 43 44 46 48 53 59 76 ;PUSH N Bytes
                           #--- DEPTH     #10       ;DEPTH of the stack
SLOOP           10         ;Set LOOP variable
IP              76 59 53 48 46 44 43 37 7 22 ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   26 62     ;PUSH Bytes
IP              62         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_5   1 0 28 34 67 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              67 34 28 0 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 43      ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
                           #--- PUSHB_2   78 83     ;PUSH Bytes
SRP1            83         ;Set Reference Point 1
SRP2            78         ;Set Reference Point 2
                           #--- PUSHB_4   12 31 7 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 7 31 12 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_4   17 26 46 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 46 26 17 ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_4   24 50 19 55 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              55 19 50 24 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'colon': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   6 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 6 ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_5   13 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   23 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 23 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 10 ;CALL function
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'comma': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'commasubnosp': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   4 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 4 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 1 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'commaturnedmod': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_3   21 10 10  ;PUSH Bytes
CALL            10 10 21   ;CALL function
                           #--- PUSHB_4   64 21 25 9 ;PUSH Bytes
CALL            9 25 21 64 ;CALL function
                           #--- PUSHB_3   49 2 0    ;PUSH Bytes
CALL            0 2 49     ;CALL function
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_3   49 2 10   ;PUSH Bytes
CALL            10 2 49    ;CALL function
                           #--- PUSHB_4   64 49 42 9 ;PUSH Bytes
CALL            9 42 49 64 ;CALL function
                           #--- PUSHB_3   38 2 0    ;PUSH Bytes
CALL            0 2 38     ;CALL function
                           #--- PUSHB_3   45 2 0    ;PUSH Bytes
CALL            0 2 45     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_5   57 6 0 44 4 ;PUSH Bytes
CALL            4 44 0 6 57 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   38 53     ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   9 44      ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   22 28 10  ;PUSH Bytes
CALL            10 28 22   ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   0 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 0 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   57 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_2   32 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   13 15 47  ;PUSH Bytes
IP              47         ;Interpolate Point
IP              15         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   15 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_3   9 47 54   ;PUSH Bytes
IP              54         ;Interpolate Point
IP              47         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'copyright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   46 0 0    ;PUSH Bytes
CALL            0 0 46     ;CALL function
                           #--- PUSHB_5   57 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 57 ;CALL function
                           #--- PUSHB_3   41 2 0    ;PUSH Bytes
CALL            0 2 41     ;CALL function
                           #--- PUSHB_5   51 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 51 ;CALL function
                           #--- PUSHB_5   11 0 46 41 13 ;PUSH Bytes
CALL            13 41 46 0 11 ;CALL function
                           #--- PUSHB_5   11 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 11 ;CALL function
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 5 9   ;PUSH Bytes
CALL            9 5 0 0    ;CALL function
                           #--- PUSHB_5   18 33 46 41 13 ;PUSH Bytes
CALL            13 41 46 33 18 ;CALL function
                           #--- PUSHB_5   18 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 18 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   28 4 0 22 4 ;PUSH Bytes
CALL            4 22 0 4 28 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
                           #--- PUSHB_5   54 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 54 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   37 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_5   43 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 43 ;CALL function
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   37 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_8   11 18 25 8 41 46 51 57 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              57 51 46 41 8 25 18 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   43 49 54 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 54 49 43 ;Interpolate Point
                           #--- PUSHB_2   18 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'currency': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_2   62 4      ;PUSH Bytes
MIRP[min,black] stemt 62   ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   54        ;PUSH Bytes
MDRP[rp0,rnd,white] 54         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   59 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_6   9 12 42 46 52 0 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              0 52 46 42 12 9 ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_2   41 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              41         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_5   16 25 29 35 39 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              39 35 29 25 16 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   62 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_6   29 32 39 42 49 52 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              52 49 42 39 32 29 ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_4   25 0 54 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 54 0 25 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   6 12 16 21 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              21 16 12 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'd': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 3 0    ;PUSH Bytes
CALL            0 3 21     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   3 13      ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 25 10  ;PUSH Bytes
CALL            10 25 23   ;CALL function
                           #--- PUSHB_4   64 23 1 9 ;PUSH Bytes
CALL            9 1 23 64  ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_5   18 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   18 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_4   11 6 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 6 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_2   28 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_3   9 25 31   ;PUSH Bytes
IP              31         ;Interpolate Point
IP              25         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dageshhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dagger': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 3 0    ;PUSH Bytes
CALL            0 3 18     ;CALL function
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   9 14 10   ;PUSH Bytes
CALL            10 14 9    ;CALL function
                           #--- PUSHB_4   64 9 6 9  ;PUSH Bytes
CALL            9 6 9 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   4 7 10    ;PUSH Bytes
CALL            10 7 4     ;CALL function
                           #--- PUSHB_4   64 4 1 9  ;PUSH Bytes
CALL            9 1 4 64   ;CALL function
                           #--- PUSHB_3   7 4 10    ;PUSH Bytes
CALL            10 4 7     ;CALL function
                           #--- PUSHB_4   64 7 12 9 ;PUSH Bytes
CALL            9 12 7 64  ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'daggerdbl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 3 0    ;PUSH Bytes
CALL            0 3 34     ;CALL function
                           #--- PUSHB_3   30 1 0    ;PUSH Bytes
CALL            0 1 30     ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   17 22 10  ;PUSH Bytes
CALL            10 22 17   ;CALL function
                           #--- PUSHB_4   64 17 14 9 ;PUSH Bytes
CALL            9 14 17 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   23 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 37      ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   12 15 10  ;PUSH Bytes
CALL            10 15 12   ;CALL function
                           #--- PUSHB_4   64 12 7 9 ;PUSH Bytes
CALL            9 7 12 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   15 12 10  ;PUSH Bytes
CALL            10 12 15   ;CALL function
                           #--- PUSHB_4   64 15 20 9 ;PUSH Bytes
CALL            9 20 15 64 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dalethebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 19 10  ;PUSH Bytes
CALL            10 19 14   ;CALL function
                           #--- PUSHB_4   64 14 10 9 ;PUSH Bytes
CALL            9 10 14 64 ;CALL function
                           #--- PUSHB_3   19 14 10  ;PUSH Bytes
CALL            10 14 19   ;CALL function
                           #--- PUSHB_4   64 19 4 9 ;PUSH Bytes
CALL            9 4 19 64  ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dcroat': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_4   12 27 33 8 ;PUSH Bytes
CALL            8 33 27 12 ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   18 29     ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   13 41 10  ;PUSH Bytes
CALL            10 41 13   ;CALL function
                           #--- PUSHB_4   64 13 9 9 ;PUSH Bytes
CALL            9 9 13 64  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   0 36      ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   21 27 33  ;PUSH Bytes
IP              33         ;Interpolate Point
IP              27         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_2   33 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_3   24 36 41  ;PUSH Bytes
IP              41         ;Interpolate Point
IP              36         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'decyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 24      ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_5   6 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 6 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_2   2 23      ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   14 4 10   ;PUSH Bytes
CALL            10 4 14    ;CALL function
                           #--- PUSHB_4   64 14 17 9 ;PUSH Bytes
CALL            9 17 14 64 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_4   31 24 1 8 ;PUSH Bytes
CALL            8 1 24 31  ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   4 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_2   26 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'degree': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 2 0     ;PUSH Bytes
CALL            0 2 1      ;CALL function
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   18 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   1 0 6     ;PUSH Bytes
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'delta': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   41 3 0    ;PUSH Bytes
CALL            0 3 41     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   48 3 0    ;PUSH Bytes
CALL            0 3 48     ;CALL function
                           #--- PUSHB_5   13 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 13 ;CALL function
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
                           #--- DUP       #37       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 37         ;Move Direct Relative Point
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   17 14     ;PUSH Bytes
SDPVTL[orthog]  14 17      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[no-rnd]    17         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[grey]      14         ;Move Direct Relative Point
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDRP[grey]      46         ;Move Direct Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_4   15 17 14 19 ;PUSH Bytes
CALL            19 14 17 15 ;CALL function
                           #--- PUSHB_4   16 17 14 19 ;PUSH Bytes
CALL            19 14 17 16 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   44 43 46 19 ;PUSH Bytes
CALL            19 46 43 44 ;CALL function
                           #--- PUSHB_4   45 43 46 19 ;PUSH Bytes
CALL            19 46 43 45 ;CALL function
                           #--- PUSHB_3   44 43 46  ;PUSH Bytes
                           #--- DUP       #46       ;DUPlicate top stack element
ROLL            46 46 43   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              44         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_3   16 17 14  ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              16         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_8   14 46 15 16 17 43 44 45 ;PUSH Bytes
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    44         ;Move Direct Absolute Point
MDAP[no-rnd]    43         ;Move Direct Absolute Point
MDAP[no-rnd]    17         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    46         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_8   14 46 15 16 17 43 44 45 ;PUSH Bytes
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    44         ;Move Direct Absolute Point
MDAP[no-rnd]    43         ;Move Direct Absolute Point
MDAP[no-rnd]    17         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    46         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 37      ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_5   6 0 25 31 41 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              41 31 25 0 6 ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   10 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   28 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   19 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   22 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'desc.uni0E0D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   32 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_4   12 6 32 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 32 6 12 ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   18 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'desc.uni0E10': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_2   37 42     ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_5   60 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 60 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
                           #--- PUSHB_3   48 6 10   ;PUSH Bytes
CALL            10 6 48    ;CALL function
                           #--- PUSHB_4   64 48 53 9 ;PUSH Bytes
CALL            9 53 48 64 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_1   12        ;PUSH Bytes
                           #--- DUP       #12       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   30 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 30 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[rp0,rnd,white] 45         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_5   55 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   33 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 33 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   50 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 42 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 42 0 6  ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_4   38 39 3 56 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              56 3 39 38 ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_5   35 37 54 57 59 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              59 57 54 37 35 ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   24 30 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              30         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   36 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_3   3 9 45    ;PUSH Bytes
IP              45         ;Interpolate Point
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   56        ;PUSH Bytes
IP              56         ;Interpolate Point
                           #--- PUSHB_2   18 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   21 27 15  ;PUSH Bytes
IP              15         ;Interpolate Point
IP              27         ;Interpolate Point
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'diamond': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'diamondopen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   12 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 12 ;CALL function
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dieresistonos': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   15 23     ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_2   23 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_4   10 16 30 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 30 16 10 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dkshade': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 24 4 ;PUSH Bytes
CALL            4 24 0 4 0 ;CALL function
                           #--- PUSHB_5   0 4 0 24 4 ;PUSH Bytes
CALL            4 24 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dnblock': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dollar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_5   65 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 65 ;CALL function
                           #--- PUSHB_4   48 65 40 8 ;PUSH Bytes
CALL            8 40 65 48 ;CALL function
                           #--- PUSHB_5   53 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 53 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 0 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
                           #--- DUP       #16       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_5   10 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   81        ;PUSH Bytes
MDAP[rnd]       81         ;Move Direct Absolute Point
                           #--- PUSHB_1   74        ;PUSH Bytes
MDRP[rp0,rnd,white] 74         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_1   77        ;PUSH Bytes
SHP[rp2]        77         ;SHift Point using reference point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   37 43 10  ;PUSH Bytes
CALL            10 43 37   ;CALL function
                           #--- PUSHB_4   64 37 12 9 ;PUSH Bytes
CALL            9 12 37 64 ;CALL function
                           #--- PUSHB_3   43 37 10  ;PUSH Bytes
CALL            10 37 43   ;CALL function
                           #--- PUSHB_4   64 43 50 9 ;PUSH Bytes
CALL            9 50 43 64 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_2   82 1      ;PUSH Bytes
CALL            1 82       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   73 71     ;PUSH Bytes
SDPVTL[orthog]  71 73      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[no-rnd]    73         ;Move Direct Absolute Point
                           #--- PUSHB_1   71        ;PUSH Bytes
MDRP[grey]      71         ;Move Direct Relative Point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[grey]      29         ;Move Direct Relative Point
                           #--- PUSHB_4   27 26 29 19 ;PUSH Bytes
CALL            19 29 26 27 ;CALL function
                           #--- PUSHB_4   28 26 29 19 ;PUSH Bytes
CALL            19 29 26 28 ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SRP0            73         ;Set Reference Point 0
                           #--- PUSHB_4   72 73 71 19 ;PUSH Bytes
CALL            19 71 73 72 ;CALL function
                           #--- PUSHB_3   27 26 29  ;PUSH Bytes
                           #--- DUP       #29       ;DUPlicate top stack element
ROLL            29 29 26   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              27         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_3   72 73 71  ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            73         ;Set Reference Point 2
IP              72         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   26 27 71 72 28 29 ;PUSH Bytes
MDAP[no-rnd]    29         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    72         ;Move Direct Absolute Point
MDAP[no-rnd]    71         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   26 27 71 72 28 29 ;PUSH Bytes
MDAP[no-rnd]    29         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    72         ;Move Direct Absolute Point
MDAP[no-rnd]    71         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 74     ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_4   46 48 53 63 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              63 53 48 46 ;Interpolate Point
                           #--- PUSHB_2   37 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   21 65     ;PUSH Bytes
IP              65         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
                           #--- PUSHB_3   7 18 19   ;PUSH Bytes
IP              19         ;Interpolate Point
IP              18         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   8 16      ;PUSH Bytes
IP              16         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   36 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_2   33 68     ;PUSH Bytes
IP              68         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_2   21 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   24 74     ;PUSH Bytes
IP              74         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_2   6 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   5 77      ;PUSH Bytes
IP              77         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dotaccent': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dzecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 6 10   ;PUSH Bytes
CALL            10 6 10    ;CALL function
                           #--- PUSHB_4   64 10 21 9 ;PUSH Bytes
CALL            9 21 10 64 ;CALL function
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_2   11 39     ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_5   0 46 15 33 13 ;PUSH Bytes
CALL            13 33 15 46 0 ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 13 10  ;PUSH Bytes
CALL            10 13 29   ;CALL function
                           #--- PUSHB_4   64 29 32 9 ;PUSH Bytes
CALL            9 32 29 64 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   40 10 10  ;PUSH Bytes
CALL            10 10 40   ;CALL function
                           #--- PUSHB_4   64 40 36 9 ;PUSH Bytes
CALL            9 36 40 64 ;CALL function
                           #--- PUSHB_3   10 40 10  ;PUSH Bytes
CALL            10 40 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   29 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   46 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_3   23 24 43  ;PUSH Bytes
IP              43         ;Interpolate Point
IP              24         ;Interpolate Point
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'e': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_5   15 23 4 10 13 ;PUSH Bytes
CALL            13 10 4 23 15 ;CALL function
                           #--- PUSHB_2   15 5      ;PUSH Bytes
MIRP[min,black] cvt_5 15   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'egrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   57 4      ;PUSH Bytes
MIRP[min,black] stemt 57   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 3 0    ;PUSH Bytes
CALL            0 3 36     ;CALL function
                           #--- PUSHB_5   31 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 31 ;CALL function
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_2   51 5      ;PUSH Bytes
MIRP[min,black] cvt_5 51   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_4   20 51 36 8 ;PUSH Bytes
CALL            8 36 51 20 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   54 6      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   54 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_2   23 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- NPUSHB    9 12 6 20 15 29 36 45 27 48 ;PUSH N Bytes
                           #--- DEPTH     #9        ;DEPTH of the stack
SLOOP           9          ;Set LOOP variable
IP              48 27 45 36 29 15 20 6 12 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   0 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   31 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   17 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   39 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eight': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 3 0    ;PUSH Bytes
CALL            0 3 14     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_5   24 28 5 14 13 ;PUSH Bytes
CALL            13 14 5 28 24 ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
                           #--- DUP       #8        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
                           #--- DUP       #36       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   31 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_2   26 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_4   5 14 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 14 5 ;Interpolate Point
                           #--- PUSHB_2   17 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   8 2       ;PUSH Bytes
IP              2          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   10 0      ;PUSH Bytes
IP              0          ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   12 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eightsuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 3 0    ;PUSH Bytes
CALL            0 3 15     ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   34 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 34 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   25 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 25 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   2 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 2 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   32 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_4   5 22 15 26 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              26 15 22 5 ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   8 2       ;PUSH Bytes
IP              2          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   10 0      ;PUSH Bytes
IP              0          ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   18 12     ;PUSH Bytes
IP              12         ;Interpolate Point
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'elcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   24 5      ;PUSH Bytes
MIRP[min,black] cvt_5 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 3 10   ;PUSH Bytes
CALL            10 3 24    ;CALL function
                           #--- PUSHB_4   64 24 17 9 ;PUSH Bytes
CALL            9 17 24 64 ;CALL function
                           #--- PUSHB_3   30 1 0    ;PUSH Bytes
CALL            0 1 30     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   7 35      ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   26 9 10   ;PUSH Bytes
CALL            10 9 26    ;CALL function
                           #--- PUSHB_4   64 26 29 9 ;PUSH Bytes
CALL            9 29 26 64 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 6 5 14  ;PUSH Bytes
CALL            14 5 6 9   ;CALL function
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   26 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'element': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   23 5      ;PUSH Bytes
MIRP[min,black] cvt_5 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 5      ;PUSH Bytes
MIRP[min,black] cvt_5 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   30 10 10  ;PUSH Bytes
CALL            10 10 30   ;CALL function
                           #--- PUSHB_4   0 30 27 9 ;PUSH Bytes
CALL            9 27 30 0  ;CALL function
                           #--- PUSHB_2   3 16      ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ellipsis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_2   12 24     ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_5   6 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 6 ;CALL function
                           #--- PUSHB_2   18 30     ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   6 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   10 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 10 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_5   22 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   34 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 34 ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'emcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 15 22   ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   37 1 0    ;PUSH Bytes
CALL            0 1 37     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 16 20   ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 31 29 14 ;PUSH Bytes
CALL            14 29 31 9 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_5   24 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 24 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_4   9 6 8 14  ;PUSH Bytes
CALL            14 8 6 9   ;CALL function
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 8  ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   24 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_4   18 19 38 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 38 19 18 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   18 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'emdash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'emptyset': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 0 0    ;PUSH Bytes
CALL            0 0 26     ;CALL function
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 50 10  ;PUSH Bytes
CALL            10 50 26   ;CALL function
                           #--- PUSHB_4   64 26 32 9 ;PUSH Bytes
CALL            9 32 26 64 ;CALL function
                           #--- PUSHB_3   45 3 0    ;PUSH Bytes
CALL            0 3 45     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   45 2 10   ;PUSH Bytes
CALL            10 2 45    ;CALL function
                           #--- PUSHB_4   64 45 13 9 ;PUSH Bytes
CALL            9 13 45 64 ;CALL function
                           #--- PUSHB_3   17 3 0    ;PUSH Bytes
CALL            0 3 17     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   6 40      ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   32 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_4   0 26 45 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 45 26 0 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   13 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   50 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   8 47      ;PUSH Bytes
IP              47         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   9 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'encyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 21 24  ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 12    ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   23 1 29 38 13 ;PUSH Bytes
CALL            13 38 29 1 23 ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_5   41 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 41 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_4   24 41 35 8 ;PUSH Bytes
CALL            8 35 41 24 ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 15 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_4   13 15 20 8 ;PUSH Bytes
CALL            8 20 15 13 ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 13 10  ;PUSH Bytes
CALL            10 13 21   ;CALL function
                           #--- PUSHB_4   64 21 5 9 ;PUSH Bytes
CALL            9 5 21 64  ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eng': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 20 10  ;PUSH Bytes
CALL            10 20 29   ;CALL function
                           #--- PUSHB_4   0 29 26 9 ;PUSH Bytes
CALL            9 26 29 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 39 10   ;PUSH Bytes
CALL            10 39 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   9 3 1 14  ;PUSH Bytes
CALL            14 1 3 9   ;CALL function
                           #--- PUSHB_5   42 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 42 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 17 10  ;PUSH Bytes
CALL            10 17 32   ;CALL function
                           #--- PUSHB_4   0 32 23 9 ;PUSH Bytes
CALL            9 23 32 0  ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   32 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   13 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_2   8 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   6 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'enquad': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   12 5      ;PUSH Bytes
MIRP[min,black] cvt_5 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 5      ;PUSH Bytes
MIRP[min,black] cvt_5 17   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 14 ;CALL function
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   0 14 9 9  ;PUSH Bytes
CALL            9 9 14 0   ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   0 1       ;PUSH Bytes
IP              1          ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eogonek': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_1   32        ;PUSH Bytes
                           #--- DUP       #32       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   45 4      ;PUSH Bytes
MIRP[min,black] stemt 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
                           #--- PUSHB_5   27 41 16 22 13 ;PUSH Bytes
CALL            13 22 16 41 27 ;CALL function
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   39 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 39 ;CALL function
                           #--- PUSHB_3   39 12 10  ;PUSH Bytes
CALL            10 12 39   ;CALL function
                           #--- PUSHB_4   0 39 6 9  ;PUSH Bytes
CALL            9 6 39 0   ;CALL function
                           #--- PUSHB_4   64 39 35 9 ;PUSH Bytes
CALL            9 35 39 64 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   12 39 10  ;PUSH Bytes
CALL            10 39 12   ;CALL function
                           #--- PUSHB_4   64 12 19 9 ;PUSH Bytes
CALL            9 19 12 64 ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   39 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   14 16 22 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 22 16 14 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   12 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   29 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   41 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'epsilon': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_5   55 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 55 ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_5   28 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 28 ;CALL function
                           #--- PUSHB_5   39 45 7 19 13 ;PUSH Bytes
CALL            13 19 7 45 39 ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   48 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   13 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_2   48 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              48         ;Interpolate Point
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   14 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   33 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   16 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'equivalence': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ercyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_5   12 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 12 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 6 5 14  ;PUSH Bytes
CALL            14 5 6 9   ;CALL function
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ereversedcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   39 0 0    ;PUSH Bytes
CALL            0 0 39     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_5   20 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 20 ;CALL function
                           #--- PUSHB_5   8 11 39 31 13 ;PUSH Bytes
CALL            13 31 39 11 8 ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   0 42      ;PUSH Bytes
IP              42         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   14 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eta': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 28 10   ;PUSH Bytes
CALL            10 28 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   9 3 1 14  ;PUSH Bytes
CALL            14 1 3 9   ;CALL function
                           #--- PUSHB_5   31 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 31 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_5   19 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 19 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   21 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   13 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_2   8 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   6 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'exclamdbl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 3 0    ;PUSH Bytes
CALL            0 3 24     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   1 13 10   ;PUSH Bytes
CALL            10 13 1    ;CALL function
                           #--- PUSHB_4   0 1 7 9   ;PUSH Bytes
CALL            9 7 1 0    ;CALL function
                           #--- PUSHB_2   27 38     ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   1 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'existential': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_5   1 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 1 ;CALL function
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_5   23 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 23 ;CALL function
                           #--- PUSHB_5   17 6 38 25 13 ;PUSH Bytes
CALL            13 25 38 6 17 ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 6 9 14  ;PUSH Bytes
CALL            14 9 6 9   ;CALL function
                           #--- PUSHB_5   14 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
                           #--- DUP       #24       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 4 10   ;PUSH Bytes
CALL            10 4 33    ;CALL function
                           #--- PUSHB_4   64 33 29 9 ;PUSH Bytes
CALL            9 29 33 64 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'f': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 0 10    ;PUSH Bytes
CALL            10 0 8     ;CALL function
                           #--- PUSHB_4   0 8 5 9   ;PUSH Bytes
CALL            9 5 8 0    ;CALL function
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_3   17 28 10  ;PUSH Bytes
CALL            10 28 17   ;CALL function
                           #--- PUSHB_4   0 17 2 9  ;PUSH Bytes
CALL            9 2 17 0   ;CALL function
                           #--- PUSHB_4   64 17 20 9 ;PUSH Bytes
CALL            9 20 17 64 ;CALL function
                           #--- PUSHB_4   64 17 14 9 ;PUSH Bytes
CALL            9 14 17 64 ;CALL function
                           #--- PUSHB_3   28 17 10  ;PUSH Bytes
CALL            10 17 28   ;CALL function
                           #--- PUSHB_4   64 28 24 9 ;PUSH Bytes
CALL            9 24 28 64 ;CALL function
                           #--- PUSHB_4   64 28 32 9 ;PUSH Bytes
CALL            9 32 28 64 ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ff': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 60      ;PUSH Bytes
SHP[rp2]        60         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   27 3 0    ;PUSH Bytes
CALL            0 3 27     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_3   36 27 10  ;PUSH Bytes
CALL            10 27 36   ;CALL function
                           #--- PUSHB_4   0 36 51 9 ;PUSH Bytes
CALL            9 51 36 0  ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   40 58     ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   2 61      ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_2   63 6      ;PUSH Bytes
MIRP[min,black] stemw 63   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   63 15 10  ;PUSH Bytes
CALL            10 15 63   ;CALL function
                           #--- PUSHB_4   0 63 30 9 ;PUSH Bytes
CALL            9 30 63 0  ;CALL function
                           #--- PUSHB_3   15 63 10  ;PUSH Bytes
CALL            10 63 15   ;CALL function
                           #--- PUSHB_4   64 15 11 9 ;PUSH Bytes
CALL            9 11 15 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_3   4 60 10   ;PUSH Bytes
CALL            10 60 4    ;CALL function
                           #--- PUSHB_4   64 4 7 9  ;PUSH Bytes
CALL            9 7 4 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_4   0 4 48 9  ;PUSH Bytes
CALL            9 48 4 0   ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'fi': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_2   1 40      ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   26 3 0    ;PUSH Bytes
CALL            0 3 26     ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 26 10  ;PUSH Bytes
CALL            10 26 35   ;CALL function
                           #--- PUSHB_4   0 35 32 9 ;PUSH Bytes
CALL            9 32 35 0  ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_3   43 14 10  ;PUSH Bytes
CALL            10 14 43   ;CALL function
                           #--- PUSHB_4   0 43 29 9 ;PUSH Bytes
CALL            9 29 43 0  ;CALL function
                           #--- PUSHB_3   14 43 10  ;PUSH Bytes
CALL            10 43 14   ;CALL function
                           #--- PUSHB_4   64 14 10 9 ;PUSH Bytes
CALL            9 10 14 64 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 40 10   ;PUSH Bytes
CALL            10 40 1    ;CALL function
                           #--- PUSHB_4   64 1 5 9  ;PUSH Bytes
CALL            9 5 1 64   ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'filledbox': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 1  ;CALL function
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'filledrect': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 1  ;CALL function
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'finalkafhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 7 10   ;PUSH Bytes
CALL            10 7 12    ;CALL function
                           #--- PUSHB_4   0 12 23 9 ;PUSH Bytes
CALL            9 23 12 0  ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'finalmemhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   8 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'finalnunhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 13 10   ;PUSH Bytes
CALL            10 13 8    ;CALL function
                           #--- PUSHB_4   64 8 4 9  ;PUSH Bytes
CALL            9 4 8 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'finalpehebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 33 10  ;PUSH Bytes
CALL            10 33 28   ;CALL function
                           #--- PUSHB_4   0 28 45 9 ;PUSH Bytes
CALL            9 45 28 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   18 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 18 ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   14 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'finaltsadihebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_4   28 12 18 8 ;PUSH Bytes
CALL            8 18 12 28 ;CALL function
                           #--- PUSHB_5   25 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   28 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 28 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   9 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 9 ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   12 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   0 15      ;PUSH Bytes
IP              15         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'five': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   39 3 0    ;PUSH Bytes
CALL            0 3 39     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   39 3 0    ;PUSH Bytes
CALL            0 3 39     ;CALL function
                           #--- PUSHB_5   35 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 35 ;CALL function
                           #--- PUSHB_5   32 6 35 39 13 ;PUSH Bytes
CALL            13 39 35 6 32 ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 38 10   ;PUSH Bytes
CALL            10 38 4    ;CALL function
                           #--- PUSHB_4   0 4 0 9   ;PUSH Bytes
CALL            9 0 4 0    ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   4 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   24 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_4   6 15 26 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 26 15 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_3   9 21 29   ;PUSH Bytes
IP              29         ;Interpolate Point
IP              21         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   6 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'fiveeighths': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 0 0    ;PUSH Bytes
CALL            0 0 43     ;CALL function
                           #--- PUSHB_5   72 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 72 ;CALL function
                           #--- PUSHB_3   36 3 0    ;PUSH Bytes
CALL            0 3 36     ;CALL function
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_3   86 2 0    ;PUSH Bytes
CALL            0 2 86     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_3   29 8 10   ;PUSH Bytes
CALL            10 8 29    ;CALL function
                           #--- PUSHB_4   64 29 32 9 ;PUSH Bytes
CALL            9 32 29 64 ;CALL function
                           #--- PUSHB_5   68 63 43 29 13 ;PUSH Bytes
CALL            13 29 43 63 68 ;CALL function
                           #--- PUSHB_5   68 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 68 ;CALL function
                           #--- PUSHB_5   24 14 43 29 13 ;PUSH Bytes
CALL            13 29 43 14 24 ;CALL function
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
                           #--- PUSHB_3   24 14 10  ;PUSH Bytes
CALL            10 14 24   ;CALL function
                           #--- PUSHB_4   0 24 20 9 ;PUSH Bytes
CALL            9 20 24 0  ;CALL function
                           #--- PUSHB_5   53 58 43 29 13 ;PUSH Bytes
CALL            13 29 43 58 53 ;CALL function
                           #--- PUSHB_5   53 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 53 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   91        ;PUSH Bytes
MDAP[rnd]       91         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_3   6 35 10   ;PUSH Bytes
CALL            10 35 6    ;CALL function
                           #--- PUSHB_4   0 6 2 9   ;PUSH Bytes
CALL            9 2 6 0    ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_3   26 11 10  ;PUSH Bytes
CALL            10 11 26   ;CALL function
                           #--- PUSHB_4   0 26 17 9 ;PUSH Bytes
CALL            9 17 26 0  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_5   70 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 70 ;CALL function
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP0            70         ;Set Reference Point 0
                           #--- PUSHB_2   74 1      ;PUSH Bytes
CALL            1 74       ;CALL function
                           #--- PUSHB_5   40 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 40 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp2]        56         ;SHift Point using reference point
                           #--- PUSHB_2   92 1      ;PUSH Bytes
CALL            1 92       ;CALL function
                           #--- PUSHB_2   6 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_4   8 29 78 81 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              81 78 29 8 ;Interpolate Point
                           #--- PUSHB_2   70 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_1   74        ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
                           #--- PUSHB_6   43 60 53 64 86 89 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              89 86 64 53 60 43 ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   68 72     ;PUSH Bytes
SRP1            72         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_4   46 40 78 81 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              81 78 40 46 ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_2   48 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              48         ;Interpolate Point
                           #--- PUSHB_2   24 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_4   50 56 61 65 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              65 61 56 50 ;Interpolate Point
                           #--- PUSHB_2   53 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_2   11 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_2   8 29      ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   89        ;PUSH Bytes
IP              89         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'fivesuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 3 0    ;PUSH Bytes
CALL            0 3 36     ;CALL function
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_3   29 8 10   ;PUSH Bytes
CALL            10 8 29    ;CALL function
                           #--- PUSHB_4   64 29 32 9 ;PUSH Bytes
CALL            9 32 29 64 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
                           #--- PUSHB_3   24 14 10  ;PUSH Bytes
CALL            10 14 24   ;CALL function
                           #--- PUSHB_4   0 24 20 9 ;PUSH Bytes
CALL            9 20 24 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_3   6 35 10   ;PUSH Bytes
CALL            10 35 6    ;CALL function
                           #--- PUSHB_4   0 6 2 9   ;PUSH Bytes
CALL            9 2 6 0    ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_3   26 11 10  ;PUSH Bytes
CALL            10 11 26   ;CALL function
                           #--- PUSHB_4   0 26 17 9 ;PUSH Bytes
CALL            9 17 26 0  ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   6 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   8 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'fl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 6 34    ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   32 3 0    ;PUSH Bytes
CALL            0 3 32     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   4 20 10   ;PUSH Bytes
CALL            10 20 4    ;CALL function
                           #--- PUSHB_4   64 4 1 9  ;PUSH Bytes
CALL            9 1 4 64   ;CALL function
                           #--- PUSHB_3   20 4 10   ;PUSH Bytes
CALL            10 4 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   34 6 10   ;PUSH Bytes
CALL            10 6 34    ;CALL function
                           #--- PUSHB_4   64 34 37 9 ;PUSH Bytes
CALL            9 37 34 64 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'florin': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   42 3 0    ;PUSH Bytes
CALL            0 3 42     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 42 10   ;PUSH Bytes
CALL            10 42 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 18 10  ;PUSH Bytes
CALL            10 18 27   ;CALL function
                           #--- PUSHB_4   0 27 24 9 ;PUSH Bytes
CALL            9 24 27 0  ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   15 30 10  ;PUSH Bytes
CALL            10 30 15   ;CALL function
                           #--- PUSHB_4   64 15 11 9 ;PUSH Bytes
CALL            9 11 15 64 ;CALL function
                           #--- PUSHB_4   0 15 45 9 ;PUSH Bytes
CALL            9 45 15 0  ;CALL function
                           #--- PUSHB_3   30 15 10  ;PUSH Bytes
CALL            10 15 30   ;CALL function
                           #--- PUSHB_4   64 30 34 9 ;PUSH Bytes
CALL            9 34 30 64 ;CALL function
                           #--- PUSHB_4   0 30 21 9 ;PUSH Bytes
CALL            9 21 30 0  ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'four': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   7 3 0     ;PUSH Bytes
CALL            0 3 7      ;CALL function
                           #--- PUSHB_5   5 21 18 7 13 ;PUSH Bytes
CALL            13 7 18 21 5 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   3 14 10   ;PUSH Bytes
CALL            10 14 3    ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_4   8 14 16 14 ;PUSH Bytes
CALL            14 16 14 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   16 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 16 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   3 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'foursuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 3 0    ;PUSH Bytes
CALL            0 3 20     ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   16 6 10   ;PUSH Bytes
CALL            10 6 16    ;CALL function
                           #--- PUSHB_4   64 16 18 9 ;PUSH Bytes
CALL            9 18 16 64 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_4   13 6 8 14 ;PUSH Bytes
CALL            14 8 6 13  ;CALL function
                           #--- PUSHB_5   13 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 8 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   16 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_2   1 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'g': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   18 38     ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 7 10   ;PUSH Bytes
CALL            10 7 25    ;CALL function
                           #--- PUSHB_4   64 25 22 9 ;PUSH Bytes
CALL            9 22 25 64 ;CALL function
                           #--- PUSHB_3   7 25 10   ;PUSH Bytes
CALL            10 25 7    ;CALL function
                           #--- PUSHB_4   64 7 0 9  ;PUSH Bytes
CALL            9 0 7 64   ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   7 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   10 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_3   13 34 38  ;PUSH Bytes
IP              38         ;Interpolate Point
IP              34         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   20 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gamma': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 3  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 32 29 14 ;PUSH Bytes
CALL            14 29 32 8 ;CALL function
                           #--- PUSHB_5   22 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 22 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   14 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 14 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   29 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_2   18 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   22 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   6 16 34   ;PUSH Bytes
IP              34         ;Interpolate Point
IP              16         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gcaron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   35 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 35 ;CALL function
                           #--- PUSHB_3   35 12 10  ;PUSH Bytes
CALL            10 12 35   ;CALL function
                           #--- PUSHB_4   0 35 6 9  ;PUSH Bytes
CALL            9 6 35 0   ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   35 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_4   21 30 37 43 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 37 30 21 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   12 18 27 43 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 27 18 12 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_5   0 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_4   9 15 14 14 ;PUSH Bytes
CALL            14 14 15 9 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_5   8 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 8  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gereshhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 2 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'germandbls': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   53 0 0    ;PUSH Bytes
CALL            0 0 53     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 16 10  ;PUSH Bytes
CALL            10 16 27   ;CALL function
                           #--- PUSHB_4   0 27 22 9 ;PUSH Bytes
CALL            9 22 27 0  ;CALL function
                           #--- PUSHB_3   7 3 0     ;PUSH Bytes
CALL            0 3 7      ;CALL function
                           #--- PUSHB_2   45 4      ;PUSH Bytes
MIRP[min,black] stemt 45   ;Move Indirect Relative Point
                           #--- PUSHB_5   40 35 16 7 13 ;PUSH Bytes
CALL            13 7 16 35 40 ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_4   9 48 50 14 ;PUSH Bytes
CALL            14 50 48 9 ;CALL function
                           #--- PUSHB_5   1 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   50 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 50 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 13 30 8 ;PUSH Bytes
CALL            8 30 13 9  ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   42 9 10   ;PUSH Bytes
CALL            10 9 42    ;CALL function
                           #--- PUSHB_4   64 42 37 9 ;PUSH Bytes
CALL            9 37 42 64 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   42 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_5   7 22 35 40 45 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              45 40 35 22 7 ;Interpolate Point
                           #--- PUSHB_2   30 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   16 11     ;PUSH Bytes
IP              11         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
                           #--- PUSHB_2   35 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   13 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gershayimhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 2 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   12 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 12 ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gimelhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 3 10   ;PUSH Bytes
CALL            10 3 19    ;CALL function
                           #--- PUSHB_4   64 19 22 9 ;PUSH Bytes
CALL            9 22 19 64 ;CALL function
                           #--- PUSHB_3   3 19 10   ;PUSH Bytes
CALL            10 19 3    ;CALL function
                           #--- PUSHB_4   64 3 0 9  ;PUSH Bytes
CALL            9 0 3 64   ;CALL function
                           #--- PUSHB_4   0 3 11 9  ;PUSH Bytes
CALL            9 11 3 0   ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   19 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   25 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   22 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gjecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   37 1 0    ;PUSH Bytes
CALL            0 1 37     ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   37 1 0    ;PUSH Bytes
CALL            0 1 37     ;CALL function
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
                           #--- PUSHB_5   16 11 29 37 13 ;PUSH Bytes
CALL            13 37 29 11 16 ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   23 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   9 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gradient': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'grave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   14 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   3 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 3 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'gravecomb': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'greater': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   28 0 0    ;PUSH Bytes
CALL            0 0 28     ;CALL function
                           #--- PUSHB_5   33 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 33 ;CALL function
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 6 10   ;PUSH Bytes
CALL            10 6 23    ;CALL function
                           #--- PUSHB_4   0 23 14 9 ;PUSH Bytes
CALL            9 14 23 0  ;CALL function
                           #--- PUSHB_4   0 23 1 9  ;PUSH Bytes
CALL            9 1 23 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_5   37 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 9 10   ;PUSH Bytes
CALL            10 9 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   37 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   12 6 17 23 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              23 17 6 12 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'greaterequal': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 0 0    ;PUSH Bytes
CALL            0 0 23     ;CALL function
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 18      ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guillemotleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 3 10   ;PUSH Bytes
CALL            10 3 10    ;CALL function
                           #--- PUSHB_4   0 10 7 9  ;PUSH Bytes
CALL            9 7 10 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 5 10    ;PUSH Bytes
CALL            10 5 8     ;CALL function
                           #--- PUSHB_4   0 8 0 9   ;PUSH Bytes
CALL            9 0 8 0    ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guillemotright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   49 0 0    ;PUSH Bytes
CALL            0 0 49     ;CALL function
                           #--- PUSHB_5   53 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 53 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_5   55 61 49 33 13 ;PUSH Bytes
CALL            13 33 49 61 55 ;CALL function
                           #--- PUSHB_5   55 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 55 ;CALL function
                           #--- PUSHB_3   61 55 10  ;PUSH Bytes
CALL            10 55 61   ;CALL function
                           #--- PUSHB_4   64 61 38 9 ;PUSH Bytes
CALL            9 38 61 64 ;CALL function
                           #--- PUSHB_5   7 11 49 33 13 ;PUSH Bytes
CALL            13 33 49 11 7 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   7 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 7 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp2]        59         ;SHift Point using reference point
                           #--- PUSHB_5   44 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 44 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_3   54 44 10  ;PUSH Bytes
CALL            10 44 54   ;CALL function
                           #--- PUSHB_4   64 54 56 9 ;PUSH Bytes
CALL            9 56 54 64 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_4   13 44 46 14 ;PUSH Bytes
CALL            14 46 44 13 ;CALL function
                           #--- PUSHB_5   51 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_5   46 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 46 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_4   25 28 33 61 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              61 33 28 25 ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_2   36 58     ;PUSH Bytes
IP              58         ;Interpolate Point
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_3   28 39 57  ;PUSH Bytes
IP              57         ;Interpolate Point
IP              39         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guilsinglright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   8 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 8  ;CALL function
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   8 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'h': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 18 27  ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_3   2 3 0     ;PUSH Bytes
CALL            0 3 2      ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_4   9 36 34 14 ;PUSH Bytes
CALL            14 34 36 9 ;CALL function
                           #--- PUSHB_5   30 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 30 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_4   9 10 13 14 ;PUSH Bytes
CALL            14 13 10 9 ;CALL function
                           #--- PUSHB_5   17 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   17 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   6 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hardsigncyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_5   0 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 0 ;CALL function
                           #--- PUSHB_5   8 35 18 3 13 ;PUSH Bytes
CALL            13 3 18 35 8 ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   27 21 10  ;PUSH Bytes
CALL            10 21 27   ;CALL function
                           #--- PUSHB_4   64 27 6 9 ;PUSH Bytes
CALL            9 6 27 64  ;CALL function
                           #--- PUSHB_3   21 27 10  ;PUSH Bytes
CALL            10 27 21   ;CALL function
                           #--- PUSHB_4   64 21 20 9 ;PUSH Bytes
CALL            9 20 21 64 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hbar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 22 31  ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   2 3 0     ;PUSH Bytes
CALL            0 3 2      ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   10 1 0    ;PUSH Bytes
CALL            0 1 10     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   31 40 10  ;PUSH Bytes
CALL            10 40 31   ;CALL function
                           #--- PUSHB_4   64 31 5 9 ;PUSH Bytes
CALL            9 5 31 64  ;CALL function
                           #--- PUSHB_3   40 31 10  ;PUSH Bytes
CALL            10 31 40   ;CALL function
                           #--- PUSHB_4   64 40 0 9 ;PUSH Bytes
CALL            9 0 40 64  ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_4   9 40 38 14 ;PUSH Bytes
CALL            14 38 40 9 ;CALL function
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_4   9 14 17 14 ;PUSH Bytes
CALL            14 17 14 9 ;CALL function
                           #--- PUSHB_5   21 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   17 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 17 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   21 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   10 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'heart': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   3 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   6 0 13 18 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              18 13 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'heartopen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   24 3 10   ;PUSH Bytes
CALL            10 3 24    ;CALL function
                           #--- PUSHB_4   64 24 45 9 ;PUSH Bytes
CALL            9 45 24 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   27 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   27 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_8   3 9 15 21 24 30 35 39 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              39 35 30 24 21 15 9 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hehebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 21 10  ;PUSH Bytes
CALL            10 21 26   ;CALL function
                           #--- PUSHB_4   0 26 37 9 ;PUSH Bytes
CALL            9 37 26 0  ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hethebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 0 0    ;PUSH Bytes
CALL            0 0 26     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 23 10  ;PUSH Bytes
CALL            10 23 29   ;CALL function
                           #--- PUSHB_4   64 29 40 9 ;PUSH Bytes
CALL            9 40 29 64 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   23 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hiriqhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'holamhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hungarumlaut': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_5   27 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 27 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hyphen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'i': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   23 3 0    ;PUSH Bytes
CALL            0 3 23     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 9 10   ;PUSH Bytes
CALL            10 9 18    ;CALL function
                           #--- PUSHB_4   64 18 1 9 ;PUSH Bytes
CALL            9 1 18 64  ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_3   13 18 10  ;PUSH Bytes
CALL            10 18 13   ;CALL function
                           #--- PUSHB_4   64 13 5 9 ;PUSH Bytes
CALL            9 5 13 64  ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_1   21        ;PUSH Bytes
                           #--- DUP       #21       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_5   22 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 21 ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iacyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   19 26     ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   31 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 31 ;CALL function
                           #--- PUSHB_4   8 31 0 8  ;PUSH Bytes
CALL            8 0 31 8   ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_4   9 19 21 14 ;PUSH Bytes
CALL            14 21 19 9 ;CALL function
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 21 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   40 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_2   5 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_2   26 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_4   8 27 28 43 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 28 27 8 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   5 73      ;PUSH Bytes
SHP[rp1]        73         ;SHift Point using reference point
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SHP[rp2]        67         ;SHift Point using reference point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   45 58     ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp2]        65         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 15 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 3 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_4   0 3 8 8   ;PUSH Bytes
CALL            8 8 3 0    ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp2]        56         ;SHift Point using reference point
                           #--- PUSHB_5   71 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 71 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   15 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   13 25 37  ;PUSH Bytes
IP              37         ;Interpolate Point
IP              25         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   71 76     ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_3   54 66 78  ;PUSH Bytes
IP              78         ;Interpolate Point
IP              66         ;Interpolate Point
IP              54         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_4   0 11 13 78 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              78 13 11 0 ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_6   12 38 39 52 53 79 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              79 53 52 39 38 12 ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   37 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iicyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 25 28  ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   41 1 0    ;PUSH Bytes
CALL            0 1 41     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 14    ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_5   31 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 31 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_4   28 31 36 8 ;PUSH Bytes
CALL            8 36 31 28 ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_5   12 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 12 ;CALL function
                           #--- PUSHB_3   10 17 19  ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_4   15 12 5 8 ;PUSH Bytes
CALL            8 5 12 15  ;CALL function
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 15 10  ;PUSH Bytes
CALL            10 15 25   ;CALL function
                           #--- PUSHB_4   64 25 5 9 ;PUSH Bytes
CALL            9 5 25 64  ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   1 26      ;PUSH Bytes
IP              26         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iishortcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_5   22 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 22 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   8 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ij': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   23 3 0    ;PUSH Bytes
CALL            0 3 23     ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 9 10   ;PUSH Bytes
CALL            10 9 18    ;CALL function
                           #--- PUSHB_4   64 18 1 9 ;PUSH Bytes
CALL            9 1 18 64  ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_3   13 18 10  ;PUSH Bytes
CALL            10 18 13   ;CALL function
                           #--- PUSHB_4   64 13 5 9 ;PUSH Bytes
CALL            9 5 13 64  ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_1   21        ;PUSH Bytes
                           #--- DUP       #21       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_5   22 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 21 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 40 10  ;PUSH Bytes
CALL            10 40 31   ;CALL function
                           #--- PUSHB_4   64 31 24 9 ;PUSH Bytes
CALL            9 24 31 64 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_5   35 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_4   47 40 31 8 ;PUSH Bytes
CALL            8 31 40 47 ;CALL function
                           #--- PUSHB_5   48 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 48 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_5   47 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 47 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   35 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'infinity': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   36 5      ;PUSH Bytes
MIRP[min,black] cvt_5 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   33 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   5 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 5 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   20 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_6   2 8 12 18 26 40 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              40 26 18 12 8 2 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_2   15 5      ;PUSH Bytes
IP              5          ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'invbullet': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   9 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 9  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 7 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   2 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 2 ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'invcircle': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   10 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 10 ;CALL function
                           #--- PUSHB_3   2 2 0     ;PUSH Bytes
CALL            0 2 2      ;CALL function
                           #--- PUSHB_5   4 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 4 ;CALL function
                           #--- PUSHB_5   21 15 0 2 13 ;PUSH Bytes
CALL            13 2 0 15 21 ;CALL function
                           #--- PUSHB_5   21 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 21 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 7 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_5   18 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   18 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   4 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   13 7      ;PUSH Bytes
IP              7          ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'invsmileface': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_5   17 4 0 24 4 ;PUSH Bytes
CALL            4 24 0 4 17 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   42 4 0 14 4 ;PUSH Bytes
CALL            4 14 0 4 42 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   45 6      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   19 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   14 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_2   42 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_3   8 28 36   ;PUSH Bytes
IP              36         ;Interpolate Point
IP              28         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   22 25 30 32 50 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              50 32 30 25 22 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iogonek': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   44 3 0    ;PUSH Bytes
CALL            0 3 44     ;CALL function
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_3   26 31 10  ;PUSH Bytes
CALL            10 31 26   ;CALL function
                           #--- PUSHB_4   64 26 18 9 ;PUSH Bytes
CALL            9 18 26 64 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_1   39        ;PUSH Bytes
                           #--- DUP       #39       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_5   12 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 39 ;CALL function
                           #--- PUSHB_3   39 12 10  ;PUSH Bytes
CALL            10 12 39   ;CALL function
                           #--- PUSHB_4   0 39 6 9  ;PUSH Bytes
CALL            9 6 39 0   ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_1   42        ;PUSH Bytes
                           #--- DUP       #42       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_5   43 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_5   42 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 42 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   12 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iota': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   15 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 15 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   25 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_3   0 23 33   ;PUSH Bytes
IP              33         ;Interpolate Point
IP              23         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   11 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   13 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   13 32     ;PUSH Bytes
IP              32         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iotadieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 3 0    ;PUSH Bytes
CALL            0 3 23     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   13 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_6   0 8 23 29 32 38 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              38 32 29 23 8 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   29 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'iucyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_5   12 34 8 3 13 ;PUSH Bytes
CALL            13 3 8 34 12 ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 15 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_4   21 15 20 8 ;PUSH Bytes
CALL            8 20 15 21 ;CALL function
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   44 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_2   38 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_2   26 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'j': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 3 0    ;PUSH Bytes
CALL            0 3 25     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 16 10   ;PUSH Bytes
CALL            10 16 7    ;CALL function
                           #--- PUSHB_4   0 7 0 9   ;PUSH Bytes
CALL            9 0 7 0    ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_4   23 16 7 8 ;PUSH Bytes
CALL            8 7 16 23  ;CALL function
                           #--- PUSHB_5   24 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 23 ;CALL function
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'k': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_3   24 3 0    ;PUSH Bytes
CALL            0 3 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
                           #--- DUP       #29       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_5   35 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 35 ;CALL function
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   29 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   27 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_3   7 38 40   ;PUSH Bytes
IP              40         ;Interpolate Point
IP              38         ;Interpolate Point
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_3   9 8 26    ;PUSH Bytes
IP              26         ;Interpolate Point
IP              8          ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'kafhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 0 10   ;PUSH Bytes
CALL            10 0 20    ;CALL function
                           #--- PUSHB_4   0 20 11 9 ;PUSH Bytes
CALL            9 11 20 0  ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   3 40      ;PUSH Bytes
IP              40         ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'khacyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   18 30     ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   0 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 0 ;CALL function
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 20 29  ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 7 11 14 ;PUSH Bytes
CALL            14 11 7 9  ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_5   16 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 16 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 19 23 14 ;PUSH Bytes
CALL            14 23 19 9 ;CALL function
                           #--- PUSHB_5   28 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_1   32        ;PUSH Bytes
                           #--- DUP       #32       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   28 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'kjecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   28 0 0    ;PUSH Bytes
CALL            0 0 28     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 10 44   ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_4   9 35 38 14 ;PUSH Bytes
CALL            14 38 35 9 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_5   42 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 42 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   19 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 1 4 14  ;PUSH Bytes
CALL            14 4 1 9   ;CALL function
                           #--- PUSHB_5   8 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 8  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   42 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   24 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_2   19 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   17 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'l': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 16 10   ;PUSH Bytes
CALL            10 16 5    ;CALL function
                           #--- PUSHB_4   64 5 8 9  ;PUSH Bytes
CALL            9 8 5 64   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_3   0 5 10    ;PUSH Bytes
CALL            10 5 0     ;CALL function
                           #--- PUSHB_4   64 0 12 9 ;PUSH Bytes
CALL            9 12 0 64  ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'lamedhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_3   14 3 0    ;PUSH Bytes
CALL            0 3 14     ;CALL function
                           #--- PUSHB_5   17 10 0 14 13 ;PUSH Bytes
CALL            13 14 0 10 17 ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   8 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   0 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'less': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'lessequal': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   22 5      ;PUSH Bytes
MIRP[min,black] cvt_5 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'lfblock': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'lira': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   23 33 10  ;PUSH Bytes
CALL            10 33 23   ;CALL function
                           #--- PUSHB_4   0 23 26 9 ;PUSH Bytes
CALL            9 26 23 0  ;CALL function
                           #--- PUSHB_3   58 2 0    ;PUSH Bytes
CALL            0 2 58     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 58 10   ;PUSH Bytes
CALL            10 58 4    ;CALL function
                           #--- PUSHB_4   0 4 0 9   ;PUSH Bytes
CALL            9 0 4 0    ;CALL function
                           #--- PUSHB_5   42 45 33 58 13 ;PUSH Bytes
CALL            13 58 33 45 42 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_5   52 49 33 58 13 ;PUSH Bytes
CALL            13 58 33 49 52 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_5   52 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 52 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDRP[rp0,rnd,white] 55         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 55 10   ;PUSH Bytes
CALL            10 55 7    ;CALL function
                           #--- PUSHB_4   0 7 61 9  ;PUSH Bytes
CALL            9 61 7 0   ;CALL function
                           #--- PUSHB_3   55 7 10   ;PUSH Bytes
CALL            10 7 55    ;CALL function
                           #--- PUSHB_4   64 55 35 9 ;PUSH Bytes
CALL            9 35 55 64 ;CALL function
                           #--- PUSHB_4   64 55 44 9 ;PUSH Bytes
CALL            9 44 55 64 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_1   41        ;PUSH Bytes
                           #--- DUP       #41       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 41 10  ;PUSH Bytes
CALL            10 41 21   ;CALL function
                           #--- PUSHB_4   64 21 29 9 ;PUSH Bytes
CALL            9 29 21 64 ;CALL function
                           #--- PUSHB_4   64 21 19 9 ;PUSH Bytes
CALL            9 19 21 64 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   41 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_4   38 46 48 53 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              53 48 46 38 ;Interpolate Point
                           #--- PUSHB_2   21 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_4   9 14 16 23 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              23 16 14 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_2   4 52      ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'lozenge': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   4 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'lslash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   15 26 10  ;PUSH Bytes
CALL            10 26 15   ;CALL function
                           #--- PUSHB_4   64 15 10 9 ;PUSH Bytes
CALL            9 10 15 64 ;CALL function
                           #--- PUSHB_4   64 15 19 9 ;PUSH Bytes
CALL            9 19 15 64 ;CALL function
                           #--- PUSHB_3   26 15 10  ;PUSH Bytes
CALL            10 15 26   ;CALL function
                           #--- PUSHB_4   64 26 32 9 ;PUSH Bytes
CALL            9 32 26 64 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_3   0 15 10   ;PUSH Bytes
CALL            10 15 0    ;CALL function
                           #--- PUSHB_4   64 0 24 9 ;PUSH Bytes
CALL            9 24 0 64  ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   7 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ltshade': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   2 6       ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   107 2 0   ;PUSH Bytes
CALL            0 2 107    ;CALL function
                           #--- PUSHB_2   98 102    ;PUSH Bytes
SHP[rp1]        102        ;SHift Point using reference point
SHP[rp1]        98         ;SHift Point using reference point
                           #--- PUSHB_5   104 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 104 ;CALL function
                           #--- PUSHB_2   96 100    ;PUSH Bytes
SHP[rp2]        100        ;SHift Point using reference point
SHP[rp2]        96         ;SHift Point using reference point
                           #--- PUSHB_3   80 1 0    ;PUSH Bytes
CALL            0 1 80     ;CALL function
                           #--- PUSHB_2   72 76     ;PUSH Bytes
SHP[rp1]        76         ;SHift Point using reference point
SHP[rp1]        72         ;SHift Point using reference point
                           #--- PUSHB_5   83 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 83 ;CALL function
                           #--- PUSHB_2   74 78     ;PUSH Bytes
SHP[rp2]        78         ;SHift Point using reference point
SHP[rp2]        74         ;SHift Point using reference point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 30     ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_5   32 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 32 ;CALL function
                           #--- PUSHB_2   24 28     ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_2   38 42     ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_5   44 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 44 ;CALL function
                           #--- PUSHB_2   36 40     ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_5   23 20 11 80 13 ;PUSH Bytes
CALL            13 80 11 20 23 ;CALL function
                           #--- PUSHB_2   12 16     ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
                           #--- PUSHB_2   14 18     ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_5   59 56 11 80 13 ;PUSH Bytes
CALL            13 80 11 56 59 ;CALL function
                           #--- PUSHB_2   48 52     ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
SHP[rp1]        48         ;SHift Point using reference point
                           #--- PUSHB_5   59 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 59 ;CALL function
                           #--- PUSHB_2   50 54     ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_5   68 71 11 80 13 ;PUSH Bytes
CALL            13 80 11 71 68 ;CALL function
                           #--- PUSHB_2   62 66     ;PUSH Bytes
SHP[rp1]        66         ;SHift Point using reference point
SHP[rp1]        62         ;SHift Point using reference point
                           #--- PUSHB_5   68 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 68 ;CALL function
                           #--- PUSHB_2   60 64     ;PUSH Bytes
SHP[rp2]        64         ;SHift Point using reference point
SHP[rp2]        60         ;SHift Point using reference point
                           #--- PUSHB_5   95 92 83 104 13 ;PUSH Bytes
CALL            13 104 83 92 95 ;CALL function
                           #--- PUSHB_2   84 88     ;PUSH Bytes
SHP[rp1]        88         ;SHift Point using reference point
SHP[rp1]        84         ;SHift Point using reference point
                           #--- PUSHB_5   95 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 95 ;CALL function
                           #--- PUSHB_2   86 90     ;PUSH Bytes
SHP[rp2]        90         ;SHift Point using reference point
SHP[rp2]        86         ;SHift Point using reference point
                           #--- PUSHB_1   119       ;PUSH Bytes
MDAP[rnd]       119        ;Move Direct Absolute Point
                           #--- PUSHB_2   110 114   ;PUSH Bytes
SHP[rp1]        114        ;SHift Point using reference point
SHP[rp1]        110        ;SHift Point using reference point
                           #--- PUSHB_5   116 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 116 ;CALL function
                           #--- PUSHB_2   108 112   ;PUSH Bytes
SHP[rp2]        112        ;SHift Point using reference point
SHP[rp2]        108        ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   120       ;PUSH Bytes
MDAP[rnd]       120        ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_4   8 56 80 104 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        104 80 56 8 ;SHift Point using reference point
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_4   9 57 81 105 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        105 81 57 9 ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_4   20 68 92 116 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        116 92 68 20 ;SHift Point using reference point
                           #--- PUSHB_5   46 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 46 ;CALL function
                           #--- PUSHB_4   21 69 93 117 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        117 93 69 21 ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_4   4 52 76 100 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        100 76 52 4 ;SHift Point using reference point
                           #--- PUSHB_5   30 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 30 ;CALL function
                           #--- PUSHB_4   5 53 77 101 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        101 77 53 5 ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_4   16 64 88 112 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        112 88 64 16 ;SHift Point using reference point
                           #--- PUSHB_5   42 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 42 ;CALL function
                           #--- PUSHB_4   17 65 89 113 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        113 89 65 17 ;SHift Point using reference point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_4   0 48 72 96 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        96 72 48 0 ;SHift Point using reference point
                           #--- PUSHB_5   26 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 26 ;CALL function
                           #--- PUSHB_4   1 49 73 97 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        97 73 49 1 ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_4   12 60 84 108 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        108 84 60 12 ;SHift Point using reference point
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_4   13 61 85 109 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        109 85 61 13 ;SHift Point using reference point
                           #--- PUSHB_2   121 1     ;PUSH Bytes
CALL            1 121      ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'm': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   23 36     ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 31 44  ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 44 10   ;PUSH Bytes
CALL            10 44 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   10 3 2 14 ;PUSH Bytes
CALL            14 2 3 10  ;CALL function
                           #--- PUSHB_5   46 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 46 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_5   34 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 34 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_5   22 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 22 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   37 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   12 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   30 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_3   6 10 14   ;PUSH Bytes
IP              14         ;Interpolate Point
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'macron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'macronbelowcmb': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_5   12 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 12 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   12 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 12 ;CALL function
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'memhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_5   36 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   14 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   21 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              21         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_2   24 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'micro': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 24 10   ;PUSH Bytes
CALL            10 24 6    ;CALL function
                           #--- PUSHB_4   64 6 11 9 ;PUSH Bytes
CALL            9 11 6 64  ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_5   16 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 26 10  ;PUSH Bytes
CALL            10 26 33   ;CALL function
                           #--- PUSHB_4   64 33 1 9 ;PUSH Bytes
CALL            9 1 33 64  ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_5   30 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   30 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   6 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_2   14 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'middot': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'minus': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'minute': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_5   4 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 4  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'musicalnote': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_5   35 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 35 ;CALL function
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   28 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 28 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_5   33 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   13 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 13 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   0 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_2   18 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   10 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   15 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_3   13 18 27  ;PUSH Bytes
IP              27         ;Interpolate Point
IP              18         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'musicalnotedbl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_5   8 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 8 ;CALL function
                           #--- PUSHB_4   16 8 4 8  ;PUSH Bytes
CALL            8 4 8 16   ;CALL function
                           #--- PUSHB_5   20 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 20 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_5   18 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   1 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 1 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   6 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   22 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   20 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'n': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 24 31  ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 31 10   ;PUSH Bytes
CALL            10 31 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   9 3 1 14  ;PUSH Bytes
CALL            14 1 3 9   ;CALL function
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 24 23 14 ;PUSH Bytes
CALL            14 23 24 9 ;CALL function
                           #--- PUSHB_5   19 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 19 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   23 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   13 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   6 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'nine': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 9 10   ;PUSH Bytes
CALL            10 9 18    ;CALL function
                           #--- PUSHB_4   0 18 15 9 ;PUSH Bytes
CALL            9 15 18 0  ;CALL function
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_5   23 38 9 0 13 ;PUSH Bytes
CALL            13 0 9 38 23 ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   35 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   5 26      ;PUSH Bytes
IP              26         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ninesuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 3 0    ;PUSH Bytes
CALL            0 3 26     ;CALL function
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 15 ;CALL function
                           #--- PUSHB_3   15 6 10   ;PUSH Bytes
CALL            10 6 15    ;CALL function
                           #--- PUSHB_4   0 15 12 9 ;PUSH Bytes
CALL            9 12 15 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   36 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 36 ;CALL function
                           #--- PUSHB_3   36 23 10  ;PUSH Bytes
CALL            10 23 36   ;CALL function
                           #--- PUSHB_4   64 36 0 9 ;PUSH Bytes
CALL            9 0 36 64  ;CALL function
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   36 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   15 12     ;PUSH Bytes
IP              12         ;Interpolate Point
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'njecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 16 52  ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 38 51  ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_5   36 15 22 31 13 ;PUSH Bytes
CALL            13 31 22 15 36 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp1]        57         ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_5   19 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 19 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_4   16 19 24 8 ;PUSH Bytes
CALL            8 24 19 16 ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   52 13 10  ;PUSH Bytes
CALL            10 13 52   ;CALL function
                           #--- PUSHB_4   64 52 48 9 ;PUSH Bytes
CALL            9 48 52 64 ;CALL function
                           #--- PUSHB_3   13 52 10  ;PUSH Bytes
CALL            10 52 13   ;CALL function
                           #--- PUSHB_4   64 13 40 9 ;PUSH Bytes
CALL            9 40 13 64 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   13 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'nonbreakingspace': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_1   3         ;PUSH Bytes
                           #--- DUP       #3        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 23 ;CALL function
                           #--- PUSHB_4   31 23 41 8 ;PUSH Bytes
CALL            8 41 23 31 ;CALL function
                           #--- PUSHB_5   36 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 36 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   10 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_2   0 41      ;PUSH Bytes
IP              41         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   34 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   29 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   6 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   36 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   17 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_2   31 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_2   20 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'notcontains': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   53 5      ;PUSH Bytes
MIRP[min,black] cvt_5 53   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp1]        56         ;SHift Point using reference point
                           #--- PUSHB_2   9 5       ;PUSH Bytes
MIRP[min,black] cvt_5 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp1]        62         ;SHift Point using reference point
                           #--- PUSHB_2   17 5      ;PUSH Bytes
MIRP[min,black] cvt_5 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   17 12 10  ;PUSH Bytes
CALL            10 12 17   ;CALL function
                           #--- PUSHB_4   64 17 24 9 ;PUSH Bytes
CALL            9 24 17 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_2   35 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              35         ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'notelement': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 13 9 ;PUSH Bytes
CALL            9 13 7 64  ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_2   63 5      ;PUSH Bytes
MIRP[min,black] cvt_5 63   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_2   25 5      ;PUSH Bytes
MIRP[min,black] cvt_5 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   25 60 10  ;PUSH Bytes
CALL            10 60 25   ;CALL function
                           #--- PUSHB_4   64 25 30 9 ;PUSH Bytes
CALL            9 30 25 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   56 6      ;PUSH Bytes
MIRP[min,black] stemw 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp2]        63         ;SHift Point using reference point
                           #--- PUSHB_3   56 22 10  ;PUSH Bytes
CALL            10 22 56   ;CALL function
                           #--- PUSHB_4   64 56 48 9 ;PUSH Bytes
CALL            9 48 56 64 ;CALL function
                           #--- PUSHB_2   3 39      ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   56 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 7       ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'notequal': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   32 35 10  ;PUSH Bytes
CALL            10 35 32   ;CALL function
                           #--- PUSHB_4   64 32 25 9 ;PUSH Bytes
CALL            9 25 32 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   2 38 10   ;PUSH Bytes
CALL            10 38 2    ;CALL function
                           #--- PUSHB_4   64 2 6 9  ;PUSH Bytes
CALL            9 6 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'notsubset': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 2 0     ;PUSH Bytes
CALL            0 2 8      ;CALL function
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_2   48 5      ;PUSH Bytes
MIRP[min,black] cvt_5 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_2   24 5      ;PUSH Bytes
MIRP[min,black] cvt_5 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   50 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 50 ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   50 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'notsuperset': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_2   23 5      ;PUSH Bytes
MIRP[min,black] cvt_5 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   20 5      ;PUSH Bytes
MIRP[min,black] cvt_5 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_3   15 20 10  ;PUSH Bytes
CALL            10 20 15   ;CALL function
                           #--- PUSHB_4   64 15 8 9 ;PUSH Bytes
CALL            9 8 15 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 0 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   0 47      ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_3   0 42 47   ;PUSH Bytes
IP              47         ;Interpolate Point
IP              42         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ntilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 9 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_5   18 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 18 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_5   11 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 11 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'nu': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   37 3 0    ;PUSH Bytes
CALL            0 3 37     ;CALL function
                           #--- PUSHB_2   30 5      ;PUSH Bytes
MIRP[min,black] cvt_5 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   37 3 0    ;PUSH Bytes
CALL            0 3 37     ;CALL function
                           #--- PUSHB_5   34 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 34 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   74        ;PUSH Bytes
SHP[rp2]        74         ;SHift Point using reference point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 5      ;PUSH Bytes
MIRP[min,black] cvt_5 46   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   81        ;PUSH Bytes
MDAP[rnd]       81         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   56 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 56 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_5   36 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_5   42 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 42 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   70 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 70 ;CALL function
                           #--- PUSHB_3   70 11 10  ;PUSH Bytes
CALL            10 11 70   ;CALL function
                           #--- PUSHB_4   64 70 77 9 ;PUSH Bytes
CALL            9 77 70 64 ;CALL function
                           #--- PUSHB_3   11 70 10  ;PUSH Bytes
CALL            10 70 11   ;CALL function
                           #--- PUSHB_4   64 11 2 9 ;PUSH Bytes
CALL            9 2 11 64  ;CALL function
                           #--- PUSHB_2   82 1      ;PUSH Bytes
CALL            1 82       ;CALL function
                           #--- PUSHB_2   56 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   42 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_3   14 22 29  ;PUSH Bytes
IP              29         ;Interpolate Point
IP              22         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_5   6 46 53 59 62 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              62 59 53 46 6 ;Interpolate Point
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_5   40 49 52 64 74 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              74 64 52 49 40 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'numbersign': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   59 1 0    ;PUSH Bytes
CALL            0 1 59     ;CALL function
                           #--- PUSHB_4   5 6 14 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp1]        60 14 6 5  ;SHift Point using reference point
                           #--- PUSHB_2   54 4      ;PUSH Bytes
MIRP[min,black] stemt 54   ;Move Indirect Relative Point
                           #--- PUSHB_4   19 53 66 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        67 66 53 19 ;SHift Point using reference point
                           #--- PUSHB_3   59 54 10  ;PUSH Bytes
CALL            10 54 59   ;CALL function
                           #--- PUSHB_4   64 59 63 9 ;PUSH Bytes
CALL            9 63 59 64 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_3   25 35 45  ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
SHP[rp1]        35         ;SHift Point using reference point
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_4   20 52 68 69 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        69 68 52 20 ;SHift Point using reference point
                           #--- PUSHB_3   46 51 10  ;PUSH Bytes
CALL            10 51 46   ;CALL function
                           #--- PUSHB_4   64 46 29 9 ;PUSH Bytes
CALL            9 29 46 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 7 10   ;PUSH Bytes
CALL            10 7 13    ;CALL function
                           #--- PUSHB_4   64 13 23 9 ;PUSH Bytes
CALL            9 23 13 64 ;CALL function
                           #--- PUSHB_4   64 13 17 9 ;PUSH Bytes
CALL            9 17 13 64 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_1   34        ;PUSH Bytes
                           #--- DUP       #34       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   34 26 10  ;PUSH Bytes
CALL            10 26 34   ;CALL function
                           #--- PUSHB_4   64 34 48 9 ;PUSH Bytes
CALL            9 48 34 64 ;CALL function
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   42 61     ;PUSH Bytes
SDPVTL[orthog]  61 42      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[no-rnd]    42         ;Move Direct Absolute Point
                           #--- PUSHB_1   61        ;PUSH Bytes
MDRP[grey]      61         ;Move Direct Relative Point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[grey]      2          ;Move Direct Relative Point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
SDPVTL[orthog]  6 32       ;Set Dual Projection Vector To Line
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[no-rnd]    6          ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[grey]      32         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 14   ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[grey]      27         ;Move Direct Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_4   3 36 2 19 ;PUSH Bytes
CALL            19 2 36 3  ;CALL function
                           #--- PUSHB_4   4 36 2 19 ;PUSH Bytes
CALL            19 2 36 4  ;CALL function
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_4   5 36 2 19 ;PUSH Bytes
CALL            19 2 36 5  ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_4   19 27 14 19 ;PUSH Bytes
CALL            19 14 27 19 ;CALL function
                           #--- PUSHB_4   20 27 14 19 ;PUSH Bytes
CALL            19 14 27 20 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_4   35 36 2 19 ;PUSH Bytes
CALL            19 2 36 35 ;CALL function
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_4   43 42 61 19 ;PUSH Bytes
CALL            19 61 42 43 ;CALL function
                           #--- PUSHB_4   44 42 61 19 ;PUSH Bytes
CALL            19 61 42 44 ;CALL function
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_4   45 42 61 19 ;PUSH Bytes
CALL            19 61 42 45 ;CALL function
                           #--- PUSHB_4   52 42 61 19 ;PUSH Bytes
CALL            19 61 42 52 ;CALL function
                           #--- PUSHB_4   53 42 61 19 ;PUSH Bytes
CALL            19 61 42 53 ;CALL function
                           #--- PUSHB_4   60 42 61 19 ;PUSH Bytes
CALL            19 61 42 60 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_4   66 32 6 19 ;PUSH Bytes
CALL            19 6 32 66 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_4   67 36 2 19 ;PUSH Bytes
CALL            19 2 36 67 ;CALL function
                           #--- PUSHB_4   68 36 2 19 ;PUSH Bytes
CALL            19 2 36 68 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_4   69 32 6 19 ;PUSH Bytes
CALL            19 6 32 69 ;CALL function
                           #--- PUSHB_3   43 42 61  ;PUSH Bytes
                           #--- DUP       #61       ;DUPlicate top stack element
ROLL            61 61 42   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              43         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_3   3 36 2    ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
IP              3          ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    10 27 32 36 44 61 2 3 4 42 43 ;PUSH N Bytes
MDAP[no-rnd]    43         ;Move Direct Absolute Point
MDAP[no-rnd]    42         ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    61         ;Move Direct Absolute Point
MDAP[no-rnd]    44         ;Move Direct Absolute Point
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    24 5 6 14 19 20 27 32 35 36 44 45 52 53 60 61 66 67 68 69 2 3 4 42 43 ;PUSH N Bytes
MDAP[no-rnd]    43         ;Move Direct Absolute Point
MDAP[no-rnd]    42         ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    69         ;Move Direct Absolute Point
MDAP[no-rnd]    68         ;Move Direct Absolute Point
MDAP[no-rnd]    67         ;Move Direct Absolute Point
MDAP[no-rnd]    66         ;Move Direct Absolute Point
MDAP[no-rnd]    61         ;Move Direct Absolute Point
MDAP[no-rnd]    60         ;Move Direct Absolute Point
MDAP[no-rnd]    53         ;Move Direct Absolute Point
MDAP[no-rnd]    52         ;Move Direct Absolute Point
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    44         ;Move Direct Absolute Point
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    20         ;Move Direct Absolute Point
MDAP[no-rnd]    19         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    5          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   9 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'nunhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   14 7 10   ;PUSH Bytes
CALL            10 7 14    ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_4   0 14 24 9 ;PUSH Bytes
CALL            9 24 14 0  ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'o': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   19 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   8 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ocyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 22 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 21      ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_4   9 11 10 14 ;PUSH Bytes
CALL            14 10 11 9 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_5   4 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 4  ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 31 30 14 ;PUSH Bytes
CALL            14 30 31 9 ;CALL function
                           #--- PUSHB_5   24 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 24 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'oe': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_5   5 44 22 28 13 ;PUSH Bytes
CALL            13 28 22 44 5 ;CALL function
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   13 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_3   25 35 41  ;PUSH Bytes
IP              41         ;Interpolate Point
IP              35         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_2   28 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ogonek': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   19 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 19 ;CALL function
                           #--- PUSHB_3   19 12 10  ;PUSH Bytes
CALL            10 12 19   ;CALL function
                           #--- PUSHB_4   0 19 6 9  ;PUSH Bytes
CALL            9 6 19 0   ;CALL function
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ohorn': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   8 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_3   20 25 27  ;PUSH Bytes
IP              27         ;Interpolate Point
IP              25         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_4   10 15 30 33 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              33 30 15 10 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   15 17 22  ;PUSH Bytes
IP              22         ;Interpolate Point
IP              17         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   13 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'omega': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp1]        53         ;SHift Point using reference point
                           #--- PUSHB_2   20 5      ;PUSH Bytes
MIRP[min,black] cvt_5 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp1]        63         ;SHift Point using reference point
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   22 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 22 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
                           #--- DUP       #10       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_5   16 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 16 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_5   38 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   60 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 60 ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP0            60         ;Set Reference Point 0
                           #--- PUSHB_1   56        ;PUSH Bytes
                           #--- DUP       #56       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 56         ;Move Direct Relative Point
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_5   51 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_5   56 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 56 ;CALL function
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   22 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   0 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   38 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_2   45 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   41 63     ;PUSH Bytes
IP              63         ;Interpolate Point
IP              41         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_4   6 34 45 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 45 34 6 ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_4   8 51 56 58 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              58 56 51 8 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'omegapi': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_2   32 5      ;PUSH Bytes
MIRP[min,black] cvt_5 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   39 5      ;PUSH Bytes
MIRP[min,black] cvt_5 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   34 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   50 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   20 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 20 ;CALL function
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   8 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_2   32 0      ;PUSH Bytes
IP              0          ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_2   23 58     ;PUSH Bytes
IP              58         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_3   20 6 46   ;PUSH Bytes
IP              46         ;Interpolate Point
IP              6          ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_3   8 16 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              16         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'omicron': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_4   8 2 0 14  ;PUSH Bytes
CALL            14 0 2 8   ;CALL function
                           #--- PUSHB_5   19 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 19 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   31 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   12 6 29 33 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              33 29 6 12 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'one': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   14 3 0    ;PUSH Bytes
CALL            0 3 14     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 4 10   ;PUSH Bytes
CALL            10 4 15    ;CALL function
                           #--- PUSHB_4   64 15 18 9 ;PUSH Bytes
CALL            9 18 15 64 ;CALL function
                           #--- PUSHB_3   4 15 10   ;PUSH Bytes
CALL            10 15 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'oneeighth': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_5   34 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 34 ;CALL function
                           #--- PUSHB_3   37 3 0    ;PUSH Bytes
CALL            0 3 37     ;CALL function
                           #--- PUSHB_3   70 2 0    ;PUSH Bytes
CALL            0 2 70     ;CALL function
                           #--- PUSHB_3   56 2 0    ;PUSH Bytes
CALL            0 2 56     ;CALL function
                           #--- PUSHB_5   30 25 5 70 13 ;PUSH Bytes
CALL            13 70 5 25 30 ;CALL function
                           #--- PUSHB_5   30 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 30 ;CALL function
                           #--- PUSHB_5   44 48 5 70 13 ;PUSH Bytes
CALL            13 70 5 48 44 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_5   44 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 44 ;CALL function
                           #--- PUSHB_5   15 20 5 70 13 ;PUSH Bytes
CALL            13 70 5 20 15 ;CALL function
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_3   38 49 10  ;PUSH Bytes
CALL            10 49 38   ;CALL function
                           #--- PUSHB_4   64 38 41 9 ;PUSH Bytes
CALL            9 41 38 64 ;CALL function
                           #--- PUSHB_3   49 38 10  ;PUSH Bytes
CALL            10 38 49   ;CALL function
                           #--- PUSHB_4   64 49 46 9 ;PUSH Bytes
CALL            9 46 49 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   2 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 2 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   8 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   62 65     ;PUSH Bytes
IP              65         ;Interpolate Point
IP              62         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_6   5 22 15 26 70 73 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              73 70 26 15 22 5 ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_4   8 2 62 65 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              65 62 2 8  ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   10 0      ;PUSH Bytes
IP              0          ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_2   48 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_4   12 23 27 18 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              18 27 23 12 ;Interpolate Point
                           #--- PUSHB_2   70 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_3   50 53 73  ;PUSH Bytes
IP              73         ;Interpolate Point
IP              53         ;Interpolate Point
IP              50         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'onehalf': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   53 0 0    ;PUSH Bytes
CALL            0 0 53     ;CALL function
                           #--- PUSHB_5   46 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 46 ;CALL function
                           #--- PUSHB_3   53 0 0    ;PUSH Bytes
CALL            0 0 53     ;CALL function
                           #--- PUSHB_2   49 4      ;PUSH Bytes
MIRP[min,black] stemt 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_5   7 11 53 33 13 ;PUSH Bytes
CALL            13 33 53 11 7 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   7 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 7 ;CALL function
                           #--- PUSHB_5   41 59 53 33 13 ;PUSH Bytes
CALL            13 33 53 59 41 ;CALL function
                           #--- PUSHB_5   41 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 41 ;CALL function
                           #--- PUSHB_3   59 41 10  ;PUSH Bytes
CALL            10 41 59   ;CALL function
                           #--- PUSHB_4   0 59 64 9 ;PUSH Bytes
CALL            9 64 59 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_5   43 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 43 ;CALL function
                           #--- PUSHB_3   57 43 10  ;PUSH Bytes
CALL            10 43 57   ;CALL function
                           #--- PUSHB_4   64 57 53 9 ;PUSH Bytes
CALL            9 53 57 64 ;CALL function
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   25 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_4   33 36 41 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 41 36 33 ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   47 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              47         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_2   28 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_2   11 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   43 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_2   33 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_3   13 16 36  ;PUSH Bytes
IP              36         ;Interpolate Point
IP              16         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'onesuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'openbullet': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   17 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   7 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ordfeminine': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_5   25 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 25 ;CALL function
                           #--- PUSHB_3   25 3 10   ;PUSH Bytes
CALL            10 3 25    ;CALL function
                           #--- PUSHB_4   0 25 28 9 ;PUSH Bytes
CALL            9 28 25 0  ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_5   49 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 49 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_5   40 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_1   7         ;PUSH Bytes
                           #--- DUP       #7        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_5   11 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 11 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_5   20 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 20 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   12 22     ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_5   7 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 7 ;CALL function
                           #--- PUSHB_3   7 31 10   ;PUSH Bytes
CALL            10 31 7    ;CALL function
                           #--- PUSHB_4   64 7 10 9 ;PUSH Bytes
CALL            9 10 7 64  ;CALL function
                           #--- PUSHB_3   31 7 10   ;PUSH Bytes
CALL            10 7 31    ;CALL function
                           #--- PUSHB_4   0 31 0 9  ;PUSH Bytes
CALL            9 0 31 0   ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   37 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   15 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_2   34 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_3   17 31 37  ;PUSH Bytes
IP              37         ;Interpolate Point
IP              31         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ordmasculine': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_5   13 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 13 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   24 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 24 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   18 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 18 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'orthogonal': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 11 9 ;PUSH Bytes
CALL            9 11 0 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 4 9  ;PUSH Bytes
CALL            9 4 0 64   ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'oslash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 36 10   ;PUSH Bytes
CALL            10 36 3    ;CALL function
                           #--- PUSHB_4   64 3 29 9 ;PUSH Bytes
CALL            9 29 3 64  ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   44 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   11 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_6   8 22 24 6 31 39 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              39 31 6 24 22 8 ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   1 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   8 17      ;PUSH Bytes
IP              17         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_4   19 3 30 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 30 3 19 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   1 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'p': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 37      ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   26 15 10  ;PUSH Bytes
CALL            10 15 26   ;CALL function
                           #--- PUSHB_4   64 26 0 9 ;PUSH Bytes
CALL            9 0 26 64  ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   7 26 24 14 ;PUSH Bytes
CALL            14 24 26 7 ;CALL function
                           #--- PUSHB_5   19 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 19 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   32 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_4   6 12 34 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 34 12 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_3   9 32 37   ;PUSH Bytes
IP              37         ;Interpolate Point
IP              32         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   2 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   0 4       ;PUSH Bytes
IP              4          ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'paragraph': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_5   38 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 38 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   2 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 2 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   34 6 0 54 4 ;PUSH Bytes
CALL            4 54 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_5   39 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 39 ;CALL function
                           #--- PUSHB_3   3 39 10   ;PUSH Bytes
CALL            10 39 3    ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_5   17 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 17 ;CALL function
                           #--- PUSHB_3   17 43 10  ;PUSH Bytes
CALL            10 43 17   ;CALL function
                           #--- PUSHB_4   64 17 20 9 ;PUSH Bytes
CALL            9 20 17 64 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   43 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_4   24 39 41 43 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 41 39 24 ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_3   4 29 30   ;PUSH Bytes
IP              30         ;Interpolate Point
IP              29         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'parenleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 3 0     ;PUSH Bytes
CALL            0 3 4      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'parenright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 3 0    ;PUSH Bytes
CALL            0 3 12     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'parenrightsuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_3   6 26 41   ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
                           #--- DUP       #27       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 14 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   14 26 10  ;PUSH Bytes
CALL            10 26 14   ;CALL function
                           #--- PUSHB_4   64 14 18 9 ;PUSH Bytes
CALL            9 18 14 64 ;CALL function
                           #--- PUSHB_3   26 14 10  ;PUSH Bytes
CALL            10 14 26   ;CALL function
                           #--- PUSHB_4   64 26 24 9 ;PUSH Bytes
CALL            9 24 26 64 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_3   41 6 10   ;PUSH Bytes
CALL            10 6 41    ;CALL function
                           #--- PUSHB_4   64 41 44 9 ;PUSH Bytes
CALL            9 44 41 64 ;CALL function
                           #--- PUSHB_3   6 41 10   ;PUSH Bytes
CALL            10 41 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   6 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_2   33 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'partialdiff': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_5   18 26 13 3 13 ;PUSH Bytes
CALL            13 3 13 26 18 ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   29 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_3   3 0 23    ;PUSH Bytes
IP              23         ;Interpolate Point
IP              0          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_3   18 13 20  ;PUSH Bytes
IP              20         ;Interpolate Point
IP              13         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   16 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'patahhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   4 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 4 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'pehebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 0 0    ;PUSH Bytes
CALL            0 0 50     ;CALL function
                           #--- PUSHB_2   55 4      ;PUSH Bytes
MIRP[min,black] stemt 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 14 ;CALL function
                           #--- PUSHB_3   20 14 10  ;PUSH Bytes
CALL            10 14 20   ;CALL function
                           #--- PUSHB_4   64 20 53 9 ;PUSH Bytes
CALL            9 53 20 64 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   14 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_3   6 10 24   ;PUSH Bytes
IP              24         ;Interpolate Point
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_2   20 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'pemiddlehookcyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 46 54   ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SHP[rp2]        46         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 19      ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_2   36 5      ;PUSH Bytes
MIRP[min,black] cvt_5 36   ;Move Indirect Relative Point
                           #--- PUSHB_5   22 42 8 15 13 ;PUSH Bytes
CALL            13 15 8 42 22 ;CALL function
                           #--- PUSHB_2   22 5      ;PUSH Bytes
MIRP[min,black] cvt_5 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_4   9 11 10 14 ;PUSH Bytes
CALL            14 10 11 9 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_5   4 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 4  ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_4   9 54 53 14 ;PUSH Bytes
CALL            14 53 54 9 ;CALL function
                           #--- PUSHB_5   48 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 48 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   39 28 10  ;PUSH Bytes
CALL            10 28 39   ;CALL function
                           #--- PUSHB_4   64 39 35 9 ;PUSH Bytes
CALL            9 35 39 64 ;CALL function
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   39 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   22 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'percent': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   46 0 0    ;PUSH Bytes
CALL            0 0 46     ;CALL function
                           #--- PUSHB_5   58 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 58 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_5   40 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 40 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_5   55 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_5   43 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 43 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   32 33     ;PUSH Bytes
SDPVTL[orthog]  33 32      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[no-rnd]    32         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[grey]      33         ;Move Direct Relative Point
                           #--- PUSHB_2   25 8      ;PUSH Bytes
MIRP[rp0,min,black] cvt_8 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[grey]      24         ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   24 25 32 33 ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   24 25 32 33 ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   15 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_4   6 12 0 18 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              18 0 12 6  ;Interpolate Point
                           #--- PUSHB_2   3 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   40 46 52  ;PUSH Bytes
IP              52         ;Interpolate Point
IP              46         ;Interpolate Point
IP              40         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   43 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_2   12 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'period': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   6 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 6 ;CALL function
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   6 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   10 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 10 ;CALL function
                           #--- PUSHB_5   10 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 10 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'perpendicular': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   1 0 10    ;PUSH Bytes
CALL            10 0 1     ;CALL function
                           #--- PUSHB_4   64 1 3 9  ;PUSH Bytes
CALL            9 3 1 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 5 ;CALL function
                           #--- PUSHB_3   5 2 10    ;PUSH Bytes
CALL            10 2 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_3   2 5 10    ;PUSH Bytes
CALL            10 5 2     ;CALL function
                           #--- PUSHB_4   64 2 0 9  ;PUSH Bytes
CALL            9 0 2 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'perthousand': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 0 0    ;PUSH Bytes
CALL            0 0 43     ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
SHP[rp1]        64         ;SHift Point using reference point
                           #--- PUSHB_5   53 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 53 ;CALL function
                           #--- PUSHB_1   74        ;PUSH Bytes
SHP[rp2]        74         ;SHift Point using reference point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_5   49 37 43 32 13 ;PUSH Bytes
CALL            13 32 43 37 49 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_5   49 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 49 ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_5   16 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 16 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   79        ;PUSH Bytes
MDAP[rnd]       79         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_5   30 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_5   51 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_5   19 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   40 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_5   72 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 72 ;CALL function
                           #--- PUSHB_1   72        ;PUSH Bytes
SRP0            72         ;Set Reference Point 0
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_5   61 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 61 ;CALL function
                           #--- PUSHB_2   80 1      ;PUSH Bytes
CALL            1 80       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   8 9       ;PUSH Bytes
SDPVTL[orthog]  9 8        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[no-rnd]    8          ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[grey]      9          ;Move Direct Relative Point
                           #--- PUSHB_2   1 8       ;PUSH Bytes
MIRP[rp0,min,black] cvt_8 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[grey]      0          ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   0 1 8 9   ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   0 1 8 9   ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   30 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   28 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_4   22 27 32 16 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              16 32 27 22 ;Interpolate Point
                           #--- PUSHB_2   19 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   37 43 49 53 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              53 49 43 37 ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_2   77 72     ;PUSH Bytes
SRP1            72         ;Set Reference Point 1
SRP2            77         ;Set Reference Point 2
                           #--- PUSHB_3   58 64 14  ;PUSH Bytes
IP              14         ;Interpolate Point
IP              64         ;Interpolate Point
IP              58         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   49 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_4   46 40 61 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              67 61 40 46 ;Interpolate Point
                           #--- PUSHB_2   28 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   19 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'phi': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 37 10  ;PUSH Bytes
CALL            10 37 21   ;CALL function
                           #--- PUSHB_4   64 21 17 9 ;PUSH Bytes
CALL            9 17 21 64 ;CALL function
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_5   29 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'phi1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   41 7 10   ;PUSH Bytes
CALL            10 7 41    ;CALL function
                           #--- PUSHB_4   64 41 37 9 ;PUSH Bytes
CALL            9 37 41 64 ;CALL function
                           #--- PUSHB_3   22 3 0    ;PUSH Bytes
CALL            0 3 22     ;CALL function
                           #--- PUSHB_3   47 1 0    ;PUSH Bytes
CALL            0 1 47     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   0 18      ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   9 24      ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 7       ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   29 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'plus': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   14 9 10   ;PUSH Bytes
CALL            10 9 14    ;CALL function
                           #--- PUSHB_4   64 14 18 9 ;PUSH Bytes
CALL            9 18 14 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   4 7 10    ;PUSH Bytes
CALL            10 7 4     ;CALL function
                           #--- PUSHB_4   64 4 1 9  ;PUSH Bytes
CALL            9 1 4 64   ;CALL function
                           #--- PUSHB_3   7 4 10    ;PUSH Bytes
CALL            10 4 7     ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'plusminus': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 3 0    ;PUSH Bytes
CALL            0 3 16     ;CALL function
                           #--- PUSHB_5   12 9 29 16 13 ;PUSH Bytes
CALL            13 16 29 9 12 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   9 12 10   ;PUSH Bytes
CALL            10 12 9    ;CALL function
                           #--- PUSHB_4   64 9 6 9  ;PUSH Bytes
CALL            9 6 9 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   4 7 10    ;PUSH Bytes
CALL            10 7 4     ;CALL function
                           #--- PUSHB_4   64 4 27 9 ;PUSH Bytes
CALL            9 27 4 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   7 4 10    ;PUSH Bytes
CALL            10 4 7     ;CALL function
                           #--- PUSHB_4   64 7 23 9 ;PUSH Bytes
CALL            9 23 7 64  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'primemod': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_5   0 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 1 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'propersuperset': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 1 ;CALL function
                           #--- PUSHB_3   15 1 10   ;PUSH Bytes
CALL            10 1 15    ;CALL function
                           #--- PUSHB_4   0 15 7 9  ;PUSH Bytes
CALL            9 7 15 0   ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   1 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'proportional': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_2   37 5      ;PUSH Bytes
MIRP[min,black] cvt_5 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 1 ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'psi': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   39 0 0    ;PUSH Bytes
CALL            0 0 39     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_3   39 7 10   ;PUSH Bytes
CALL            10 7 39    ;CALL function
                           #--- PUSHB_4   64 39 35 9 ;PUSH Bytes
CALL            9 35 39 64 ;CALL function
                           #--- PUSHB_3   12 3 0    ;PUSH Bytes
CALL            0 3 12     ;CALL function
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_5   23 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 23 ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 44      ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'q': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 1 0    ;PUSH Bytes
CALL            0 1 17     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   15 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 3 10   ;PUSH Bytes
CALL            10 3 22    ;CALL function
                           #--- PUSHB_4   64 22 19 9 ;PUSH Bytes
CALL            9 19 22 64 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_4   7 22 25 14 ;PUSH Bytes
CALL            14 25 22 7 ;CALL function
                           #--- PUSHB_5   1 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   25 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 25 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   1 37      ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   6 12 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 12 6 ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_3   9 31 37   ;PUSH Bytes
IP              37         ;Interpolate Point
IP              31         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   17 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'qamatshebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_5   7 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 7 ;CALL function
                           #--- PUSHB_3   1 7 10    ;PUSH Bytes
CALL            10 7 1     ;CALL function
                           #--- PUSHB_4   64 1 19 9 ;PUSH Bytes
CALL            9 19 1 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   16 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 16 ;CALL function
                           #--- PUSHB_3   16 22 10  ;PUSH Bytes
CALL            10 22 16   ;CALL function
                           #--- PUSHB_4   64 16 11 9 ;PUSH Bytes
CALL            9 11 16 64 ;CALL function
                           #--- PUSHB_3   22 16 10  ;PUSH Bytes
CALL            10 16 22   ;CALL function
                           #--- PUSHB_4   64 22 4 9 ;PUSH Bytes
CALL            9 4 22 64  ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'qofhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 18 10   ;PUSH Bytes
CALL            10 18 8    ;CALL function
                           #--- PUSHB_4   0 8 13 9  ;PUSH Bytes
CALL            9 13 8 0   ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   8 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   0 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'questiondown': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   56 0 0    ;PUSH Bytes
CALL            0 0 56     ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_4   3 32 47 51 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        51 47 32 3 ;SHift Point using reference point
                           #--- PUSHB_3   56 0 0    ;PUSH Bytes
CALL            0 0 56     ;CALL function
                           #--- PUSHB_5   36 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 36 ;CALL function
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_2   4 16      ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_5   14 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 14 ;CALL function
                           #--- PUSHB_4   21 10 14 8 ;PUSH Bytes
CALL            8 14 10 21 ;CALL function
                           #--- PUSHB_5   27 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_1   50        ;PUSH Bytes
                           #--- DUP       #50       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_2   59 4      ;PUSH Bytes
MIRP[min,black] stemt 59   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   53 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 53 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   48 32 10  ;PUSH Bytes
CALL            10 32 48   ;CALL function
                           #--- PUSHB_4   64 48 7 9 ;PUSH Bytes
CALL            9 7 48 64  ;CALL function
                           #--- PUSHB_4   64 48 44 9 ;PUSH Bytes
CALL            9 44 48 64 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
                           #--- DUP       #33       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   51 58     ;PUSH Bytes
SDPVTL[orthog]  58 51      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[no-rnd]    58         ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[no-rnd]    3          ;Move Direct Absolute Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 51   ;Move Indirect Relative Point
                           #--- PUSHB_4   50 51 58 19 ;PUSH Bytes
CALL            19 58 51 50 ;CALL function
                           #--- PUSHB_4   59 51 58 19 ;PUSH Bytes
CALL            19 58 51 59 ;CALL function
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[no-rnd]    58         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_5   3 4 50 51 59 ;PUSH Bytes
MDAP[no-rnd]    59         ;Move Direct Absolute Point
MDAP[no-rnd]    51         ;Move Direct Absolute Point
MDAP[no-rnd]    50         ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   12 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   59 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_2   31 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   18 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedbl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_5   5 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 5  ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 2 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   10 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 10 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   15 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedblleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 3 0    ;PUSH Bytes
CALL            0 3 11     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_5   7 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 7  ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotesinglbase': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 3 0    ;PUSH Bytes
CALL            0 3 11     ;CALL function
                           #--- PUSHB_5   7 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 7  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 2 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   2 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotesingle': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_5   5 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 5  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 2 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'r': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   9 0 10    ;PUSH Bytes
CALL            10 0 9     ;CALL function
                           #--- PUSHB_4   0 9 6 9   ;PUSH Bytes
CALL            9 6 9 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   13 24 10  ;PUSH Bytes
CALL            10 24 13   ;CALL function
                           #--- PUSHB_4   64 13 16 9 ;PUSH Bytes
CALL            9 16 13 64 ;CALL function
                           #--- PUSHB_3   24 13 10  ;PUSH Bytes
CALL            10 13 24   ;CALL function
                           #--- PUSHB_4   64 24 28 9 ;PUSH Bytes
CALL            9 28 24 64 ;CALL function
                           #--- PUSHB_4   64 24 20 9 ;PUSH Bytes
CALL            9 20 24 64 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   29 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'rafehebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   4 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 4 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'reflexsubset': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 16 10   ;PUSH Bytes
CALL            10 16 7    ;CALL function
                           #--- PUSHB_4   0 7 0 9   ;PUSH Bytes
CALL            9 0 7 0    ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'reshhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 7 10   ;PUSH Bytes
CALL            10 7 12    ;CALL function
                           #--- PUSHB_4   0 12 23 9 ;PUSH Bytes
CALL            9 23 12 0  ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'revlogicalnot': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 8 10    ;PUSH Bytes
CALL            10 8 3     ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 7 10    ;PUSH Bytes
CALL            10 7 4     ;CALL function
                           #--- PUSHB_4   0 4 0 9   ;PUSH Bytes
CALL            9 0 4 0    ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ring': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   16 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 16 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   13 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'rtblock': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    's': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 0 0    ;PUSH Bytes
CALL            0 0 25     ;CALL function
                           #--- PUSHB_5   30 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 30 ;CALL function
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_5   3 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDRP[rp0,rnd,white] 37         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   18 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_4   0 14 3 47 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              47 3 14 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_2   18 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   14 39 40  ;PUSH Bytes
IP              40         ;Interpolate Point
IP              39         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   11 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'samekhhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   53 0 0    ;PUSH Bytes
CALL            0 0 53     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDRP[rp0,rnd,white] 55         ;Move Direct Relative Point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   55 13 10  ;PUSH Bytes
CALL            10 13 55   ;CALL function
                           #--- PUSHB_4   64 55 33 9 ;PUSH Bytes
CALL            9 33 55 64 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   13 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   47 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              47         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'scedilla': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   45 0 0    ;PUSH Bytes
CALL            0 0 45     ;CALL function
                           #--- PUSHB_5   50 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 50 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
                           #--- DUP       #38       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_5   54 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 54 ;CALL function
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_3   65 1 0    ;PUSH Bytes
CALL            0 1 65     ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp1]        69         ;SHift Point using reference point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   65 1 0    ;PUSH Bytes
CALL            0 1 65     ;CALL function
                           #--- PUSHB_5   3 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 3 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   34 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 34 ;CALL function
                           #--- PUSHB_3   34 25 10  ;PUSH Bytes
CALL            10 25 34   ;CALL function
                           #--- PUSHB_4   0 34 31 9 ;PUSH Bytes
CALL            9 31 34 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_5   22 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 22 ;CALL function
                           #--- PUSHB_3   36 22 10  ;PUSH Bytes
CALL            10 22 36   ;CALL function
                           #--- PUSHB_4   0 36 28 9 ;PUSH Bytes
CALL            9 28 36 0  ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   22 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   17 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_4   0 14 3 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              67 3 14 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_2   54 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_2   17 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   14 59 60  ;PUSH Bytes
IP              60         ;Interpolate Point
IP              59         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   11 62     ;PUSH Bytes
IP              62         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_1   67        ;PUSH Bytes
IP              67         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'second': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 3 0     ;PUSH Bytes
CALL            0 3 9      ;CALL function
                           #--- PUSHB_5   6 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 6  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'section': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 2 0    ;PUSH Bytes
CALL            0 2 44     ;CALL function
                           #--- PUSHB_2   4 5       ;PUSH Bytes
MIRP[min,black] cvt_5 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 2 0    ;PUSH Bytes
CALL            0 2 44     ;CALL function
                           #--- PUSHB_5   1 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 1 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_5   25 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 25 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_5   27 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_1   52        ;PUSH Bytes
                           #--- DUP       #52       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 52         ;Move Direct Relative Point
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_4   41 27 23 8 ;PUSH Bytes
CALL            8 23 27 41 ;CALL function
                           #--- PUSHB_5   7 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 7 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_5   46 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 46 ;CALL function
                           #--- PUSHB_4   18 46 2 8 ;PUSH Bytes
CALL            8 2 46 18  ;CALL function
                           #--- PUSHB_5   31 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 31 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_5   18 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 18 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_1   61        ;PUSH Bytes
                           #--- DUP       #61       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 61         ;Move Direct Relative Point
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   52 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   34 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              34         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_6   9 33 47 49 54 55 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              55 54 49 47 33 9 ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_3   10 56 57  ;PUSH Bytes
IP              57         ;Interpolate Point
IP              56         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_3   16 18 31  ;PUSH Bytes
IP              31         ;Interpolate Point
IP              18         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_6   9 13 33 37 50 57 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              57 50 37 33 13 9 ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_3   7 39 41   ;PUSH Bytes
IP              41         ;Interpolate Point
IP              39         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'segolhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 1 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   7 11      ;PUSH Bytes
CALL            11 7       ;CALL function
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   26 11     ;PUSH Bytes
CALL            11 26      ;CALL function
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'semicolon': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_5   16 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 16 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 13 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   13 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'seven': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   0 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   3 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'seveneighths': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_5   51 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 51 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 3 10   ;PUSH Bytes
CALL            10 3 15    ;CALL function
                           #--- PUSHB_4   0 15 8 9  ;PUSH Bytes
CALL            9 8 15 0   ;CALL function
                           #--- PUSHB_3   65 2 0    ;PUSH Bytes
CALL            0 2 65     ;CALL function
                           #--- PUSHB_5   47 42 22 65 13 ;PUSH Bytes
CALL            13 65 22 42 47 ;CALL function
                           #--- PUSHB_5   47 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 47 ;CALL function
                           #--- PUSHB_5   37 32 8 65 13 ;PUSH Bytes
CALL            13 65 8 32 37 ;CALL function
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_3   6 11 10   ;PUSH Bytes
CALL            10 11 6    ;CALL function
                           #--- PUSHB_4   64 6 5 9  ;PUSH Bytes
CALL            9 5 6 64   ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_5   49 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_5   19 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 19 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   6 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   14 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_6   22 39 32 43 65 68 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              68 65 43 32 39 22 ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_4   25 19 57 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 57 19 25 ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_2   27 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   29 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_2   15 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   68        ;PUSH Bytes
IP              68         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sevensuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 3 10   ;PUSH Bytes
CALL            10 3 15    ;CALL function
                           #--- PUSHB_4   0 15 8 9  ;PUSH Bytes
CALL            9 8 15 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_3   6 11 10   ;PUSH Bytes
CALL            10 11 6    ;CALL function
                           #--- PUSHB_4   64 6 5 9  ;PUSH Bytes
CALL            9 5 6 64   ;CALL function
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'shacyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 33 45  ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   26 38     ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 32 35  ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_4   11 8 12 14 ;PUSH Bytes
CALL            14 12 8 11 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_5   17 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 17 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_4   11 20 24 14 ;PUSH Bytes
CALL            14 24 20 11 ;CALL function
                           #--- PUSHB_5   29 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 29 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   45 6      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_4   11 45 41 14 ;PUSH Bytes
CALL            14 41 45 11 ;CALL function
                           #--- PUSHB_5   37 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_5   41 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 41 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   9 44      ;PUSH Bytes
IP              44         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'shade': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_5   2 6 10 14 22 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        22 14 10 6 2 ;SHift Point using reference point
                           #--- PUSHB_5   16 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 16 ;CALL function
                           #--- PUSHB_5   0 4 8 12 20 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        20 12 8 4 0 ;SHift Point using reference point
                           #--- PUSHB_3   211 2 0   ;PUSH Bytes
CALL            0 2 211    ;CALL function
                           #--- PUSHB_5   194 198 202 206 214 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        214 206 202 198 194 ;SHift Point using reference point
                           #--- PUSHB_5   208 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 208 ;CALL function
                           #--- PUSHB_5   192 196 200 204 212 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        212 204 200 196 192 ;SHift Point using reference point
                           #--- PUSHB_3   160 1 0   ;PUSH Bytes
CALL            0 1 160    ;CALL function
                           #--- PUSHB_5   144 148 152 156 164 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        164 156 152 148 144 ;SHift Point using reference point
                           #--- PUSHB_5   163 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 163 ;CALL function
                           #--- PUSHB_5   146 150 154 158 166 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        166 158 154 150 146 ;SHift Point using reference point
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_5   50 54 58 62 70 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        70 62 58 54 50 ;SHift Point using reference point
                           #--- PUSHB_5   64 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 64 ;CALL function
                           #--- PUSHB_5   48 52 56 60 68 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        68 60 56 52 48 ;SHift Point using reference point
                           #--- PUSHB_1   91        ;PUSH Bytes
MDAP[rnd]       91         ;Move Direct Absolute Point
                           #--- PUSHB_5   74 78 82 86 94 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        94 86 82 78 74 ;SHift Point using reference point
                           #--- PUSHB_5   88 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 88 ;CALL function
                           #--- PUSHB_5   72 76 80 84 92 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        92 84 80 76 72 ;SHift Point using reference point
                           #--- PUSHB_5   43 40 19 160 13 ;PUSH Bytes
CALL            13 160 19 40 43 ;CALL function
                           #--- PUSHB_5   24 28 32 36 44 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        44 36 32 28 24 ;SHift Point using reference point
                           #--- PUSHB_5   43 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 43 ;CALL function
                           #--- PUSHB_5   26 30 34 38 46 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        46 38 34 30 26 ;SHift Point using reference point
                           #--- PUSHB_5   115 112 19 160 13 ;PUSH Bytes
CALL            13 160 19 112 115 ;CALL function
                           #--- PUSHB_5   96 100 104 108 116 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        116 108 104 100 96 ;SHift Point using reference point
                           #--- PUSHB_5   115 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 115 ;CALL function
                           #--- PUSHB_5   98 102 106 110 118 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        118 110 106 102 98 ;SHift Point using reference point
                           #--- PUSHB_5   136 139 19 160 13 ;PUSH Bytes
CALL            13 160 19 139 136 ;CALL function
                           #--- PUSHB_5   122 126 130 134 142 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        142 134 130 126 122 ;SHift Point using reference point
                           #--- PUSHB_5   136 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 136 ;CALL function
                           #--- PUSHB_5   120 124 128 132 140 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        140 132 128 124 120 ;SHift Point using reference point
                           #--- PUSHB_5   187 184 163 208 13 ;PUSH Bytes
CALL            13 208 163 184 187 ;CALL function
                           #--- PUSHB_5   168 172 176 180 188 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        188 180 176 172 168 ;SHift Point using reference point
                           #--- PUSHB_5   187 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 187 ;CALL function
                           #--- PUSHB_5   170 174 178 182 190 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        190 182 178 174 170 ;SHift Point using reference point
                           #--- PUSHB_1   235       ;PUSH Bytes
MDAP[rnd]       235        ;Move Direct Absolute Point
                           #--- PUSHB_5   218 222 226 230 238 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp1]        238 230 226 222 218 ;SHift Point using reference point
                           #--- PUSHB_5   232 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 232 ;CALL function
                           #--- PUSHB_5   216 220 224 228 236 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        236 228 224 220 216 ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   240       ;PUSH Bytes
MDAP[rnd]       240        ;Move Direct Absolute Point
                           #--- PUSHB_1   67        ;PUSH Bytes
MDRP[rp0,rnd,white] 67         ;Move Direct Relative Point
                           #--- PUSHB_4   16 112 160 208 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        208 160 112 16 ;SHift Point using reference point
                           #--- PUSHB_5   66 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 66 ;CALL function
                           #--- PUSHB_4   17 113 161 209 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        209 161 113 17 ;SHift Point using reference point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP0            66         ;Set Reference Point 0
                           #--- PUSHB_2   91 11     ;PUSH Bytes
CALL            11 91      ;CALL function
                           #--- PUSHB_4   40 136 184 232 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        232 184 136 40 ;SHift Point using reference point
                           #--- PUSHB_5   90 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 90 ;CALL function
                           #--- PUSHB_4   41 137 185 233 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        233 185 137 41 ;SHift Point using reference point
                           #--- PUSHB_1   90        ;PUSH Bytes
SRP0            90         ;Set Reference Point 0
                           #--- PUSHB_2   63 11     ;PUSH Bytes
CALL            11 63      ;CALL function
                           #--- PUSHB_4   12 108 156 204 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        204 156 108 12 ;SHift Point using reference point
                           #--- PUSHB_5   62 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 62 ;CALL function
                           #--- PUSHB_4   13 109 157 205 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        205 157 109 13 ;SHift Point using reference point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP0            62         ;Set Reference Point 0
                           #--- PUSHB_2   87 11     ;PUSH Bytes
CALL            11 87      ;CALL function
                           #--- PUSHB_4   36 132 180 228 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        228 180 132 36 ;SHift Point using reference point
                           #--- PUSHB_5   86 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 86 ;CALL function
                           #--- PUSHB_4   37 133 181 229 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        229 181 133 37 ;SHift Point using reference point
                           #--- PUSHB_1   86        ;PUSH Bytes
SRP0            86         ;Set Reference Point 0
                           #--- PUSHB_2   59 11     ;PUSH Bytes
CALL            11 59      ;CALL function
                           #--- PUSHB_4   8 104 152 200 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        200 152 104 8 ;SHift Point using reference point
                           #--- PUSHB_5   58 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 58 ;CALL function
                           #--- PUSHB_4   9 105 153 201 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        201 153 105 9 ;SHift Point using reference point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   83 11     ;PUSH Bytes
CALL            11 83      ;CALL function
                           #--- PUSHB_4   32 128 176 224 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        224 176 128 32 ;SHift Point using reference point
                           #--- PUSHB_5   82 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 82 ;CALL function
                           #--- PUSHB_4   33 129 177 225 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        225 177 129 33 ;SHift Point using reference point
                           #--- PUSHB_1   82        ;PUSH Bytes
SRP0            82         ;Set Reference Point 0
                           #--- PUSHB_2   55 11     ;PUSH Bytes
CALL            11 55      ;CALL function
                           #--- PUSHB_4   4 100 148 196 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        196 148 100 4 ;SHift Point using reference point
                           #--- PUSHB_5   54 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 54 ;CALL function
                           #--- PUSHB_4   5 101 149 197 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        197 149 101 5 ;SHift Point using reference point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   79 11     ;PUSH Bytes
CALL            11 79      ;CALL function
                           #--- PUSHB_4   28 124 172 220 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        220 172 124 28 ;SHift Point using reference point
                           #--- PUSHB_5   78 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 78 ;CALL function
                           #--- PUSHB_4   29 125 173 221 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        221 173 125 29 ;SHift Point using reference point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP0            78         ;Set Reference Point 0
                           #--- PUSHB_2   51 11     ;PUSH Bytes
CALL            11 51      ;CALL function
                           #--- PUSHB_4   0 96 144 192 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        192 144 96 0 ;SHift Point using reference point
                           #--- PUSHB_5   50 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 50 ;CALL function
                           #--- PUSHB_4   1 97 145 193 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        193 145 97 1 ;SHift Point using reference point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   75 11     ;PUSH Bytes
CALL            11 75      ;CALL function
                           #--- PUSHB_4   24 120 168 216 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        216 168 120 24 ;SHift Point using reference point
                           #--- PUSHB_5   74 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 74 ;CALL function
                           #--- PUSHB_4   25 121 169 217 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        217 169 121 25 ;SHift Point using reference point
                           #--- PUSHB_1   74        ;PUSH Bytes
SRP0            74         ;Set Reference Point 0
                           #--- PUSHB_2   71 11     ;PUSH Bytes
CALL            11 71      ;CALL function
                           #--- PUSHB_4   20 116 164 212 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        212 164 116 20 ;SHift Point using reference point
                           #--- PUSHB_5   70 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 70 ;CALL function
                           #--- PUSHB_4   21 117 165 213 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        213 165 117 21 ;SHift Point using reference point
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP0            70         ;Set Reference Point 0
                           #--- PUSHB_2   95 11     ;PUSH Bytes
CALL            11 95      ;CALL function
                           #--- PUSHB_4   44 140 188 236 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        236 188 140 44 ;SHift Point using reference point
                           #--- PUSHB_5   94 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 94 ;CALL function
                           #--- PUSHB_4   45 141 189 237 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        237 189 141 45 ;SHift Point using reference point
                           #--- PUSHB_2   241 1     ;PUSH Bytes
CALL            1 241      ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'shchacyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 31 45   ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   15 20 10  ;PUSH Bytes
CALL            10 20 15   ;CALL function
                           #--- PUSHB_4   64 15 11 9 ;PUSH Bytes
CALL            9 11 15 64 ;CALL function
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   0 38      ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 44 47  ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        33         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_4   11 20 24 14 ;PUSH Bytes
CALL            14 24 20 11 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_5   29 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 29 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   45 6      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_4   11 32 36 14 ;PUSH Bytes
CALL            14 36 32 11 ;CALL function
                           #--- PUSHB_5   41 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 41 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
                           #--- DUP       #13       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_5   49 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   6 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   5 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'shindothebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'shinhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   22 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   6 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_5   17 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 17 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_5   32 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 32 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   22 23     ;PUSH Bytes
SDPVTL[orthog]  23 22      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[no-rnd]    22         ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[grey]      23         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   36 7      ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 36   ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[grey]      35         ;Move Direct Relative Point
                           #--- PUSHB_2   40 0      ;PUSH Bytes
SDPVTL[orthog]  0 40       ;Set Dual Projection Vector To Line
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[grey]      40         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 6    ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[grey]      7          ;Move Direct Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_4   7 23 35 40 ;PUSH Bytes
MDAP[no-rnd]    40         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    23         ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_8   0 6 7 22 23 35 36 40 ;PUSH Bytes
MDAP[no-rnd]    40         ;Move Direct Absolute Point
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    23         ;Move Direct Absolute Point
MDAP[no-rnd]    22         ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sigma': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 8 10   ;PUSH Bytes
CALL            10 8 12    ;CALL function
                           #--- PUSHB_4   64 12 24 9 ;PUSH Bytes
CALL            9 24 12 64 ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   8 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   12 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sigma1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_5   38 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 38 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   46 5      ;PUSH Bytes
MIRP[min,black] cvt_5 46   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_5   6 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 6 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
                           #--- DUP       #62       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 62         ;Move Direct Relative Point
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_5   15 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 15 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   59        ;PUSH Bytes
MDRP[rp0,rnd,white] 59         ;Move Direct Relative Point
                           #--- PUSHB_5   18 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_1   42        ;PUSH Bytes
                           #--- DUP       #42       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_5   36 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_5   42 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 42 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   4 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 4 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_1   24        ;PUSH Bytes
                           #--- DUP       #24       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_5   51 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_5   24 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 24 ;CALL function
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   18 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   33 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_3   21 15 54  ;PUSH Bytes
IP              54         ;Interpolate Point
IP              15         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_2   24 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_3   0 6 65    ;PUSH Bytes
IP              65         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   24 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   21 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   18 59     ;PUSH Bytes
IP              59         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sindothebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   6 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 6 ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_5   13 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   23 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 23 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 10 ;CALL function
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'six': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 3 0    ;PUSH Bytes
CALL            0 3 10     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 10 10  ;PUSH Bytes
CALL            10 10 19   ;CALL function
                           #--- PUSHB_4   0 19 16 9 ;PUSH Bytes
CALL            9 16 19 0  ;CALL function
                           #--- PUSHB_5   25 40 0 10 13 ;PUSH Bytes
CALL            13 10 0 40 25 ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDRP[rp0,rnd,white] 37         ;Move Direct Relative Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   28 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   6 28      ;PUSH Bytes
IP              28         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sixsuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 3 0     ;PUSH Bytes
CALL            0 3 8      ;CALL function
                           #--- PUSHB_5   17 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 17 ;CALL function
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   0 17 14 9 ;PUSH Bytes
CALL            9 14 17 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   31 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 31 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_5   25 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 25 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   34 25 10  ;PUSH Bytes
CALL            10 25 34   ;CALL function
                           #--- PUSHB_4   64 34 5 9 ;PUSH Bytes
CALL            9 5 34 64  ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   25 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   17 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   5 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'slash': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   22 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   8 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'smileface': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_2   59 5      ;PUSH Bytes
MIRP[min,black] cvt_5 59   ;Move Indirect Relative Point
                           #--- PUSHB_3   53 1 0    ;PUSH Bytes
CALL            0 1 53     ;CALL function
                           #--- PUSHB_2   42 5      ;PUSH Bytes
MIRP[min,black] cvt_5 42   ;Move Indirect Relative Point
                           #--- PUSHB_5   38 28 47 42 13 ;PUSH Bytes
CALL            13 42 47 28 38 ;CALL function
                           #--- PUSHB_5   38 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 38 ;CALL function
                           #--- PUSHB_3   28 38 10  ;PUSH Bytes
CALL            10 38 28   ;CALL function
                           #--- PUSHB_4   0 28 22 9 ;PUSH Bytes
CALL            9 22 28 0  ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_5   11 17 47 42 13 ;PUSH Bytes
CALL            13 42 47 17 11 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
                           #--- PUSHB_5   56 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 56 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_5   25 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 25 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_5   30 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_5   45 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 45 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   25 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   17 11     ;PUSH Bytes
IP              11         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   26 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_3   42 47 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              47         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_4   6 0 28 59 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              59 28 0 6  ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_3   50 56 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              56         ;Interpolate Point
IP              50         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'softhyphen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_5   58 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 58 ;CALL function
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_5   53 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 53 ;CALL function
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_5   11 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 11 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_5   6 10 48 15 13 ;PUSH Bytes
CALL            13 15 48 10 6 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   6 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 6 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_5   33 0 48 15 13 ;PUSH Bytes
CALL            13 15 48 0 33 ;CALL function
                           #--- PUSHB_5   33 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 33 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDRP[rp0,rnd,white] 51         ;Move Direct Relative Point
                           #--- PUSHB_5   56 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 56 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   1 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 1 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   13 1 3 14 ;PUSH Bytes
CALL            14 3 1 13  ;CALL function
                           #--- PUSHB_5   8 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 3 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   19 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 19 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
                           #--- DUP       #29       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_5   26 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 26 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_5   45 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 45 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   3 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_5   32 42 48 53 58 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              58 53 48 42 32 ;Interpolate Point
                           #--- PUSHB_2   29 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_2   24 56     ;PUSH Bytes
IP              56         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_2   33 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_3   22 45 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              45         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'softsigncyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   1 32 15 22 13 ;PUSH Bytes
CALL            13 22 15 32 1 ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   9 26 25 14 ;PUSH Bytes
CALL            14 25 26 9 ;CALL function
                           #--- PUSHB_5   21 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'space': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_5   22 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 22 ;CALL function
                           #--- PUSHB_3   12 3 0    ;PUSH Bytes
CALL            0 3 12     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 14 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_5   6 12 19 3 25 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              25 3 19 12 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'spade': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   35 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 35 ;CALL function
                           #--- PUSHB_5   35 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 35 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   35 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_7   0 2 16 23 32 38 40 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              40 38 32 23 16 2 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'spadesuitwhite': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_5   2 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 2 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   70        ;PUSH Bytes
SHP[rp1]        70         ;SHift Point using reference point
                           #--- PUSHB_5   27 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 27 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDRP[rp0,rnd,white] 51         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   67 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 67 ;CALL function
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   24 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   34 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              34         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- NPUSHB    12 3 9 15 22 27 37 2 48 55 59 70 72 ;PUSH N Bytes
                           #--- DEPTH     #12       ;DEPTH of the stack
SLOOP           12         ;Set LOOP variable
IP              72 70 59 55 48 2 37 27 22 15 9 3 ;Interpolate Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP2            67         ;Set Reference Point 2
                           #--- PUSHB_3   32 33 64  ;PUSH Bytes
IP              64         ;Interpolate Point
IP              33         ;Interpolate Point
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   37 78     ;PUSH Bytes
IP              78         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   46 72     ;PUSH Bytes
IP              72         ;Interpolate Point
IP              46         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sterling': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   7 17 10   ;PUSH Bytes
CALL            10 17 7    ;CALL function
                           #--- PUSHB_4   0 7 10 9  ;PUSH Bytes
CALL            9 10 7 0   ;CALL function
                           #--- PUSHB_3   39 2 0    ;PUSH Bytes
CALL            0 2 39     ;CALL function
                           #--- PUSHB_2   49 4      ;PUSH Bytes
MIRP[min,black] stemt 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   49 39 10  ;PUSH Bytes
CALL            10 39 49   ;CALL function
                           #--- PUSHB_4   0 49 45 9 ;PUSH Bytes
CALL            9 45 49 0  ;CALL function
                           #--- PUSHB_5   28 33 17 39 13 ;PUSH Bytes
CALL            13 39 17 33 28 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp1]        54         ;SHift Point using reference point
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 25 10   ;PUSH Bytes
CALL            10 25 5    ;CALL function
                           #--- PUSHB_4   64 5 13 9 ;PUSH Bytes
CALL            9 13 5 64  ;CALL function
                           #--- PUSHB_4   64 5 1 9  ;PUSH Bytes
CALL            9 1 5 64   ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_1   36        ;PUSH Bytes
                           #--- DUP       #36       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   52 36 10  ;PUSH Bytes
CALL            10 36 52   ;CALL function
                           #--- PUSHB_4   0 52 42 9 ;PUSH Bytes
CALL            9 42 52 0  ;CALL function
                           #--- PUSHB_3   36 52 10  ;PUSH Bytes
CALL            10 52 36   ;CALL function
                           #--- PUSHB_4   64 36 19 9 ;PUSH Bytes
CALL            9 19 36 64 ;CALL function
                           #--- PUSHB_4   64 36 30 9 ;PUSH Bytes
CALL            9 30 36 64 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   25 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   22 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_2   5 52      ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   7 54      ;PUSH Bytes
IP              54         ;Interpolate Point
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_2   49 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'suchthat': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_2   32 5      ;PUSH Bytes
MIRP[min,black] cvt_5 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 5       ;PUSH Bytes
MIRP[min,black] cvt_5 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   19 5      ;PUSH Bytes
MIRP[min,black] cvt_5 19   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 23 10   ;PUSH Bytes
CALL            10 23 3    ;CALL function
                           #--- PUSHB_4   64 3 7 9  ;PUSH Bytes
CALL            9 7 3 64   ;CALL function
                           #--- PUSHB_2   16 29     ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'summation': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 19 10   ;PUSH Bytes
CALL            10 19 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   41 36 10  ;PUSH Bytes
CALL            10 36 41   ;CALL function
                           #--- PUSHB_4   64 41 21 9 ;PUSH Bytes
CALL            9 21 41 64 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_1   8         ;PUSH Bytes
                           #--- DUP       #8        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   4 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    't': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   0 18 10   ;PUSH Bytes
CALL            10 18 0    ;CALL function
                           #--- PUSHB_4   0 0 11 9  ;PUSH Bytes
CALL            9 11 0 0   ;CALL function
                           #--- PUSHB_4   64 0 37 9 ;PUSH Bytes
CALL            9 37 0 64  ;CALL function
                           #--- PUSHB_3   18 0 10   ;PUSH Bytes
CALL            10 0 18    ;CALL function
                           #--- PUSHB_4   64 18 22 9 ;PUSH Bytes
CALL            9 22 18 64 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tau': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 12 10  ;PUSH Bytes
CALL            10 12 27   ;CALL function
                           #--- PUSHB_4   0 27 6 9  ;PUSH Bytes
CALL            9 6 27 0   ;CALL function
                           #--- PUSHB_4   64 27 23 9 ;PUSH Bytes
CALL            9 23 27 64 ;CALL function
                           #--- PUSHB_3   12 27 10  ;PUSH Bytes
CALL            10 27 12   ;CALL function
                           #--- PUSHB_4   64 12 17 9 ;PUSH Bytes
CALL            9 17 12 64 ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tavhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 22 10  ;PUSH Bytes
CALL            10 22 36   ;CALL function
                           #--- PUSHB_4   0 36 30 9 ;PUSH Bytes
CALL            9 30 36 0  ;CALL function
                           #--- PUSHB_4   64 36 41 9 ;PUSH Bytes
CALL            9 41 36 64 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tbar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   49 2 0    ;PUSH Bytes
CALL            0 2 49     ;CALL function
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp1]        53         ;SHift Point using reference point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   37 32 27 45 13 ;PUSH Bytes
CALL            13 45 27 32 37 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   38 46     ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 52      ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   12 30 10  ;PUSH Bytes
CALL            10 30 12   ;CALL function
                           #--- PUSHB_4   64 12 0 9 ;PUSH Bytes
CALL            9 0 12 64  ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_4   0 12 23 9 ;PUSH Bytes
CALL            9 23 12 0  ;CALL function
                           #--- PUSHB_3   30 12 10  ;PUSH Bytes
CALL            10 12 30   ;CALL function
                           #--- PUSHB_4   64 30 42 9 ;PUSH Bytes
CALL            9 42 30 64 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tethebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 41 10  ;PUSH Bytes
CALL            10 41 27   ;CALL function
                           #--- PUSHB_4   64 27 35 9 ;PUSH Bytes
CALL            9 35 27 64 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   32 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'theta': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_5   23 16 8 0 13 ;PUSH Bytes
CALL            13 0 8 16 23 ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   22 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   8 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'theta1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 5      ;PUSH Bytes
MIRP[min,black] cvt_5 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 10 10  ;PUSH Bytes
CALL            10 10 33   ;CALL function
                           #--- PUSHB_4   64 33 27 9 ;PUSH Bytes
CALL            9 27 33 64 ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_2   53 5      ;PUSH Bytes
MIRP[min,black] cvt_5 53   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 5       ;PUSH Bytes
MIRP[min,black] cvt_5 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   50 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 50 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   50 0 10   ;PUSH Bytes
CALL            10 0 50    ;CALL function
                           #--- PUSHB_4   0 50 57 9 ;PUSH Bytes
CALL            9 57 50 0  ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_5   16 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   50 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_2   12 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_2   10 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   61 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_2   7 39      ;PUSH Bytes
IP              39         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'three': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   28 3 0    ;PUSH Bytes
CALL            0 3 28     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 28 10  ;PUSH Bytes
CALL            10 28 17   ;CALL function
                           #--- PUSHB_4   0 17 22 9 ;PUSH Bytes
CALL            9 22 17 0  ;CALL function
                           #--- PUSHB_5   10 5 41 28 13 ;PUSH Bytes
CALL            13 28 41 5 10 ;CALL function
                           #--- PUSHB_2   10 5      ;PUSH Bytes
MIRP[min,black] cvt_5 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 36 10   ;PUSH Bytes
CALL            10 36 2    ;CALL function
                           #--- PUSHB_4   0 2 44 9  ;PUSH Bytes
CALL            9 44 2 0   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_1   14        ;PUSH Bytes
                           #--- DUP       #14       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 31 10  ;PUSH Bytes
CALL            10 31 14   ;CALL function
                           #--- PUSHB_4   64 14 7 9 ;PUSH Bytes
CALL            9 7 14 64  ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   2 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   36 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'threeeighths': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   55 0 0    ;PUSH Bytes
CALL            0 0 55     ;CALL function
                           #--- PUSHB_5   84 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 84 ;CALL function
                           #--- PUSHB_3   31 3 0    ;PUSH Bytes
CALL            0 3 31     ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_3   20 31 10  ;PUSH Bytes
CALL            10 31 20   ;CALL function
                           #--- PUSHB_4   0 20 25 9 ;PUSH Bytes
CALL            9 25 20 0  ;CALL function
                           #--- PUSHB_3   98 2 0    ;PUSH Bytes
CALL            0 2 98     ;CALL function
                           #--- PUSHB_5   80 75 55 98 13 ;PUSH Bytes
CALL            13 98 55 75 80 ;CALL function
                           #--- PUSHB_5   80 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 80 ;CALL function
                           #--- PUSHB_5   44 3 55 98 13 ;PUSH Bytes
CALL            13 98 55 3 44 ;CALL function
                           #--- PUSHB_5   44 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 44 ;CALL function
                           #--- PUSHB_3   3 44 10   ;PUSH Bytes
CALL            10 44 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_5   65 70 55 98 13 ;PUSH Bytes
CALL            13 98 55 70 65 ;CALL function
                           #--- PUSHB_5   65 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 65 ;CALL function
                           #--- PUSHB_4   14 55 98 8 ;PUSH Bytes
CALL            8 98 55 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   103       ;PUSH Bytes
MDAP[rnd]       103        ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_3   5 41 10   ;PUSH Bytes
CALL            10 41 5    ;CALL function
                           #--- PUSHB_4   0 5 47 9  ;PUSH Bytes
CALL            9 47 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_1   17        ;PUSH Bytes
                           #--- DUP       #17       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_3   17 34 10  ;PUSH Bytes
CALL            10 34 17   ;CALL function
                           #--- PUSHB_4   64 17 10 9 ;PUSH Bytes
CALL            9 10 17 64 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_5   82 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 82 ;CALL function
                           #--- PUSHB_1   82        ;PUSH Bytes
SRP0            82         ;Set Reference Point 0
                           #--- PUSHB_2   86 1      ;PUSH Bytes
CALL            1 86       ;CALL function
                           #--- PUSHB_5   52 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 52 ;CALL function
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp2]        68         ;SHift Point using reference point
                           #--- PUSHB_2   104 1     ;PUSH Bytes
CALL            1 104      ;CALL function
                           #--- PUSHB_2   34 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   39 90     ;PUSH Bytes
IP              90         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_2   82 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            82         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_1   86        ;PUSH Bytes
SRP1            86         ;Set Reference Point 1
                           #--- PUSHB_6   55 72 65 76 98 101 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              101 98 76 65 72 55 ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   80 84     ;PUSH Bytes
SRP1            84         ;Set Reference Point 1
SRP2            80         ;Set Reference Point 2
                           #--- PUSHB_4   58 52 90 93 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              93 90 52 58 ;Interpolate Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
                           #--- PUSHB_2   60 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              60         ;Interpolate Point
                           #--- PUSHB_2   3 44      ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   62 68 73 77 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              77 73 68 62 ;Interpolate Point
                           #--- PUSHB_2   65 70     ;PUSH Bytes
SRP1            70         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_2   5 41      ;PUSH Bytes
IP              41         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_3   7 38 39   ;PUSH Bytes
IP              39         ;Interpolate Point
IP              38         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   34 101    ;PUSH Bytes
IP              101        ;Interpolate Point
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'threequarters': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   77 0 0    ;PUSH Bytes
CALL            0 0 77     ;CALL function
                           #--- PUSHB_5   81 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 81 ;CALL function
                           #--- PUSHB_1   72        ;PUSH Bytes
SHP[rp2]        72         ;SHift Point using reference point
                           #--- PUSHB_3   31 3 0    ;PUSH Bytes
CALL            0 3 31     ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_3   20 31 10  ;PUSH Bytes
CALL            10 31 20   ;CALL function
                           #--- PUSHB_4   0 20 25 9 ;PUSH Bytes
CALL            9 25 20 0  ;CALL function
                           #--- PUSHB_3   61 2 0    ;PUSH Bytes
CALL            0 2 61     ;CALL function
                           #--- PUSHB_5   83 89 77 61 13 ;PUSH Bytes
CALL            13 61 77 89 83 ;CALL function
                           #--- PUSHB_5   83 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 83 ;CALL function
                           #--- PUSHB_3   89 83 10  ;PUSH Bytes
CALL            10 83 89   ;CALL function
                           #--- PUSHB_4   64 89 66 9 ;PUSH Bytes
CALL            9 66 89 64 ;CALL function
                           #--- PUSHB_5   44 3 77 61 13 ;PUSH Bytes
CALL            13 61 77 3 44 ;CALL function
                           #--- PUSHB_5   44 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 44 ;CALL function
                           #--- PUSHB_3   3 44 10   ;PUSH Bytes
CALL            10 44 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_4   14 77 61 8 ;PUSH Bytes
CALL            8 61 77 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   90        ;PUSH Bytes
MDAP[rnd]       90         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_3   5 41 10   ;PUSH Bytes
CALL            10 41 5    ;CALL function
                           #--- PUSHB_4   0 5 47 9  ;PUSH Bytes
CALL            9 47 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_1   17        ;PUSH Bytes
                           #--- DUP       #17       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_3   17 34 10  ;PUSH Bytes
CALL            10 34 17   ;CALL function
                           #--- PUSHB_4   64 17 10 9 ;PUSH Bytes
CALL            9 10 17 64 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   82 1      ;PUSH Bytes
CALL            1 82       ;CALL function
                           #--- PUSHB_1   87        ;PUSH Bytes
SHP[rp2]        87         ;SHift Point using reference point
                           #--- PUSHB_5   72 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 72 ;CALL function
                           #--- PUSHB_1   66        ;PUSH Bytes
SHP[rp2]        66         ;SHift Point using reference point
                           #--- PUSHB_3   82 72 10  ;PUSH Bytes
CALL            10 72 82   ;CALL function
                           #--- PUSHB_4   64 82 84 9 ;PUSH Bytes
CALL            9 84 82 64 ;CALL function
                           #--- PUSHB_1   72        ;PUSH Bytes
SRP0            72         ;Set Reference Point 0
                           #--- PUSHB_4   12 72 74 14 ;PUSH Bytes
CALL            14 74 72 12 ;CALL function
                           #--- PUSHB_5   79 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 79 ;CALL function
                           #--- PUSHB_1   79        ;PUSH Bytes
MDAP[rnd]       79         ;Move Direct Absolute Point
                           #--- PUSHB_5   74 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 74 ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
                           #--- PUSHB_2   91 1      ;PUSH Bytes
CALL            1 91       ;CALL function
                           #--- PUSHB_2   34 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   39 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_2   79 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            79         ;Set Reference Point 2
                           #--- PUSHB_2   61 89     ;PUSH Bytes
IP              89         ;Interpolate Point
IP              61         ;Interpolate Point
                           #--- PUSHB_1   82        ;PUSH Bytes
SRP1            82         ;Set Reference Point 1
                           #--- PUSHB_2   64 86     ;PUSH Bytes
IP              86         ;Interpolate Point
IP              64         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   81 77     ;PUSH Bytes
SRP1            77         ;Set Reference Point 1
SRP2            81         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP1            83         ;Set Reference Point 1
                           #--- PUSHB_1   71        ;PUSH Bytes
IP              71         ;Interpolate Point
                           #--- PUSHB_1   89        ;PUSH Bytes
SRP2            89         ;Set Reference Point 2
                           #--- PUSHB_3   56 67 85  ;PUSH Bytes
IP              85         ;Interpolate Point
IP              67         ;Interpolate Point
IP              56         ;Interpolate Point
                           #--- PUSHB_2   3 44      ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   88        ;PUSH Bytes
IP              88         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   38 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   34 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'threesuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 3 0    ;PUSH Bytes
CALL            0 3 31     ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_3   20 31 10  ;PUSH Bytes
CALL            10 31 20   ;CALL function
                           #--- PUSHB_4   0 20 25 9 ;PUSH Bytes
CALL            9 25 20 0  ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_3   3 44 10   ;PUSH Bytes
CALL            10 44 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_3   5 41 10   ;PUSH Bytes
CALL            10 41 5    ;CALL function
                           #--- PUSHB_4   0 5 47 9  ;PUSH Bytes
CALL            9 47 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_1   17        ;PUSH Bytes
                           #--- DUP       #17       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   34 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   38 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tilde': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_4   12 0 9 8  ;PUSH Bytes
CALL            8 9 0 12   ;CALL function
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   7 2 0     ;PUSH Bytes
CALL            0 2 7      ;CALL function
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'trademark': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   42 45     ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_5   17 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 17 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_5   14 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 14 ;CALL function
                           #--- PUSHB_3   0 38 50   ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   32 56     ;PUSH Bytes
SHP[rp1]        56         ;SHift Point using reference point
SHP[rp1]        32         ;SHift Point using reference point
                           #--- PUSHB_5   11 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 11 ;CALL function
                           #--- PUSHB_4   1 28 37 61 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        61 37 28 1 ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   1 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 1 ;CALL function
                           #--- PUSHB_4   10 12 9 14 ;PUSH Bytes
CALL            14 9 12 10 ;CALL function
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_5   22 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   28 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 28 ;CALL function
                           #--- PUSHB_3   37 28 10  ;PUSH Bytes
CALL            10 28 37   ;CALL function
                           #--- PUSHB_4   64 37 40 9 ;PUSH Bytes
CALL            9 40 37 64 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_4   13 37 35 14 ;PUSH Bytes
CALL            14 35 37 13 ;CALL function
                           #--- PUSHB_5   30 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 30 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_5   51 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 51 ;CALL function
                           #--- PUSHB_3   51 61 10  ;PUSH Bytes
CALL            10 61 51   ;CALL function
                           #--- PUSHB_4   64 51 48 9 ;PUSH Bytes
CALL            9 48 51 64 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_4   13 51 54 14 ;PUSH Bytes
CALL            14 54 51 13 ;CALL function
                           #--- PUSHB_5   59 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 59 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_5   54 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 54 ;CALL function
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   9 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_2   30 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_3   44 63 64  ;PUSH Bytes
IP              64         ;Interpolate Point
IP              63         ;Interpolate Point
IP              44         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_2   63 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              63         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_3   27 44 62  ;PUSH Bytes
IP              62         ;Interpolate Point
IP              44         ;Interpolate Point
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'triagdn': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'triaglf': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_5   1 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'triagrt': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   2 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 2  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'triagup': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tsadihebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_5   29 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   9 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 9 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   29 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   1 11 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              11         ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_4   0 10 12 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 12 10 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tserehebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_5   1 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 1 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   1 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'tshecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 40 52  ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   17 3 0    ;PUSH Bytes
CALL            0 3 17     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_5   29 47 0 11 13 ;PUSH Bytes
CALL            13 11 0 47 29 ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_2   18 26     ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   52 4 10   ;PUSH Bytes
CALL            10 4 52    ;CALL function
                           #--- PUSHB_4   64 52 23 9 ;PUSH Bytes
CALL            9 23 52 64 ;CALL function
                           #--- PUSHB_3   4 52 10   ;PUSH Bytes
CALL            10 52 4    ;CALL function
                           #--- PUSHB_4   64 4 9 9  ;PUSH Bytes
CALL            9 9 4 64   ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_5   16 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   9 4 2 14  ;PUSH Bytes
CALL            14 2 4 9   ;CALL function
                           #--- PUSHB_5   55 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 55 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_4   9 32 35 14 ;PUSH Bytes
CALL            14 35 32 9 ;CALL function
                           #--- PUSHB_5   39 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 35 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   39 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_2   32 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'two': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_5   7 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 7 ;CALL function
                           #--- PUSHB_3   35 3 0    ;PUSH Bytes
CALL            0 3 35     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 35 10  ;PUSH Bytes
CALL            10 35 23   ;CALL function
                           #--- PUSHB_4   0 23 29 9 ;PUSH Bytes
CALL            9 29 23 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   20 0 10   ;PUSH Bytes
CALL            10 0 20    ;CALL function
                           #--- PUSHB_4   64 20 11 9 ;PUSH Bytes
CALL            9 11 20 64 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   20 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   4 35      ;PUSH Bytes
IP              35         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_2   0 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'twosuperior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   21 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 21 ;CALL function
                           #--- PUSHB_3   21 3 10   ;PUSH Bytes
CALL            10 3 21    ;CALL function
                           #--- PUSHB_4   0 21 26 9 ;PUSH Bytes
CALL            9 26 21 0  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   5 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 5 ;CALL function
                           #--- PUSHB_3   19 5 10   ;PUSH Bytes
CALL            10 5 19    ;CALL function
                           #--- PUSHB_4   64 19 15 9 ;PUSH Bytes
CALL            9 15 19 64 ;CALL function
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   19 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   9 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_2   5 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'twothirds': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   73 0 0    ;PUSH Bytes
CALL            0 0 73     ;CALL function
                           #--- PUSHB_5   32 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 32 ;CALL function
                           #--- PUSHB_3   32 73 10  ;PUSH Bytes
CALL            10 73 32   ;CALL function
                           #--- PUSHB_4   0 32 29 9 ;PUSH Bytes
CALL            9 29 32 0  ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   21 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 21 ;CALL function
                           #--- PUSHB_3   21 3 10   ;PUSH Bytes
CALL            10 3 21    ;CALL function
                           #--- PUSHB_4   0 21 26 9 ;PUSH Bytes
CALL            9 26 21 0  ;CALL function
                           #--- PUSHB_3   90 2 0    ;PUSH Bytes
CALL            0 2 90     ;CALL function
                           #--- PUSHB_4   43 73 90 8 ;PUSH Bytes
CALL            8 90 73 43 ;CALL function
                           #--- PUSHB_5   15 8 73 90 13 ;PUSH Bytes
CALL            13 90 73 8 15 ;CALL function
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_5   60 49 73 90 13 ;PUSH Bytes
CALL            13 90 73 49 60 ;CALL function
                           #--- PUSHB_5   60 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 60 ;CALL function
                           #--- PUSHB_3   49 60 10  ;PUSH Bytes
CALL            10 60 49   ;CALL function
                           #--- PUSHB_4   0 49 54 9 ;PUSH Bytes
CALL            9 54 49 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   95        ;PUSH Bytes
MDAP[rnd]       95         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   5 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 5 ;CALL function
                           #--- PUSHB_3   19 5 10   ;PUSH Bytes
CALL            10 5 19    ;CALL function
                           #--- PUSHB_4   64 19 15 9 ;PUSH Bytes
CALL            9 15 19 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   70 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 70 ;CALL function
                           #--- PUSHB_3   34 70 10  ;PUSH Bytes
CALL            10 70 34   ;CALL function
                           #--- PUSHB_4   0 34 76 9 ;PUSH Bytes
CALL            9 76 34 0  ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_1   46        ;PUSH Bytes
                           #--- DUP       #46       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_5   63 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 63 ;CALL function
                           #--- PUSHB_3   46 63 10  ;PUSH Bytes
CALL            10 63 46   ;CALL function
                           #--- PUSHB_4   0 46 57 9 ;PUSH Bytes
CALL            9 57 46 0  ;CALL function
                           #--- PUSHB_2   96 1      ;PUSH Bytes
CALL            1 96       ;CALL function
                           #--- PUSHB_2   19 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_3   3 8 85    ;PUSH Bytes
IP              85         ;Interpolate Point
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_3   9 11 82   ;PUSH Bytes
IP              82         ;Interpolate Point
IP              11         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_6   13 14 37 39 90 93 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              93 90 39 37 14 13 ;Interpolate Point
                           #--- PUSHB_2   63 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   68        ;PUSH Bytes
IP              68         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_4   67 70 82 85 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              85 82 70 67 ;Interpolate Point
                           #--- PUSHB_2   49 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_2   46 63     ;PUSH Bytes
IP              63         ;Interpolate Point
IP              46         ;Interpolate Point
                           #--- PUSHB_2   11 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_2   21 60     ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   19 5 93   ;PUSH Bytes
IP              93         ;Interpolate Point
IP              5          ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'u': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_5   23 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 33 10   ;PUSH Bytes
CALL            10 33 7    ;CALL function
                           #--- PUSHB_4   64 7 9 9  ;PUSH Bytes
CALL            9 9 7 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   3 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   3 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   15 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   20 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ucyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 1 0    ;PUSH Bytes
CALL            0 1 41     ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_2   53 4      ;PUSH Bytes
MIRP[min,black] stemt 53   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   50 6      ;PUSH Bytes
MIRP[min,black] stemw 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   42 54     ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   1 12      ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_5   9 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_5   26 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 26 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   17 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ugrave': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 3 0     ;PUSH Bytes
CALL            0 3 2      ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 38      ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_5   20 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 20 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   33 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_4   7 13 35 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 35 13 7 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uhorn': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_2   49 4      ;PUSH Bytes
MIRP[min,black] stemt 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   26 48     ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_5   15 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   49 6      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   49 25 10  ;PUSH Bytes
CALL            10 25 49   ;CALL function
                           #--- PUSHB_4   64 49 1 9 ;PUSH Bytes
CALL            9 1 49 64  ;CALL function
                           #--- PUSHB_4   64 49 45 9 ;PUSH Bytes
CALL            9 45 49 64 ;CALL function
                           #--- PUSHB_3   25 49 10  ;PUSH Bytes
CALL            10 49 25   ;CALL function
                           #--- PUSHB_4   64 25 31 9 ;PUSH Bytes
CALL            9 31 25 64 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   25 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   7 33      ;PUSH Bytes
IP              33         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_2   12 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'underscore': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'underscoredbl': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   2 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 2  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0163': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   51 0 0    ;PUSH Bytes
CALL            0 0 51     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 57 10   ;PUSH Bytes
CALL            10 57 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   36 13 10  ;PUSH Bytes
CALL            10 13 36   ;CALL function
                           #--- PUSHB_4   64 36 32 9 ;PUSH Bytes
CALL            9 32 36 64 ;CALL function
                           #--- PUSHB_3   13 36 10  ;PUSH Bytes
CALL            10 36 13   ;CALL function
                           #--- PUSHB_4   64 13 17 9 ;PUSH Bytes
CALL            9 17 13 64 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   54 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 54 ;CALL function
                           #--- PUSHB_3   54 5 10   ;PUSH Bytes
CALL            10 5 54    ;CALL function
                           #--- PUSHB_4   64 54 47 9 ;PUSH Bytes
CALL            9 47 54 64 ;CALL function
                           #--- PUSHB_3   5 54 10   ;PUSH Bytes
CALL            10 54 5    ;CALL function
                           #--- PUSHB_4   0 5 60 9  ;PUSH Bytes
CALL            9 60 5 0   ;CALL function
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   5 36      ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   9 10 39 51 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              51 39 10 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_3   7 9 54    ;PUSH Bytes
IP              54         ;Interpolate Point
IP              9          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0180': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 3 0    ;PUSH Bytes
CALL            0 3 14     ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   3 39 10   ;PUSH Bytes
CALL            10 39 3    ;CALL function
                           #--- PUSHB_4   64 3 18 9 ;PUSH Bytes
CALL            9 18 3 64  ;CALL function
                           #--- PUSHB_3   39 3 10   ;PUSH Bytes
CALL            10 3 39    ;CALL function
                           #--- PUSHB_4   64 39 12 9 ;PUSH Bytes
CALL            9 12 39 64 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   9 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   24 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   31 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_2   0 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   3 9 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0181': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   36 2 0    ;PUSH Bytes
CALL            0 2 36     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   22 36 10  ;PUSH Bytes
CALL            10 36 22   ;CALL function
                           #--- PUSHB_4   64 22 30 9 ;PUSH Bytes
CALL            9 30 22 64 ;CALL function
                           #--- PUSHB_5   0 13 48 36 13 ;PUSH Bytes
CALL            13 36 48 13 0 ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 14 10  ;PUSH Bytes
CALL            10 14 20   ;CALL function
                           #--- PUSHB_4   64 20 18 9 ;PUSH Bytes
CALL            9 18 20 64 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
                           #--- DUP       #9        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0182': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 3 0    ;PUSH Bytes
CALL            0 3 14     ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   3 39 10   ;PUSH Bytes
CALL            10 39 3    ;CALL function
                           #--- PUSHB_4   64 3 18 9 ;PUSH Bytes
CALL            9 18 3 64  ;CALL function
                           #--- PUSHB_3   39 3 10   ;PUSH Bytes
CALL            10 3 39    ;CALL function
                           #--- PUSHB_4   64 39 12 9 ;PUSH Bytes
CALL            9 12 39 64 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   9 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   24 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   31 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_2   0 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   3 9 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0184': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_2   43 5      ;PUSH Bytes
MIRP[min,black] cvt_5 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SHP[rp2]        66         ;SHift Point using reference point
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 5      ;PUSH Bytes
MIRP[min,black] cvt_5 21   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   66 6      ;PUSH Bytes
MIRP[min,black] stemw 66   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   66 44 10  ;PUSH Bytes
CALL            10 44 66   ;CALL function
                           #--- PUSHB_4   64 66 11 9 ;PUSH Bytes
CALL            9 11 66 64 ;CALL function
                           #--- PUSHB_3   44 66 10  ;PUSH Bytes
CALL            10 66 44   ;CALL function
                           #--- PUSHB_4   64 44 34 9 ;PUSH Bytes
CALL            9 34 44 64 ;CALL function
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP0            66         ;Set Reference Point 0
                           #--- PUSHB_5   51 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP0            66         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   66 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   65 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0185': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   65 5      ;PUSH Bytes
MIRP[min,black] cvt_5 65   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   45 5      ;PUSH Bytes
MIRP[min,black] cvt_5 45   ;Move Indirect Relative Point
                           #--- PUSHB_3   45 33 10  ;PUSH Bytes
CALL            10 33 45   ;CALL function
                           #--- PUSHB_4   64 45 2 9 ;PUSH Bytes
CALL            9 2 45 64  ;CALL function
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   71 5      ;PUSH Bytes
MIRP[min,black] cvt_5 71   ;Move Indirect Relative Point
                           #--- PUSHB_3   54 1 0    ;PUSH Bytes
CALL            0 1 54     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   62 6      ;PUSH Bytes
MIRP[min,black] stemw 62   ;Move Indirect Relative Point
                           #--- PUSHB_2   20 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   62 46 10  ;PUSH Bytes
CALL            10 46 62   ;CALL function
                           #--- PUSHB_4   64 62 11 9 ;PUSH Bytes
CALL            9 11 62 64 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP0            62         ;Set Reference Point 0
                           #--- PUSHB_5   36 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP0            62         ;Set Reference Point 0
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_2   62 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
                           #--- PUSHB_2   23 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   65 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_2   71 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_3   26 62 68  ;PUSH Bytes
IP              68         ;Interpolate Point
IP              62         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_3   21 47 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              47         ;Interpolate Point
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0186': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 3 10   ;PUSH Bytes
CALL            10 3 43    ;CALL function
                           #--- PUSHB_4   0 43 48 9 ;PUSH Bytes
CALL            9 48 43 0  ;CALL function
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 10 10  ;PUSH Bytes
CALL            10 10 36   ;CALL function
                           #--- PUSHB_4   64 36 29 9 ;PUSH Bytes
CALL            9 29 36 64 ;CALL function
                           #--- PUSHB_3   10 36 10  ;PUSH Bytes
CALL            10 36 10   ;CALL function
                           #--- PUSHB_4   64 10 15 9 ;PUSH Bytes
CALL            9 15 10 64 ;CALL function
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   32 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_4   3 10 13 43 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 13 10 3 ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   46 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              46         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_4   12 21 24 26 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              26 24 21 12 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0188': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 33 10   ;PUSH Bytes
CALL            10 33 8    ;CALL function
                           #--- PUSHB_4   64 8 2 9  ;PUSH Bytes
CALL            9 2 8 64   ;CALL function
                           #--- PUSHB_3   33 8 10   ;PUSH Bytes
CALL            10 8 33    ;CALL function
                           #--- PUSHB_4   64 33 38 9 ;PUSH Bytes
CALL            9 38 33 64 ;CALL function
                           #--- PUSHB_3   42 1 0    ;PUSH Bytes
CALL            0 1 42     ;CALL function
                           #--- PUSHB_3   47 1 0    ;PUSH Bytes
CALL            0 1 47     ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 30 10  ;PUSH Bytes
CALL            10 30 11   ;CALL function
                           #--- PUSHB_4   0 11 21 9 ;PUSH Bytes
CALL            9 21 11 0  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   0 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   33 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_4   0 18 21 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 21 18 0 ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_3   35 44 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              44         ;Interpolate Point
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0189': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   34 18 10  ;PUSH Bytes
CALL            10 18 34   ;CALL function
                           #--- PUSHB_4   0 34 12 9 ;PUSH Bytes
CALL            9 12 34 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 5 10   ;PUSH Bytes
CALL            10 5 32    ;CALL function
                           #--- PUSHB_4   64 32 29 9 ;PUSH Bytes
CALL            9 29 32 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni018B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_5   1 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 1 ;CALL function
                           #--- PUSHB_5   22 32 16 3 13 ;PUSH Bytes
CALL            13 3 16 32 22 ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_1   28        ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 30 10  ;PUSH Bytes
CALL            10 30 11   ;CALL function
                           #--- PUSHB_4   64 11 7 9 ;PUSH Bytes
CALL            9 7 11 64  ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni018C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 3 0    ;PUSH Bytes
CALL            0 3 21     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   16 28     ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 0 10   ;PUSH Bytes
CALL            10 0 23    ;CALL function
                           #--- PUSHB_4   64 23 26 9 ;PUSH Bytes
CALL            9 26 23 64 ;CALL function
                           #--- PUSHB_3   0 23 10   ;PUSH Bytes
CALL            10 23 0    ;CALL function
                           #--- PUSHB_4   0 0 20 9  ;PUSH Bytes
CALL            9 20 0 0   ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   14 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_2   3 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   0 6 11 12 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              12 11 6 0  ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni018D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   37 0 0    ;PUSH Bytes
CALL            0 0 37     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_5   27 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 27 ;CALL function
                           #--- PUSHB_3   48 2 0    ;PUSH Bytes
CALL            0 2 48     ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp1]        53         ;SHift Point using reference point
                           #--- PUSHB_2   71 4      ;PUSH Bytes
MIRP[min,black] stemt 71   ;Move Indirect Relative Point
                           #--- PUSHB_3   71 48 10  ;PUSH Bytes
CALL            10 48 71   ;CALL function
                           #--- PUSHB_4   64 71 59 9 ;PUSH Bytes
CALL            9 59 71 64 ;CALL function
                           #--- PUSHB_5   9 3 37 48 13 ;PUSH Bytes
CALL            13 48 37 3 9 ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[rp0,rnd,white] 45         ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 45 10   ;PUSH Bytes
CALL            10 45 0    ;CALL function
                           #--- PUSHB_4   64 0 6 9  ;PUSH Bytes
CALL            9 6 0 64   ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_1   40        ;PUSH Bytes
                           #--- DUP       #40       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   57 6      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_2   74 1      ;PUSH Bytes
CALL            1 74       ;CALL function
                           #--- PUSHB_2   12 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_2   68 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_6   4 8 9 15 37 48 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              48 37 15 9 8 4 ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_5   18 27 33 35 50 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              50 35 33 27 18 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   12 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni018f': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   42 0 0    ;PUSH Bytes
CALL            0 0 42     ;CALL function
                           #--- PUSHB_5   29 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 29 ;CALL function
                           #--- PUSHB_3   29 42 10  ;PUSH Bytes
CALL            10 42 29   ;CALL function
                           #--- PUSHB_4   0 29 33 9 ;PUSH Bytes
CALL            9 33 29 0  ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 6 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_3   22 6 10   ;PUSH Bytes
CALL            10 6 22    ;CALL function
                           #--- PUSHB_4   64 22 17 9 ;PUSH Bytes
CALL            9 17 22 64 ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_5   109 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 109 ;CALL function
                           #--- PUSHB_1   67        ;PUSH Bytes
                           #--- DUP       #67       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 67         ;Move Direct Relative Point
SRP1            67         ;Set Reference Point 1
                           #--- PUSHB_5   100 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 100 ;CALL function
                           #--- PUSHB_1   103       ;PUSH Bytes
MDAP[rnd]       103        ;Move Direct Absolute Point
                           #--- PUSHB_5   79 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 79 ;CALL function
                           #--- PUSHB_1   79        ;PUSH Bytes
SRP0            79         ;Set Reference Point 0
                           #--- PUSHB_1   81        ;PUSH Bytes
                           #--- DUP       #81       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 81         ;Move Direct Relative Point
SRP1            81         ;Set Reference Point 1
                           #--- PUSHB_5   112 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 112 ;CALL function
                           #--- PUSHB_1   85        ;PUSH Bytes
MDAP[rnd]       85         ;Move Direct Absolute Point
                           #--- PUSHB_5   94 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 94 ;CALL function
                           #--- PUSHB_3   85 94 10  ;PUSH Bytes
CALL            10 94 85   ;CALL function
                           #--- PUSHB_4   0 85 88 9 ;PUSH Bytes
CALL            9 88 85 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   114       ;PUSH Bytes
MDAP[rnd]       114        ;Move Direct Absolute Point
                           #--- PUSHB_1   74        ;PUSH Bytes
MDRP[rp0,rnd,white] 74         ;Move Direct Relative Point
                           #--- PUSHB_5   106 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 106 ;CALL function
                           #--- PUSHB_1   106       ;PUSH Bytes
SRP0            106        ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   27 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 27 ;CALL function
                           #--- PUSHB_3   27 0 10   ;PUSH Bytes
CALL            10 0 27    ;CALL function
                           #--- PUSHB_4   0 27 36 9 ;PUSH Bytes
CALL            9 36 27 0  ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   83 1      ;PUSH Bytes
CALL            1 83       ;CALL function
                           #--- PUSHB_5   97 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 97 ;CALL function
                           #--- PUSHB_3   97 83 10  ;PUSH Bytes
CALL            10 83 97   ;CALL function
                           #--- PUSHB_4   64 97 64 9 ;PUSH Bytes
CALL            9 64 97 64 ;CALL function
                           #--- PUSHB_3   83 97 10  ;PUSH Bytes
CALL            10 97 83   ;CALL function
                           #--- PUSHB_4   0 83 91 9 ;PUSH Bytes
CALL            9 91 83 0  ;CALL function
                           #--- PUSHB_2   115 1     ;PUSH Bytes
CALL            1 115      ;CALL function
                           #--- PUSHB_2   0 106     ;PUSH Bytes
SRP1            106        ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   71 109    ;PUSH Bytes
IP              109        ;Interpolate Point
IP              71         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   79 103    ;PUSH Bytes
IP              103        ;Interpolate Point
IP              79         ;Interpolate Point
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP2            83         ;Set Reference Point 2
                           #--- PUSHB_4   68 69 111 112 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              112 111 69 68 ;Interpolate Point
                           #--- PUSHB_1   97        ;PUSH Bytes
SRP1            97         ;Set Reference Point 1
                           #--- PUSHB_1   100       ;PUSH Bytes
IP              100        ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   0 49 52   ;PUSH Bytes
IP              52         ;Interpolate Point
IP              49         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   8 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   109 67    ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
SRP2            109        ;Set Reference Point 2
                           #--- PUSHB_3   61 64 69  ;PUSH Bytes
IP              69         ;Interpolate Point
IP              64         ;Interpolate Point
IP              61         ;Interpolate Point
                           #--- PUSHB_1   100       ;PUSH Bytes
SRP1            100        ;Set Reference Point 1
                           #--- PUSHB_1   74        ;PUSH Bytes
IP              74         ;Interpolate Point
                           #--- PUSHB_1   112       ;PUSH Bytes
SRP2            112        ;Set Reference Point 2
                           #--- PUSHB_3   58 106 111 ;PUSH Bytes
IP              111        ;Interpolate Point
IP              106        ;Interpolate Point
IP              58         ;Interpolate Point
                           #--- PUSHB_2   85 79     ;PUSH Bytes
SRP1            79         ;Set Reference Point 1
SRP2            85         ;Set Reference Point 2
                           #--- PUSHB_2   83 97     ;PUSH Bytes
IP              97         ;Interpolate Point
IP              83         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0191': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_5   31 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 31 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   0 17 14 9 ;PUSH Bytes
CALL            9 14 17 0  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_4   9 35 39 14 ;PUSH Bytes
CALL            14 39 35 9 ;CALL function
                           #--- PUSHB_5   0 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   20 5 10   ;PUSH Bytes
CALL            10 5 20    ;CALL function
                           #--- PUSHB_4   0 20 11 9 ;PUSH Bytes
CALL            9 11 20 0  ;CALL function
                           #--- PUSHB_4   64 20 24 9 ;PUSH Bytes
CALL            9 24 20 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0193': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   59 0 0    ;PUSH Bytes
CALL            0 0 59     ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 3 10   ;PUSH Bytes
CALL            10 3 35    ;CALL function
                           #--- PUSHB_4   64 35 23 9 ;PUSH Bytes
CALL            9 23 35 64 ;CALL function
                           #--- PUSHB_3   3 35 10   ;PUSH Bytes
CALL            10 35 3    ;CALL function
                           #--- PUSHB_4   64 3 8 9  ;PUSH Bytes
CALL            9 8 3 64   ;CALL function
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_5   45 50 59 8 13 ;PUSH Bytes
CALL            13 8 59 50 45 ;CALL function
                           #--- PUSHB_2   45 4      ;PUSH Bytes
MIRP[min,black] stemt 45   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   65        ;PUSH Bytes
MDRP[rp0,rnd,white] 65         ;Move Direct Relative Point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   56 6      ;PUSH Bytes
MIRP[min,black] stemw 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   56 43 10  ;PUSH Bytes
CALL            10 43 56   ;CALL function
                           #--- PUSHB_4   64 56 53 9 ;PUSH Bytes
CALL            9 53 56 64 ;CALL function
                           #--- PUSHB_3   43 56 10  ;PUSH Bytes
CALL            10 56 43   ;CALL function
                           #--- PUSHB_4   64 43 47 9 ;PUSH Bytes
CALL            9 47 43 64 ;CALL function
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   43 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_3   33 3 59   ;PUSH Bytes
IP              59         ;Interpolate Point
IP              3          ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   56        ;PUSH Bytes
IP              56         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_2   35 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_4   5 14 17 19 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              19 17 14 5 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0194': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 2 0     ;PUSH Bytes
CALL            0 2 7      ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 15 26  ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   59 5      ;PUSH Bytes
MIRP[min,black] cvt_5 59   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_2   56 6      ;PUSH Bytes
MIRP[min,black] stemw 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_2   56 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_3   13 10 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              10         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_3   37 59 14  ;PUSH Bytes
IP              14         ;Interpolate Point
IP              59         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_3   18 28 15  ;PUSH Bytes
IP              15         ;Interpolate Point
IP              28         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 59      ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   14 34 40 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 40 34 14 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0195': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   28 0 0    ;PUSH Bytes
CALL            0 0 28     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 3 0     ;PUSH Bytes
CALL            0 3 2      ;CALL function
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDRP[rp0,rnd,white] 48         ;Move Direct Relative Point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_4   9 48 46 14 ;PUSH Bytes
CALL            14 46 48 9 ;CALL function
                           #--- PUSHB_5   42 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 42 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_5   18 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   42 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   6 36      ;PUSH Bytes
IP              36         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   18 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_5   9 10 32 33 38 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              38 33 32 10 9 ;Interpolate Point
                           #--- PUSHB_2   21 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   18 4      ;PUSH Bytes
IP              4          ;Interpolate Point
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0196': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 17 10   ;PUSH Bytes
CALL            10 17 8    ;CALL function
                           #--- PUSHB_4   0 8 11 9  ;PUSH Bytes
CALL            9 11 8 0   ;CALL function
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   0 5 14 9  ;PUSH Bytes
CALL            9 14 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0197': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_5   41 2 33 10 13 ;PUSH Bytes
CALL            13 10 33 2 41 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDRP[rp0,rnd,white] 39         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   26 39 10  ;PUSH Bytes
CALL            10 39 26   ;CALL function
                           #--- PUSHB_4   64 26 30 9 ;PUSH Bytes
CALL            9 30 26 64 ;CALL function
                           #--- PUSHB_2   14 22     ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   39 26 10  ;PUSH Bytes
CALL            10 26 39   ;CALL function
                           #--- PUSHB_4   64 39 35 9 ;PUSH Bytes
CALL            9 35 39 64 ;CALL function
                           #--- PUSHB_2   0 7       ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0198': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 37      ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   52 2 0    ;PUSH Bytes
CALL            0 2 52     ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp1]        73         ;SHift Point using reference point
                           #--- PUSHB_2   40 5      ;PUSH Bytes
MIRP[min,black] cvt_5 40   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 91     ;PUSH Bytes
SHP[rp2]        91         ;SHift Point using reference point
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_3   85 1 0    ;PUSH Bytes
CALL            0 1 85     ;CALL function
                           #--- PUSHB_2   80 5      ;PUSH Bytes
MIRP[min,black] cvt_5 80   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   93        ;PUSH Bytes
MDAP[rnd]       93         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp2]        59         ;SHift Point using reference point
                           #--- PUSHB_3   18 38 10  ;PUSH Bytes
CALL            10 38 18   ;CALL function
                           #--- PUSHB_4   64 18 21 9 ;PUSH Bytes
CALL            9 21 18 64 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
                           #--- PUSHB_3   38 18 10  ;PUSH Bytes
CALL            10 18 38   ;CALL function
                           #--- PUSHB_4   64 38 28 9 ;PUSH Bytes
CALL            9 28 38 64 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   88 1      ;PUSH Bytes
CALL            1 88       ;CALL function
                           #--- PUSHB_2   77 6      ;PUSH Bytes
MIRP[min,black] stemw 77   ;Move Indirect Relative Point
                           #--- PUSHB_3   88 77 10  ;PUSH Bytes
CALL            10 77 88   ;CALL function
                           #--- PUSHB_4   0 88 83 9 ;PUSH Bytes
CALL            9 83 88 0  ;CALL function
                           #--- PUSHB_2   94 1      ;PUSH Bytes
CALL            1 94       ;CALL function
                           #--- PUSHB_2   88 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            88         ;Set Reference Point 2
                           #--- PUSHB_6   4 11 0 61 64 65 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              65 64 61 0 11 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   80 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            80         ;Set Reference Point 2
                           #--- PUSHB_3   0 16 60   ;PUSH Bytes
IP              60         ;Interpolate Point
IP              16         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   40 85     ;PUSH Bytes
SRP1            85         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   77        ;PUSH Bytes
IP              77         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_1   61        ;PUSH Bytes
IP              61         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0199': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   8 3 0     ;PUSH Bytes
CALL            0 3 8      ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   0 17 14 9 ;PUSH Bytes
CALL            9 14 17 0  ;CALL function
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   46 4 10   ;PUSH Bytes
CALL            10 4 46    ;CALL function
                           #--- PUSHB_4   0 46 11 9 ;PUSH Bytes
CALL            9 11 46 0  ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   38 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 38 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
                           #--- DUP       #24       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_5   30 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 30 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   24 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_2   22 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_3   33 35 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              35         ;Interpolate Point
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 48      ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_3   21 45 46  ;PUSH Bytes
IP              46         ;Interpolate Point
IP              45         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni019A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 0 0    ;PUSH Bytes
CALL            0 0 25     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   10 3 0    ;PUSH Bytes
CALL            0 3 10     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_5   33 2 25 10 13 ;PUSH Bytes
CALL            13 10 25 2 33 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   20 31 10  ;PUSH Bytes
CALL            10 31 20   ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_4   64 20 23 9 ;PUSH Bytes
CALL            9 23 20 64 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_5   7 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 7  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_3   7 20 10   ;PUSH Bytes
CALL            10 20 7    ;CALL function
                           #--- PUSHB_4   64 7 1 9  ;PUSH Bytes
CALL            9 1 7 64   ;CALL function
                           #--- PUSHB_4   64 7 27 9 ;PUSH Bytes
CALL            9 27 7 64  ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni019B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_2   48 4      ;PUSH Bytes
MIRP[min,black] stemt 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_3   24 3 0    ;PUSH Bytes
CALL            0 3 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   8 21 48   ;PUSH Bytes
IP              48         ;Interpolate Point
IP              21         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_3   28 37 47  ;PUSH Bytes
IP              47         ;Interpolate Point
IP              37         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   31 38 34 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 34 38 31 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   7 38      ;PUSH Bytes
IP              38         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_2   37 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni019C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_2   0 36      ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 31 44   ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_5   22 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_5   34 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 43 10   ;PUSH Bytes
CALL            10 43 4    ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   10 4 2 14 ;PUSH Bytes
CALL            14 2 4 10  ;CALL function
                           #--- PUSHB_5   46 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   2 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 2 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   34 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   12 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   6 10 14   ;PUSH Bytes
IP              14         ;Interpolate Point
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   30 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni019D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 32      ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 10 10  ;PUSH Bytes
CALL            10 10 19   ;CALL function
                           #--- PUSHB_4   0 19 16 9 ;PUSH Bytes
CALL            9 16 19 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   22 7 10   ;PUSH Bytes
CALL            10 7 22    ;CALL function
                           #--- PUSHB_4   0 22 13 9 ;PUSH Bytes
CALL            9 13 22 0  ;CALL function
                           #--- PUSHB_4   64 22 26 9 ;PUSH Bytes
CALL            9 26 22 64 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   8 4 2 14  ;PUSH Bytes
CALL            14 2 4 8   ;CALL function
                           #--- PUSHB_5   35 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_5   2 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 2  ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   7 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   4 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   6 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni019E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 31 10   ;PUSH Bytes
CALL            10 31 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   9 3 1 14  ;PUSH Bytes
CALL            14 1 3 9   ;CALL function
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 24 23 14 ;PUSH Bytes
CALL            14 23 24 9 ;CALL function
                           #--- PUSHB_5   19 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 19 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   23 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   13 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   8 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   6 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni019F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_5   22 20 9 0 13 ;PUSH Bytes
CALL            13 0 9 20 22 ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   12 6      ;PUSH Bytes
IP              6          ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   39 3 0    ;PUSH Bytes
CALL            0 3 39     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   9 43 46 14 ;PUSH Bytes
CALL            14 46 43 9 ;CALL function
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   46 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 46 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   6 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   27 35 37  ;PUSH Bytes
IP              37         ;Interpolate Point
IP              35         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_2   15 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   18 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   56 0 0    ;PUSH Bytes
CALL            0 0 56     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_1   47        ;PUSH Bytes
                           #--- DUP       #47       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 42 40 14 ;PUSH Bytes
CALL            14 40 42 9 ;CALL function
                           #--- PUSHB_5   36 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 36 ;CALL function
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   9 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_3   24 25 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              25         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_2   42 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   45 0 0    ;PUSH Bytes
CALL            0 0 45     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   14 28 10  ;PUSH Bytes
CALL            10 28 14   ;CALL function
                           #--- PUSHB_4   0 14 22 9 ;PUSH Bytes
CALL            9 22 14 0  ;CALL function
                           #--- PUSHB_5   39 1 45 28 13 ;PUSH Bytes
CALL            13 28 45 1 39 ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   40 12 10  ;PUSH Bytes
CALL            10 12 40   ;CALL function
                           #--- PUSHB_4   64 40 43 9 ;PUSH Bytes
CALL            9 43 40 64 ;CALL function
                           #--- PUSHB_3   12 40 10  ;PUSH Bytes
CALL            10 40 12   ;CALL function
                           #--- PUSHB_4   64 12 10 9 ;PUSH Bytes
CALL            9 10 12 64 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   45 3 0    ;PUSH Bytes
CALL            0 3 45     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 45 10  ;PUSH Bytes
CALL            10 45 15   ;CALL function
                           #--- PUSHB_4   0 15 12 9 ;PUSH Bytes
CALL            9 12 15 0  ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 18      ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   30 41 10  ;PUSH Bytes
CALL            10 41 30   ;CALL function
                           #--- PUSHB_4   0 30 48 9 ;PUSH Bytes
CALL            9 48 30 0  ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_4   7 41 39 14 ;PUSH Bytes
CALL            14 39 41 7 ;CALL function
                           #--- PUSHB_5   34 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 34 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   9 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_4   6 0 21 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 21 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_5   56 1 13 32 13 ;PUSH Bytes
CALL            13 32 13 1 56 ;CALL function
                           #--- PUSHB_2   56 4      ;PUSH Bytes
MIRP[min,black] stemt 56   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   57 6      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 31      ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   57 17 10  ;PUSH Bytes
CALL            10 17 57   ;CALL function
                           #--- PUSHB_4   64 57 10 9 ;PUSH Bytes
CALL            9 10 57 64 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   17 57 10  ;PUSH Bytes
CALL            10 57 17   ;CALL function
                           #--- PUSHB_4   64 17 15 9 ;PUSH Bytes
CALL            9 15 17 64 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   43 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 43 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
                           #--- DUP       #5        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   5 57      ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_2   36 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   38 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 56      ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_5   30 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 30 ;CALL function
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   52 4      ;PUSH Bytes
MIRP[min,black] stemt 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   52 5 10   ;PUSH Bytes
CALL            10 5 52    ;CALL function
                           #--- PUSHB_4   64 52 63 9 ;PUSH Bytes
CALL            9 63 52 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDRP[rp0,rnd,white] 43         ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_1   54        ;PUSH Bytes
                           #--- DUP       #54       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 54         ;Move Direct Relative Point
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_2   65 6      ;PUSH Bytes
MIRP[min,black] stemw 65   ;Move Indirect Relative Point
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_2   54 6      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_1   33        ;PUSH Bytes
                           #--- DUP       #33       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   45 47     ;PUSH Bytes
SDPVTL[orthog]  47 45      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[no-rnd]    45         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDRP[grey]      47         ;Move Direct Relative Point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[grey]      12         ;Move Direct Relative Point
                           #--- PUSHB_4   13 14 12 19 ;PUSH Bytes
CALL            19 12 14 13 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_4   46 45 47 19 ;PUSH Bytes
CALL            19 47 45 46 ;CALL function
                           #--- PUSHB_3   46 45 47  ;PUSH Bytes
                           #--- DUP       #47       ;DUPlicate top stack element
ROLL            47 47 45   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              46         ;Interpolate Point
                           #--- PUSHB_3   13 14 12  ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   12 13 14 45 46 47 ;PUSH Bytes
MDAP[no-rnd]    47         ;Move Direct Absolute Point
MDAP[no-rnd]    46         ;Move Direct Absolute Point
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    12         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   12 13 14 45 46 47 ;PUSH Bytes
MDAP[no-rnd]    47         ;Move Direct Absolute Point
MDAP[no-rnd]    46         ;Move Direct Absolute Point
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    12         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 65     ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   0 63      ;PUSH Bytes
IP              63         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_2   3 57      ;PUSH Bytes
IP              57         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_3   5 19 40   ;PUSH Bytes
IP              40         ;Interpolate Point
IP              19         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_3   30 36 38  ;PUSH Bytes
IP              38         ;Interpolate Point
IP              36         ;Interpolate Point
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   8 43      ;PUSH Bytes
IP              43         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_5   22 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 22 ;CALL function
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_5   49 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 49 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   15 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   0 5 49    ;PUSH Bytes
IP              49         ;Interpolate Point
IP              5          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_2   15 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_2   13 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_2   10 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01A9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_5   1 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 1  ;CALL function
                           #--- PUSHB_3   9 2 0     ;PUSH Bytes
CALL            0 2 9      ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   9 2 0     ;PUSH Bytes
CALL            0 2 9      ;CALL function
                           #--- PUSHB_5   13 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_3   19 3 10   ;PUSH Bytes
CALL            10 3 19    ;CALL function
                           #--- PUSHB_4   64 19 5 9 ;PUSH Bytes
CALL            9 5 19 64  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   7 17      ;PUSH Bytes
IP              17         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_2   9 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01AB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   39 9 10   ;PUSH Bytes
CALL            10 9 39    ;CALL function
                           #--- PUSHB_4   64 39 44 9 ;PUSH Bytes
CALL            9 44 39 64 ;CALL function
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 51 10   ;PUSH Bytes
CALL            10 51 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   36 12 10  ;PUSH Bytes
CALL            10 12 36   ;CALL function
                           #--- PUSHB_4   64 36 32 9 ;PUSH Bytes
CALL            9 32 36 64 ;CALL function
                           #--- PUSHB_3   12 36 10  ;PUSH Bytes
CALL            10 36 12   ;CALL function
                           #--- PUSHB_4   64 12 16 9 ;PUSH Bytes
CALL            9 16 12 64 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 48 10   ;PUSH Bytes
CALL            10 48 6    ;CALL function
                           #--- PUSHB_4   0 6 54 9  ;PUSH Bytes
CALL            9 54 6 0   ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   6 36      ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   9 39      ;PUSH Bytes
IP              39         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01AC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_5   25 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 25 ;CALL function
                           #--- PUSHB_3   6 20 10   ;PUSH Bytes
CALL            10 20 6    ;CALL function
                           #--- PUSHB_4   64 6 14 9 ;PUSH Bytes
CALL            9 14 6 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 4 10   ;PUSH Bytes
CALL            10 4 30    ;CALL function
                           #--- PUSHB_4   64 30 33 9 ;PUSH Bytes
CALL            9 33 30 64 ;CALL function
                           #--- PUSHB_3   4 30 10   ;PUSH Bytes
CALL            10 30 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01AD': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   45 0 0    ;PUSH Bytes
CALL            0 0 45     ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 3 0     ;PUSH Bytes
CALL            0 3 8      ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   0 17 14 9 ;PUSH Bytes
CALL            9 14 17 0  ;CALL function
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDRP[rp0,rnd,white] 48         ;Move Direct Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   30 48 10  ;PUSH Bytes
CALL            10 48 30   ;CALL function
                           #--- PUSHB_4   64 30 26 9 ;PUSH Bytes
CALL            9 26 30 64 ;CALL function
                           #--- PUSHB_4   0 30 11 9 ;PUSH Bytes
CALL            9 11 30 0  ;CALL function
                           #--- PUSHB_4   0 30 41 9 ;PUSH Bytes
CALL            9 41 30 0  ;CALL function
                           #--- PUSHB_3   48 30 10  ;PUSH Bytes
CALL            10 30 48   ;CALL function
                           #--- PUSHB_4   64 48 0 9 ;PUSH Bytes
CALL            9 0 48 64  ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01AE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_5   0 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 0  ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 17 10   ;PUSH Bytes
CALL            10 17 8    ;CALL function
                           #--- PUSHB_4   0 8 11 9  ;PUSH Bytes
CALL            9 11 8 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   0 5 14 9  ;PUSH Bytes
CALL            9 14 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01B3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 40 10  ;PUSH Bytes
CALL            10 40 29   ;CALL function
                           #--- PUSHB_4   64 29 32 9 ;PUSH Bytes
CALL            9 32 29 64 ;CALL function
                           #--- PUSHB_3   40 29 10  ;PUSH Bytes
CALL            10 29 40   ;CALL function
                           #--- PUSHB_4   64 40 36 9 ;PUSH Bytes
CALL            9 36 40 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   22 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 22 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   29 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   22 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   13 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_3   3 0 12    ;PUSH Bytes
IP              12         ;Interpolate Point
IP              0          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   11 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01B4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_2   7 25      ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   0 5 10    ;PUSH Bytes
CALL            10 5 0     ;CALL function
                           #--- PUSHB_4   0 0 19 9  ;PUSH Bytes
CALL            9 19 0 0   ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 3  ;CALL function
                           #--- PUSHB_3   3 47 10   ;PUSH Bytes
CALL            10 47 3    ;CALL function
                           #--- PUSHB_4   64 3 33 9 ;PUSH Bytes
CALL            9 33 3 64  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 22 10  ;PUSH Bytes
CALL            10 22 13   ;CALL function
                           #--- PUSHB_4   0 13 16 9 ;PUSH Bytes
CALL            9 16 13 0  ;CALL function
                           #--- PUSHB_4   64 13 9 9 ;PUSH Bytes
CALL            9 9 13 64  ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   3 47      ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   5 44      ;PUSH Bytes
IP              44         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_4   6 7 25 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 25 7 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 42      ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   6 45      ;PUSH Bytes
IP              45         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01B5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_5   9 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 9 ;CALL function
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_5   25 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 25 ;CALL function
                           #--- PUSHB_5   16 19 13 27 13 ;PUSH Bytes
CALL            13 27 13 19 16 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 26 10  ;PUSH Bytes
CALL            10 26 23   ;CALL function
                           #--- PUSHB_4   64 23 0 9 ;PUSH Bytes
CALL            9 0 23 64  ;CALL function
                           #--- PUSHB_4   64 23 29 9 ;PUSH Bytes
CALL            9 29 23 64 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 11 10   ;PUSH Bytes
CALL            10 11 5    ;CALL function
                           #--- PUSHB_4   64 5 13 9 ;PUSH Bytes
CALL            9 13 5 64  ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   23 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_5   3 4 20 21 30 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              30 21 20 4 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_2   27 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01B6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_5   7 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 7 ;CALL function
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_5   25 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 25 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 26 10  ;PUSH Bytes
CALL            10 26 23   ;CALL function
                           #--- PUSHB_4   64 23 11 9 ;PUSH Bytes
CALL            9 11 23 64 ;CALL function
                           #--- PUSHB_4   64 23 29 9 ;PUSH Bytes
CALL            9 29 23 64 ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   23 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   17 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_5   3 14 19 20 30 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              30 20 19 14 3 ;Interpolate Point
                           #--- PUSHB_2   27 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01B7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_5   1 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 1 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 15 10  ;PUSH Bytes
CALL            10 15 29   ;CALL function
                           #--- PUSHB_4   0 29 24 9 ;PUSH Bytes
CALL            9 24 29 0  ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_2   6 8       ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   44 2 10   ;PUSH Bytes
CALL            10 2 44    ;CALL function
                           #--- PUSHB_4   64 44 5 9 ;PUSH Bytes
CALL            9 5 44 64  ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 11 10  ;PUSH Bytes
CALL            10 11 32   ;CALL function
                           #--- PUSHB_4   0 32 20 9 ;PUSH Bytes
CALL            9 20 32 0  ;CALL function
                           #--- PUSHB_4   64 32 39 9 ;PUSH Bytes
CALL            9 39 32 64 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   32 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   6 42      ;PUSH Bytes
IP              42         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_2   3 43      ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01B8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_5   1 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 1 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 30 10  ;PUSH Bytes
CALL            10 30 17   ;CALL function
                           #--- PUSHB_4   0 17 22 9 ;PUSH Bytes
CALL            9 22 17 0  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 34 10  ;PUSH Bytes
CALL            10 34 14   ;CALL function
                           #--- PUSHB_4   0 14 25 9 ;PUSH Bytes
CALL            9 25 14 0  ;CALL function
                           #--- PUSHB_4   64 14 8 9 ;PUSH Bytes
CALL            9 8 14 64  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 42 10   ;PUSH Bytes
CALL            10 42 2    ;CALL function
                           #--- PUSHB_4   64 2 39 9 ;PUSH Bytes
CALL            9 39 2 64  ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   2 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   4 38      ;PUSH Bytes
IP              38         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01BB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_5   18 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 18 ;CALL function
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   34 3 10   ;PUSH Bytes
CALL            10 3 34    ;CALL function
                           #--- PUSHB_4   0 34 40 9 ;PUSH Bytes
CALL            9 40 34 0  ;CALL function
                           #--- PUSHB_5   25 28 22 3 13 ;PUSH Bytes
CALL            13 3 22 28 25 ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 31 10   ;PUSH Bytes
CALL            10 31 5    ;CALL function
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
                           #--- PUSHB_4   64 5 21 9 ;PUSH Bytes
CALL            9 21 5 64  ;CALL function
                           #--- PUSHB_3   31 5 10   ;PUSH Bytes
CALL            10 5 31    ;CALL function
                           #--- PUSHB_4   64 31 27 9 ;PUSH Bytes
CALL            9 27 31 64 ;CALL function
                           #--- PUSHB_4   64 31 22 9 ;PUSH Bytes
CALL            9 22 31 64 ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   31 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   3 12 15 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 15 12 3 ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_3   7 16 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              16         ;Interpolate Point
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_2   28 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01C0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 3 0    ;PUSH Bytes
CALL            0 3 10     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01C3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_5   34 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 34 ;CALL function
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 28 46   ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 17 21 14 ;PUSH Bytes
CALL            14 21 17 9 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_5   27 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 27 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   9 4 0 14  ;PUSH Bytes
CALL            14 0 4 9   ;CALL function
                           #--- PUSHB_5   49 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   38 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_2   44 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   40 9      ;PUSH Bytes
IP              9          ;Interpolate Point
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_2   34 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01C8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_5   8 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 8  ;CALL function
                           #--- PUSHB_3   53 3 0    ;PUSH Bytes
CALL            0 3 53     ;CALL function
                           #--- PUSHB_2   52 4      ;PUSH Bytes
MIRP[min,black] stemt 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 2 0    ;PUSH Bytes
CALL            0 2 26     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   42 1 0    ;PUSH Bytes
CALL            0 1 42     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_4   8 19 23 14 ;PUSH Bytes
CALL            14 23 19 8 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 44 10  ;PUSH Bytes
CALL            10 44 35   ;CALL function
                           #--- PUSHB_4   64 35 28 9 ;PUSH Bytes
CALL            9 28 35 64 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_5   39 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_4   51 44 35 8 ;PUSH Bytes
CALL            8 35 44 51 ;CALL function
                           #--- PUSHB_5   52 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 52 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_5   51 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 51 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_2   52 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   8 32      ;PUSH Bytes
IP              32         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01C9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 0 0    ;PUSH Bytes
CALL            0 0 43     ;CALL function
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   62 3 0    ;PUSH Bytes
CALL            0 3 62     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   54 4      ;PUSH Bytes
MIRP[min,black] stemt 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
MDRP[rp0,rnd,white] 52         ;Move Direct Relative Point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 52 10  ;PUSH Bytes
CALL            10 52 33   ;CALL function
                           #--- PUSHB_4   64 33 38 9 ;PUSH Bytes
CALL            9 38 33 64 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_5   58 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 58 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_3   58 33 10  ;PUSH Bytes
CALL            10 33 58   ;CALL function
                           #--- PUSHB_4   64 58 47 9 ;PUSH Bytes
CALL            9 47 58 64 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 11 10  ;PUSH Bytes
CALL            10 11 27   ;CALL function
                           #--- PUSHB_4   64 27 19 9 ;PUSH Bytes
CALL            9 19 27 64 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_5   5 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 5  ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_4   29 11 27 8 ;PUSH Bytes
CALL            8 27 11 29 ;CALL function
                           #--- PUSHB_5   30 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 29 ;CALL function
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   33 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_2   30 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01CB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   50 2 0    ;PUSH Bytes
CALL            0 2 50     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_2   30 53     ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDRP[rp0,rnd,white] 43         ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_4   10 43 40 14 ;PUSH Bytes
CALL            14 40 43 10 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_5   36 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 36 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_4   10 30 28 14 ;PUSH Bytes
CALL            14 28 30 10 ;CALL function
                           #--- PUSHB_5   55 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_5   28 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 28 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 20 10  ;PUSH Bytes
CALL            10 20 11   ;CALL function
                           #--- PUSHB_4   64 11 4 9 ;PUSH Bytes
CALL            9 4 11 64  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_5   15 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_1   1         ;PUSH Bytes
                           #--- DUP       #1        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   34 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_2   52 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_2   15 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   33 52     ;PUSH Bytes
IP              52         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_2   50 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_3   28 47 55  ;PUSH Bytes
IP              55         ;Interpolate Point
IP              47         ;Interpolate Point
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01CC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 0 0    ;PUSH Bytes
CALL            0 0 43     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_2   34 64     ;PUSH Bytes
SHP[rp2]        64         ;SHift Point using reference point
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   56 1 0    ;PUSH Bytes
CALL            0 1 56     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   52 4      ;PUSH Bytes
MIRP[min,black] stemt 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   61 1 0    ;PUSH Bytes
CALL            0 1 61     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDRP[rp0,rnd,white] 51         ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_3   51 34 10  ;PUSH Bytes
CALL            10 34 51   ;CALL function
                           #--- PUSHB_4   64 51 54 9 ;PUSH Bytes
CALL            9 54 51 64 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_4   9 51 47 14 ;PUSH Bytes
CALL            14 47 51 9 ;CALL function
                           #--- PUSHB_5   38 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 38 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   64 6      ;PUSH Bytes
MIRP[min,black] stemw 64   ;Move Indirect Relative Point
                           #--- PUSHB_5   66 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 66 ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP0            64         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 20 10  ;PUSH Bytes
CALL            10 20 11   ;CALL function
                           #--- PUSHB_4   64 11 4 9 ;PUSH Bytes
CALL            9 4 11 64  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_5   15 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_1   1         ;PUSH Bytes
                           #--- DUP       #1        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_5   2 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 2 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 1 ;CALL function
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_2   38 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   61        ;PUSH Bytes
IP              61         ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP2            64         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   56 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_3   15 54 58  ;PUSH Bytes
IP              58         ;Interpolate Point
IP              54         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01CD': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   7 37      ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   44 26 10  ;PUSH Bytes
CALL            10 26 44   ;CALL function
                           #--- PUSHB_4   64 44 10 9 ;PUSH Bytes
CALL            9 10 44 64 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   26 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   19 29 35  ;PUSH Bytes
IP              35         ;Interpolate Point
IP              29         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 44      ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_3   3 7 32    ;PUSH Bytes
IP              32         ;Interpolate Point
IP              7          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   39 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01CF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_3   17 25 37  ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
SHP[rp1]        25         ;SHift Point using reference point
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_5   39 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 39 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_5   59 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 59 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 5 8 14  ;PUSH Bytes
CALL            14 8 5 8   ;CALL function
                           #--- PUSHB_5   15 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 15 ;CALL function
                           #--- PUSHB_4   46 19 5 8 ;PUSH Bytes
CALL            8 5 19 46  ;CALL function
                           #--- PUSHB_5   41 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 41 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   8 0 35 14 ;PUSH Bytes
CALL            14 35 0 8  ;CALL function
                           #--- PUSHB_5   28 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 35 ;CALL function
                           #--- PUSHB_4   50 0 24 8 ;PUSH Bytes
CALL            8 24 0 50  ;CALL function
                           #--- PUSHB_5   55 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_5   50 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 50 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   19 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   38 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_2   24 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_3   22 48 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              48         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01D6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_3   17 25 37  ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
SHP[rp1]        25         ;SHift Point using reference point
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_5   39 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 39 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 5 8 14  ;PUSH Bytes
CALL            14 8 5 8   ;CALL function
                           #--- PUSHB_5   15 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 15 ;CALL function
                           #--- PUSHB_4   46 19 5 8 ;PUSH Bytes
CALL            8 5 19 46  ;CALL function
                           #--- PUSHB_5   41 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 41 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   8 0 35 14 ;PUSH Bytes
CALL            14 35 0 8  ;CALL function
                           #--- PUSHB_5   28 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 35 ;CALL function
                           #--- PUSHB_4   50 0 24 8 ;PUSH Bytes
CALL            8 24 0 50  ;CALL function
                           #--- PUSHB_5   55 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_5   50 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_1   70        ;PUSH Bytes
                           #--- DUP       #70       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 70         ;Move Direct Relative Point
SRP1            70         ;Set Reference Point 1
                           #--- PUSHB_5   62 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 62 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_5   70 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 70 ;CALL function
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   19 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   38 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_2   28 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
                           #--- PUSHB_2   70 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_4   22 53 47 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              67 47 53 22 ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01D8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   57 3 0    ;PUSH Bytes
CALL            0 3 57     ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp1]        65         ;SHift Point using reference point
                           #--- PUSHB_5   62 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 62 ;CALL function
                           #--- PUSHB_1   70        ;PUSH Bytes
SHP[rp2]        70         ;SHift Point using reference point
                           #--- PUSHB_3   9 3 0     ;PUSH Bytes
CALL            0 3 9      ;CALL function
                           #--- PUSHB_3   64 3 0    ;PUSH Bytes
CALL            0 3 64     ;CALL function
                           #--- PUSHB_3   73 3 0    ;PUSH Bytes
CALL            0 3 73     ;CALL function
                           #--- PUSHB_5   29 24 21 57 13 ;PUSH Bytes
CALL            13 57 21 24 29 ;CALL function
                           #--- PUSHB_3   35 43 55  ;PUSH Bytes
SHP[rp1]        55         ;SHift Point using reference point
SHP[rp1]        43         ;SHift Point using reference point
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_4   9 62 57 8 ;PUSH Bytes
CALL            8 57 62 9  ;CALL function
                           #--- PUSHB_4   15 9 62 14 ;PUSH Bytes
CALL            14 62 9 15 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 23 26 14 ;PUSH Bytes
CALL            14 26 23 8 ;CALL function
                           #--- PUSHB_5   33 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 33 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_1   64        ;PUSH Bytes
                           #--- DUP       #64       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 64         ;Move Direct Relative Point
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_5   59 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 59 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_4   8 18 53 14 ;PUSH Bytes
CALL            14 53 18 8 ;CALL function
                           #--- PUSHB_5   46 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   53 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 53 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_1   68        ;PUSH Bytes
                           #--- DUP       #68       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 68         ;Move Direct Relative Point
SRP1            68         ;Set Reference Point 1
                           #--- PUSHB_5   73 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 73 ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_5   68 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 68 ;CALL function
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_2   37 64     ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   15 12 56 62 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              62 56 12 15 ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_2   21 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_2   46 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   9 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   65 71     ;PUSH Bytes
IP              71         ;Interpolate Point
IP              65         ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
                           #--- PUSHB_3   3 6 66    ;PUSH Bytes
IP              66         ;Interpolate Point
IP              6          ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 62      ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   59 68     ;PUSH Bytes
IP              68         ;Interpolate Point
IP              59         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01DA': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_2   49 4      ;PUSH Bytes
MIRP[min,black] stemt 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   55 2 0    ;PUSH Bytes
CALL            0 2 55     ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp1]        65         ;SHift Point using reference point
                           #--- PUSHB_5   61 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 61 ;CALL function
                           #--- PUSHB_1   70        ;PUSH Bytes
SHP[rp2]        70         ;SHift Point using reference point
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDRP[rp0,rnd,white] 37         ;Move Direct Relative Point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_5   42 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 42 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_1   63        ;PUSH Bytes
                           #--- DUP       #63       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 63         ;Move Direct Relative Point
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_5   58 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 58 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 52 10  ;PUSH Bytes
CALL            10 52 26   ;CALL function
                           #--- PUSHB_4   64 26 28 9 ;PUSH Bytes
CALL            9 28 26 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   22 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_4   68 26 52 8 ;PUSH Bytes
CALL            8 52 26 68 ;CALL function
                           #--- PUSHB_5   73 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 73 ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_5   68 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 68 ;CALL function
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   63 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_3   16 55 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              55         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_2   22 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_4   9 0 34 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 34 0 9  ;Interpolate Point
                           #--- PUSHB_2   52 73     ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   65 71     ;PUSH Bytes
IP              71         ;Interpolate Point
IP              65         ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   49 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_2   39 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01DB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_3   33 41 53  ;PUSH Bytes
SHP[rp1]        53         ;SHift Point using reference point
SHP[rp1]        41         ;SHift Point using reference point
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp1]        68         ;SHift Point using reference point
                           #--- PUSHB_5   55 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 55 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp2]        63         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 21 24 14 ;PUSH Bytes
CALL            14 24 21 8 ;CALL function
                           #--- PUSHB_5   31 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 31 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_1   62        ;PUSH Bytes
                           #--- DUP       #62       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 62         ;Move Direct Relative Point
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_5   57 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 57 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_4   8 16 51 14 ;PUSH Bytes
CALL            14 51 16 8 ;CALL function
                           #--- PUSHB_5   44 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_5   51 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 51 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_1   66        ;PUSH Bytes
                           #--- DUP       #66       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 66         ;Move Direct Relative Point
SRP1            66         ;Set Reference Point 1
                           #--- PUSHB_5   71 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 71 ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_5   66 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 66 ;CALL function
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   35 62     ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_3   11 54 60  ;PUSH Bytes
IP              60         ;Interpolate Point
IP              54         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_3   19 14 55  ;PUSH Bytes
IP              55         ;Interpolate Point
IP              14         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_2   44 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
                           #--- PUSHB_2   38 3      ;PUSH Bytes
IP              3          ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   63 69     ;PUSH Bytes
IP              69         ;Interpolate Point
IP              63         ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
                           #--- PUSHB_1   64        ;PUSH Bytes
IP              64         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 60      ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_4   57 62 66 71 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              71 66 62 57 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01DC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   17 5      ;PUSH Bytes
MIRP[min,black] cvt_5 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 7 27    ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   35 5      ;PUSH Bytes
MIRP[min,black] cvt_5 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 5      ;PUSH Bytes
MIRP[min,black] cvt_5 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_5   37 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 37 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_5   57 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 57 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_5   39 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_5   48 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 48 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   39 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_4   6 7 35 18 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              18 35 7 6  ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_5   4 5 26 0 33 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              33 0 26 5 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01DF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   17 5      ;PUSH Bytes
MIRP[min,black] cvt_5 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 7 27    ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   35 5      ;PUSH Bytes
MIRP[min,black] cvt_5 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 5      ;PUSH Bytes
MIRP[min,black] cvt_5 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_5   37 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 37 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   48 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 48 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_5   39 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 39 ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   39 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_3   26 34 0   ;PUSH Bytes
IP              0          ;Interpolate Point
IP              34         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01E1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   53 4      ;PUSH Bytes
MIRP[min,black] stemt 53   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_5   29 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 29 ;CALL function
                           #--- PUSHB_5   4 64 8 18 13 ;PUSH Bytes
CALL            13 18 8 64 4 ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_5   57 62 8 18 13 ;PUSH Bytes
CALL            13 18 8 62 57 ;CALL function
                           #--- PUSHB_2   57 4      ;PUSH Bytes
MIRP[min,black] stemt 57   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_5   0 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_1   64        ;PUSH Bytes
                           #--- DUP       #64       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 64         ;Move Direct Relative Point
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_5   59 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 59 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_5   64 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 64 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP0            64         ;Set Reference Point 0
                           #--- PUSHB_1   26        ;PUSH Bytes
                           #--- DUP       #26       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   55 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_4   8 18 53 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 53 18 8 ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP2            64         ;Set Reference Point 2
                           #--- PUSHB_3   20 22 29  ;PUSH Bytes
IP              29         ;Interpolate Point
IP              22         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_2   18 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01EB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   38 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 38 ;CALL function
                           #--- PUSHB_3   38 12 10  ;PUSH Bytes
CALL            10 12 38   ;CALL function
                           #--- PUSHB_4   0 38 6 9  ;PUSH Bytes
CALL            9 6 38 0   ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   38 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_4   21 27 40 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 40 27 21 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   12 18 24 45 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              45 24 18 12 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01EC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   28 0 0    ;PUSH Bytes
CALL            0 0 28     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_5   42 26 28 16 13 ;PUSH Bytes
CALL            13 16 28 26 42 ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_5   30 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_5   37 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_5   2 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 2 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01F8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   28 0 0    ;PUSH Bytes
CALL            0 0 28     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_5   33 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 33 ;CALL function
                           #--- PUSHB_3   19 23 42  ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   51 3 0    ;PUSH Bytes
CALL            0 3 51     ;CALL function
                           #--- PUSHB_5   63 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 63 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_3   40 1 0    ;PUSH Bytes
CALL            0 1 40     ;CALL function
                           #--- PUSHB_5   35 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 35 ;CALL function
                           #--- PUSHB_5   22 50 28 40 13 ;PUSH Bytes
CALL            13 40 28 50 22 ;CALL function
                           #--- PUSHB_5   22 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 22 ;CALL function
                           #--- PUSHB_5   57 68 35 51 13 ;PUSH Bytes
CALL            13 51 35 68 57 ;CALL function
                           #--- PUSHB_5   57 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 57 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   59        ;PUSH Bytes
MDRP[rp0,rnd,white] 59         ;Move Direct Relative Point
                           #--- PUSHB_5   65 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 65 ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP0            65         ;Set Reference Point 0
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_5   54 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 54 ;CALL function
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   65 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_3   3 57 50   ;PUSH Bytes
IP              50         ;Interpolate Point
IP              57         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP1            70         ;Set Reference Point 1
                           #--- PUSHB_3   11 49 51  ;PUSH Bytes
IP              51         ;Interpolate Point
IP              49         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_4   16 41 48 14 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              14 48 41 16 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_2   63 68     ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_2   54 59     ;PUSH Bytes
IP              59         ;Interpolate Point
IP              54         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01aa': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_5   6 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 6 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_5   11 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   33 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 3 10   ;PUSH Bytes
CALL            10 3 15    ;CALL function
                           #--- PUSHB_4   64 15 24 9 ;PUSH Bytes
CALL            9 24 15 64 ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   3 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   6 11 38   ;PUSH Bytes
IP              38         ;Interpolate Point
IP              11         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   4 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_2   11 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01b1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   62 0 0    ;PUSH Bytes
CALL            0 0 62     ;CALL function
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_5   5 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 5 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_5   18 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 18 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   68        ;PUSH Bytes
MDRP[rp0,rnd,white] 68         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_1   3         ;PUSH Bytes
                           #--- DUP       #3        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_5   15 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 3 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   18 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   52 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 52 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
                           #--- DUP       #49       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_2   3 68      ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_2   55 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   55 68     ;PUSH Bytes
IP              68         ;Interpolate Point
IP              55         ;Interpolate Point
                           #--- PUSHB_2   2 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   0 52      ;PUSH Bytes
IP              52         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01b2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   33 5      ;PUSH Bytes
MIRP[min,black] cvt_5 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   6 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 14 10  ;PUSH Bytes
CALL            10 14 30   ;CALL function
                           #--- PUSHB_4   64 30 25 9 ;PUSH Bytes
CALL            9 25 30 64 ;CALL function
                           #--- PUSHB_3   14 30 10  ;PUSH Bytes
CALL            10 30 14   ;CALL function
                           #--- PUSHB_4   64 14 19 9 ;PUSH Bytes
CALL            9 19 14 64 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_5   4 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 4 ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   0 30      ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01b9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 1 0    ;PUSH Bytes
CALL            0 1 34     ;CALL function
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 19 10   ;PUSH Bytes
CALL            10 19 6    ;CALL function
                           #--- PUSHB_4   64 6 12 9 ;PUSH Bytes
CALL            9 12 6 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 3 ;CALL function
                           #--- PUSHB_3   22 3 10   ;PUSH Bytes
CALL            10 3 22    ;CALL function
                           #--- PUSHB_4   64 22 30 9 ;PUSH Bytes
CALL            9 30 22 64 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   3 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01ba': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_2   33 5      ;PUSH Bytes
MIRP[min,black] cvt_5 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   66 5      ;PUSH Bytes
MIRP[min,black] cvt_5 66   ;Move Indirect Relative Point
                           #--- PUSHB_3   66 0 10   ;PUSH Bytes
CALL            10 0 66    ;CALL function
                           #--- PUSHB_4   0 66 73 9 ;PUSH Bytes
CALL            9 73 66 0  ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   62 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 62 ;CALL function
                           #--- PUSHB_3   62 6 10   ;PUSH Bytes
CALL            10 6 62    ;CALL function
                           #--- PUSHB_4   0 62 76 9 ;PUSH Bytes
CALL            9 76 62 0  ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP0            62         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   57 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 57 ;CALL function
                           #--- PUSHB_3   57 14 10  ;PUSH Bytes
CALL            10 14 57   ;CALL function
                           #--- PUSHB_4   64 57 42 9 ;PUSH Bytes
CALL            9 42 57 64 ;CALL function
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   62 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_3   27 25 36  ;PUSH Bytes
IP              36         ;Interpolate Point
IP              25         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_5   11 22 32 54 60 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              60 54 32 22 11 ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_2   48 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              48         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01bc': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_2   47 5      ;PUSH Bytes
MIRP[min,black] cvt_5 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   53 27 10  ;PUSH Bytes
CALL            10 27 53   ;CALL function
                           #--- PUSHB_4   64 53 0 9 ;PUSH Bytes
CALL            9 0 53 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 3 10   ;PUSH Bytes
CALL            10 3 25    ;CALL function
                           #--- PUSHB_4   64 25 15 9 ;PUSH Bytes
CALL            9 15 25 64 ;CALL function
                           #--- PUSHB_3   3 25 10   ;PUSH Bytes
CALL            10 25 3    ;CALL function
                           #--- PUSHB_4   64 3 8 9  ;PUSH Bytes
CALL            9 8 3 64   ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   25 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   45 56     ;PUSH Bytes
IP              56         ;Interpolate Point
IP              45         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_4   27 33 47 53 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              53 47 33 27 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_3   30 38 41  ;PUSH Bytes
IP              41         ;Interpolate Point
IP              38         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01bd': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   20 5      ;PUSH Bytes
MIRP[min,black] cvt_5 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 13 10  ;PUSH Bytes
CALL            10 13 20   ;CALL function
                           #--- PUSHB_4   64 20 64 9 ;PUSH Bytes
CALL            9 64 20 64 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_2   52 5      ;PUSH Bytes
MIRP[min,black] cvt_5 52   ;Move Indirect Relative Point
                           #--- PUSHB_5   58 23 64 13 13 ;PUSH Bytes
CALL            13 13 64 23 58 ;CALL function
                           #--- PUSHB_2   58 5      ;PUSH Bytes
MIRP[min,black] cvt_5 58   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 21 10   ;PUSH Bytes
CALL            10 21 0    ;CALL function
                           #--- PUSHB_4   64 0 3 9  ;PUSH Bytes
CALL            9 3 0 64   ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_5   28 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 28 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   43 45 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              45         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_4   23 31 48 58 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              58 48 31 23 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
                           #--- PUSHB_2   28 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_2   13 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01be': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp1]        48         ;SHift Point using reference point
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 9 ;CALL function
                           #--- PUSHB_4   74 9 69 8 ;PUSH Bytes
CALL            8 69 9 74  ;CALL function
                           #--- PUSHB_5   3 4 0 14 4 ;PUSH Bytes
CALL            4 14 0 4 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   63 6      ;PUSH Bytes
MIRP[min,black] stemw 63   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_3   63 17 10  ;PUSH Bytes
CALL            10 17 63   ;CALL function
                           #--- PUSHB_4   64 63 52 9 ;PUSH Bytes
CALL            9 52 63 64 ;CALL function
                           #--- PUSHB_4   64 63 37 9 ;PUSH Bytes
CALL            9 37 63 64 ;CALL function
                           #--- PUSHB_3   17 63 10  ;PUSH Bytes
CALL            10 63 17   ;CALL function
                           #--- PUSHB_4   64 17 21 9 ;PUSH Bytes
CALL            9 21 17 64 ;CALL function
                           #--- PUSHB_4   64 17 30 9 ;PUSH Bytes
CALL            9 30 17 64 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   66 6      ;PUSH Bytes
MIRP[min,black] stemw 66   ;Move Indirect Relative Point
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   7 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   73        ;PUSH Bytes
IP              73         ;Interpolate Point
                           #--- PUSHB_2   63 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_2   9 69      ;PUSH Bytes
IP              69         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   66 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 74      ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   75        ;PUSH Bytes
IP              75         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_2   12 66     ;PUSH Bytes
IP              66         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   16 63     ;PUSH Bytes
IP              63         ;Interpolate Point
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01bf': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
                           #--- DUP       #40       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 5      ;PUSH Bytes
MIRP[min,black] cvt_5 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 34      ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   10 26 10  ;PUSH Bytes
CALL            10 26 10   ;CALL function
                           #--- PUSHB_4   64 10 14 9 ;PUSH Bytes
CALL            9 14 10 64 ;CALL function
                           #--- PUSHB_3   26 10 10  ;PUSH Bytes
CALL            10 10 26   ;CALL function
                           #--- PUSHB_4   64 26 21 9 ;PUSH Bytes
CALL            9 21 26 64 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   43 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 43 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   3 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   3 9 0 43  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 0 9 3   ;Interpolate Point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   30 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01c2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   69 3 0    ;PUSH Bytes
CALL            0 3 69     ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_2   47 5      ;PUSH Bytes
MIRP[min,black] cvt_5 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   62 5      ;PUSH Bytes
MIRP[min,black] cvt_5 62   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   48 63     ;PUSH Bytes
SHP[rp2]        63         ;SHift Point using reference point
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_5   19 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 19 ;CALL function
                           #--- PUSHB_2   8 78      ;PUSH Bytes
SHP[rp2]        78         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   19 33 10  ;PUSH Bytes
CALL            10 33 19   ;CALL function
                           #--- PUSHB_4   64 19 15 9 ;PUSH Bytes
CALL            9 15 19 64 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   33 19 10  ;PUSH Bytes
CALL            10 19 33   ;CALL function
                           #--- PUSHB_4   64 33 38 9 ;PUSH Bytes
CALL            9 38 33 64 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01c4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   76 0 0    ;PUSH Bytes
CALL            0 0 76     ;CALL function
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   3 5       ;PUSH Bytes
MIRP[min,black] cvt_5 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_2   58 64     ;PUSH Bytes
SHP[rp1]        64         ;SHift Point using reference point
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_2   31 5      ;PUSH Bytes
MIRP[min,black] cvt_5 31   ;Move Indirect Relative Point
                           #--- PUSHB_4   45 71 90 95 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        95 90 71 45 ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   99        ;PUSH Bytes
MDAP[rnd]       99         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_4   10 29 20 14 ;PUSH Bytes
CALL            14 20 29 10 ;CALL function
                           #--- PUSHB_5   8 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 8 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   96 6      ;PUSH Bytes
MIRP[min,black] stemw 96   ;Move Indirect Relative Point
                           #--- PUSHB_3   44 96 10  ;PUSH Bytes
CALL            10 96 44   ;CALL function
                           #--- PUSHB_4   64 44 49 9 ;PUSH Bytes
CALL            9 49 44 64 ;CALL function
                           #--- PUSHB_1   96        ;PUSH Bytes
SRP0            96         ;Set Reference Point 0
                           #--- PUSHB_2   78 1      ;PUSH Bytes
CALL            1 78       ;CALL function
                           #--- PUSHB_5   85 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 85 ;CALL function
                           #--- PUSHB_1   85        ;PUSH Bytes
SRP0            85         ;Set Reference Point 0
                           #--- PUSHB_2   89 1      ;PUSH Bytes
CALL            1 89       ;CALL function
                           #--- PUSHB_2   73 6      ;PUSH Bytes
MIRP[min,black] stemw 73   ;Move Indirect Relative Point
                           #--- PUSHB_3   73 89 10  ;PUSH Bytes
CALL            10 89 73   ;CALL function
                           #--- PUSHB_4   64 73 68 9 ;PUSH Bytes
CALL            9 68 73 64 ;CALL function
                           #--- PUSHB_2   100 1     ;PUSH Bytes
CALL            1 100      ;CALL function
                           #--- PUSHB_2   8 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   43 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_2   85 78     ;PUSH Bytes
SRP1            78         ;Set Reference Point 1
SRP2            85         ;Set Reference Point 2
                           #--- PUSHB_2   62 93     ;PUSH Bytes
IP              93         ;Interpolate Point
IP              62         ;Interpolate Point
                           #--- PUSHB_1   89        ;PUSH Bytes
SRP1            89         ;Set Reference Point 1
                           #--- PUSHB_1   76        ;PUSH Bytes
IP              76         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   29 87     ;PUSH Bytes
IP              87         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_4   2 44 82 85 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              85 82 44 2 ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_3   62 68 93  ;PUSH Bytes
IP              93         ;Interpolate Point
IP              68         ;Interpolate Point
IP              62         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01ef': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 0 0    ;PUSH Bytes
CALL            0 0 26     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   32 52     ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   0 26 10   ;PUSH Bytes
CALL            10 26 0    ;CALL function
                           #--- PUSHB_4   0 0 57 9  ;PUSH Bytes
CALL            9 57 0 0   ;CALL function
                           #--- PUSHB_3   46 2 0    ;PUSH Bytes
CALL            0 2 46     ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   32 0 10   ;PUSH Bytes
CALL            10 0 32    ;CALL function
                           #--- PUSHB_4   64 32 30 9 ;PUSH Bytes
CALL            9 30 32 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_4   48 24 5 8 ;PUSH Bytes
CALL            8 5 24 48  ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 48 10  ;PUSH Bytes
CALL            10 48 17   ;CALL function
                           #--- PUSHB_4   64 17 51 9 ;PUSH Bytes
CALL            9 51 17 64 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   53 12 10  ;PUSH Bytes
CALL            10 12 53   ;CALL function
                           #--- PUSHB_4   64 53 13 9 ;PUSH Bytes
CALL            9 13 53 64 ;CALL function
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   17 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_4   19 21 33 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 33 21 19 ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01f2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   10 44     ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_5   15 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 15 ;CALL function
                           #--- PUSHB_3   58 2 0    ;PUSH Bytes
CALL            0 2 58     ;CALL function
                           #--- PUSHB_2   7 5       ;PUSH Bytes
MIRP[min,black] cvt_5 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   60 1 0    ;PUSH Bytes
CALL            0 1 60     ;CALL function
                           #--- PUSHB_5   25 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 25 ;CALL function
                           #--- PUSHB_3   60 1 0    ;PUSH Bytes
CALL            0 1 60     ;CALL function
                           #--- PUSHB_2   22 5      ;PUSH Bytes
MIRP[min,black] cvt_5 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 0 10   ;PUSH Bytes
CALL            10 0 44    ;CALL function
                           #--- PUSHB_4   64 44 35 9 ;PUSH Bytes
CALL            9 35 44 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 17 10  ;PUSH Bytes
CALL            10 17 11   ;CALL function
                           #--- PUSHB_4   64 11 19 9 ;PUSH Bytes
CALL            9 19 11 64 ;CALL function
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   28 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   10 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   9 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_2   22 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01f3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   15 5      ;PUSH Bytes
MIRP[min,black] cvt_5 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   46 0 0    ;PUSH Bytes
CALL            0 0 46     ;CALL function
                           #--- PUSHB_2   58 5      ;PUSH Bytes
MIRP[min,black] cvt_5 58   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 44 10  ;PUSH Bytes
CALL            10 44 15   ;CALL function
                           #--- PUSHB_4   64 15 34 9 ;PUSH Bytes
CALL            9 34 15 64 ;CALL function
                           #--- PUSHB_3   13 3 0    ;PUSH Bytes
CALL            0 3 13     ;CALL function
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   22 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 22 ;CALL function
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   56 1 0    ;PUSH Bytes
CALL            0 1 56     ;CALL function
                           #--- PUSHB_2   63 5      ;PUSH Bytes
MIRP[min,black] cvt_5 63   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDRP[rp0,rnd,white] 51         ;Move Direct Relative Point
                           #--- PUSHB_2   67 6      ;PUSH Bytes
MIRP[min,black] stemw 67   ;Move Indirect Relative Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP0            67         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   60 15 10  ;PUSH Bytes
CALL            10 15 60   ;CALL function
                           #--- PUSHB_4   64 60 5 9 ;PUSH Bytes
CALL            9 5 60 64  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 25 10  ;PUSH Bytes
CALL            10 25 19   ;CALL function
                           #--- PUSHB_4   64 19 28 9 ;PUSH Bytes
CALL            9 28 19 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   60 67     ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_3   8 46 56   ;PUSH Bytes
IP              56         ;Interpolate Point
IP              46         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_2   19 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_2   17 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_4   37 51 60 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              67 60 51 37 ;Interpolate Point
                           #--- PUSHB_2   26 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni01f7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 2 0     ;PUSH Bytes
CALL            0 2 2      ;CALL function
                           #--- PUSHB_2   53 5      ;PUSH Bytes
MIRP[min,black] cvt_5 53   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 2 0    ;PUSH Bytes
CALL            0 2 43     ;CALL function
                           #--- PUSHB_2   31 5      ;PUSH Bytes
MIRP[min,black] cvt_5 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   44 46     ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_3   9 29 10   ;PUSH Bytes
CALL            10 29 9    ;CALL function
                           #--- PUSHB_4   64 9 12 9 ;PUSH Bytes
CALL            9 12 9 64  ;CALL function
                           #--- PUSHB_3   29 9 10   ;PUSH Bytes
CALL            10 9 29    ;CALL function
                           #--- PUSHB_4   64 29 19 9 ;PUSH Bytes
CALL            9 19 29 64 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_5   5 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 5 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   50 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   5 46 47 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 47 46 5 ;Interpolate Point
                           #--- PUSHB_2   43 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni021c': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_2   47 5      ;PUSH Bytes
MIRP[min,black] cvt_5 47   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 32 10   ;PUSH Bytes
CALL            10 32 5    ;CALL function
                           #--- PUSHB_4   64 5 0 9  ;PUSH Bytes
CALL            9 0 5 64   ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_1   36        ;PUSH Bytes
                           #--- DUP       #36       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_5   53 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 53 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_5   36 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 36 ;CALL function
                           #--- PUSHB_3   53 36 10  ;PUSH Bytes
CALL            10 36 53   ;CALL function
                           #--- PUSHB_4   0 53 44 9 ;PUSH Bytes
CALL            9 44 53 0  ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   32 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 47      ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_6   5 10 13 14 32 36 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              36 32 14 13 10 5 ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni021d': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 1 0    ;PUSH Bytes
CALL            0 1 30     ;CALL function
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_2   12 5      ;PUSH Bytes
MIRP[min,black] cvt_5 12   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   65        ;PUSH Bytes
MDRP[rp0,rnd,white] 65         ;Move Direct Relative Point
                           #--- PUSHB_5   45 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_1   41        ;PUSH Bytes
                           #--- DUP       #41       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   9 41 10   ;PUSH Bytes
CALL            10 41 9    ;CALL function
                           #--- PUSHB_4   64 9 0 9  ;PUSH Bytes
CALL            9 0 9 64   ;CALL function
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0225': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 20 10  ;PUSH Bytes
CALL            10 20 31   ;CALL function
                           #--- PUSHB_4   64 31 0 9 ;PUSH Bytes
CALL            9 0 31 64  ;CALL function
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_5   26 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 26 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 6 10   ;PUSH Bytes
CALL            10 6 15    ;CALL function
                           #--- PUSHB_4   0 15 12 9 ;PUSH Bytes
CALL            9 12 15 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 27 10  ;PUSH Bytes
CALL            10 27 24   ;CALL function
                           #--- PUSHB_4   64 24 30 9 ;PUSH Bytes
CALL            9 30 24 64 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   18 3 10   ;PUSH Bytes
CALL            10 3 18    ;CALL function
                           #--- PUSHB_4   0 18 9 9  ;PUSH Bytes
CALL            9 9 18 0   ;CALL function
                           #--- PUSHB_4   64 18 20 9 ;PUSH Bytes
CALL            9 20 18 64 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   18 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   22 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_2   28 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0226': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_5   48 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 48 ;CALL function
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_5   26 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 26 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 57 10   ;PUSH Bytes
CALL            10 57 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_5   30 43 11 22 13 ;PUSH Bytes
CALL            13 22 11 43 30 ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 43 39 14 ;PUSH Bytes
CALL            14 39 43 9 ;CALL function
                           #--- PUSHB_5   34 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 34 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   15 44 10  ;PUSH Bytes
CALL            10 44 15   ;CALL function
                           #--- PUSHB_4   64 15 19 9 ;PUSH Bytes
CALL            9 19 15 64 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   9 31      ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_4   5 37 41 8 ;PUSH Bytes
CALL            8 41 37 5  ;CALL function
                           #--- PUSHB_5   54 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 54 ;CALL function
                           #--- PUSHB_3   5 54 10   ;PUSH Bytes
CALL            10 54 5    ;CALL function
                           #--- PUSHB_4   0 5 60 9  ;PUSH Bytes
CALL            9 60 5 0   ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   49 6      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
                           #--- DUP       #27       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   5 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   34 39 51 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              52 51 39 34 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0229': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 40 10   ;PUSH Bytes
CALL            10 40 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   23 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 23 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 5      ;PUSH Bytes
MIRP[min,black] cvt_5 46   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   37 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 37 ;CALL function
                           #--- PUSHB_3   37 5 10   ;PUSH Bytes
CALL            10 5 37    ;CALL function
                           #--- PUSHB_4   64 37 29 9 ;PUSH Bytes
CALL            9 29 37 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   5 37 10   ;PUSH Bytes
CALL            10 37 5    ;CALL function
                           #--- PUSHB_4   0 5 43 9  ;PUSH Bytes
CALL            9 43 5 0   ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_3   10 29 34  ;PUSH Bytes
IP              34         ;Interpolate Point
IP              29         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni022A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   31 5      ;PUSH Bytes
MIRP[min,black] cvt_5 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_5   38 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 38 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   40 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_5   49 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   54 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_4   19 25 31 8 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              8 31 25 19 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_4   16 22 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 22 16 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni022B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   31 5      ;PUSH Bytes
MIRP[min,black] cvt_5 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   37 3 0    ;PUSH Bytes
CALL            0 3 37     ;CALL function
                           #--- PUSHB_5   46 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 46 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_4   49 37 46 8 ;PUSH Bytes
CALL            8 46 37 49 ;CALL function
                           #--- PUSHB_5   58 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 58 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_3   44 3 0    ;PUSH Bytes
CALL            0 3 44     ;CALL function
                           #--- PUSHB_5   8 25 19 58 13 ;PUSH Bytes
CALL            13 58 19 25 8 ;CALL function
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   28 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_6   8 19 40 46 52 58 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              58 52 46 40 19 8 ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_4   16 22 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 22 16 ;Interpolate Point
                           #--- PUSHB_2   49 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni022D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   31 5      ;PUSH Bytes
MIRP[min,black] cvt_5 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_5   38 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 38 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   40 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   40 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   19 25 31 8 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              8 31 25 19 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_4   16 22 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 22 16 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0231': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   29 3 10   ;PUSH Bytes
CALL            10 3 29    ;CALL function
                           #--- PUSHB_4   64 29 12 9 ;PUSH Bytes
CALL            9 12 29 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   21 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 0 10   ;PUSH Bytes
CALL            10 0 16    ;CALL function
                           #--- PUSHB_4   64 16 19 9 ;PUSH Bytes
CALL            9 19 16 64 ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   24 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_2   3 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   0 6 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0252': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 3 0    ;PUSH Bytes
CALL            0 3 20     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 20 10  ;PUSH Bytes
CALL            10 20 29   ;CALL function
                           #--- PUSHB_4   0 29 26 9 ;PUSH Bytes
CALL            9 26 29 0  ;CALL function
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   32 42     ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   3 16 10   ;PUSH Bytes
CALL            10 16 3    ;CALL function
                           #--- PUSHB_4   0 3 23 9  ;PUSH Bytes
CALL            9 23 3 0   ;CALL function
                           #--- PUSHB_3   16 3 10   ;PUSH Bytes
CALL            10 3 16    ;CALL function
                           #--- PUSHB_4   64 16 12 9 ;PUSH Bytes
CALL            9 12 16 64 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   9 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   35 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              35         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 44      ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   12 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   0 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   3 9 38    ;PUSH Bytes
IP              38         ;Interpolate Point
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0254': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_5   38 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 38 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 10 10  ;PUSH Bytes
CALL            10 10 29   ;CALL function
                           #--- PUSHB_4   0 29 19 9 ;PUSH Bytes
CALL            9 19 29 0  ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_4   19 10 22 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 22 10 19 ;Interpolate Point
                           #--- PUSHB_2   7 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0256': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 3 0    ;PUSH Bytes
CALL            0 3 15     ;CALL function
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   40 1 0    ;PUSH Bytes
CALL            0 1 40     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 29 10  ;PUSH Bytes
CALL            10 29 20   ;CALL function
                           #--- PUSHB_4   0 20 23 9 ;PUSH Bytes
CALL            9 23 20 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   0 42      ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 32 10  ;PUSH Bytes
CALL            10 32 17   ;CALL function
                           #--- PUSHB_4   0 17 26 9 ;PUSH Bytes
CALL            9 26 17 0  ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_5   12 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   3 9 35 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 35 9 3  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0257': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   37 0 0    ;PUSH Bytes
CALL            0 0 37     ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 3 0    ;PUSH Bytes
CALL            0 3 20     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 20 10  ;PUSH Bytes
CALL            10 20 29   ;CALL function
                           #--- PUSHB_4   0 29 26 9 ;PUSH Bytes
CALL            9 26 29 0  ;CALL function
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   16 38     ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 0 10   ;PUSH Bytes
CALL            10 0 33    ;CALL function
                           #--- PUSHB_4   0 33 23 9 ;PUSH Bytes
CALL            9 23 33 0  ;CALL function
                           #--- PUSHB_4   64 33 36 9 ;PUSH Bytes
CALL            9 36 33 64 ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   14 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 37      ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_2   3 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   0 6 11 12 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              12 11 6 0  ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0258': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_5   9 28 19 13 13 ;PUSH Bytes
CALL            13 13 19 28 9 ;CALL function
                           #--- PUSHB_2   9 5       ;PUSH Bytes
MIRP[min,black] cvt_5 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0259': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_5   55 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 55 ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_5   28 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 28 ;CALL function
                           #--- PUSHB_5   39 45 7 19 13 ;PUSH Bytes
CALL            13 19 7 45 39 ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   48 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   13 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_2   48 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              48         ;Interpolate Point
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   14 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   33 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   16 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni025C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   30 7 10   ;PUSH Bytes
CALL            10 7 30    ;CALL function
                           #--- PUSHB_4   64 30 26 9 ;PUSH Bytes
CALL            9 26 30 64 ;CALL function
                           #--- PUSHB_3   7 30 10   ;PUSH Bytes
CALL            10 30 7    ;CALL function
                           #--- PUSHB_4   0 7 17 9  ;PUSH Bytes
CALL            9 17 7 0   ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0260': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   45 0 0    ;PUSH Bytes
CALL            0 0 45     ;CALL function
                           #--- PUSHB_3   32 3 0    ;PUSH Bytes
CALL            0 3 32     ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   41 32 10  ;PUSH Bytes
CALL            10 32 41   ;CALL function
                           #--- PUSHB_4   0 41 38 9 ;PUSH Bytes
CALL            9 38 41 0  ;CALL function
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   7 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   45 6      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_3   45 17 10  ;PUSH Bytes
CALL            10 17 45   ;CALL function
                           #--- PUSHB_4   0 45 35 9 ;PUSH Bytes
CALL            9 35 45 0  ;CALL function
                           #--- PUSHB_3   17 45 10  ;PUSH Bytes
CALL            10 45 17   ;CALL function
                           #--- PUSHB_4   64 17 10 9 ;PUSH Bytes
CALL            9 10 17 64 ;CALL function
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   17 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   20 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0261': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   35 0 10   ;PUSH Bytes
CALL            10 0 35    ;CALL function
                           #--- PUSHB_4   64 35 10 9 ;PUSH Bytes
CALL            9 10 35 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   7 37      ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 13 10  ;PUSH Bytes
CALL            10 13 26   ;CALL function
                           #--- PUSHB_4   64 26 19 9 ;PUSH Bytes
CALL            9 19 26 64 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   26 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   29 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 29      ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0265': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   26 34 43  ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   7 3 0     ;PUSH Bytes
CALL            0 3 7      ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 7 10   ;PUSH Bytes
CALL            10 7 16    ;CALL function
                           #--- PUSHB_4   0 16 13 9 ;PUSH Bytes
CALL            9 13 16 0  ;CALL function
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   43 3 10   ;PUSH Bytes
CALL            10 3 43    ;CALL function
                           #--- PUSHB_4   0 43 10 9 ;PUSH Bytes
CALL            9 10 43 0  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   9 3 1 14  ;PUSH Bytes
CALL            14 1 3 9   ;CALL function
                           #--- PUSHB_5   46 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 46 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   9 26 29 14 ;PUSH Bytes
CALL            14 29 26 9 ;CALL function
                           #--- PUSHB_5   33 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 29 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   33 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   22 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0267': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   49 3 0    ;PUSH Bytes
CALL            0 3 49     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 49 10   ;PUSH Bytes
CALL            10 49 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 16 10  ;PUSH Bytes
CALL            10 16 25   ;CALL function
                           #--- PUSHB_4   0 25 22 9 ;PUSH Bytes
CALL            9 22 25 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[rp0,rnd,white] 45         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   36 45 10  ;PUSH Bytes
CALL            10 45 36   ;CALL function
                           #--- PUSHB_4   0 36 52 9 ;PUSH Bytes
CALL            9 52 36 0  ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_4   9 45 43 14 ;PUSH Bytes
CALL            14 43 45 9 ;CALL function
                           #--- PUSHB_5   39 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 39 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 13 10  ;PUSH Bytes
CALL            10 13 28   ;CALL function
                           #--- PUSHB_4   0 28 19 9 ;PUSH Bytes
CALL            9 19 28 0  ;CALL function
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   28 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   9 32      ;PUSH Bytes
IP              32         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0268': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   10 13 36 21 13 ;PUSH Bytes
CALL            13 21 36 13 10 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   31 8 10   ;PUSH Bytes
CALL            10 8 31    ;CALL function
                           #--- PUSHB_4   64 31 34 9 ;PUSH Bytes
CALL            9 34 31 64 ;CALL function
                           #--- PUSHB_4   64 31 27 9 ;PUSH Bytes
CALL            9 27 31 64 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_5   18 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_3   18 31 10  ;PUSH Bytes
CALL            10 31 18   ;CALL function
                           #--- PUSHB_4   64 18 4 9 ;PUSH Bytes
CALL            9 4 18 64  ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_1   1         ;PUSH Bytes
                           #--- DUP       #1        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_5   2 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 2 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 1 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0269': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 17 10   ;PUSH Bytes
CALL            10 17 8    ;CALL function
                           #--- PUSHB_4   0 8 11 9  ;PUSH Bytes
CALL            9 11 8 0   ;CALL function
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   0 5 14 9  ;PUSH Bytes
CALL            9 14 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni026A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 17 10   ;PUSH Bytes
CALL            10 17 4    ;CALL function
                           #--- PUSHB_4   64 4 8 9  ;PUSH Bytes
CALL            9 8 4 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   17 4 10   ;PUSH Bytes
CALL            10 4 17    ;CALL function
                           #--- PUSHB_4   64 17 13 9 ;PUSH Bytes
CALL            9 13 17 64 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni026B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   12 3 0    ;PUSH Bytes
CALL            0 3 12     ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_5   26 16 34 12 13 ;PUSH Bytes
CALL            13 12 34 16 26 ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 26 10  ;PUSH Bytes
CALL            10 26 16   ;CALL function
                           #--- PUSHB_4   0 16 20 9 ;PUSH Bytes
CALL            9 20 16 0  ;CALL function
                           #--- PUSHB_5   3 43 34 12 13 ;PUSH Bytes
CALL            13 12 34 43 3 ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   43 3 10   ;PUSH Bytes
CALL            10 3 43    ;CALL function
                           #--- PUSHB_4   0 43 47 9 ;PUSH Bytes
CALL            9 47 43 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   29 40 10  ;PUSH Bytes
CALL            10 40 29   ;CALL function
                           #--- PUSHB_4   64 29 32 9 ;PUSH Bytes
CALL            9 32 29 64 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_5   9 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 9  ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_3   9 29 10   ;PUSH Bytes
CALL            10 29 9    ;CALL function
                           #--- PUSHB_4   64 9 36 9 ;PUSH Bytes
CALL            9 36 9 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   40 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   3 47      ;PUSH Bytes
IP              47         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   28 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_2   3 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   5 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni026D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 17 10   ;PUSH Bytes
CALL            10 17 8    ;CALL function
                           #--- PUSHB_4   0 8 11 9  ;PUSH Bytes
CALL            9 11 8 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   0 5 14 9  ;PUSH Bytes
CALL            9 14 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni026F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   0 36      ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 31 44   ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_5   22 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_5   34 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   10 4 2 14 ;PUSH Bytes
CALL            14 2 4 10  ;CALL function
                           #--- PUSHB_5   46 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   2 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 2 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_5   6 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 6 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   34 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   12 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   10 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0271': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   42 55     ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   52 4      ;PUSH Bytes
MIRP[min,black] stemt 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 23 10  ;PUSH Bytes
CALL            10 23 32   ;CALL function
                           #--- PUSHB_4   0 32 29 9 ;PUSH Bytes
CALL            9 29 32 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 55 10   ;PUSH Bytes
CALL            10 55 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   10 3 2 14 ;PUSH Bytes
CALL            14 2 3 10  ;CALL function
                           #--- PUSHB_5   57 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 57 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_5   45 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 45 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 20 10  ;PUSH Bytes
CALL            10 20 35   ;CALL function
                           #--- PUSHB_4   0 35 26 9 ;PUSH Bytes
CALL            9 26 35 0  ;CALL function
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   48 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   12 52     ;PUSH Bytes
IP              52         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   41 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              41         ;Interpolate Point
                           #--- PUSHB_2   8 52      ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_3   6 10 14   ;PUSH Bytes
IP              14         ;Interpolate Point
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0272': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 37 10   ;PUSH Bytes
CALL            10 37 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   6 34 10   ;PUSH Bytes
CALL            10 34 6    ;CALL function
                           #--- PUSHB_4   64 6 9 9  ;PUSH Bytes
CALL            9 9 6 64   ;CALL function
                           #--- PUSHB_4   0 6 40 9  ;PUSH Bytes
CALL            9 40 6 0   ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 27 26 14 ;PUSH Bytes
CALL            14 26 27 9 ;CALL function
                           #--- PUSHB_5   22 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 22 ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   26 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   16 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_2   11 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   9 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0273': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 29 10  ;PUSH Bytes
CALL            10 29 20   ;CALL function
                           #--- PUSHB_4   0 20 23 9 ;PUSH Bytes
CALL            9 23 20 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   3 39 10   ;PUSH Bytes
CALL            10 39 3    ;CALL function
                           #--- PUSHB_4   64 3 6 9  ;PUSH Bytes
CALL            9 6 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   9 3 1 14  ;PUSH Bytes
CALL            14 1 3 9   ;CALL function
                           #--- PUSHB_5   42 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 42 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 32 10  ;PUSH Bytes
CALL            10 32 17   ;CALL function
                           #--- PUSHB_4   0 17 26 9 ;PUSH Bytes
CALL            9 26 17 0  ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   32 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   13 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_3   16 33 38  ;PUSH Bytes
IP              38         ;Interpolate Point
IP              33         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_2   8 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   6 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0274': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 27      ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_4   10 17 14 14 ;PUSH Bytes
CALL            14 14 17 10 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 10 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   10 4 2 14 ;PUSH Bytes
CALL            14 2 4 10  ;CALL function
                           #--- PUSHB_5   29 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_5   2 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 2 ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   8 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_2   4 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   7 26      ;PUSH Bytes
IP              26         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0279': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   33 24 10  ;PUSH Bytes
CALL            10 24 33   ;CALL function
                           #--- PUSHB_4   0 33 30 9 ;PUSH Bytes
CALL            9 30 33 0  ;CALL function
                           #--- PUSHB_3   41 1 0    ;PUSH Bytes
CALL            0 1 41     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 17 10   ;PUSH Bytes
CALL            10 17 8    ;CALL function
                           #--- PUSHB_4   0 8 11 9  ;PUSH Bytes
CALL            9 11 8 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   64 5 0 9  ;PUSH Bytes
CALL            9 0 5 64   ;CALL function
                           #--- PUSHB_4   0 5 14 9  ;PUSH Bytes
CALL            9 14 5 0   ;CALL function
                           #--- PUSHB_3   20 5 10   ;PUSH Bytes
CALL            10 5 20    ;CALL function
                           #--- PUSHB_4   64 20 40 9 ;PUSH Bytes
CALL            9 40 20 64 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni027C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   0 17 14 9 ;PUSH Bytes
CALL            9 14 17 0  ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   21 32 10  ;PUSH Bytes
CALL            10 32 21   ;CALL function
                           #--- PUSHB_4   64 21 24 9 ;PUSH Bytes
CALL            9 24 21 64 ;CALL function
                           #--- PUSHB_3   32 21 10  ;PUSH Bytes
CALL            10 21 32   ;CALL function
                           #--- PUSHB_4   64 32 2 9 ;PUSH Bytes
CALL            9 2 32 64  ;CALL function
                           #--- PUSHB_4   64 32 28 9 ;PUSH Bytes
CALL            9 28 32 64 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_2   3 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni027D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 32 10   ;PUSH Bytes
CALL            10 32 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 19 10  ;PUSH Bytes
CALL            10 19 10   ;CALL function
                           #--- PUSHB_4   0 10 13 9 ;PUSH Bytes
CALL            9 13 10 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   7 22 10   ;PUSH Bytes
CALL            10 22 7    ;CALL function
                           #--- PUSHB_4   0 7 16 9  ;PUSH Bytes
CALL            9 16 7 0   ;CALL function
                           #--- PUSHB_3   22 7 10   ;PUSH Bytes
CALL            10 7 22    ;CALL function
                           #--- PUSHB_4   64 22 26 9 ;PUSH Bytes
CALL            9 26 22 64 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   27 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni027E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 0 0    ;PUSH Bytes
CALL            0 0 26     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   0 17 14 9 ;PUSH Bytes
CALL            9 14 17 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 4 10   ;PUSH Bytes
CALL            10 4 21    ;CALL function
                           #--- PUSHB_4   64 21 24 9 ;PUSH Bytes
CALL            9 24 21 64 ;CALL function
                           #--- PUSHB_4   0 21 11 9 ;PUSH Bytes
CALL            9 11 21 0  ;CALL function
                           #--- PUSHB_3   4 21 10   ;PUSH Bytes
CALL            10 21 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni027F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 20 10  ;PUSH Bytes
CALL            10 20 11   ;CALL function
                           #--- PUSHB_4   0 11 14 9 ;PUSH Bytes
CALL            9 14 11 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 7 10   ;PUSH Bytes
CALL            10 7 24    ;CALL function
                           #--- PUSHB_4   64 24 0 9 ;PUSH Bytes
CALL            9 0 24 64  ;CALL function
                           #--- PUSHB_3   7 24 10   ;PUSH Bytes
CALL            10 24 7    ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_4   0 7 17 9  ;PUSH Bytes
CALL            9 17 7 0   ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0280': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   7 34      ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_5   6 36 13 25 13 ;PUSH Bytes
CALL            13 25 13 36 6 ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_4   10 7 10 14 ;PUSH Bytes
CALL            14 10 7 10 ;CALL function
                           #--- PUSHB_5   15 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 10 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
                           #--- DUP       #3        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_5   1 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 1 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   10 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_2   29 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   31 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0281': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   4 22 10   ;PUSH Bytes
CALL            10 22 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_4   0 4 15 9  ;PUSH Bytes
CALL            9 15 4 0   ;CALL function
                           #--- PUSHB_3   22 4 10   ;PUSH Bytes
CALL            10 4 22    ;CALL function
                           #--- PUSHB_4   64 22 26 9 ;PUSH Bytes
CALL            9 26 22 64 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0283': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 3 0    ;PUSH Bytes
CALL            0 3 10     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 10 10  ;PUSH Bytes
CALL            10 10 19   ;CALL function
                           #--- PUSHB_4   0 19 16 9 ;PUSH Bytes
CALL            9 16 19 0  ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 26 10   ;PUSH Bytes
CALL            10 26 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 6 10   ;PUSH Bytes
CALL            10 6 23    ;CALL function
                           #--- PUSHB_4   0 23 13 9 ;PUSH Bytes
CALL            9 13 23 0  ;CALL function
                           #--- PUSHB_3   6 23 10   ;PUSH Bytes
CALL            10 23 6    ;CALL function
                           #--- PUSHB_4   0 6 29 9  ;PUSH Bytes
CALL            9 29 6 0   ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   7 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0284': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 3 0    ;PUSH Bytes
CALL            0 3 17     ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 17 10  ;PUSH Bytes
CALL            10 17 26   ;CALL function
                           #--- PUSHB_4   0 26 23 9 ;PUSH Bytes
CALL            9 23 26 0  ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   38 7 10   ;PUSH Bytes
CALL            10 7 38    ;CALL function
                           #--- PUSHB_4   0 38 20 9 ;PUSH Bytes
CALL            9 20 38 0  ;CALL function
                           #--- PUSHB_4   64 38 34 9 ;PUSH Bytes
CALL            9 34 38 64 ;CALL function
                           #--- PUSHB_3   7 38 10   ;PUSH Bytes
CALL            10 38 7    ;CALL function
                           #--- PUSHB_4   64 7 0 9  ;PUSH Bytes
CALL            9 0 7 64   ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0285': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 3 0    ;PUSH Bytes
CALL            0 3 22     ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 22 10  ;PUSH Bytes
CALL            10 22 13   ;CALL function
                           #--- PUSHB_4   0 13 16 9 ;PUSH Bytes
CALL            9 16 13 0  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 6 10   ;PUSH Bytes
CALL            10 6 29    ;CALL function
                           #--- PUSHB_4   0 29 0 9  ;PUSH Bytes
CALL            9 0 29 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 9 10   ;PUSH Bytes
CALL            10 9 26    ;CALL function
                           #--- PUSHB_4   0 26 3 9  ;PUSH Bytes
CALL            9 3 26 0   ;CALL function
                           #--- PUSHB_3   9 26 10   ;PUSH Bytes
CALL            10 26 9    ;CALL function
                           #--- PUSHB_4   0 9 19 9  ;PUSH Bytes
CALL            9 19 9 0   ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   9 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0289': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   46 4      ;PUSH Bytes
MIRP[min,black] stemt 46   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_5   17 20 13 29 13 ;PUSH Bytes
CALL            13 29 13 20 17 ;CALL function
                           #--- PUSHB_2   31 42     ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 45      ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_3   42 32 10  ;PUSH Bytes
CALL            10 32 42   ;CALL function
                           #--- PUSHB_4   64 42 7 9 ;PUSH Bytes
CALL            9 7 42 64  ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_5   38 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   3 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni028C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 14 10  ;PUSH Bytes
CALL            10 14 25   ;CALL function
                           #--- PUSHB_4   64 25 28 9 ;PUSH Bytes
CALL            9 28 25 64 ;CALL function
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_5   20 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 20 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 21 10  ;PUSH Bytes
CALL            10 21 18   ;CALL function
                           #--- PUSHB_4   64 18 24 9 ;PUSH Bytes
CALL            9 24 18 64 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 12 10  ;PUSH Bytes
CALL            10 12 32   ;CALL function
                           #--- PUSHB_4   0 32 6 9  ;PUSH Bytes
CALL            9 6 32 0   ;CALL function
                           #--- PUSHB_3   12 32 10  ;PUSH Bytes
CALL            10 32 12   ;CALL function
                           #--- PUSHB_4   64 12 14 9 ;PUSH Bytes
CALL            9 14 12 64 ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   12 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   16 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   15 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_2   22 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0291': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_2   35 5      ;PUSH Bytes
MIRP[min,black] cvt_5 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 35 10  ;PUSH Bytes
CALL            10 35 21   ;CALL function
                           #--- PUSHB_4   64 21 18 9 ;PUSH Bytes
CALL            9 18 21 64 ;CALL function
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   25 5      ;PUSH Bytes
MIRP[min,black] cvt_5 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_5   28 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 28 ;CALL function
                           #--- PUSHB_5   40 8 18 32 13 ;PUSH Bytes
CALL            13 32 18 8 40 ;CALL function
                           #--- PUSHB_2   40 5      ;PUSH Bytes
MIRP[min,black] cvt_5 40   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 31 10  ;PUSH Bytes
CALL            10 31 26   ;CALL function
                           #--- PUSHB_4   64 26 34 9 ;PUSH Bytes
CALL            9 34 26 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 15 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 15 10  ;PUSH Bytes
CALL            10 15 20   ;CALL function
                           #--- PUSHB_4   64 20 22 9 ;PUSH Bytes
CALL            9 22 20 64 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   11 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 11 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   20 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   32 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0292': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   39 0 0    ;PUSH Bytes
CALL            0 0 39     ;CALL function
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   9 5       ;PUSH Bytes
MIRP[min,black] cvt_5 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   45 5      ;PUSH Bytes
MIRP[min,black] cvt_5 45   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDRP[rp0,rnd,white] 48         ;Move Direct Relative Point
                           #--- PUSHB_5   27 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 27 ;CALL function
                           #--- PUSHB_3   27 48 10  ;PUSH Bytes
CALL            10 48 27   ;CALL function
                           #--- PUSHB_4   64 27 19 9 ;PUSH Bytes
CALL            9 19 27 64 ;CALL function
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   27 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   27 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0293': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   58 1 0    ;PUSH Bytes
CALL            0 1 58     ;CALL function
                           #--- PUSHB_2   52 5      ;PUSH Bytes
MIRP[min,black] cvt_5 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SHP[rp2]        64         ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   22 8 10   ;PUSH Bytes
CALL            10 8 22    ;CALL function
                           #--- PUSHB_4   64 22 17 9 ;PUSH Bytes
CALL            9 17 22 64 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_5   71 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 71 ;CALL function
                           #--- PUSHB_3   71 32 10  ;PUSH Bytes
CALL            10 32 71   ;CALL function
                           #--- PUSHB_4   64 71 62 9 ;PUSH Bytes
CALL            9 62 71 64 ;CALL function
                           #--- PUSHB_2   74 1      ;PUSH Bytes
CALL            1 74       ;CALL function
                           #--- PUSHB_2   6 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   41 44 47  ;PUSH Bytes
IP              47         ;Interpolate Point
IP              44         ;Interpolate Point
IP              41         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_7   0 20 22 28 39 51 66 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              66 51 39 28 22 20 0 ;Interpolate Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_2   17 65     ;PUSH Bytes
IP              65         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_3   10 14 20  ;PUSH Bytes
IP              20         ;Interpolate Point
IP              14         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_2   32 71     ;PUSH Bytes
IP              71         ;Interpolate Point
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0294': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 6 10   ;PUSH Bytes
CALL            10 6 31    ;CALL function
                           #--- PUSHB_4   0 31 1 9  ;PUSH Bytes
CALL            9 1 31 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 24 22 14 ;PUSH Bytes
CALL            14 22 24 8 ;CALL function
                           #--- PUSHB_5   17 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 17 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   13 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   6 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0295': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 30 10   ;PUSH Bytes
CALL            10 30 5    ;CALL function
                           #--- PUSHB_4   0 5 1 9   ;PUSH Bytes
CALL            9 1 5 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 23 19 14 ;PUSH Bytes
CALL            14 19 23 8 ;CALL function
                           #--- PUSHB_5   15 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 15 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   12 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   5 30      ;PUSH Bytes
IP              30         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0296': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_5   21 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 21 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 3 10   ;PUSH Bytes
CALL            10 3 35    ;CALL function
                           #--- PUSHB_4   0 35 40 9 ;PUSH Bytes
CALL            9 40 35 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   24 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_3   3 10 35   ;PUSH Bytes
IP              35         ;Interpolate Point
IP              10         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_3   13 38 40  ;PUSH Bytes
IP              40         ;Interpolate Point
IP              38         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0298': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   9 2 0     ;PUSH Bytes
CALL            0 2 9      ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_5   1 6 18 9 13 ;PUSH Bytes
CALL            13 9 18 6 1 ;CALL function
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   9 18 24 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 24 18 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   15 21 27 33 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              33 27 21 15 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0299': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   26 5      ;PUSH Bytes
MIRP[min,black] cvt_5 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_5   28 39 20 7 13 ;PUSH Bytes
CALL            13 7 20 39 28 ;CALL function
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   27 40 10  ;PUSH Bytes
CALL            10 40 27   ;CALL function
                           #--- PUSHB_4   64 27 4 9 ;PUSH Bytes
CALL            9 4 27 64  ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
                           #--- DUP       #31       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   11 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni029C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 0 0    ;PUSH Bytes
CALL            0 0 25     ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 16 19   ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 42 45   ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_5   43 18 25 36 13 ;PUSH Bytes
CALL            13 36 25 18 43 ;CALL function
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_5   22 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 22 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_4   19 22 28 8 ;PUSH Bytes
CALL            8 28 22 19 ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_5   8 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 8 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_4   5 8 14 8  ;PUSH Bytes
CALL            8 14 8 5   ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni029E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_5   8 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 8 ;CALL function
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_4   7 19 23 14 ;PUSH Bytes
CALL            14 23 19 7 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 1  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni029a': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_2   23 5      ;PUSH Bytes
MIRP[min,black] cvt_5 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   34 1 0    ;PUSH Bytes
CALL            0 1 34     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_5   7 16 48 34 13 ;PUSH Bytes
CALL            13 34 48 16 7 ;CALL function
                           #--- PUSHB_2   7 5       ;PUSH Bytes
MIRP[min,black] cvt_5 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDRP[rp0,rnd,white] 51         ;Move Direct Relative Point
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
                           #--- DUP       #31       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 31 10   ;PUSH Bytes
CALL            10 31 3    ;CALL function
                           #--- PUSHB_4   64 3 12 9 ;PUSH Bytes
CALL            9 12 3 64  ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   20 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_2   26 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_4   16 23 34 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 34 23 16 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_3   26 29 42  ;PUSH Bytes
IP              42         ;Interpolate Point
IP              29         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni029b': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   53 5      ;PUSH Bytes
MIRP[min,black] cvt_5 53   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   47 5      ;PUSH Bytes
MIRP[min,black] cvt_5 47   ;Move Indirect Relative Point
                           #--- PUSHB_3   47 11 10  ;PUSH Bytes
CALL            10 11 47   ;CALL function
                           #--- PUSHB_4   64 47 40 9 ;PUSH Bytes
CALL            9 40 47 64 ;CALL function
                           #--- PUSHB_4   0 47 22 9 ;PUSH Bytes
CALL            9 22 47 0  ;CALL function
                           #--- PUSHB_4   33 11 47 8 ;PUSH Bytes
CALL            8 47 11 33 ;CALL function
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   57 63 4 16 13 ;PUSH Bytes
CALL            13 16 4 63 57 ;CALL function
                           #--- PUSHB_2   57 5      ;PUSH Bytes
MIRP[min,black] cvt_5 57   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   51 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   0 55 10   ;PUSH Bytes
CALL            10 55 0    ;CALL function
                           #--- PUSHB_4   64 0 67 9 ;PUSH Bytes
CALL            9 67 0 64  ;CALL function
                           #--- PUSHB_3   55 0 10   ;PUSH Bytes
CALL            10 0 55    ;CALL function
                           #--- PUSHB_4   64 55 60 9 ;PUSH Bytes
CALL            9 60 55 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   55 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_3   4 47 11   ;PUSH Bytes
IP              11         ;Interpolate Point
IP              47         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   13 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
                           #--- PUSHB_2   63 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   13 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni029d': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_2   14 5      ;PUSH Bytes
MIRP[min,black] cvt_5 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   41 5      ;PUSH Bytes
MIRP[min,black] cvt_5 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   38 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   29 34 10  ;PUSH Bytes
CALL            10 34 29   ;CALL function
                           #--- PUSHB_4   64 29 25 9 ;PUSH Bytes
CALL            9 25 29 64 ;CALL function
                           #--- PUSHB_3   34 29 10  ;PUSH Bytes
CALL            10 29 34   ;CALL function
                           #--- PUSHB_4   0 34 17 9 ;PUSH Bytes
CALL            9 17 34 0  ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_1   1         ;PUSH Bytes
                           #--- DUP       #1        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02A0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 3 0    ;PUSH Bytes
CALL            0 3 30     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   39 30 10  ;PUSH Bytes
CALL            10 30 39   ;CALL function
                           #--- PUSHB_4   0 39 36 9 ;PUSH Bytes
CALL            9 36 39 0  ;CALL function
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   3 26      ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 14 10  ;PUSH Bytes
CALL            10 14 43   ;CALL function
                           #--- PUSHB_4   0 43 33 9 ;PUSH Bytes
CALL            9 33 43 0  ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   7 43 46 14 ;PUSH Bytes
CALL            14 46 43 7 ;CALL function
                           #--- PUSHB_5   12 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   46 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 46 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   12 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   0 6 17 23 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              23 17 6 0  ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02A1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   42 0 0    ;PUSH Bytes
CALL            0 0 42     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 28 10  ;PUSH Bytes
CALL            10 28 18   ;CALL function
                           #--- PUSHB_4   0 18 23 9 ;PUSH Bytes
CALL            9 23 18 0  ;CALL function
                           #--- PUSHB_5   5 10 42 28 13 ;PUSH Bytes
CALL            13 28 42 10 5 ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_4   39 31 15 8 ;PUSH Bytes
CALL            8 15 31 39 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   39 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 39 ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   35 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   18 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02A2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 16 10  ;PUSH Bytes
CALL            10 16 26   ;CALL function
                           #--- PUSHB_4   0 26 22 9 ;PUSH Bytes
CALL            9 22 26 0  ;CALL function
                           #--- PUSHB_5   40 33 3 16 13 ;PUSH Bytes
CALL            13 16 3 33 40 ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_4   5 29 13 8 ;PUSH Bytes
CALL            8 13 29 5  ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   41 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   16 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02BE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_5   5 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 5 ;CALL function
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_5   14 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 9 ;CALL function
                           #--- PUSHB_3   1 9 10    ;PUSH Bytes
CALL            10 9 1     ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02BF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_5   8 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 8 ;CALL function
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_5   16 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 16 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 14 ;CALL function
                           #--- PUSHB_3   14 5 10   ;PUSH Bytes
CALL            10 5 14    ;CALL function
                           #--- PUSHB_4   64 14 10 9 ;PUSH Bytes
CALL            9 10 14 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02D0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   25 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 25 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   25 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 25 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   7 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02D1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_5   8 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 8 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 3 ;CALL function
                           #--- PUSHB_5   3 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 3 ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02EE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 10   ;PUSH Bytes
CALL            10 0 15    ;CALL function
                           #--- PUSHB_4   64 15 21 9 ;PUSH Bytes
CALL            9 21 15 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 5 ;CALL function
                           #--- PUSHB_5   16 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 16 ;CALL function
                           #--- PUSHB_5   5 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 5 ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   5 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02FA': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   31 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 31 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   5 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 0 ;CALL function
                           #--- PUSHB_3   14 0 10   ;PUSH Bytes
CALL            10 0 14    ;CALL function
                           #--- PUSHB_4   64 14 21 9 ;PUSH Bytes
CALL            9 21 14 64 ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   19 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 19 ;CALL function
                           #--- PUSHB_3   5 36 50   ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   32 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 32 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_5   28 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 28 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 5 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
                           #--- PUSHB_3   20 5 10   ;PUSH Bytes
CALL            10 5 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_5   25 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_5   36 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 36 ;CALL function
                           #--- PUSHB_3   36 51 10  ;PUSH Bytes
CALL            10 51 36   ;CALL function
                           #--- PUSHB_4   64 36 40 9 ;PUSH Bytes
CALL            9 40 36 64 ;CALL function
                           #--- PUSHB_3   51 36 10  ;PUSH Bytes
CALL            10 36 51   ;CALL function
                           #--- PUSHB_4   64 51 47 9 ;PUSH Bytes
CALL            9 47 51 64 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   51 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   0 32      ;PUSH Bytes
IP              32         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_3   16 40 47  ;PUSH Bytes
IP              47         ;Interpolate Point
IP              40         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 2 0    ;PUSH Bytes
CALL            0 2 34     ;CALL function
                           #--- PUSHB_5   24 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 24 ;CALL function
                           #--- PUSHB_3   31 2 0    ;PUSH Bytes
CALL            0 2 31     ;CALL function
                           #--- PUSHB_5   26 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 26 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_5   19 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 19 ;CALL function
                           #--- PUSHB_3   5 44 58   ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   40 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 40 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 5 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
                           #--- PUSHB_4   0 5 28 9  ;PUSH Bytes
CALL            9 28 5 0   ;CALL function
                           #--- PUSHB_3   20 5 10   ;PUSH Bytes
CALL            10 5 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_5   44 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 44 ;CALL function
                           #--- PUSHB_3   44 59 10  ;PUSH Bytes
CALL            10 59 44   ;CALL function
                           #--- PUSHB_4   64 44 48 9 ;PUSH Bytes
CALL            9 48 44 64 ;CALL function
                           #--- PUSHB_3   59 44 10  ;PUSH Bytes
CALL            10 44 59   ;CALL function
                           #--- PUSHB_4   64 59 55 9 ;PUSH Bytes
CALL            9 55 59 64 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   59 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_3   16 48 55  ;PUSH Bytes
IP              55         ;Interpolate Point
IP              48         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   18 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 18 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 6 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   27 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 27 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   8 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 8 ;CALL function
                           #--- PUSHB_3   22 8 10   ;PUSH Bytes
CALL            10 8 22    ;CALL function
                           #--- PUSHB_4   0 22 15 9 ;PUSH Bytes
CALL            9 15 22 0  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_1   25        ;PUSH Bytes
                           #--- DUP       #25       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_5   26 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   25 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 25 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   18 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 18 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   27 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 27 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   21 27 10  ;PUSH Bytes
CALL            10 27 21   ;CALL function
                           #--- PUSHB_4   0 21 37 9 ;PUSH Bytes
CALL            9 37 21 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 4 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   4 19 10   ;PUSH Bytes
CALL            10 19 4    ;CALL function
                           #--- PUSHB_4   64 4 8 9  ;PUSH Bytes
CALL            9 8 4 64   ;CALL function
                           #--- PUSHB_3   19 4 10   ;PUSH Bytes
CALL            10 4 19    ;CALL function
                           #--- PUSHB_4   64 19 15 9 ;PUSH Bytes
CALL            9 15 19 64 ;CALL function
                           #--- PUSHB_4   64 19 24 9 ;PUSH Bytes
CALL            9 24 19 64 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   24 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   0 31 10   ;PUSH Bytes
CALL            10 31 0    ;CALL function
                           #--- PUSHB_4   0 0 37 9  ;PUSH Bytes
CALL            9 37 0 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_5   11 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_5   20 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 20 ;CALL function
                           #--- PUSHB_3   20 3 10   ;PUSH Bytes
CALL            10 3 20    ;CALL function
                           #--- PUSHB_4   64 20 15 9 ;PUSH Bytes
CALL            9 15 20 64 ;CALL function
                           #--- PUSHB_4   64 20 24 9 ;PUSH Bytes
CALL            9 24 20 64 ;CALL function
                           #--- PUSHB_3   3 20 10   ;PUSH Bytes
CALL            10 20 3    ;CALL function
                           #--- PUSHB_4   64 3 8 9  ;PUSH Bytes
CALL            9 8 3 64   ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   24 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_5   5 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 5 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_1   26        ;PUSH Bytes
                           #--- DUP       #26       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_5   31 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 31 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 39 10   ;PUSH Bytes
CALL            10 39 0    ;CALL function
                           #--- PUSHB_4   0 0 45 9  ;PUSH Bytes
CALL            9 45 0 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   20 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 20 ;CALL function
                           #--- PUSHB_3   20 36 10  ;PUSH Bytes
CALL            10 36 20   ;CALL function
                           #--- PUSHB_4   64 20 15 9 ;PUSH Bytes
CALL            9 15 20 64 ;CALL function
                           #--- PUSHB_4   0 20 29 9 ;PUSH Bytes
CALL            9 29 20 0  ;CALL function
                           #--- PUSHB_3   36 20 10  ;PUSH Bytes
CALL            10 20 36   ;CALL function
                           #--- PUSHB_4   64 36 8 9 ;PUSH Bytes
CALL            9 8 36 64  ;CALL function
                           #--- PUSHB_4   64 36 42 9 ;PUSH Bytes
CALL            9 42 36 64 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 39      ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 3 0    ;PUSH Bytes
CALL            0 3 35     ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_5   29 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 29 ;CALL function
                           #--- PUSHB_2   11 42     ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   26 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 26 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   44 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 44 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_5   46 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 46 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_3   46 27 10  ;PUSH Bytes
CALL            10 27 46   ;CALL function
                           #--- PUSHB_4   64 46 39 9 ;PUSH Bytes
CALL            9 39 46 64 ;CALL function
                           #--- PUSHB_3   27 46 10  ;PUSH Bytes
CALL            10 46 27   ;CALL function
                           #--- PUSHB_4   64 27 32 9 ;PUSH Bytes
CALL            9 32 27 64 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_5   16 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 16 ;CALL function
                           #--- PUSHB_3   16 50 10  ;PUSH Bytes
CALL            10 50 16   ;CALL function
                           #--- PUSHB_4   64 16 8 9 ;PUSH Bytes
CALL            9 8 16 64  ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   50 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   4 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_2   16 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_5   12 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 12 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   19 12 10  ;PUSH Bytes
CALL            10 12 19   ;CALL function
                           #--- PUSHB_4   64 19 4 9 ;PUSH Bytes
CALL            9 4 19 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_7   5 15 8 22 28 35 38 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              38 35 28 22 8 15 5 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02b8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 15 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_5   25 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 25 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_4   21 35 39 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 39 35 21 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02ba': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   11 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 1 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   1 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   2 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02c0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   21 0 10   ;PUSH Bytes
CALL            10 0 21    ;CALL function
                           #--- PUSHB_4   0 21 10 9 ;PUSH Bytes
CALL            9 10 21 0  ;CALL function
                           #--- PUSHB_4   0 21 27 9 ;PUSH Bytes
CALL            9 27 21 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_5   7 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 7 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   24 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   7 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   0 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02c1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   30 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 30 ;CALL function
                           #--- PUSHB_3   9 30 10   ;PUSH Bytes
CALL            10 30 9    ;CALL function
                           #--- PUSHB_4   0 9 3 9   ;PUSH Bytes
CALL            9 3 9 0    ;CALL function
                           #--- PUSHB_4   0 9 20 9  ;PUSH Bytes
CALL            9 20 9 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_5   17 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   0 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 0 ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   17 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   9 30      ;PUSH Bytes
IP              30         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02c2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   10 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   13 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   2 16      ;PUSH Bytes
IP              16         ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02c3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_5   5 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 5  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_5   8 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 8  ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02c5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   9 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 9 ;CALL function
                           #--- PUSHB_5   9 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 9 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 0 ;CALL function
                           #--- PUSHB_5   0 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 0 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02c9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 0 10    ;PUSH Bytes
CALL            10 0 5     ;CALL function
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 11 ;CALL function
                           #--- PUSHB_3   11 6 10   ;PUSH Bytes
CALL            10 6 11    ;CALL function
                           #--- PUSHB_4   64 11 15 9 ;PUSH Bytes
CALL            9 15 11 64 ;CALL function
                           #--- PUSHB_3   6 11 10   ;PUSH Bytes
CALL            10 11 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02d5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   22 28 10  ;PUSH Bytes
CALL            10 28 22   ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
                           #--- PUSHB_3   28 22 10  ;PUSH Bytes
CALL            10 22 28   ;CALL function
                           #--- PUSHB_4   64 28 3 9 ;PUSH Bytes
CALL            9 3 28 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 15 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   15 20 10  ;PUSH Bytes
CALL            10 20 15   ;CALL function
                           #--- PUSHB_4   64 15 10 9 ;PUSH Bytes
CALL            9 10 15 64 ;CALL function
                           #--- PUSHB_3   20 15 10  ;PUSH Bytes
CALL            10 15 20   ;CALL function
                           #--- PUSHB_4   64 20 25 9 ;PUSH Bytes
CALL            9 25 20 64 ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02d7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   9 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 9  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02de': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   4 5       ;PUSH Bytes
MIRP[min,black] cvt_5 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   10 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 10 ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 18      ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_3   10 22 23  ;PUSH Bytes
IP              23         ;Interpolate Point
IP              22         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02df': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp1]        57         ;SHift Point using reference point
                           #--- PUSHB_5   19 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 19 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   38 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 38 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   38 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   7 45      ;PUSH Bytes
IP              45         ;Interpolate Point
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 73     ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   26 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_5   18 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 18 ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   18 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_6   1 16 5 21 26 37 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              37 26 21 5 16 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 14 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 0 ;CALL function
                           #--- PUSHB_3   0 15 10   ;PUSH Bytes
CALL            10 15 0    ;CALL function
                           #--- PUSHB_4   64 0 4 9  ;PUSH Bytes
CALL            9 4 0 64   ;CALL function
                           #--- PUSHB_3   15 0 10   ;PUSH Bytes
CALL            10 0 15    ;CALL function
                           #--- PUSHB_4   64 15 11 9 ;PUSH Bytes
CALL            9 11 15 64 ;CALL function
                           #--- PUSHB_4   0 15 20 9 ;PUSH Bytes
CALL            9 20 15 0  ;CALL function
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   4 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_5   52 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 52 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
                           #--- DUP       #38       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_5   45 4 0 22 4 ;PUSH Bytes
CALL            4 22 0 4 45 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_1   7         ;PUSH Bytes
                           #--- DUP       #7        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_5   14 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_5   49 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 49 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
                           #--- DUP       #0        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_5   25 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 25 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_5   31 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 31 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   60 57     ;PUSH Bytes
SDPVTL[orthog]  57 60      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[no-rnd]    57         ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDRP[grey]      60         ;Move Direct Relative Point
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[rp0,min,black] cvt_9 28   ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[grey]      26         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   27 26 28 19 ;PUSH Bytes
CALL            19 28 26 27 ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP0            60         ;Set Reference Point 0
                           #--- PUSHB_4   58 60 57 19 ;PUSH Bytes
CALL            19 57 60 58 ;CALL function
                           #--- PUSHB_4   59 60 57 19 ;PUSH Bytes
CALL            19 57 60 59 ;CALL function
                           #--- PUSHB_3   27 26 28  ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
ROLL            28 28 26   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              27         ;Interpolate Point
                           #--- PUSHB_3   59 60 57  ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
IP              59         ;Interpolate Point
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_7   26 27 28 57 58 59 60 ;PUSH Bytes
MDAP[no-rnd]    60         ;Move Direct Absolute Point
MDAP[no-rnd]    59         ;Move Direct Absolute Point
MDAP[no-rnd]    58         ;Move Direct Absolute Point
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_5   27 28 58 59 60 ;PUSH Bytes
MDAP[no-rnd]    60         ;Move Direct Absolute Point
MDAP[no-rnd]    59         ;Move Direct Absolute Point
MDAP[no-rnd]    58         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   49 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_3   36 38 45  ;PUSH Bytes
IP              45         ;Interpolate Point
IP              38         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_2   56 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_5   18 3 21 52 34 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              34 52 21 3 18 ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_3   5 10 14   ;PUSH Bytes
IP              14         ;Interpolate Point
IP              10         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_2   31 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_2   21 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   0 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_5   36 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 36 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_6   5 12 18 25 15 43 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              43 15 25 18 12 5 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   31 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 31 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   39 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 39 ;CALL function
                           #--- PUSHB_3   9 39 10   ;PUSH Bytes
CALL            10 39 9    ;CALL function
                           #--- PUSHB_4   0 9 3 9   ;PUSH Bytes
CALL            9 3 9 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_5   17 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 17 ;CALL function
                           #--- PUSHB_3   17 32 10  ;PUSH Bytes
CALL            10 32 17   ;CALL function
                           #--- PUSHB_4   64 17 21 9 ;PUSH Bytes
CALL            9 21 17 64 ;CALL function
                           #--- PUSHB_3   32 17 10  ;PUSH Bytes
CALL            10 17 32   ;CALL function
                           #--- PUSHB_4   64 32 28 9 ;PUSH Bytes
CALL            9 28 32 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   0 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 0 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   17 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   9 39      ;PUSH Bytes
IP              39         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   3 42      ;PUSH Bytes
IP              42         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   21 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 0 10    ;PUSH Bytes
CALL            10 0 9     ;CALL function
                           #--- PUSHB_4   0 9 5 9   ;PUSH Bytes
CALL            9 5 9 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 2 ;CALL function
                           #--- PUSHB_3   7 2 10    ;PUSH Bytes
CALL            10 2 7     ;CALL function
                           #--- PUSHB_4   0 7 12 9  ;PUSH Bytes
CALL            9 12 7 0   ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 5 10    ;PUSH Bytes
CALL            10 5 0     ;CALL function
                           #--- PUSHB_4   64 0 17 9 ;PUSH Bytes
CALL            9 17 0 64  ;CALL function
                           #--- PUSHB_3   5 0 10    ;PUSH Bytes
CALL            10 0 5     ;CALL function
                           #--- PUSHB_4   64 5 10 9 ;PUSH Bytes
CALL            9 10 5 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   14 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 14 ;CALL function
                           #--- PUSHB_3   26 14 10  ;PUSH Bytes
CALL            10 14 26   ;CALL function
                           #--- PUSHB_4   64 26 3 9 ;PUSH Bytes
CALL            9 3 26 64  ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 6 10    ;PUSH Bytes
CALL            10 6 0     ;CALL function
                           #--- PUSHB_4   64 0 17 9 ;PUSH Bytes
CALL            9 17 0 64  ;CALL function
                           #--- PUSHB_3   6 0 10    ;PUSH Bytes
CALL            10 0 6     ;CALL function
                           #--- PUSHB_4   64 6 10 9 ;PUSH Bytes
CALL            9 10 6 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_5   14 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 14 ;CALL function
                           #--- PUSHB_3   20 14 10  ;PUSH Bytes
CALL            10 14 20   ;CALL function
                           #--- PUSHB_4   64 20 3 9 ;PUSH Bytes
CALL            9 3 20 64  ;CALL function
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 6 10    ;PUSH Bytes
CALL            10 6 0     ;CALL function
                           #--- PUSHB_4   64 0 17 9 ;PUSH Bytes
CALL            9 17 0 64  ;CALL function
                           #--- PUSHB_3   6 0 10    ;PUSH Bytes
CALL            10 0 6     ;CALL function
                           #--- PUSHB_4   64 6 11 9 ;PUSH Bytes
CALL            9 11 6 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 15 ;CALL function
                           #--- PUSHB_3   18 15 10  ;PUSH Bytes
CALL            10 15 18   ;CALL function
                           #--- PUSHB_4   64 18 3 9 ;PUSH Bytes
CALL            9 3 18 64  ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02e9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 5       ;PUSH Bytes
MIRP[min,black] cvt_5 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 12 10   ;PUSH Bytes
CALL            10 12 3    ;CALL function
                           #--- PUSHB_4   0 3 7 9   ;PUSH Bytes
CALL            9 7 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 11 ;CALL function
                           #--- PUSHB_3   4 11 10   ;PUSH Bytes
CALL            10 11 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02ea': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 10    ;PUSH Bytes
CALL            10 1 8     ;CALL function
                           #--- PUSHB_4   64 8 5 9  ;PUSH Bytes
CALL            9 5 8 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   8 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 8 ;CALL function
                           #--- PUSHB_3   8 1 10    ;PUSH Bytes
CALL            10 1 8     ;CALL function
                           #--- PUSHB_4   64 8 11 9 ;PUSH Bytes
CALL            9 11 8 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02eb': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   20 5      ;PUSH Bytes
MIRP[min,black] cvt_5 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 20 10   ;PUSH Bytes
CALL            10 20 6    ;CALL function
                           #--- PUSHB_4   64 6 10 9 ;PUSH Bytes
CALL            9 10 6 64  ;CALL function
                           #--- PUSHB_3   20 6 10   ;PUSH Bytes
CALL            10 6 20    ;CALL function
                           #--- PUSHB_4   64 20 16 9 ;PUSH Bytes
CALL            9 16 20 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 7 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_3   7 12 10   ;PUSH Bytes
CALL            10 12 7    ;CALL function
                           #--- PUSHB_4   64 7 3 9  ;PUSH Bytes
CALL            9 3 7 64   ;CALL function
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02ec': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   13 5      ;PUSH Bytes
MIRP[min,black] cvt_5 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02fb': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_5   12 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 12 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   12 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02fe': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   6 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 6 ;CALL function
                           #--- PUSHB_2   10 5      ;PUSH Bytes
MIRP[min,black] cvt_5 10   ;Move Indirect Relative Point
                           #--- PUSHB_5   6 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 3 10   ;PUSH Bytes
CALL            10 3 10    ;CALL function
                           #--- PUSHB_4   64 10 1 9 ;PUSH Bytes
CALL            9 1 10 64  ;CALL function
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni02ff': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_5   2 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 2  ;CALL function
                           #--- PUSHB_5   2 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 2  ;CALL function
                           #--- PUSHB_4   7 2 19 8  ;PUSH Bytes
CALL            8 19 2 7   ;CALL function
                           #--- PUSHB_2   14 5      ;PUSH Bytes
MIRP[min,black] cvt_5 14   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0306': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 3 0    ;PUSH Bytes
CALL            0 3 18     ;CALL function
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_3   18 29 10  ;PUSH Bytes
CALL            10 29 18   ;CALL function
                           #--- PUSHB_4   0 18 8 9  ;PUSH Bytes
CALL            9 8 18 0   ;CALL function
                           #--- PUSHB_4   0 18 23 9 ;PUSH Bytes
CALL            9 23 18 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_5   20 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 20 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_2   6 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   13 18 29  ;PUSH Bytes
IP              29         ;Interpolate Point
IP              18         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   1 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni030A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   10 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 10 ;CALL function
                           #--- PUSHB_5   10 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 1 ;CALL function
                           #--- PUSHB_5   1 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 1 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni030E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 2 0    ;PUSH Bytes
CALL            0 2 11     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   0 11 0 9  ;PUSH Bytes
CALL            9 0 11 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0321': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 15 9  ;PUSH Bytes
CALL            9 15 0 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   0 3 12 9  ;PUSH Bytes
CALL            9 12 3 0   ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0322': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 12 10  ;PUSH Bytes
CALL            10 12 15   ;CALL function
                           #--- PUSHB_4   0 15 6 9  ;PUSH Bytes
CALL            9 6 15 0   ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0327': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_5   11 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0333': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_5   33 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 33 ;CALL function
                           #--- PUSHB_5   19 14 6 28 13 ;PUSH Bytes
CALL            13 28 6 14 19 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   46 12 10  ;PUSH Bytes
CALL            10 12 46   ;CALL function
                           #--- PUSHB_4   64 46 3 9 ;PUSH Bytes
CALL            9 3 46 64  ;CALL function
                           #--- PUSHB_4   64 46 41 9 ;PUSH Bytes
CALL            9 41 46 64 ;CALL function
                           #--- PUSHB_3   12 46 10  ;PUSH Bytes
CALL            10 46 12   ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   17 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0346': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   4 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 4 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0374': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 12 10  ;PUSH Bytes
CALL            10 12 15   ;CALL function
                           #--- PUSHB_4   0 15 6 9  ;PUSH Bytes
CALL            9 6 15 0   ;CALL function
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni037E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   14 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 14 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03BC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   48 4      ;PUSH Bytes
MIRP[min,black] stemt 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_5   28 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_4   9 23 20 14 ;PUSH Bytes
CALL            14 20 23 9 ;CALL function
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   48 38 10  ;PUSH Bytes
CALL            10 38 48   ;CALL function
                           #--- PUSHB_4   64 48 1 9 ;PUSH Bytes
CALL            9 1 48 64  ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_5   44 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   13 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_2   25 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03D3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   32 5      ;PUSH Bytes
MIRP[min,black] cvt_5 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 23 10  ;PUSH Bytes
CALL            10 23 32   ;CALL function
                           #--- PUSHB_4   64 32 7 9 ;PUSH Bytes
CALL            9 7 32 64  ;CALL function
                           #--- PUSHB_4   0 32 29 9 ;PUSH Bytes
CALL            9 29 32 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   1 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03D4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 2 0    ;PUSH Bytes
CALL            0 2 38     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 5      ;PUSH Bytes
MIRP[min,black] cvt_5 24   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   30 28     ;PUSH Bytes
SDPVTL[orthog]  28 30      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[no-rnd]    30         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[grey]      28         ;Move Direct Relative Point
                           #--- PUSHB_2   7 10      ;PUSH Bytes
MIRP[rp0,min,black] cvt_10 7   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[grey]      9          ;Move Direct Relative Point
                           #--- PUSHB_4   8 7 9 19  ;PUSH Bytes
CALL            19 9 7 8   ;CALL function
                           #--- PUSHB_3   8 7 9     ;PUSH Bytes
                           #--- DUP       #9        ;DUPlicate top stack element
ROLL            9 9 7      ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_5   28 30 7 8 9 ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_5   28 30 7 8 9 ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   19 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   11 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03DB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   20 5      ;PUSH Bytes
MIRP[min,black] cvt_5 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   32 5      ;PUSH Bytes
MIRP[min,black] cvt_5 32   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   27 24     ;PUSH Bytes
SDPVTL[orthog]  24 27      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[no-rnd]    24         ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[grey]      27         ;Move Direct Relative Point
                           #--- PUSHB_2   11 11     ;PUSH Bytes
MIRP[rp0,min,black] cvt_11 11  ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[grey]      9          ;Move Direct Relative Point
                           #--- PUSHB_2   26 24     ;PUSH Bytes
SDPVTL[orthog]  24 26      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[grey]      26         ;Move Direct Relative Point
                           #--- PUSHB_2   9 11      ;PUSH Bytes
SFVTL[parallel] 11 9       ;Set Freedom Vector To Line
                           #--- PUSHB_2   11 11     ;PUSH Bytes
MIRP[rp0,min,black] cvt_11 11  ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[grey]      9          ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   10 9 11 19 ;PUSH Bytes
CALL            19 11 9 10 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_4   25 27 24 19 ;PUSH Bytes
CALL            19 24 27 25 ;CALL function
                           #--- PUSHB_2   27 24     ;PUSH Bytes
SFVTL[parallel] 24 27      ;Set Freedom Vector To Line
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   25 26 24 19 ;PUSH Bytes
CALL            19 24 26 25 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_4   26 27 24 19 ;PUSH Bytes
CALL            19 24 27 26 ;CALL function
                           #--- PUSHB_3   10 9 11   ;PUSH Bytes
                           #--- DUP       #11       ;DUPlicate top stack element
ROLL            11 11 9    ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_7   9 10 11 24 25 26 27 ;PUSH Bytes
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   9 10 11 25 26 27 ;PUSH Bytes
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 29      ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   19 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   13 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03F0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_2   90 5      ;PUSH Bytes
MIRP[min,black] cvt_5 90   ;Move Indirect Relative Point
                           #--- PUSHB_2   14 38     ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_2   86 5      ;PUSH Bytes
MIRP[min,black] cvt_5 86   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   94        ;PUSH Bytes
MDAP[rnd]       94         ;Move Direct Absolute Point
                           #--- PUSHB_2   95 1      ;PUSH Bytes
CALL            1 95       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   86 74     ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
SRP2            86         ;Set Reference Point 2
                           #--- PUSHB_1   61        ;PUSH Bytes
IP              61         ;Interpolate Point
                           #--- PUSHB_1   90        ;PUSH Bytes
SRP1            90         ;Set Reference Point 1
                           #--- PUSHB_3   13 16 60  ;PUSH Bytes
IP              60         ;Interpolate Point
IP              16         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03F1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   1 14 10   ;PUSH Bytes
CALL            10 14 1    ;CALL function
                           #--- PUSHB_4   64 1 8 9  ;PUSH Bytes
CALL            9 8 1 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   18 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03F5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 5      ;PUSH Bytes
MIRP[min,black] cvt_5 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   14 5      ;PUSH Bytes
MIRP[min,black] cvt_5 14   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   17 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 17 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   17 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   8 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03dc': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   58 2 0    ;PUSH Bytes
CALL            0 2 58     ;CALL function
                           #--- PUSHB_2   46 5      ;PUSH Bytes
MIRP[min,black] cvt_5 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp2]        73         ;SHift Point using reference point
                           #--- PUSHB_3   58 2 0    ;PUSH Bytes
CALL            0 2 58     ;CALL function
                           #--- PUSHB_5   63 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 63 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 5      ;PUSH Bytes
MIRP[min,black] cvt_5 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   75 5      ;PUSH Bytes
MIRP[min,black] cvt_5 75   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 75 10  ;PUSH Bytes
CALL            10 75 14   ;CALL function
                           #--- PUSHB_4   0 14 3 9  ;PUSH Bytes
CALL            9 3 14 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   74        ;PUSH Bytes
SHP[rp2]        74         ;SHift Point using reference point
                           #--- PUSHB_3   44 15 10  ;PUSH Bytes
CALL            10 15 44   ;CALL function
                           #--- PUSHB_4   64 44 49 9 ;PUSH Bytes
CALL            9 49 44 64 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_2   60 6      ;PUSH Bytes
MIRP[min,black] stemw 60   ;Move Indirect Relative Point
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   0 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   18 21 23  ;PUSH Bytes
IP              23         ;Interpolate Point
IP              21         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni03f4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_5   26 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 26 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   1 2       ;PUSH Bytes
SDPVTL[orthog]  2 1        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[no-rnd]    1          ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   10 19     ;PUSH Bytes
MIRP[rp0,min,black] cvt_19 10  ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   2 19      ;PUSH Bytes
MIRP[rp0,min,black] cvt_19 2   ;Move Indirect Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_4   1 2 9 10  ;PUSH Bytes
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   26 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0400': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 0 0    ;PUSH Bytes
CALL            0 0 43     ;CALL function
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   53 2 0    ;PUSH Bytes
CALL            0 2 53     ;CALL function
                           #--- PUSHB_5   51 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 51 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   53 2 0    ;PUSH Bytes
CALL            0 2 53     ;CALL function
                           #--- PUSHB_2   49 4      ;PUSH Bytes
MIRP[min,black] stemt 49   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_5   6 31 43 53 13 ;PUSH Bytes
CALL            13 53 43 31 6 ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
MDRP[rp0,rnd,white] 52         ;Move Direct Relative Point
                           #--- PUSHB_2   49 6      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_4   9 47 45 14 ;PUSH Bytes
CALL            14 45 47 9 ;CALL function
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   2 34      ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   20 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0450': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   39 3 0    ;PUSH Bytes
CALL            0 3 39     ;CALL function
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_5   51 12 22 33 13 ;PUSH Bytes
CALL            13 33 22 12 51 ;CALL function
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   40 48     ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_3   17 26 10  ;PUSH Bytes
CALL            10 26 17   ;CALL function
                           #--- PUSHB_4   64 17 45 9 ;PUSH Bytes
CALL            9 45 17 64 ;CALL function
                           #--- PUSHB_3   26 17 10  ;PUSH Bytes
CALL            10 17 26   ;CALL function
                           #--- PUSHB_4   64 26 31 9 ;PUSH Bytes
CALL            9 31 26 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_5   38 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   9 26 24 14 ;PUSH Bytes
CALL            14 24 26 9 ;CALL function
                           #--- PUSHB_5   20 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 20 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   57 6      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 57 10   ;PUSH Bytes
CALL            10 57 6    ;CALL function
                           #--- PUSHB_4   64 6 1 9  ;PUSH Bytes
CALL            9 1 6 64   ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   6 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   12 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni048E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   10 35 16 27 13 ;PUSH Bytes
CALL            13 27 16 35 10 ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   11 20 10  ;PUSH Bytes
CALL            10 20 11   ;CALL function
                           #--- PUSHB_4   64 11 14 9 ;PUSH Bytes
CALL            9 14 11 64 ;CALL function
                           #--- PUSHB_3   20 11 10  ;PUSH Bytes
CALL            10 11 20   ;CALL function
                           #--- PUSHB_4   64 20 24 9 ;PUSH Bytes
CALL            9 24 20 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 49 10  ;PUSH Bytes
CALL            10 49 31   ;CALL function
                           #--- PUSHB_4   64 31 2 9 ;PUSH Bytes
CALL            9 2 31 64  ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   31 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_3   5 7 33    ;PUSH Bytes
IP              33         ;Interpolate Point
IP              7          ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni048F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   56 1 0    ;PUSH Bytes
CALL            0 1 56     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   52 1 0    ;PUSH Bytes
CALL            0 1 52     ;CALL function
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[rp0,rnd,white] 45         ;Move Direct Relative Point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   3 53      ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   45 34 10  ;PUSH Bytes
CALL            10 34 45   ;CALL function
                           #--- PUSHB_4   64 45 50 9 ;PUSH Bytes
CALL            9 50 45 64 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_4   7 45 43 14 ;PUSH Bytes
CALL            14 43 45 7 ;CALL function
                           #--- PUSHB_5   38 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 38 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   38 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_7   6 0 15 8 29 31 56 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              56 31 29 8 15 0 6 ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_2   26 61     ;PUSH Bytes
IP              61         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   23 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_3   29 33 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              33         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_3   3 20 59   ;PUSH Bytes
IP              59         ;Interpolate Point
IP              20         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   52 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   50 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              50         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni048b': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 25 28  ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   35 38 10  ;PUSH Bytes
CALL            10 38 35   ;CALL function
                           #--- PUSHB_4   64 35 19 9 ;PUSH Bytes
CALL            9 19 35 64 ;CALL function
                           #--- PUSHB_3   47 3 0    ;PUSH Bytes
CALL            0 3 47     ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp1]        57         ;SHift Point using reference point
                           #--- PUSHB_3   42 1 0    ;PUSH Bytes
CALL            0 1 42     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 13    ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   52 62 39 47 13 ;PUSH Bytes
CALL            13 47 39 62 52 ;CALL function
                           #--- PUSHB_5   52 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 52 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDRP[rp0,rnd,white] 37         ;Move Direct Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_5   31 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 31 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_4   28 31 37 8 ;PUSH Bytes
CALL            8 37 31 28 ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 10 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_4   14 10 5 8 ;PUSH Bytes
CALL            8 5 10 14  ;CALL function
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 14 10  ;PUSH Bytes
CALL            10 14 25   ;CALL function
                           #--- PUSHB_4   64 25 5 9 ;PUSH Bytes
CALL            9 5 25 64  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   28 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   47 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              47         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_2   50 62     ;PUSH Bytes
IP              62         ;Interpolate Point
IP              50         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   1 26      ;PUSH Bytes
IP              26         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_2   47 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   59 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              59         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni048c': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   36 3 0    ;PUSH Bytes
CALL            0 3 36     ;CALL function
                           #--- PUSHB_5   9 8 20 36 13 ;PUSH Bytes
CALL            13 36 20 8 9 ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_5   31 28 20 36 13 ;PUSH Bytes
CALL            13 36 20 28 31 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   9 39      ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   0 26 10   ;PUSH Bytes
CALL            10 26 0    ;CALL function
                           #--- PUSHB_4   64 0 44 9 ;PUSH Bytes
CALL            9 44 0 64  ;CALL function
                           #--- PUSHB_3   26 0 10   ;PUSH Bytes
CALL            10 0 26    ;CALL function
                           #--- PUSHB_4   64 26 23 9 ;PUSH Bytes
CALL            9 23 26 64 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni048d': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   32 28 10  ;PUSH Bytes
CALL            10 28 32   ;CALL function
                           #--- PUSHB_4   64 32 7 9 ;PUSH Bytes
CALL            9 7 32 64  ;CALL function
                           #--- PUSHB_5   6 15 24 7 13 ;PUSH Bytes
CALL            13 7 24 15 6 ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   9 14      ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   0 27 10   ;PUSH Bytes
CALL            10 27 0    ;CALL function
                           #--- PUSHB_4   64 0 12 9 ;PUSH Bytes
CALL            9 12 0 64  ;CALL function
                           #--- PUSHB_3   27 0 10   ;PUSH Bytes
CALL            10 0 27    ;CALL function
                           #--- PUSHB_4   64 27 30 9 ;PUSH Bytes
CALL            9 30 27 64 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0493': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_5   23 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 23 ;CALL function
                           #--- PUSHB_5   10 13 5 18 13 ;PUSH Bytes
CALL            13 18 5 13 10 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_5   10 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 10 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   37 8 10   ;PUSH Bytes
CALL            10 8 37    ;CALL function
                           #--- PUSHB_4   64 37 32 9 ;PUSH Bytes
CALL            9 32 37 64 ;CALL function
                           #--- PUSHB_3   8 37 10   ;PUSH Bytes
CALL            10 37 8    ;CALL function
                           #--- PUSHB_4   64 8 12 9 ;PUSH Bytes
CALL            9 12 8 64  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_4   9 8 7 14  ;PUSH Bytes
CALL            14 7 8 9   ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0494': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_5   25 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 25 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_2   49 5      ;PUSH Bytes
MIRP[min,black] cvt_5 49   ;Move Indirect Relative Point
                           #--- PUSHB_5   56 32 6 20 13 ;PUSH Bytes
CALL            13 20 6 32 56 ;CALL function
                           #--- PUSHB_2   56 5      ;PUSH Bytes
MIRP[min,black] cvt_5 56   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_4   8 12 8 14 ;PUSH Bytes
CALL            14 8 12 8  ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
                           #--- DUP       #27       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   52 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_4   32 44 46 56 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              56 46 44 32 ;Interpolate Point
                           #--- PUSHB_2   37 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 56     ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0495': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_5   0 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 0 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   22 5      ;PUSH Bytes
MIRP[min,black] cvt_5 22   ;Move Indirect Relative Point
                           #--- PUSHB_5   28 8 38 45 13 ;PUSH Bytes
CALL            13 45 38 8 28 ;CALL function
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_4   9 31 34 14 ;PUSH Bytes
CALL            14 34 31 9 ;CALL function
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_3   25 14 10  ;PUSH Bytes
CALL            10 14 25   ;CALL function
                           #--- PUSHB_4   64 25 21 9 ;PUSH Bytes
CALL            9 21 25 64 ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   25 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   8 28      ;PUSH Bytes
IP              28         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0496': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   12 22     ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 17 28   ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   33 36 10  ;PUSH Bytes
CALL            10 36 33   ;CALL function
                           #--- PUSHB_4   64 33 10 9 ;PUSH Bytes
CALL            9 10 33 64 ;CALL function
                           #--- PUSHB_3   43 2 0    ;PUSH Bytes
CALL            0 2 43     ;CALL function
                           #--- PUSHB_2   0 55      ;PUSH Bytes
SHP[rp1]        55         ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 50 61   ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   46 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 46 ;CALL function
                           #--- PUSHB_4   32 46 42 8 ;PUSH Bytes
CALL            8 42 46 32 ;CALL function
                           #--- PUSHB_5   37 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_5   32 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 32 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
                           #--- PUSHB_4   9 28 25 14 ;PUSH Bytes
CALL            14 25 28 9 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp1]        52         ;SHift Point using reference point
                           #--- PUSHB_5   20 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 20 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp2]        59         ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_5   65 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 65 ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_4   6 8 11 8  ;PUSH Bytes
CALL            8 11 8 6   ;CALL function
                           #--- PUSHB_5   13 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp1]        63         ;SHift Point using reference point
                           #--- PUSHB_5   6 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 6 ;CALL function
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_2   37 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_2   46 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_2   13 65     ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   16 29 49 62 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              62 49 29 16 ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_2   48 63     ;PUSH Bytes
IP              63         ;Interpolate Point
IP              48         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0497': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_2   10 22     ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   38 43 10  ;PUSH Bytes
CALL            10 43 38   ;CALL function
                           #--- PUSHB_4   64 38 7 9 ;PUSH Bytes
CALL            9 7 38 64  ;CALL function
                           #--- PUSHB_3   52 1 0    ;PUSH Bytes
CALL            0 1 52     ;CALL function
                           #--- PUSHB_2   65 78     ;PUSH Bytes
SHP[rp1]        78         ;SHift Point using reference point
SHP[rp1]        65         ;SHift Point using reference point
                           #--- PUSHB_2   46 4      ;PUSH Bytes
MIRP[min,black] stemt 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   85        ;PUSH Bytes
SHP[rp2]        85         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   88        ;PUSH Bytes
MDAP[rnd]       88         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_5   35 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 35 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_5   20 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 20 ;CALL function
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp2]        68         ;SHift Point using reference point
                           #--- PUSHB_4   17 20 25 8 ;PUSH Bytes
CALL            8 25 20 17 ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   72        ;PUSH Bytes
SHP[rp2]        72         ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_5   82 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 82 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   82        ;PUSH Bytes
SRP0            82         ;Set Reference Point 0
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   89 1      ;PUSH Bytes
CALL            1 89       ;CALL function
                           #--- PUSHB_2   35 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_3   33 45 57  ;PUSH Bytes
IP              57         ;Interpolate Point
IP              45         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_2   9 76      ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   15 74 86  ;PUSH Bytes
IP              86         ;Interpolate Point
IP              74         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   82        ;PUSH Bytes
SRP1            82         ;Set Reference Point 1
                           #--- PUSHB_3   7 85 87   ;PUSH Bytes
IP              87         ;Interpolate Point
IP              85         ;Interpolate Point
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_4   15 17 31 33 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              33 31 17 15 ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_6   16 32 58 59 72 73 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              73 72 59 58 32 16 ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   57 74     ;PUSH Bytes
IP              74         ;Interpolate Point
IP              57         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0498': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_5   20 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 20 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
                           #--- DUP       #7        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_5   31 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 31 ;CALL function
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_3   81 0 0    ;PUSH Bytes
CALL            0 0 81     ;CALL function
                           #--- PUSHB_3   70 2 0    ;PUSH Bytes
CALL            0 2 70     ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp1]        65         ;SHift Point using reference point
                           #--- PUSHB_2   49 4      ;PUSH Bytes
MIRP[min,black] stemt 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   49 70 10  ;PUSH Bytes
CALL            10 70 49   ;CALL function
                           #--- PUSHB_4   64 49 59 9 ;PUSH Bytes
CALL            9 59 49 64 ;CALL function
                           #--- PUSHB_1   86        ;PUSH Bytes
MDAP[rnd]       86         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 86 10   ;PUSH Bytes
CALL            10 86 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_5   38 42 14 70 13 ;PUSH Bytes
CALL            13 70 14 42 38 ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   92        ;PUSH Bytes
MDAP[rnd]       92         ;Move Direct Absolute Point
                           #--- PUSHB_1   61        ;PUSH Bytes
MDRP[rp0,rnd,white] 61         ;Move Direct Relative Point
                           #--- PUSHB_2   51 6      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_1   28        ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   83 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 83 ;CALL function
                           #--- PUSHB_3   5 83 10   ;PUSH Bytes
CALL            10 83 5    ;CALL function
                           #--- PUSHB_4   0 5 89 9  ;PUSH Bytes
CALL            9 89 5 0   ;CALL function
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP0            83         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   73 6      ;PUSH Bytes
MIRP[min,black] stemw 73   ;Move Indirect Relative Point
                           #--- PUSHB_3   46 73 10  ;PUSH Bytes
CALL            10 73 46   ;CALL function
                           #--- PUSHB_4   64 46 40 9 ;PUSH Bytes
CALL            9 40 46 64 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_1   34        ;PUSH Bytes
                           #--- DUP       #34       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_2   78 6      ;PUSH Bytes
MIRP[min,black] stemw 78   ;Move Indirect Relative Point
                           #--- PUSHB_2   93 1      ;PUSH Bytes
CALL            1 93       ;CALL function
                           #--- PUSHB_2   28 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_5   12 20 14 59 65 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              65 59 14 20 12 ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_2   29 68     ;PUSH Bytes
IP              68         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- NPUSHB    9 9 10 31 37 38 42 43 49 70 ;PUSH N Bytes
                           #--- DEPTH     #9        ;DEPTH of the stack
SLOOP           9          ;Set LOOP variable
IP              70 49 43 42 38 37 31 10 9 ;Interpolate Point
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP1            83         ;Set Reference Point 1
                           #--- PUSHB_1   81        ;PUSH Bytes
IP              81         ;Interpolate Point
                           #--- PUSHB_2   73 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            73         ;Set Reference Point 2
                           #--- PUSHB_1   76        ;PUSH Bytes
IP              76         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   83        ;PUSH Bytes
IP              83         ;Interpolate Point
                           #--- PUSHB_2   31 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   34 78     ;PUSH Bytes
IP              78         ;Interpolate Point
IP              34         ;Interpolate Point
                           #--- PUSHB_2   42 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   76        ;PUSH Bytes
IP              76         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_1   73        ;PUSH Bytes
IP              73         ;Interpolate Point
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_1   68        ;PUSH Bytes
IP              68         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0499': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_5   19 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 19 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
                           #--- DUP       #7        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_5   23 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 23 ;CALL function
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_3   67 0 0    ;PUSH Bytes
CALL            0 0 67     ;CALL function
                           #--- PUSHB_3   55 1 0    ;PUSH Bytes
CALL            0 1 55     ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   55 1 0    ;PUSH Bytes
CALL            0 1 55     ;CALL function
                           #--- PUSHB_5   46 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 46 ;CALL function
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 72 10   ;PUSH Bytes
CALL            10 72 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_5   33 30 14 55 13 ;PUSH Bytes
CALL            13 55 14 30 33 ;CALL function
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   69 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 69 ;CALL function
                           #--- PUSHB_3   69 5 10   ;PUSH Bytes
CALL            10 5 69    ;CALL function
                           #--- PUSHB_4   64 69 58 9 ;PUSH Bytes
CALL            9 58 69 64 ;CALL function
                           #--- PUSHB_3   5 69 10   ;PUSH Bytes
CALL            10 69 5    ;CALL function
                           #--- PUSHB_4   0 5 75 9  ;PUSH Bytes
CALL            9 75 5 0   ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP0            69         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   64 6      ;PUSH Bytes
MIRP[min,black] stemw 64   ;Move Indirect Relative Point
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   69 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_2   37 67     ;PUSH Bytes
IP              67         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_2   64 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            64         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   69        ;PUSH Bytes
IP              69         ;Interpolate Point
                           #--- PUSHB_2   23 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_2   26 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_2   33 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   60 61     ;PUSH Bytes
IP              61         ;Interpolate Point
IP              60         ;Interpolate Point
                           #--- PUSHB_2   40 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   37 58     ;PUSH Bytes
IP              58         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni049A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   8 48      ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   1 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 1  ;CALL function
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   31 44     ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   8 19 10   ;PUSH Bytes
CALL            10 19 8    ;CALL function
                           #--- PUSHB_4   64 8 11 9 ;PUSH Bytes
CALL            9 11 8 64  ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   19 8 10   ;PUSH Bytes
CALL            10 8 19    ;CALL function
                           #--- PUSHB_4   64 19 15 9 ;PUSH Bytes
CALL            9 15 19 64 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   50 6      ;PUSH Bytes
MIRP[min,black] stemw 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_1   42        ;PUSH Bytes
                           #--- DUP       #42       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_5   36 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_5   42 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 42 ;CALL function
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   36 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   4 34      ;PUSH Bytes
IP              34         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   44 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              44         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   7 33      ;PUSH Bytes
IP              33         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni049B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_5   38 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 38 ;CALL function
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_5   19 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 19 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   29 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 29 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   39 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_5   4 21 32 33 34 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              34 33 32 21 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_2   5 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni049c': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 0 0    ;PUSH Bytes
CALL            0 0 23     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 18      ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   37 2 0    ;PUSH Bytes
CALL            0 2 37     ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp1]        56         ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_2   41 62     ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
SHP[rp2]        41         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   18 29 10  ;PUSH Bytes
CALL            10 29 18   ;CALL function
                           #--- PUSHB_4   64 18 21 9 ;PUSH Bytes
CALL            9 21 18 64 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   29 18 10  ;PUSH Bytes
CALL            10 18 29   ;CALL function
                           #--- PUSHB_4   64 29 25 9 ;PUSH Bytes
CALL            9 25 29 64 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_5   60 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 60 ;CALL function
                           #--- PUSHB_3   60 54 10  ;PUSH Bytes
CALL            10 54 60   ;CALL function
                           #--- PUSHB_4   64 60 3 9 ;PUSH Bytes
CALL            9 3 60 64  ;CALL function
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   9 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_4   6 52 62 66 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              66 62 52 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_5   8 17 43 48 51 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              51 48 43 17 8 ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni049d': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_5   30 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 30 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_2   38 52     ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_5   48 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 48 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   48 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_4   7 40 51 54 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              54 51 40 7 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   7 11 12   ;PUSH Bytes
IP              12         ;Interpolate Point
IP              11         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_5   15 8 16 31 32 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              32 31 16 8 15 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   35 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni049e': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   37 2 0    ;PUSH Bytes
CALL            0 2 37     ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp1]        56         ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_2   41 62     ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   23 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 23 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   42 50     ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   10 21 10  ;PUSH Bytes
CALL            10 21 10   ;CALL function
                           #--- PUSHB_4   64 10 13 9 ;PUSH Bytes
CALL            9 13 10 64 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_4   64 10 47 9 ;PUSH Bytes
CALL            9 47 10 64 ;CALL function
                           #--- PUSHB_3   21 10 10  ;PUSH Bytes
CALL            10 10 21   ;CALL function
                           #--- PUSHB_4   64 21 17 9 ;PUSH Bytes
CALL            9 17 21 64 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_5   60 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 60 ;CALL function
                           #--- PUSHB_3   60 54 10  ;PUSH Bytes
CALL            10 54 60   ;CALL function
                           #--- PUSHB_4   64 60 3 9 ;PUSH Bytes
CALL            9 3 60 64  ;CALL function
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   54 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_4   6 52 62 66 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              66 62 52 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_3   9 51 63   ;PUSH Bytes
IP              63         ;Interpolate Point
IP              51         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   37 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni049f': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_5   21 16 10 29 13 ;PUSH Bytes
CALL            13 29 10 16 21 ;CALL function
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_5   30 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 30 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   8 47      ;PUSH Bytes
IP              47         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   29 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04A2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 15 19   ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   24 29 10  ;PUSH Bytes
CALL            10 29 24   ;CALL function
                           #--- PUSHB_4   64 24 9 9 ;PUSH Bytes
CALL            9 9 24 64  ;CALL function
                           #--- PUSHB_3   36 2 0    ;PUSH Bytes
CALL            0 2 36     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 40 44   ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_5   42 18 9 36 13 ;PUSH Bytes
CALL            13 36 9 18 42 ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_4   9 30 33 14 ;PUSH Bytes
CALL            14 33 30 9 ;CALL function
                           #--- PUSHB_5   39 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 39 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_4   9 5 2 14  ;PUSH Bytes
CALL            14 2 5 9   ;CALL function
                           #--- PUSHB_5   47 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 47 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_5   2 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 2  ;CALL function
                           #--- PUSHB_4   10 5 16 8 ;PUSH Bytes
CALL            8 16 5 10  ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04A3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 6 35    ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   11 14 10  ;PUSH Bytes
CALL            10 14 11   ;CALL function
                           #--- PUSHB_4   64 11 39 9 ;PUSH Bytes
CALL            9 39 11 64 ;CALL function
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 26 34  ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_5   24 5 39 18 13 ;PUSH Bytes
CALL            13 18 39 5 24 ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_5   8 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 8  ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_4   6 8 13 8  ;PUSH Bytes
CALL            8 13 8 6   ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_5   36 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 36 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_4   35 36 2 8 ;PUSH Bytes
CALL            8 2 36 35  ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 35 10   ;PUSH Bytes
CALL            10 35 3    ;CALL function
                           #--- PUSHB_4   64 3 28 9 ;PUSH Bytes
CALL            9 28 3 64  ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04A6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 54    ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_2   45 5      ;PUSH Bytes
MIRP[min,black] cvt_5 45   ;Move Indirect Relative Point
                           #--- PUSHB_5   51 31 11 23 13 ;PUSH Bytes
CALL            13 23 11 31 51 ;CALL function
                           #--- PUSHB_2   51 5      ;PUSH Bytes
MIRP[min,black] cvt_5 51   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 6 10   ;PUSH Bytes
CALL            10 6 17    ;CALL function
                           #--- PUSHB_4   64 17 20 9 ;PUSH Bytes
CALL            9 20 17 64 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_4   9 17 13 14 ;PUSH Bytes
CALL            14 13 17 9 ;CALL function
                           #--- PUSHB_5   9 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 9  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   54 6      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   54 3 10   ;PUSH Bytes
CALL            10 3 54    ;CALL function
                           #--- PUSHB_4   64 54 26 9 ;PUSH Bytes
CALL            9 26 54 64 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   9 3 1 14  ;PUSH Bytes
CALL            14 1 3 9   ;CALL function
                           #--- PUSHB_5   57 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 57 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   48 37 10  ;PUSH Bytes
CALL            10 37 48   ;CALL function
                           #--- PUSHB_4   64 48 44 9 ;PUSH Bytes
CALL            9 44 48 64 ;CALL function
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   57 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_2   31 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04A8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_3   16 51 10  ;PUSH Bytes
CALL            10 51 16   ;CALL function
                           #--- PUSHB_4   64 16 13 9 ;PUSH Bytes
CALL            9 13 16 64 ;CALL function
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_5   36 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 36 ;CALL function
                           #--- PUSHB_5   3 59 13 23 13 ;PUSH Bytes
CALL            13 23 13 59 3 ;CALL function
                           #--- PUSHB_2   3 5       ;PUSH Bytes
MIRP[min,black] cvt_5 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   10 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_2   23 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_4   3 27 40 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 40 27 3 ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   27 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04AC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_5   9 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 9  ;CALL function
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   25 2 0    ;PUSH Bytes
CALL            0 2 25     ;CALL function
                           #--- PUSHB_5   0 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 0  ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   18 5 10   ;PUSH Bytes
CALL            10 5 18    ;CALL function
                           #--- PUSHB_4   64 18 14 9 ;PUSH Bytes
CALL            9 14 18 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_4   7 27 2 8  ;PUSH Bytes
CALL            8 2 27 7   ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   27 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04AD': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   12 15 10  ;PUSH Bytes
CALL            10 15 12   ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_5   21 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 21 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_4   10 5 15 8 ;PUSH Bytes
CALL            8 15 5 10  ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   14 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04AE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_5   6 11 47 16 13 ;PUSH Bytes
CALL            13 16 47 11 6 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   19 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   42 4 10   ;PUSH Bytes
CALL            10 4 42    ;CALL function
                           #--- PUSHB_4   64 42 45 9 ;PUSH Bytes
CALL            9 45 42 64 ;CALL function
                           #--- PUSHB_4   64 42 39 9 ;PUSH Bytes
CALL            9 39 42 64 ;CALL function
                           #--- PUSHB_3   4 42 10   ;PUSH Bytes
CALL            10 42 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_4   64 4 8 9  ;PUSH Bytes
CALL            9 8 4 64   ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_5   32 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 32 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   19 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   13 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   42 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_2   32 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   23 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   21 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04B1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   19 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   41 4 10   ;PUSH Bytes
CALL            10 4 41    ;CALL function
                           #--- PUSHB_4   64 41 44 9 ;PUSH Bytes
CALL            9 44 41 64 ;CALL function
                           #--- PUSHB_4   64 41 38 9 ;PUSH Bytes
CALL            9 38 41 64 ;CALL function
                           #--- PUSHB_3   4 41 10   ;PUSH Bytes
CALL            10 41 4    ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_4   64 4 8 9  ;PUSH Bytes
CALL            9 8 4 64   ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_5   32 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 32 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   19 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   13 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_2   32 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   23 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   21 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04B2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_3   15 20 10  ;PUSH Bytes
CALL            10 20 15   ;CALL function
                           #--- PUSHB_4   64 15 1 9 ;PUSH Bytes
CALL            9 1 15 64  ;CALL function
                           #--- PUSHB_3   38 2 0    ;PUSH Bytes
CALL            0 2 38     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_5   29 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 29 ;CALL function
                           #--- PUSHB_4   12 24 17 14 ;PUSH Bytes
CALL            14 17 24 12 ;CALL function
                           #--- PUSHB_5   12 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 12 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_5   6 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 6  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_1   41        ;PUSH Bytes
                           #--- DUP       #41       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_5   35 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_5   41 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 41 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   29 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_4   20 21 10 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 10 21 20 ;Interpolate Point
                           #--- PUSHB_2   6 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   9 32      ;PUSH Bytes
IP              32         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   2 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_3   8 33 44   ;PUSH Bytes
IP              44         ;Interpolate Point
IP              33         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   43 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              43         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   8 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_3   9 22 32   ;PUSH Bytes
IP              32         ;Interpolate Point
IP              22         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   31 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04B3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 24 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_1   35        ;PUSH Bytes
                           #--- DUP       #35       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_5   30 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_5   35 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 35 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   24 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_4   6 15 16 26 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              26 16 15 6 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_2   5 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_3   4 28 38   ;PUSH Bytes
IP              38         ;Interpolate Point
IP              28         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_2   37 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              37         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_4   5 27 39 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 39 27 5 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04B4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   29 42     ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   4 8 10    ;PUSH Bytes
CALL            10 8 4     ;CALL function
                           #--- PUSHB_4   64 4 1 9  ;PUSH Bytes
CALL            9 1 4 64   ;CALL function
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 31 40  ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_5   14 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 14 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 29 10   ;PUSH Bytes
CALL            10 29 8    ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 30 34 14 ;PUSH Bytes
CALL            14 34 30 9 ;CALL function
                           #--- PUSHB_5   39 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 39 ;CALL function
                           #--- PUSHB_4   2 42 30 8 ;PUSH Bytes
CALL            8 30 42 2  ;CALL function
                           #--- PUSHB_2   44 6      ;PUSH Bytes
MIRP[min,black] stemw 44   ;Move Indirect Relative Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04B5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_2   24 36     ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 40 9 ;PUSH Bytes
CALL            9 40 0 64  ;CALL function
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   22 26 35  ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_5   9 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 9 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 24 10   ;PUSH Bytes
CALL            10 24 3    ;CALL function
                           #--- PUSHB_4   64 3 2 9  ;PUSH Bytes
CALL            9 2 3 64   ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 25 29 14 ;PUSH Bytes
CALL            14 29 25 9 ;CALL function
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_4   41 36 25 8 ;PUSH Bytes
CALL            8 25 36 41 ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04B6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   13 16 10  ;PUSH Bytes
CALL            10 16 13   ;CALL function
                           #--- PUSHB_4   64 13 10 9 ;PUSH Bytes
CALL            9 10 13 64 ;CALL function
                           #--- PUSHB_3   31 2 0    ;PUSH Bytes
CALL            0 2 31     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 35 42   ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   20 39 10 31 13 ;PUSH Bytes
CALL            13 31 10 39 20 ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 26 29 14 ;PUSH Bytes
CALL            14 29 26 9 ;CALL function
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_4   9 6 3 14  ;PUSH Bytes
CALL            14 3 6 9   ;CALL function
                           #--- PUSHB_5   45 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 3  ;CALL function
                           #--- PUSHB_4   11 6 17 8 ;PUSH Bytes
CALL            8 17 6 11  ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   45 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   20 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04B7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   12 15 10  ;PUSH Bytes
CALL            10 15 12   ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 30 38   ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_5   34 18 9 25 13 ;PUSH Bytes
CALL            13 25 9 18 34 ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 21 24 14 ;PUSH Bytes
CALL            14 24 21 9 ;CALL function
                           #--- PUSHB_5   28 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 28 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_5   2 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 2  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_4   5 2 40 8  ;PUSH Bytes
CALL            8 40 2 5   ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   15 5 10   ;PUSH Bytes
CALL            10 5 15    ;CALL function
                           #--- PUSHB_4   64 15 40 9 ;PUSH Bytes
CALL            9 40 15 64 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   40 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   18 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_2   25 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04BA': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   56 0 0    ;PUSH Bytes
CALL            0 0 56     ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_4   3 32 47 51 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        51 47 32 3 ;SHift Point using reference point
                           #--- PUSHB_3   56 0 0    ;PUSH Bytes
CALL            0 0 56     ;CALL function
                           #--- PUSHB_5   36 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 36 ;CALL function
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_2   4 16      ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_5   14 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 14 ;CALL function
                           #--- PUSHB_4   21 10 14 8 ;PUSH Bytes
CALL            8 14 10 21 ;CALL function
                           #--- PUSHB_5   27 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_1   50        ;PUSH Bytes
                           #--- DUP       #50       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_2   59 4      ;PUSH Bytes
MIRP[min,black] stemt 59   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   53 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 53 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   48 32 10  ;PUSH Bytes
CALL            10 32 48   ;CALL function
                           #--- PUSHB_4   64 48 7 9 ;PUSH Bytes
CALL            9 7 48 64  ;CALL function
                           #--- PUSHB_4   64 48 44 9 ;PUSH Bytes
CALL            9 44 48 64 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
                           #--- DUP       #33       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   51 58     ;PUSH Bytes
SDPVTL[orthog]  58 51      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[no-rnd]    58         ;Move Direct Absolute Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[no-rnd]    3          ;Move Direct Absolute Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[rp0,min,black] cvt_7 51   ;Move Indirect Relative Point
                           #--- PUSHB_4   50 51 58 19 ;PUSH Bytes
CALL            19 58 51 50 ;CALL function
                           #--- PUSHB_4   59 51 58 19 ;PUSH Bytes
CALL            19 58 51 59 ;CALL function
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[no-rnd]    58         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_5   3 4 50 51 59 ;PUSH Bytes
MDAP[no-rnd]    59         ;Move Direct Absolute Point
MDAP[no-rnd]    51         ;Move Direct Absolute Point
MDAP[no-rnd]    50         ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   12 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   59 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_2   31 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   18 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04D5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   62 4      ;PUSH Bytes
MIRP[min,black] stemt 62   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_5   11 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 11 ;CALL function
                           #--- PUSHB_3   52 1 0    ;PUSH Bytes
CALL            0 1 52     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
                           #--- PUSHB_5   35 56 27 52 13 ;PUSH Bytes
CALL            13 52 27 56 35 ;CALL function
                           #--- PUSHB_2   35 5      ;PUSH Bytes
MIRP[min,black] cvt_5 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
                           #--- DUP       #5        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   71 5      ;PUSH Bytes
MIRP[min,black] cvt_5 71   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   59 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   62 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_3   14 21 25  ;PUSH Bytes
IP              25         ;Interpolate Point
IP              21         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   5 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   30 59 64  ;PUSH Bytes
IP              64         ;Interpolate Point
IP              59         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_2   35 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   47 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              47         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04D6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 2 0     ;PUSH Bytes
CALL            0 2 0      ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_5   16 27 9 0 13 ;PUSH Bytes
CALL            13 0 9 27 16 ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   12 6      ;PUSH Bytes
IP              6          ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04E9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   22 4      ;PUSH Bytes
MIRP[min,black] stemt 22   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_5   17 19 6 0 13 ;PUSH Bytes
CALL            13 0 6 19 17 ;CALL function
                           #--- PUSHB_5   17 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 17 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   8 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04EA': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 1 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04a0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   34 47     ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_5   26 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 26 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_4   8 21 17 14 ;PUSH Bytes
CALL            14 17 21 8 ;CALL function
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   45 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 45 ;CALL function
                           #--- PUSHB_3   45 39 10  ;PUSH Bytes
CALL            10 39 45   ;CALL function
                           #--- PUSHB_4   64 45 3 9 ;PUSH Bytes
CALL            9 3 45 64  ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   17 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_2   39 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_4   6 37 47 51 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              51 47 37 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   9 36 48   ;PUSH Bytes
IP              48         ;Interpolate Point
IP              36         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   30 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04a1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_5   20 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 20 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_5   12 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   12 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   25 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04a4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 47    ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 31 45  ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_5   42 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 42 ;CALL function
                           #--- PUSHB_5   5 29 11 23 13 ;PUSH Bytes
CALL            13 23 11 29 5 ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_4   9 17 20 14 ;PUSH Bytes
CALL            14 20 17 9 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_4   8 47 50 14 ;PUSH Bytes
CALL            14 50 47 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   50 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 50 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04a5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 26 29  ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   43 1 0    ;PUSH Bytes
CALL            0 1 43     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 16    ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   43 1 0    ;PUSH Bytes
CALL            0 1 43     ;CALL function
                           #--- PUSHB_5   13 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 13 ;CALL function
                           #--- PUSHB_5   28 1 34 43 13 ;PUSH Bytes
CALL            13 43 34 1 28 ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_5   46 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 46 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_4   29 46 40 8 ;PUSH Bytes
CALL            8 40 46 29 ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 18 10  ;PUSH Bytes
CALL            10 18 26   ;CALL function
                           #--- PUSHB_4   64 26 5 9 ;PUSH Bytes
CALL            9 5 26 64  ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   9 26 25 14 ;PUSH Bytes
CALL            14 25 26 9 ;CALL function
                           #--- PUSHB_5   20 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 20 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04a9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_3   15 43 10  ;PUSH Bytes
CALL            10 43 15   ;CALL function
                           #--- PUSHB_4   64 15 12 9 ;PUSH Bytes
CALL            9 12 15 64 ;CALL function
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_5   32 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 32 ;CALL function
                           #--- PUSHB_5   3 50 12 23 13 ;PUSH Bytes
CALL            13 23 12 50 3 ;CALL function
                           #--- PUSHB_5   3 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
                           #--- DUP       #6        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   9 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   12 23 38  ;PUSH Bytes
IP              38         ;Interpolate Point
IP              23         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_3   35 3 50   ;PUSH Bytes
IP              50         ;Interpolate Point
IP              3          ;Interpolate Point
IP              35         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   25 32     ;PUSH Bytes
IP              32         ;Interpolate Point
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   50 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_2   6 47      ;PUSH Bytes
IP              47         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_2   20 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_2   23 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04aa': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp1]        56         ;SHift Point using reference point
                           #--- PUSHB_2   45 5      ;PUSH Bytes
MIRP[min,black] cvt_5 45   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_5   30 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 30 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   63 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 63 ;CALL function
                           #--- PUSHB_3   63 6 10   ;PUSH Bytes
CALL            10 6 63    ;CALL function
                           #--- PUSHB_4   0 63 0 9  ;PUSH Bytes
CALL            9 0 63 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   61 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 61 ;CALL function
                           #--- PUSHB_3   61 9 10   ;PUSH Bytes
CALL            10 9 61    ;CALL function
                           #--- PUSHB_4   0 61 3 9  ;PUSH Bytes
CALL            9 3 61 0   ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP0            61         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   33 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_6   11 12 19 38 45 56 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              56 45 38 19 12 11 ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_3   22 48 50  ;PUSH Bytes
IP              50         ;Interpolate Point
IP              48         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_2   30 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   50 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              50         ;Interpolate Point
                           #--- PUSHB_2   24 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04ab': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 0 0    ;PUSH Bytes
CALL            0 0 50     ;CALL function
                           #--- PUSHB_2   39 4      ;PUSH Bytes
MIRP[min,black] stemt 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_5   28 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 28 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   57 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 57 ;CALL function
                           #--- PUSHB_3   57 6 10   ;PUSH Bytes
CALL            10 6 57    ;CALL function
                           #--- PUSHB_4   0 57 0 9  ;PUSH Bytes
CALL            9 0 57 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   55 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 55 ;CALL function
                           #--- PUSHB_3   55 9 10   ;PUSH Bytes
CALL            10 9 55    ;CALL function
                           #--- PUSHB_4   0 55 3 9  ;PUSH Bytes
CALL            9 3 55 0   ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   26 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_6   11 19 34 39 44 50 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              50 44 39 34 19 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   50 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_2   9 55      ;PUSH Bytes
IP              55         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   28 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   16 37 44 47 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              47 44 37 16 ;Interpolate Point
                           #--- PUSHB_2   19 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04b8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   57 0 0    ;PUSH Bytes
CALL            0 0 57     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 41 51  ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
SHP[rp2]        41         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 18 21 14 ;PUSH Bytes
CALL            14 21 18 9 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_5   7 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 7 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_4   8 52 55 14 ;PUSH Bytes
CALL            14 55 52 8 ;CALL function
                           #--- PUSHB_5   1 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 1  ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   55 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 55 ;CALL function
                           #--- PUSHB_5   49 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 49 ;CALL function
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   26 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   19 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04b9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_3   20 1 0    ;PUSH Bytes
CALL            0 1 20     ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   25 39 48  ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 16 19 14 ;PUSH Bytes
CALL            14 19 16 9 ;CALL function
                           #--- PUSHB_5   23 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 23 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_5   46 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 46 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_4   35 46 41 8 ;PUSH Bytes
CALL            8 41 46 35 ;CALL function
                           #--- PUSHB_5   28 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 35 ;CALL function
                           #--- PUSHB_4   49 46 41 8 ;PUSH Bytes
CALL            8 41 46 49 ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   49 6      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 49 10   ;PUSH Bytes
CALL            10 49 6    ;CALL function
                           #--- PUSHB_4   64 6 41 9 ;PUSH Bytes
CALL            9 41 6 64  ;CALL function
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   23 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   12 32     ;PUSH Bytes
IP              32         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_4   7 9 14 28 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              28 14 9 7  ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04c3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 0 0    ;PUSH Bytes
CALL            0 0 26     ;CALL function
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_3   40 2 0    ;PUSH Bytes
CALL            0 2 40     ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   44 57     ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   12 5      ;PUSH Bytes
MIRP[min,black] cvt_5 12   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_3   21 32 10  ;PUSH Bytes
CALL            10 32 21   ;CALL function
                           #--- PUSHB_4   64 21 24 9 ;PUSH Bytes
CALL            9 24 21 64 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   32 21 10  ;PUSH Bytes
CALL            10 21 32   ;CALL function
                           #--- PUSHB_4   64 32 28 9 ;PUSH Bytes
CALL            9 28 32 64 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   9 0 55 14 ;PUSH Bytes
CALL            14 55 0 9  ;CALL function
                           #--- PUSHB_5   49 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_5   55 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 55 ;CALL function
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   49 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_4   6 12 9 58 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              58 9 12 6  ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_3   20 46 58  ;PUSH Bytes
IP              58         ;Interpolate Point
IP              46         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04c4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_2   53 5      ;PUSH Bytes
MIRP[min,black] cvt_5 53   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   17 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 17 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_4   9 40 27 14 ;PUSH Bytes
CALL            14 27 40 9 ;CALL function
                           #--- PUSHB_5   21 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   27 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 27 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   21 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   47 50 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              50         ;Interpolate Point
IP              47         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   19 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_3   3 18 31   ;PUSH Bytes
IP              31         ;Interpolate Point
IP              18         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04c5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_2   21 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   40 5 10   ;PUSH Bytes
CALL            10 5 40    ;CALL function
                           #--- PUSHB_4   64 40 25 9 ;PUSH Bytes
CALL            9 25 40 64 ;CALL function
                           #--- PUSHB_3   5 40 10   ;PUSH Bytes
CALL            10 40 5    ;CALL function
                           #--- PUSHB_4   0 5 0 9   ;PUSH Bytes
CALL            9 0 5 0    ;CALL function
                           #--- PUSHB_3   15 2 0    ;PUSH Bytes
CALL            0 2 15     ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   20 35     ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDRP[rp0,rnd,white] 43         ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 37 10   ;PUSH Bytes
CALL            10 37 8    ;CALL function
                           #--- PUSHB_4   64 8 12 9 ;PUSH Bytes
CALL            9 12 8 64  ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 34 10  ;PUSH Bytes
CALL            10 34 21   ;CALL function
                           #--- PUSHB_4   64 21 18 9 ;PUSH Bytes
CALL            9 18 21 64 ;CALL function
                           #--- PUSHB_4   26 21 34 8 ;PUSH Bytes
CALL            8 34 21 26 ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_5   30 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   8 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04c6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   21 5      ;PUSH Bytes
MIRP[min,black] cvt_5 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 21 10   ;PUSH Bytes
CALL            10 21 0    ;CALL function
                           #--- PUSHB_4   64 0 38 9 ;PUSH Bytes
CALL            9 38 0 64  ;CALL function
                           #--- PUSHB_3   21 0 10   ;PUSH Bytes
CALL            10 0 21    ;CALL function
                           #--- PUSHB_4   64 21 14 9 ;PUSH Bytes
CALL            9 14 21 64 ;CALL function
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 32      ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   23 6 10   ;PUSH Bytes
CALL            10 6 23    ;CALL function
                           #--- PUSHB_4   64 23 26 9 ;PUSH Bytes
CALL            9 26 23 64 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 33 10   ;PUSH Bytes
CALL            10 33 3    ;CALL function
                           #--- PUSHB_4   64 3 2 9  ;PUSH Bytes
CALL            9 2 3 64   ;CALL function
                           #--- PUSHB_4   39 33 3 8 ;PUSH Bytes
CALL            8 3 33 39  ;CALL function
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   23 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04c7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 0 0    ;PUSH Bytes
CALL            0 0 23     ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   39 43 54  ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
SHP[rp2]        43         ;SHift Point using reference point
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   12 5      ;PUSH Bytes
MIRP[min,black] cvt_5 12   ;Move Indirect Relative Point
                           #--- PUSHB_5   17 41 23 35 13 ;PUSH Bytes
CALL            13 35 23 41 17 ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_4   9 29 32 14 ;PUSH Bytes
CALL            14 32 29 9 ;CALL function
                           #--- PUSHB_5   38 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 38 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_5   25 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   9 0 52 14 ;PUSH Bytes
CALL            14 52 0 9  ;CALL function
                           #--- PUSHB_5   46 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   52 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 52 ;CALL function
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   38 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   9 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   7 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04c8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 33 42  ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_5   10 31 16 25 13 ;PUSH Bytes
CALL            13 25 16 31 10 ;CALL function
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_5   28 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 28 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_4   11 28 22 8 ;PUSH Bytes
CALL            8 22 28 11 ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 8 10   ;PUSH Bytes
CALL            10 8 43    ;CALL function
                           #--- PUSHB_4   64 43 41 9 ;PUSH Bytes
CALL            9 41 43 64 ;CALL function
                           #--- PUSHB_3   8 43 10   ;PUSH Bytes
CALL            10 43 8    ;CALL function
                           #--- PUSHB_4   64 8 35 9 ;PUSH Bytes
CALL            9 35 8 64  ;CALL function
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   28 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   2 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   0 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04c9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 6 43    ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   11 16 10  ;PUSH Bytes
CALL            10 16 11   ;CALL function
                           #--- PUSHB_4   64 11 47 9 ;PUSH Bytes
CALL            9 47 11 64 ;CALL function
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 31 42  ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_5   29 5 47 23 13 ;PUSH Bytes
CALL            13 23 47 5 29 ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_4   9 17 20 14 ;PUSH Bytes
CALL            14 20 17 9 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   9 43 40 14 ;PUSH Bytes
CALL            14 40 43 9 ;CALL function
                           #--- PUSHB_5   34 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_4   48 43 3 8 ;PUSH Bytes
CALL            8 3 43 48  ;CALL function
                           #--- PUSHB_2   45 6      ;PUSH Bytes
MIRP[min,black] stemw 45   ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04ca': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 23 26  ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   31 34 10  ;PUSH Bytes
CALL            10 34 31   ;CALL function
                           #--- PUSHB_4   64 31 17 9 ;PUSH Bytes
CALL            9 17 31 64 ;CALL function
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 11    ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   1 25 17 38 13 ;PUSH Bytes
CALL            13 38 17 25 1 ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_5   28 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 28 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_4   26 28 33 8 ;PUSH Bytes
CALL            8 33 28 26 ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   14 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 14 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_4   12 14 22 8 ;PUSH Bytes
CALL            8 22 14 12 ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 12 10  ;PUSH Bytes
CALL            10 12 23   ;CALL function
                           #--- PUSHB_4   64 23 5 9 ;PUSH Bytes
CALL            9 5 23 64  ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04cb': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_5   1 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 1  ;CALL function
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 29 39  ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_5   7 26 1 18 13 ;PUSH Bytes
CALL            13 18 1 26 7 ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 13 16 14 ;PUSH Bytes
CALL            14 16 13 9 ;CALL function
                           #--- PUSHB_5   21 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 21 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_4   46 40 4 8 ;PUSH Bytes
CALL            8 4 40 46  ;CALL function
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_5   37 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 37 ;CALL function
                           #--- PUSHB_5   43 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 43 ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   2 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   7 26      ;PUSH Bytes
IP              26         ;Interpolate Point
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04cc': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   39 0 0    ;PUSH Bytes
CALL            0 0 39     ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   39 35 10  ;PUSH Bytes
CALL            10 35 39   ;CALL function
                           #--- PUSHB_4   64 39 43 9 ;PUSH Bytes
CALL            9 43 39 64 ;CALL function
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp1]        29         ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 25 34  ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_5   21 3 43 12 13 ;PUSH Bytes
CALL            13 12 43 3 21 ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 6 9 14  ;PUSH Bytes
CALL            14 9 6 9   ;CALL function
                           #--- PUSHB_5   15 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 15 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_5   37 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 37 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_4   35 37 45 8 ;PUSH Bytes
CALL            8 45 37 35 ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   45 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   3 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
                           #--- PUSHB_2   12 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04cd': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_2   19 4      ;PUSH Bytes
MIRP[min,black] stemt 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 9 36    ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   16 19 10  ;PUSH Bytes
CALL            10 19 16   ;CALL function
                           #--- PUSHB_4   64 16 40 9 ;PUSH Bytes
CALL            9 40 16 64 ;CALL function
                           #--- PUSHB_3   31 2 0    ;PUSH Bytes
CALL            0 2 31     ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 9 10   ;PUSH Bytes
CALL            10 9 19    ;CALL function
                           #--- PUSHB_4   64 19 22 9 ;PUSH Bytes
CALL            9 22 19 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_4   8 19 18 14 ;PUSH Bytes
CALL            14 18 19 8 ;CALL function
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 4 10   ;PUSH Bytes
CALL            10 4 36    ;CALL function
                           #--- PUSHB_4   64 36 33 9 ;PUSH Bytes
CALL            9 33 36 64 ;CALL function
                           #--- PUSHB_4   41 36 4 8 ;PUSH Bytes
CALL            8 4 36 41  ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   9 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   6 7 29    ;PUSH Bytes
IP              29         ;Interpolate Point
IP              7          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   5 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04ce': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   33 4      ;PUSH Bytes
MIRP[min,black] stemt 33   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 17 24   ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   29 33 10  ;PUSH Bytes
CALL            10 33 29   ;CALL function
                           #--- PUSHB_4   64 29 10 9 ;PUSH Bytes
CALL            9 10 29 64 ;CALL function
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 18 22   ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 33 31 14 ;PUSH Bytes
CALL            14 31 33 9 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 5 10   ;PUSH Bytes
CALL            10 5 17    ;CALL function
                           #--- PUSHB_4   64 17 15 9 ;PUSH Bytes
CALL            9 15 17 64 ;CALL function
                           #--- PUSHB_4   11 5 17 8 ;PUSH Bytes
CALL            8 17 5 11  ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   26 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_3   21 39 41  ;PUSH Bytes
IP              41         ;Interpolate Point
IP              39         ;Interpolate Point
IP              21         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   20 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04d8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 0 0    ;PUSH Bytes
CALL            0 0 30     ;CALL function
                           #--- PUSHB_2   40 5      ;PUSH Bytes
MIRP[min,black] cvt_5 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 2 0    ;PUSH Bytes
CALL            0 2 20     ;CALL function
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 20 10   ;PUSH Bytes
CALL            10 20 5    ;CALL function
                           #--- PUSHB_4   0 5 10 9  ;PUSH Bytes
CALL            9 10 5 0   ;CALL function
                           #--- PUSHB_5   1 37 30 20 13 ;PUSH Bytes
CALL            13 20 30 37 1 ;CALL function
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 24 10  ;PUSH Bytes
CALL            10 24 36   ;CALL function
                           #--- PUSHB_4   64 36 0 9 ;PUSH Bytes
CALL            9 0 36 64  ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04f6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   33 24 10  ;PUSH Bytes
CALL            10 24 33   ;CALL function
                           #--- PUSHB_4   0 33 31 9 ;PUSH Bytes
CALL            9 31 33 0  ;CALL function
                           #--- PUSHB_3   14 2 0    ;PUSH Bytes
CALL            0 2 14     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   14 2 0    ;PUSH Bytes
CALL            0 2 14     ;CALL function
                           #--- PUSHB_5   19 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 19 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 24 10   ;PUSH Bytes
CALL            10 24 6    ;CALL function
                           #--- PUSHB_4   64 6 2 9  ;PUSH Bytes
CALL            9 2 6 64   ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] stemw 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni04f7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   14 17 10  ;PUSH Bytes
CALL            10 17 14   ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_5   0 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   17 6 10   ;PUSH Bytes
CALL            10 6 17    ;CALL function
                           #--- PUSHB_4   64 17 16 9 ;PUSH Bytes
CALL            9 16 17 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_4   12 6 17 8 ;PUSH Bytes
CALL            8 17 6 12  ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0510': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 0 0    ;PUSH Bytes
CALL            0 0 30     ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   26 0 0    ;PUSH Bytes
CALL            0 0 26     ;CALL function
                           #--- PUSHB_5   20 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 20 ;CALL function
                           #--- PUSHB_3   41 2 0    ;PUSH Bytes
CALL            0 2 41     ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   63 4      ;PUSH Bytes
MIRP[min,black] stemt 63   ;Move Indirect Relative Point
                           #--- PUSHB_3   63 41 10  ;PUSH Bytes
CALL            10 41 63   ;CALL function
                           #--- PUSHB_4   64 63 52 9 ;PUSH Bytes
CALL            9 52 63 64 ;CALL function
                           #--- PUSHB_5   3 68 30 41 13 ;PUSH Bytes
CALL            13 41 30 68 3 ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_2   65 6      ;PUSH Bytes
MIRP[min,black] stemw 65   ;Move Indirect Relative Point
                           #--- PUSHB_3   65 38 10  ;PUSH Bytes
CALL            10 38 65   ;CALL function
                           #--- PUSHB_4   64 65 0 9 ;PUSH Bytes
CALL            9 0 65 64  ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_1   33        ;PUSH Bytes
                           #--- DUP       #33       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP0            65         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   50 6      ;PUSH Bytes
MIRP[min,black] stemw 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
                           #--- DUP       #12       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_2   6 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   60 65     ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_6   2 9 30 3 41 69 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              69 41 3 30 9 2 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_5   20 26 28 46 52 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              52 46 28 26 20 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   6 33      ;PUSH Bytes
IP              33         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   68 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0511': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_5   55 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 55 ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_5   28 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 28 ;CALL function
                           #--- PUSHB_5   40 45 7 19 13 ;PUSH Bytes
CALL            13 19 7 45 40 ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   48 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   13 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              13         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_2   48 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              48         ;Interpolate Point
                           #--- PUSHB_2   40 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   14 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   34 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   16 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0513': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   26 5      ;PUSH Bytes
MIRP[min,black] cvt_5 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 13 10  ;PUSH Bytes
CALL            10 13 26   ;CALL function
                           #--- PUSHB_4   0 26 19 9 ;PUSH Bytes
CALL            9 19 26 0  ;CALL function
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_2   9 37      ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 11 10  ;PUSH Bytes
CALL            10 11 28   ;CALL function
                           #--- PUSHB_4   64 28 31 9 ;PUSH Bytes
CALL            9 31 28 64 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 8 10   ;PUSH Bytes
CALL            10 8 38    ;CALL function
                           #--- PUSHB_4   64 38 35 9 ;PUSH Bytes
CALL            9 35 38 64 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   28 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_2   8 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   2 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni051a': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 40 10   ;PUSH Bytes
CALL            10 40 5    ;CALL function
                           #--- PUSHB_4   0 5 0 9   ;PUSH Bytes
CALL            9 0 5 0    ;CALL function
                           #--- PUSHB_3   13 2 0    ;PUSH Bytes
CALL            0 2 13     ;CALL function
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_2   18 35     ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 5      ;PUSH Bytes
MIRP[min,black] cvt_5 31   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
MDRP[rp0,rnd,white] 43         ;Move Direct Relative Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   7 37 10   ;PUSH Bytes
CALL            10 37 7    ;CALL function
                           #--- PUSHB_4   64 7 10 9 ;PUSH Bytes
CALL            9 10 7 64  ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 34 10  ;PUSH Bytes
CALL            10 34 19   ;CALL function
                           #--- PUSHB_4   64 19 16 9 ;PUSH Bytes
CALL            9 16 19 64 ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   7 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_2   28 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   26 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni051e': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 55     ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_3   23 29 10  ;PUSH Bytes
CALL            10 29 23   ;CALL function
                           #--- PUSHB_4   64 23 62 9 ;PUSH Bytes
CALL            9 62 23 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_3   10 21 10  ;PUSH Bytes
CALL            10 21 10   ;CALL function
                           #--- PUSHB_4   64 10 13 9 ;PUSH Bytes
CALL            9 13 10 64 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   21 10 10  ;PUSH Bytes
CALL            10 10 21   ;CALL function
                           #--- PUSHB_4   64 21 17 9 ;PUSH Bytes
CALL            9 17 21 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_5   53 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 53 ;CALL function
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   47 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   41 66     ;PUSH Bytes
IP              66         ;Interpolate Point
IP              41         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_5   44 6 45 65 69 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              69 65 45 6 44 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_5   9 35 38 44 65 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              65 44 38 35 9 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_2   41 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              41         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni051f': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   16 21 10  ;PUSH Bytes
CALL            10 21 16   ;CALL function
                           #--- PUSHB_4   64 16 47 9 ;PUSH Bytes
CALL            9 47 16 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_5   22 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 22 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_4   8 23 24 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 24 23 8 ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E01': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 0       ;PUSH Bytes
MIAP[rnd]       cvt_0 0    ;Move Indirect Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_2   22 1      ;PUSH Bytes
MIAP[rnd]       vheight 22 ;Move Indirect Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[rp0,min,rnd,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_4   14 0 22 8 ;PUSH Bytes
CALL            8 22 0 14  ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[min,rnd,black] 8          ;Move Direct Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[rp0,min,rnd,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,min,rnd,grey] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[rp0,min,rnd,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   14 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_7   5 6 10 11 12 22 23 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              23 22 12 11 10 6 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E02': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_2   15 5      ;PUSH Bytes
MIRP[min,black] cvt_5 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_5   41 22 1 28 13 ;PUSH Bytes
CALL            13 28 1 22 41 ;CALL function
                           #--- PUSHB_5   41 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 41 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_5   50 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_5   19 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 37 10   ;PUSH Bytes
CALL            10 37 6    ;CALL function
                           #--- PUSHB_4   64 6 3 9  ;PUSH Bytes
CALL            9 3 6 64   ;CALL function
                           #--- PUSHB_4   12 37 6 8 ;PUSH Bytes
CALL            8 6 37 12  ;CALL function
                           #--- PUSHB_5   31 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 31 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   44 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   15 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   9 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_6   12 19 25 31 44 50 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              50 44 31 25 19 12 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E03': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_2   45 4      ;PUSH Bytes
MIRP[min,black] stemt 45   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_2   25 27     ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_5   0 19 41 25 13 ;PUSH Bytes
CALL            13 25 41 19 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   16 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   46 11     ;PUSH Bytes
CALL            11 46      ;CALL function
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_3   46 36 10  ;PUSH Bytes
CALL            10 36 46   ;CALL function
                           #--- PUSHB_4   64 46 43 9 ;PUSH Bytes
CALL            9 43 46 64 ;CALL function
                           #--- PUSHB_4   52 36 46 8 ;PUSH Bytes
CALL            8 46 36 52 ;CALL function
                           #--- PUSHB_5   30 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 30 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   12 19 25 57 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              57 25 19 12 ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   26 56     ;PUSH Bytes
IP              56         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   32 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_7   6 16 22 26 30 49 57 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              57 49 30 26 22 16 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E04': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_3   49 1 0    ;PUSH Bytes
CALL            0 1 49     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_5   33 0 40 49 13 ;PUSH Bytes
CALL            13 49 40 0 33 ;CALL function
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
                           #--- PUSHB_5   27 6 40 49 13 ;PUSH Bytes
CALL            13 49 40 6 27 ;CALL function
                           #--- PUSHB_5   27 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 27 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
                           #--- DUP       #46       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   30 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   39 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_5   9 17 27 33 49 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              49 33 27 17 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   36 43 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              43         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   23 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E05': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_3   48 1 0    ;PUSH Bytes
CALL            0 1 48     ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp1]        50         ;SHift Point using reference point
                           #--- PUSHB_5   33 0 40 48 13 ;PUSH Bytes
CALL            13 48 40 0 33 ;CALL function
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
                           #--- PUSHB_5   27 6 40 48 13 ;PUSH Bytes
CALL            13 48 40 6 27 ;CALL function
                           #--- PUSHB_5   27 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 27 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
                           #--- DUP       #46       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   20 6      ;PUSH Bytes
MIRP[min,black] stemw 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   30 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   39 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_3   18 23 48  ;PUSH Bytes
IP              48         ;Interpolate Point
IP              23         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_5   9 17 27 33 49 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              49 33 27 17 9 ;Interpolate Point
                           #--- PUSHB_2   13 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   16 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   36 43 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              43         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   23 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_4   17 18 16 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 16 18 17 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E06': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   66 0 0    ;PUSH Bytes
CALL            0 0 66     ;CALL function
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_3   63 1 0    ;PUSH Bytes
CALL            0 1 63     ;CALL function
                           #--- PUSHB_2   49 51     ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
SHP[rp1]        49         ;SHift Point using reference point
                           #--- PUSHB_5   0 21 15 49 13 ;PUSH Bytes
CALL            13 49 15 21 0 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_5   68 43 15 49 13 ;PUSH Bytes
CALL            13 49 15 43 68 ;CALL function
                           #--- PUSHB_5   68 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 68 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
                           #--- PUSHB_5   77 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 77 ;CALL function
                           #--- PUSHB_1   77        ;PUSH Bytes
SRP0            77         ;Set Reference Point 0
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_5   40 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 40 ;CALL function
                           #--- PUSHB_4   3 40 71 8 ;PUSH Bytes
CALL            8 71 40 3  ;CALL function
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_5   54 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 54 ;CALL function
                           #--- PUSHB_4   60 54 29 8 ;PUSH Bytes
CALL            8 29 54 60 ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   60 6      ;PUSH Bytes
MIRP[min,black] stemw 60   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP0            60         ;Set Reference Point 0
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   65 6      ;PUSH Bytes
MIRP[min,black] stemw 65   ;Move Indirect Relative Point
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_2   71 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_6   34 37 43 49 68 74 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              74 68 49 43 37 34 ;Interpolate Point
                           #--- PUSHB_2   40 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   0 6 33 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 33 6 0  ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   26 32     ;PUSH Bytes
IP              32         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_2   62 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_1   66        ;PUSH Bytes
IP              66         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   12 18 62  ;PUSH Bytes
IP              62         ;Interpolate Point
IP              18         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_2   68 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_2   56 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              56         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_7   26 34 40 46 50 54 74 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              74 54 50 46 40 34 26 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E07': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_5   0 32 13 38 13 ;PUSH Bytes
CALL            13 38 13 32 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   29 42 10  ;PUSH Bytes
CALL            10 42 29   ;CALL function
                           #--- PUSHB_4   64 29 18 9 ;PUSH Bytes
CALL            9 18 29 64 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   29 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_4   6 0 32 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 32 0 6  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   15 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E08': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_3   43 1 0    ;PUSH Bytes
CALL            0 1 43     ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 43 10  ;PUSH Bytes
CALL            10 43 32   ;CALL function
                           #--- PUSHB_4   0 32 38 9 ;PUSH Bytes
CALL            9 38 32 0  ;CALL function
                           #--- PUSHB_5   16 0 13 43 13 ;PUSH Bytes
CALL            13 43 13 0 16 ;CALL function
                           #--- PUSHB_5   16 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 16 ;CALL function
                           #--- PUSHB_5   6 22 38 43 13 ;PUSH Bytes
CALL            13 43 38 22 6 ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   25 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   36 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_5   13 16 22 32 43 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              43 32 22 16 13 ;Interpolate Point
                           #--- PUSHB_2   29 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   29 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E09': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_3   30 0 0    ;PUSH Bytes
CALL            0 0 30     ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_3   71 1 0    ;PUSH Bytes
CALL            0 1 71     ;CALL function
                           #--- PUSHB_2   57 4      ;PUSH Bytes
MIRP[min,black] stemt 57   ;Move Indirect Relative Point
                           #--- PUSHB_5   41 12 30 71 13 ;PUSH Bytes
CALL            13 71 30 12 41 ;CALL function
                           #--- PUSHB_5   41 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 41 ;CALL function
                           #--- PUSHB_5   47 18 30 71 13 ;PUSH Bytes
CALL            13 71 30 18 47 ;CALL function
                           #--- PUSHB_5   47 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 47 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   50 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
                           #--- DUP       #33       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_4   3 24 53 8 ;PUSH Bytes
CALL            8 53 24 3  ;CALL function
                           #--- PUSHB_5   27 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 27 ;CALL function
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   21 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   66        ;PUSH Bytes
IP              66         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_5   38 41 47 60 61 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              61 60 47 41 38 ;Interpolate Point
                           #--- PUSHB_2   33 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_3   37 57 71  ;PUSH Bytes
IP              71         ;Interpolate Point
IP              57         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_5   6 27 33 35 51 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              51 35 33 27 6 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_3   24 52 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              52         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
                           #--- PUSHB_2   57 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
                           #--- PUSHB_3   58 1 0    ;PUSH Bytes
CALL            0 1 58     ;CALL function
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_3   58 6 10   ;PUSH Bytes
CALL            10 6 58    ;CALL function
                           #--- PUSHB_4   64 58 18 9 ;PUSH Bytes
CALL            9 18 58 64 ;CALL function
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_5   0 52 31 18 13 ;PUSH Bytes
CALL            13 18 31 52 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDRP[rp0,rnd,white] 55         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   49 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   71 6      ;PUSH Bytes
MIRP[min,black] stemw 71   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 71 10  ;PUSH Bytes
CALL            10 71 36   ;CALL function
                           #--- PUSHB_4   64 36 33 9 ;PUSH Bytes
CALL            9 33 36 64 ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_1   21        ;PUSH Bytes
                           #--- DUP       #21       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   30 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   18 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   67        ;PUSH Bytes
IP              67         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_3   39 40 65  ;PUSH Bytes
IP              65         ;Interpolate Point
IP              40         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_5   12 26 42 49 55 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              55 49 42 26 12 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp2]        68         ;SHift Point using reference point
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_3   53 1 0    ;PUSH Bytes
CALL            0 1 53     ;CALL function
                           #--- PUSHB_3   59 1 0    ;PUSH Bytes
CALL            0 1 59     ;CALL function
                           #--- PUSHB_5   0 39 13 45 13 ;PUSH Bytes
CALL            13 45 13 39 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   79        ;PUSH Bytes
MDAP[rnd]       79         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   36 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   18 11     ;PUSH Bytes
CALL            11 18      ;CALL function
                           #--- PUSHB_2   78 6      ;PUSH Bytes
MIRP[min,black] stemw 78   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 78 10  ;PUSH Bytes
CALL            10 78 18   ;CALL function
                           #--- PUSHB_4   64 18 15 9 ;PUSH Bytes
CALL            9 15 18 64 ;CALL function
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP0            78         ;Set Reference Point 0
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_1   59        ;PUSH Bytes
                           #--- DUP       #59       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 59         ;Move Direct Relative Point
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_2   53 6      ;PUSH Bytes
MIRP[min,black] stemw 53   ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_2   80 1      ;PUSH Bytes
CALL            1 80       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   29 32 39 45 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              45 39 32 29 ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   28 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP2            78         ;Set Reference Point 2
                           #--- PUSHB_3   24 27 47  ;PUSH Bytes
IP              47         ;Interpolate Point
IP              27         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
                           #--- PUSHB_2   12 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   56 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              56         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 39      ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   74 75     ;PUSH Bytes
IP              75         ;Interpolate Point
IP              74         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- NPUSHB    9 6 21 29 36 42 46 50 64 72 ;PUSH N Bytes
                           #--- DEPTH     #9        ;DEPTH of the stack
SLOOP           9          ;Set LOOP variable
IP              72 64 50 46 42 36 29 21 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 0 0    ;PUSH Bytes
CALL            0 0 25     ;CALL function
                           #--- PUSHB_3   58 0 0    ;PUSH Bytes
CALL            0 0 58     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   74 1 0    ;PUSH Bytes
CALL            0 1 74     ;CALL function
                           #--- PUSHB_3   67 1 0    ;PUSH Bytes
CALL            0 1 67     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_5   12 52 58 67 13 ;PUSH Bytes
CALL            13 67 58 52 12 ;CALL function
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   44 49 58 67 13 ;PUSH Bytes
CALL            13 67 58 49 44 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp1]        62         ;SHift Point using reference point
                           #--- PUSHB_5   44 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 44 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_1   61        ;PUSH Bytes
MDRP[rp0,rnd,white] 61         ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 15 ;CALL function
                           #--- PUSHB_2   50 6      ;PUSH Bytes
MIRP[min,black] stemw 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   55 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   71 6      ;PUSH Bytes
MIRP[min,black] stemw 71   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 71 36 8 ;PUSH Bytes
CALL            8 36 71 9  ;CALL function
                           #--- PUSHB_5   33 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp2]        73         ;SHift Point using reference point
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   15 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   18 12 52  ;PUSH Bytes
IP              52         ;Interpolate Point
IP              12         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_3   40 46 67  ;PUSH Bytes
IP              67         ;Interpolate Point
IP              46         ;Interpolate Point
IP              40         ;Interpolate Point
                           #--- PUSHB_2   71 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_2   3 30      ;PUSH Bytes
IP              30         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   27 33 55 73 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              73 55 33 27 ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_2   36 71     ;PUSH Bytes
IP              71         ;Interpolate Point
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_5   61 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 61 ;CALL function
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_5   77 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 77 ;CALL function
                           #--- PUSHB_3   58 1 0    ;PUSH Bytes
CALL            0 1 58     ;CALL function
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   73 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 73 ;CALL function
                           #--- PUSHB_5   67 50 77 58 13 ;PUSH Bytes
CALL            13 58 77 50 67 ;CALL function
                           #--- PUSHB_5   67 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 67 ;CALL function
                           #--- PUSHB_5   35 40 77 58 13 ;PUSH Bytes
CALL            13 58 77 40 35 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp1]        53         ;SHift Point using reference point
                           #--- PUSHB_5   35 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 35 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   83        ;PUSH Bytes
MDAP[rnd]       83         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
                           #--- PUSHB_5   70 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 70 ;CALL function
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP0            70         ;Set Reference Point 0
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_5   41 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 41 ;CALL function
                           #--- PUSHB_1   80        ;PUSH Bytes
SHP[rp2]        80         ;SHift Point using reference point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   84 1      ;PUSH Bytes
CALL            1 84       ;CALL function
                           #--- PUSHB_2   52 70     ;PUSH Bytes
SRP1            70         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_4   44 50 61 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              67 61 50 44 ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_7   2 6 12 31 37 58 75 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              75 58 37 31 12 6 2 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   73 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            73         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   77        ;PUSH Bytes
SRP1            77         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   25 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_2   61 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0D.descless': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   48 4      ;PUSH Bytes
MIRP[min,black] stemt 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   50 1 0    ;PUSH Bytes
CALL            0 1 50     ;CALL function
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_5   0 29 35 44 13 ;PUSH Bytes
CALL            13 44 35 29 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_5   21 26 35 44 13 ;PUSH Bytes
CALL            13 44 35 26 21 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 3 ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   3 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   6 0 29    ;PUSH Bytes
IP              29         ;Interpolate Point
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_3   17 23 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              23         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_5   90 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 90 ;CALL function
                           #--- PUSHB_3   17 90 10  ;PUSH Bytes
CALL            10 90 17   ;CALL function
                           #--- PUSHB_4   64 17 23 9 ;PUSH Bytes
CALL            9 23 17 64 ;CALL function
                           #--- PUSHB_3   57 0 0    ;PUSH Bytes
CALL            0 0 57     ;CALL function
                           #--- PUSHB_5   74 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 74 ;CALL function
                           #--- PUSHB_3   71 1 0    ;PUSH Bytes
CALL            0 1 71     ;CALL function
                           #--- PUSHB_2   44 4      ;PUSH Bytes
MIRP[min,black] stemt 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   86 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 86 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_5   80 63 17 71 13 ;PUSH Bytes
CALL            13 71 17 63 80 ;CALL function
                           #--- PUSHB_5   80 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 80 ;CALL function
                           #--- PUSHB_5   48 53 17 71 13 ;PUSH Bytes
CALL            13 71 17 53 48 ;CALL function
                           #--- PUSHB_1   66        ;PUSH Bytes
SHP[rp1]        66         ;SHift Point using reference point
                           #--- PUSHB_5   48 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 48 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   96        ;PUSH Bytes
MDAP[rnd]       96         ;Move Direct Absolute Point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDRP[rp0,rnd,white] 60         ;Move Direct Relative Point
                           #--- PUSHB_5   83 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 83 ;CALL function
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP0            83         ;Set Reference Point 0
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_5   54 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 54 ;CALL function
                           #--- PUSHB_4   93 54 77 8 ;PUSH Bytes
CALL            8 77 54 93 ;CALL function
                           #--- PUSHB_5   14 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   93 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 93 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   65 6      ;PUSH Bytes
MIRP[min,black] stemw 65   ;Move Indirect Relative Point
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   97 1      ;PUSH Bytes
CALL            1 97       ;CALL function
                           #--- PUSHB_2   65 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_4   57 63 74 80 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              80 74 63 57 ;Interpolate Point
                           #--- PUSHB_1   77        ;PUSH Bytes
SRP1            77         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_2   54 93     ;PUSH Bytes
SRP1            93         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_4   11 19 17 88 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              88 17 19 11 ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_7   2 9 26 30 44 50 71 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              71 50 44 30 26 9 2 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   86 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            86         ;Set Reference Point 2
                           #--- PUSHB_2   4 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   90        ;PUSH Bytes
SRP1            90         ;Set Reference Point 1
                           #--- PUSHB_2   14 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   17 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   19 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_2   80 74     ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
SRP2            80         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E10': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   45 1 0    ;PUSH Bytes
CALL            0 1 45     ;CALL function
                           #--- PUSHB_2   37 39     ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   49 31 11 45 13 ;PUSH Bytes
CALL            13 45 11 31 49 ;CALL function
                           #--- PUSHB_5   49 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 49 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_5   58 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 58 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_5   28 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   11 11     ;PUSH Bytes
CALL            11 11      ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   52 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_4   22 31 37 25 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              25 37 31 22 ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   21 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_3   17 20 39  ;PUSH Bytes
IP              39         ;Interpolate Point
IP              20         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 49      ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_5   14 17 28 34 55 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              55 34 28 17 14 ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_5   20 22 26 38 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              42 38 26 22 20 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E10.descless': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_1   46        ;PUSH Bytes
                           #--- DUP       #46       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   41 4      ;PUSH Bytes
MIRP[min,black] stemt 41   ;Move Indirect Relative Point
                           #--- PUSHB_5   16 0 13 38 13 ;PUSH Bytes
CALL            13 38 13 0 16 ;CALL function
                           #--- PUSHB_5   16 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 16 ;CALL function
                           #--- PUSHB_5   6 22 13 38 13 ;PUSH Bytes
CALL            13 38 13 22 6 ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_5   53 34 13 38 13 ;PUSH Bytes
CALL            13 38 13 34 53 ;CALL function
                           #--- PUSHB_5   53 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 53 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   25 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   57 6      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   9 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_3   13 16 22  ;PUSH Bytes
IP              22         ;Interpolate Point
IP              16         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   38 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_2   12 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_2   41 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   44        ;PUSH Bytes
IP              44         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E12': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   56 0 0    ;PUSH Bytes
CALL            0 0 56     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_3   23 0 0    ;PUSH Bytes
CALL            0 0 23     ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_2   62 64     ;PUSH Bytes
SHP[rp1]        64         ;SHift Point using reference point
SHP[rp1]        62         ;SHift Point using reference point
                           #--- PUSHB_5   47 67 23 62 13 ;PUSH Bytes
CALL            13 62 23 67 47 ;CALL function
                           #--- PUSHB_5   47 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 47 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   79        ;PUSH Bytes
MDAP[rnd]       79         ;Move Direct Absolute Point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDRP[rp0,rnd,white] 60         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_5   70 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 70 ;CALL function
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP0            70         ;Set Reference Point 0
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_5   50 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_4   9 12 29 8 ;PUSH Bytes
CALL            8 29 12 9  ;CALL function
                           #--- PUSHB_5   26 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   80 1      ;PUSH Bytes
CALL            1 80       ;CALL function
                           #--- PUSHB_2   36 60     ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   56        ;PUSH Bytes
IP              56         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   62        ;PUSH Bytes
IP              62         ;Interpolate Point
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_5   38 34 41 54 55 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              55 54 41 34 38 ;Interpolate Point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
                           #--- PUSHB_2   63 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              63         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_2   32 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   3 23      ;PUSH Bytes
IP              23         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   67 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            67         ;Set Reference Point 2
                           #--- NPUSHB    13 6 12 14 20 26 29 38 39 41 50 54 59 73 ;PUSH N Bytes
                           #--- DEPTH     #13       ;DEPTH of the stack
SLOOP           13         ;Set LOOP variable
IP              73 59 54 50 41 39 38 29 26 20 14 12 6 ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_4   32 33 34 63 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              63 34 33 32 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E13': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp1]        59         ;SHift Point using reference point
                           #--- PUSHB_5   72 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 72 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   51 1 0    ;PUSH Bytes
CALL            0 1 51     ;CALL function
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_5   66 29 35 44 13 ;PUSH Bytes
CALL            13 44 35 29 66 ;CALL function
                           #--- PUSHB_5   66 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 66 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   21 26 35 44 13 ;PUSH Bytes
CALL            13 44 35 26 21 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_5   69 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 69 ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP0            69         ;Set Reference Point 0
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   53 6      ;PUSH Bytes
MIRP[min,black] stemw 53   ;Move Indirect Relative Point
                           #--- PUSHB_1   62        ;PUSH Bytes
                           #--- DUP       #62       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 62         ;Move Direct Relative Point
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_4   3 53 50 8 ;PUSH Bytes
CALL            8 50 53 3  ;CALL function
                           #--- PUSHB_5   56 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 56 ;CALL function
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   69 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP2            75         ;Set Reference Point 2
                           #--- PUSHB_5   17 29 44 66 72 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              72 66 44 29 17 ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   66 72     ;PUSH Bytes
SRP1            72         ;Set Reference Point 1
SRP2            66         ;Set Reference Point 2
                           #--- PUSHB_4   32 56 62 64 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              64 62 56 32 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_3   48 50 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              50         ;Interpolate Point
IP              48         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E14': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_5   19 40 29 36 13 ;PUSH Bytes
CALL            13 36 29 40 19 ;CALL function
                           #--- PUSHB_5   19 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 19 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_5   43 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_5   22 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   8 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   11 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_3   26 36 5   ;PUSH Bytes
IP              5          ;Interpolate Point
IP              36         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_6   10 11 13 22 32 46 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              46 32 22 13 11 10 ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E15': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_5   19 40 29 35 13 ;PUSH Bytes
CALL            13 35 29 40 19 ;CALL function
                           #--- PUSHB_5   19 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 19 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_5   43 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_5   22 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   8 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_4   6 11 28 35 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              35 28 11 6 ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_3   26 36 5   ;PUSH Bytes
IP              5          ;Interpolate Point
IP              36         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   4 37      ;PUSH Bytes
IP              37         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_6   10 11 13 22 32 46 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              46 32 22 13 11 10 ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_4   5 6 4 36  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 4 6 5   ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E16': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_5   42 18 24 33 13 ;PUSH Bytes
CALL            13 33 24 18 42 ;CALL function
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_5   10 15 24 33 13 ;PUSH Bytes
CALL            13 33 24 15 10 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_5   10 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_5   45 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 45 ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   45 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_3   18 36 42  ;PUSH Bytes
IP              42         ;Interpolate Point
IP              36         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   6 33      ;PUSH Bytes
IP              33         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E17': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_5   39 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 39 ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_2   26 5      ;PUSH Bytes
MIRP[min,black] cvt_5 26   ;Move Indirect Relative Point
                           #--- PUSHB_5   33 2 32 8 13 ;PUSH Bytes
CALL            13 8 32 2 33 ;CALL function
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   42 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 42 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_5   36 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   32 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_4   2 8 33 39 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              39 33 8 2  ;Interpolate Point
                           #--- PUSHB_2   22 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_2   39 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_3   5 36 42   ;PUSH Bytes
IP              42         ;Interpolate Point
IP              36         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E18': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 1 10    ;PUSH Bytes
CALL            10 1 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_1   21        ;PUSH Bytes
                           #--- DUP       #21       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   28 9 1 13 13 ;PUSH Bytes
CALL            13 13 1 9 28 ;CALL function
                           #--- PUSHB_5   28 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 28 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   4 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   13 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   16 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E19': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 0 0    ;PUSH Bytes
CALL            0 0 31     ;CALL function
                           #--- PUSHB_3   23 0 0    ;PUSH Bytes
CALL            0 0 23     ;CALL function
                           #--- PUSHB_5   44 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 44 ;CALL function
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   38 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 38 ;CALL function
                           #--- PUSHB_5   28 14 23 8 13 ;PUSH Bytes
CALL            13 8 23 14 28 ;CALL function
                           #--- PUSHB_5   28 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 28 ;CALL function
                           #--- PUSHB_5   32 2 23 8 13 ;PUSH Bytes
CALL            13 8 23 2 32 ;CALL function
                           #--- PUSHB_5   32 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 32 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_5   35 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
                           #--- DUP       #26       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_5   53 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 53 ;CALL function
                           #--- PUSHB_4   47 17 14 8 ;PUSH Bytes
CALL            8 14 17 47 ;CALL function
                           #--- PUSHB_5   20 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 20 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   31 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_3   8 32 38   ;PUSH Bytes
IP              38         ;Interpolate Point
IP              32         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   12 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   47 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   26 20 47 53 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              53 47 20 26 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_3   12 17 50  ;PUSH Bytes
IP              50         ;Interpolate Point
IP              17         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   32 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_5   23 2 17 8 13 ;PUSH Bytes
CALL            13 8 17 2 23 ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 12 10  ;PUSH Bytes
CALL            10 12 22   ;CALL function
                           #--- PUSHB_4   64 22 19 9 ;PUSH Bytes
CALL            9 19 22 64 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   22 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   8 23 29   ;PUSH Bytes
IP              29         ;Interpolate Point
IP              23         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   14 2 0    ;PUSH Bytes
CALL            0 2 14     ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_5   23 2 17 8 13 ;PUSH Bytes
CALL            13 8 17 2 23 ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 12 10  ;PUSH Bytes
CALL            10 12 22   ;CALL function
                           #--- PUSHB_4   64 22 19 9 ;PUSH Bytes
CALL            9 19 22 64 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   22 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   8 23 29   ;PUSH Bytes
IP              29         ;Interpolate Point
IP              23         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_5   23 14 4 8 13 ;PUSH Bytes
CALL            13 8 4 14 23 ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_5   32 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 32 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   17 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   8 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   23 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   1 2       ;PUSH Bytes
IP              2          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   2 17 18 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 18 17 2 ;Interpolate Point
                           #--- PUSHB_2   29 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_5   23 21 11 15 13 ;PUSH Bytes
CALL            13 15 11 21 23 ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_5   32 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 32 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   1 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   10 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   23 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_2   8 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_4   2 4 1 9   ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              9 1 4 2    ;Interpolate Point
                           #--- PUSHB_2   29 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_5   23 2 22 8 13 ;PUSH Bytes
CALL            13 8 22 2 23 ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_5   14 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   22 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   8 23 29   ;PUSH Bytes
IP              29         ;Interpolate Point
IP              23         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   14 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_3   12 15 20  ;PUSH Bytes
IP              20         ;Interpolate Point
IP              15         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_5   23 2 22 8 13 ;PUSH Bytes
CALL            13 8 22 2 23 ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_5   14 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   22 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   8 23 29   ;PUSH Bytes
IP              29         ;Interpolate Point
IP              23         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   14 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_3   12 15 20  ;PUSH Bytes
IP              20         ;Interpolate Point
IP              15         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E20': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_5   42 25 19 33 13 ;PUSH Bytes
CALL            13 33 19 25 42 ;CALL function
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_5   10 15 19 33 13 ;PUSH Bytes
CALL            13 33 19 15 10 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_5   10 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   45 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   16 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   27 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_4   19 25 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 25 19 ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_2   2 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_3   6 12 33   ;PUSH Bytes
IP              33         ;Interpolate Point
IP              12         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E21': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_3   23 0 0    ;PUSH Bytes
CALL            0 0 23     ;CALL function
                           #--- PUSHB_5   43 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 43 ;CALL function
                           #--- PUSHB_3   15 1 0    ;PUSH Bytes
CALL            0 1 15     ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
                           #--- PUSHB_5   20 12 23 8 13 ;PUSH Bytes
CALL            13 8 23 12 20 ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
                           #--- DUP       #29       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_5   49 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 49 ;CALL function
                           #--- PUSHB_5   31 2 23 8 13 ;PUSH Bytes
CALL            13 8 23 2 31 ;CALL function
                           #--- PUSHB_5   31 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 31 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   52 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 52 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_5   46 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
MIRP[min,black] stemw 17   ;Move Indirect Relative Point
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   30 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_6   8 23 31 37 43 49 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              49 43 37 31 23 8 ;Interpolate Point
                           #--- PUSHB_2   14 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   14 26 46 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              52 46 26 14 ;Interpolate Point
                           #--- PUSHB_2   37 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E22': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_5   46 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 46 ;CALL function
                           #--- PUSHB_5   2 35 11 21 13 ;PUSH Bytes
CALL            13 21 11 35 2 ;CALL function
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   40 27 11 21 13 ;PUSH Bytes
CALL            13 21 11 27 40 ;CALL function
                           #--- PUSHB_5   40 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 40 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
                           #--- DUP       #12       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_5   24 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   32 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_6   2 21 27 35 40 46 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              46 40 35 27 21 2 ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   0 36      ;PUSH Bytes
IP              36         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   40 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_3   18 30 32  ;PUSH Bytes
IP              32         ;Interpolate Point
IP              30         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E23': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   40 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 40 ;CALL function
                           #--- PUSHB_3   17 1 0    ;PUSH Bytes
CALL            0 1 17     ;CALL function
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_1   25        ;PUSH Bytes
                           #--- DUP       #25       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_5   46 6 0 17 13 ;PUSH Bytes
CALL            13 17 0 6 46 ;CALL function
                           #--- PUSHB_5   46 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 46 ;CALL function
                           #--- PUSHB_5   32 12 0 17 13 ;PUSH Bytes
CALL            13 17 0 12 32 ;CALL function
                           #--- PUSHB_5   32 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 32 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   49 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_5   43 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   8 49      ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_6   0 6 17 29 40 46 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              46 40 29 17 6 0 ;Interpolate Point
                           #--- PUSHB_2   36 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_2   20 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E24': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_5   42 18 24 33 13 ;PUSH Bytes
CALL            13 33 24 18 42 ;CALL function
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_5   10 15 24 33 13 ;PUSH Bytes
CALL            13 33 24 15 10 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_5   10 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_5   45 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 45 ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   45 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_3   18 36 42  ;PUSH Bytes
IP              42         ;Interpolate Point
IP              36         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   6 33      ;PUSH Bytes
IP              33         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E25': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 44 10  ;PUSH Bytes
CALL            10 44 30   ;CALL function
                           #--- PUSHB_4   0 30 36 9 ;PUSH Bytes
CALL            9 36 30 0  ;CALL function
                           #--- PUSHB_5   54 10 16 44 13 ;PUSH Bytes
CALL            13 44 16 10 54 ;CALL function
                           #--- PUSHB_5   54 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 54 ;CALL function
                           #--- PUSHB_5   23 4 16 44 13 ;PUSH Bytes
CALL            13 44 16 4 23 ;CALL function
                           #--- PUSHB_2   23 5      ;PUSH Bytes
MIRP[min,black] cvt_5 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   57 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 57 ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   57 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_2   33 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_3   10 48 54  ;PUSH Bytes
IP              54         ;Interpolate Point
IP              48         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_2   4 44      ;PUSH Bytes
IP              44         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   54 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E26': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_5   42 24 18 32 13 ;PUSH Bytes
CALL            13 32 18 24 42 ;CALL function
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_5   9 14 18 32 13 ;PUSH Bytes
CALL            13 32 18 14 9 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   45 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   15 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   26 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_4   18 24 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 24 18 ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_2   1 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_3   5 11 32   ;PUSH Bytes
IP              32         ;Interpolate Point
IP              11         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E27': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 26 10  ;PUSH Bytes
CALL            10 26 12   ;CALL function
                           #--- PUSHB_4   0 12 18 9 ;PUSH Bytes
CALL            9 18 12 0  ;CALL function
                           #--- PUSHB_5   39 6 0 26 13 ;PUSH Bytes
CALL            13 26 0 6 39 ;CALL function
                           #--- PUSHB_5   39 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 39 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   42 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 42 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_5   36 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 36 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   8 42      ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_4   0 6 33 39 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              39 33 6 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   39 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E28': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_2   63 4      ;PUSH Bytes
MIRP[min,black] stemt 63   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 63 10  ;PUSH Bytes
CALL            10 63 28   ;CALL function
                           #--- PUSHB_4   64 28 36 9 ;PUSH Bytes
CALL            9 36 28 64 ;CALL function
                           #--- PUSHB_5   12 48 19 36 13 ;PUSH Bytes
CALL            13 36 19 48 12 ;CALL function
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
                           #--- PUSHB_5   73 54 19 36 13 ;PUSH Bytes
CALL            13 36 19 54 73 ;CALL function
                           #--- PUSHB_5   73 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 73 ;CALL function
                           #--- PUSHB_1   75        ;PUSH Bytes
SHP[rp2]        75         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
                           #--- DUP       #25       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   66 6      ;PUSH Bytes
MIRP[min,black] stemw 66   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   18 66     ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   69        ;PUSH Bytes
IP              69         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_5   12 28 57 63 75 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              75 63 57 28 12 ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   7 60      ;PUSH Bytes
IP              60         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_2   0 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   31 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_3   15 22 23  ;PUSH Bytes
IP              23         ;Interpolate Point
IP              22         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_2   9 69      ;PUSH Bytes
IP              69         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SRP2            73         ;Set Reference Point 2
                           #--- PUSHB_3   7 25 4    ;PUSH Bytes
IP              4          ;Interpolate Point
IP              25         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_2   28 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   31 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E29': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_2   52 4      ;PUSH Bytes
MIRP[min,black] stemt 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   34 1 0    ;PUSH Bytes
CALL            0 1 34     ;CALL function
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   60 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 60 ;CALL function
                           #--- PUSHB_5   25 72 48 8 13 ;PUSH Bytes
CALL            13 8 48 72 25 ;CALL function
                           #--- PUSHB_5   25 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 25 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_5   54 2 48 8 13 ;PUSH Bytes
CALL            13 8 48 2 54 ;CALL function
                           #--- PUSHB_5   54 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 54 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   63 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 63 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   53 12 10  ;PUSH Bytes
CALL            10 12 53   ;CALL function
                           #--- PUSHB_4   64 53 50 9 ;PUSH Bytes
CALL            9 50 53 64 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_5   57 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 57 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_5   75 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 75 ;CALL function
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP0            75         ;Set Reference Point 0
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_5   28 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_3   46 13 10  ;PUSH Bytes
CALL            10 13 46   ;CALL function
                           #--- PUSHB_4   64 46 42 9 ;PUSH Bytes
CALL            9 42 46 64 ;CALL function
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   53 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_3   8 54 60   ;PUSH Bytes
IP              60         ;Interpolate Point
IP              54         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   69 75     ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_2   46 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   72 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_6   22 28 30 33 46 66 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              66 46 33 30 28 22 ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   36 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_2   60 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_5   72 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 72 ;CALL function
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[min,black] stemt 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 44 10  ;PUSH Bytes
CALL            10 44 30   ;CALL function
                           #--- PUSHB_4   0 30 36 9 ;PUSH Bytes
CALL            9 36 30 0  ;CALL function
                           #--- PUSHB_3   49 1 0    ;PUSH Bytes
CALL            0 1 49     ;CALL function
                           #--- PUSHB_5   78 10 16 44 13 ;PUSH Bytes
CALL            13 44 16 10 78 ;CALL function
                           #--- PUSHB_5   78 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 78 ;CALL function
                           #--- PUSHB_5   23 4 16 44 13 ;PUSH Bytes
CALL            13 44 16 4 23 ;CALL function
                           #--- PUSHB_2   23 5      ;PUSH Bytes
MIRP[min,black] cvt_5 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   84        ;PUSH Bytes
MDAP[rnd]       84         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   81 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 81 ;CALL function
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   81        ;PUSH Bytes
SRP0            81         ;Set Reference Point 0
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   63 65     ;PUSH Bytes
SHP[rp2]        65         ;SHift Point using reference point
SHP[rp2]        63         ;SHift Point using reference point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   85 1      ;PUSH Bytes
CALL            1 85       ;CALL function
                           #--- PUSHB_2   81 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            81         ;Set Reference Point 2
                           #--- PUSHB_2   33 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP2            75         ;Set Reference Point 2
                           #--- PUSHB_3   10 72 78  ;PUSH Bytes
IP              78         ;Interpolate Point
IP              72         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_3   4 25 44   ;PUSH Bytes
IP              44         ;Interpolate Point
IP              25         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   28 70     ;PUSH Bytes
IP              70         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_3   46 50 60  ;PUSH Bytes
IP              60         ;Interpolate Point
IP              50         ;Interpolate Point
IP              46         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   78 72     ;PUSH Bytes
SRP1            72         ;Set Reference Point 1
SRP2            78         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   63 67     ;PUSH Bytes
IP              67         ;Interpolate Point
IP              63         ;Interpolate Point
                           #--- PUSHB_2   44 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   46 60     ;PUSH Bytes
IP              60         ;Interpolate Point
IP              46         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_3   44 1 0    ;PUSH Bytes
CALL            0 1 44     ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp1]        59         ;SHift Point using reference point
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   12 38 35 44 13 ;PUSH Bytes
CALL            13 44 35 38 12 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_5   15 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_2   35 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_3   18 12 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              12         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_2   9 56      ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   29 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_2   3 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   0 6 59    ;PUSH Bytes
IP              59         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   38 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   29 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_2   53 65     ;PUSH Bytes
IP              65         ;Interpolate Point
IP              53         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   41 56 62  ;PUSH Bytes
IP              62         ;Interpolate Point
IP              56         ;Interpolate Point
IP              41         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp1]        54         ;SHift Point using reference point
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_5   42 2 41 8 13 ;PUSH Bytes
CALL            13 8 41 2 42 ;CALL function
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   51 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_5   45 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   63 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 63 ;CALL function
                           #--- PUSHB_4   14 63 21 8 ;PUSH Bytes
CALL            8 21 63 14 ;CALL function
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   14 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 14 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   41 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   8 42 48   ;PUSH Bytes
IP              48         ;Interpolate Point
IP              42         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   21 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_2   38 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_3   24 54 60  ;PUSH Bytes
IP              60         ;Interpolate Point
IP              54         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_2   30 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_3   12 15 39  ;PUSH Bytes
IP              39         ;Interpolate Point
IP              15         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_3   5 14 13   ;PUSH Bytes
IP              13         ;Interpolate Point
IP              14         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_3   21 57 63  ;PUSH Bytes
IP              63         ;Interpolate Point
IP              57         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   28 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_5   9 37 36 31 13 ;PUSH Bytes
CALL            13 31 36 37 9 ;CALL function
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
                           #--- PUSHB_5   3 43 36 31 13 ;PUSH Bytes
CALL            13 31 36 43 3 ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   46 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   46 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   20 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_3   3 12 11   ;PUSH Bytes
IP              11         ;Interpolate Point
IP              12         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 0 0    ;PUSH Bytes
CALL            0 0 43     ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_5   62 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 62 ;CALL function
                           #--- PUSHB_5   9 44 43 26 13 ;PUSH Bytes
CALL            13 26 43 44 9 ;CALL function
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
                           #--- PUSHB_5   3 50 43 26 13 ;PUSH Bytes
CALL            13 26 43 50 3 ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_5   56 20 43 26 13 ;PUSH Bytes
CALL            13 26 43 20 56 ;CALL function
                           #--- PUSHB_5   56 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 56 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   53 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 53 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_2   53 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_4   3 12 11 65 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              65 11 12 3 ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   59        ;PUSH Bytes
IP              59         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   29 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   50 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   56 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_2   38 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   39 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   29 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_5   9 15 17 18 30 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              30 18 17 15 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E30': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 1 0    ;PUSH Bytes
CALL            0 1 50     ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp1]        62         ;SHift Point using reference point
                           #--- PUSHB_5   76 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 76 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   82        ;PUSH Bytes
MDAP[rnd]       82         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_1   79        ;PUSH Bytes
SHP[rp2]        79         ;SHift Point using reference point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp2]        73         ;SHift Point using reference point
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
                           #--- PUSHB_2   83 1      ;PUSH Bytes
CALL            1 83       ;CALL function
                           #--- PUSHB_2   32 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   9 50      ;PUSH Bytes
IP              50         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   18 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
                           #--- PUSHB_7   69 41 47 53 55 56 70 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              70 56 55 53 47 41 69 ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_2   59 65     ;PUSH Bytes
IP              65         ;Interpolate Point
IP              59         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E31': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 3 0    ;PUSH Bytes
CALL            0 3 35     ;CALL function
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   24 3 0    ;PUSH Bytes
CALL            0 3 24     ;CALL function
                           #--- PUSHB_3   7 3 0     ;PUSH Bytes
CALL            0 3 7      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   32 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E32': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 19 10   ;PUSH Bytes
CALL            10 19 5    ;CALL function
                           #--- PUSHB_4   0 5 11 9  ;PUSH Bytes
CALL            9 11 5 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E33': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_5   4 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 4 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   13 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E35': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 2 0    ;PUSH Bytes
CALL            0 2 12     ;CALL function
                           #--- PUSHB_5   4 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 4 ;CALL function
                           #--- PUSHB_3   4 12 10   ;PUSH Bytes
CALL            10 12 4    ;CALL function
                           #--- PUSHB_4   64 4 7 9  ;PUSH Bytes
CALL            9 7 4 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 15 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   8 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 8 ;CALL function
                           #--- PUSHB_3   6 8 10    ;PUSH Bytes
CALL            10 8 6     ;CALL function
                           #--- PUSHB_4   64 6 1 9  ;PUSH Bytes
CALL            9 1 6 64   ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E36': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_5   4 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 4 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   35 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 35 ;CALL function
                           #--- PUSHB_5   17 4 0 44 4 ;PUSH Bytes
CALL            4 44 0 4 17 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   12 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   4 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_3   6 20 26   ;PUSH Bytes
IP              26         ;Interpolate Point
IP              20         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E37': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 2 0    ;PUSH Bytes
CALL            0 2 17     ;CALL function
                           #--- PUSHB_5   4 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 4 ;CALL function
                           #--- PUSHB_3   4 17 10   ;PUSH Bytes
CALL            10 17 4    ;CALL function
                           #--- PUSHB_4   64 4 12 9 ;PUSH Bytes
CALL            9 12 4 64  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   20 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 20 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 1 9  ;PUSH Bytes
CALL            9 1 6 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   13 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 13 ;CALL function
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   9 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E38': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_3   4 14 10   ;PUSH Bytes
CALL            10 14 4    ;CALL function
                           #--- PUSHB_4   64 4 1 9  ;PUSH Bytes
CALL            9 1 4 64   ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   10 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   23 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_5   1 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 1 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   1 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   4 10 14 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 14 10 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E39': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_3   14 1 10   ;PUSH Bytes
CALL            10 1 14    ;CALL function
                           #--- PUSHB_4   64 14 16 9 ;PUSH Bytes
CALL            9 16 14 64 ;CALL function
                           #--- PUSHB_4   4 14 1 8  ;PUSH Bytes
CALL            8 1 14 4   ;CALL function
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   10 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   27 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   0 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 0 ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   21 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   4 10 1    ;PUSH Bytes
IP              1          ;Interpolate Point
IP              10         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_2   24 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E3A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   6 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 6 ;CALL function
                           #--- PUSHB_5   6 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 9 ;CALL function
                           #--- PUSHB_5   9 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 9 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   3 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E3B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp1]        58         ;SHift Point using reference point
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 15      ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   27 31 10  ;PUSH Bytes
CALL            10 31 27   ;CALL function
                           #--- PUSHB_4   64 27 23 9 ;PUSH Bytes
CALL            9 23 27 64 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_2   5 14      ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   38 4      ;PUSH Bytes
MIRP[min,black] stemt 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 34 10  ;PUSH Bytes
CALL            10 34 38   ;CALL function
                           #--- PUSHB_4   64 38 42 9 ;PUSH Bytes
CALL            9 42 38 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   32 3 10   ;PUSH Bytes
CALL            10 3 32    ;CALL function
                           #--- PUSHB_4   64 32 29 9 ;PUSH Bytes
CALL            9 29 32 64 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_3   0 4 39    ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   60 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 60 ;CALL function
                           #--- PUSHB_3   8 15 44   ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP0            60         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
                           #--- DUP       #11       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   49 6      ;PUSH Bytes
MIRP[min,black] stemw 49   ;Move Indirect Relative Point
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   19 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 31      ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_2   45 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              45         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E40': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_5   6 20 12 16 13 ;PUSH Bytes
CALL            13 16 12 20 6 ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   23 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 23 ;CALL function
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   18 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_3   0 6 20    ;PUSH Bytes
IP              20         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E41': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 0 0     ;PUSH Bytes
CALL            0 0 9      ;CALL function
                           #--- PUSHB_5   40 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 40 ;CALL function
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
                           #--- DUP       #29       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 2 0    ;PUSH Bytes
CALL            0 2 27     ;CALL function
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   36 5      ;PUSH Bytes
MIRP[min,black] cvt_5 36   ;Move Indirect Relative Point
                           #--- PUSHB_5   46 3 9 36 13 ;PUSH Bytes
CALL            13 36 9 3 46 ;CALL function
                           #--- PUSHB_5   46 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 46 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_5   49 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 49 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   49 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_2   21 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_3   3 40 46   ;PUSH Bytes
IP              46         ;Interpolate Point
IP              40         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   24 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   12 6      ;PUSH Bytes
IP              6          ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   16 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E43': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 0 0    ;PUSH Bytes
CALL            0 0 50     ;CALL function
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
                           #--- PUSHB_3   26 2 0    ;PUSH Bytes
CALL            0 2 26     ;CALL function
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_5   18 44 50 26 13 ;PUSH Bytes
CALL            13 26 50 44 18 ;CALL function
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_5   0 32 50 26 13 ;PUSH Bytes
CALL            13 26 50 32 0 ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_5   38 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 38 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   29 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_5   21 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 21 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   47 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 47 ;CALL function
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   24 26 32  ;PUSH Bytes
IP              32         ;Interpolate Point
IP              26         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_2   38 57     ;PUSH Bytes
IP              57         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_2   42 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_3   12 18 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              18         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   47 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              47         ;Interpolate Point
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   29 35 54  ;PUSH Bytes
IP              54         ;Interpolate Point
IP              35         ;Interpolate Point
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E44': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   33 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_3   0 6 35    ;PUSH Bytes
IP              35         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E45': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 19 10   ;PUSH Bytes
CALL            10 19 5    ;CALL function
                           #--- PUSHB_4   0 5 11 9  ;PUSH Bytes
CALL            9 11 5 0   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E46': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 1 0    ;PUSH Bytes
CALL            0 1 32     ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 4      ;PUSH Bytes
MIRP[min,black] stemt 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   23 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   50 38 10  ;PUSH Bytes
CALL            10 38 50   ;CALL function
                           #--- PUSHB_4   64 50 44 9 ;PUSH Bytes
CALL            9 44 50 64 ;CALL function
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   17 20 26 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 26 20 17 ;Interpolate Point
                           #--- PUSHB_2   50 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_3   16 33 34  ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_5   6 15 23 29 33 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              33 29 23 15 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E47': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 3 0    ;PUSH Bytes
CALL            0 3 38     ;CALL function
                           #--- PUSHB_5   50 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 50 ;CALL function
                           #--- PUSHB_3   24 3 0    ;PUSH Bytes
CALL            0 3 24     ;CALL function
                           #--- PUSHB_5   10 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 10 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_5   44 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 44 ;CALL function
                           #--- PUSHB_3   44 0 10   ;PUSH Bytes
CALL            10 0 44    ;CALL function
                           #--- PUSHB_4   64 44 31 9 ;PUSH Bytes
CALL            9 31 44 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   27 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_5   53 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 53 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   35 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_4   4 10 24 3 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              3 24 10 4  ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_2   23 11     ;PUSH Bytes
IP              11         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_4   13 14 0 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 0 14 13 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   50 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_6   30 3 41 47 35 53 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              53 35 47 41 3 30 ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_2   7 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E47.high': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 4 0 14 4 ;PUSH Bytes
CALL            4 14 0 4 5 ;CALL function
                           #--- PUSHB_5   5 4 0 14 4 ;PUSH Bytes
CALL            4 14 0 4 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   8 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 8 ;CALL function
                           #--- PUSHB_5   8 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 8 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E48': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E49.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   13 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 13 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   25 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 25 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   16 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_5   0 19 25 28 31 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              31 28 25 19 0 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4A.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   63 3 0    ;PUSH Bytes
CALL            0 3 63     ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp1]        56         ;SHift Point using reference point
                           #--- PUSHB_5   25 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 25 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   63 25 10  ;PUSH Bytes
CALL            10 25 63   ;CALL function
                           #--- PUSHB_4   64 63 59 9 ;PUSH Bytes
CALL            9 59 63 64 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_5   52 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 52 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_4   60 15 3 8 ;PUSH Bytes
CALL            8 3 15 60  ;CALL function
                           #--- PUSHB_5   59 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 59 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_5   35 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 35 ;CALL function
                           #--- PUSHB_3   53 35 10  ;PUSH Bytes
CALL            10 35 53   ;CALL function
                           #--- PUSHB_4   64 53 50 9 ;PUSH Bytes
CALL            9 50 53 64 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_5   44 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 44 ;CALL function
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   12 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
                           #--- PUSHB_2   59 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 48      ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_3   3 9 15    ;PUSH Bytes
IP              15         ;Interpolate Point
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_2   6 38      ;PUSH Bytes
IP              38         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   28 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4B.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 3 0     ;PUSH Bytes
CALL            0 3 8      ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_5   4 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 4 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   4 8 10    ;PUSH Bytes
CALL            10 8 4     ;CALL function
                           #--- PUSHB_4   64 4 0 9  ;PUSH Bytes
CALL            9 0 4 64   ;CALL function
                           #--- PUSHB_3   8 4 10    ;PUSH Bytes
CALL            10 4 8     ;CALL function
                           #--- PUSHB_4   64 8 12 9 ;PUSH Bytes
CALL            9 12 8 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   22 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 22 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 10   ;PUSH Bytes
CALL            10 2 22    ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
                           #--- PUSHB_3   2 22 10   ;PUSH Bytes
CALL            10 22 2    ;CALL function
                           #--- PUSHB_4   64 2 6 9  ;PUSH Bytes
CALL            9 6 2 64   ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4C.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
                           #--- DUP       #6        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_5   28 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 28 ;CALL function
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   12 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   24 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   15 32     ;PUSH Bytes
IP              32         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4D.high': """

""",

    'uni0E4E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 3 0    ;PUSH Bytes
CALL            0 3 21     ;CALL function
                           #--- PUSHB_2   13 5      ;PUSH Bytes
MIRP[min,black] cvt_5 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 3 0    ;PUSH Bytes
CALL            0 3 30     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   45 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 45 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   43 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 43 ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_2   5 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   12 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 12 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   36 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 36 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_5   30 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 30 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   21 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_5   45 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   33 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_6   6 12 18 24 30 0 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              0 30 24 18 12 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_6   9 15 21 27 33 3 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              3 33 27 21 15 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E50': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   12 4      ;PUSH Bytes
MIRP[min,black] stemt 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E51': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 0 0    ;PUSH Bytes
CALL            0 0 23     ;CALL function
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   17 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 17 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   49 29 10  ;PUSH Bytes
CALL            10 29 49   ;CALL function
                           #--- PUSHB_4   0 49 37 9 ;PUSH Bytes
CALL            9 37 49 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_2   52 6      ;PUSH Bytes
MIRP[min,black] stemw 52   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   20 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 20 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_3   46 32 10  ;PUSH Bytes
CALL            10 32 46   ;CALL function
                           #--- PUSHB_4   0 46 40 9 ;PUSH Bytes
CALL            9 40 46 0  ;CALL function
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   9 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_3   17 29 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              29         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   12 14 20  ;PUSH Bytes
IP              20         ;Interpolate Point
IP              14         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_2   26 52     ;PUSH Bytes
IP              52         ;Interpolate Point
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E52': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_2   47 4      ;PUSH Bytes
MIRP[min,black] stemt 47   ;Move Indirect Relative Point
                           #--- PUSHB_3   47 33 10  ;PUSH Bytes
CALL            10 33 47   ;CALL function
                           #--- PUSHB_4   64 47 42 9 ;PUSH Bytes
CALL            9 42 47 64 ;CALL function
                           #--- PUSHB_5   20 0 33 42 13 ;PUSH Bytes
CALL            13 42 33 0 20 ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_5   12 6 33 42 13 ;PUSH Bytes
CALL            13 42 33 6 12 ;CALL function
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   17 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   47 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_2   3 9       ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_5   12 14 20 25 55 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              55 25 20 14 12 ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_2   26 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              26         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_2   27 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              27         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   17 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E53': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_5   46 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 46 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   36 4      ;PUSH Bytes
MIRP[min,black] stemt 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   17 36 10  ;PUSH Bytes
CALL            10 36 17   ;CALL function
                           #--- PUSHB_4   64 17 11 9 ;PUSH Bytes
CALL            9 11 17 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_5   55 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 55 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_4   26 9 13 8 ;PUSH Bytes
CALL            8 13 9 26  ;CALL function
                           #--- PUSHB_5   49 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_5   26 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 26 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   21 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_3   23 46 52  ;PUSH Bytes
IP              52         ;Interpolate Point
IP              46         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   17 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_2   9 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   11 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_2   17 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   9 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E54': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   41 5      ;PUSH Bytes
MIRP[min,black] cvt_5 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_2   19 5      ;PUSH Bytes
MIRP[min,black] cvt_5 19   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   51 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 51 ;CALL function
                           #--- PUSHB_3   51 3 10   ;PUSH Bytes
CALL            10 3 51    ;CALL function
                           #--- PUSHB_4   64 51 60 9 ;PUSH Bytes
CALL            9 60 51 64 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   9 45      ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_3   19 35 42  ;PUSH Bytes
IP              42         ;Interpolate Point
IP              35         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_2   48 55     ;PUSH Bytes
IP              55         ;Interpolate Point
IP              48         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_3   20 34 57  ;PUSH Bytes
IP              57         ;Interpolate Point
IP              34         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_5   0 16 38 45 51 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              51 45 38 16 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E55': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   68 0 0    ;PUSH Bytes
CALL            0 0 68     ;CALL function
                           #--- PUSHB_2   46 5      ;PUSH Bytes
MIRP[min,black] cvt_5 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_3   6 1 0     ;PUSH Bytes
CALL            0 1 6      ;CALL function
                           #--- PUSHB_5   79 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 79 ;CALL function
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_3   77 1 0    ;PUSH Bytes
CALL            0 1 77     ;CALL function
                           #--- PUSHB_5   18 53 68 79 13 ;PUSH Bytes
CALL            13 79 68 53 18 ;CALL function
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_5   0 40 68 79 13 ;PUSH Bytes
CALL            13 79 68 40 0 ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   84        ;PUSH Bytes
MDAP[rnd]       84         ;Move Direct Absolute Point
                           #--- PUSHB_1   71        ;PUSH Bytes
MDRP[rp0,rnd,white] 71         ;Move Direct Relative Point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
                           #--- DUP       #50       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_1   74        ;PUSH Bytes
SHP[rp1]        74         ;SHift Point using reference point
                           #--- PUSHB_5   21 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 21 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   82 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 82 ;CALL function
                           #--- PUSHB_4   15 82 3 8 ;PUSH Bytes
CALL            8 3 82 15  ;CALL function
                           #--- PUSHB_5   56 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 56 ;CALL function
                           #--- PUSHB_3   56 15 10  ;PUSH Bytes
CALL            10 15 56   ;CALL function
                           #--- PUSHB_4   64 56 65 9 ;PUSH Bytes
CALL            9 65 56 64 ;CALL function
                           #--- PUSHB_2   85 1      ;PUSH Bytes
CALL            1 85       ;CALL function
                           #--- PUSHB_2   21 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_5   6 0 40 47 79 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              79 47 40 0 6 ;Interpolate Point
                           #--- PUSHB_2   15 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_4   12 18 53 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 53 18 12 ;Interpolate Point
                           #--- PUSHB_1   82        ;PUSH Bytes
SRP1            82         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_2   39 62     ;PUSH Bytes
IP              62         ;Interpolate Point
IP              39         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_5   12 43 50 56 71 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              71 56 50 43 12 ;Interpolate Point
                           #--- PUSHB_2   0 40      ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   74        ;PUSH Bytes
IP              74         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_3   29 76 82  ;PUSH Bytes
IP              82         ;Interpolate Point
IP              76         ;Interpolate Point
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E56': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   19 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 19 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   15 9 48 14 ;PUSH Bytes
CALL            14 48 9 15 ;CALL function
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   22 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   53 6      ;PUSH Bytes
MIRP[min,black] stemw 53   ;Move Indirect Relative Point
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   9 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_2   3 48      ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   0 6 19    ;PUSH Bytes
IP              19         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   27 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_3   12 30 50  ;PUSH Bytes
IP              50         ;Interpolate Point
IP              30         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_3   3 9 16    ;PUSH Bytes
IP              16         ;Interpolate Point
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   27 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_2   33 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E57': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 0 0    ;PUSH Bytes
CALL            0 0 12     ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_3   41 0 0    ;PUSH Bytes
CALL            0 0 41     ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_2   48 4      ;PUSH Bytes
MIRP[min,black] stemt 48   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_3   30 48 10  ;PUSH Bytes
CALL            10 48 30   ;CALL function
                           #--- PUSHB_4   64 30 25 9 ;PUSH Bytes
CALL            9 25 30 64 ;CALL function
                           #--- PUSHB_3   48 30 10  ;PUSH Bytes
CALL            10 30 48   ;CALL function
                           #--- PUSHB_4   0 48 65 9 ;PUSH Bytes
CALL            9 65 48 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_2   33 6      ;PUSH Bytes
MIRP[min,black] stemw 33   ;Move Indirect Relative Point
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   58 6      ;PUSH Bytes
MIRP[min,black] stemw 58   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 58 10  ;PUSH Bytes
CALL            10 58 17   ;CALL function
                           #--- PUSHB_4   64 17 14 9 ;PUSH Bytes
CALL            9 14 17 64 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   68 6      ;PUSH Bytes
MIRP[min,black] stemw 68   ;Move Indirect Relative Point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   33 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   41        ;PUSH Bytes
IP              41         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_5   0 6 30 35 48 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              48 35 30 6 0 ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   14 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   48 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E58': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_5   0 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 0 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   17 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 17 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_2   34 5      ;PUSH Bytes
MIRP[min,black] cvt_5 34   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_2   54 6      ;PUSH Bytes
MIRP[min,black] stemw 54   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   20 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 20 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   59 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_4   28 34 51 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 51 34 28 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   35 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              35         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   38 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   14 27 57  ;PUSH Bytes
IP              57         ;Interpolate Point
IP              27         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_2   31 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E59': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   53 0 0    ;PUSH Bytes
CALL            0 0 53     ;CALL function
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_1   46        ;PUSH Bytes
                           #--- DUP       #46       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   34 5      ;PUSH Bytes
MIRP[min,black] cvt_5 34   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDRP[rp0,rnd,white] 24         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   3 59      ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   9 15 21 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 21 15 9 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   46 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   24 59     ;PUSH Bytes
IP              59         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_2   34 56     ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E5A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 0 0    ;PUSH Bytes
CALL            0 0 24     ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_2   21 44     ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   39 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   23 6      ;PUSH Bytes
MIRP[min,black] stemw 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_2   15 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_5   9 15 17 18 30 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              30 18 17 15 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E5B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   52 0 0    ;PUSH Bytes
CALL            0 0 52     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   41 35 10  ;PUSH Bytes
CALL            10 35 41   ;CALL function
                           #--- PUSHB_4   64 41 47 9 ;PUSH Bytes
CALL            9 47 41 64 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_3   35 41 10  ;PUSH Bytes
CALL            10 41 35   ;CALL function
                           #--- PUSHB_4   64 35 28 9 ;PUSH Bytes
CALL            9 28 35 64 ;CALL function
                           #--- PUSHB_2   25 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_1   64        ;PUSH Bytes
                           #--- DUP       #64       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 64         ;Move Direct Relative Point
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_2   46 49     ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_2   58 5      ;PUSH Bytes
MIRP[min,black] cvt_5 58   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDRP[rp0,rnd,white] 55         ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   61 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 61 ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP0            61         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   9 67      ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_4   12 21 52 64 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              64 52 21 12 ;Interpolate Point
                           #--- PUSHB_2   31 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_3   25 45 49  ;PUSH Bytes
IP              49         ;Interpolate Point
IP              45         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   43 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              43         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_5   6 18 38 55 67 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              67 55 38 18 6 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_4   12 27 30 71 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              71 30 27 12 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   11 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_4   3 8 22 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 22 8 3  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 3 0    ;PUSH Bytes
CALL            0 3 35     ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
                           #--- PUSHB_3   35 23 10  ;PUSH Bytes
CALL            10 23 35   ;CALL function
                           #--- PUSHB_4   64 35 31 9 ;PUSH Bytes
CALL            9 31 35 64 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   45 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 45 ;CALL function
                           #--- PUSHB_4   31 45 12 8 ;PUSH Bytes
CALL            8 12 45 31 ;CALL function
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   31 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_2   32 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_3   15 25 27  ;PUSH Bytes
IP              27         ;Interpolate Point
IP              25         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   16 9 23 36 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              42 36 23 9 16 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   40 48     ;PUSH Bytes
IP              48         ;Interpolate Point
IP              40         ;Interpolate Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_6   6 12 27 28 39 40 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              40 39 28 27 12 6 ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_5   50 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 50 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 21 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_5   47 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 47 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_5   23 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   47 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_5   3 15 21 35 45 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              45 35 21 15 3 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   42 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_2   29 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   10 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_6   0 16 18 23 32 42 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              42 32 23 18 16 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   49 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 49 ;CALL function
                           #--- PUSHB_4   29 49 7 8 ;PUSH Bytes
CALL            8 7 49 29  ;CALL function
                           #--- PUSHB_5   28 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 28 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   46 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_5   4 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 4 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   18 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   28 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_2   30 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   12 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_5   7 21 24 38 0 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              0 38 24 21 7 ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   20 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_2   14 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_5   26 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 26 ;CALL function
                           #--- PUSHB_4   0 26 14 8 ;PUSH Bytes
CALL            8 14 26 0  ;CALL function
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   0 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   22 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_5   12 5 29 24 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              42 24 29 5 12 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_4   22 0 23 43 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              43 23 0 22 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   27 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 27 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_5   36 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 36 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 24 ;CALL function
                           #--- PUSHB_4   59 24 15 8 ;PUSH Bytes
CALL            8 15 24 59 ;CALL function
                           #--- PUSHB_5   46 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 46 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   24 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_8   12 0 27 21 35 36 43 56 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              56 43 36 35 21 27 0 12 ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   15 20     ;PUSH Bytes
IP              20         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   57 59     ;PUSH Bytes
IP              59         ;Interpolate Point
IP              57         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   37 3 0    ;PUSH Bytes
CALL            0 3 37     ;CALL function
                           #--- PUSHB_5   19 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 19 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   54 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 54 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_5   40 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   51 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   25 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   51 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_5   12 14 19 37 42 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              42 37 19 14 12 ;Interpolate Point
                           #--- PUSHB_2   25 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   27 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_4   3 28 30 54 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              54 30 28 3 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_5   6 0 27 30 48 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              48 30 27 0 6 ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_3   17 29 28  ;PUSH Bytes
IP              28         ;Interpolate Point
IP              29         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_5   27 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   40 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   30 5      ;PUSH Bytes
IP              5          ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   7 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   15 9 16 22 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              22 16 9 15 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_5   0 1 19 12 24 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              24 12 19 1 0 ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10D9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_5   43 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 43 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   33 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   33 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_6   6 7 12 18 30 42 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              42 30 18 12 7 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   20 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10DA': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_2   36 44     ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_5   18 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 18 ;CALL function
                           #--- PUSHB_2   20 23     ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   53 18 10  ;PUSH Bytes
CALL            10 18 53   ;CALL function
                           #--- PUSHB_4   64 53 41 9 ;PUSH Bytes
CALL            9 41 53 64 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_5   55 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_5   48 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 48 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   40 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   27 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 27 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   55 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_2   9 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   18 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   21 58     ;PUSH Bytes
IP              58         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   22 59     ;PUSH Bytes
IP              59         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_3   24 0 31   ;PUSH Bytes
IP              31         ;Interpolate Point
IP              0          ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   30 61     ;PUSH Bytes
IP              61         ;Interpolate Point
IP              30         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   19 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10DB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 3 0    ;PUSH Bytes
CALL            0 3 14     ;CALL function
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   16 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 16 ;CALL function
                           #--- PUSHB_4   6 16 21 8 ;PUSH Bytes
CALL            8 21 16 6  ;CALL function
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   6 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_2   32 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_4   4 8 14 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 14 8 4  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_2   14 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10DC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 2 0     ;PUSH Bytes
CALL            0 2 3      ;CALL function
                           #--- PUSHB_5   26 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 26 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
                           #--- DUP       #6        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 39 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   36 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 36 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   31 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_5   3 12 17 23 26 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              26 23 17 12 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10DD': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   33 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   34 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_3   4 5 11    ;PUSH Bytes
IP              11         ;Interpolate Point
IP              5          ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   21 15 22  ;PUSH Bytes
IP              22         ;Interpolate Point
IP              15         ;Interpolate Point
IP              21         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10DE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   27 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 27 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   17 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   38 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_1   43        ;PUSH Bytes
                           #--- DUP       #43       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 43         ;Move Direct Relative Point
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_5   31 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 31 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_5   43 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 43 ;CALL function
                           #--- PUSHB_3   31 43 10  ;PUSH Bytes
CALL            10 43 31   ;CALL function
                           #--- PUSHB_4   64 31 27 9 ;PUSH Bytes
CALL            9 27 31 64 ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_2   38 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_2   36 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
                           #--- PUSHB_4   20 3 33 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 33 3 20 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   0 10 6    ;PUSH Bytes
IP              6          ;Interpolate Point
IP              10         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   9 45      ;PUSH Bytes
IP              45         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10DF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   19 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 19 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_5   38 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 38 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_5   16 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 16 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   26 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   16 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   12 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_5   4 13 29 45 46 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              46 45 29 13 4 ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   19 24 48  ;PUSH Bytes
IP              48         ;Interpolate Point
IP              24         ;Interpolate Point
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   7 12      ;PUSH Bytes
IP              12         ;Interpolate Point
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_5   43 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_2   19 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_4   28 29 47 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 47 29 28 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_3   37 46 51  ;PUSH Bytes
IP              51         ;Interpolate Point
IP              46         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   11 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_2   4 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   8 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   29 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 29 ;CALL function
                           #--- PUSHB_3   29 20 10  ;PUSH Bytes
CALL            10 20 29   ;CALL function
                           #--- PUSHB_4   64 29 25 9 ;PUSH Bytes
CALL            9 25 29 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   20 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   3 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_2   0 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   0 20      ;PUSH Bytes
IP              20         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   61 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 61 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 39 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_5   27 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 27 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_5   13 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   55 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 55 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_5   25 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 25 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   10 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_3   13 48 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              48         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_4   5 41 0 55 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              55 0 41 5  ;Interpolate Point
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   44 52     ;PUSH Bytes
IP              52         ;Interpolate Point
IP              44         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   17 8      ;PUSH Bytes
IP              8          ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   15 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   61 1 0    ;PUSH Bytes
CALL            0 1 61     ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
                           #--- DUP       #14       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_3   54 5 10   ;PUSH Bytes
CALL            10 5 54    ;CALL function
                           #--- PUSHB_4   64 54 47 9 ;PUSH Bytes
CALL            9 47 54 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   57        ;PUSH Bytes
MDRP[rp0,rnd,white] 57         ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 2 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_4   7 32 24 8 ;PUSH Bytes
CALL            8 24 32 7  ;CALL function
                           #--- PUSHB_5   51 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 51 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_5   46 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   24 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   61        ;PUSH Bytes
IP              61         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_3   5 0 54    ;PUSH Bytes
IP              54         ;Interpolate Point
IP              0          ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_2   51 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_2   10 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_3   12 35 21  ;PUSH Bytes
IP              21         ;Interpolate Point
IP              35         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   54 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_2   24 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_2   42 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_4   2 7 51 57 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              57 51 7 2  ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_3   8 0 12    ;PUSH Bytes
IP              12         ;Interpolate Point
IP              0          ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_5   52 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 52 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   63 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 63 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_1   6         ;PUSH Bytes
                           #--- DUP       #6        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp1]        57         ;SHift Point using reference point
                           #--- PUSHB_5   30 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 30 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_5   60 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 60 ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP0            60         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_5   49 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_5   17 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   39 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 39 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   49 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_2   46 58     ;PUSH Bytes
IP              58         ;Interpolate Point
IP              46         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_5   26 42 20 47 63 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              63 47 20 42 26 ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_4   4 3 15 28 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              28 15 3 4  ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_4   6 13 30 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              52 30 13 6 ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   44 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              44         ;Interpolate Point
                           #--- PUSHB_2   63 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_4   17 23 55 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 55 23 17 ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_5   45 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 45 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_5   42 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 42 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_5   29 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 29 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   0 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   32 37 38  ;PUSH Bytes
IP              38         ;Interpolate Point
IP              37         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_6   7 8 18 19 24 45 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              45 24 19 18 8 7 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   49 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_4   11 34 8 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 8 34 11 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   46 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_5   37 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_5   22 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 22 ;CALL function
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   46 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   4 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_4   0 14 8 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 8 14 0  ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_5   25 18 26 50 53 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              53 50 26 18 25 ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   0 49 50   ;PUSH Bytes
IP              50         ;Interpolate Point
IP              49         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_2   25 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 1 0    ;PUSH Bytes
CALL            0 1 43     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_5   31 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 31 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_5   7 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 7 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   28 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 28 ;CALL function
                           #--- PUSHB_4   39 28 19 8 ;PUSH Bytes
CALL            8 19 28 39 ;CALL function
                           #--- PUSHB_5   4 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 4 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   4 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_6   0 16 24 31 36 43 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              43 36 31 24 16 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_2   23 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_3   11 12 39  ;PUSH Bytes
IP              39         ;Interpolate Point
IP              12         ;Interpolate Point
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 3 0    ;PUSH Bytes
CALL            0 3 40     ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_5   10 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 10 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   40 10 10  ;PUSH Bytes
CALL            10 10 40   ;CALL function
                           #--- PUSHB_4   64 40 35 9 ;PUSH Bytes
CALL            9 35 40 64 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_5   50 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 50 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   26 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 26 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_5   48 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 48 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   35 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   24 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_3   10 3 40   ;PUSH Bytes
IP              40         ;Interpolate Point
IP              3          ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_4   21 26 12 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 12 26 21 ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_2   40 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10E9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 3 0    ;PUSH Bytes
CALL            0 3 36     ;CALL function
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   26 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 26 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   10 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 10 ;CALL function
                           #--- PUSHB_2   23 39     ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_5   30 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 30 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   33 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_4   6 15 21 26 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              26 21 15 6 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_2   30 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   36 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10EA': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_5   21 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 21 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_5   30 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 30 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   18 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   44 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_5   4 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 4 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   24 4 10   ;PUSH Bytes
CALL            10 4 24    ;CALL function
                           #--- PUSHB_4   64 24 30 9 ;PUSH Bytes
CALL            9 30 24 64 ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   41 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   14 15 21  ;PUSH Bytes
IP              21         ;Interpolate Point
IP              15         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   38 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_2   2 51      ;PUSH Bytes
IP              51         ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_3   11 18 4   ;PUSH Bytes
IP              4          ;Interpolate Point
IP              18         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_3   0 15 42   ;PUSH Bytes
IP              42         ;Interpolate Point
IP              15         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10EB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   19 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   13 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   8 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10EC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 3 0    ;PUSH Bytes
CALL            0 3 18     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_5   32 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 32 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_3   18 32 10  ;PUSH Bytes
CALL            10 32 18   ;CALL function
                           #--- PUSHB_4   64 18 14 9 ;PUSH Bytes
CALL            9 14 18 64 ;CALL function
                           #--- PUSHB_3   30 3 0    ;PUSH Bytes
CALL            0 3 30     ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_5   39 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 39 ;CALL function
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   45 43     ;PUSH Bytes
SDPVTL[orthog]  43 45      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[no-rnd]    43         ;Move Direct Absolute Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[grey]      45         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   25 12     ;PUSH Bytes
MIRP[rp0,min,black] cvt_12 25  ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[grey]      26         ;Move Direct Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_2   26 45     ;PUSH Bytes
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   25 26 43 45 ;PUSH Bytes
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    43         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   18 24 32 44 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              44 32 24 18 ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   0 36 42   ;PUSH Bytes
IP              42         ;Interpolate Point
IP              36         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   29 39 42  ;PUSH Bytes
IP              42         ;Interpolate Point
IP              39         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10ED': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 3 0    ;PUSH Bytes
CALL            0 3 26     ;CALL function
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_3   26 14 10  ;PUSH Bytes
CALL            10 14 26   ;CALL function
                           #--- PUSHB_4   64 26 22 9 ;PUSH Bytes
CALL            9 22 26 64 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   58 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 58 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_5   51 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 51 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   73 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 73 ;CALL function
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_5   7 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 7 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   75        ;PUSH Bytes
MDAP[rnd]       75         ;Move Direct Absolute Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
                           #--- PUSHB_5   55 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 55 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
                           #--- DUP       #5        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_5   71 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 71 ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_5   23 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_5   40 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 40 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_5   43 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 43 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_1   34        ;PUSH Bytes
                           #--- DUP       #34       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_5   33 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_2   76 1      ;PUSH Bytes
CALL            1 76       ;CALL function
                           #--- PUSHB_2   55 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_2   23 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   18 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- NPUSHB    11 2 7 14 27 46 51 52 58 64 68 73 ;PUSH N Bytes
                           #--- DEPTH     #11       ;DEPTH of the stack
SLOOP           11         ;Set LOOP variable
IP              73 68 64 58 52 51 46 27 14 7 2 ;Interpolate Point
                           #--- PUSHB_2   61 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_2   43 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_3   49 43 63  ;PUSH Bytes
IP              63         ;Interpolate Point
IP              43         ;Interpolate Point
IP              49         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
                           #--- PUSHB_3   0 37 39   ;PUSH Bytes
IP              39         ;Interpolate Point
IP              37         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_2   5 36      ;PUSH Bytes
IP              36         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_2   9 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   18 19 33 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 33 19 18 ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10EE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   25 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 25 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   0 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 0 ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   17 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_4   3 11 12 14 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              14 12 11 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10EF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   79 0 0    ;PUSH Bytes
CALL            0 0 79     ;CALL function
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
                           #--- PUSHB_3   35 0 0    ;PUSH Bytes
CALL            0 0 35     ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   30 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 30 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SHP[rp1]        67         ;SHift Point using reference point
                           #--- PUSHB_5   57 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 57 ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   82        ;PUSH Bytes
MDAP[rnd]       82         ;Move Direct Absolute Point
                           #--- PUSHB_1   54        ;PUSH Bytes
MDRP[rp0,rnd,white] 54         ;Move Direct Relative Point
                           #--- PUSHB_5   47 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 47 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   20 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 20 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
SHP[rp2]        64         ;SHift Point using reference point
                           #--- PUSHB_5   9 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 9 ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp2]        73         ;SHift Point using reference point
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   64 0 68 9 ;PUSH Bytes
CALL            9 68 0 64  ;CALL function
                           #--- PUSHB_2   83 1      ;PUSH Bytes
CALL            1 83       ;CALL function
                           #--- PUSHB_2   47 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_7   17 39 40 44 50 51 57 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              57 51 50 44 40 39 17 ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   16 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_5   4 5 12 61 76 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              76 61 12 5 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_2   79 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            79         ;Set Reference Point 2
                           #--- PUSHB_3   20 28 34  ;PUSH Bytes
IP              34         ;Interpolate Point
IP              28         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_3   9 37 39   ;PUSH Bytes
IP              39         ;Interpolate Point
IP              37         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   17 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_7   16 41 51 54 61 73 76 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              76 73 61 54 51 41 16 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10F0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 3 0    ;PUSH Bytes
CALL            0 3 50     ;CALL function
                           #--- PUSHB_5   38 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 38 ;CALL function
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_5   30 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 30 ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 12 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_1   69        ;PUSH Bytes
MDRP[rp0,rnd,white] 69         ;Move Direct Relative Point
                           #--- PUSHB_5   8 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   25 34     ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_5   62 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 62 ;CALL function
                           #--- PUSHB_2   54 58     ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_3   15 62 10  ;PUSH Bytes
CALL            10 62 15   ;CALL function
                           #--- PUSHB_4   64 15 21 9 ;PUSH Bytes
CALL            9 21 15 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_2   74 1      ;PUSH Bytes
CALL            1 74       ;CALL function
                           #--- PUSHB_2   15 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_5   0 41 51 65 72 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              72 65 51 41 0 ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
                           #--- PUSHB_2   56 60     ;PUSH Bytes
IP              60         ;Interpolate Point
IP              56         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   2 62 69   ;PUSH Bytes
IP              69         ;Interpolate Point
IP              62         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_3   0 60 72   ;PUSH Bytes
IP              72         ;Interpolate Point
IP              60         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   56        ;PUSH Bytes
IP              56         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10F1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_5   66 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 66 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   81        ;PUSH Bytes
MDAP[rnd]       81         ;Move Direct Absolute Point
                           #--- PUSHB_1   75        ;PUSH Bytes
MDRP[rp0,rnd,white] 75         ;Move Direct Relative Point
                           #--- PUSHB_5   69 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 69 ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP0            69         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_5   47 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 47 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
                           #--- DUP       #9        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_5   51 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 51 ;CALL function
                           #--- PUSHB_3   9 51 10   ;PUSH Bytes
CALL            10 51 9    ;CALL function
                           #--- PUSHB_4   64 9 14 9 ;PUSH Bytes
CALL            9 14 9 64  ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   82 1      ;PUSH Bytes
CALL            1 82       ;CALL function
                           #--- PUSHB_2   69 75     ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_3   6 54 33   ;PUSH Bytes
IP              33         ;Interpolate Point
IP              54         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_3   30 34 41  ;PUSH Bytes
IP              41         ;Interpolate Point
IP              34         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_2   51 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   45 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              45         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_4   0 49 57 59 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              59 57 49 0 ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   47 60 62 72 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              72 62 60 47 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_2   44 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              44         ;Interpolate Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP2            78         ;Set Reference Point 2
                           #--- PUSHB_3   30 69 75  ;PUSH Bytes
IP              75         ;Interpolate Point
IP              69         ;Interpolate Point
IP              30         ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
                           #--- PUSHB_3   33 41 40  ;PUSH Bytes
IP              40         ;Interpolate Point
IP              41         ;Interpolate Point
IP              33         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10F2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_5   32 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 32 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   35 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   15 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 15 ;CALL function
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   35 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_2   12 2      ;PUSH Bytes
IP              2          ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_3   6 17 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              17         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10F3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_5   35 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 35 ;CALL function
                           #--- PUSHB_4   38 36 35 8 ;PUSH Bytes
CALL            8 35 36 38 ;CALL function
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_1   16        ;PUSH Bytes
                           #--- DUP       #16       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   27 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 27 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 6 10   ;PUSH Bytes
CALL            10 6 21    ;CALL function
                           #--- PUSHB_4   64 21 27 9 ;PUSH Bytes
CALL            9 27 21 64 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   6 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_2   35 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   0 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10F4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   54 2 0    ;PUSH Bytes
CALL            0 2 54     ;CALL function
                           #--- PUSHB_5   2 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 2 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_5   32 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 32 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_5   41 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 41 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   29 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_5   5 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 5 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_5   16 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 16 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   51 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_4   19 25 40 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 40 25 19 ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_6   0 8 13 32 48 54 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              54 48 32 13 8 0 ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   25 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_2   13 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_2   2 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   0 51      ;PUSH Bytes
IP              51         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni10F5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   34 3 0    ;PUSH Bytes
CALL            0 3 34     ;CALL function
                           #--- PUSHB_5   19 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 19 ;CALL function
                           #--- PUSHB_3   17 3 0    ;PUSH Bytes
CALL            0 3 17     ;CALL function
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_5   40 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 40 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   46 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 46 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
                           #--- DUP       #17       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   37 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 37 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   12 29     ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 3 ;CALL function
                           #--- PUSHB_2   23 27     ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   41 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   6 48      ;PUSH Bytes
IP              48         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E00': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 37 10   ;PUSH Bytes
CALL            10 37 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] stemw 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 48 10  ;PUSH Bytes
CALL            10 48 16   ;CALL function
                           #--- PUSHB_4   64 16 13 9 ;PUSH Bytes
CALL            9 13 16 64 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   34 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 34 ;CALL function
                           #--- PUSHB_3   5 34 10   ;PUSH Bytes
CALL            10 34 5    ;CALL function
                           #--- PUSHB_4   0 5 40 9  ;PUSH Bytes
CALL            9 40 5 0   ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   5 48      ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   9 10 31 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 31 10 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E11': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 0 0    ;PUSH Bytes
CALL            0 0 32     ;CALL function
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_1   56        ;PUSH Bytes
                           #--- DUP       #56       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 56         ;Move Direct Relative Point
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_5   7 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 7 ;CALL function
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_3   36 0 0    ;PUSH Bytes
CALL            0 0 36     ;CALL function
                           #--- PUSHB_3   26 3 0    ;PUSH Bytes
CALL            0 3 26     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   50 4      ;PUSH Bytes
MIRP[min,black] stemt 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 41 10   ;PUSH Bytes
CALL            10 41 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   53 6      ;PUSH Bytes
MIRP[min,black] stemw 53   ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP0            53         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   38 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 38 ;CALL function
                           #--- PUSHB_3   5 38 10   ;PUSH Bytes
CALL            10 38 5    ;CALL function
                           #--- PUSHB_4   0 5 44 9  ;PUSH Bytes
CALL            9 44 5 0   ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   47 1      ;PUSH Bytes
CALL            1 47       ;CALL function
                           #--- PUSHB_2   18 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 47 10  ;PUSH Bytes
CALL            10 47 28   ;CALL function
                           #--- PUSHB_4   64 28 31 9 ;PUSH Bytes
CALL            9 31 28 64 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_5   23 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   5 53      ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_5   9 10 16 36 50 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              50 36 16 10 9 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   56        ;PUSH Bytes
IP              56         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_1   38        ;PUSH Bytes
IP              38         ;Interpolate Point
                           #--- PUSHB_2   56 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   50 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            50         ;Set Reference Point 2
                           #--- PUSHB_3   13 47 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              47         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E12': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_2   24 5      ;PUSH Bytes
MIRP[min,black] cvt_5 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp2]        59         ;SHift Point using reference point
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_5   16 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 16 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 5      ;PUSH Bytes
MIRP[min,black] cvt_5 43   ;Move Indirect Relative Point
                           #--- PUSHB_4   10 58 53 14 ;PUSH Bytes
CALL            14 53 58 10 ;CALL function
                           #--- PUSHB_5   48 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 48 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_2   32 5      ;PUSH Bytes
MIRP[min,black] cvt_5 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_5   37 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 37 ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_5   70 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 70 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   25 59 10  ;PUSH Bytes
CALL            10 59 25   ;CALL function
                           #--- PUSHB_4   64 25 23 9 ;PUSH Bytes
CALL            9 23 25 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_2   51 6      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
                           #--- DUP       #40       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   59 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_2   11 67     ;PUSH Bytes
IP              67         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   6 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   34 60     ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_3   16 37 74  ;PUSH Bytes
IP              74         ;Interpolate Point
IP              37         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E15': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_2   24 5      ;PUSH Bytes
MIRP[min,black] cvt_5 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp2]        59         ;SHift Point using reference point
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_5   16 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 16 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 5      ;PUSH Bytes
MIRP[min,black] cvt_5 43   ;Move Indirect Relative Point
                           #--- PUSHB_4   10 58 53 14 ;PUSH Bytes
CALL            14 53 58 10 ;CALL function
                           #--- PUSHB_5   48 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 48 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_2   32 5      ;PUSH Bytes
MIRP[min,black] cvt_5 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_5   37 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 37 ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_5   70 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 70 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   25 59 10  ;PUSH Bytes
CALL            10 59 25   ;CALL function
                           #--- PUSHB_4   64 25 23 9 ;PUSH Bytes
CALL            9 23 25 64 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_2   51 6      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] stemw 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
                           #--- DUP       #40       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   59 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   67        ;PUSH Bytes
IP              67         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_3   16 37 74  ;PUSH Bytes
IP              74         ;Interpolate Point
IP              37         ;Interpolate Point
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E17': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   47 59     ;PUSH Bytes
SHP[rp1]        59         ;SHift Point using reference point
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 51 55  ;PUSH Bytes
SHP[rp2]        55         ;SHift Point using reference point
SHP[rp2]        51         ;SHift Point using reference point
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 31 42  ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 66 10   ;PUSH Bytes
CALL            10 66 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_5   54 29 11 23 13 ;PUSH Bytes
CALL            13 23 11 29 54 ;CALL function
                           #--- PUSHB_2   54 4      ;PUSH Bytes
MIRP[min,black] stemt 54   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_4   9 17 20 14 ;PUSH Bytes
CALL            14 20 17 9 ;CALL function
                           #--- PUSHB_5   26 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 26 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_4   5 55 17 8 ;PUSH Bytes
CALL            8 17 55 5  ;CALL function
                           #--- PUSHB_5   63 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 63 ;CALL function
                           #--- PUSHB_3   5 63 10   ;PUSH Bytes
CALL            10 63 5    ;CALL function
                           #--- PUSHB_4   0 5 69 9  ;PUSH Bytes
CALL            9 69 5 0   ;CALL function
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP0            55         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_4   8 43 46 14 ;PUSH Bytes
CALL            14 46 43 8 ;CALL function
                           #--- PUSHB_5   50 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   46 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 46 ;CALL function
                           #--- PUSHB_5   40 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 40 ;CALL function
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   5 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   9 10 60 61 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              61 60 10 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E29': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   34 51     ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 38 47  ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   22 3 0    ;PUSH Bytes
CALL            0 3 22     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 1 0    ;PUSH Bytes
CALL            0 1 26     ;CALL function
                           #--- PUSHB_2   43 4      ;PUSH Bytes
MIRP[min,black] stemt 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 3 ;CALL function
                           #--- PUSHB_3   3 58 10   ;PUSH Bytes
CALL            10 58 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_5   20 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 20 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_4   9 15 13 14 ;PUSH Bytes
CALL            14 13 15 9 ;CALL function
                           #--- PUSHB_5   50 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 50 ;CALL function
                           #--- PUSHB_4   5 47 15 8 ;PUSH Bytes
CALL            8 15 47 5  ;CALL function
                           #--- PUSHB_5   55 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 55 ;CALL function
                           #--- PUSHB_3   5 55 10   ;PUSH Bytes
CALL            10 55 5    ;CALL function
                           #--- PUSHB_4   0 5 61 9  ;PUSH Bytes
CALL            9 61 5 0   ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_4   9 30 33 14 ;PUSH Bytes
CALL            14 33 30 9 ;CALL function
                           #--- PUSHB_5   37 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_5   33 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 33 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   5 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_4   9 10 52 53 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              53 52 10 9 ;Interpolate Point
                           #--- PUSHB_2   37 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   26 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_2   26 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E2A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_3   45 3 0    ;PUSH Bytes
CALL            0 3 45     ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
SHP[rp1]        53         ;SHift Point using reference point
                           #--- PUSHB_5   50 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 50 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   35 30 22 45 13 ;PUSH Bytes
CALL            13 45 22 30 35 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp1]        41         ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
                           #--- DUP       #50       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
SRP1            50         ;Set Reference Point 1
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
MDRP[rp0,rnd,white] 52         ;Move Direct Relative Point
                           #--- PUSHB_5   47 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 47 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   43 6      ;PUSH Bytes
MIRP[min,black] stemw 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   43 28 10  ;PUSH Bytes
CALL            10 28 43   ;CALL function
                           #--- PUSHB_4   64 43 19 9 ;PUSH Bytes
CALL            9 19 43 64 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   28 43 10  ;PUSH Bytes
CALL            10 43 28   ;CALL function
                           #--- PUSHB_4   64 28 24 9 ;PUSH Bytes
CALL            9 24 28 64 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP0            43         ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_5   56 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 56 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   43 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   3 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   56 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_2   11 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 50      ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   47 52 56 61 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              61 56 52 47 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E2F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_2   39 5      ;PUSH Bytes
MIRP[min,black] cvt_5 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   57 2 0    ;PUSH Bytes
CALL            0 2 57     ;CALL function
                           #--- PUSHB_5   66 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 66 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   45 2 0    ;PUSH Bytes
CALL            0 2 45     ;CALL function
                           #--- PUSHB_5   54 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 54 ;CALL function
                           #--- PUSHB_1   60        ;PUSH Bytes
SHP[rp2]        60         ;SHift Point using reference point
                           #--- PUSHB_3   52 2 0    ;PUSH Bytes
CALL            0 2 52     ;CALL function
                           #--- PUSHB_5   16 33 27 45 13 ;PUSH Bytes
CALL            13 45 27 33 16 ;CALL function
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[rnd]       69         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   70 1      ;PUSH Bytes
CALL            1 70       ;CALL function
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_8   3 11 16 27 6 48 54 63 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              63 54 48 6 27 16 11 3 ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   14 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_4   24 30 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 30 24 ;Interpolate Point
                           #--- PUSHB_2   57 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_1   63        ;PUSH Bytes
IP              63         ;Interpolate Point
                           #--- PUSHB_2   3 45      ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   51        ;PUSH Bytes
IP              51         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E4D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_2   41 5      ;PUSH Bytes
MIRP[min,black] cvt_5 41   ;Move Indirect Relative Point
                           #--- PUSHB_3   59 2 0    ;PUSH Bytes
CALL            0 2 59     ;CALL function
                           #--- PUSHB_5   68 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 68 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_3   47 2 0    ;PUSH Bytes
CALL            0 2 47     ;CALL function
                           #--- PUSHB_5   56 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 56 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_3   66 2 0    ;PUSH Bytes
CALL            0 2 66     ;CALL function
                           #--- PUSHB_5   18 35 29 47 13 ;PUSH Bytes
CALL            13 47 29 35 18 ;CALL function
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] stemw 26   ;Move Indirect Relative Point
                           #--- PUSHB_4   12 26 44 8 ;PUSH Bytes
CALL            8 44 26 12 ;CALL function
                           #--- PUSHB_5   17 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 12 ;CALL function
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_2   8 38      ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_3   59 62 68  ;PUSH Bytes
IP              68         ;Interpolate Point
IP              62         ;Interpolate Point
IP              59         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_4   18 29 35 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 35 29 18 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_3   47 50 56  ;PUSH Bytes
IP              56         ;Interpolate Point
IP              50         ;Interpolate Point
IP              47         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_4   26 32 38 44 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              44 38 32 26 ;Interpolate Point
                           #--- PUSHB_2   68 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E4F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_2   39 5      ;PUSH Bytes
MIRP[min,black] cvt_5 39   ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   48 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 48 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_4   11 16 27 3 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              3 27 16 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_4   24 30 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 30 24 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E51': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 0 0    ;PUSH Bytes
CALL            0 0 27     ;CALL function
                           #--- PUSHB_2   39 5      ;PUSH Bytes
MIRP[min,black] cvt_5 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   48 3 0    ;PUSH Bytes
CALL            0 3 48     ;CALL function
                           #--- PUSHB_5   45 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 45 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   16 33 27 48 13 ;PUSH Bytes
CALL            13 48 27 33 16 ;CALL function
                           #--- PUSHB_2   16 5      ;PUSH Bytes
MIRP[min,black] cvt_5 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[rp0,rnd,white] 30         ;Move Direct Relative Point
                           #--- PUSHB_2   36 6      ;PUSH Bytes
MIRP[min,black] stemw 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_4   14 16 27 6 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              6 27 16 14 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_4   24 30 36 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 36 30 24 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E53': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   62 5      ;PUSH Bytes
MIRP[min,black] cvt_5 62   ;Move Indirect Relative Point
                           #--- PUSHB_3   45 0 0    ;PUSH Bytes
CALL            0 0 45     ;CALL function
                           #--- PUSHB_5   51 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 51 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_2   76 5      ;PUSH Bytes
MIRP[min,black] cvt_5 76   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP0            76         ;Set Reference Point 0
                           #--- PUSHB_5   16 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 16 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   97        ;PUSH Bytes
MDAP[rnd]       97         ;Move Direct Absolute Point
                           #--- PUSHB_1   73        ;PUSH Bytes
MDRP[rp0,rnd,white] 73         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_2   98 1      ;PUSH Bytes
CALL            1 98       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   69 67     ;PUSH Bytes
SDPVTL[orthog]  67 69      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[no-rnd]    69         ;Move Direct Absolute Point
                           #--- PUSHB_1   67        ;PUSH Bytes
MDRP[grey]      67         ;Move Direct Relative Point
                           #--- PUSHB_2   33 11     ;PUSH Bytes
MIRP[rp0,min,black] cvt_11 33  ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[grey]      35         ;Move Direct Relative Point
                           #--- PUSHB_4   34 33 35 19 ;PUSH Bytes
CALL            19 35 33 34 ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP0            69         ;Set Reference Point 0
                           #--- PUSHB_4   68 69 67 19 ;PUSH Bytes
CALL            19 67 69 68 ;CALL function
                           #--- PUSHB_3   34 33 35  ;PUSH Bytes
                           #--- DUP       #35       ;DUPlicate top stack element
ROLL            35 35 33   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              34         ;Interpolate Point
                           #--- PUSHB_3   68 69 67  ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
IP              68         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   33 34 35 67 68 69 ;PUSH Bytes
MDAP[no-rnd]    69         ;Move Direct Absolute Point
MDAP[no-rnd]    68         ;Move Direct Absolute Point
MDAP[no-rnd]    67         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    34         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   33 34 35 67 68 69 ;PUSH Bytes
MDAP[no-rnd]    69         ;Move Direct Absolute Point
MDAP[no-rnd]    68         ;Move Direct Absolute Point
MDAP[no-rnd]    67         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    34         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 73     ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_4   42 45 51 59 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              59 51 45 42 ;Interpolate Point
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_6   28 40 62 76 84 87 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              87 84 76 62 40 28 ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
                           #--- PUSHB_4   25 78 92 95 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              95 92 78 25 ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_3   12 16 9   ;PUSH Bytes
IP              9          ;Interpolate Point
IP              16         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   62 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_2   38 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_2   28 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   31 73     ;PUSH Bytes
IP              73         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
                           #--- PUSHB_1   78        ;PUSH Bytes
IP              78         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   87 95     ;PUSH Bytes
IP              95         ;Interpolate Point
IP              87         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   92        ;PUSH Bytes
IP              92         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E65': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_2   62 5      ;PUSH Bytes
MIRP[min,black] cvt_5 62   ;Move Indirect Relative Point
                           #--- PUSHB_3   45 0 0    ;PUSH Bytes
CALL            0 0 45     ;CALL function
                           #--- PUSHB_5   51 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 51 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_2   76 5      ;PUSH Bytes
MIRP[min,black] cvt_5 76   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP0            76         ;Set Reference Point 0
                           #--- PUSHB_5   16 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 16 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   100       ;PUSH Bytes
MDAP[rnd]       100        ;Move Direct Absolute Point
                           #--- PUSHB_1   73        ;PUSH Bytes
MDRP[rp0,rnd,white] 73         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_2   101 1     ;PUSH Bytes
CALL            1 101      ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   69 67     ;PUSH Bytes
SDPVTL[orthog]  67 69      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   69        ;PUSH Bytes
MDAP[no-rnd]    69         ;Move Direct Absolute Point
                           #--- PUSHB_1   67        ;PUSH Bytes
MDRP[grey]      67         ;Move Direct Relative Point
                           #--- PUSHB_2   33 11     ;PUSH Bytes
MIRP[rp0,min,black] cvt_11 33  ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[grey]      35         ;Move Direct Relative Point
                           #--- PUSHB_4   34 33 35 19 ;PUSH Bytes
CALL            19 35 33 34 ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP0            69         ;Set Reference Point 0
                           #--- PUSHB_4   68 69 67 19 ;PUSH Bytes
CALL            19 67 69 68 ;CALL function
                           #--- PUSHB_3   34 33 35  ;PUSH Bytes
                           #--- DUP       #35       ;DUPlicate top stack element
ROLL            35 35 33   ;ROLL the top three stack elements
                           #--- DUP       #&_ROLL#1 ;DUPlicate top stack element
ROLL            &_ROLL#1 &_ROLL#1 &_ROLL#2 ;ROLL the top three stack elements
SWAP            &_ROLL#1 &_ROLL#2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP#1 &_SWAP#2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL#3   ;Set Reference Point 1
SRP2            &_ROLL#3   ;Set Reference Point 2
IP              34         ;Interpolate Point
                           #--- PUSHB_3   68 69 67  ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
IP              68         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   33 34 35 67 68 69 ;PUSH Bytes
MDAP[no-rnd]    69         ;Move Direct Absolute Point
MDAP[no-rnd]    68         ;Move Direct Absolute Point
MDAP[no-rnd]    67         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    34         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_6   33 34 35 67 68 69 ;PUSH Bytes
MDAP[no-rnd]    69         ;Move Direct Absolute Point
MDAP[no-rnd]    68         ;Move Direct Absolute Point
MDAP[no-rnd]    67         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
MDAP[no-rnd]    34         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 73     ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_6   42 45 51 59 94 97 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              97 94 59 51 45 42 ;Interpolate Point
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_6   28 40 62 76 81 90 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              90 81 76 62 40 28 ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
                           #--- PUSHB_2   25 78     ;PUSH Bytes
IP              78         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_5   12 16 9 84 87 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              87 84 9 16 12 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   62 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_2   38 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_2   28 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   31 73     ;PUSH Bytes
IP              73         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
                           #--- PUSHB_1   78        ;PUSH Bytes
IP              78         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   87 90 94  ;PUSH Bytes
IP              94         ;Interpolate Point
IP              90         ;Interpolate Point
IP              87         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   84 97     ;PUSH Bytes
IP              97         ;Interpolate Point
IP              84         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E67': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   43 0 0    ;PUSH Bytes
CALL            0 0 43     ;CALL function
                           #--- PUSHB_2   62 4      ;PUSH Bytes
MIRP[min,black] stemt 62   ;Move Indirect Relative Point
                           #--- PUSHB_3   37 3 0    ;PUSH Bytes
CALL            0 3 37     ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_5   28 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 28 ;CALL function
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_3   16 2 0    ;PUSH Bytes
CALL            0 2 16     ;CALL function
                           #--- PUSHB_5   25 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 25 ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_3   35 2 0    ;PUSH Bytes
CALL            0 2 35     ;CALL function
                           #--- PUSHB_5   51 46 43 37 13 ;PUSH Bytes
CALL            13 37 43 46 51 ;CALL function
                           #--- PUSHB_3   57 65 77  ;PUSH Bytes
SHP[rp1]        77         ;SHift Point using reference point
SHP[rp1]        65         ;SHift Point using reference point
SHP[rp1]        57         ;SHift Point using reference point
                           #--- PUSHB_2   51 4      ;PUSH Bytes
MIRP[min,black] stemt 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SHP[rp2]        71         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
                           #--- DUP       #28       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
SRP1            28         ;Set Reference Point 1
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDRP[rp0,rnd,white] 45         ;Move Direct Relative Point
                           #--- PUSHB_2   59 6      ;PUSH Bytes
MIRP[min,black] stemw 59   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 45 48 14 ;PUSH Bytes
CALL            14 48 45 8 ;CALL function
                           #--- PUSHB_5   55 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 55 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   64 1      ;PUSH Bytes
CALL            1 64       ;CALL function
                           #--- PUSHB_2   40 6      ;PUSH Bytes
MIRP[min,black] stemw 40   ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_4   8 40 75 14 ;PUSH Bytes
CALL            14 75 40 8 ;CALL function
                           #--- PUSHB_5   68 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 68 ;CALL function
                           #--- PUSHB_1   68        ;PUSH Bytes
MDAP[rnd]       68         ;Move Direct Absolute Point
                           #--- PUSHB_5   75 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 75 ;CALL function
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   59 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_2   31 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              31         ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_3   28 43 37  ;PUSH Bytes
IP              37         ;Interpolate Point
IP              43         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_2   3 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
                           #--- PUSHB_4   11 16 62 25 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              25 62 16 11 ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_3   19 14 22  ;PUSH Bytes
IP              22         ;Interpolate Point
IP              14         ;Interpolate Point
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_2   3 16      ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E79': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_2   40 4      ;PUSH Bytes
MIRP[min,black] stemt 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   59 3 0    ;PUSH Bytes
CALL            0 3 59     ;CALL function
                           #--- PUSHB_5   56 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 56 ;CALL function
                           #--- PUSHB_5   29 24 21 59 13 ;PUSH Bytes
CALL            13 59 21 24 29 ;CALL function
                           #--- PUSHB_3   35 43 55  ;PUSH Bytes
SHP[rp1]        55         ;SHift Point using reference point
SHP[rp1]        43         ;SHift Point using reference point
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_2   29 4      ;PUSH Bytes
MIRP[min,black] stemt 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
                           #--- PUSHB_5   1 4 0 34 4 ;PUSH Bytes
CALL            4 34 0 4 1 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] stemw 37   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 23 26 14 ;PUSH Bytes
CALL            14 26 23 8 ;CALL function
                           #--- PUSHB_5   33 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 33 ;CALL function
                           #--- PUSHB_4   8 37 23 8 ;PUSH Bytes
CALL            8 23 37 8  ;CALL function
                           #--- PUSHB_5   3 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 3 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_4   8 18 53 14 ;PUSH Bytes
CALL            14 53 18 8 ;CALL function
                           #--- PUSHB_5   46 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   53 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 53 ;CALL function
                           #--- PUSHB_4   12 18 42 8 ;PUSH Bytes
CALL            8 42 18 12 ;CALL function
                           #--- PUSHB_5   17 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 6 0 34 4 ;PUSH Bytes
CALL            4 34 0 6 12 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   37 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_2   42 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_3   10 15 40  ;PUSH Bytes
IP              40         ;Interpolate Point
IP              15         ;Interpolate Point
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1E7B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   55 0 0    ;PUSH Bytes
CALL            0 0 55     ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp1]        73         ;SHift Point using reference point
                           #--- PUSHB_2   60 5      ;PUSH Bytes
MIRP[min,black] cvt_5 60   ;Move Indirect Relative Point
                           #--- PUSHB_3   46 50 70  ;PUSH Bytes
SHP[rp2]        70         ;SHift Point using reference point
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   78 5      ;PUSH Bytes
MIRP[min,black] cvt_5 78   ;Move Indirect Relative Point
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_2   68 5      ;PUSH Bytes
MIRP[min,black] cvt_5 68   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_4   0 21 12 8 ;PUSH Bytes
CALL            8 12 21 0  ;CALL function
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   79        ;PUSH Bytes
MDAP[rnd]       79         ;Move Direct Absolute Point
                           #--- PUSHB_2   80 1      ;PUSH Bytes
CALL            1 80       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   68 62     ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_5   24 27 30 37 40 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              40 37 30 27 24 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   18 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1EAB': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp1]        65         ;SHift Point using reference point
                           #--- PUSHB_2   52 5      ;PUSH Bytes
MIRP[min,black] cvt_5 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 42 62  ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_5   15 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 15 ;CALL function
                           #--- PUSHB_3   5 15 10   ;PUSH Bytes
CALL            10 15 5    ;CALL function
                           #--- PUSHB_4   0 5 0 9   ;PUSH Bytes
CALL            9 0 5 0    ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   41 70 47 0 13 ;PUSH Bytes
CALL            13 0 47 70 41 ;CALL function
                           #--- PUSHB_2   41 5      ;PUSH Bytes
MIRP[min,black] cvt_5 41   ;Move Indirect Relative Point
                           #--- PUSHB_5   60 54 47 0 13 ;PUSH Bytes
CALL            13 0 47 54 60 ;CALL function
                           #--- PUSHB_2   60 5      ;PUSH Bytes
MIRP[min,black] cvt_5 60   ;Move Indirect Relative Point
                           #--- PUSHB_4   22 5 0 8  ;PUSH Bytes
CALL            8 0 5 22   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   60 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1EAF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp1]        65         ;SHift Point using reference point
                           #--- PUSHB_2   52 5      ;PUSH Bytes
MIRP[min,black] cvt_5 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 42 62  ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_3   5 2 0     ;PUSH Bytes
CALL            0 2 5      ;CALL function
                           #--- PUSHB_5   15 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 15 ;CALL function
                           #--- PUSHB_3   5 15 10   ;PUSH Bytes
CALL            10 15 5    ;CALL function
                           #--- PUSHB_4   0 5 0 9   ;PUSH Bytes
CALL            9 0 5 0    ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   41 70 47 0 13 ;PUSH Bytes
CALL            13 0 47 70 41 ;CALL function
                           #--- PUSHB_2   41 5      ;PUSH Bytes
MIRP[min,black] cvt_5 41   ;Move Indirect Relative Point
                           #--- PUSHB_5   60 54 47 0 13 ;PUSH Bytes
CALL            13 0 47 54 60 ;CALL function
                           #--- PUSHB_2   60 5      ;PUSH Bytes
MIRP[min,black] cvt_5 60   ;Move Indirect Relative Point
                           #--- PUSHB_4   25 5 0 8  ;PUSH Bytes
CALL            8 0 5 25   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   71        ;PUSH Bytes
MDAP[rnd]       71         ;Move Direct Absolute Point
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   60 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1EB1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   63 0 0    ;PUSH Bytes
CALL            0 0 63     ;CALL function
                           #--- PUSHB_1   81        ;PUSH Bytes
SHP[rp1]        81         ;SHift Point using reference point
                           #--- PUSHB_2   68 5      ;PUSH Bytes
MIRP[min,black] cvt_5 68   ;Move Indirect Relative Point
                           #--- PUSHB_3   54 58 78  ;PUSH Bytes
SHP[rp2]        78         ;SHift Point using reference point
SHP[rp2]        58         ;SHift Point using reference point
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_2   86 5      ;PUSH Bytes
MIRP[min,black] cvt_5 86   ;Move Indirect Relative Point
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_2   76 5      ;PUSH Bytes
MIRP[min,black] cvt_5 76   ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_5   37 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 37 ;CALL function
                           #--- PUSHB_3   37 47 10  ;PUSH Bytes
CALL            10 47 37   ;CALL function
                           #--- PUSHB_4   0 37 32 9 ;PUSH Bytes
CALL            9 32 37 0  ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 29 ;CALL function
                           #--- PUSHB_3   18 29 10  ;PUSH Bytes
CALL            10 29 18   ;CALL function
                           #--- PUSHB_4   0 18 23 9 ;PUSH Bytes
CALL            9 23 18 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   87        ;PUSH Bytes
MDAP[rnd]       87         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_5   20 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 20 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_2   88 1      ;PUSH Bytes
CALL            1 88       ;CALL function
                           #--- PUSHB_2   20 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   47 57 58 69 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              69 58 57 47 ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_1   86        ;PUSH Bytes
IP              86         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   13 18 29  ;PUSH Bytes
IP              29         ;Interpolate Point
IP              18         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   4 85      ;PUSH Bytes
IP              85         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   76 70     ;PUSH Bytes
SRP1            70         ;Set Reference Point 1
SRP2            76         ;Set Reference Point 2
                           #--- PUSHB_1   73        ;PUSH Bytes
IP              73         ;Interpolate Point
                           #--- PUSHB_2   18 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1EB3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   55 0 0    ;PUSH Bytes
CALL            0 0 55     ;CALL function
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp1]        73         ;SHift Point using reference point
                           #--- PUSHB_2   60 5      ;PUSH Bytes
MIRP[min,black] cvt_5 60   ;Move Indirect Relative Point
                           #--- PUSHB_3   46 50 70  ;PUSH Bytes
SHP[rp2]        70         ;SHift Point using reference point
SHP[rp2]        50         ;SHift Point using reference point
SHP[rp2]        46         ;SHift Point using reference point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_2   78 5      ;PUSH Bytes
MIRP[min,black] cvt_5 78   ;Move Indirect Relative Point
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_2   68 5      ;PUSH Bytes
MIRP[min,black] cvt_5 68   ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 29 ;CALL function
                           #--- PUSHB_3   29 39 10  ;PUSH Bytes
CALL            10 39 29   ;CALL function
                           #--- PUSHB_4   0 29 24 9 ;PUSH Bytes
CALL            9 24 29 0  ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_4   0 21 12 8 ;PUSH Bytes
CALL            8 12 21 0  ;CALL function
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   79        ;PUSH Bytes
MDAP[rnd]       79         ;Move Direct Absolute Point
                           #--- PUSHB_2   80 1      ;PUSH Bytes
CALL            1 80       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   68 62     ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_1   65        ;PUSH Bytes
IP              65         ;Interpolate Point
                           #--- PUSHB_2   12 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1EB5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_2   51 5      ;PUSH Bytes
MIRP[min,black] cvt_5 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   86        ;PUSH Bytes
SHP[rp2]        86         ;SHift Point using reference point
                           #--- PUSHB_3   48 0 0    ;PUSH Bytes
CALL            0 0 48     ;CALL function
                           #--- PUSHB_5   43 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 43 ;CALL function
                           #--- PUSHB_1   85        ;PUSH Bytes
MDAP[rnd]       85         ;Move Direct Absolute Point
                           #--- PUSHB_2   70 5      ;PUSH Bytes
MIRP[min,black] cvt_5 70   ;Move Indirect Relative Point
                           #--- PUSHB_4   10 85 80 14 ;PUSH Bytes
CALL            14 80 85 10 ;CALL function
                           #--- PUSHB_5   75 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 75 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp1]        68         ;SHift Point using reference point
                           #--- PUSHB_2   59 5      ;PUSH Bytes
MIRP[min,black] cvt_5 59   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_5   64 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 64 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_4   0 21 12 8 ;PUSH Bytes
CALL            8 12 21 0  ;CALL function
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   91        ;PUSH Bytes
MDAP[rnd]       91         ;Move Direct Absolute Point
                           #--- PUSHB_1   52        ;PUSH Bytes
MDRP[rp0,rnd,white] 52         ;Move Direct Relative Point
                           #--- PUSHB_2   86 6      ;PUSH Bytes
MIRP[min,black] stemw 86   ;Move Indirect Relative Point
                           #--- PUSHB_1   69        ;PUSH Bytes
SHP[rp2]        69         ;SHift Point using reference point
                           #--- PUSHB_3   52 86 10  ;PUSH Bytes
CALL            10 86 52   ;CALL function
                           #--- PUSHB_4   64 52 50 9 ;PUSH Bytes
CALL            9 50 52 64 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SHP[rp2]        56         ;SHift Point using reference point
                           #--- PUSHB_1   86        ;PUSH Bytes
SRP0            86         ;Set Reference Point 0
                           #--- PUSHB_2   83 1      ;PUSH Bytes
CALL            1 83       ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
SHP[rp2]        71         ;SHift Point using reference point
                           #--- PUSHB_2   78 6      ;PUSH Bytes
MIRP[min,black] stemw 78   ;Move Indirect Relative Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP0            78         ;Set Reference Point 0
                           #--- PUSHB_2   87 1      ;PUSH Bytes
CALL            1 87       ;CALL function
                           #--- PUSHB_2   46 6      ;PUSH Bytes
MIRP[min,black] stemw 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   67        ;PUSH Bytes
                           #--- DUP       #67       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 67         ;Move Direct Relative Point
SRP1            67         ;Set Reference Point 1
                           #--- PUSHB_2   61 6      ;PUSH Bytes
MIRP[min,black] stemw 61   ;Move Indirect Relative Point
                           #--- PUSHB_2   92 1      ;PUSH Bytes
CALL            1 92       ;CALL function
                           #--- PUSHB_2   86 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            86         ;Set Reference Point 2
                           #--- PUSHB_4   15 27 18 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 18 27 15 ;Interpolate Point
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP1            83         ;Set Reference Point 1
                           #--- PUSHB_2   21 12     ;PUSH Bytes
IP              12         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP2            78         ;Set Reference Point 2
                           #--- PUSHB_4   9 0 34 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 34 0 9  ;Interpolate Point
                           #--- PUSHB_2   87 67     ;PUSH Bytes
SRP1            67         ;Set Reference Point 1
SRP2            87         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_5   3 37 43 6 64 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              64 6 43 37 3 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   59 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   27 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1EC5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   54 0 0    ;PUSH Bytes
CALL            0 0 54     ;CALL function
                           #--- PUSHB_2   66 5      ;PUSH Bytes
MIRP[min,black] cvt_5 66   ;Move Indirect Relative Point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_2   43 5      ;PUSH Bytes
MIRP[min,black] cvt_5 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 21 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_4   0 21 12 8 ;PUSH Bytes
CALL            8 12 21 0  ;CALL function
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_1   57        ;PUSH Bytes
MDRP[rp0,rnd,white] 57         ;Move Direct Relative Point
                           #--- PUSHB_2   63 6      ;PUSH Bytes
MIRP[min,black] stemw 63   ;Move Indirect Relative Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_2   51 6      ;PUSH Bytes
MIRP[min,black] stemw 51   ;Move Indirect Relative Point
                           #--- PUSHB_2   73 1      ;PUSH Bytes
CALL            1 73       ;CALL function
                           #--- PUSHB_2   69 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_7   3 9 30 37 43 54 18 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              18 54 43 37 30 9 3 ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   60 66     ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_4   51 57 63 69 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              69 63 57 51 ;Interpolate Point
                           #--- PUSHB_2   9 43      ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   27 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   21 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni1ED7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2010': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 0 ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   0 19      ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_8   5 7 8 16 25 26 29 31 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              31 29 26 25 16 8 7 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2036': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 14 ;CALL function
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   14 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   2 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2038': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_5   17 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 17 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni203b': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_5   28 4 0 22 4 ;PUSH Bytes
CALL            4 22 0 4 28 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_5   8 4 0 22 4 ;PUSH Bytes
CALL            4 22 0 4 8 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_5   38 4 0 22 4 ;PUSH Bytes
CALL            4 22 0 4 38 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
                           #--- PUSHB_5   20 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 20 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_5   10 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 10 ;CALL function
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_4   60 63 69 72 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              72 69 63 60 ;Interpolate Point
                           #--- PUSHB_2   20 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_4   48 57 66 75 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              75 66 57 48 ;Interpolate Point
                           #--- PUSHB_2   10 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_4   42 45 51 54 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              54 51 45 42 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   51 54 60 63 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              63 60 54 51 ;Interpolate Point
                           #--- PUSHB_2   8 3       ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_4   48 57 66 75 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              75 66 57 48 ;Interpolate Point
                           #--- PUSHB_2   38 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_4   42 45 69 72 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              72 69 45 42 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni203e': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_5   7 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 7 ;CALL function
                           #--- PUSHB_3   7 29 10   ;PUSH Bytes
CALL            10 29 7    ;CALL function
                           #--- PUSHB_4   0 7 0 9   ;PUSH Bytes
CALL            9 0 7 0    ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 3 ;CALL function
                           #--- PUSHB_3   3 32 10   ;PUSH Bytes
CALL            10 32 3    ;CALL function
                           #--- PUSHB_4   0 3 26 9  ;PUSH Bytes
CALL            9 26 3 0   ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   3 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2040': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 2 0    ;PUSH Bytes
CALL            0 2 21     ;CALL function
                           #--- PUSHB_5   7 5 0 35 4 ;PUSH Bytes
CALL            4 35 0 5 7 ;CALL function
                           #--- PUSHB_3   7 21 10   ;PUSH Bytes
CALL            10 21 7    ;CALL function
                           #--- PUSHB_4   0 7 0 9   ;PUSH Bytes
CALL            9 0 7 0    ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_5   24 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 24 ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   13 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2041': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   21 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 21 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
                           #--- DUP       #8        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_5   13 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 13 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   8 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_2   13 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   10 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2043': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_5   62 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 62 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
MDRP[rp0,rnd,white] 46         ;Move Direct Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_5   41 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 41 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   41 46     ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 62      ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   2 16 22   ;PUSH Bytes
IP              22         ;Interpolate Point
IP              16         ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2046': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 3 0    ;PUSH Bytes
CALL            0 3 40     ;CALL function
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 8 10   ;PUSH Bytes
CALL            10 8 20    ;CALL function
                           #--- PUSHB_4   0 20 14 9 ;PUSH Bytes
CALL            9 14 20 0  ;CALL function
                           #--- PUSHB_2   25 37     ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   8 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   27 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2048': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_5   15 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 15 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_5   12 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 12 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_5   38 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 38 ;CALL function
                           #--- PUSHB_3   13 38 10  ;PUSH Bytes
CALL            10 38 13   ;CALL function
                           #--- PUSHB_4   64 13 11 9 ;PUSH Bytes
CALL            9 11 13 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   27 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 27 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   27 42 10  ;PUSH Bytes
CALL            10 42 27   ;CALL function
                           #--- PUSHB_4   64 27 1 9 ;PUSH Bytes
CALL            9 1 27 64  ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_5   23 6 0 54 4 ;PUSH Bytes
CALL            4 54 0 6 23 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   42 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   6 38 40 42 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              42 40 38 6 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_3   26 29 36  ;PUSH Bytes
IP              36         ;Interpolate Point
IP              29         ;Interpolate Point
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni204C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_5   23 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 23 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
                           #--- PUSHB_5   23 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_5   7 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 7 ;CALL function
                           #--- PUSHB_3   7 24 10   ;PUSH Bytes
CALL            10 24 7    ;CALL function
                           #--- PUSHB_4   64 7 11 9 ;PUSH Bytes
CALL            9 11 7 64  ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni204a': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_5   0 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   0 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_2   3 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni204d': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 2 0    ;PUSH Bytes
CALL            0 2 13     ;CALL function
                           #--- PUSHB_5   42 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 42 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   12 4 0 24 4 ;PUSH Bytes
CALL            4 24 0 4 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDRP[rp0,rnd,white] 49         ;Move Direct Relative Point
                           #--- PUSHB_5   44 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_4   12 28 10 14 ;PUSH Bytes
CALL            14 10 28 12 ;CALL function
                           #--- PUSHB_5   3 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 3 ;CALL function
                           #--- PUSHB_4   20 34 28 8 ;PUSH Bytes
CALL            8 28 34 20 ;CALL function
                           #--- PUSHB_5   25 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_5   20 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 20 ;CALL function
                           #--- PUSHB_3   25 20 10  ;PUSH Bytes
CALL            10 20 25   ;CALL function
                           #--- PUSHB_4   64 25 28 9 ;PUSH Bytes
CALL            9 28 25 64 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   16 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 16 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   10 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_2   25 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   42        ;PUSH Bytes
IP              42         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_2   13 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_3   16 23 47  ;PUSH Bytes
IP              47         ;Interpolate Point
IP              23         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   50        ;PUSH Bytes
IP              50         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni204f': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_5   21 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 21 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 13 ;CALL function
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_2   13 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   0 9       ;PUSH Bytes
IP              9          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2050': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   82 0 0    ;PUSH Bytes
CALL            0 0 82     ;CALL function
                           #--- PUSHB_2   74 78     ;PUSH Bytes
SHP[rp1]        78         ;SHift Point using reference point
SHP[rp1]        74         ;SHift Point using reference point
                           #--- PUSHB_5   41 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 41 ;CALL function
                           #--- PUSHB_2   21 31     ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   51 1 0    ;PUSH Bytes
CALL            0 1 51     ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp1]        11         ;SHift Point using reference point
                           #--- PUSHB_5   62 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 62 ;CALL function
                           #--- PUSHB_3   60 1 0    ;PUSH Bytes
CALL            0 1 60     ;CALL function
                           #--- PUSHB_5   37 87 82 51 13 ;PUSH Bytes
CALL            13 51 82 87 37 ;CALL function
                           #--- PUSHB_2   68 90     ;PUSH Bytes
SHP[rp1]        90         ;SHift Point using reference point
SHP[rp1]        68         ;SHift Point using reference point
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
                           #--- PUSHB_2   16 26     ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_5   56 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 56 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   92        ;PUSH Bytes
MDAP[rnd]       92         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
MDRP[rp0,rnd,white] 64         ;Move Direct Relative Point
                           #--- PUSHB_5   49 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 49 ;CALL function
                           #--- PUSHB_4   39 49 64 8 ;PUSH Bytes
CALL            8 64 49 39 ;CALL function
                           #--- PUSHB_5   85 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 85 ;CALL function
                           #--- PUSHB_1   85        ;PUSH Bytes
MDAP[rnd]       85         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 39 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_5   59 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 59 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_1   29        ;PUSH Bytes
                           #--- DUP       #29       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_5   44 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_5   29 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 29 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   19 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_5   71 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 71 ;CALL function
                           #--- PUSHB_2   93 1      ;PUSH Bytes
CALL            1 93       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   8 9       ;PUSH Bytes
SDPVTL[orthog]  9 8        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[no-rnd]    8          ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[grey]      9          ;Move Direct Relative Point
                           #--- PUSHB_2   1 8       ;PUSH Bytes
MIRP[rp0,min,black] cvt_8 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[grey]      0          ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   0 1 8 9   ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   0 1 8 9   ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   49 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_2   3 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_8   37 41 46 51 56 62 82 87 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              87 82 62 56 51 46 41 37 ;Interpolate Point
                           #--- PUSHB_2   29 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   80 89     ;PUSH Bytes
IP              89         ;Interpolate Point
IP              80         ;Interpolate Point
                           #--- PUSHB_2   34 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_3   27 31 78  ;PUSH Bytes
IP              78         ;Interpolate Point
IP              31         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_2   66 76     ;PUSH Bytes
IP              76         ;Interpolate Point
IP              66         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_3   14 68 74  ;PUSH Bytes
IP              74         ;Interpolate Point
IP              68         ;Interpolate Point
IP              14         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 82     ;PUSH Bytes
SRP1            82         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   76 80     ;PUSH Bytes
IP              80         ;Interpolate Point
IP              76         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_2   71 85     ;PUSH Bytes
IP              85         ;Interpolate Point
IP              71         ;Interpolate Point
                           #--- PUSHB_1   87        ;PUSH Bytes
SRP2            87         ;Set Reference Point 2
                           #--- PUSHB_2   66 89     ;PUSH Bytes
IP              89         ;Interpolate Point
IP              66         ;Interpolate Point
                           #--- PUSHB_2   51 62     ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_2   59 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              59         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2055': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   32 2 0    ;PUSH Bytes
CALL            0 2 32     ;CALL function
                           #--- PUSHB_1   67        ;PUSH Bytes
SHP[rp1]        67         ;SHift Point using reference point
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   85        ;PUSH Bytes
SHP[rp1]        85         ;SHift Point using reference point
                           #--- PUSHB_5   79 4 0 14 4 ;PUSH Bytes
CALL            4 14 0 4 79 ;CALL function
                           #--- PUSHB_1   91        ;PUSH Bytes
SHP[rp2]        91         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
                           #--- PUSHB_5   13 4 0 22 4 ;PUSH Bytes
CALL            4 22 0 4 13 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   94        ;PUSH Bytes
MDAP[rnd]       94         ;Move Direct Absolute Point
                           #--- PUSHB_1   77        ;PUSH Bytes
MDRP[rp0,rnd,white] 77         ;Move Direct Relative Point
                           #--- PUSHB_5   71 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 71 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
                           #--- DUP       #27       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_4   12 71 77 8 ;PUSH Bytes
CALL            8 77 71 12 ;CALL function
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   16 11     ;PUSH Bytes
CALL            11 16      ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   89 1      ;PUSH Bytes
CALL            1 89       ;CALL function
                           #--- PUSHB_5   83 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 83 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
                           #--- DUP       #63       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 63         ;Move Direct Relative Point
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_2   57 6      ;PUSH Bytes
MIRP[min,black] stemw 57   ;Move Indirect Relative Point
                           #--- PUSHB_4   47 83 89 8 ;PUSH Bytes
CALL            8 89 83 47 ;CALL function
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP0            83         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_2   95 1      ;PUSH Bytes
CALL            1 95       ;CALL function
                           #--- PUSHB_2   12 77     ;PUSH Bytes
SRP1            77         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   6 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_3   9 18 32   ;PUSH Bytes
IP              32         ;Interpolate Point
IP              18         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   47 89     ;PUSH Bytes
SRP1            89         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_2   41 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   44 54 67  ;PUSH Bytes
IP              67         ;Interpolate Point
IP              54         ;Interpolate Point
IP              44         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   5 40      ;PUSH Bytes
IP              40         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_8   0 16 20 24 35 51 56 60 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              60 56 51 35 24 20 16 0 ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   28 64     ;PUSH Bytes
IP              64         ;Interpolate Point
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2064': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 3 0     ;PUSH Bytes
CALL            0 3 1      ;CALL function
                           #--- PUSHB_5   22 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 22 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   16 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 16 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   4 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 4 ;CALL function
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   18 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   1 7 0     ;PUSH Bytes
IP              0          ;Interpolate Point
IP              7          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni207A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 2 0     ;PUSH Bytes
CALL            0 2 8      ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp1]        19         ;SHift Point using reference point
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_3   28 3 10   ;PUSH Bytes
CALL            10 3 28    ;CALL function
                           #--- PUSHB_4   64 28 24 9 ;PUSH Bytes
CALL            9 24 28 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDRP[rp0,rnd,white] 26         ;Move Direct Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_5   21 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 21 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   21 26 10  ;PUSH Bytes
CALL            10 26 21   ;CALL function
                           #--- PUSHB_4   64 21 16 9 ;PUSH Bytes
CALL            9 16 21 64 ;CALL function
                           #--- PUSHB_3   26 21 10  ;PUSH Bytes
CALL            10 21 26   ;CALL function
                           #--- PUSHB_4   64 26 1 9 ;PUSH Bytes
CALL            9 1 26 64  ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni207B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   7 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 7  ;CALL function
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni207C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 7 ;CALL function
                           #--- PUSHB_3   7 21 10   ;PUSH Bytes
CALL            10 21 7    ;CALL function
                           #--- PUSHB_4   0 7 3 9   ;PUSH Bytes
CALL            9 3 7 0    ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni208A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   47 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 47 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
                           #--- DUP       #16       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_5   26 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 26 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_5   5 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_5   44 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   17 28     ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_3   9 38 10   ;PUSH Bytes
CALL            10 38 9    ;CALL function
                           #--- PUSHB_4   64 9 13 9 ;PUSH Bytes
CALL            9 13 9 64  ;CALL function
                           #--- PUSHB_3   38 9 10   ;PUSH Bytes
CALL            10 9 38    ;CALL function
                           #--- PUSHB_4   0 38 0 9  ;PUSH Bytes
CALL            9 0 38 0   ;CALL function
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   38 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_4   20 26 41 47 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              47 41 26 20 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   13 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   41 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_3   23 38 44  ;PUSH Bytes
IP              44         ;Interpolate Point
IP              38         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_2   32 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2091': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   18 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 18 ;CALL function
                           #--- PUSHB_3   18 3 10   ;PUSH Bytes
CALL            10 3 18    ;CALL function
                           #--- PUSHB_4   0 18 22 9 ;PUSH Bytes
CALL            9 22 18 0  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_5   25 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 25 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 9 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2092': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   18 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 18 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   9 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 9 ;CALL function
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   21 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_3   9 15 21   ;PUSH Bytes
IP              21         ;Interpolate Point
IP              15         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2093': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_5   29 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 29 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 13 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 0 ;CALL function
                           #--- PUSHB_2   54 1      ;PUSH Bytes
CALL            1 54       ;CALL function
                           #--- PUSHB_2   13 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_4   11 22 23 35 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              35 23 22 11 ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_2   10 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_4   9 37 46 50 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              50 46 37 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- NPUSHB    10 7 0 11 13 20 26 33 36 39 46 ;PUSH N Bytes
                           #--- DEPTH     #10       ;DEPTH of the stack
SLOOP           10         ;Set LOOP variable
IP              46 39 36 33 26 20 13 11 0 7 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2094': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   26 2 0    ;PUSH Bytes
CALL            0 2 26     ;CALL function
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   2 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 2 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 13 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   13 3 10   ;PUSH Bytes
CALL            10 3 13    ;CALL function
                           #--- PUSHB_4   64 13 17 9 ;PUSH Bytes
CALL            9 17 13 64 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_5   8 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_5   26 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_3   26 13 10  ;PUSH Bytes
CALL            10 13 26   ;CALL function
                           #--- PUSHB_4   64 26 0 9 ;PUSH Bytes
CALL            9 0 26 64  ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2101': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 0 0    ;PUSH Bytes
CALL            0 0 21     ;CALL function
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_5   33 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 33 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   44 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 44 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_3   5 44 10   ;PUSH Bytes
CALL            10 44 5    ;CALL function
                           #--- PUSHB_4   64 5 0 9  ;PUSH Bytes
CALL            9 0 5 64   ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_5   102 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 102 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
                           #--- DUP       #59       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 59         ;Move Direct Relative Point
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_5   92 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 92 ;CALL function
                           #--- PUSHB_1   96        ;PUSH Bytes
MDAP[rnd]       96         ;Move Direct Absolute Point
                           #--- PUSHB_5   71 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 71 ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_1   73        ;PUSH Bytes
                           #--- DUP       #73       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 73         ;Move Direct Relative Point
SRP1            73         ;Set Reference Point 1
                           #--- PUSHB_5   105 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 105 ;CALL function
                           #--- PUSHB_1   77        ;PUSH Bytes
MDAP[rnd]       77         ;Move Direct Absolute Point
                           #--- PUSHB_5   86 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 86 ;CALL function
                           #--- PUSHB_3   77 86 10  ;PUSH Bytes
CALL            10 86 77   ;CALL function
                           #--- PUSHB_4   0 77 80 9 ;PUSH Bytes
CALL            9 80 77 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   124       ;PUSH Bytes
MDAP[rnd]       124        ;Move Direct Absolute Point
                           #--- PUSHB_1   66        ;PUSH Bytes
MDRP[rp0,rnd,white] 66         ;Move Direct Relative Point
                           #--- PUSHB_5   99 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 99 ;CALL function
                           #--- PUSHB_1   99        ;PUSH Bytes
SRP0            99         ;Set Reference Point 0
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_5   89 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 89 ;CALL function
                           #--- PUSHB_3   89 75 10  ;PUSH Bytes
CALL            10 75 89   ;CALL function
                           #--- PUSHB_4   64 89 56 9 ;PUSH Bytes
CALL            9 56 89 64 ;CALL function
                           #--- PUSHB_3   75 89 10  ;PUSH Bytes
CALL            10 89 75   ;CALL function
                           #--- PUSHB_4   0 75 83 9 ;PUSH Bytes
CALL            9 83 75 0  ;CALL function
                           #--- PUSHB_4   8 89 75 8 ;PUSH Bytes
CALL            8 75 89 8  ;CALL function
                           #--- PUSHB_5   41 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 41 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 8 ;CALL function
                           #--- PUSHB_3   8 41 10   ;PUSH Bytes
CALL            10 41 8    ;CALL function
                           #--- PUSHB_4   0 8 51 9  ;PUSH Bytes
CALL            9 51 8 0   ;CALL function
                           #--- PUSHB_1   89        ;PUSH Bytes
SRP0            89         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   14 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 14 ;CALL function
                           #--- PUSHB_3   36 14 10  ;PUSH Bytes
CALL            10 14 36   ;CALL function
                           #--- PUSHB_4   0 36 24 9 ;PUSH Bytes
CALL            9 24 36 0  ;CALL function
                           #--- PUSHB_2   125 1     ;PUSH Bytes
CALL            1 125      ;CALL function
                           #--- PUSHB_2   41 99     ;PUSH Bytes
SRP1            99         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_4   63 71 96 102 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              102 96 71 63 ;Interpolate Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
                           #--- PUSHB_5   39 60 61 104 105 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              105 104 61 60 39 ;Interpolate Point
                           #--- PUSHB_2   89 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            89         ;Set Reference Point 2
                           #--- PUSHB_2   38 92     ;PUSH Bytes
IP              92         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_2   14 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   19 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_5   14 29 41 109 112 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              112 109 41 29 14 ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   46 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              46         ;Interpolate Point
                           #--- PUSHB_2   102 59    ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            102        ;Set Reference Point 2
                           #--- PUSHB_3   56 61 121 ;PUSH Bytes
IP              121        ;Interpolate Point
IP              61         ;Interpolate Point
IP              56         ;Interpolate Point
                           #--- PUSHB_1   92        ;PUSH Bytes
SRP1            92         ;Set Reference Point 1
                           #--- PUSHB_1   66        ;PUSH Bytes
IP              66         ;Interpolate Point
                           #--- PUSHB_1   105       ;PUSH Bytes
SRP2            105        ;Set Reference Point 2
                           #--- PUSHB_3   99 104 118 ;PUSH Bytes
IP              118        ;Interpolate Point
IP              104        ;Interpolate Point
IP              99         ;Interpolate Point
                           #--- PUSHB_2   77 71     ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
SRP2            77         ;Set Reference Point 2
                           #--- PUSHB_2   75 89     ;PUSH Bytes
IP              89         ;Interpolate Point
IP              75         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2103': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   0 0 5 9   ;PUSH Bytes
CALL            9 5 0 0    ;CALL function
                           #--- PUSHB_3   18 2 0    ;PUSH Bytes
CALL            0 2 18     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 2 0    ;PUSH Bytes
CALL            0 2 23     ;CALL function
                           #--- PUSHB_5   29 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 29 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_1   56        ;PUSH Bytes
                           #--- DUP       #56       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 56         ;Move Direct Relative Point
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_5   53 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 53 ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_5   47 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 47 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_5   64 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 64 ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP0            64         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   41 6      ;PUSH Bytes
MIRP[min,black] stemw 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_5   59 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 59 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   59 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_4   47 53 56 61 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              61 56 53 47 ;Interpolate Point
                           #--- PUSHB_2   32 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_3   0 11 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              11         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_3   3 21 5    ;PUSH Bytes
IP              5          ;Interpolate Point
IP              21         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_2   61 56     ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_2   50 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              50         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2112': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   32 4      ;PUSH Bytes
MIRP[min,black] stemt 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   32 0 10   ;PUSH Bytes
CALL            10 0 32    ;CALL function
                           #--- PUSHB_4   0 32 35 9 ;PUSH Bytes
CALL            9 35 32 0  ;CALL function
                           #--- PUSHB_3   14 2 0    ;PUSH Bytes
CALL            0 2 14     ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 14 10  ;PUSH Bytes
CALL            10 14 24   ;CALL function
                           #--- PUSHB_4   0 24 20 9 ;PUSH Bytes
CALL            9 20 24 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   30 8 10   ;PUSH Bytes
CALL            10 8 30    ;CALL function
                           #--- PUSHB_4   64 30 38 9 ;PUSH Bytes
CALL            9 38 30 64 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_1   11        ;PUSH Bytes
                           #--- DUP       #11       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 11 10  ;PUSH Bytes
CALL            10 11 27   ;CALL function
                           #--- PUSHB_4   0 27 17 9 ;PUSH Bytes
CALL            9 17 27 0  ;CALL function
                           #--- PUSHB_3   11 27 10  ;PUSH Bytes
CALL            10 27 11   ;CALL function
                           #--- PUSHB_4   64 11 2 9 ;PUSH Bytes
CALL            9 2 11 64  ;CALL function
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   8 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_2   30 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   5 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2121': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   70 0 0    ;PUSH Bytes
CALL            0 0 70     ;CALL function
                           #--- PUSHB_2   8 32      ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_5   74 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 74 ;CALL function
                           #--- PUSHB_5   1 13 25 37 64 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
SHP[rp2]        64 37 25 13 1 ;SHift Point using reference point
                           #--- PUSHB_3   70 0 0    ;PUSH Bytes
CALL            0 0 70     ;CALL function
                           #--- PUSHB_5   29 4 0 33 4 ;PUSH Bytes
CALL            4 33 0 4 29 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   51 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 51 ;CALL function
                           #--- PUSHB_3   24 51 10  ;PUSH Bytes
CALL            10 51 24   ;CALL function
                           #--- PUSHB_4   64 24 60 9 ;PUSH Bytes
CALL            9 60 24 64 ;CALL function
                           #--- PUSHB_3   51 24 10  ;PUSH Bytes
CALL            10 24 51   ;CALL function
                           #--- PUSHB_4   64 51 55 9 ;PUSH Bytes
CALL            9 55 51 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_3   0 14 49   ;PUSH Bytes
SHP[rp1]        49         ;SHift Point using reference point
SHP[rp1]        14         ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   42 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 42 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   38 42 10  ;PUSH Bytes
CALL            10 42 38   ;CALL function
                           #--- PUSHB_4   64 38 46 9 ;PUSH Bytes
CALL            9 46 38 64 ;CALL function
                           #--- PUSHB_1   77        ;PUSH Bytes
MDAP[rnd]       77         ;Move Direct Absolute Point
                           #--- PUSHB_1   91        ;PUSH Bytes
SHP[rp1]        91         ;SHift Point using reference point
                           #--- PUSHB_5   83 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 83 ;CALL function
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP0            83         ;Set Reference Point 0
                           #--- PUSHB_5   80 4 0 23 4 ;PUSH Bytes
CALL            4 23 0 4 80 ;CALL function
                           #--- PUSHB_1   87        ;PUSH Bytes
SHP[rp2]        87         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   93        ;PUSH Bytes
MDAP[rnd]       93         ;Move Direct Absolute Point
                           #--- PUSHB_1   82        ;PUSH Bytes
MDRP[rp0,rnd,white] 82         ;Move Direct Relative Point
                           #--- PUSHB_5   78 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 78 ;CALL function
                           #--- PUSHB_1   78        ;PUSH Bytes
SRP0            78         ;Set Reference Point 0
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_5   64 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 64 ;CALL function
                           #--- PUSHB_3   64 75 10  ;PUSH Bytes
CALL            10 75 64   ;CALL function
                           #--- PUSHB_4   64 64 67 9 ;PUSH Bytes
CALL            9 67 64 64 ;CALL function
                           #--- PUSHB_3   75 64 10  ;PUSH Bytes
CALL            10 64 75   ;CALL function
                           #--- PUSHB_4   64 75 72 9 ;PUSH Bytes
CALL            9 72 75 64 ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP0            64         ;Set Reference Point 0
                           #--- PUSHB_2   90 1      ;PUSH Bytes
CALL            1 90       ;CALL function
                           #--- PUSHB_5   85 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 85 ;CALL function
                           #--- PUSHB_1   85        ;PUSH Bytes
SRP0            85         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_5   25 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 25 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SHP[rp2]        50         ;SHift Point using reference point
                           #--- PUSHB_3   37 25 10  ;PUSH Bytes
CALL            10 25 37   ;CALL function
                           #--- PUSHB_4   64 37 35 9 ;PUSH Bytes
CALL            9 35 37 64 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_5   58 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 58 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_5   32 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 32 ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_3   1 13 10   ;PUSH Bytes
CALL            10 13 1    ;CALL function
                           #--- PUSHB_4   64 1 21 9 ;PUSH Bytes
CALL            9 21 1 64  ;CALL function
                           #--- PUSHB_3   13 1 10   ;PUSH Bytes
CALL            10 1 13    ;CALL function
                           #--- PUSHB_4   64 13 11 9 ;PUSH Bytes
CALL            9 11 13 64 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_5   8 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 8 ;CALL function
                           #--- PUSHB_2   94 1      ;PUSH Bytes
CALL            1 94       ;CALL function
                           #--- PUSHB_2   32 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   16 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2126': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_5   12 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 12 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_5   6 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 6 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDRP[rp0,rnd,white] 47         ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 47 10  ;PUSH Bytes
CALL            10 47 15   ;CALL function
                           #--- PUSHB_4   64 15 10 9 ;PUSH Bytes
CALL            9 10 15 64 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_1   8         ;PUSH Bytes
                           #--- DUP       #8        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] stemw 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 39 10  ;PUSH Bytes
CALL            10 39 21   ;CALL function
                           #--- PUSHB_4   64 21 26 9 ;PUSH Bytes
CALL            9 26 21 64 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_1   33        ;PUSH Bytes
                           #--- DUP       #33       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   3 47      ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   21 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_4   1 0 35 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 35 0 1  ;Interpolate Point
                           #--- PUSHB_2   39 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   39 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   0 36      ;PUSH Bytes
IP              36         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni212A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   44 0 0    ;PUSH Bytes
CALL            0 0 44     ;CALL function
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_3   3 44 10   ;PUSH Bytes
CALL            10 44 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_3   50 3 0    ;PUSH Bytes
CALL            0 3 50     ;CALL function
                           #--- PUSHB_3   83 2 0    ;PUSH Bytes
CALL            0 2 83     ;CALL function
                           #--- PUSHB_3   69 2 0    ;PUSH Bytes
CALL            0 2 69     ;CALL function
                           #--- PUSHB_4   14 44 83 8 ;PUSH Bytes
CALL            8 83 44 14 ;CALL function
                           #--- PUSHB_5   57 61 44 83 13 ;PUSH Bytes
CALL            13 83 44 61 57 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp1]        51         ;SHift Point using reference point
                           #--- PUSHB_5   57 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 57 ;CALL function
                           #--- PUSHB_5   31 20 44 83 13 ;PUSH Bytes
CALL            13 83 44 20 31 ;CALL function
                           #--- PUSHB_5   31 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 31 ;CALL function
                           #--- PUSHB_3   20 31 10  ;PUSH Bytes
CALL            10 31 20   ;CALL function
                           #--- PUSHB_4   0 20 25 9 ;PUSH Bytes
CALL            9 25 20 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   88        ;PUSH Bytes
MDAP[rnd]       88         ;Move Direct Absolute Point
                           #--- PUSHB_1   62        ;PUSH Bytes
MDRP[rp0,rnd,white] 62         ;Move Direct Relative Point
                           #--- PUSHB_5   51 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 51 ;CALL function
                           #--- PUSHB_3   51 62 10  ;PUSH Bytes
CALL            10 62 51   ;CALL function
                           #--- PUSHB_4   64 51 54 9 ;PUSH Bytes
CALL            9 54 51 64 ;CALL function
                           #--- PUSHB_3   62 51 10  ;PUSH Bytes
CALL            10 51 62   ;CALL function
                           #--- PUSHB_4   64 62 59 9 ;PUSH Bytes
CALL            9 59 62 64 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_3   5 41 10   ;PUSH Bytes
CALL            10 41 5    ;CALL function
                           #--- PUSHB_4   0 5 47 9  ;PUSH Bytes
CALL            9 47 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_1   17        ;PUSH Bytes
                           #--- DUP       #17       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_3   17 34 10  ;PUSH Bytes
CALL            10 34 17   ;CALL function
                           #--- PUSHB_4   0 17 28 9 ;PUSH Bytes
CALL            9 28 17 0  ;CALL function
                           #--- PUSHB_2   89 1      ;PUSH Bytes
CALL            1 89       ;CALL function
                           #--- PUSHB_2   17 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_4   8 10 78 86 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              86 78 10 8 ;Interpolate Point
                           #--- PUSHB_2   34 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   38 41 75 78 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              78 75 41 38 ;Interpolate Point
                           #--- PUSHB_2   61 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            61         ;Set Reference Point 2
                           #--- PUSHB_2   17 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_2   83 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            83         ;Set Reference Point 2
                           #--- PUSHB_3   63 66 86  ;PUSH Bytes
IP              86         ;Interpolate Point
IP              66         ;Interpolate Point
IP              63         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2132': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   86 0 0    ;PUSH Bytes
CALL            0 0 86     ;CALL function
                           #--- PUSHB_4   5 16 51 68 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp1]        68 51 16 5 ;SHift Point using reference point
                           #--- PUSHB_5   90 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 90 ;CALL function
                           #--- NPUSHB    9 1 10 12 21 46 56 64 73 80 ;PUSH N Bytes
                           #--- DEPTH     #9        ;DEPTH of the stack
SLOOP           9          ;Set LOOP variable
SHP[rp2]        80 73 64 56 46 21 12 10 1 ;SHift Point using reference point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   78 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 78 ;CALL function
                           #--- PUSHB_1   79        ;PUSH Bytes
MDAP[rnd]       79         ;Move Direct Absolute Point
                           #--- PUSHB_5   104 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 104 ;CALL function
                           #--- PUSHB_3   79 104 10 ;PUSH Bytes
CALL            10 104 79  ;CALL function
                           #--- PUSHB_4   64 79 113 9 ;PUSH Bytes
CALL            9 113 79 64 ;CALL function
                           #--- PUSHB_3   104 79 10 ;PUSH Bytes
CALL            10 79 104  ;CALL function
                           #--- PUSHB_4   64 104 108 9 ;PUSH Bytes
CALL            9 108 104 64 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_6   23 32 34 43 57 77 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
SHP[rp1]        77 57 43 34 32 23 ;SHift Point using reference point
                           #--- PUSHB_5   62 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 62 ;CALL function
                           #--- PUSHB_2   27 38     ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   91        ;PUSH Bytes
MDAP[rnd]       91         ;Move Direct Absolute Point
                           #--- PUSHB_1   102       ;PUSH Bytes
SHP[rp1]        102        ;SHift Point using reference point
                           #--- PUSHB_5   95 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 95 ;CALL function
                           #--- PUSHB_3   91 95 10  ;PUSH Bytes
CALL            10 95 91   ;CALL function
                           #--- PUSHB_4   0 91 99 9 ;PUSH Bytes
CALL            9 99 91 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   117       ;PUSH Bytes
MDAP[rnd]       117        ;Move Direct Absolute Point
                           #--- PUSHB_1   90        ;PUSH Bytes
MDRP[rp0,rnd,white] 90         ;Move Direct Relative Point
                           #--- PUSHB_5   80 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 80 ;CALL function
                           #--- PUSHB_1   103       ;PUSH Bytes
SHP[rp2]        103        ;SHift Point using reference point
                           #--- PUSHB_3   80 90 10  ;PUSH Bytes
CALL            10 90 80   ;CALL function
                           #--- PUSHB_4   64 80 83 9 ;PUSH Bytes
CALL            9 83 80 64 ;CALL function
                           #--- PUSHB_3   90 80 10  ;PUSH Bytes
CALL            10 80 90   ;CALL function
                           #--- PUSHB_4   64 90 88 9 ;PUSH Bytes
CALL            9 88 90 64 ;CALL function
                           #--- PUSHB_1   93        ;PUSH Bytes
SHP[rp2]        93         ;SHift Point using reference point
                           #--- PUSHB_1   80        ;PUSH Bytes
SRP0            80         ;Set Reference Point 0
                           #--- PUSHB_2   115 1     ;PUSH Bytes
CALL            1 115      ;CALL function
                           #--- PUSHB_1   105       ;PUSH Bytes
SHP[rp2]        105        ;SHift Point using reference point
                           #--- PUSHB_5   111 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 111 ;CALL function
                           #--- PUSHB_1   111       ;PUSH Bytes
SRP0            111        ;Set Reference Point 0
                           #--- PUSHB_2   101 1     ;PUSH Bytes
CALL            1 101      ;CALL function
                           #--- PUSHB_5   97 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 97 ;CALL function
                           #--- PUSHB_1   97        ;PUSH Bytes
SRP0            97         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_2   118 1     ;PUSH Bytes
CALL            1 118      ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   56 57     ;PUSH Bytes
SDPVTL[orthog]  57 56      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[no-rnd]    56         ;Move Direct Absolute Point
                           #--- PUSHB_1   77        ;PUSH Bytes
MDAP[no-rnd]    77         ;Move Direct Absolute Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   46 13     ;PUSH Bytes
MIRP[rp0,min,black] cvt_13 46  ;Move Indirect Relative Point
                           #--- PUSHB_1   77        ;PUSH Bytes
SRP0            77         ;Set Reference Point 0
                           #--- PUSHB_2   57 13     ;PUSH Bytes
MIRP[rp0,min,black] cvt_13 57  ;Move Indirect Relative Point
                           #--- PUSHB_2   23 22     ;PUSH Bytes
SDPVTL[orthog]  22 23      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[no-rnd]    23         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[grey]      22         ;Move Direct Relative Point
                           #--- PUSHB_2   32 14     ;PUSH Bytes
MIRP[rp0,min,black] cvt_14 32  ;Move Indirect Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[grey]      33         ;Move Direct Relative Point
                           #--- PUSHB_2   33 34     ;PUSH Bytes
SDPVTL[orthog]  34 33      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[no-rnd]    34         ;Move Direct Absolute Point
                           #--- PUSHB_2   32 33     ;PUSH Bytes
SFVTL[parallel] 33 32      ;Set Freedom Vector To Line
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[grey]      33         ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_2   43 15     ;PUSH Bytes
MIRP[rp0,min,black] cvt_15 43  ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[grey]      0          ;Move Direct Relative Point
SFVTCA[x-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_4   45 46 77 19 ;PUSH Bytes
CALL            19 77 46 45 ;CALL function
                           #--- PUSHB_4   78 46 77 19 ;PUSH Bytes
CALL            19 77 46 78 ;CALL function
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 22 33   ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    22         ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    13 0 22 23 32 33 34 43 45 46 56 57 77 78 ;PUSH N Bytes
MDAP[no-rnd]    78         ;Move Direct Absolute Point
MDAP[no-rnd]    77         ;Move Direct Absolute Point
MDAP[no-rnd]    57         ;Move Direct Absolute Point
MDAP[no-rnd]    56         ;Move Direct Absolute Point
MDAP[no-rnd]    46         ;Move Direct Absolute Point
MDAP[no-rnd]    45         ;Move Direct Absolute Point
MDAP[no-rnd]    43         ;Move Direct Absolute Point
MDAP[no-rnd]    34         ;Move Direct Absolute Point
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    23         ;Move Direct Absolute Point
MDAP[no-rnd]    22         ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   111 115   ;PUSH Bytes
SRP1            115        ;Set Reference Point 1
SRP2            111        ;Set Reference Point 2
                           #--- PUSHB_1   54        ;PUSH Bytes
IP              54         ;Interpolate Point
                           #--- PUSHB_2   97 101    ;PUSH Bytes
SRP1            101        ;Set Reference Point 1
SRP2            97         ;Set Reference Point 2
                           #--- PUSHB_1   60        ;PUSH Bytes
IP              60         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_4   49 63 66 75 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              75 66 63 49 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   78 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            78         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2136': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_5   23 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 23 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
                           #--- DUP       #48       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 48         ;Move Direct Relative Point
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_5   45 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 45 ;CALL function
                           #--- PUSHB_5   31 0 10 19 13 ;PUSH Bytes
CALL            13 19 10 0 31 ;CALL function
                           #--- PUSHB_5   31 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 31 ;CALL function
                           #--- PUSHB_4   27 31 0 8 ;PUSH Bytes
CALL            8 0 31 27  ;CALL function
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_5   39 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 39 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_5   56 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 56 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_5   42 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 42 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_4   7 13 12 14 ;PUSH Bytes
CALL            14 12 13 7 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_5   8 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 8  ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   51 56     ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_4   45 48 39 53 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              53 39 48 45 ;Interpolate Point
                           #--- PUSHB_2   8 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   0 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   45 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_2   53 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_2   42 36     ;PUSH Bytes
IP              36         ;Interpolate Point
IP              42         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2155': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 3 0    ;PUSH Bytes
CALL            0 3 38     ;CALL function
                           #--- PUSHB_3   71 2 0    ;PUSH Bytes
CALL            0 2 71     ;CALL function
                           #--- PUSHB_3   57 2 0    ;PUSH Bytes
CALL            0 2 57     ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_5   25 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 25 ;CALL function
                           #--- PUSHB_3   25 15 10  ;PUSH Bytes
CALL            10 15 25   ;CALL function
                           #--- PUSHB_4   0 25 21 9 ;PUSH Bytes
CALL            9 21 25 0  ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   9 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 9 ;CALL function
                           #--- PUSHB_3   30 9 10   ;PUSH Bytes
CALL            10 9 30    ;CALL function
                           #--- PUSHB_4   64 30 33 9 ;PUSH Bytes
CALL            9 33 30 64 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   49 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 49 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_4   6 49 45 8 ;PUSH Bytes
CALL            8 45 49 6  ;CALL function
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
                           #--- PUSHB_5   39 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 39 ;CALL function
                           #--- PUSHB_3   39 50 10  ;PUSH Bytes
CALL            10 50 39   ;CALL function
                           #--- PUSHB_4   64 39 42 9 ;PUSH Bytes
CALL            9 42 39 64 ;CALL function
                           #--- PUSHB_3   50 39 10  ;PUSH Bytes
CALL            10 39 50   ;CALL function
                           #--- PUSHB_4   64 50 47 9 ;PUSH Bytes
CALL            9 47 50 64 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_5   7 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 7 ;CALL function
                           #--- PUSHB_3   7 36 10   ;PUSH Bytes
CALL            10 36 7    ;CALL function
                           #--- PUSHB_4   0 7 3 9   ;PUSH Bytes
CALL            9 3 7 0    ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_3   27 12 10  ;PUSH Bytes
CALL            10 12 27   ;CALL function
                           #--- PUSHB_4   0 27 18 9 ;PUSH Bytes
CALL            9 18 27 0  ;CALL function
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   36 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   63 66     ;PUSH Bytes
IP              66         ;Interpolate Point
IP              63         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_2   33 71     ;PUSH Bytes
IP              71         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_3   9 30 74   ;PUSH Bytes
IP              74         ;Interpolate Point
IP              30         ;Interpolate Point
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_3   12 63 66  ;PUSH Bytes
IP              66         ;Interpolate Point
IP              63         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   42 47     ;PUSH Bytes
IP              47         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_2   37 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP1            71         ;Set Reference Point 1
                           #--- PUSHB_3   51 54 74  ;PUSH Bytes
IP              74         ;Interpolate Point
IP              54         ;Interpolate Point
IP              51         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2156': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
CALL            0 3 3      ;CALL function
                           #--- PUSHB_5   21 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 21 ;CALL function
                           #--- PUSHB_3   21 3 10   ;PUSH Bytes
CALL            10 3 21    ;CALL function
                           #--- PUSHB_4   0 21 26 9 ;PUSH Bytes
CALL            9 26 21 0  ;CALL function
                           #--- PUSHB_3   78 2 0    ;PUSH Bytes
CALL            0 2 78     ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_5   54 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 54 ;CALL function
                           #--- PUSHB_3   54 44 10  ;PUSH Bytes
CALL            10 44 54   ;CALL function
                           #--- PUSHB_4   0 54 50 9 ;PUSH Bytes
CALL            9 50 54 0  ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_5   38 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 38 ;CALL function
                           #--- PUSHB_3   59 38 10  ;PUSH Bytes
CALL            10 38 59   ;CALL function
                           #--- PUSHB_4   64 59 62 9 ;PUSH Bytes
CALL            9 62 59 64 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_5   66 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 66 ;CALL function
                           #--- PUSHB_4   8 66 35 8 ;PUSH Bytes
CALL            8 35 66 8  ;CALL function
                           #--- PUSHB_5   15 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   83        ;PUSH Bytes
MDAP[rnd]       83         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   5 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 5 ;CALL function
                           #--- PUSHB_3   19 5 10   ;PUSH Bytes
CALL            10 5 19    ;CALL function
                           #--- PUSHB_4   64 19 15 9 ;PUSH Bytes
CALL            9 15 19 64 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_5   36 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 36 ;CALL function
                           #--- PUSHB_3   36 65 10  ;PUSH Bytes
CALL            10 65 36   ;CALL function
                           #--- PUSHB_4   0 36 32 9 ;PUSH Bytes
CALL            9 32 36 0  ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_3   56 41 10  ;PUSH Bytes
CALL            10 41 56   ;CALL function
                           #--- PUSHB_4   0 56 47 9 ;PUSH Bytes
CALL            9 47 56 0  ;CALL function
                           #--- PUSHB_2   84 1      ;PUSH Bytes
CALL            1 84       ;CALL function
                           #--- PUSHB_2   19 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_3   3 8 73    ;PUSH Bytes
IP              73         ;Interpolate Point
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_3   9 11 70   ;PUSH Bytes
IP              70         ;Interpolate Point
IP              11         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_2   13 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_2   62 78     ;PUSH Bytes
IP              78         ;Interpolate Point
IP              62         ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_3   38 59 81  ;PUSH Bytes
IP              81         ;Interpolate Point
IP              59         ;Interpolate Point
IP              38         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   59 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_3   41 70 73  ;PUSH Bytes
IP              73         ;Interpolate Point
IP              70         ;Interpolate Point
IP              41         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
                           #--- PUSHB_2   11 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   16 32     ;PUSH Bytes
IP              32         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_2   21 66     ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   19 5 81   ;PUSH Bytes
IP              81         ;Interpolate Point
IP              5          ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2157': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   31 3 0    ;PUSH Bytes
CALL            0 3 31     ;CALL function
                           #--- PUSHB_5   20 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 20 ;CALL function
                           #--- PUSHB_3   20 31 10  ;PUSH Bytes
CALL            10 31 20   ;CALL function
                           #--- PUSHB_4   0 20 25 9 ;PUSH Bytes
CALL            9 25 20 0  ;CALL function
                           #--- PUSHB_3   99 2 0    ;PUSH Bytes
CALL            0 2 99     ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_5   75 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 75 ;CALL function
                           #--- PUSHB_3   75 65 10  ;PUSH Bytes
CALL            10 65 75   ;CALL function
                           #--- PUSHB_4   0 75 71 9 ;PUSH Bytes
CALL            9 71 75 0  ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 3 ;CALL function
                           #--- PUSHB_3   3 44 10   ;PUSH Bytes
CALL            10 44 3    ;CALL function
                           #--- PUSHB_4   0 3 0 9   ;PUSH Bytes
CALL            9 0 3 0    ;CALL function
                           #--- PUSHB_4   59 3 44 8 ;PUSH Bytes
CALL            8 44 3 59  ;CALL function
                           #--- PUSHB_5   80 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 80 ;CALL function
                           #--- PUSHB_3   80 59 10  ;PUSH Bytes
CALL            10 59 80   ;CALL function
                           #--- PUSHB_4   64 80 83 9 ;PUSH Bytes
CALL            9 83 80 64 ;CALL function
                           #--- PUSHB_4   56 3 44 8 ;PUSH Bytes
CALL            8 44 3 56  ;CALL function
                           #--- PUSHB_5   87 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 87 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   104       ;PUSH Bytes
MDAP[rnd]       104        ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   41 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 41 ;CALL function
                           #--- PUSHB_3   5 41 10   ;PUSH Bytes
CALL            10 41 5    ;CALL function
                           #--- PUSHB_4   0 5 47 9  ;PUSH Bytes
CALL            9 47 5 0   ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_1   17        ;PUSH Bytes
                           #--- DUP       #17       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_3   17 34 10  ;PUSH Bytes
CALL            10 34 17   ;CALL function
                           #--- PUSHB_4   64 17 10 9 ;PUSH Bytes
CALL            9 10 17 64 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP0            41         ;Set Reference Point 0
                           #--- PUSHB_2   86 1      ;PUSH Bytes
CALL            1 86       ;CALL function
                           #--- PUSHB_5   57 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 57 ;CALL function
                           #--- PUSHB_3   57 86 10  ;PUSH Bytes
CALL            10 86 57   ;CALL function
                           #--- PUSHB_4   0 57 53 9 ;PUSH Bytes
CALL            9 53 57 0  ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_5   62 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 62 ;CALL function
                           #--- PUSHB_3   77 62 10  ;PUSH Bytes
CALL            10 62 77   ;CALL function
                           #--- PUSHB_4   0 77 68 9 ;PUSH Bytes
CALL            9 68 77 0  ;CALL function
                           #--- PUSHB_2   105 1     ;PUSH Bytes
CALL            1 105      ;CALL function
                           #--- PUSHB_2   34 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   39 91     ;PUSH Bytes
IP              91         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_2   57 86     ;PUSH Bytes
SRP1            86         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_2   83 99     ;PUSH Bytes
IP              99         ;Interpolate Point
IP              83         ;Interpolate Point
                           #--- PUSHB_1   77        ;PUSH Bytes
SRP1            77         ;Set Reference Point 1
                           #--- PUSHB_3   59 80 102 ;PUSH Bytes
IP              102        ;Interpolate Point
IP              80         ;Interpolate Point
IP              59         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   80 75     ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
SRP2            80         ;Set Reference Point 2
                           #--- PUSHB_3   62 91 94  ;PUSH Bytes
IP              94         ;Interpolate Point
IP              91         ;Interpolate Point
IP              62         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   57        ;PUSH Bytes
IP              57         ;Interpolate Point
                           #--- PUSHB_2   87 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            87         ;Set Reference Point 2
                           #--- PUSHB_3   5 41 53   ;PUSH Bytes
IP              53         ;Interpolate Point
IP              41         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_3   7 38 39   ;PUSH Bytes
IP              39         ;Interpolate Point
IP              38         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   34 102    ;PUSH Bytes
IP              102        ;Interpolate Point
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2158': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 3 0    ;PUSH Bytes
CALL            0 3 20     ;CALL function
                           #--- PUSHB_3   73 2 0    ;PUSH Bytes
CALL            0 2 73     ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_5   49 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 49 ;CALL function
                           #--- PUSHB_3   49 39 10  ;PUSH Bytes
CALL            10 39 49   ;CALL function
                           #--- PUSHB_4   0 49 45 9 ;PUSH Bytes
CALL            9 45 49 0  ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_5   33 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 33 ;CALL function
                           #--- PUSHB_3   54 33 10  ;PUSH Bytes
CALL            10 33 54   ;CALL function
                           #--- PUSHB_4   64 54 57 9 ;PUSH Bytes
CALL            9 57 54 64 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_5   61 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 61 ;CALL function
                           #--- PUSHB_4   15 61 30 8 ;PUSH Bytes
CALL            8 30 61 15 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_1   17        ;PUSH Bytes
                           #--- DUP       #17       ;DUPlicate top stack element
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_5   23 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 23 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   16 6 10   ;PUSH Bytes
CALL            10 6 16    ;CALL function
                           #--- PUSHB_4   64 16 18 9 ;PUSH Bytes
CALL            9 18 16 64 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_4   13 6 8 14 ;PUSH Bytes
CALL            14 8 6 13  ;CALL function
                           #--- PUSHB_5   13 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_5   8 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 8 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   60 1      ;PUSH Bytes
CALL            1 60       ;CALL function
                           #--- PUSHB_5   31 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 31 ;CALL function
                           #--- PUSHB_3   31 60 10  ;PUSH Bytes
CALL            10 60 31   ;CALL function
                           #--- PUSHB_4   0 31 27 9 ;PUSH Bytes
CALL            9 27 31 0  ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_5   36 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 36 ;CALL function
                           #--- PUSHB_3   51 36 10  ;PUSH Bytes
CALL            10 36 51   ;CALL function
                           #--- PUSHB_4   0 51 42 9 ;PUSH Bytes
CALL            9 42 51 0  ;CALL function
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   16 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   65 68     ;PUSH Bytes
IP              68         ;Interpolate Point
IP              65         ;Interpolate Point
                           #--- PUSHB_2   31 60     ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   57 73     ;PUSH Bytes
IP              73         ;Interpolate Point
IP              57         ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_3   33 54 76  ;PUSH Bytes
IP              76         ;Interpolate Point
IP              54         ;Interpolate Point
IP              33         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   54 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_3   36 65 68  ;PUSH Bytes
IP              68         ;Interpolate Point
IP              65         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   8 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   17 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   5 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   1 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SRP1            73         ;Set Reference Point 1
                           #--- PUSHB_2   22 76     ;PUSH Bytes
IP              76         ;Interpolate Point
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2159': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   31 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 31 ;CALL function
                           #--- PUSHB_3   39 3 0    ;PUSH Bytes
CALL            0 3 39     ;CALL function
                           #--- PUSHB_3   72 2 0    ;PUSH Bytes
CALL            0 2 72     ;CALL function
                           #--- PUSHB_3   58 2 0    ;PUSH Bytes
CALL            0 2 58     ;CALL function
                           #--- PUSHB_5   37 22 0 72 13 ;PUSH Bytes
CALL            13 72 0 22 37 ;CALL function
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
                           #--- PUSHB_5   46 50 0 72 13 ;PUSH Bytes
CALL            13 72 0 50 46 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_5   46 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 46 ;CALL function
                           #--- PUSHB_5   8 17 0 72 13 ;PUSH Bytes
CALL            13 72 0 17 8 ;CALL function
                           #--- PUSHB_5   8 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 8 ;CALL function
                           #--- PUSHB_3   17 8 10   ;PUSH Bytes
CALL            10 8 17    ;CALL function
                           #--- PUSHB_4   0 17 14 9 ;PUSH Bytes
CALL            9 14 17 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   77        ;PUSH Bytes
MDAP[rnd]       77         ;Move Direct Absolute Point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDRP[rp0,rnd,white] 51         ;Move Direct Relative Point
                           #--- PUSHB_5   40 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 40 ;CALL function
                           #--- PUSHB_3   40 51 10  ;PUSH Bytes
CALL            10 51 40   ;CALL function
                           #--- PUSHB_4   64 40 43 9 ;PUSH Bytes
CALL            9 43 40 64 ;CALL function
                           #--- PUSHB_3   51 40 10  ;PUSH Bytes
CALL            10 40 51   ;CALL function
                           #--- PUSHB_4   64 51 48 9 ;PUSH Bytes
CALL            9 48 51 64 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   25 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 25 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   34 25 10  ;PUSH Bytes
CALL            10 25 34   ;CALL function
                           #--- PUSHB_4   64 34 5 9 ;PUSH Bytes
CALL            9 5 34 64  ;CALL function
                           #--- PUSHB_2   78 1      ;PUSH Bytes
CALL            1 78       ;CALL function
                           #--- PUSHB_2   34 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_7   0 8 20 22 28 67 75 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              75 67 28 22 20 8 0 ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   17 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   64        ;PUSH Bytes
IP              64         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_3   5 25 67   ;PUSH Bytes
IP              67         ;Interpolate Point
IP              25         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
                           #--- PUSHB_2   72 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_3   52 55 75  ;PUSH Bytes
IP              75         ;Interpolate Point
IP              55         ;Interpolate Point
IP              52         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni215A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   38 0 0    ;PUSH Bytes
CALL            0 0 38     ;CALL function
                           #--- PUSHB_5   69 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 69 ;CALL function
                           #--- PUSHB_3   36 3 0    ;PUSH Bytes
CALL            0 3 36     ;CALL function
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_3   88 2 0    ;PUSH Bytes
CALL            0 2 88     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_5   8 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 8 ;CALL function
                           #--- PUSHB_3   29 8 10   ;PUSH Bytes
CALL            10 8 29    ;CALL function
                           #--- PUSHB_4   64 29 32 9 ;PUSH Bytes
CALL            9 32 29 64 ;CALL function
                           #--- PUSHB_5   75 60 38 29 13 ;PUSH Bytes
CALL            13 29 38 60 75 ;CALL function
                           #--- PUSHB_5   75 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 75 ;CALL function
                           #--- PUSHB_5   24 14 38 29 13 ;PUSH Bytes
CALL            13 29 38 14 24 ;CALL function
                           #--- PUSHB_5   24 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 24 ;CALL function
                           #--- PUSHB_3   24 14 10  ;PUSH Bytes
CALL            10 14 24   ;CALL function
                           #--- PUSHB_4   0 24 20 9 ;PUSH Bytes
CALL            9 20 24 0  ;CALL function
                           #--- PUSHB_5   46 55 38 29 13 ;PUSH Bytes
CALL            13 29 38 55 46 ;CALL function
                           #--- PUSHB_5   46 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 46 ;CALL function
                           #--- PUSHB_3   55 46 10  ;PUSH Bytes
CALL            10 46 55   ;CALL function
                           #--- PUSHB_4   0 55 52 9 ;PUSH Bytes
CALL            9 52 55 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   93        ;PUSH Bytes
MDAP[rnd]       93         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_3   6 35 10   ;PUSH Bytes
CALL            10 35 6    ;CALL function
                           #--- PUSHB_4   0 6 2 9   ;PUSH Bytes
CALL            9 2 6 0    ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   11 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 11 ;CALL function
                           #--- PUSHB_3   26 11 10  ;PUSH Bytes
CALL            10 11 26   ;CALL function
                           #--- PUSHB_4   0 26 17 9 ;PUSH Bytes
CALL            9 17 26 0  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   72 1      ;PUSH Bytes
CALL            1 72       ;CALL function
                           #--- PUSHB_5   63 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 63 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_3   72 63 10  ;PUSH Bytes
CALL            10 63 72   ;CALL function
                           #--- PUSHB_4   64 72 43 9 ;PUSH Bytes
CALL            9 43 72 64 ;CALL function
                           #--- PUSHB_2   94 1      ;PUSH Bytes
CALL            1 94       ;CALL function
                           #--- PUSHB_2   6 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_4   8 29 80 83 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              83 80 29 8 ;Interpolate Point
                           #--- PUSHB_2   72 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_7   38 46 58 60 66 88 91 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              91 88 66 60 58 46 38 ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_2   55 52     ;PUSH Bytes
IP              52         ;Interpolate Point
IP              55         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   69 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_1   80        ;PUSH Bytes
IP              80         ;Interpolate Point
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP1            75         ;Set Reference Point 1
                           #--- PUSHB_3   43 63 83  ;PUSH Bytes
IP              83         ;Interpolate Point
IP              63         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   58        ;PUSH Bytes
IP              58         ;Interpolate Point
                           #--- PUSHB_2   46 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   11 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_2   8 29      ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   91        ;PUSH Bytes
IP              91         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni215F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 3 0     ;PUSH Bytes
CALL            0 3 0      ;CALL function
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 11 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 1 ;CALL function
                           #--- PUSHB_3   1 12 10   ;PUSH Bytes
CALL            10 12 1    ;CALL function
                           #--- PUSHB_4   64 1 4 9  ;PUSH Bytes
CALL            9 4 1 64   ;CALL function
                           #--- PUSHB_3   12 1 10   ;PUSH Bytes
CALL            10 1 12    ;CALL function
                           #--- PUSHB_4   64 12 9 9 ;PUSH Bytes
CALL            9 9 12 64  ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   33 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2160': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 28      ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   19 2 0    ;PUSH Bytes
CALL            0 2 19     ;CALL function
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   25 29     ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] stemw 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 31 10  ;PUSH Bytes
CALL            10 31 12   ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 28 10  ;PUSH Bytes
CALL            10 28 27   ;CALL function
                           #--- PUSHB_4   64 27 3 9 ;PUSH Bytes
CALL            9 3 27 64  ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2162': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   21 22 27  ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   13 2 0    ;PUSH Bytes
CALL            0 2 13     ;CALL function
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   19 23 26  ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] stemw 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   6 27 10   ;PUSH Bytes
CALL            10 27 6    ;CALL function
                           #--- PUSHB_4   64 6 5 9  ;PUSH Bytes
CALL            9 5 6 64   ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] stemw 25   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 22 10  ;PUSH Bytes
CALL            10 22 21   ;CALL function
                           #--- PUSHB_4   64 21 1 9 ;PUSH Bytes
CALL            9 1 21 64  ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   20        ;PUSH Bytes
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2163': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   29 2 0    ;PUSH Bytes
CALL            0 2 29     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   6 9       ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_4   8 23 20 14 ;PUSH Bytes
CALL            14 20 23 8 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_5   15 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 15 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_5   5 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 5 ;CALL function
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_2   15 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_3   7 8 30    ;PUSH Bytes
IP              30         ;Interpolate Point
IP              8          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2164': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   30 2 0    ;PUSH Bytes
CALL            0 2 30     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   25 4      ;PUSH Bytes
MIRP[min,black] stemt 25   ;Move Indirect Relative Point
                           #--- PUSHB_2   8 21      ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_4   9 20 17 14 ;PUSH Bytes
CALL            14 17 20 9 ;CALL function
                           #--- PUSHB_5   12 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 12 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   20 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2166': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_2   10 35     ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_3   33 2 0    ;PUSH Bytes
CALL            0 2 33     ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   28 4      ;PUSH Bytes
MIRP[min,black] stemt 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 22 36   ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   39        ;PUSH Bytes
MDAP[rnd]       39         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   38 6      ;PUSH Bytes
MIRP[min,black] stemw 38   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 38 10  ;PUSH Bytes
CALL            10 38 21   ;CALL function
                           #--- PUSHB_4   64 21 18 9 ;PUSH Bytes
CALL            9 18 21 64 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 35 10  ;PUSH Bytes
CALL            10 35 10   ;CALL function
                           #--- PUSHB_4   64 10 6 9 ;PUSH Bytes
CALL            9 6 10 64  ;CALL function
                           #--- PUSHB_4   64 10 13 9 ;PUSH Bytes
CALL            9 13 10 64 ;CALL function
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2169': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_5   16 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 16 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_2   21 5      ;PUSH Bytes
MIRP[min,black] cvt_5 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 0 0    ;PUSH Bytes
CALL            0 0 13     ;CALL function
                           #--- PUSHB_5   16 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 16 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   23        ;PUSH Bytes
MDAP[rnd]       23         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   21 6      ;PUSH Bytes
MIRP[min,black] stemw 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] stemw 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2215': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 5      ;PUSH Bytes
MIRP[min,black] cvt_5 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2234': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_5   19 4 0 33 4 ;PUSH Bytes
CALL            4 33 0 4 19 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_5   3 4 0 33 4 ;PUSH Bytes
CALL            4 33 0 4 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDRP[rp0,rnd,white] 27         ;Move Direct Relative Point
                           #--- PUSHB_5   22 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   0 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_5   11 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 11 ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2501': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2503': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2504': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   4 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2505': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_5   10 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 10 ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   6 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] stemw 2    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2506': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   1 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2507': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_5   10 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 10 ;CALL function
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   9 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 9 ;CALL function
                           #--- PUSHB_2   0 6       ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   1 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2508': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_3   0 6 8     ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
SHP[rp1]        6          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 4 10    ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   10 4      ;PUSH Bytes
MIRP[min,black] stemt 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   8 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   0 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2509': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_3   0 6 8     ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
SHP[rp1]        6          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   14 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 14 ;CALL function
                           #--- PUSHB_3   2 4 10    ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   10 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   8 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   0 6 0 24 4 ;PUSH Bytes
CALL            4 24 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_5   6 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 6 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni250A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_3   2 6 8     ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   13 6      ;PUSH Bytes
MIRP[min,black] stemw 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 4 10    ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   8 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_4   0 1 5 4   ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              4 5 1 0    ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni250B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   7 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 7 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_3   2 6 8     ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   13 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 13 ;CALL function
                           #--- PUSHB_3   0 4 10    ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   5 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 5 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni250D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni250E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 1 10    ;PUSH Bytes
CALL            10 1 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni250F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 1 ;CALL function
                           #--- PUSHB_3   3 1 10    ;PUSH Bytes
CALL            10 1 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2511': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2512': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2513': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2515': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2516': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 5 10    ;PUSH Bytes
CALL            10 5 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 3 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2517': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
                           #--- PUSHB_3   3 5 10    ;PUSH Bytes
CALL            10 5 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 3 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2519': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni251A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 0 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni251B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 0 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni251D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 0 9  ;PUSH Bytes
CALL            9 0 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni251E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   4 4       ;PUSH Bytes
MIRP[min,black] stemt 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 4 10    ;PUSH Bytes
CALL            10 4 7     ;CALL function
                           #--- PUSHB_4   64 7 9 9  ;PUSH Bytes
CALL            9 9 7 64   ;CALL function
                           #--- PUSHB_3   4 7 10    ;PUSH Bytes
CALL            10 7 4     ;CALL function
                           #--- PUSHB_4   64 4 3 9  ;PUSH Bytes
CALL            9 3 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   10 9 1 14 ;PUSH Bytes
CALL            14 1 9 10  ;CALL function
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni251F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 7 9  ;PUSH Bytes
CALL            9 7 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   10 0 8 14 ;PUSH Bytes
CALL            14 8 0 10  ;CALL function
                           #--- PUSHB_5   7 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 7 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2520': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 5 10    ;PUSH Bytes
CALL            10 5 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_3   5 0 10    ;PUSH Bytes
CALL            10 0 5     ;CALL function
                           #--- PUSHB_4   64 5 3 9  ;PUSH Bytes
CALL            9 3 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 7 9  ;PUSH Bytes
CALL            9 7 1 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2521': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_5   7 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 7 ;CALL function
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 6 9  ;PUSH Bytes
CALL            9 6 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 9 9  ;PUSH Bytes
CALL            9 9 1 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_4   10 2 4 14 ;PUSH Bytes
CALL            14 4 2 10  ;CALL function
                           #--- PUSHB_5   7 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 7 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2522': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 4 9  ;PUSH Bytes
CALL            9 4 3 64   ;CALL function
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 8 9  ;PUSH Bytes
CALL            9 8 0 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_4   10 7 5 14 ;PUSH Bytes
CALL            14 5 7 10  ;CALL function
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2523': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 0 9  ;PUSH Bytes
CALL            9 0 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 7 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2525': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2526': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_4   10 2 6 14 ;PUSH Bytes
CALL            14 6 2 10  ;CALL function
                           #--- PUSHB_5   9 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 9 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2527': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   5 6 10    ;PUSH Bytes
CALL            10 6 5     ;CALL function
                           #--- PUSHB_4   64 5 3 9  ;PUSH Bytes
CALL            9 3 5 64   ;CALL function
                           #--- PUSHB_3   6 5 10    ;PUSH Bytes
CALL            10 5 6     ;CALL function
                           #--- PUSHB_4   64 6 8 9  ;PUSH Bytes
CALL            9 8 6 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_4   10 7 3 14 ;PUSH Bytes
CALL            14 3 7 10  ;CALL function
                           #--- PUSHB_5   2 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 2 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2528': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2529': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 9 9  ;PUSH Bytes
CALL            9 9 1 64   ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 8 10    ;PUSH Bytes
CALL            10 8 9     ;CALL function
                           #--- PUSHB_4   64 9 1 9  ;PUSH Bytes
CALL            9 1 9 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   10 9 3 14 ;PUSH Bytes
CALL            14 3 9 10  ;CALL function
                           #--- PUSHB_5   6 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 6 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni252A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_5   9 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 9 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_3   9 8 10    ;PUSH Bytes
CALL            10 8 9     ;CALL function
                           #--- PUSHB_4   64 9 1 9  ;PUSH Bytes
CALL            9 1 9 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 8 9  ;PUSH Bytes
CALL            9 8 0 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   10 0 6 14 ;PUSH Bytes
CALL            14 6 0 10  ;CALL function
                           #--- PUSHB_5   5 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 5 ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni252B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni252D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   2 9 10    ;PUSH Bytes
CALL            10 9 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_4   10 2 6 14 ;PUSH Bytes
CALL            14 6 2 10  ;CALL function
                           #--- PUSHB_5   7 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 7 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   3 4 10    ;PUSH Bytes
CALL            10 4 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_3   4 3 10    ;PUSH Bytes
CALL            10 3 4     ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni252E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 0 10    ;PUSH Bytes
CALL            10 0 9     ;CALL function
                           #--- PUSHB_4   64 9 7 9  ;PUSH Bytes
CALL            9 7 9 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   10 9 5 14 ;PUSH Bytes
CALL            14 5 9 10  ;CALL function
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 7 10    ;PUSH Bytes
CALL            10 7 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_3   7 6 10    ;PUSH Bytes
CALL            10 6 7     ;CALL function
                           #--- PUSHB_4   64 7 9 9  ;PUSH Bytes
CALL            9 9 7 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni252F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2530': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2531': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   10 0 4 14 ;PUSH Bytes
CALL            14 4 0 10  ;CALL function
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 9 9  ;PUSH Bytes
CALL            9 9 1 64   ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2532': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 9 9  ;PUSH Bytes
CALL            9 9 1 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   10 1 7 14 ;PUSH Bytes
CALL            14 7 1 10  ;CALL function
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   8 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 8 ;CALL function
                           #--- PUSHB_3   8 9 10    ;PUSH Bytes
CALL            10 9 8     ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_3   9 8 10    ;PUSH Bytes
CALL            10 8 9     ;CALL function
                           #--- PUSHB_4   64 9 1 9  ;PUSH Bytes
CALL            9 1 9 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2533': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 5 9  ;PUSH Bytes
CALL            9 5 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2535': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 1 10    ;PUSH Bytes
CALL            10 1 8     ;CALL function
                           #--- PUSHB_4   64 8 6 9  ;PUSH Bytes
CALL            9 6 8 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   10 1 3 14 ;PUSH Bytes
CALL            14 3 1 10  ;CALL function
                           #--- PUSHB_5   4 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 4 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   8 6       ;PUSH Bytes
MIRP[min,black] stemw 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_3   8 5 10    ;PUSH Bytes
CALL            10 5 8     ;CALL function
                           #--- PUSHB_4   64 8 0 9  ;PUSH Bytes
CALL            9 0 8 64   ;CALL function
                           #--- PUSHB_3   5 8 10    ;PUSH Bytes
CALL            10 8 5     ;CALL function
                           #--- PUSHB_4   64 5 3 9  ;PUSH Bytes
CALL            9 3 5 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2536': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 0 10    ;PUSH Bytes
CALL            10 0 1     ;CALL function
                           #--- PUSHB_4   64 1 3 9  ;PUSH Bytes
CALL            9 3 1 64   ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   10 0 8 14 ;PUSH Bytes
CALL            14 8 0 10  ;CALL function
                           #--- PUSHB_5   5 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 2 10    ;PUSH Bytes
CALL            10 2 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_3   2 5 10    ;PUSH Bytes
CALL            10 5 2     ;CALL function
                           #--- PUSHB_4   64 2 0 9  ;PUSH Bytes
CALL            9 0 2 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2537': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 0 9  ;PUSH Bytes
CALL            9 0 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2538': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   7 6 10    ;PUSH Bytes
CALL            10 6 7     ;CALL function
                           #--- PUSHB_4   64 7 1 9  ;PUSH Bytes
CALL            9 1 7 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 3 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 6 9  ;PUSH Bytes
CALL            9 6 0 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2539': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 8 9  ;PUSH Bytes
CALL            9 8 0 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   10 3 5 14 ;PUSH Bytes
CALL            14 5 3 10  ;CALL function
                           #--- PUSHB_5   6 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 0 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   0 7 10    ;PUSH Bytes
CALL            10 7 0     ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_3   7 0 10    ;PUSH Bytes
CALL            10 0 7     ;CALL function
                           #--- PUSHB_4   64 7 6 9  ;PUSH Bytes
CALL            9 6 7 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni253A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 8 10    ;PUSH Bytes
CALL            10 8 9     ;CALL function
                           #--- PUSHB_4   64 9 1 9  ;PUSH Bytes
CALL            9 1 9 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_4   10 8 5 14 ;PUSH Bytes
CALL            14 5 8 10  ;CALL function
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 3 ;CALL function
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 4 9  ;PUSH Bytes
CALL            9 4 3 64   ;CALL function
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 8 9  ;PUSH Bytes
CALL            9 8 0 64   ;CALL function
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni253B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 6 ;CALL function
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 0 9  ;PUSH Bytes
CALL            9 0 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni253D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 6 10    ;PUSH Bytes
CALL            10 6 9     ;CALL function
                           #--- PUSHB_4   64 9 11 9 ;PUSH Bytes
CALL            9 11 9 64  ;CALL function
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   10 9 1 14 ;PUSH Bytes
CALL            14 1 9 10  ;CALL function
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni253E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   10 1 9 14 ;PUSH Bytes
CALL            14 9 1 10  ;CALL function
                           #--- PUSHB_5   6 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni253F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2540': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_4   10 11 3 14 ;PUSH Bytes
CALL            14 3 11 10 ;CALL function
                           #--- PUSHB_5   6 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 6 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2541': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 3 10    ;PUSH Bytes
CALL            10 3 6     ;CALL function
                           #--- PUSHB_4   64 6 8 9  ;PUSH Bytes
CALL            9 8 6 64   ;CALL function
                           #--- PUSHB_3   3 6 10    ;PUSH Bytes
CALL            10 6 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_4   10 3 11 14 ;PUSH Bytes
CALL            14 11 3 10 ;CALL function
                           #--- PUSHB_5   10 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 10 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2542': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 10 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2543': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 6 10    ;PUSH Bytes
CALL            10 6 9     ;CALL function
                           #--- PUSHB_4   64 9 13 9 ;PUSH Bytes
CALL            9 13 9 64  ;CALL function
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   10 9 1 14 ;PUSH Bytes
CALL            14 1 9 10  ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 13 10  ;PUSH Bytes
CALL            10 13 12   ;CALL function
                           #--- PUSHB_4   64 12 8 9 ;PUSH Bytes
CALL            9 8 12 64  ;CALL function
                           #--- PUSHB_3   13 12 10  ;PUSH Bytes
CALL            10 12 13   ;CALL function
                           #--- PUSHB_4   64 13 2 9 ;PUSH Bytes
CALL            9 2 13 64  ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_4   10 13 3 14 ;PUSH Bytes
CALL            14 3 13 10 ;CALL function
                           #--- PUSHB_5   6 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 6 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2544': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 7 10    ;PUSH Bytes
CALL            10 7 6     ;CALL function
                           #--- PUSHB_4   64 6 2 9  ;PUSH Bytes
CALL            9 2 6 64   ;CALL function
                           #--- PUSHB_3   7 6 10    ;PUSH Bytes
CALL            10 6 7     ;CALL function
                           #--- PUSHB_4   64 7 10 9 ;PUSH Bytes
CALL            9 10 7 64  ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_4   10 6 0 14 ;PUSH Bytes
CALL            14 0 6 10  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
                           #--- PUSHB_5   11 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 11 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 12 9 ;PUSH Bytes
CALL            9 12 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 6 9  ;PUSH Bytes
CALL            9 6 2 64   ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_4   10 2 8 14 ;PUSH Bytes
CALL            14 8 2 10  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_5   11 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 11 ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2545': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   8 5 10    ;PUSH Bytes
CALL            10 5 8     ;CALL function
                           #--- PUSHB_4   64 8 10 9 ;PUSH Bytes
CALL            9 10 8 64  ;CALL function
                           #--- PUSHB_3   5 8 10    ;PUSH Bytes
CALL            10 8 5     ;CALL function
                           #--- PUSHB_4   64 5 1 9  ;PUSH Bytes
CALL            9 1 5 64   ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_4   10 8 12 14 ;PUSH Bytes
CALL            14 12 8 10 ;CALL function
                           #--- PUSHB_5   13 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 13 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 7 9  ;PUSH Bytes
CALL            9 7 3 64   ;CALL function
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 12 9 ;PUSH Bytes
CALL            9 12 0 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   10 0 10 14 ;PUSH Bytes
CALL            14 10 0 10 ;CALL function
                           #--- PUSHB_5   9 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 9 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2546': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 4       ;PUSH Bytes
MIRP[min,black] stemt 8    ;Move Indirect Relative Point
                           #--- PUSHB_3   7 8 10    ;PUSH Bytes
CALL            10 8 7     ;CALL function
                           #--- PUSHB_4   64 7 4 9  ;PUSH Bytes
CALL            9 4 7 64   ;CALL function
                           #--- PUSHB_3   8 7 10    ;PUSH Bytes
CALL            10 7 8     ;CALL function
                           #--- PUSHB_4   64 8 12 9 ;PUSH Bytes
CALL            9 12 8 64  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_4   10 7 3 14 ;PUSH Bytes
CALL            14 3 7 10  ;CALL function
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   0 6       ;PUSH Bytes
MIRP[min,black] stemw 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 11 10   ;PUSH Bytes
CALL            10 11 0    ;CALL function
                           #--- PUSHB_4   64 0 2 9  ;PUSH Bytes
CALL            9 2 0 64   ;CALL function
                           #--- PUSHB_3   11 0 10   ;PUSH Bytes
CALL            10 0 11    ;CALL function
                           #--- PUSHB_4   64 11 7 9 ;PUSH Bytes
CALL            9 7 11 64  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_4   10 11 5 14 ;PUSH Bytes
CALL            14 5 11 10 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2547': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] stemw 10   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_4   10 11 3 14 ;PUSH Bytes
CALL            14 3 11 10 ;CALL function
                           #--- PUSHB_5   6 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 6 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2548': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_5   11 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 11 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_3   3 0 10    ;PUSH Bytes
CALL            10 0 3     ;CALL function
                           #--- PUSHB_4   64 3 5 9  ;PUSH Bytes
CALL            9 5 3 64   ;CALL function
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 10 9 ;PUSH Bytes
CALL            9 10 0 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_4   10 0 8 14 ;PUSH Bytes
CALL            14 8 0 10  ;CALL function
                           #--- PUSHB_5   7 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 7 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2549': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 6 10    ;PUSH Bytes
CALL            10 6 9     ;CALL function
                           #--- PUSHB_4   64 9 11 9 ;PUSH Bytes
CALL            9 11 9 64  ;CALL function
                           #--- PUSHB_3   6 9 10    ;PUSH Bytes
CALL            10 9 6     ;CALL function
                           #--- PUSHB_4   64 6 4 9  ;PUSH Bytes
CALL            9 4 6 64   ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_4   10 9 1 14 ;PUSH Bytes
CALL            14 1 9 10  ;CALL function
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 10 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni254A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 5 10    ;PUSH Bytes
CALL            10 5 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   5 4 10    ;PUSH Bytes
CALL            10 4 5     ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_4   10 4 0 14 ;PUSH Bytes
CALL            14 0 4 10  ;CALL function
                           #--- PUSHB_5   9 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 9 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni254B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_5   2 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 2 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   1 2 10    ;PUSH Bytes
CALL            10 2 1     ;CALL function
                           #--- PUSHB_4   64 1 11 9 ;PUSH Bytes
CALL            9 11 1 64  ;CALL function
                           #--- PUSHB_3   2 1 10    ;PUSH Bytes
CALL            10 1 2     ;CALL function
                           #--- PUSHB_4   64 2 4 9  ;PUSH Bytes
CALL            9 4 2 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   10 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 10 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_3   10 11 10  ;PUSH Bytes
CALL            10 11 10   ;CALL function
                           #--- PUSHB_4   64 10 8 9 ;PUSH Bytes
CALL            9 8 10 64  ;CALL function
                           #--- PUSHB_3   11 10 10  ;PUSH Bytes
CALL            10 10 11   ;CALL function
                           #--- PUSHB_4   64 11 1 9 ;PUSH Bytes
CALL            9 1 11 64  ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni254C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni254D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   6 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 6 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   6 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 4  ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni254E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   5 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 5 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   5 6 0 22 4 ;PUSH Bytes
CALL            4 22 0 6 5 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni254F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   5 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 5  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   5 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 5  ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni256D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_2   7 6       ;PUSH Bytes
MIRP[min,black] stemw 7    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni256E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] stemw 4    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni256F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2571': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   3 11      ;PUSH Bytes
CALL            11 3       ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2575': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2576': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
                           #--- PUSHB_5   0 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2579': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_5   1 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 1 ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni257A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   4 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 4 ;CALL function
                           #--- PUSHB_5   4 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 4 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni257D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 5 ;CALL function
                           #--- PUSHB_5   5 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 5 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni257E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
                           #--- PUSHB_5   3 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 3 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni257F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2581': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 24 4 ;PUSH Bytes
CALL            4 24 0 4 0 ;CALL function
                           #--- PUSHB_5   0 4 0 24 4 ;PUSH Bytes
CALL            4 24 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2582': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 0  ;CALL function
                           #--- PUSHB_5   0 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2583': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2585': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2586': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2587': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2589': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni258A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni258B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni258D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni258E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 2 ;CALL function
                           #--- PUSHB_5   2 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 2 ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni258F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 2 ;CALL function
                           #--- PUSHB_5   2 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 2 ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2595': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 2 ;CALL function
                           #--- PUSHB_5   2 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 2 ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25A3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   4 5       ;PUSH Bytes
MIRP[min,black] cvt_5 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   1 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 1 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 5       ;PUSH Bytes
MIRP[min,black] cvt_5 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 4 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   3 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   11 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 11 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25A4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   13 5      ;PUSH Bytes
MIRP[min,black] cvt_5 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 13 ;CALL function
                           #--- PUSHB_2   4 8       ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_2   6 9       ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25A5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 12      ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 14      ;PUSH Bytes
SHP[rp1]        14         ;SHift Point using reference point
SHP[rp1]        6          ;SHift Point using reference point
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   4 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 4 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   12 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_5   0 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 0 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25A6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_2   26 37     ;PUSH Bytes
SHP[rp2]        37         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   24 36     ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
SHP[rp1]        24         ;SHift Point using reference point
                           #--- PUSHB_2   14 5      ;PUSH Bytes
MIRP[min,black] cvt_5 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   18 29     ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_2   16 28     ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   10 5      ;PUSH Bytes
MIRP[min,black] cvt_5 10   ;Move Indirect Relative Point
                           #--- PUSHB_2   22 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   20 32     ;PUSH Bytes
SHP[rp1]        32         ;SHift Point using reference point
SHP[rp1]        20         ;SHift Point using reference point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 6 ;CALL function
                           #--- PUSHB_2   9 13      ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   8 12      ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_5   26 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 26 ;CALL function
                           #--- PUSHB_2   17 21     ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   16 20     ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_5   37 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 37 ;CALL function
                           #--- PUSHB_2   28 32     ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_2   30 34     ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25A7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 5 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   9 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   6 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   4 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25A8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 11 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 0 ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   6 11      ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   5 13      ;PUSH Bytes
IP              13         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   4 15      ;PUSH Bytes
IP              15         ;Interpolate Point
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25A9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   7 5       ;PUSH Bytes
MIRP[min,black] cvt_5 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp1]        25         ;SHift Point using reference point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 7 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   15 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_6   4 11 18 20 22 27 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              27 22 20 18 11 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_6   5 10 17 19 21 23 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              23 21 19 17 10 5 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25AD': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   7 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 7 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25AE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 0  ;CALL function
                           #--- PUSHB_5   0 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 0  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25AF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   3 5       ;PUSH Bytes
MIRP[min,black] cvt_5 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   4 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 4 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 1  ;CALL function
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   1 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   5 5       ;PUSH Bytes
MIRP[min,black] cvt_5 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   4 5       ;PUSH Bytes
SDPVTL[orthog]  5 4        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[no-rnd]    4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[no-rnd]    3          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   0 16      ;PUSH Bytes
MIRP[rp0,min,black] cvt_16 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   5 16      ;PUSH Bytes
MIRP[rp0,min,black] cvt_16 5   ;Move Indirect Relative Point
                           #--- PUSHB_2   1 2       ;PUSH Bytes
SDPVTL[orthog]  2 1        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[no-rnd]    1          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[no-rnd]    6          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   7 11      ;PUSH Bytes
MIRP[rp0,min,black] cvt_11 7   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   2 11      ;PUSH Bytes
MIRP[rp0,min,black] cvt_11 2   ;Move Indirect Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_8   0 1 2 3 4 5 6 7 ;PUSH Bytes
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    5          ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   2 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 2  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_5   2 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   3 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   2 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 2 ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   2 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 2  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25B9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_5   5 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 5  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 2 ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   2 1       ;PUSH Bytes
IP              1          ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25BD': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25BE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_5   0 4 0 9 4 ;PUSH Bytes
CALL            4 9 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25BF': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   3 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   1 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   1 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25C0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25C1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 5 ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25C2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_5   1 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 1  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   1 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 1  ;CALL function
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25C3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_5   4 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 4  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   5 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 5 ;CALL function
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 5       ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   2 1       ;PUSH Bytes
IP              1          ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25C5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25C7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25C9': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   27 5      ;PUSH Bytes
MIRP[min,black] cvt_5 27   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   10 5      ;PUSH Bytes
MIRP[min,black] cvt_5 10   ;Move Indirect Relative Point
                           #--- PUSHB_5   0 5 15 10 13 ;PUSH Bytes
CALL            13 10 15 5 0 ;CALL function
                           #--- PUSHB_5   0 4 0 11 4 ;PUSH Bytes
CALL            4 11 0 4 0 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   3 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 3 ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_5   13 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 13 ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_4   10 15 21 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 21 15 10 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_3   18 24 29  ;PUSH Bytes
IP              29         ;Interpolate Point
IP              24         ;Interpolate Point
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25CD': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   16 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   26 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   3 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 3 ;CALL function
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   19 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   0 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_6   3 8 12 11 25 26 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              26 25 11 12 8 3 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25D0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   12 5      ;PUSH Bytes
MIRP[min,black] cvt_5 12   ;Move Indirect Relative Point
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   12 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   3 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 3 ;CALL function
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   12 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25D1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   18 5      ;PUSH Bytes
MIRP[min,black] cvt_5 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   12 1 0    ;PUSH Bytes
CALL            0 1 12     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   15 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   18 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25D2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   19 5      ;PUSH Bytes
MIRP[min,black] cvt_5 19   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   16 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_5   3 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 3 ;CALL function
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   11 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   0 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   13 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25D5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_5   11 4 0 8 4 ;PUSH Bytes
CALL            4 8 0 4 11 ;CALL function
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_5   3 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 3  ;CALL function
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   12 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   3 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25D6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 6  ;CALL function
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25D7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   4 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 4  ;CALL function
                           #--- PUSHB_5   4 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 4  ;CALL function
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25E2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25E3': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25E4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25E7': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 0 0     ;PUSH Bytes
CALL            0 0 7      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_5   7 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 7 ;CALL function
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25E8': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   0 3 10    ;PUSH Bytes
CALL            10 3 0     ;CALL function
                           #--- PUSHB_4   64 0 4 9  ;PUSH Bytes
CALL            9 4 0 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 6 ;CALL function
                           #--- PUSHB_3   1 6 10    ;PUSH Bytes
CALL            10 6 1     ;CALL function
                           #--- PUSHB_4   64 1 3 9  ;PUSH Bytes
CALL            9 3 1 64   ;CALL function
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25EA': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_5   9 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 9 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25EC': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_2   13 5      ;PUSH Bytes
MIRP[min,black] cvt_5 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_5   6 0 15 16 13 ;PUSH Bytes
CALL            13 16 15 0 6 ;CALL function
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   12 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25ED': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 2       ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25EE': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 0       ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25F0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   7 5       ;PUSH Bytes
MIRP[min,black] cvt_5 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   12 5      ;PUSH Bytes
MIRP[min,black] cvt_5 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   1 5       ;PUSH Bytes
MIRP[min,black] cvt_5 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 7 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_5   5 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 5 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   3 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 3 ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25F1': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   3 0 0     ;PUSH Bytes
CALL            0 0 3      ;CALL function
                           #--- PUSHB_2   13 5      ;PUSH Bytes
MIRP[min,black] cvt_5 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   8 5       ;PUSH Bytes
MIRP[min,black] cvt_5 8    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 5       ;PUSH Bytes
MIRP[min,black] cvt_5 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 13 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   4 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 4 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_5   2 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 2 ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25F2': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
CALL            0 0 1      ;CALL function
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   2 5       ;PUSH Bytes
MIRP[min,black] cvt_5 2    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   6 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
                           #--- PUSHB_5   11 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 0 ;CALL function
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25F4': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_2   19 5      ;PUSH Bytes
MIRP[min,black] cvt_5 19   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   26 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_5   8 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 8  ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_5   3 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 3 ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   12 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   11 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_3   0 5 19    ;PUSH Bytes
IP              19         ;Interpolate Point
IP              5          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   8 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   13 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25F5': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_5   16 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   6 5       ;PUSH Bytes
MIRP[min,black] cvt_5 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_5   18 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   9 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 9 ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   14 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   11 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_3   0 6 24    ;PUSH Bytes
IP              24         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_3   9 14 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              14         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
                           #--- PUSHB_2   3 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni25F6': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   6 0 0     ;PUSH Bytes
CALL            0 0 6      ;CALL function
                           #--- PUSHB_2   24 5      ;PUSH Bytes
MIRP[min,black] cvt_5 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 5      ;PUSH Bytes
MIRP[min,black] cvt_5 15   ;Move Indirect Relative Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   21 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   15 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 15 ;CALL function
                           #--- PUSHB_5   3 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 3  ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   15 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   0 6 24    ;PUSH Bytes
IP              24         ;Interpolate Point
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
                           #--- PUSHB_2   11 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   3 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_3   9 14 18   ;PUSH Bytes
IP              18         ;Interpolate Point
IP              14         ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2607': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   23 5      ;PUSH Bytes
MIRP[min,black] cvt_5 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 16 10  ;PUSH Bytes
CALL            10 16 23   ;CALL function
                           #--- PUSHB_4   64 23 10 9 ;PUSH Bytes
CALL            9 10 23 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   14 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 14 ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_3   6 14 10   ;PUSH Bytes
CALL            10 14 6    ;CALL function
                           #--- PUSHB_4   64 6 19 9 ;PUSH Bytes
CALL            9 19 6 64  ;CALL function
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   14 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2608': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 0 0    ;PUSH Bytes
CALL            0 0 29     ;CALL function
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_2   21 5      ;PUSH Bytes
MIRP[min,black] cvt_5 21   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 14 10  ;PUSH Bytes
CALL            10 14 21   ;CALL function
                           #--- PUSHB_4   64 21 8 9 ;PUSH Bytes
CALL            9 8 21 64  ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   32 5      ;PUSH Bytes
MIRP[min,black] cvt_5 32   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDRP[rp0,rnd,white] 31         ;Move Direct Relative Point
                           #--- PUSHB_5   26 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 26 ;CALL function
                           #--- PUSHB_3   26 31 10  ;PUSH Bytes
CALL            10 31 26   ;CALL function
                           #--- PUSHB_4   64 26 0 9 ;PUSH Bytes
CALL            9 0 26 64  ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_5   12 6 0 45 4 ;PUSH Bytes
CALL            4 45 0 6 12 ;CALL function
                           #--- PUSHB_3   4 12 10   ;PUSH Bytes
CALL            10 12 4    ;CALL function
                           #--- PUSHB_4   64 4 17 9 ;PUSH Bytes
CALL            9 17 4 64  ;CALL function
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   4 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_2   3 24      ;PUSH Bytes
IP              24         ;Interpolate Point
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_2   3 4       ;PUSH Bytes
IP              4          ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2609': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   28 5      ;PUSH Bytes
MIRP[min,black] cvt_5 28   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 1 0    ;PUSH Bytes
CALL            0 1 22     ;CALL function
                           #--- PUSHB_2   11 5      ;PUSH Bytes
MIRP[min,black] cvt_5 11   ;Move Indirect Relative Point
                           #--- PUSHB_5   0 6 16 11 13 ;PUSH Bytes
CALL            13 11 16 6 0 ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[rnd]       33         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   25 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_5   14 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 14 ;CALL function
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_3   11 16 22  ;PUSH Bytes
IP              22         ;Interpolate Point
IP              16         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 28      ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_3   19 25 30  ;PUSH Bytes
IP              30         ;Interpolate Point
IP              25         ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2630': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2631': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 0 0     ;PUSH Bytes
CALL            0 0 8      ;CALL function
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[min,black] stemt 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2632': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2633': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 0 0    ;PUSH Bytes
CALL            0 0 16     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   6 16      ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   13 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 13 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   11 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 11 ;CALL function
                           #--- PUSHB_2   2 18      ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2634': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 0 0     ;PUSH Bytes
CALL            0 0 2      ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   3 4       ;PUSH Bytes
MIRP[min,black] stemt 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2635': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   6 16      ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   13 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 13 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   11 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 11 ;CALL function
                           #--- PUSHB_2   2 18      ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2636': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 0 0     ;PUSH Bytes
CALL            0 0 5      ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp1]        2          ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDAP[rnd]       13         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   13 16     ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_5   4 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 4 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_5   2 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 2 ;CALL function
                           #--- PUSHB_2   9 17      ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2637': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   22 0 0    ;PUSH Bytes
CALL            0 0 22     ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp1]        16         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   7 4       ;PUSH Bytes
MIRP[min,black] stemt 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   6 14      ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   21 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 21 ;CALL function
                           #--- PUSHB_2   4 12      ;PUSH Bytes
SHP[rp2]        12         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   0 8       ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   19 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 19 ;CALL function
                           #--- PUSHB_2   2 10      ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2639': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_2   59 5      ;PUSH Bytes
MIRP[min,black] cvt_5 59   ;Move Indirect Relative Point
                           #--- PUSHB_3   53 1 0    ;PUSH Bytes
CALL            0 1 53     ;CALL function
                           #--- PUSHB_2   42 5      ;PUSH Bytes
MIRP[min,black] cvt_5 42   ;Move Indirect Relative Point
                           #--- PUSHB_5   37 27 47 42 13 ;PUSH Bytes
CALL            13 42 47 27 37 ;CALL function
                           #--- PUSHB_5   37 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 37 ;CALL function
                           #--- PUSHB_3   37 27 10  ;PUSH Bytes
CALL            10 27 37   ;CALL function
                           #--- PUSHB_4   0 37 22 9 ;PUSH Bytes
CALL            9 22 37 0  ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_5   11 17 47 42 13 ;PUSH Bytes
CALL            13 42 47 17 11 ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   11 4      ;PUSH Bytes
MIRP[min,black] stemt 11   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   50        ;PUSH Bytes
MDRP[rp0,rnd,white] 50         ;Move Direct Relative Point
                           #--- PUSHB_5   56 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 56 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_5   39 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 39 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   3 6       ;PUSH Bytes
MIRP[min,black] stemw 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_5   34 6 0 15 4 ;PUSH Bytes
CALL            4 15 0 6 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_5   45 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 45 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   39 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   17 11     ;PUSH Bytes
IP              11         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_3   42 47 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              47         ;Interpolate Point
IP              42         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_5   6 0 27 35 59 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              59 35 27 0 6 ;Interpolate Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_3   50 56 61  ;PUSH Bytes
IP              61         ;Interpolate Point
IP              56         ;Interpolate Point
IP              50         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2669': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   10 0 0    ;PUSH Bytes
CALL            0 0 10     ;CALL function
                           #--- PUSHB_5   14 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 14 ;CALL function
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
CALL            0 2 4      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDRP[rp0,rnd,white] 12         ;Move Direct Relative Point
                           #--- PUSHB_5   7 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 7 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   0 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 0 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   12 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   0 12      ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni266C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_5   8 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 8 ;CALL function
                           #--- PUSHB_4   16 8 4 8  ;PUSH Bytes
CALL            8 4 8 16   ;CALL function
                           #--- PUSHB_5   20 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 20 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   13 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 13 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_5   22 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 22 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_5   1 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 1 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   6 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 6 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   22 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   20 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   11 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni266D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   16 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 16 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
MDRP[rp0,rnd,white] 28         ;Move Direct Relative Point
                           #--- PUSHB_5   10 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 10 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   18 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 18 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni266E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 3 0     ;PUSH Bytes
CALL            0 3 4      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   11 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 11 ;CALL function
                           #--- PUSHB_2   6 10      ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_3   2 8 9     ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   0 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 0 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_2   13 1      ;PUSH Bytes
CALL            1 13       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   11 8      ;PUSH Bytes
SDPVTL[orthog]  8 11       ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[no-rnd]    11         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[no-rnd]    2          ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   3 17      ;PUSH Bytes
MIRP[rp0,min,black] cvt_17 3   ;Move Indirect Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   8 17      ;PUSH Bytes
MIRP[rp0,min,black] cvt_17 8   ;Move Indirect Relative Point
                           #--- PUSHB_2   6 7       ;PUSH Bytes
SDPVTL[orthog]  7 6        ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[no-rnd]    6          ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[no-rnd]    9          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   10 17     ;PUSH Bytes
MIRP[rp0,min,black] cvt_17 10  ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   7 17      ;PUSH Bytes
MIRP[rp0,min,black] cvt_17 7   ;Move Indirect Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_8   2 3 6 7 8 9 10 11 ;PUSH Bytes
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni266F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 3 0     ;PUSH Bytes
CALL            0 3 8      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_4   0 3 24 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        27 24 3 0  ;SHift Point using reference point
                           #--- PUSHB_5   22 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 22 ;CALL function
                           #--- PUSHB_4   6 21 28 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        29 28 21 6 ;SHift Point using reference point
                           #--- PUSHB_3   23 22 10  ;PUSH Bytes
CALL            10 22 23   ;CALL function
                           #--- PUSHB_4   64 23 2 9 ;PUSH Bytes
CALL            9 2 23 64  ;CALL function
                           #--- PUSHB_3   1 25 26   ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_4   7 20 30 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        31 30 20 7 ;SHift Point using reference point
                           #--- PUSHB_5   18 6 0 35 4 ;PUSH Bytes
CALL            4 35 0 6 18 ;CALL function
                           #--- PUSHB_4   10 13 14 17 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
SHP[rp2]        17 14 13 10 ;SHift Point using reference point
                           #--- PUSHB_3   18 19 10  ;PUSH Bytes
CALL            10 19 18   ;CALL function
                           #--- PUSHB_4   64 18 12 9 ;PUSH Bytes
CALL            9 12 18 64 ;CALL function
                           #--- PUSHB_3   11 15 16  ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   26 15     ;PUSH Bytes
SDPVTL[orthog]  15 26      ;Set Dual Projection Vector To Line
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[no-rnd]    26         ;Move Direct Absolute Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[no-rnd]    16         ;Move Direct Absolute Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   25 18     ;PUSH Bytes
MIRP[rp0,min,black] cvt_18 25  ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   15 18     ;PUSH Bytes
MIRP[rp0,min,black] cvt_18 15  ;Move Indirect Relative Point
                           #--- PUSHB_2   2 11      ;PUSH Bytes
SDPVTL[orthog]  11 2       ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[no-rnd]    2          ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[no-rnd]    12         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   1 18      ;PUSH Bytes
MIRP[rp0,min,black] cvt_18 1   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   11 18     ;PUSH Bytes
MIRP[rp0,min,black] cvt_18 11  ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   0 1 12 19 ;PUSH Bytes
CALL            19 12 1 0  ;CALL function
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_4   3 2 11 19 ;PUSH Bytes
CALL            19 11 2 3  ;CALL function
                           #--- PUSHB_4   6 2 11 19 ;PUSH Bytes
CALL            19 11 2 6  ;CALL function
                           #--- PUSHB_4   7 2 11 19 ;PUSH Bytes
CALL            19 11 2 7  ;CALL function
                           #--- PUSHB_4   10 2 11 19 ;PUSH Bytes
CALL            19 11 2 10 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   13 1 12 19 ;PUSH Bytes
CALL            19 12 1 13 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   14 26 15 19 ;PUSH Bytes
CALL            19 15 26 14 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_4   17 25 16 19 ;PUSH Bytes
CALL            19 16 25 17 ;CALL function
                           #--- PUSHB_4   20 25 16 19 ;PUSH Bytes
CALL            19 16 25 20 ;CALL function
                           #--- PUSHB_4   21 25 16 19 ;PUSH Bytes
CALL            19 16 25 21 ;CALL function
                           #--- PUSHB_4   24 25 16 19 ;PUSH Bytes
CALL            19 16 25 24 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   27 26 15 19 ;PUSH Bytes
CALL            19 15 26 27 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   28 1 12 19 ;PUSH Bytes
CALL            19 12 1 28 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_4   29 26 15 19 ;PUSH Bytes
CALL            19 15 26 29 ;CALL function
                           #--- PUSHB_4   30 26 15 19 ;PUSH Bytes
CALL            19 15 26 30 ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_4   31 1 12 19 ;PUSH Bytes
CALL            19 12 1 31 ;CALL function
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- NPUSHB    24 0 1 2 3 6 7 10 11 12 13 14 15 16 17 20 21 24 25 26 27 28 29 30 31 ;PUSH N Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    29         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
MDAP[no-rnd]    25         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    21         ;Move Direct Absolute Point
MDAP[no-rnd]    20         ;Move Direct Absolute Point
MDAP[no-rnd]    17         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    12         ;Move Direct Absolute Point
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uogonek': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   20 0 0    ;PUSH Bytes
CALL            0 0 20     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_3   15 0 0    ;PUSH Bytes
CALL            0 0 15     ;CALL function
                           #--- PUSHB_3   52 0 0    ;PUSH Bytes
CALL            0 0 52     ;CALL function
                           #--- PUSHB_3   33 1 0    ;PUSH Bytes
CALL            0 1 33     ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp1]        45         ;SHift Point using reference point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_5   30 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 30 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_3   47 40 10  ;PUSH Bytes
CALL            10 40 47   ;CALL function
                           #--- PUSHB_4   64 47 49 9 ;PUSH Bytes
CALL            9 49 47 64 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_5   44 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_4   55 47 40 8 ;PUSH Bytes
CALL            8 40 47 55 ;CALL function
                           #--- PUSHB_5   12 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_5   55 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 55 ;CALL function
                           #--- PUSHB_3   55 12 10  ;PUSH Bytes
CALL            10 12 55   ;CALL function
                           #--- PUSHB_4   0 55 6 9  ;PUSH Bytes
CALL            9 6 55 0   ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   44 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   20 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_2   47 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   15 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   12 53     ;PUSH Bytes
IP              53         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_2   17 49     ;PUSH Bytes
IP              49         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'upblock': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
                           #--- PUSHB_5   0 4 0 7 4 ;PUSH Bytes
CALL            4 7 0 4 0  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_5   2 6 0 7 4 ;PUSH Bytes
CALL            4 7 0 6 2  ;CALL function
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'upperdothebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   40 0 0    ;PUSH Bytes
CALL            0 0 40     ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_2   34 4      ;PUSH Bytes
MIRP[min,black] stemt 34   ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_5   38 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 38 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_5   14 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   34 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   3 44      ;PUSH Bytes
IP              44         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_2   14 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   6 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   18 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   20 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   34 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_4   6 20 29 44 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              44 29 20 6 ;Interpolate Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'upsilon': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   19 0 0    ;PUSH Bytes
CALL            0 0 19     ;CALL function
                           #--- PUSHB_2   0 4       ;PUSH Bytes
MIRP[min,black] stemt 0    ;Move Indirect Relative Point
                           #--- PUSHB_3   30 1 0    ;PUSH Bytes
CALL            0 1 30     ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp1]        8          ;SHift Point using reference point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   4 14      ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] stemw 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_5   27 6 0 11 4 ;PUSH Bytes
CALL            4 11 0 6 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] stemw 16   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_4   8 16 12 14 ;PUSH Bytes
CALL            14 12 16 8 ;CALL function
                           #--- PUSHB_5   7 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 7  ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
MDAP[rnd]       7          ;Move Direct Absolute Point
                           #--- PUSHB_5   12 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 12 ;CALL function
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   7 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_2   0 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'v': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   18 0 0    ;PUSH Bytes
CALL            0 0 18     ;CALL function
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_3   2 5 15    ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
MDRP[rp0,rnd,white] 22         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   13 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 13 ;CALL function
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_2   0 22      ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   3 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   5 17      ;PUSH Bytes
IP              17         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'vavhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'vavvavhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'vavyodhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
MDAP[rnd]       22         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   27 4      ;PUSH Bytes
MIRP[min,black] stemt 27   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   22 27 10  ;PUSH Bytes
CALL            10 27 22   ;CALL function
                           #--- PUSHB_4   64 22 18 9 ;PUSH Bytes
CALL            9 18 22 64 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'vecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_2   20 4      ;PUSH Bytes
MIRP[min,black] stemt 20   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   21 4      ;PUSH Bytes
MIRP[min,black] stemt 21   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   1 16 17 24 13 ;PUSH Bytes
CALL            13 24 17 16 1 ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDRP[rp0,rnd,white] 20         ;Move Direct Relative Point
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] stemw 9    ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   20 9 10   ;PUSH Bytes
CALL            10 9 20    ;CALL function
                           #--- PUSHB_4   64 20 19 9 ;PUSH Bytes
CALL            9 19 20 64 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_2   35 6      ;PUSH Bytes
MIRP[min,black] stemw 35   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
                           #--- DUP       #4        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_2   30 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'w': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   9 26 31   ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   24 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 24 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_5   7 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 7  ;CALL function
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   15 14     ;PUSH Bytes
SDPVTL[orthog]  14 15      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[no-rnd]    15         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[no-rnd]    27         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   26 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 26   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_2   30 31     ;PUSH Bytes
SDPVTL[orthog]  31 30      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[no-rnd]    10         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   9 4       ;PUSH Bytes
MIRP[rp0,min,black] stemt 9    ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   30 4      ;PUSH Bytes
MIRP[rp0,min,black] stemt 30   ;Move Indirect Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_2   27 30     ;PUSH Bytes
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_8   9 10 14 15 26 27 30 31 ;PUSH Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    26         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   2 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_4   11 13 28 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 28 13 11 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_2   28 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'weierstrass': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 5       ;PUSH Bytes
MIRP[min,black] cvt_5 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_2   17 5      ;PUSH Bytes
MIRP[min,black] cvt_5 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   17 60 10  ;PUSH Bytes
CALL            10 60 17   ;CALL function
                           #--- PUSHB_4   64 17 13 9 ;PUSH Bytes
CALL            9 13 17 64 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   52 5      ;PUSH Bytes
MIRP[min,black] cvt_5 52   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_5   4 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 4 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_5   35 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 35 ;CALL function
                           #--- PUSHB_4   11 35 0 8 ;PUSH Bytes
CALL            8 0 35 11  ;CALL function
                           #--- PUSHB_5   14 6 0 55 4 ;PUSH Bytes
CALL            4 55 0 6 14 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   55 6      ;PUSH Bytes
MIRP[min,black] stemw 55   ;Move Indirect Relative Point
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   4 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   38 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_2   9 33      ;PUSH Bytes
IP              33         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   22 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_3   26 52 60  ;PUSH Bytes
IP              60         ;Interpolate Point
IP              52         ;Interpolate Point
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 60     ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_5   0 4 33 35 41 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              41 35 33 4 0 ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_6   2 9 43 46 50 55 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              55 50 46 43 9 2 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'x': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   33 0 0    ;PUSH Bytes
CALL            0 0 33     ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_3   43 1 0    ;PUSH Bytes
CALL            0 1 43     ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_5   2 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 2  ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_5   35 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_5   19 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 19 ;CALL function
                           #--- PUSHB_5   13 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 13 ;CALL function
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   2 41      ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_4   4 28 37 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 37 28 4 ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_2   5 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_4   6 16 17 26 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              26 17 16 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   43 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
                           #--- PUSHB_2   5 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'y': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   16 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 16 ;CALL function
                           #--- PUSHB_3   16 10 10  ;PUSH Bytes
CALL            10 10 16   ;CALL function
                           #--- PUSHB_4   64 16 34 9 ;PUSH Bytes
CALL            9 34 16 64 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_5   27 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 27 ;CALL function
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   16 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   7 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_2   19 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   20 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_3   8 19 29   ;PUSH Bytes
IP              29         ;Interpolate Point
IP              19         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ydieresis': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 0 0    ;PUSH Bytes
CALL            0 0 30     ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp1]        15         ;SHift Point using reference point
                           #--- PUSHB_2   35 4      ;PUSH Bytes
MIRP[min,black] stemt 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   21 25 44  ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
SHP[rp2]        25         ;SHift Point using reference point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   42 2 0    ;PUSH Bytes
CALL            0 2 42     ;CALL function
                           #--- PUSHB_2   37 4      ;PUSH Bytes
MIRP[min,black] stemt 37   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDAP[rnd]       9          ;Move Direct Absolute Point
                           #--- PUSHB_5   0 5 0 25 4 ;PUSH Bytes
CALL            4 25 0 5 0 ;CALL function
                           #--- PUSHB_3   0 9 10    ;PUSH Bytes
CALL            10 9 0     ;CALL function
                           #--- PUSHB_4   0 0 3 9   ;PUSH Bytes
CALL            9 3 0 0    ;CALL function
                           #--- PUSHB_5   24 56 30 42 13 ;PUSH Bytes
CALL            13 42 30 56 24 ;CALL function
                           #--- PUSHB_2   24 4      ;PUSH Bytes
MIRP[min,black] stemt 24   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[rp0,rnd,white] 32         ;Move Direct Relative Point
                           #--- PUSHB_5   28 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   47 6 0 8 4 ;PUSH Bytes
CALL            4 8 0 6 47 ;CALL function
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_4   12 47 18 8 ;PUSH Bytes
CALL            8 18 47 12 ;CALL function
                           #--- PUSHB_5   52 6 0 25 4 ;PUSH Bytes
CALL            4 25 0 6 52 ;CALL function
                           #--- PUSHB_3   52 12 10  ;PUSH Bytes
CALL            10 12 52   ;CALL function
                           #--- PUSHB_4   0 52 6 9  ;PUSH Bytes
CALL            9 6 52 0   ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   28 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_5   24 25 36 39 56 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              56 39 36 25 24 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   43 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_2   22 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              22         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   15 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   12 50     ;PUSH Bytes
IP              50         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_2   37 56     ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   55        ;PUSH Bytes
IP              55         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'yen': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   37 0 0    ;PUSH Bytes
CALL            0 0 37     ;CALL function
                           #--- PUSHB_2   42 4      ;PUSH Bytes
MIRP[min,black] stemt 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_5   48 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 48 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_5   54 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 54 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   59        ;PUSH Bytes
MDAP[rnd]       59         ;Move Direct Absolute Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp1]        17         ;SHift Point using reference point
                           #--- PUSHB_2   65 4      ;PUSH Bytes
MIRP[min,black] stemt 65   ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SHP[rp2]        13         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   62        ;PUSH Bytes
MDRP[rp0,rnd,white] 62         ;Move Direct Relative Point
                           #--- PUSHB_5   3 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 3  ;CALL function
                           #--- PUSHB_1   3         ;PUSH Bytes
SRP0            3          ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SHP[rp2]        49         ;SHift Point using reference point
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] stemw 30   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_3   30 43 10  ;PUSH Bytes
CALL            10 43 30   ;CALL function
                           #--- PUSHB_4   64 30 34 9 ;PUSH Bytes
CALL            9 34 30 64 ;CALL function
                           #--- PUSHB_4   64 30 27 9 ;PUSH Bytes
CALL            9 27 30 64 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_3   43 30 10  ;PUSH Bytes
CALL            10 30 43   ;CALL function
                           #--- PUSHB_4   64 43 39 9 ;PUSH Bytes
CALL            9 39 43 64 ;CALL function
                           #--- PUSHB_4   64 43 47 9 ;PUSH Bytes
CALL            9 47 43 64 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_5   16 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 16 ;CALL function
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   3 62      ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   6 55      ;PUSH Bytes
IP              55         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   30 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_2   16 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   8 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   59 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            59         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP1            65         ;Set Reference Point 1
                           #--- PUSHB_2   6 8       ;PUSH Bytes
IP              8          ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'yericyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp1]        47         ;SHift Point using reference point
                           #--- PUSHB_2   14 4      ;PUSH Bytes
MIRP[min,black] stemt 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   22 42 53  ;PUSH Bytes
SHP[rp2]        53         ;SHift Point using reference point
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_3   18 1 0    ;PUSH Bytes
CALL            0 1 18     ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   15 4      ;PUSH Bytes
MIRP[min,black] stemt 15   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 29 41   ;PUSH Bytes
SHP[rp2]        41         ;SHift Point using reference point
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_5   1 28 11 18 13 ;PUSH Bytes
CALL            13 18 11 28 1 ;CALL function
                           #--- PUSHB_2   1 4       ;PUSH Bytes
MIRP[min,black] stemt 1    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] stemw 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_4   9 22 21 14 ;PUSH Bytes
CALL            14 21 22 9 ;CALL function
                           #--- PUSHB_5   17 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 17 ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_5   21 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 21 ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] stemw 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP0            5          ;Set Reference Point 0
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_5   44 6 0 10 4 ;PUSH Bytes
CALL            4 10 0 6 44 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   44 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   29 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'yodhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_3   8 13 10   ;PUSH Bytes
CALL            10 13 8    ;CALL function
                           #--- PUSHB_4   64 8 4 9  ;PUSH Bytes
CALL            9 4 8 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   0 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 0  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] stemw 6    ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDAP[rnd]       6          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'yodyodhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   13 4      ;PUSH Bytes
MIRP[min,black] stemt 13   ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_3   8 13 10   ;PUSH Bytes
CALL            10 13 8    ;CALL function
                           #--- PUSHB_4   64 8 4 9  ;PUSH Bytes
CALL            9 4 8 64   ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_2   1 6       ;PUSH Bytes
MIRP[min,black] stemw 1    ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_5   11 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] stemw 15   ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_5   25 6 0 9 4 ;PUSH Bytes
CALL            4 9 0 6 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'z': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   14 0 0    ;PUSH Bytes
CALL            0 0 14     ;CALL function
                           #--- PUSHB_5   9 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 9 ;CALL function
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
CALL            0 1 3      ;CALL function
                           #--- PUSHB_5   1 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 1 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] stemw 18   ;Move Indirect Relative Point
                           #--- PUSHB_4   13 2 15 14 ;PUSH Bytes
CALL            14 15 2 13 ;CALL function
                           #--- PUSHB_5   6 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 6 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] stemw 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_1   4         ;PUSH Bytes
                           #--- DUP       #4        ;DUPlicate top stack element
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_5   16 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_5   4 6 0 13 4 ;PUSH Bytes
CALL            4 13 0 6 4 ;CALL function
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   4 7       ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_2   3 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zayinhebrew': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 0 0    ;PUSH Bytes
CALL            0 0 17     ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] stemw 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   14 19 10  ;PUSH Bytes
CALL            10 19 14   ;CALL function
                           #--- PUSHB_4   64 14 10 9 ;PUSH Bytes
CALL            9 10 14 64 ;CALL function
                           #--- PUSHB_3   19 14 10  ;PUSH Bytes
CALL            10 14 19   ;CALL function
                           #--- PUSHB_4   64 19 4 9 ;PUSH Bytes
CALL            9 4 19 64  ;CALL function
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zecyrillic': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   50 0 0    ;PUSH Bytes
CALL            0 0 50     ;CALL function
                           #--- PUSHB_2   6 4       ;PUSH Bytes
MIRP[min,black] stemt 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   54 0 0    ;PUSH Bytes
CALL            0 0 54     ;CALL function
                           #--- PUSHB_5   2 4 0 13 4 ;PUSH Bytes
CALL            4 13 0 4 2 ;CALL function
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   23 4      ;PUSH Bytes
MIRP[min,black] stemt 23   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 1 0    ;PUSH Bytes
CALL            0 1 38     ;CALL function
                           #--- PUSHB_5   29 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 29 ;CALL function
                           #--- PUSHB_5   16 13 50 38 13 ;PUSH Bytes
CALL            13 38 50 13 16 ;CALL function
                           #--- PUSHB_2   16 4      ;PUSH Bytes
MIRP[min,black] stemt 16   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_2   47 6      ;PUSH Bytes
MIRP[min,black] stemw 47   ;Move Indirect Relative Point
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   47 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_2   41 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              41         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   6 54      ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_1   52        ;PUSH Bytes
IP              52         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   9 47      ;PUSH Bytes
IP              47         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   16 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_2   43 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              43         ;Interpolate Point
                           #--- PUSHB_2   23 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   20 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zeroinferior': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   47 0 0    ;PUSH Bytes
CALL            0 0 47     ;CALL function
                           #--- PUSHB_2   2 4       ;PUSH Bytes
MIRP[min,black] stemt 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp2]        42         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_2   17 4      ;PUSH Bytes
MIRP[min,black] stemt 17   ;Move Indirect Relative Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp2]        28         ;SHift Point using reference point
                           #--- PUSHB_3   22 2 0    ;PUSH Bytes
CALL            0 2 22     ;CALL function
                           #--- PUSHB_5   26 4 0 10 4 ;PUSH Bytes
CALL            4 10 0 4 26 ;CALL function
                           #--- PUSHB_5   5 8 47 22 13 ;PUSH Bytes
CALL            13 22 47 8 5 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_5   5 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 5 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_5   14 11 47 22 13 ;PUSH Bytes
CALL            13 22 47 11 14 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_5   14 5 0 15 4 ;PUSH Bytes
CALL            4 15 0 5 14 ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp2]        30         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   9 15      ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] stemw 42   ;Move Indirect Relative Point
                           #--- PUSHB_2   29 35     ;PUSH Bytes
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        29         ;SHift Point using reference point
                           #--- PUSHB_3   42 3 10   ;PUSH Bytes
CALL            10 3 42    ;CALL function
                           #--- PUSHB_4   64 42 45 9 ;PUSH Bytes
CALL            9 45 42 64 ;CALL function
                           #--- PUSHB_4   64 42 39 9 ;PUSH Bytes
CALL            9 39 42 64 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_3   3 42 10   ;PUSH Bytes
CALL            10 42 3    ;CALL function
                           #--- PUSHB_4   64 3 19 9 ;PUSH Bytes
CALL            9 19 3 64  ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] stemw 24   ;Move Indirect Relative Point
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zeta': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 0 0    ;PUSH Bytes
CALL            0 0 11     ;CALL function
                           #--- PUSHB_2   31 4      ;PUSH Bytes
MIRP[min,black] stemt 31   ;Move Indirect Relative Point
                           #--- PUSHB_3   34 0 0    ;PUSH Bytes
CALL            0 0 34     ;CALL function
                           #--- PUSHB_3   23 3 0    ;PUSH Bytes
CALL            0 3 23     ;CALL function
                           #--- PUSHB_2   18 4      ;PUSH Bytes
MIRP[min,black] stemt 18   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 3 0    ;PUSH Bytes
CALL            0 3 23     ;CALL function
                           #--- PUSHB_5   21 4 0 12 4 ;PUSH Bytes
CALL            4 12 0 4 21 ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 4       ;PUSH Bytes
MIRP[min,black] stemt 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   28 6      ;PUSH Bytes
MIRP[min,black] stemw 28   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   34 6      ;PUSH Bytes
MIRP[min,black] stemw 34   ;Move Indirect Relative Point
                           #--- PUSHB_3   34 8 10   ;PUSH Bytes
CALL            10 8 34    ;CALL function
                           #--- PUSHB_4   64 34 39 9 ;PUSH Bytes
CALL            9 39 34 64 ;CALL function
                           #--- PUSHB_4   64 34 25 9 ;PUSH Bytes
CALL            9 25 34 64 ;CALL function
                           #--- PUSHB_3   8 34 10   ;PUSH Bytes
CALL            10 34 8    ;CALL function
                           #--- PUSHB_4   64 8 3 9  ;PUSH Bytes
CALL            9 3 8 64   ;CALL function
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   28 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_3   11 17 31  ;PUSH Bytes
IP              31         ;Interpolate Point
IP              17         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   36        ;PUSH Bytes
IP              36         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   21 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   14 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   23 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

}
